#ifdef __VBCC__
    #define AMIGA
#endif
#ifdef AMIGA
    #include "amiga.h"
    #include <string.h>
    #include <stdlib.h>
    #include <proto/locale.h> // GetCatalogStr()
#endif
#ifdef _lint
    #define WIN32
    #define _inline
#endif
#ifdef WIN32
    #include "ibm.h"
    #define EXEC_TYPES_H
#endif

#include <stdio.h>

#include "aa.h"
#define CATCOMP_NUMBERS
#define CATCOMP_BLOCK
#include "aa_strings.h"

#include "arcadia.h"

// #define SPARESCREEN
// whether to show the lower screen instead of upper screen in low-res
// games

IMPORT ULONG                 autofire,
                             collisions,
                             demultiplex,
                             downframes,
                             flagline,
                             frames,
                             memflags[32768],
                             swapped,
                             totalframes;
IMPORT UBYTE*                IOBuffer;
IMPORT FLAG                  golf,
                             lmb,
                             mmb,
                             undithernow;
IMPORT FILE*                 MacroHandle;
IMPORT TEXT                  filepart[MAX_PATH + 1],
                             friendly[2 + 13 + 1 + 1],
                             ProjectBuffer[PROJECTSIZE];
IMPORT int                   ax[2],
                             ay[2],
                             connected,
                             console_start,
                             console_a,
                             console_b,
                             console_reset,
                             consoleopen,
                             enhancestars,
                             game,
                             hostcontroller[2],
                             inframe,
                             key1,
                             key2,
                             key3,
                             key4,
                             machine,
                             memmap,
                             offset,
                             overcalc, // must be signed!
                             p1bgcol[4],
                             p2bgcol[4],
                             p1sprcol[6],
                             p2sprcol[6],
                             paddleup,
                             paddledown,
                             paddleleft,
                             paddleright,
                             rast,
                             rastn,
                             recmode,
                             requirebutton,
                             romsize,
                             p1rumble,
                             p2rumble,
                             rumbling[2],
                             runtodma,
                             serializemode,
                             shadowing,
                             slice,
                             spritesvisible,
                             starfield,
                             trace;
IMPORT ASCREEN               a_screen[A_BOXWIDTH][A_BOXHEIGHT],
                             screen[BOXWIDTH][BOXHEIGHT];
IMPORT UBYTE                 memory[32768],
                             OutputBuffer[7],
                             psu,
                             sx[2], sy[2];
IMPORT UWORD                 console[4],
                             jf[2],
                             keypads[2][NUMKEYS],
                             mirror_r[32768],
                             mirror_w[32768];
IMPORT       struct KeyTableStruct keytable[16];
IMPORT const struct KindStruct     filekind[KINDS];

#ifdef WIN32
    IMPORT int             CatalogPtr;
#endif
#ifdef AMIGA
    IMPORT LONG            pens[PENS],
                           wordpens[PENS],
                           longpens[PENS];
    IMPORT int             divided,
                        // remainder,
                           size,
                           wide;
    IMPORT FLAG            blockarexx;
    IMPORT UBYTE*          byteptr[MAXBOXHEIGHT];
    IMPORT UWORD*          wordptr[MAXBOXHEIGHT];
    IMPORT ULONG*          longptr[MAXBOXHEIGHT];
    IMPORT struct Catalog* CatalogPtr;
#endif

MODULE int    hoffset, // = XMARGIN + 0..7
              notrast,
              stopline,
              tall[FLIPS][4],
              xx,
              yy;
MODULE FLAG   newband,
              shadowed,
              skip[FLIPS][4],
              theflag[A_BOXHEIGHT];  // Flag pin for this line (TRUE or FALSE)
MODULE UBYTE  t,
              bgc1[A_BOXHEIGHT],  // background colour for this line (taking account of Flag pin) (stored in Arcadia format)
              bgc2[A_BOXHEIGHT],
              fgc,                  // stored in Arcadia format
              fgc1, fgc2,           // stored in Arcadia format, and only used for board mode
              bgc,                  // stored in Arcadia format
              outerbgc, innerbgc,   // stored in Arcadia format, and only used for board mode
              hires,                // 0 for low resolution, 1 for high resolution
              spritefgc[FLIPS][4][16],
              image[FLIPS][4][8],
              newshadow[A_BOXWIDTH],
              shadow[A_BOXWIDTH],
              sprcolour,
              sprcolours[A_BOXWIDTH][A_BOXHEIGHT],
              spritex[FLIPS][4],
              spritey[FLIPS][4],
              boardmode,
              rowbuf[16];
MODULE SLONG  rowc, // goes up only 1 per 2 rasts in low-res mode
                    // 0..7: which y-pixel row in the current "band" (row of chars) we are doing
              row,  // whenever rowc gets to 8, rowc is cleared and row is incremented
              blockmode,
              column,
              thechar,
              imagedata,
              rowlimit;
MODULE       TEXT   fn_project[MAX_PATH + 1] = ""; // complete pathname of the EAP/EAL file
MODULE const TEXT   txtmaker_chars[64 + 1]   =  "                0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ.,+$        ";

EXPORT       FLAG  protect[4];
EXPORT       int   flip,
                   flips = 1,
                   voffset;
EXPORT const UBYTE from_a[16] =
{   0, //  0 ->  0 white
    1, //  1 ->  1 yellow
    4, //  2 ->  4 cyan
    5, //  3 ->  5 green
    2, //  4 ->  2 purple
    3, //  5 ->  3 red
    6, //  6 ->  6 blue
    7, //  7 ->  7 black
    8,
    9,
   10,
   11,
   12,
   13,
   14,
   15
};

/* Bottom margins are as follows (for initial screen):
 HOBO:     (very thick) yellow
 THE-END:  thick green, medium yellow, thin cyan
 TURTLES:  (very thick) green
 JUMPBUG?: thin green, thick yellow
These were tested under MESS V2 and WinArcadia 1.5.
*/

// MODULE FUNCTIONS

MODULE void a_playerinput(int source, int dest);
MODULE void drawsprites(SLONG flipper);
MODULE __inline void a_emuinput(void);
MODULE int sprite_collision(int first, int second);
MODULE void drawallsprites(void);
MODULE __inline void collidesprites(void);
MODULE __inline void breakdma(void);
MODULE __inline void breakrastline(void);
MODULE __inline void a_drawline(int y, UBYTE colour);

// start of code

EXPORT void uvi(void)
{   PERSIST int x; // PERSISTent for speed
#ifdef SHOWRUMBLE
    PERSIST int y; // PERSISTent for speed
#endif

    // assert(machine == ARCADIA);

    inframe = TRUE;

    voffset = (SWORD) 255 - memory[A_VSCROLL];

    if (memory[A_RESOLUTION] & 0x40) // lower screen on/off flag
    {   rowlimit = 26;
    } else
    {   rowlimit = 13;
    }
    hires = (memory[A_BGCOLOUR] & 0x80) >> 7; // %10000000 -> %00000001 (doublescan flag)

    psu &= ~(PSU_S);
    uviwrite(A_CHARLINE,      0xFF);
    uviwrite(A_P1PADDLE,      0xFF); // "The potentiometer is set to $FF
    uviwrite(A_P2PADDLE,      0xFF); // on the trailing edge of VRST."

    // These have to be commented out for ALIENINV and DORAEMON collision detection to work reliably
    // uviwrite(A_SPRITECOLLIDE, 0xFF); // "Each [bit] is reset to 1...at the end of the vertical blanking period."
    // uviwrite(A_BGCOLLIDE,     0xFF); // "Each [bit] is reset [to 1]...at the end of the vertical blanking period."
    breakdma();

    // top margin---------------------------------------------------------

    if (voffset)
    {   if (voffset < A_BOXHEIGHT)
        {   stopline = voffset;
        } else
        {   stopline = A_BOXHEIGHT;
        }
        for (rast = 0; rast < stopline; rast++)
        {   if (flagline && (psu & PSU_F))
            {   theflag[rast]  = PSU_F;
                bgc1[rast] = 7 - (memory[A_BGCOLOUR] & 0x07);
            } else
            {   theflag[rast]  = 0;
                bgc1[rast] =      memory[A_BGCOLOUR] & 0x07;
            }

            breakrastline();
            slice = CPL - overcalc;
            cpu();
            CHECKINPUT;

            a_drawline(rast, bgc1[rast]); // draw entire (blank) line

            if (rast == INPUTLINE) // 207
            {   a_emuinput();
            } elif (rast == SENSELINE) // 240
            {   psu |= PSU_S;
    }   }   }

//       0..voffset-1:               top margin (as determined by VOFFSET)
// voffset..voffset+UVI_RASTLINES-1: main area/bottom margin

    // main (character) area----------------------------------------------

    rowc     =
    row      = 0;
    newband  = TRUE;
    notrast  = 0;
    shadowed = FALSE;

    for (x = 0; x < A_BOXWIDTH; x++)
    {   newshadow[x] = 0;
    }

    for (rast = voffset; rast < UVI_RASTLINES; rast++)
    {   for (x = 0; x < A_BOXWIDTH; x++)
        {   shadow[x] = newshadow[x];
            newshadow[x] = 0;
        }

        if (newband)
        {   // start of a new "band" (row) of characters (128*8 pixels in size)

            // BOWLING relies on boardmode being refreshed for each new "band"
            boardmode = memory[A_PITCH] & 0x80;
            if (boardmode)
            {   fgc1     = (memory[A_RESOLUTION] & 0x38) >> 3; // %00111000 -> %00000111
                fgc2     = (memory[A_BGCOLOUR  ] & 0x38) >> 3; // %00111000 -> %00000111 colours of tile set 0
                outerbgc =  memory[A_RESOLUTION] & 0x07;       // %00000111
                innerbgc =  memory[A_BGCOLOUR  ] & 0x07;       // %00000111              background colour
            }

#ifdef SPARESCREEN
            if 
            (   !(memory[A_RESOLUTION] & 0x40) // lower screen on/off flag is clear (so lower screen is turned off)
             || !(memory[A_BGCOLOUR]   & 0x80) // or we are in high res mode
            )
            {   for (x = 0; x < 16; x++)
                {   rowbuf[x]        = memory[0x1A00               + (row << 4) + x];
            }   }
            else
#else
            if (0)
            {   ;
            } else
#endif
            {   // REDCLASH relies on the row of characters being cached
                if (row <= 12)
                {   for (x = 0; x < 16; x++)
                    {   rowbuf[x]    = memory[A_OFFSET_UPPERSCREEN + (row << 4) + x];
                }   }
                elif (row <= 25)
                {   // row can be 26 or more, but rowbuf[] is not used in that case
                    for (x = 0; x < 16; x++)
                    {   rowbuf[x]    = memory[0x1930               + (row << 4) + x];
            }   }   }

            hoffset = A_XMARGIN + ((memory[A_VOLUME] & 0xE0) >> 5); // 3 bits wide
            row++;

            newband = FALSE;
            if (memory[A_CHARLINE] != dma[(memory[A_BGCOLOUR] & 0x80) >> 7][notrast >> 3])
            {   uviwrite(A_CHARLINE, dma[(memory[A_BGCOLOUR] & 0x80) >> 7][notrast >> 3]);
                breakdma();
        }   }
        breakrastline();

        if (rast < A_BOXHEIGHT)
        {   if (flagline && (psu & PSU_F))
            {   theflag[rast] = PSU_F;
                bgc1[rast] = 7 - (memory[A_BGCOLOUR] & 0x07);
            } else
            {   theflag[rast] = 0;
                bgc1[rast] =      memory[A_BGCOLOUR] & 0x07 ;
            }

            slice = CPL - overcalc;
            cpu();
            CHECKINPUT;

            // ** draw one Y-line of the display
            if (row <= rowlimit)
            {   // left margin
                if (screen[0][rast] != from_a[bgc1[rast]])
                {   a_drawpixel(0, rast, bgc1[rast]); // *not* bgc!
                }
                for (x = 1; x < hoffset; x++)
                {   if
                    (   shadowing
                     && (    (bgc1[rast] == BLACK && shadow[x - 1] == 1)
                          || (bgc1[rast] != BLACK && shadow[x - 1] == 2)
                    )   )
                    {   if (screen[x][rast] != GREY1)
                        {   a_drawpixel(x, rast, GREY1);
                        }
                        a_screen[x][rast] = bgc1[rast];
                    } elif (shadowing && shadow[x] == 1)
                    {   if (screen[x][rast] != BLACK)
                        {   a_drawpixel(x, rast, BLACK);
                        }
                        a_screen[x][rast] = bgc1[rast];
                    } else
                    {   if (screen[x][rast] != from_a[bgc1[rast]])
                        {   a_drawpixel(x, rast, bgc1[rast]); // *not* bgc!
                }   }   }

                // centre area
                // assert(x == hoffset);
                // x = hoffset;
                blockmode = (memory[A_RESOLUTION] & 0x80) >> 7;
                for (column = 0; column < 16; column++)
                {   // ** draw one character (or block graphic) **

                    thechar = rowbuf[column];
                    if (thechar == 0xC0)
                    {   blockmode = 1;
                    } elif (thechar == 0x40)
                    {   blockmode = 0;
                    }

                    // get colours for this tile
                    if (boardmode)
                    {   if (theflag[rast]) // or: if (flagline && (psu & PSU_F))
                        {   if (thechar & 0x40)
                            {   fgc = (UBYTE) (7 - fgc2);
                            } else
                            {   fgc = (UBYTE) (7 - fgc1);
                            }
                            if (thechar & 0x80)
                            {   bgc = (UBYTE) (7 - innerbgc);
                            } else
                            {   bgc = (UBYTE) (7 - outerbgc);
                        }   }
                        else
                        {   if (thechar & 0x40)
                            {   fgc = fgc2;
                            } else
                            {   fgc = fgc1;
                            }
                            if (thechar & 0x80)
                            {   bgc = innerbgc;
                            } else
                            {   bgc = outerbgc;
                        }   }
                        bgc2[rast] = innerbgc;
                    } else
                    {   if (theflag[rast]) // or: if (flagline && (psu & PSU_F))
                        {   // if (thechar == 0x3F && undithernow)
                            // {   fgc = DARKBLUE; // logically it should go light (not medium!) blue ($4444FF or $5555FF)
                            // } else
                            fgc = 7
                                - ((thechar            &  0xC0) >> 5)  // %11000000 -> %00000110 (0, 2, 4 or 6)
                                - ((memory[A_BGCOLOUR] >>    3) &  1); // 0 or 1
                        } else
                        {   if (thechar == 0x3F && undithernow)
                            {   fgc = BROWN;
                            } else
                            {   fgc = ((thechar            &  0xC0) >> 5)  // %11000000 -> %00000110 (0, 2, 4 or 6)
                                    + ((memory[A_BGCOLOUR] >>    3) &  1); // 0 or 1
                        }   }
                        bgc = bgc2[rast] = bgc1[rast];
                    }

                    if (thechar == 0x3F && undithernow)
                    {   imagedata = 0xFF;
                    } else
                    {   // get image data for this tile
                        thechar &= 0x3F;
                        if (!blockmode && thechar >= 56) // this is a UDC
                        {   imagedata = memory[A_OFFSET_SPRITES + (8 * (thechar - 56)) + rowc];
                        } else // built-in graphics
                        {   imagedata = pix[blockmode][thechar][rowc];
                    }   }

                    // draw one row of this tile (ie. 8*1)
                    for (xx = 0; xx < 8; xx++)
                    {   if (imagedata & (0x80 >> xx))
                        {   if (screen[x][rast] != from_a[fgc])
                            {   a_drawpixel(x, rast, fgc);
                            }
                            if (fgc == BLACK)
                            {   newshadow[x] = 2;
                            } else
                            {   newshadow[x] = 1;
                        }   }
                        elif (shadowing && shadow[x - 1] >= 1)
                        {   if
                            (   (bgc == BLACK && shadow[x - 1] == 1)
                             || (bgc != BLACK && shadow[x - 1] == 2)
                            )
                            // (Because Space Attack uses black UDCs on a black background.)
                            // Our code doesn't seem to take board mode into account :-( .
                            // Eg. look at shadows on text at top of screen in Space Raiders.
                            {   if (screen[x][rast] != GREY1)
                                {   a_drawpixel(x, rast, GREY1);
                            }   }
                            else
                            {   if (screen[x][rast] != BLACK)
                                {   a_drawpixel(x, rast, BLACK);
                            }   }
                            a_screen[x][rast] = bgc;
                        } else
                        {   if (screen[x][rast] != from_a[bgc])
                            {   a_drawpixel(x, rast, bgc);
                        }   }
                        x++;
                }   }

                // assert(x == hoffset + 128);
                if (shadowing && shadow[x - 1] >= 1)
                {   if
                    (   (bgc1[rast] == BLACK && shadow[x - 1] == 1)
                     || (bgc1[rast] != BLACK && shadow[x - 1] == 2)
                    )
                    {   if (screen[x][rast] != GREY1)
                        {   a_drawpixel(x, rast, GREY1);
                    }   }
                    else
                    {   if (screen[x][rast] != BLACK)
                        {   a_drawpixel(x, rast, BLACK);
                    }   }
                    a_screen[x][rast] = bgc1[rast];
                } else
                {   if (screen[x][rast] != from_a[bgc1[rast]])
                    {   a_drawpixel(x, rast, bgc1[rast]); // *not* bgc!
                }   }
                x++;

                // right margin
                // in case we are in board mode
                // assert(x == hoffset + 128 + 1);
                do
                {   if (screen[x][rast] != from_a[bgc1[rast]])
                    {   a_drawpixel(x, rast, bgc1[rast]); // *not* bgc!
                    }
                    x++;
                } while (x < A_BOXWIDTH);
            } else
            {   // bottom margin

                a_drawline(rast, bgc1[rast]); // draw entire (blank) line
                if (shadowing && !shadowed)
                {   shadowed = TRUE;
                    for (x = hoffset + 1; x <= hoffset + 128; x++)
                    {   if
                        (   (bgc1[rast] == BLACK && shadow[x - 1] == 1)
                         || (bgc1[rast] != BLACK && shadow[x - 1] == 2)
                        )
                        {   if (screen[x][rast] != GREY1)
                            {   a_drawpixel(x, rast, GREY1);
                            }
                            a_screen[x][rast] = bgc1[rast];
                        } elif (shadow[x - 1] == 1)
                        {   if (screen[x][rast] != BLACK)
                            {   a_drawpixel(x, rast, BLACK);
                            }
                            a_screen[x][rast] = bgc1[rast];
                        } else
                        {   if (screen[x][rast] != from_a[bgc1[rast]])
                            {   a_drawpixel(x, rast, bgc1[rast]); // *not* bgc!
        }   }   }   }   }   }
        else // this raster is not shown
        {   slice = CPL - overcalc;
            cpu();
            CHECKINPUT;
        }

        if (rast == INPUTLINE) // 207
        {   a_emuinput();
        } elif (rast == SENSELINE) // 240
        {   psu |= PSU_S;
        }

        if (hires || (notrast & 1))
        {   if (rowc == 7)
            {   rowc = 0;
                newband = TRUE;
            } else rowc++;
        }

        notrast++;
    }

    /* if (A_BOXHEIGHT > UVI_RASTLINES)
    {   // fill gap at bottom margin
        for (notrast = UVI_RASTLINES; notrast < A_BOXHEIGHT; notrast++)
        {   a_drawline(notrast, bgc1[UVI_RASTLINES - 1]);
    }   } */

    // rastline is 0 (262), Sense bit is set, CHARLINE is $FD
    drawallsprites(); // must not be done at SENSELINE, eg. REDCLASH
    collidesprites(); // must not be done at SENSELINE, eg. ROBOTKIL, ESCAPE

    psu &= ~(PSU_S); // clear Sense bit. Necessary, eg. CIRCUS
    uviwrite(A_CHARLINE, 0xFF); // possibly unnecessary or wrong?
    breakdma();

    // Currently, frame skipping only affects turbo mode when "limit
    // refresh rate" is off.

    if (flip == flips)
    {   flip = 0;
    } else flip++;

#ifdef SHOWRUMBLE
    if (rumbling[0])
    {   for (y = 0; y < A_BOXHEIGHT; y++)
        {   a_drawpixel(0, y, (UBYTE) (15 - screen[0][y]));
    }   }
    if (rumbling[1])
    {   for (y = 0; y < A_BOXHEIGHT; y++)
        {   a_drawpixel(A_BOXWIDTH - 1, y, (UBYTE) (15 - screen[A_BOXWIDTH - 1][y]));
    }   }
#endif

    endofframe();
}

MODULE void drawallsprites(void)
{   PERSIST int i, // all PERSISTent for speed
                whichsprite,
                x, y;

    // cache sprite variables
       tall[flip][0] = 2 - ((memory[A_SPRITES01CTRL] & 0x80) >> 7); // %10000000 -> %00000001
       tall[flip][1] = 2 - ((memory[A_SPRITES01CTRL] & 0x40) >> 6); // %01000000 -> %00000001
       tall[flip][2] = 2 - ((memory[A_SPRITES23CTRL] & 0x80) >> 7); // %10000000 -> %00000001
       tall[flip][3] = 2 - ((memory[A_SPRITES23CTRL] & 0x40) >> 6); // %01000000 -> %00000001
    spritex[flip][0] =                memory[A_SPRITE0X] - 43 + A_XMARGIN;
    spritey[flip][0] = (UBYTE) (256 - memory[A_SPRITE0Y]);
    spritex[flip][1] =                memory[A_SPRITE1X] - 43 + A_XMARGIN;
    spritey[flip][1] = (UBYTE) (256 - memory[A_SPRITE1Y]);
    spritex[flip][2] =                memory[A_SPRITE2X] - 43 + A_XMARGIN;
    spritey[flip][2] = (UBYTE) (256 - memory[A_SPRITE2Y]);
    spritex[flip][3] =                memory[A_SPRITE3X] - 43 + A_XMARGIN;
    spritey[flip][3] = (UBYTE) (256 - memory[A_SPRITE3Y]);

    t = 0xFF;
    for (whichsprite = 0; whichsprite < 4; whichsprite++)
    {   // cache sprite background flag pin state
        for (y = 0; y < tall[flip][whichsprite] * 8; y++)
        {   yy = spritey[flip][whichsprite] + y;
            if (yy >= A_BOXHEIGHT)
            {   break;
            }
            switch(whichsprite)
            {
            case 0:
                if (theflag[yy])
                {   spritefgc[flip][whichsprite][y] = (UBYTE) 7 - ((memory[A_SPRITES01CTRL] & 0x38) >> 3); // %00111000 -> %00000111
                } else
                {   spritefgc[flip][whichsprite][y] = (UBYTE)     ((memory[A_SPRITES01CTRL] & 0x38) >> 3); // %00111000 -> %00000111
                }
            acase 1:
                if (theflag[yy])
                {   spritefgc[flip][whichsprite][y] = (UBYTE) 7 - ( memory[A_SPRITES01CTRL] & 0x07      ); // %00000111 -> %00000111
                } else
                {   spritefgc[flip][whichsprite][y] = (UBYTE)     ( memory[A_SPRITES01CTRL] & 0x07      ); // %00000111 -> %00000111
                }
            acase 2:
                if (theflag[yy])
                {   spritefgc[flip][whichsprite][y] = (UBYTE) 7 - ((memory[A_SPRITES23CTRL] & 0x38) >> 3); // %00111000 -> %00000111
                } else
                {   spritefgc[flip][whichsprite][y] = (UBYTE)     ((memory[A_SPRITES23CTRL] & 0x38) >> 3); // %00111000 -> %00000111
                }
            acase 3:
                if (theflag[yy])
                {   spritefgc[flip][whichsprite][y] = (UBYTE) 7 - ( memory[A_SPRITES23CTRL] & 0x07      ); // %00000111 -> %00000111
                } else
                {   spritefgc[flip][whichsprite][y] = (UBYTE)     ( memory[A_SPRITES23CTRL] & 0x07      ); // %00000111 -> %00000111
                }
            adefault:
                // assert(0);
            break;
        }   }

        // cache sprite imagery
        for (y = 0; y < 8; y++)
        {   image[flip][whichsprite][y] = memory[A_OFFSET_SPRITES + (whichsprite * 8) + y];
        }

/* bgc1[y] is sampled (written) at the start of the right margin...
   but really we could have several bgcolours for the one rastline, so the below reliance on
   bgc1[y] is somewhat dodgy... */

        // check sprite position
        if (memory[A_SPRITE0X + (2 * whichsprite)] > 227)
        {   // "If the HC is set to >227, the object is effectively
            // removed from the video field."
            skip[flip][whichsprite] = TRUE;
        } else
        {   skip[flip][whichsprite] = FALSE;

            // detect sprite-background collisions
            // it is important that this is done BEFORE drawing any sprites
            if (collisions)
            {   x = spritex[flip][whichsprite];
                y = spritey[flip][whichsprite];
                if (tall[flip][whichsprite] == 1)
                {   for (xx = 0; xx < 8; xx++)
                    {   if (x >= 0 && x < A_BOXWIDTH)
                        {   for (yy = 0; yy < 8; yy++)
                            {   if (y >= 0 && y < A_BOXHEIGHT)
                                {   imagedata = image[flip][whichsprite][yy];

                                    if
                                    (   (imagedata & (0x80 >> xx)) // if this sprite-pixel is set
                                     && a_screen[x][y] != bgc2[y]
                                    )
                                    {   t &= ~(1 << whichsprite);
                                        if (p1bgcol[whichsprite] > 0)
                                        {   p1rumble = p1bgcol[whichsprite];
                                            // T1; zprintf("p1 background rumble!\n"); T2;
                                        }
                                        if (p2bgcol[whichsprite] > 0)
                                        {   p2rumble = p2bgcol[whichsprite];
                                            // T1; zprintf("p2 background rumble!\n"); T2;
                                        }
                                        break;
                                }   }
                                y++;
                            }
                            y -= 8;
                        }
                        x++;
                }   }
                else
                {   // assert(tall[flip][whichsprite] == 2);
                    for (xx = 0; xx < 8; xx++)
                    {   if (x >= 0 && x < A_BOXWIDTH)
                        {   for (yy = 0; yy < 8; yy++)
                            {   if (y >= 0 && y < A_BOXHEIGHT)
                                {   imagedata = image[flip][whichsprite][yy];

                                    if (imagedata & (0x80 >> xx)) // if this sprite-pixel is set
                                    {   if (a_screen[x][y] != bgc2[y])
                                        {   t &= ~(1 << whichsprite);
                                            if (p1bgcol[whichsprite] > 0)
                                            {   p1rumble = p1bgcol[whichsprite];
                                                // T1; zprintf("p1 background rumble!\n"); T2;
                                            }
                                            if (p2bgcol[whichsprite] > 0)
                                            {   p2rumble = p2bgcol[whichsprite];
                                                // T1; zprintf("p2 background rumble!\n"); T2;
                                            }
                                            break;
                                        }
                                        if (y < A_BOXHEIGHT - 1)
                                        {   if (a_screen[x][y + 1] != bgc2[y + 1])
                                            {   t &= ~(1 << whichsprite);
                                                if (p1bgcol[whichsprite] > 0)
                                                {   p1rumble = p1bgcol[whichsprite];
                                                    // T1; zprintf("p1 background rumble!\n"); T2;
                                                }
                                                if (p2bgcol[whichsprite] > 0)
                                                {   p2rumble = p2bgcol[whichsprite];
                                                    // T1; zprintf("p2 background rumble!\n"); T2;
                                                }
                                                break;
                                }   }   }   }
                                y += 2;
                            }
                            y -= 16;
                        }
                        x++;
    }   }   }   }   }
    uviwrite(A_BGCOLLIDE, t);

    if (t & 1)
    {   if (p1bgcol[0] < 0) p1rumble = -p1bgcol[0];
        if (p2bgcol[0] < 0) p2rumble = -p2bgcol[0];
    }
    if (t & 2)
    {   if (p1bgcol[1] < 0) p1rumble = -p1bgcol[1];
        if (p2bgcol[1] < 0) p2rumble = -p2bgcol[1];
    }
    if (t & 4)
    {   if (p1bgcol[2] < 0) p1rumble = -p1bgcol[2];
        if (p2bgcol[2] < 0) p2rumble = -p2bgcol[2];
    }
    if (t & 8)
    {   if (p1bgcol[3] < 0) p1rumble = -p1bgcol[3];
        if (p2bgcol[3] < 0) p2rumble = -p2bgcol[3];
    }

    for (x = 0; x < A_BOXWIDTH; x++)
    {   for (y = 0; y < A_BOXHEIGHT; y++)
        {   if (flagline && (psu & PSU_F))
            {   sprcolours[x][y] = 7;
            } else sprcolours[x][y] = 0;
    }   }

    if (demultiplex && frames >= (ULONG) flips)
    {   for (i = 1; i <= flips; i++)
        {   drawsprites((flip + i) % (flips + 1));
    }   }

    drawsprites(flip);
}

MODULE __inline void collidesprites(void)
{   /* This doesn't use screen[], thus it is safe at any point in the frame. */

    t = 0xFF;
    if (collisions)
    {   if (sprite_collision(0, 1))
        {   t &=  ~1; // AND with %11111110 (clear bit 0)
            if (p1sprcol[0]) p1rumble = p1sprcol[0];
            if (p2sprcol[0]) p2rumble = p2sprcol[0];
        }
        if (sprite_collision(0, 2))
        {   t &=  ~2; // AND with %11111101 (clear bit 1)
            if (p1sprcol[1]) p1rumble = p1sprcol[1];
            if (p2sprcol[1]) p2rumble = p2sprcol[1];
        }
        if (sprite_collision(0, 3))
        {   t &=  ~4; // AND with %11111011 (clear bit 2)
            if (p1sprcol[2]) p1rumble = p1sprcol[2];
            if (p2sprcol[2]) p2rumble = p2sprcol[2];
        }
        if (sprite_collision(1, 2))
        {   t &=  ~8; // AND with %11110111 (clear bit 3)
            if (p1sprcol[3]) p1rumble = p1sprcol[3];
            if (p2sprcol[3]) p2rumble = p2sprcol[3];
        }
        if (sprite_collision(1, 3))
        {   t &= ~16; // AND with %11101111 (clear bit 4)
            if (p1sprcol[4]) p1rumble = p1sprcol[4];
            if (p2sprcol[4]) p2rumble = p2sprcol[4];
        }
        if (sprite_collision(2, 3))
        {   t &= ~32; // AND with %11011111 (clear bit 5)
            if (p1sprcol[5]) p1rumble = p1sprcol[5];
            if (p2sprcol[5]) p2rumble = p2sprcol[5];
    }   }
    uviwrite(A_SPRITECOLLIDE, t);
}

MODULE void drawsprites(SLONG flipper)
{   PERSIST int whichsprite, x, y; // PERSISTent for speed

    if (!spritesvisible)
    {   return;
    }

    for (whichsprite = 0; whichsprite < 4; whichsprite++)
    {   if
        (   !skip[flipper][whichsprite]
         && (!demultiplex || flipper == flip || !protect[whichsprite])
        )
        {   x = spritex[flipper][whichsprite];
            y = spritey[flipper][whichsprite];

            /* Space Vultures: Unfortunately you get two enemy bombs
            stacked on top of one another when demultiplexing. */

            if (tall[flipper][whichsprite] == 1)
            {   for (yy = 0; yy < 8; yy++)
                {   if (y >= 0 && y < UVI_RASTLINES)
                    {   imagedata =     image[flipper][whichsprite][yy];
                        sprcolour = spritefgc[flipper][whichsprite][yy];

                        for (xx = 0; xx < 8; xx++)
                        {   if (imagedata & (0x80 >> xx)) // if this x-bit is set
                            {   if (x >= 0 && x < A_BOXWIDTH)
                                {   if (flagline && (psu & PSU_F))
                                    {   sprcolours[x][y] = combo[1][sprcolours[x][y]][sprcolour];
                                    } else
                                    {   sprcolours[x][y] = combo[0][sprcolours[x][y]][sprcolour];
                                    }
                                    if (screen[x][y] != from_a[sprcolours[x][y]])
                                    {   a_drawpixel(x, y, sprcolours[x][y]);
                            }   }   }
                            x++;
                        }
                        x -= 8;
                    }
                    y++;
            }   }
            else
            {   for (yy = 0; yy < 8; yy++) // for each y-line of the sprite
                {   if (y >= 0 && y < UVI_RASTLINES)
                    {   imagedata =     image[flipper][whichsprite][yy];
                        sprcolour = spritefgc[flipper][whichsprite][yy * 2];

                        for (xx = 0; xx < 8; xx++)
                        {   if (imagedata & (0x80 >> xx)) // if this x-bit is set
                            {   if (x >= 0 && x < A_BOXWIDTH)
                                {   if (flagline && (psu & PSU_F))
                                    {   sprcolours[x][y] = combo[1][sprcolours[x][y]][sprcolour];
                                    } else
                                    {   sprcolours[x][y] = combo[0][sprcolours[x][y]][sprcolour];
                                    }
                                    if (screen[x][y] != from_a[sprcolours[x][y]])
                                    {   a_drawpixel(x, y, sprcolours[x][y]);
                                    }
                                    if (y < UVI_RASTLINES - 1)
                                    {   if (flagline && (psu & PSU_F))
                                        {   sprcolours[x][y + 1] = combo[1][sprcolours[x][y + 1]][sprcolour];
                                        } else
                                        {   sprcolours[x][y + 1] = combo[0][sprcolours[x][y + 1]][sprcolour];
                                        }
                                        if (screen[x][y + 1] != from_a[sprcolours[x][y + 1]])
                                        {   a_drawpixel(x, y + 1, sprcolours[x][y + 1]);
                            }   }   }   }
                            x++;
                        } // rof (end for)
                        x -= 8;
                    }
                    y += 2;
}   }   }   }   }

/* Each raster is about  12x 16  =  192 clock periods.
   Each frame  is about 192x262/2       clock periods. */

MODULE void a_playerinput(int source, int dest)
{   PERSIST UWORD jg; // PERSISTent for speed

    // dest   is which guest side (0 or 1) you want to set the registers of.
    // source is which host  side (0 or 1) you want to use to do it.

    if (recmode == RECMODE_PLAY)
    {   t = IOBuffer[offset++];
        uviwrite((UWORD) (A_P1PADDLE     -  dest     ),           t              );
        if (memory[A_BGCOLOUR] & 0x40) // paddle interpolation bit
        {   ax[dest] = sx[dest] = t;
        } else
        {   ay[dest] = sy[dest] = t;
        }
        t = IOBuffer[offset++];
        uviwrite((UWORD) (A_P1LEFTKEYS   + (dest * 4)), (UBYTE) ((t & 0xF0) >> 4)); // bits 7..4 -> bits 3..0
        uviwrite((UWORD) (A_P1MIDDLEKEYS + (dest * 4)), (UBYTE)  (t & 0x0F)      ); // bits 3..0 -> bits 3..0 (masking is indeed necessary)
        t = IOBuffer[offset++];
        uviwrite((UWORD) (A_P1RIGHTKEYS  + (dest * 4)), (UBYTE) ((t & 0xF0) >> 4)); // bits 7..4 -> bits 3..0
        uviwrite((UWORD) (A_P1PALLADIUM  + (dest * 4)), (UBYTE)  (t & 0x0F)      ); // bits 3..0 -> bits 3..0 (masking is indeed necessary)
    } else
    {   // assert(recmode == RECMODE_NORMAL || recmode == RECMODE_RECORD);

        if
        (   (dest == 0 && connected == NET_CLIENT)
         || (dest == 1 && connected == NET_SERVER)
        )
        {   return;
        }

        if
        (   hostcontroller[source] == CONTROLLER_1STDJOY
         || hostcontroller[source] == CONTROLLER_1STDPAD
      // || hostcontroller[source] == CONTROLLER_1STAJOY
         || hostcontroller[source] == CONTROLLER_1STAPAD
        )
        {   jg = jf[0];
        } elif
        (   hostcontroller[source] == CONTROLLER_2NDDJOY
         || hostcontroller[source] == CONTROLLER_2NDDPAD
         || hostcontroller[source] == CONTROLLER_2NDAJOY
         || hostcontroller[source] == CONTROLLER_2NDAPAD
        )
        {   jg = jf[1];
        } else
        {   jg = 0;
        }

        memory[A_P1LEFTKEYS   + (dest * 4)] =
        memory[A_P1MIDDLEKEYS + (dest * 4)] =
        memory[A_P1RIGHTKEYS  + (dest * 4)] =
        memory[A_P1PALLADIUM  + (dest * 4)] = 0;
        if (autofire)
        {   if
            (   (   !requirebutton
                 || (jg & JOYFIRE1)
                 || KeyDown(keypads[source][0])
                 || (   hostcontroller[source] == CONTROLLER_TRACKBALL
                     && lmb
                )   )
             && ((frames % totalframes) < downframes)
            )
            {   // 1st firebutton
                memory[keytable[key1].a_address + (dest * 4)] |= keytable[key1].a_mask;
        }   }
        else
        {   if
            (   (jg & JOYFIRE1)
             || KeyDown(keypads[source][0])
             || (   hostcontroller[source] == CONTROLLER_TRACKBALL
                 && lmb
            )   )
            {   // 1st firebutton
                memory[keytable[key1].a_address + (dest * 4)] |= keytable[key1].a_mask;
        }   }

        if
        (   (jg & JOYFIRE2)
         || (KeyDown(keypads[source][21]))
         || (hostcontroller[source] == CONTROLLER_TRACKBALL && mmb)
        )
        {   // 2nd firebutton
            memory[keytable[key2].a_address + (dest * 4)] |= keytable[key2].a_mask;
        }
        if
        (   (jg & JOYFIRE3)
         || (KeyDown(keypads[source][22]))
        )
        {   // 3rd firebutton
            memory[keytable[key3].a_address + (dest * 4)] |= keytable[key3].a_mask;
        }
        if
        (   (jg & JOYFIRE4)
         || (KeyDown(keypads[source][23]))
        )
        {   // 4th firebutton
            memory[keytable[key4].a_address + (dest * 4)] |= keytable[key4].a_mask;
        }

        // left column
        t =  memory[A_P1LEFTKEYS + (dest * 4)];
        t |= (UBYTE) (0x08 * KeyDown(keypads[source][ 1])); // "1"  key (Arcadia)
        t |= (UBYTE) (0x04 * KeyDown(keypads[source][ 4])); // "4"  key (Arcadia)
        t |= (UBYTE) (0x02 * KeyDown(keypads[source][ 7])); // "7"  key (Arcadia)
        t |= (UBYTE) (0x01 * KeyDown(keypads[source][10])); // "Cl" key (Arcadia)
        if (ay[dest] <=  64)
        {   if   (paddleup    ==  1) t |= 8;
            elif (paddleup    ==  4) t |= 4;
            elif (paddleup    ==  7) t |= 2;
            elif (paddleup    == 10) t |= 1;
        } elif (ay[dest] >= 192)
        {   if   (paddledown  ==  1) t |= 8;
            elif (paddledown  ==  4) t |= 4;
            elif (paddledown  ==  7) t |= 2;
            elif (paddledown  == 10) t |= 1;
        }
        if (ax[dest] <=  64)
        {   if   (paddleleft  ==  1) t |= 8;
            elif (paddleleft  ==  4) t |= 4;
            elif (paddleleft  ==  7) t |= 2;
            elif (paddleleft  == 10) t |= 1;
        } elif (ax[dest] >= 192)
        {   if   (paddleright ==  1) t |= 8;
            elif (paddleright ==  4) t |= 4;
            elif (paddleright ==  7) t |= 2;
            elif (paddleright == 10) t |= 1;
        }
        uviwrite((UWORD) (A_P1LEFTKEYS   + (dest * 4)), t);

        // middle column
        t =  memory[A_P1MIDDLEKEYS + (dest * 4)];
        t |= (UBYTE) (0x08 * KeyDown(keypads[source][ 2])); // "2"  key (Arcadia)
        t |= (UBYTE) (0x04 * KeyDown(keypads[source][ 5])); // "5"  key (Arcadia)
        t |= (UBYTE) (0x02 * KeyDown(keypads[source][ 8])); // "8"  key (Arcadia)
        t |= (UBYTE) (0x01 * KeyDown(keypads[source][11])); // "0"  key (Arcadia)
        if (ay[dest] <=  64)
        {   if   (paddleup    ==  2) t |= 8;
            elif (paddleup    ==  5) t |= 4;
            elif (paddleup    ==  8) t |= 2;
            elif (paddleup    ==  0) t |= 1;
        } elif (ay[dest] >= 192)
        {   if   (paddledown  ==  2) t |= 8;
            elif (paddledown  ==  5) t |= 4;
            elif (paddledown  ==  8) t |= 2;
            elif (paddledown  ==  0) t |= 1;
        }
        if (ax[dest] <=  64)
        {   if   (paddleleft  ==  2) t |= 8;
            elif (paddleleft  ==  5) t |= 4;
            elif (paddleleft  ==  8) t |= 2;
            elif (paddleleft  ==  0) t |= 1;
        } elif (ax[dest] >= 192)
        {   if   (paddleright ==  2) t |= 8;
            elif (paddleright ==  5) t |= 4;
            elif (paddleright ==  8) t |= 2;
            elif (paddleright ==  0) t |= 1;
        }
        uviwrite((UWORD) (A_P1MIDDLEKEYS + (dest * 4)), t);

        // right column
        t =  memory[A_P1RIGHTKEYS + (dest * 4)];
        t |= (UBYTE) (0x08 * KeyDown(keypads[source][ 3])); // "3"  key (Arcadia)
        t |= (UBYTE) (0x04 * KeyDown(keypads[source][ 6])); // "6"  key (Arcadia)
        t |= (UBYTE) (0x02 * KeyDown(keypads[source][ 9])); // "9"  key (Arcadia)
        t |= (UBYTE) (0x01 * KeyDown(keypads[source][12])); // "En" key (Arcadia)
        if (ay[dest] <=  64)
        {   if   (paddleup    ==  3) t |= 8;
            elif (paddleup    ==  6) t |= 4;
            elif (paddleup    ==  9) t |= 2;
            elif (paddleup    == 11) t |= 1;
        } elif (ay[dest] >= 192)
        {   if   (paddledown  ==  3) t |= 8;
            elif (paddledown  ==  6) t |= 4;
            elif (paddledown  ==  9) t |= 2;
            elif (paddledown  == 11) t |= 1;
        }
        if (ax[dest] <=  64)
        {   if   (paddleleft  ==  3) t |= 8;
            elif (paddleleft  ==  6) t |= 4;
            elif (paddleleft  ==  9) t |= 2;
            elif (paddleleft  == 11) t |= 1;
        } elif (ax[dest] >= 192)
        {   if   (paddleright ==  3) t |= 8;
            elif (paddleright ==  6) t |= 4;
            elif (paddleright ==  9) t |= 2;
            elif (paddleright == 11) t |= 1;
        }
        uviwrite((UWORD) (A_P1RIGHTKEYS  + (dest * 4)), t);

        // Palladium "column"
        t =  memory[A_P1PALLADIUM + (dest * 4)];
        t |= (UBYTE) (0x08 * KeyDown(keypads[source][16])); // "x4" key (Arcadia)
        t |= (UBYTE) (0x04 * KeyDown(keypads[source][15])); // "x3" key (Arcadia)
        t |= (UBYTE) (0x02 * KeyDown(keypads[source][14])); // "x2" key (Arcadia)
        t |= (UBYTE) (0x01 * KeyDown(keypads[source][13])); // "x1" key (Arcadia)
        if (ay[dest] <=  64)
        {   if   (paddleup    == 15) t |= 8;
            elif (paddleup    == 14) t |= 4;
            elif (paddleup    == 13) t |= 2;
            elif (paddleup    == 12) t |= 1;
        } elif (ay[dest] >= 192)
        {   if   (paddledown  == 15) t |= 8;
            elif (paddledown  == 14) t |= 4;
            elif (paddledown  == 13) t |= 2;
            elif (paddledown  == 12) t |= 1;
        }
        if (ax[dest] <=  64)
        {   if   (paddleleft  == 15) t |= 8;
            elif (paddleleft  == 14) t |= 4;
            elif (paddleleft  == 13) t |= 2;
            elif (paddleleft  == 12) t |= 1;
        } elif (ax[dest] >= 192)
        {   if   (paddleright == 15) t |= 8;
            elif (paddleright == 14) t |= 4;
            elif (paddleright == 13) t |= 2;
            elif (paddleright == 12) t |= 1;
        }
        uviwrite((UWORD) (A_P1PALLADIUM + (dest * 4)), t);

        engine_dopaddle(source, dest);

        if (memory[A_BGCOLOUR] & 0x40) // paddle interpolation bit
        {   uviwrite((UWORD) (A_P1PADDLE - dest), (UBYTE) ax[dest]);
            sx[dest] = (UBYTE) ax[dest];
        } else
        {   uviwrite((UWORD) (A_P1PADDLE - dest), (UBYTE) ay[dest]);
            sy[dest] = (UBYTE) ay[dest];
}   }   }

MODULE __inline void a_emuinput(void)
{   UBYTE therecv[4],
          thesend[4];

    readkybd();
    ReadJoystick(0);
    ReadJoystick(1);
    // must always do a_playerinput(foo, 0) then a_playerinput(foo, 1).
    if (swapped)
    {   a_playerinput(1, 0);
        a_playerinput(0, 1);
    } else
    {   a_playerinput(0, 0);
        a_playerinput(1, 1);
    }
    p1rumble =
    p2rumble = 0;

    if (recmode != RECMODE_PLAY)
    {   // assert(recmode == RECMODE_NORMAL || recmode == RECMODE_RECORD);

        if (KeyDown(console[0]) || (jf[0] & JOYSTART) || (jf[1] & JOYSTART) || console_start) { t =  1; } else { t = 0; }
        if (KeyDown(console[1]) || (jf[0] & JOYA    ) || (jf[1] & JOYA    ) || console_a    ) { t |= 2; }
        if (KeyDown(console[2]) || (jf[0] & JOYB    ) || (jf[1] & JOYB    ) || console_b    ) { t |= 4; }

        uviwrite(A_CONSOLE, t);

        domouse();
    }

    /* 1st argument is pointer to receive buffer.
       2nd argument is pointer to send buffer.
       3rd argument is size in bytes of each buffer

    Server is left player, client is right player.
    4 bytes per frame (27 significant bits) are exchanged for Arcadia.
    3 bytes per frame (24 significant bits) are exchanged for Interton/Elektor. */

    if (connected == NET_SERVER)
    {   // we are left player

        thesend[0] = ((memory[A_P1LEFTKEYS  ] & 0x0F) <<  4) // bits 3..0 -> bits  7..4 (masking not really needed)
                   |  (memory[A_P1MIDDLEKEYS] & 0x0F);       // bits 3..0 -> bits  3..0 (masking not really needed)
        thesend[1] = ((memory[A_P1RIGHTKEYS ] & 0x0F) <<  4) // bits 3..0 -> bits  7..4 (masking not really needed)
                   |  (memory[A_P1PALLADIUM ] & 0x0F);       // bits 3..0 -> bits  3..0 (masking not really needed)
        thesend[2] =   memory[A_P1PADDLE];                   // bits 7..0 -> bits  7..0
        thesend[3] =   memory[A_CONSOLE];                    // bits 7..0 -> bits  7..0

        if (NetExchange((char *) therecv, (const char *) thesend, 4))
        {   uviwrite(A_P2LEFTKEYS  , (UBYTE) ((therecv[0] & 0xF0) >> 4)); // bits 7..4 -> bits 3..0
            uviwrite(A_P2MIDDLEKEYS, (UBYTE)  (therecv[0] & 0x0F)      ); // bits 3..0 -> bits 3..0
            uviwrite(A_P2RIGHTKEYS , (UBYTE) ((therecv[1] & 0xF0) >> 4)); // bits 7..4 -> bits 3..0
            uviwrite(A_P2PALLADIUM , (UBYTE)  (therecv[1] & 0x0F)      ); // bits 3..0 -> bits 3..0
            uviwrite(A_P2PADDLE    ,           therecv[2]              ); // bits 7..0 -> bits 7..0
            uviwrite(A_CONSOLE     , (UBYTE)  (therecv[3] | memory[A_CONSOLE]));
    }   }
    elif (connected == NET_CLIENT)
    {   // we are right player

        thesend[0] = ((memory[A_P2LEFTKEYS  ] & 0x0F) <<  4) // bits 3..0 -> bits  7..4 (masking not really needed)
                   |  (memory[A_P2MIDDLEKEYS] & 0x0F);       // bits 3..0 -> bits  3..0 (masking not really needed)
        thesend[1] = ((memory[A_P2RIGHTKEYS ] & 0x0F) <<  4) // bits 3..0 -> bits  7..4 (masking not really needed)
                   |  (memory[A_P2PALLADIUM ] & 0x0F);       // bits 3..0 -> bits  3..0 (masking not really needed)
        thesend[2] =   memory[A_P2PADDLE];                   // bits 7..0 -> bits  7..0
        thesend[3] =   memory[A_CONSOLE];                    // bits 7..0 -> bits  7..0

        if (NetExchange((char *) therecv, (const char *) thesend, 4))
        {   uviwrite(A_P1LEFTKEYS  , (UBYTE) ((therecv[0] & 0xF0) >> 4)); // bits 7..4 -> bits 3..0
            uviwrite(A_P1MIDDLEKEYS, (UBYTE)  (therecv[0] & 0x0F)      ); // bits 3..0 -> bits 3..0
            uviwrite(A_P1RIGHTKEYS , (UBYTE) ((therecv[1] & 0xF0) >> 4)); // bits 7..4 -> bits 3..0
            uviwrite(A_P1PALLADIUM , (UBYTE)  (therecv[1] & 0x0F)      ); // bits 3..0 -> bits 3..0
            uviwrite(A_P1PADDLE    ,           therecv[2]              ); // bits 7..0 -> bits 7..0
            uviwrite(A_CONSOLE     , (UBYTE)  (therecv[3] | memory[A_CONSOLE]));
    }   }

    if (recmode == RECMODE_PLAY)
    {   uviwrite(A_CONSOLE, IOBuffer[offset++]);
    } elif (recmode == RECMODE_RECORD)
    {   // assert(MacroHandle);

        OutputBuffer[0] =   memory[A_P1PADDLE];                   // bits 7..0 -> bits  7..0
        OutputBuffer[1] = ((memory[A_P1LEFTKEYS  ] & 0x0F) <<  4) // bits 3..0 -> bits  7..4 (masking not really needed)
                        |  (memory[A_P1MIDDLEKEYS] & 0x0F);       // bits 3..0 -> bits  3..0 (masking not really needed)
        OutputBuffer[2] = ((memory[A_P1RIGHTKEYS ] & 0x0F) <<  4) // bits 3..0 -> bits  7..4 (masking not really needed)
                        |  (memory[A_P1PALLADIUM ] & 0x0F);       // bits 3..0 -> bits  3..0 (masking not really needed)
        OutputBuffer[3] =   memory[A_P2PADDLE];                   // bits 7..0 -> bits  7..0
        OutputBuffer[4] = ((memory[A_P2LEFTKEYS  ] & 0x0F) <<  4) // bits 3..0 -> bits  7..4 (masking not really needed)
                        |  (memory[A_P2MIDDLEKEYS] & 0x0F);       // bits 3..0 -> bits  3..0 (masking not really needed)
        OutputBuffer[5] = ((memory[A_P2RIGHTKEYS ] & 0x0F) <<  4) // bits 3..0 -> bits  7..4 (masking not really needed)
                        |  (memory[A_P2PALLADIUM ] & 0x0F);       // bits 3..0 -> bits  3..0 (masking not really needed)
        OutputBuffer[6] =   memory[A_CONSOLE];                    // bits 7..0 -> bits  7..0 (5 bits are wasted)

        DISCARD fwrite(OutputBuffer, 7, 1, MacroHandle);
        // should really check return code of fwrite()
        // 7 bytes per frame * 60 frames per second = 420 bytes/sec.
    }

    if (console_start) console_start--;
    if (console_a    ) console_a--;
    if (console_b    ) console_b--;
    if (console_reset) console_reset--;
}

MODULE int sprite_collision(int first, int second)
{   PERSIST int x1, x2, x3, x4, // PERSISTent for speed
                y1, y2, y3, y4;

    // Undrawn sprites are not collision-checked! This behaviour
    // is needed for eg. DORAEMON.
    if
    (   skip[flip][first]
     || skip[flip][second]
     || spritex[flip][first] <= spritex[flip][second] -  8
     || spritex[flip][first] >= spritex[flip][second] +  8
     || spritey[flip][first] <= spritey[flip][second] - 16
     || spritey[flip][first] >= spritey[flip][second] + 16
    )
    {   return FALSE;
    }

    for (x1 = 0; x1 < 8; x1++)
    {   x3 = spritex[flip][first] + x1;
        for (y1 = 0; y1 < 8 * tall[flip][first]; y1++)
        {   y3 = spritey[flip][first] + y1;
            // for each of the pixels of the first sprite, we do this...
            for (x2 = 0; x2 < 8; x2++)
            {   x4 = spritex[flip][second] + x2;
                for (y2 = 0; y2 < 8 * tall[flip][second]; y2++)
                {   y4 = spritey[flip][second] + y2;
                    if
                    (   x3 == x4
                     && y3 == y4
                     && ((image[flip][first][ y1 / tall[flip][first ]]) & (0x80 >> x1))
                     && ((image[flip][second][y2 / tall[flip][second]]) & (0x80 >> x2))
                    )
                    {   return TRUE;
    }   }   }   }   }

    return FALSE;
}

MODULE __inline void breakdma(void)
{   if (runtodma)
    {   T1; textpen(TEXTPEN_DEBUG);
        zprintf
        (   GetCatalogStr(CatalogPtr,
                MSG_UVI_REACHEDDMA,
                "Reached next DMA ($%X, at raster line %ld).\n\n"
            ),
            memory[A_CHARLINE],
            (long int) rast
        );
        T2;
        runto();
}   }

MODULE __inline void breakrastline(void)
// this is exactly the same as the pvi.c version, we could combine them
// (at some cost in speed)
{   if (rast == rastn)
    {   T1; textpen(TEXTPEN_DEBUG);
        zprintf
        (   GetCatalogStr(CatalogPtr,
                MSG_XVI_REACHEDRASTLINEN,
                "Reached raster line %ld.\n\n"
            ),
            (long int) rast
        );
        T2;
        runto();
}   }

EXPORT void uviwrite(UWORD address, UBYTE data)
{   // assert(address < 32768);

    /* Writes to memory from the UVI always go through this
    routine (so that watchpoints work properly).
      No mirroring is done here; the emulator is expected to use the
    resolved address.
      If you have a watchpoint on a mirrored address, eg. $3000,
    then ideally an access of $1000 by the UVI should trigger the.
    watchpoint. The easiest way to deal with this would be to resolve
    the address early (during the "set watchpoint" requester). The same
    applies, of course, for the PVI. */

    if ((memflags[address] & WATCHPOINT) && data != memory[address])
    {   DISCARD getfriendly((int) address);
        T1; textpen(TEXTPEN_DEBUG);
        zprintf
        (   GetCatalogStr(CatalogPtr,
                MSG_UVI_HITWP,
                "UVI is writing $%X to %s at raster %ld!\n\n"
            ),
                       data,
            (char *)   friendly,
            (long int) rast
        );
        T2;
        runto();
    }

    memory[address] = data;
}

EXPORT void a_drawpixel(int x, int y, UBYTE colour)
{   a_screen[x][y] = colour;
    colour         = from_a[colour];
    screen[x][y]   = colour;
    drawpixel(x, y, colour);
}

/* Note that ALIENINV uses sprite-background collision detection,
not sprite-sprite collision detection, for the UFO (aka mothership).
The only sprite-sprite collisions are for players colliding with the
enemy bombs.

CIRCUS waits until CHARLINE == $FD, then immediately checks
SPRITECOLLIDE.

PLEIADES doesn't seem to use the SPRITECOLLIDE or BGCOLLIDE registers
at all. Thus, turning off collision detection will have no effect on
this game.

Games with twinkling starfields:
    SATTACK?
    SVULTURE
    THE-END
and probably others. */

MODULE __inline void a_drawline(int y, UBYTE colour)
{   PERSIST int x; // PERSISTent for speed

    // assert(y >= 0);
    // assert(y < A_BOXHEIGHT);
    // assert(colour >= 0);
    // assert(colour <= 7);

#ifdef WIN32
    for (x = 0; x < A_BOXWIDTH; x++)
    {   if (screen[x][y] != from_a[colour]) // *not* if (a_screen[x][y] != colour)
        {   a_drawpixel(x, y, colour);
    }   }
#endif
#ifdef AMIGA
    for (x = 0; x < A_BOXWIDTH; x++)
    {   a_screen[x][y] = colour;
        screen[x][y]   = from_a[colour];
    }
    colour = from_a[colour];
    y *= size;
    for (x = 0; x < divided * size; x++) // this assumes all rows are contiguous
    {   *(longptr[y] + x) = longpens[colour];
    }
#endif
}

EXPORT void save_eap(int kind)
{   PERSIST   const STRPTR eapcolour[8] =
    {   "White-7",
        "Yellow-6",
        "Cyan-5",
        "Green-4",
        "Magenta-3",
        "Red-2",
        "Blue-1",
        "Black-0"
    };
    TRANSIENT       int    imageryoffset,
                           y;
    TRANSIENT       FILE*  TheLocalHandle /* = NULL */ ; // LocalHandle is a variable of winbase.h
    TRANSIENT       TEXT   disp[4 + 1]       = "";

/* Each line terminates with LF+CR ($13+$10).
   We are relying on the fact that there can never be a null byte ($00)
   in these files.

 1 ;Screen-Magenta-3                                 19
 2 Sprite11:                                         11
 3 ;Magenta-3                                        12
 4       db          xxh,xxh,xxh,xxh,xxh,xxh,xxh,xxh 51
 5 Sprite22:                                         11
 6 ;Magenta-3                                        12
 7       db          xxh,xxh,xxh,xxh,xxh,xxh,xxh,xxh 51
 8 Sprite33:                                         11
 9 ;Magenta-3                                        12
10       db          xxh,xxh,xxh,xxh,xxh,xxh,xxh,xxh 51
11 Sprite44:                                         11
12 ;Magenta-3                                        12
13       db          xxh,xxh,xxh,xxh,xxh,xxh,xxh,xxh 51
*/

    if (machine != ARCADIA)
    {   return;
    }

    strcpy(fn_project, filepart);
    fixextension(filekind[KIND_EAP].extension, fn_project, TRUE);

    if (asl
    (   filekind[KIND_EAP].hail,
        filekind[KIND_EAP].pattern,
        TRUE,
        DIR_PROJECTS,
        fn_project, // this fortunately doesn't contain the path right now
        fn_project
    ) != EXIT_SUCCESS)
    {   return;
    }

    if (kind == 0)
    {   imageryoffset = A_OFFSET_SPRITES;
    } else
    {   imageryoffset = A_OFFSET_UDCS;
    }

    // inner colour: RESOLUTION (high bit of char clear)
    //  (only usable in non-border)
    // outer colour: BGCOLOUR   (high bit of char set)
    //  (used in border, usable in non-border)
    // 1st line
    strcpy(ProjectBuffer, ";Screen-");
    if (flagline && (psu & PSU_F))
    {   if (memory[A_PITCH] & 0x80) // board mode
        {   strcat(ProjectBuffer, eapcolour[7 - (memory[A_RESOLUTION] & 0x07)]); // inner colour
        } else
        {   strcat(ProjectBuffer, eapcolour[7 - (memory[A_BGCOLOUR  ] & 0x07)]);
    }   }
    else
    {   if (memory[A_PITCH] & 0x80) // board mode
        {   strcat(ProjectBuffer, eapcolour[    (memory[A_RESOLUTION] & 0x07)]); // inner colour
        } else
        {   strcat(ProjectBuffer, eapcolour[    (memory[A_BGCOLOUR  ] & 0x07)]);
    }   }
    strcat(ProjectBuffer, "\x0D\x0A");

    // 2nd line
    strcat(ProjectBuffer, "Sprite1:");
    strcat(ProjectBuffer, "\x0D\x0A");
    // 3rd line
    strcat(ProjectBuffer, ";");
    if (flagline && (psu & PSU_F))
    {   strcat(ProjectBuffer, eapcolour[7 - ((memory[A_SPRITES01CTRL] & 0x38) >> 3)]);
    } else
    {   strcat(ProjectBuffer, eapcolour[     (memory[A_SPRITES01CTRL] & 0x38) >> 3 ]);
    }
    strcat(ProjectBuffer, "\x0D\x0A");
    // 4th line
    strcat(ProjectBuffer, "      db          "); // 6 spaces before, 10 spaces after
    for (y = 0; y < 8; y++)
    {   hex1(disp, memory[imageryoffset + 0 + y]);
        strcat(ProjectBuffer, disp);
        if (y == 7)
        {   strcat(ProjectBuffer, "h");
        } else
        {   strcat(ProjectBuffer, "h,");
    }   }
    strcat(ProjectBuffer, "\x0D\x0A");

    // 5th line
    strcat(ProjectBuffer, "Sprite2:");
    strcat(ProjectBuffer, "\x0D\x0A");
    // 6th line
    strcat(ProjectBuffer, ";");
    if (flagline && (psu & PSU_F))
    {   strcat(ProjectBuffer, eapcolour[7 -  (memory[A_SPRITES01CTRL] & 0x07)      ]);
    } else
    {   strcat(ProjectBuffer, eapcolour[     (memory[A_SPRITES01CTRL] & 0x07)      ]);
    }
    strcat(ProjectBuffer, "\x0D\x0A");
    // 7th line
    strcat(ProjectBuffer, "      db          "); // 6 spaces before, 10 spaces after
    for (y = 0; y < 8; y++)
    {   hex1(disp, memory[imageryoffset + 8 + y]);
        strcat(ProjectBuffer, disp);
        if (y == 7)
        {   strcat(ProjectBuffer, "h");
        } else
        {   strcat(ProjectBuffer, "h,");
    }   }
    strcat(ProjectBuffer, "\x0D\x0A");

    // 8th line
    strcat(ProjectBuffer, "Sprite3:");
    strcat(ProjectBuffer, "\x0D\x0A");
    // 9th line
    strcat(ProjectBuffer, ";");
    if (flagline && (psu & PSU_F))
    {   strcat(ProjectBuffer, eapcolour[7 - ((memory[A_SPRITES23CTRL] & 0x38) >> 3)]);
    } else
    {   strcat(ProjectBuffer, eapcolour[     (memory[A_SPRITES23CTRL] & 0x38) >> 3 ]);
    }
    strcat(ProjectBuffer, "\x0D\x0A");
    // 10th line
    strcat(ProjectBuffer, "      db          "); // 6 spaces before, 10 spaces after
    for (y = 0; y < 8; y++)
    {   hex1(disp, memory[imageryoffset + 16 + y]);
        strcat(ProjectBuffer, disp);
        if (y == 7)
        {   strcat(ProjectBuffer, "h");
        } else
        {   strcat(ProjectBuffer, "h,");
    }   }
    strcat(ProjectBuffer, "\x0D\x0A");

    // 11th line
    strcat(ProjectBuffer, "Sprite4:");
    strcat(ProjectBuffer, "\x0D\x0A");
    // 12th line
    strcat(ProjectBuffer, ";");
    if (flagline && (psu & PSU_F))
    {   strcat(ProjectBuffer, eapcolour[7 -  (memory[A_SPRITES23CTRL] & 0x07)      ]);
    } else
    {   strcat(ProjectBuffer, eapcolour[     (memory[A_SPRITES23CTRL] & 0x07)      ]);
    }
    strcat(ProjectBuffer, "\x0D\x0A");
    // 13th line
    strcat(ProjectBuffer, "      db          "); // 6 spaces before, 10 spaces after
    for (y = 0; y < 8; y++)
    {   hex1(disp, memory[imageryoffset + 24 + y]);
        strcat(ProjectBuffer, disp);
        if (y == 7)
        {   strcat(ProjectBuffer, "h");
        } else
        {   strcat(ProjectBuffer, "h,");
    }   }
    strcat(ProjectBuffer, "\x0D\x0A");

    if (!(TheLocalHandle = fopen(fn_project, "wb")))
    {   beep();
        return;
    }
    DISCARD fwrite(ProjectBuffer, (size_t) strlen(ProjectBuffer), 1, TheLocalHandle);
    DISCARD fclose(TheLocalHandle);
    // TheLocalHandle = NULL;
}

EXPORT void save_eal(void)
{   PERSIST const STRPTR ealcolour[8] =
    {   "White",
        "Yellow",
        "Cyan",
        "Green",
        "Majenta", // sic
        "Red",
        "Blue",
        "Black"
    };
    PERSIST       TEXT   tempstring[2 + 1];
    TRANSIENT     int    i, j;
    TRANSIENT     FILE*  TheLocalHandle /* = NULL */ ; // LocalHandle is a variable of winbase.h

/* Each line terminates with LF+CR ($13+$10).
   We are relying on the fact that there can never be a null byte ($00)
   in these files.

    1 <background colour>                                       9
    2 <foreground colour>                                       9
 3-15 "0,1,2,3,4,5,6,7,8,9,A,B,C,D,E,F,"                36*13=468
16-28 "0,1,2,3,4,5,6,7,8,9,A,B,C,D,E,F,"                36*13=468

Limitations:
 TextMakerEA doesn't support:
  graphics characters.
  UDCs.
  block mode.
  board mode.
  multiple background colours.
  multiple foreground colours.
 Improvements:
  make it have a look at the characters on the screen, determine the
   commonest foreground colour and use that.
  do similar for the background colour.
*/

    if (machine != ARCADIA)
    {   return;
    }

    strcpy(fn_project, filepart);
    fixextension(filekind[KIND_EAL].extension, fn_project, TRUE);

    if (asl
    (   filekind[KIND_EAL].hail,
        filekind[KIND_EAL].pattern,
        TRUE,
        DIR_PROJECTS,
        fn_project, // this fortunately doesn't contain the path right now
        fn_project
    ) != EXIT_SUCCESS)
    {   return;
    }

    // 1st line
    if (flagline && (psu & PSU_F))
    {   if (memory[A_PITCH] & 0x80) // board mode
        {   strcat(ProjectBuffer, ealcolour[7 - (memory[A_RESOLUTION] & 0x07)]);
        } else
        {   strcat(ProjectBuffer, ealcolour[7 - (memory[A_BGCOLOUR  ] & 0x07)]);
    }   }
    else
    {   if (memory[A_PITCH] & 0x80) // board mode
        {   strcat(ProjectBuffer, ealcolour[    (memory[A_RESOLUTION] & 0x07)]);
        } else
        {   strcat(ProjectBuffer, ealcolour[    (memory[A_BGCOLOUR  ] & 0x07)]);
    }   }
    strcat(ProjectBuffer, "\x0D\x0A");

    // 2nd line
    if (flagline && (psu & PSU_F))
    {   strcat(ProjectBuffer, ealcolour[7 - ((memory[A_BGCOLOUR] >> 3) & 1)]); // 6 or 7
    } else
    {   strcat(ProjectBuffer, ealcolour[     (memory[A_BGCOLOUR] >> 3) & 1 ]); // 0 or 1
    }
    strcat(ProjectBuffer, "\x0D\x0A");

    tempstring[1] = ',';
    tempstring[2] =  0 ;

    // 3rd..15th lines
    for (i = 0x1800; i < 0x18D0; i += 16)
    {   strcat(ProjectBuffer, "\"");
        for (j = 0; j < 16; j++)
        {   tempstring[0] = txtmaker_chars[memory[i + j] % 64];
            strcat(ProjectBuffer, tempstring);
        }
        strcat(ProjectBuffer, "\"");
        strcat(ProjectBuffer, "\x0D\x0A");
    }

    // 16th..28th lines
    for (i = 0x1A00; i < 0x1AD0; i += 16)
    {   strcat(ProjectBuffer, "\"");
        for (j = 0; j < 16; j++)
        {   tempstring[0] = txtmaker_chars[memory[i + j] % 64];
            strcat(ProjectBuffer, tempstring);
        }
        strcat(ProjectBuffer, "\"");
        strcat(ProjectBuffer, "\x0D\x0A");
    }

    if (!(TheLocalHandle = fopen(fn_project, "wb")))
    {   beep();
        return;
    }
    DISCARD fwrite(ProjectBuffer, (size_t) strlen(ProjectBuffer), 1, TheLocalHandle);
    DISCARD fclose(TheLocalHandle);
    // TheLocalHandle = NULL;
}

EXPORT void a_setmemmap(void)
{   int i, address, mirror;

    game = FALSE;

    for (i = 0; i <= 0xFF; i++) // 256 bytes
    {   memory[i] = a_bios[i];
    }
    for (i = 0x100; i <= 0x7FFF; i++)
    {   memory[i] = 0;
    }
    for (i = 0x1909; i <= 0x190F; i++)
    {   memory[i] = 0xC0; // some of them (randomly) are $40 though
    }
    for (i = 0x19C0; i <= 0x19F7; i++)
    {   memory[i] = 0xFF;
    }

    for (address = 0; address < 32 * KILOBYTE; address++)
    {   memflags[address] = 0;
        mirror            = address;

        if (memmap == MEMMAP_I)
        {   if (address < 0x1800 || address > 0x1BFF)
            {   memflags[address] |= NOWRITE;
        }   }
        else
        {   // assert(memmap == MEMMAP_G || memmap == MEMMAP_H);

            if
            (    address <= 0x0FFF                       // ROM
     // legal/not occurring: $1000..$17FF                   extra RAM and/or mirrored
        // legal:            $1800..$18CF                   upper screen
        // legal:            $18D0..$18EF                   user RAM
        // legal:            $18F0..$18F7                   R/W hardware registers
        // legal:            $18F8..$18FB                   user RAM
        // legal:            $18FC                          R/W hardware register
        // legal:            $18FD                          -/W hardware register
        // legal:            $18FE                          R/W hardware register
             || (address >= 0x18FF && address <= 0x197F) // CHARLINE, PnXKEYS/PALLADIUM, CONSOLE, unmapped
        // legal:            $1980..$19BF                   R/W hardware registers
             || (address >= 0x19C0 && address <= 0x19F7) // unmapped
        // legal:            $19F8..$19FB                   -/W hardware registers
             || (address >= 0x19FC && address <= 0x19FF) // BGCOLLIDE, SPRITECOLLIDE, PnPADDLE
        // legal:            $1A00..$1ACF                   lower screen
        // legal:            $1AD0..$1AFF                   user RAM
             ||  address >= 0x1B00                       // not occurring, ROM
            )
            {   memflags[address] |= NOWRITE;
        }   }

        if
        (
        // legal:                $0000              ..$0FFF     ROM
        // legal/not occurring:  $1000              ..$17FF     extra RAM and/or mirrored
        // legal:                $1800              ..$18CF     upper screen
        // legal:                $18D0              ..$18EF     user RAM
        // legal:                $18F0              ..$18F7     R/W hardware regs
        // legal:                $18F8              ..$18FB     user RAM
        // legal:                $18FC              ..$18FE     R/W hardware regs
        // legal:                $18FF              ..$1908     R/- hardware regs
                    (address >= 0x1909 && address <= 0x190F) // unmapped (apparently reads as $40 or $C0)
        // not occurring:        $1910              ..$197F     mirrored
        // legal:                $1980              ..$19BF     R/W hardware regs
                 || (address >= 0x19C0 && address <= 0x19FB) // unmapped (apparently reads as $FF), -/W hardware regs
        // legal:                $19FC              ..$19FF     read-once hardware regs
        // legal:                $1A00              ..$1ACF     lower screen
        // legal:                $1AD0              ..$1AFF     user RAM
        // not occurring:        $1B00              ..$1FFF     mirrored
        // legal:                $2000              ..$2FFF     ROM
        // not occurring:        $3000              ..$3FFF     mirrored
        // not occurring:        $4000              ..$4FFF     mirrored?
        // not occurring:        $5000              ..$5FFF     mirrored
        // not occurring:        $6000              ..$6FFF     mirrored?
        // not occurring:        $7000              ..$7FFF     mirrored
        )
        {   memflags[address] |= NOREAD;
        }

        if (address >= 0x19FC && address <= 0x19FF) // read-once: $19FC..$19FF: PnPADDLE, SPRITECOLLIDE, BGCOLLIDE
        {   memflags[address] |= READONCE;
        }

        if (address == A_PITCH || address == A_VOLUME)
        {   memflags[address] |= AUDIBLE;
        }

        // G,H: The only accesses that are NOT mirrored are those to:
        // $0000..$10FF (with memory map "H")
        // $1200..$12FF (with memory map "H")
        // $1800..$19FF
        // $1A00..$1AFF (with memory maps "G" and "H")
        // $2000..$2FFF
        // I:   All is ROM except $1800..$1BFF.

        if (memmap == MEMMAP_I)
        {   if (mirror >= 0x1B00 && mirror <= 0x1BFF)
            {   mirror -= 0x200; // $1Bxx -> $19xx
        }   }
        else
        {   // assert(memmap == MEMMAP_G || memmap == MEMMAP_H);

            if (mirror & 0x1000) // $1xxx, $3xxx, $5xxx, $7xxx
            {   mirror &= 0x1FFF; // -> $1xxx (mask of %0001 1111 1111 1111)

                if (mirror & 0x100) // $x1xx, $x3xx, $x5xx, $x7xx, $x9xx, $xBxx, $xDxx, $xFxx
                {   mirror &= 0x11FF; // -> $11xx
                    mirror += 0x800;  // -> $19xx
                }

                if (mirror >= 0x1400 && mirror <= 0x17FF)
                {   mirror -= 0x400; // -> $1000..$13FF
                } elif (mirror >= 0x1C00 && mirror <= 0x1FFF)
                {   mirror -= 0x400; // -> $1800..$1AFF
                }

                if (memmap == MEMMAP_G)
                {   if (mirror >= 0x1000 && mirror <= 0x13FF)
                    {   mirror += 0x800; // -> $1800..$1BFF
                }   }

                if (mirror >= 0x1F10 && mirror <= 0x1F7F)
                {   mirror &= 0x1F0F; // $1F10..$1F7F -> $1F00..$1F0F
            }   }
            else // else is just for speed
            {   if ((mirror & 0x5000) == 0x4000) // $4xxx, $6xxx
                {   mirror &= 0xFFF; // -> $0xxx
        }   }   }

        if (mirror != address)
        {   memflags[address] |= MIRRORED_R | MIRRORED_W;
        }
        mirror_r[address] =
        mirror_w[address] = (UWORD) mirror;
}   }

EXPORT void a_viewscreen(void)
{   int y;

    // Ideally, we would show the text in the correct colours

    T1; textpen(TEXTPEN_VIEW);
    for (y = 0; y <= 12; y++)
    {   dumprow(A_OFFSET_UPPERSCREEN + (y * 16));
    }
    for (y = 0; y <= 12; y++)
    {   dumprow(A_OFFSET_LOWERSCREEN + (y * 16));
    }
    zprintf("\n");
    T2;
}

EXPORT void a_serializerom(void)
{   int i;

    /* This is for Palladium (ie. memmap "I"). Emerson ("G") and Tele-
       Fever ("H") are different (see EA2001 Coding Guide). */

    // assert(machine == ARCADIA);
    // assert(romsize <= 31 * KILOBYTE);

    for (i = 0; i < 4 * KILOBYTE; i++)
    {   if (i == romsize)                   return;
        serialize_byte(&memory[i]);                    // memory $0000..$0FFF <-> file $0000..$0FFF
    }
    for (i = 0; i < 4 * KILOBYTE; i++)
    {   if (i == romsize - ( 4 * KILOBYTE)) return;
        serialize_byte(&memory[0x2000 + i]);           // memory $2000..$2FFF <-> file $1000..$1FFF
    }
    for (i = 0; i < 4 * KILOBYTE; i++)
    {   if (i == romsize - ( 8 * KILOBYTE)) return;
        serialize_byte(&memory[0x4000 + i]);           // memory $4000..$4FFF <-> file $2000..$2FFF
    }
    // arbitrary...
    for (i = 0; i < 4 * KILOBYTE; i++)
    {   if (i == romsize - (12 * KILOBYTE)) return;
        serialize_byte(&memory[0x6000 + i]);           // memory $6000..$6FFF <-> file $3000..$3FFF
    }
    for (i = 0; i < 4 * KILOBYTE; i++)
    {   if (i == romsize - (16 * KILOBYTE)) return;
        serialize_byte(&memory[0x3000 + i]);           // memory $3000..$3FFF <-> file $4000..$4FFF
    }
    for (i = 0; i < 4 * KILOBYTE; i++)
    {   if (i == romsize - (20 * KILOBYTE)) return;
        serialize_byte(&memory[0x5000 + i]);           // memory $5000..$5FFF <-> file $5000..$5FFF
    }
    for (i = 0; i < 4 * KILOBYTE; i++)
    {   if (i == romsize - (24 * KILOBYTE)) return;
        serialize_byte(&memory[0x7000 + i]);           // memory $7000..$7FFF <-> file $6000..$6FFF
    }
    for (i = 0; i < 2 * KILOBYTE; i++)
    {   if (i == romsize - (28 * KILOBYTE)) return;
        serialize_byte(&memory[0x1000 + i]);           // memory $1000..$17FF <-> file $7000..$77FF
    }
    for (i = 0; i < 1 * KILOBYTE; i++)
    {   if (i == romsize - (30 * KILOBYTE)) return;
        serialize_byte(&memory[0x1C00 + i]);           // memory $1C00..$1FFF <-> file $7800..$7BFF
    }

    if (serializemode == SERIALIZE_READ && golf)
    {   // This is for unpatched Arcadia Golf
        // It mirrors $2000..$27FF at $4000..$47FF
        for (i = 0; i < 2 * KILOBYTE; i++)
        {   memory[0x4000 + i] = memory[0x2000 + i];
}   }   }

