// INCLUDES---------------------------------------------------------------

#ifdef __VBCC__
    #define AMIGA
#endif
#ifdef AMIGA
    #include "amiga.h"
#endif
#ifdef _lint
    #define WIN32
    #define _inline
#endif
#ifdef WIN32
    #include "ibm.h"
    #define EXEC_TYPES_H
#endif

#include <stdio.h>

#include "aa.h"
#define CATCOMP_NUMBERS
#define CATCOMP_BLOCK
#include "aa_strings.h"
#ifdef AMIGA
    #include <proto/locale.h>  // GetCatalogStr()
#endif

// DEFINES----------------------------------------------------------------

// (none)

// EXPORTED VARIABLES-----------------------------------------------------

EXPORT       UBYTE          dolphin_leds[4]    = { 0, 0, 0, 0 };
EXPORT const TEXT           dolphin_chars[128] =
// 0               1               2               3
// 0123456789ABCDEF0123456789ABCDEF0123456789ABCDEF0123456789ABCDEF
#ifdef AMIGA
  " " \
   "\'" \
     ",17_=JuJ'rn71nLCGU0" \
  "-==3r?nc2odacuo495Y9FPhHAtE668";
#endif
#ifdef WIN32
  " " \
   "\'" \
     ",17_=JuJ'rn71nLCGU0" \
  "-==3r?nc2odacuo495Y9FPhHAtE668";
// We could actually show some of these properly, eg. with MS-DOS corner glyphs.
#endif

// IMPORTED VARIABLES-----------------------------------------------------

IMPORT UBYTE                memory[32768],
                            sd_column[7];
IMPORT UWORD                mirror_r[32768],
                            mirror_w[32768];
IMPORT ULONG                frames,
                            memflags[32768];
IMPORT int                  consoleopen,
                            drawcorners,
                            drawunlit,
                            game,
                            inframe,
                            machine,
                            memmap,
                            offset,
                            overcalc,
                            recmode,
                            shadowing,
                            slice,
                            zinterrupt;
IMPORT UBYTE                OutputBuffer[7],
                            psu;
IMPORT UBYTE*               IOBuffer;
IMPORT UWORD                console[4],
                            iar,
                            keypads[2][NUMKEYS];
IMPORT ULONG                cycles,
                            elapsed;
IMPORT ULONG*               ctrldisplay;
IMPORT FILE*                MacroHandle;
IMPORT TEXT                 friendly[21 + 1];
IMPORT ASCREEN              screen[BOXWIDTH][BOXHEIGHT];
#ifdef AMIGA
    IMPORT struct Catalog*   CatalogPtr;
#endif
#ifdef WIN32
    IMPORT int               CatalogPtr; // APTR doesn't work
#endif

// MODULE VARIABLES-------------------------------------------------------

MODULE const UBYTE d_bios[256] = {
0xCC,0x02,0xF0,0x04,0x02,0x93,0xCC,0x02,0xF9,0xCD,0x02,0xF1,0xCE,0x02,0xF2,0xCF,
0x02,0xF3,0x04,0x00,0x1B,0x36,0x1B,0x1F,0x07,0x00,0x0E,0x02,0xF2,0x0D,0x02,0xF1,
0x0C,0x02,0xF0,0xBF,0x82,0xF9,0x17,0x55,0x07,0xE1,0x18,0x7B,0x17,0xCF,0x02,0xF9,
0x0C,0x82,0xF9,0xCC,0x02,0xFB,0x17,0x3F,0x00,0xCB,0x55,0x07,0x01,0xE4,0x50,0x98,
0x04,0x3B,0x2C,0x1B,0x0A,0xE4,0x60,0x98,0x0B,0x0C,0x02,0xFB,0xCC,0x02,0xFA,0x3B,
0x5F,0x01,0x3B,0x53,0x01,0x9A,0x60,0x44,0x10,0x18,0x09,0x45,0x03,0x0D,0x60,0x96,
0xC3,0x9F,0x00,0x00,0x01,0x44,0x20,0x18,0x19,0x0F,0x02,0xFA,0xBF,0x01,0x00,0x0C,
0x02,0xF8,0xCC,0x82,0xF9,0x06,0xFB,0x04,0x01,0x8E,0x42,0x00,0xCE,0x62,0x00,0x38,
0x76,0x17,0x3B,0x02,0x9B,0x37,0x45,0x0F,0x0C,0x02,0xFB,0xD0,0xD0,0xD0,0xD0,0x44,
0xF0,0x61,0xCC,0x02,0xFB,0x17,0x9A,0xC0,0xA4,0xC3,0x0C,0x02,0xFA,0xA4,0x01,0xCC,
0x02,0xFA,0x9B,0x18,0x57,0x07,0x47,0x3F,0xB8,0x02,0x1B,0x78,0xD3,0xD3,0xD3,0x06,
0x01,0x3B,0x07,0xD4,0x06,0x17,0x06,0xC8,0x07,0xA5,0xC0,0xFB,0x7D,0xFA,0x79,0x17,
0x1F,0x0C,0x00,0x0C,0x02,0xFA,0xA4,0x03,0x1F,0x00,0x4C,0x0C,0x02,0xFB,0x3B,0x0E,
0xD4,0x03,0xD5,0x02,0x0C,0x02,0xFA,0x3B,0x05,0xD4,0x01,0xD5,0x00,0x17,0xC1,0x51,
0x51,0x51,0x51,0x45,0x0F,0x44,0x0F,0xC2,0x0D,0x60,0xF0,0xC1,0x0E,0x60,0xF0,0x17,
0x3F,0x06,0x5B,0x4F,0x66,0x6D,0x7D,0x07,0x7F,0x6F,0x77,0x7C,0x39,0x5E,0x79,0x71
};

// MODULE FUNCTIONS-------------------------------------------------------

MODULE void d_emuinput(void);
MODULE __inline void local_drawpixel(int x, int y, int colour);

// CODE-------------------------------------------------------------------

MODULE void d_emuinput(void)
{   UBYTE t;

    readkybd();

    if (recmode == RECMODE_PLAY)
    {   t = IOBuffer[offset++];
        sd_column[1] = (UBYTE) ((t & 0xF0) >> 4);
        sd_column[2] = (UBYTE)  (t & 0x0F)      ;
        t = IOBuffer[offset++];
        sd_column[3] = (UBYTE) ((t & 0xF0) >> 4);
        sd_column[4] = (UBYTE)  (t & 0x0F)      ;
        t = IOBuffer[offset++];
        sd_column[5] = (UBYTE) ((t & 0xF0) >> 4);
        sd_column[6] = (UBYTE)  (t & 0x0F)      ;
    } else
    {   // assert(recmode == RECMODE_NORMAL || recmode == RECMODE_RECORD);

        sd_column[1] = (UBYTE) (0x1 * KeyDown(keypads[0][ 8]));

        sd_column[2] = (UBYTE) (0x1 * KeyDown(keypads[0][11]));

        t =  0;
        t |= (UBYTE) (0x8 * KeyDown(keypads[0][3])); // "C" key
        t |= (UBYTE) (0x4 * KeyDown(keypads[0][6])); // "8" key
        t |= (UBYTE) (0x2 * KeyDown(keypads[0][9])); // "4" key
        t |= (UBYTE) (0x1 * KeyDown(keypads[0][12])); // "0" key
        sd_column[3] = t;

        t =  0;
        t |= (UBYTE) (0x8 * KeyDown(keypads[1][1])); // "D" key
        t |= (UBYTE) (0x4 * KeyDown(keypads[1][4])); // "9" key
        t |= (UBYTE) (0x2 * KeyDown(keypads[1][7])); // "5" key
        t |= (UBYTE) (0x1 * KeyDown(keypads[1][10])); // "1" key
        sd_column[4] = t;

        t =  0;
        t |= (UBYTE) (0x8 * KeyDown(keypads[1][2])); // "E" key
        t |= (UBYTE) (0x4 * KeyDown(keypads[1][5])); // "A" key
        t |= (UBYTE) (0x2 * KeyDown(keypads[1][8])); // "6" key
        t |= (UBYTE) (0x1 * KeyDown(keypads[1][11])); // "2" key
        sd_column[5] = t;

        t =  0;
        t |= (UBYTE) (0x8 * KeyDown(keypads[1][3])); // "F" key
        t |= (UBYTE) (0x4 * KeyDown(keypads[1][6])); // "B" key
        t |= (UBYTE) (0x2 * KeyDown(keypads[1][9])); // "7" key
        t |= (UBYTE) (0x1 * KeyDown(keypads[1][12])); // "3" key
        sd_column[6] = t;

        domouse();
    }

    if (recmode == RECMODE_RECORD)
    {   // assert(MacroHandle);

        OutputBuffer[0] = ((sd_column[1] & 0x0F) << 4)
                        |  (sd_column[2] & 0x0F);
        OutputBuffer[1] = ((sd_column[3] & 0x0F) << 4)
                        |  (sd_column[4] & 0x0F);
        OutputBuffer[2] = ((sd_column[5] & 0x0F) << 4)
                        |  (sd_column[6] & 0x0F);

        DISCARD fwrite(OutputBuffer, 3, 1, MacroHandle);
        // should really check return code of fwrite()
        // 3 bytes per frame * 50 frames per second = 150 bytes/sec.
}   }

EXPORT void d_setmemmap(void)
{   int i, address, mirror;

    game = FALSE;

    for (i = 0x0; i <= 0xFF; i++) // 256 bytes
    {   memory[i] = d_bios[i];
    }
    for (i = 0x100; i <= 0x7FFF; i++)
    {   memory[i] = 0;
    }

    for (address = 0; address < 32 * KILOBYTE; address++)
    {   memflags[address] = 0;
        mirror            = address;

        if
        (   address <= 0x1FF
         || address >= 0xC00
        )
        {   memflags[address] |= NOWRITE;
        }
        if
        (   address >= 0x1000
        )
        {   memflags[address] |= NOREAD;
        }

        if (mirror != address)
        {   memflags[address] |= MIRRORED_R | MIRRORED_W;
        }
        mirror_r[address] =
        mirror_w[address] = (UWORD) mirror;
}   }

EXPORT void d_emulate(void)
{   int i, j;

    inframe = TRUE;

    // this is to emulate the non-persistence of the segment display
    if (drawunlit)
    {   for (i = 0; i < 4; i++)
        {   for (j = 0; j < 7; j++)
            {   drawsegment(i, j, UNLIT);
            }
            drawsegment(i, 13, UNLIT);
    }   }
    else
    {   for (i = 0; i < 4; i++)
        {   for (j = 0; j < 7; j++)
            {   drawsegment(i, j, BLACK);
            }
            drawsegment(i, 13, BLACK);
    }   }
    if (drawunlit && drawcorners)
    {   for (i = 0; i < 4; i++)
        {   for (j = 7; j <= 12; j++)
            {   drawsegment(i, j, UNLIT);
    }   }   }
    else
    {   for (i = 0; i < 4; i++)
        {   for (j = 7; j <= 12; j++)
            {   drawsegment(i, j, BLACK);
    }   }   }

    // 1MHz = 1,000,000 cycles per second
    // 1,000,000 / 50 = 20,000
    // slice = 20000 - overcalc;
    slice = 1900 - overcalc; // this is really slow but seems correct for Reflexes
    cpu();

    d_emuinput();

    endofframe();
}

EXPORT UBYTE d_readport(int port)
{   TRANSIENT FLAG  handled = TRUE;
    PERSIST   UBYTE t; // PERSISTent for speed
    PERSIST   FLAG  fresh   = TRUE;

    // assert(machine == DOLPHIN);

    port &= 0x3F;

    switch (port)
    {
    case 0x07:
        if (fresh)
        {   if   (sd_column[3] & 1) t = 128;
            elif (sd_column[4] & 1) t = 129;
            elif (sd_column[5] & 1) t = 130;
            elif (sd_column[6] & 1) t = 131;
            elif (sd_column[3] & 2) t = 132;
            elif (sd_column[4] & 2) t = 133;
            elif (sd_column[5] & 2) t = 134;
            elif (sd_column[6] & 2) t = 135;
            elif (sd_column[3] & 4) t = 136;
            elif (sd_column[4] & 4) t = 137;
            elif (sd_column[5] & 4) t = 138;
            elif (sd_column[6] & 4) t = 139;
            elif (sd_column[3] & 8) t = 140;
            elif (sd_column[4] & 8) t = 141;
            elif (sd_column[5] & 8) t = 142;
            elif (sd_column[6] & 8) t = 143;
            elif (sd_column[1] & 1) t = 0x50;
            elif (sd_column[2] & 1) t = 0x60;
            else                   t =    0;
            if (t != 0) fresh = FALSE;
        } else
        {   t = 0;
            if
            (   !sd_column[1] && !sd_column[2] && !sd_column[3]
             && !sd_column[4] && !sd_column[5] && !sd_column[6]
            )
            {   fresh = TRUE;
        }   }
    adefault:
        handled = FALSE;
        t = 0;
    }

    logport(port, t, handled, FALSE);
    return t;
}

EXPORT void d_writeport(int port, UBYTE data)
{   FLAG handled = TRUE;
    int  i;

    port &= 0x3F;

    // ioport[port] = data;
    switch (port)
    {
    case 0x00:
    case 0x01:
    case 0x02:
    case 0x03:
        dolphin_leds[port] = data;

        for (i = 0; i < 14; i++)
        {   drawsegment(port, i, BLACK);
        }

        if (drawcorners)
        {   if (dolphin_leds[port] & 0x21) // top left
            {   drawsegment(port, 7, RED);
            } elif (drawunlit)
            {   drawsegment(port, 7, UNLIT);
            }
            if (dolphin_leds[port] & 0x03) // top right
            {   drawsegment(port, 8, RED);
            } elif (drawunlit)
            {   drawsegment(port, 8, UNLIT);
            }
            if (dolphin_leds[port] & 0x70) // middle left
            {   drawsegment(port, 9, RED);
            } elif (drawunlit)
            {   drawsegment(port, 9, UNLIT);
            }
            if (dolphin_leds[port] & 0x46) // middle right
            {   drawsegment(port, 10, RED);
            } elif (drawunlit)
            {   drawsegment(port, 10, UNLIT);
            }
            if (dolphin_leds[port] & 0x18) // bottom left
            {   drawsegment(port, 11, RED);
            } elif (drawunlit)
            {   drawsegment(port, 11, UNLIT);
            }
            if (dolphin_leds[port] & 0x0C) // bottom right
            {   drawsegment(port, 12, RED);
            } elif (drawunlit)
            {   drawsegment(port, 12, UNLIT);
        }   }

        for (i = 0; i < 7; i++)
        {   if (dolphin_leds[port] & (1 << i))
            {   drawsegment(port, i, RED);
            } elif (drawunlit)
            {   drawsegment(port, i, UNLIT);
        }   }
        if (dolphin_leds[port] & 128)
        {   drawsegment(port, 13, RED);
        } elif (drawunlit)
        {   drawsegment(port, 13, UNLIT);
        }
    adefault: // eg. $06
        handled = FALSE;
    }

    logport(port, data, handled, TRUE);
}

EXPORT void d_drawglows(void)
{   int colour,
        i,
        shadowcolour;

    for (i = 0; i < 2; i++)
    {   if (psu & (128 >> i))
        {   colour       = RED;
        } elif (drawunlit)
        {   colour       = DARKBLUE;
        } else
        {   colour       = BLACK;
        }
        if (shadowing && colour != BLACK)
        {   shadowcolour = GREY1;
        } else
        {   shadowcolour = BLACK;
        }

        local_drawpixel(20 + 23 + (i * 21), 61, shadowcolour);
        local_drawpixel(20 + 23 + (i * 21), 62, shadowcolour);
        local_drawpixel(20 + 23 + (i * 21), 63, shadowcolour);
        local_drawpixel(19 + 23 + (i * 21), 64, shadowcolour);
        local_drawpixel(20 + 23 + (i * 21), 64, shadowcolour);
        local_drawpixel(16 + 23 + (i * 21), 65, shadowcolour);
        local_drawpixel(17 + 23 + (i * 21), 65, shadowcolour);
        local_drawpixel(18 + 23 + (i * 21), 65, shadowcolour);
        local_drawpixel(19 + 23 + (i * 21), 65, shadowcolour);

        local_drawpixel(15 + 23 + (i * 21), 59, colour);
        local_drawpixel(16 + 23 + (i * 21), 59, colour);
        local_drawpixel(17 + 23 + (i * 21), 59, colour);
        local_drawpixel(18 + 23 + (i * 21), 59, colour);
        local_drawpixel(14 + 23 + (i * 21), 60, colour);
        local_drawpixel(15 + 23 + (i * 21), 60, colour);
        local_drawpixel(16 + 23 + (i * 21), 60, colour);
        local_drawpixel(17 + 23 + (i * 21), 60, colour);
        local_drawpixel(18 + 23 + (i * 21), 60, colour);
        local_drawpixel(19 + 23 + (i * 21), 60, colour);
        local_drawpixel(14 + 23 + (i * 21), 61, colour);
        local_drawpixel(15 + 23 + (i * 21), 61, colour);
        local_drawpixel(16 + 23 + (i * 21), 61, colour);
        local_drawpixel(17 + 23 + (i * 21), 61, colour);
        local_drawpixel(18 + 23 + (i * 21), 61, colour);
        local_drawpixel(19 + 23 + (i * 21), 61, colour);
        local_drawpixel(14 + 23 + (i * 21), 62, colour);
        local_drawpixel(15 + 23 + (i * 21), 62, colour);
        local_drawpixel(16 + 23 + (i * 21), 62, colour);
        local_drawpixel(17 + 23 + (i * 21), 62, colour);
        local_drawpixel(18 + 23 + (i * 21), 62, colour);
        local_drawpixel(19 + 23 + (i * 21), 62, colour);
        local_drawpixel(14 + 23 + (i * 21), 63, colour);
        local_drawpixel(15 + 23 + (i * 21), 63, colour);
        local_drawpixel(16 + 23 + (i * 21), 63, colour);
        local_drawpixel(17 + 23 + (i * 21), 63, colour);
        local_drawpixel(18 + 23 + (i * 21), 63, colour);
        local_drawpixel(19 + 23 + (i * 21), 63, colour);
        local_drawpixel(15 + 23 + (i * 21), 64, colour);
        local_drawpixel(16 + 23 + (i * 21), 64, colour);
        local_drawpixel(17 + 23 + (i * 21), 64, colour);
        local_drawpixel(18 + 23 + (i * 21), 64, colour);
}   }                      

MODULE __inline void local_drawpixel(int x, int y, int colour)
{   if (screen[x][y] != (UBYTE) colour)
    {   screen[x][y] = (UBYTE) colour;
        drawpixel(x, y, colour);
}   }

EXPORT void dolphin_viewscreen(void)
{   // assert(machine == DOLPHIN);

    T1; textpen(TEXTPEN_VIEW);
    zprintf
    (   "%02X %02X %02X %02X    %c%c%c%c%c%c%c%c\n\n",
        dolphin_leds[0],
        dolphin_leds[1],
        dolphin_leds[2],
        dolphin_leds[3],
        dolphin_chars[dolphin_leds[0] & 0x7F], (dolphin_leds[0] & 0x80) ? '.' : ' ',
        dolphin_chars[dolphin_leds[1] & 0x7F], (dolphin_leds[1] & 0x80) ? '.' : ' ',
        dolphin_chars[dolphin_leds[2] & 0x7F], (dolphin_leds[2] & 0x80) ? '.' : ' ',
        dolphin_chars[dolphin_leds[3] & 0x7F], (dolphin_leds[3] & 0x80) ? '.' : ' '
    );
    T2;
}
