// INCLUDES---------------------------------------------------------------

#ifdef __VBCC__
    #define AMIGA
#endif
#ifdef AMIGA
    #include "amiga.h"
#endif
#ifdef _lint
    #define WIN32
#endif
#ifdef WIN32
    #ifdef _lint
        #define _inline
    #endif
    #include "ibm.h"
#endif

#include <stdio.h>

#include "aa.h"
#include "elektor.h"

// DEFINES----------------------------------------------------------------

// EXPORTED VARIABLES-----------------------------------------------------

EXPORT TEXT                 letters[8 + 1];

// IMPORTED VARIABLES-----------------------------------------------------

IMPORT UBYTE                memory[32768],
                            OutputBuffer[7];
IMPORT UWORD                mirror_r[32768],
                            mirror_w[32768];
IMPORT ULONG                memflags[32768];
IMPORT int                  consoleopen,
                            game,
                            loader,
                            machine,
                            memmap,
                            offset,
                            pvibase,
                            traceverbose;
IMPORT UBYTE*               IOBuffer;
IMPORT FILE*                MacroHandle;

// CODE-------------------------------------------------------------------

EXPORT void view_psgs(void)
{   PERSIST const STRPTR waveshape[16] = {
  "\\_______________",                // %0000 single decay then off
  "\\_______________",                // %0001 single decay then off
  "\\_______________",                // %0010 single decay then off
  "\\_______________",                // %0011 single decay then off
  "/_______________",                 // %0100 single attack then off
  "/_______________",                 // %0101 single attack then off
  "/_______________",                 // %0110 single attack then off
  "/_______________",                 // %0111 single attack then off
  "\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\", // %1000 repeated decay
  "\\_______________",                // %1001 single decay then off
  "\\/\\/\\/\\/\\/\\/\\/\\/",         // %1010 repeated decay-attack
  "\\\"\"\"\"\"\"\"\"\"\"\"\"\"\"\"", // %1011 single decay then hold
  "////////////////",                 // %1100 repeated attack
  "/\"\"\"\"\"\"\"\"\"\"\"\"\"\"\"",  // %1101 single attack then hold
  "/\\/\\/\\/\\/\\/\\/\\/\\",         // %1110 repeated attack-decay
  "/_______________"                  // %1111 single attack then off
};

    if (memmap != MEMMAP_F)
    {   return;
    }

    T1; textpen(TEXTPEN_VIEW);
    zprintf
    (   "---------------PSG #1---------------- "
        "---------------PSG #2----------------\n"
    );
    zprintf
    (   "PITCHA1:      %04X PITCHD1:        %02X PITCHA2:      %04X PITCHD2:        %02X\n",
        (memory[E_PITCHA1_H] * 256) + memory[E_PITCHA1_L],
         memory[E_PITCHD1],
        (memory[E_PITCHA2_H] * 256) + memory[E_PITCHA2_L],
         memory[E_PITCHD2]
    );
    zprintf
    (   "PITCHB1:      %04X MIXER1:         %02X PITCHB2:      %04X MIXER2:         %02X\n",
        (memory[E_PITCHB1_H] * 256) + memory[E_PITCHB1_L],
         memory[E_MIXER1],
        (memory[E_PITCHB2_H] * 256) + memory[E_PITCHB2_L],
         memory[E_MIXER2]
    );
    zprintf
    (   "PITCHC1:      %04X PERIOD1:      %04X PITCHC2:      %04X PERIOD2:      %04X\n",
        (memory[E_PITCHC1_H] * 256) + memory[E_PITCHC1_L],
        (memory[E_PERIOD1_H] * 256) + memory[E_PERIOD1_L],
        (memory[E_PITCHC2_H] * 256) + memory[E_PITCHC2_L],
        (memory[E_PERIOD2_H] * 256) + memory[E_PERIOD2_L]
    );
    zprintf
    (   "AMPLITUDEA1:    %02X SHAPE1:         %02X AMPLITUDEA2:    %02X SHAPE2:         %02X\n",
        memory[E_AMPLITUDEA1],
        memory[E_SHAPE1     ],
        memory[E_AMPLITUDEA2],
        memory[E_SHAPE2     ]
    );
    zprintf
    (   "AMPLITUDEB1:    %02X PORTA1:         %02X AMPLITUDEB2:    %02X PORTA2:         %02X\n",
        memory[E_AMPLITUDEB1],
        memory[E_PORTA1     ],
        memory[E_AMPLITUDEB2],
        memory[E_PORTA2     ]
    );
    zprintf
    (   "AMPLITUDEC1:    %02X PORTB1:         %02X AMPLITUDEC2:    %02X PORTB2:         %02X\n\n",
        memory[E_AMPLITUDEC1],
        memory[E_PORTB1     ],
        memory[E_AMPLITUDEC2],
        memory[E_PORTB2     ]
    );

    if (traceverbose)
    {   zprintf
        (   "Tone A pitch:    %6.3f Hz                 %6.3f Hz\n",
            ((memory[E_PITCHA1_H] & 0x0F) == 0 && memory[E_PITCHA1_L] == 0) ? (float) 110837.0 : (float) (110837.0 / (((memory[E_PITCHA1_H] & 0x0F) * 256) + memory[E_PITCHA1_L])),
            ((memory[E_PITCHA2_H] & 0x0F) == 0 && memory[E_PITCHA2_L] == 0) ? (float) 110837.0 : (float) (110837.0 / (((memory[E_PITCHA2_H] & 0x0F) * 256) + memory[E_PITCHA2_L]))
        );
        zprintf
        (   "Tone B pitch:    %6.3f Hz                 %6.3f Hz\n",
            ((memory[E_PITCHB1_H] & 0x0F) == 0 && memory[E_PITCHB1_L] == 0) ? (float) 110837.0 : (float) (110837.0 / (((memory[E_PITCHB1_H] & 0x0F) * 256) + memory[E_PITCHB1_L])),
            ((memory[E_PITCHB2_H] & 0x0F) == 0 && memory[E_PITCHB2_L] == 0) ? (float) 110837.0 : (float) (110837.0 / (((memory[E_PITCHB2_H] & 0x0F) * 256) + memory[E_PITCHB2_L]))
        );
        zprintf
        (   "Tone C pitch:    %6.3f Hz                 %6.3f Hz\n",
            ((memory[E_PITCHC1_H] & 0x0F) == 0 && memory[E_PITCHC1_L] == 0) ? (float) 110837.0 : (float) (110837.0 / (((memory[E_PITCHB1_H] & 0x0F) * 256) + memory[E_PITCHB1_L])),
            ((memory[E_PITCHC2_H] & 0x0F) == 0 && memory[E_PITCHC2_L] == 0) ? (float) 110837.0 : (float) (110837.0 / (((memory[E_PITCHB2_H] & 0x0F) * 256) + memory[E_PITCHB2_L]))
        );
        zprintf
        (   "Noises pitch:    %6.3f Hz                 %6.3f Hz\n",
            ((memory[E_PITCHD1]   & 0x1F) == 0) ? (float) 110837.0 : (float) (110837.0 / (memory[E_PITCHD1] & 0x1F)),
            ((memory[E_PITCHD2]   & 0x1F) == 0) ? (float) 110837.0 : (float) (110837.0 / (memory[E_PITCHD2] & 0x1F))
        );
        zprintf
        (   "Tone channels:   A=%s, B=%s, C=%s           A=%s, B=%s, C=%s\n",
            (memory[E_MIXER1] & 0x01) ? "off" : "on ",
            (memory[E_MIXER1] & 0x02) ? "off" : "on ",
            (memory[E_MIXER1] & 0x04) ? "off" : "on ",
            (memory[E_MIXER2] & 0x01) ? "off" : "on ",
            (memory[E_MIXER2] & 0x02) ? "off" : "on ",
            (memory[E_MIXER2] & 0x04) ? "off" : "on "
        );
        zprintf
        (   "Noise channels:  A=%s, B=%s, C=%s           A=%s, B=%s, C=%s\n",
            (memory[E_MIXER1] & 0x08) ? "off" : "on ",
            (memory[E_MIXER1] & 0x10) ? "off" : "on ",
            (memory[E_MIXER1] & 0x20) ? "off" : "on ",
            (memory[E_MIXER2] & 0x08) ? "off" : "on ",
            (memory[E_MIXER2] & 0x10) ? "off" : "on ",
            (memory[E_MIXER2] & 0x20) ? "off" : "on "
        );
        zprintf
        (   "I/O ports:       A=%s, B=%s            A=%s, B=%s\n",
            (memory[E_MIXER1] & 0x40) ? "output" : "disbld",
            (memory[E_MIXER1] & 0x80) ? "output" : "disbld",
            (memory[E_MIXER2] & 0x40) ? "output" : "disbld",
            (memory[E_MIXER2] & 0x80) ? "output" : "disbld"
        );
        zprintf
        (   "Channel volumes: A=%2d, B=%2d, C=%2d of 15        A=%2d, B=%2d, C=%2d of 15\n",
            (int) (memory[E_AMPLITUDEA1] & 0x0F),
            (int) (memory[E_AMPLITUDEB1] & 0x0F),
            (int) (memory[E_AMPLITUDEC1] & 0x0F),
            (int) (memory[E_AMPLITUDEA2] & 0x0F),
            (int) (memory[E_AMPLITUDEB2] & 0x0F),
            (int) (memory[E_AMPLITUDEC2] & 0x0F)
        );
        zprintf
        (   "Amplitude modes: A=%s, B=%s, C=%s  A=%s, B=%s, C=%s\n",
            (memory[E_AMPLITUDEA1] & 0x10) ? "envlpe" : "normal",
            (memory[E_AMPLITUDEB1] & 0x10) ? "envlpe" : "normal",
            (memory[E_AMPLITUDEC1] & 0x10) ? "envlpe" : "normal",
            (memory[E_AMPLITUDEA2] & 0x10) ? "envlpe" : "normal",
            (memory[E_AMPLITUDEB2] & 0x10) ? "envlpe" : "normal",
            (memory[E_AMPLITUDEC2] & 0x10) ? "envlpe" : "normal"
        );

        zprintf
        (   "Envelope:\n Period:         %4.3f Hz                   %4.3f Hz\n",
            (memory[E_PERIOD1_H] == 0 && memory[E_PERIOD1_L] == 0) ? (float) 6927.313 : (float) (6927.313 / ((memory[E_PERIOD1_H] * 256) + memory[E_PERIOD1_L])),
            (memory[E_PERIOD2_H] == 0 && memory[E_PERIOD2_L] == 0) ? (float) 6927.313 : (float) (6927.313 / ((memory[E_PERIOD2_H] * 256) + memory[E_PERIOD2_L]))
        );
        zprintf
        (   " Shape:          %s              %s\n",
            waveshape[memory[E_SHAPE1] & 0x0F],
            waveshape[memory[E_SHAPE2] & 0x0F]
        );
        zprintf
        (   " Hold:           %s                           %s\n",
            (memory[E_SHAPE1] & 0x01) ? "on " : "off",
            (memory[E_SHAPE2] & 0x01) ? "on " : "off"
        );
        zprintf
        (   " Alternate:      %s                           %s\n",
            (memory[E_SHAPE1] & 0x02) ? "on " : "off",
            (memory[E_SHAPE2] & 0x02) ? "on " : "off"
        );
        zprintf
        (   " Attack:         %s                           %s\n",
            (memory[E_SHAPE1] & 0x04) ? "on " : "off",
            (memory[E_SHAPE2] & 0x04) ? "on " : "off"
        );
        zprintf
        (   " Continue:       %s                           %s\n\n",
            (memory[E_SHAPE1] & 0x08) ? "on " : "off",
            (memory[E_SHAPE2] & 0x08) ? "on " : "off"
        );
    }

    T2;
}

EXPORT void monob(int y)
{   TRANSIENT TEXT whichletter;
    TRANSIENT int  i, x;

PERSIST const TEXT  elektor_chars2[28 + 1] = "?_!NlTi:.BDHJKQRTUVXYZ!?MMWW";
// SAS/C says "initializer data truncated" if it is only [28].
PERSIST const UBYTE elektor_bmaps[28][6] = {
// from chapter 11
{ 0xE, // ###. ? ($5F)
  0x2, // ..#.
  0x2, // ..#.
  0xE, // ###.
  0x8, // #...
  0x8  // #...
},
{ 0x0, // .... _ ($8F)
  0x0, // ....
  0x0, // ....
  0x0, // ....
  0x0, // ....
  0xA  // #.#.
},
{ 0x4, // .#.. ! ($A2)
  0x4, // .#..
  0x0, // ....
  0x4, // .#..
  0x0, // ....
  0x0  // ....
},
{ 0x0, // .... N ($AA)
  0xE, // ###.
  0xA, // #.#.
  0xA, // #.#.
  0xA, // #.#.
  0xA  // #.#.
},
{ 0x8, // #... l ($BB)
  0x8, // #...
  0x8, // #...
  0x8, // #...
  0x8, // #...
  0x8  // #...
},
{ 0xE, // ###. T ($BC)
  0xE, // ###.
  0x4, // .#..
  0x4, // .#..
  0x4, // .#..
  0x4  // .#..
},
{ 0x4, // .#.. i ($DF)
  0x0, // ....
  0xC, // ##..
  0x4, // .#..
  0x4, // .#..
  0x4  // .#..
},
{ 0xC, // ##.. : ($E6)
  0xC, // ##..
  0x0, // ....
  0x0, // ....
  0xC, // ##..
  0xC  // ##..
},
{ 0x0, // .... . ($F7)
  0x0, // ....
  0x0, // ....
  0x0, // ....
  0x0, // ....
  0x4  // .#..
},
// from chapter 17
{ 0xE, // ###. B
  0xA, // #.#.
  0xC, // ##..
  0xA, // #.#.
  0xA, // #.#.
  0xE  // ###.
},
{ 0xC, // ##.. D
  0xA, // #.#.
  0xA, // #.#.
  0xA, // #.#.
  0xA, // #.#.
  0xC  // ##..
},
{ 0xA, // #.#. H
  0xA, // #.#.
  0xE, // ###.
  0xA, // #.#.
  0xA, // #.#.
  0xA  // #.#.
},
{ 0x2, // ..#. J
  0x2, // ..#.
  0x2, // ..#.
  0x2, // ..#.
  0x2, // ..#.
  0xE  // ###.
},
{ 0xA, // #.#. K
  0xA, // #.#.
  0xC, // ##..
  0xA, // #.#.
  0xA, // #.#.
  0xA  // #.#.
},
{ 0xE, // ###. Q
  0xA, // #.#.
  0xA, // #.#.
  0xA, // #.#.
  0xA, // #.#.
  0xF  // ####
},
{ 0xE, // ###. R
  0xA, // #.#.
  0xC, // ##..
  0xA, // #.#.
  0xA, // #.#.
  0xA  // #.#.
},
{ 0xE, // ###. T
  0x4, // .#..
  0x4, // .#..
  0x4, // .#..
  0x4, // .#..
  0x4  // .#..
},
{ 0xA, // #.#. U
  0xA, // #.#.
  0xA, // #.#.
  0xA, // #.#.
  0xA, // #.#.
  0xE  // ###.
},
{ 0xA, // #.#. V
  0xA, // #.#.
  0xA, // #.#.
  0xA, // #.#.
  0xA, // #.#.
  0x4  // .#..
},
{ 0xA, // #.#. X
  0xA, // #.#.
  0x4, // .#..
  0xA, // #.#.
  0xA, // #.#.
  0xA  // #.#.
},
{ 0xA, // #.#. Y
  0xA, // #.#.
  0xA, // #.#.
  0x4, // .#..
  0x4, // .#..
  0x4  // .#..
},
{ 0xE, // ###. Z
  0x2, // ..#.
  0x4, // .#..
  0x8, // #...
  0x8, // #...
  0xE  // ###.
},
{ 0x4, // .#.. !
  0x4, // .#..
  0x4, // .#..
  0x4, // .#..
  0x0, // ....
  0x4  // .#..
},
{ 0xE, // ###. ?
  0x2, // ..#.
  0xE, // ###.
  0x8, // #...
  0x0, // ....
  0x8  // #...
},
{ 0x6, // .##. M (left  half)
  0x4, // .#.#
  0x4, // .#..
  0x4, // .#..
  0x4, // .#..
  0x4  // .#..
},
{ 0xC, // ##.. M (right half)
  0x4, // .#..
  0x4, // .#..
  0x4, // .#..
  0x4, // .#..
  0x4  // .#..
},
{ 0x4, // .#.. W (left  half)
  0x4, // .#..
  0x4, // .#..
  0x4, // .#..
  0x5, // .#.#
  0x2  // ..#.
},
{ 0x4, // .#.. W (right half)
  0x4, // .#..
  0x4, // .#..
  0x4, // .#..
  0x4, // .#..
  0x8  // #...
} };

    // assert(machine == ELEKTOR);

    for (x = 0; x < 4; x++) // 4 sprites per row
    {   whichletter = '#';
        for (i = 0; i < 256; i += 2)
        {   // check left letter against left ROM letters
            if
            (   ((memory[0x800 + (y * 24) + (x * 6)]) & 0xE0)       == ((memory[0x27B + ((i / 2) * 6)]) & 0xE0)
             && ((memory[0x801 + (y * 24) + (x * 6)]) & 0xE0)       == ((memory[0x27C + ((i / 2) * 6)]) & 0xE0)
             && ((memory[0x802 + (y * 24) + (x * 6)]) & 0xE0)       == ((memory[0x27D + ((i / 2) * 6)]) & 0xE0)
             && ((memory[0x803 + (y * 24) + (x * 6)]) & 0xE0)       == ((memory[0x27E + ((i / 2) * 6)]) & 0xE0)
             && ((memory[0x804 + (y * 24) + (x * 6)]) & 0xE0)       == ((memory[0x27F + ((i / 2) * 6)]) & 0xE0)
             && ((memory[0x805 + (y * 24) + (x * 6)]) & 0xE0)       == ((memory[0x280 + ((i / 2) * 6)]) & 0xE0)
            )
            {   whichletter = elektor_chars1[i];
                break; // for speed
            }

            // check left letter against right ROM letters
            if
            (   ((memory[0x800 + (y * 24) + (x * 6)]) & 0xE0) >> 4  == ((memory[0x27B + ((i / 2) * 6)]) & 0x0E)
             && ((memory[0x801 + (y * 24) + (x * 6)]) & 0xE0) >> 4  == ((memory[0x27C + ((i / 2) * 6)]) & 0x0E)
             && ((memory[0x802 + (y * 24) + (x * 6)]) & 0xE0) >> 4  == ((memory[0x27D + ((i / 2) * 6)]) & 0x0E)
             && ((memory[0x803 + (y * 24) + (x * 6)]) & 0xE0) >> 4  == ((memory[0x27E + ((i / 2) * 6)]) & 0x0E)
             && ((memory[0x804 + (y * 24) + (x * 6)]) & 0xE0) >> 4  == ((memory[0x27F + ((i / 2) * 6)]) & 0x0E)
             && ((memory[0x805 + (y * 24) + (x * 6)]) & 0xE0) >> 4  == ((memory[0x280 + ((i / 2) * 6)]) & 0x0E)
            )
            {   whichletter = elektor_chars1[i + 1];
                break; // for speed
        }   }
        if (whichletter == '#')
        {   // check left letter against accidentals and modifieds
            for (i = 0; i < 28; i++)
            {   if
                (   ((memory[0x800 + (y * 24) + (x * 6)]) & 0xE0) >> 4 == elektor_bmaps[i][0]
                 && ((memory[0x801 + (y * 24) + (x * 6)]) & 0xE0) >> 4 == elektor_bmaps[i][1]
                 && ((memory[0x802 + (y * 24) + (x * 6)]) & 0xE0) >> 4 == elektor_bmaps[i][2]
                 && ((memory[0x803 + (y * 24) + (x * 6)]) & 0xE0) >> 4 == elektor_bmaps[i][3]
                 && ((memory[0x804 + (y * 24) + (x * 6)]) & 0xE0) >> 4 == elektor_bmaps[i][4]
                 && ((memory[0x805 + (y * 24) + (x * 6)]) & 0xE0) >> 4 == elektor_bmaps[i][5]
                )
                {   whichletter = elektor_chars2[i];
                    break; // for speed
        }   }   }

        letters[x * 2] = whichletter;

        whichletter = '#';
        for (i = 0; i < 256; i += 2)
        {   // check right letter against left ROM letters
            if
            (   ((memory[0x800 + (y * 24) + (x * 6)]) & 0x0E)       == ((memory[0x27B + ((i / 2) * 6)]) & 0xE0) >> 4
             && ((memory[0x801 + (y * 24) + (x * 6)]) & 0x0E)       == ((memory[0x27C + ((i / 2) * 6)]) & 0xE0) >> 4
             && ((memory[0x802 + (y * 24) + (x * 6)]) & 0x0E)       == ((memory[0x27D + ((i / 2) * 6)]) & 0xE0) >> 4
             && ((memory[0x803 + (y * 24) + (x * 6)]) & 0x0E)       == ((memory[0x27E + ((i / 2) * 6)]) & 0xE0) >> 4
             && ((memory[0x804 + (y * 24) + (x * 6)]) & 0x0E)       == ((memory[0x27F + ((i / 2) * 6)]) & 0xE0) >> 4
             && ((memory[0x805 + (y * 24) + (x * 6)]) & 0x0E)       == ((memory[0x280 + ((i / 2) * 6)]) & 0xE0) >> 4
            )
            {   whichletter = elektor_chars1[i];
                break;
            }

            // check right letter against right ROM letters
            if
            (   ((memory[0x800 + (y * 24) + (x * 6)]) & 0x0E)       == ((memory[0x27B + ((i / 2) * 6)]) & 0x0E)
             && ((memory[0x801 + (y * 24) + (x * 6)]) & 0x0E)       == ((memory[0x27C + ((i / 2) * 6)]) & 0x0E)
             && ((memory[0x802 + (y * 24) + (x * 6)]) & 0x0E)       == ((memory[0x27D + ((i / 2) * 6)]) & 0x0E)
             && ((memory[0x803 + (y * 24) + (x * 6)]) & 0x0E)       == ((memory[0x27E + ((i / 2) * 6)]) & 0x0E)
             && ((memory[0x804 + (y * 24) + (x * 6)]) & 0x0E)       == ((memory[0x27F + ((i / 2) * 6)]) & 0x0E)
             && ((memory[0x805 + (y * 24) + (x * 6)]) & 0x0E)       == ((memory[0x280 + ((i / 2) * 6)]) & 0x0E)
            )
            {   whichletter = elektor_chars1[i + 1];
                break;
        }   }
        if (whichletter == '#')
        {   // check right letter against accidentals and modifieds
            for (i = 0; i < 28; i++)
            {   if
                (   ((memory[0x800 + (y * 24) + (x * 6)]) & 0x0E)   == elektor_bmaps[i][0]
                 && ((memory[0x801 + (y * 24) + (x * 6)]) & 0x0E)   == elektor_bmaps[i][1]
                 && ((memory[0x802 + (y * 24) + (x * 6)]) & 0x0E)   == elektor_bmaps[i][2]
                 && ((memory[0x803 + (y * 24) + (x * 6)]) & 0x0E)   == elektor_bmaps[i][3]
                 && ((memory[0x804 + (y * 24) + (x * 6)]) & 0x0E)   == elektor_bmaps[i][4]
                 && ((memory[0x805 + (y * 24) + (x * 6)]) & 0x0E)   == elektor_bmaps[i][5]
                )
                {   whichletter = elektor_chars2[i];
                    break; // for speed
        }   }   }

        letters[(x * 2) + 1] = whichletter;
    }

    letters[8] = 0;
}

EXPORT void e_setmemmap(void)
{   int i, address;

    // assert(!crippled);
    // assert(!inframe);
    game = FALSE;

    for (i = 0; i <= 0x7FF; i++)
    {   memory[i] = e_bios[i];
    }
    for (i = 0x800; i <= 0xFFF; i++)
    {   memory[i] = 0;
    }
    if (memmap == MEMMAP_E)
    {   for (i = 0x1000; i <= 0x15FF; i++)
        {   memory[i] = 0xFF; // unimportant, illegal reads don't actually look at the stored value
            /* "If extended memory is not available, the value
                retrieved from address $1000 will be $FF." - "TV Games
                Computer" book, p. 185. */
        }
        for (i = 0x2000; i <= 0x7FFF; i++)
        {   memory[i] = 0; // not necessarily correct
    }   }
    else
    {   // assert(memmap == MEMMAP_F);
        for (i = 0x1000; i <= 0x15FF; i++)
        {   memory[i] = 0;
    }   }

    for (i = 0x1600; i <= 0x1FFF; i++)
    {   memory[i] = 0;
    }

    if (memmap == MEMMAP_F)
    {   if (loader)
        {   for (i = 0; i < 128; i++)
            {   memory[0x1C00 + i] = e_loader[i];
                memory[0x1E00 + i] = e_loader[128 + i];
        }   }
        else
        {   for (i = 0; i < 128; i++)
            {   memory[0x1C00 + i] = e_saver[i];
                memory[0x1E00 + i] = e_saver[128 + i];
        }   }
        for (i = 0; i < 512; i++)
        {   memory[0x2000 + i] = e_calculator[i];
        }
        for (i = 0x2200; i <= 0x7FFF; i++)
        {   memory[i] = 0xFF; // to simulate "blank" EPROM
    }   }

    // only MIRRORED_R and/or MIRRORED_W need be set for mirrored regions.

    for (address = 0; address < 32 * KILOBYTE; address++)
    {   memflags[address] = 0;
        mirror_r[address] =
        mirror_w[address] = (UWORD) address;

        if (memmap == MEMMAP_E)
        {   if
            (
        // legal:               $0..               $FFF     ROM, monitor RAM, user RAM
                (address >= 0x1000 && address <= 0x1E87) // unused, mirrors, I/O, input and output lines (and mirrors thereof), unused, unmapped
        // legal:            $1E88..              $1E8E     R/- hardware registers
             || (address >= 0x1E8F && address <= 0x1EFF) // unmapped, mirrors
        // legal:            $1F00..              $1F2D     R/W hardware registers, user RAM
             || (address >= 0x1F2E && address <= 0x1F3F) // unmapped
        // legal:            $1F40..              $1F6D     R/W hardware registers, user RAM
             || (address >= 0x1F6E && address <= 0x1F7F) // unmapped
        // legal:            $1F80..              $1FAD     R/W hardware registers, user RAM
             || (address >= 0x1FAE && address <= 0x1FC9) // unmapped, -/W hardware registers
        // legal:            $1FCA              ..$1FCD     R/- hardware registers
             || (address >= 0x1FCE && address <= 0x1FD9) // unused, mirrors (not occurring)
        // legal:            $1FDA              ..$1FDB     semi-mirrors
             || (address >= 0x1FDC && address <= 0x1FE9) // mirrors (not occurring)
        // legal:            $1FEA              ..$1FEB     semi-mirrors
             || (address >= 0x1FEC && address <= 0x1FF9) // mirrors (not occurring)
        // legal:            $1FFA              ..$1FFB     semi-mirrors
             ||  address >= 0x1FFC                       // mirrors (not occurring)
            )
            {   memflags[address] |= NOREAD;
            }

            if
            (    address <=  0x7FF                       // ROM
        // legal:             $800..               $FFF     monitor RAM, user RAM
             || (address >= 0x1000 && address <= 0x1EFF) // unused, mirrors, I/O, input and output lines (and mirrors thereof), unmapped, R/- hardware regs, unmapped, mirrors
        // legal:            $1F00..              $1F2D     R/W hardware regs, user RAM
             || (address >= 0x1F2E && address <= 0x1F3F) // unmapped
        // legal:            $1F40..              $1F6D     R/W hardware regs, user RAM
             || (address >= 0x1F6E && address <= 0x1F7F) // unmapped
        // legal:            $1F80..              $1FAD     R/W hardware regs, user RAM
             || (address >= 0x1FAE && address <= 0x1FBF) // unmapped
        // legal:            $1FC0..              $1FC3     -/W hardware regs
             || (address >= 0x1FC4 && address <= 0x1FC5) // unused
        // legal:            $1FC6..              $1FC9     -/W hardware regs
             ||  address >= 0x1FCA                       // R/- hardware registers, unused, semi-mirrors, unused
            )
            {   memflags[address] |= NOWRITE;
        }   }
        else
        {   // assert(memmap == MEMMAP_F);

            if
            (
        // legal:               $0..              $1BFF     ROM, monitor RAM, user RAM
        // legal:            $1C00..              $1C7F     RLG load/save routine
                (address >= 0x1C80 && address <= 0x1D1F) // mirrors, PSGs (-/W)
        // legal:            $1D20                          2nd German randomizer
             || (address >= 0x1D21 && address <= 0x1DFF) // I/O, input and output lines (and mirrors thereof)
        // legal:            $1E00..              $1E7F     RLG load/save routine
             || (address >= 0x1E80 && address <= 0x1E87) // noise register (assuming -/W), unmapped
        // legal:            $1E88..              $1E8E     R/- hardware registers
             || (address >= 0x1E8F && address <= 0x1EFF) // unmapped, mirrors
        // legal:            $1F00..              $1F2D     R/W hardware registers, user RAM
             || (address >= 0x1F2E && address <= 0x1F3F) // unmapped
        // legal:            $1F40..              $1F6D     R/W hardware registers, user RAM
             || (address >= 0x1F6E && address <= 0x1F7F) // unmapped
        // legal:            $1F80..              $1FAD     R/W hardware registers, user RAM
             ||  address == 0x1FAE                       // unmapped
        // legal:            $1FAF                          1st German randomizer
             || (address >= 0x1FB0 && address <= 0x1FC9) // unmapped, -/W hardware registers
        // legal:            $1FCA              ..$1FCD     R/- hardware registers
             || (address >= 0x1FCE && address <= 0x1FD9) // unused, mirrors (not occurring)
        // legal:            $1FDA              ..$1FDB     semi-mirrors
             || (address >= 0x1FDC && address <= 0x1FE9) // mirrors (not occurring)
        // legal:            $1FEA              ..$1FEB     semi-mirrors
             || (address >= 0x1FEC && address <= 0x1FF9) // mirrors (not occurring)
        // legal:            $1FFA              ..$1FFB     semi-mirrors
             || (address >= 0x1FFC && address <= 0x1FFE) // mirrors (not occurring)
        // legal:            $1FFF                          1st English randomizer
        // legal:            $2000..$7FFF                   RLG games storage area
            )
            {   memflags[address] |= NOREAD;
            }

/* In RLG mode, we are allowing writes to the EPROM areas at $1C00..$1C7F,
   $1E00..$1E7F and $2000..$7FFF. In reality, writing to an EPROM is more
   complex than this, and bits may be cleared but may not be set. */

            if
            (    address <=  0x7FF                       // ROM
        // legal:             $800..              $1C7F     monitor RAM, user RAM, EPROM (RLG load/save routine)
             || (address >= 0x1C80 && address <= 0x1CFF) // mirrors
        // legal:            $1D00..              $1D0E     PSG #0
             ||  address == 0x1D0F                       // PORTB1
        // legal:            $1D10..              $1D1D     PSG #1
             || (address >= 0x1D1E && address <= 0x1DFF) // PORTA2, PORTB2, randomizer #2, I/O, input and output lines (and mirrors thereof)
        // legal:            $1E00..              $1E80     EPROM (RLG load/save routine), noise register
             || (address >= 0x1E81 && address <= 0x1EFF) // unmapped, R/- hardware regs, unmapped, mirrors
        // legal:            $1F00..              $1F2D     R/W hardware regs, user RAM
             || (address >= 0x1F2E && address <= 0x1F3F) // unmapped
        // legal:            $1F40..              $1F6D     R/W hardware regs, user RAM
             || (address >= 0x1F6E && address <= 0x1F7F) // unmapped
        // legal:            $1F80..              $1FAD     R/W hardware regs, user RAM
             || (address >= 0x1FAE && address <= 0x1FBF) // unmapped
        // legal:            $1FC0..              $1FC3     -/W hardware regs
             || (address >= 0x1FC4 && address <= 0x1FC5) // unused
        // legal:            $1FC6..              $1FC9     -/W hardware regs
             || (address >= 0x1FCA && address <= 0x1FFF) // R/- hardware registers, unused, randomizer, semi-mirrors
        // legal:            $2000..              $7FFF  // EPROM (games storage area)
            )
            {   memflags[address] |= NOWRITE;
            }

            /* Writes to PORTB1, PORTA2, PORTB2 are considered illegal,
               even though these areas are write-only. This is because
               no conceivable game would write there. */

            if
            (   address == E_RANDOM1E
             || address == E_RANDOM1G
             || address == E_RANDOM2
            )
            {   memflags[address] |= RANDOM;
            }

            if
            (   (address >= 0x1C00 && address <= 0x1C7F)
             || (address >= 0x1E00 && address <= 0x1E7F)
             ||  address >= 0x2000
            )
            {   memflags[address] |= NOWRITE | EPROM;
        }   }

        if
        (   (address >= 0x1FCA && address <= 0x1FCB)
         || (address >= 0x1FDA && address <= 0x1FDB)
         || (address >= 0x1FEA && address <= 0x1FEB)
         || (address >= 0x1FFA && address <= 0x1FFB)
        )
        {   memflags[address] |= READONCE;
        }

        if
        (   address == 0x1F00 + PVI_PITCH
         || (   memmap == MEMMAP_F
             && (   address == IE_NOISE
                 || (address >= 0x1D00 && address <= 0x1D1F) // not really every byte in this range
        )   )   )
        {   memflags[address] |= AUDIBLE;
        }

// Mirroring--------------------------------------------------------------

        if (memmap == MEMMAP_E)
        {   // primary mirroring, must go first
            if (mirror_r[address] >= 0x2000)
            {   memflags[address] |= MIRRORED_R;
                mirror_r[address] &= 0x1FFF;
            }
            if (mirror_w[address] >= 0x2000)
            {   memflags[address] |= MIRRORED_W;
                mirror_w[address] &= 0x1FFF;
            }

            // secondary mirroring
            if (mirror_r[address] >= 0x1600 && mirror_r[address] <= 0x17FF) // mirror of $1E00..$1FFF
            {   memflags[address] |= MIRRORED_R;
                mirror_r[address] += 0x800;
            } elif (mirror_r[address] >= 0x1800 && mirror_r[address] <= 0x1CFF)
            {   memflags[address] |= MIRRORED_R;
                mirror_r[address] &= 0xF8FF;
                mirror_r[address] |= 0x0500;
            }
            if (mirror_w[address] >= 0x1600 && mirror_w[address] <= 0x17FF) // mirror of $1E00..$1FFF
            {   memflags[address] |= MIRRORED_W;
                mirror_w[address] += 0x800;
            } elif (mirror_w[address] >= 0x1800 && mirror_w[address] <= 0x1CFF)
            {   memflags[address] |= MIRRORED_W;
                mirror_w[address] &= 0xF8FF;
                mirror_w[address] |= 0x0500;
        }   }

        // tertiary mirroring

        // read mirrors of $1F00..$1F09 and $1F0C..$1F0F.
        // $1F0A..$1F0B are semi-mirrored.
        if
        (   (mirror_r[address] >= 0x1FD0 && mirror_r[address] <= 0x1FD9)
         || (mirror_r[address] >= 0x1FDC && mirror_r[address] <= 0x1FE9)
         || (mirror_r[address] >= 0x1FEC && mirror_r[address] <= 0x1FF9)
         || (mirror_r[address] >= 0x1FFC && mirror_r[address] <= 0x1FFE) // $1FFF is a randomizer
        )
        {   memflags[address] |= MIRRORED_R;
            mirror_r[address] &= 0xFFCF; // apply mask of %1111111111001111
        }

        if (mirror_r[address] >= 0x1C80 && mirror_r[address] <= 0x1CFF) // mirror of $1D80..$1DFF
        {   memflags[address] |= MIRRORED_R;
            mirror_r[address] += 0x100;
        }

        // write mirrors of $1F00..$1F09 and $1F0C..$1F0F.
        // $1F0A..$1F0B are semi-mirrored.
        if
        (   (mirror_w[address] >= 0x1FD0 && mirror_w[address] <= 0x1FD9)
         || (mirror_w[address] >= 0x1FDC && mirror_w[address] <= 0x1FE9)
         || (mirror_w[address] >= 0x1FEC && mirror_w[address] <= 0x1FF9)
         || (mirror_w[address] >= 0x1FFC && mirror_w[address] <= 0x1FFE) // $1FFF is a randomizer
        )
        {   memflags[address] |= MIRRORED_W;
            mirror_w[address] &= 0xFFCF; // apply mask of %1111111111001111
        }

        if (mirror_w[address] >= 0x1C80 && mirror_w[address] <= 0x1CFF) // mirror of $1D80..$1DFF
        {   memflags[address] |= MIRRORED_W;
            mirror_w[address] += 0x100;
        }

        ie_inputmirrors(address);
    }

/* Unresolved issues:
 how should writes to $1FFF be handled?
  a) mirror them: they will resolve to $1FCF; or...
  b) handle them as (illegal) writes to randomizer #1
  we're handling them as (b) currently.
 we're assuming $1D20 is mirrored at $1C20, but it might not be.
*/

    if (memory[0x73E] == 0x19) // buggy version of monitor
    {   memflags[0x199C] |= MIRRORED_R | MIRRORED_W;
        memflags[0x199D] |= MIRRORED_R | MIRRORED_W;
        memflags[0x199E] |= MIRRORED_R | MIRRORED_W;
        memflags[0x199F] |= MIRRORED_R | MIRRORED_W;
        memflags[0x19BC] |= MIRRORED_R | MIRRORED_W;
        memflags[0x19BD] |= MIRRORED_R | MIRRORED_W;
        memflags[0x19BE] |= MIRRORED_R | MIRRORED_W;
        memflags[0x19BF] |= MIRRORED_R | MIRRORED_W;
        mirror_r[0x199C] = mirror_w[0x199C] = 0x1D9C;
        mirror_r[0x199D] = mirror_w[0x199D] = 0x1D9D;
        mirror_r[0x199E] = mirror_w[0x199E] = 0x1D9E;
        mirror_r[0x199F] = mirror_w[0x199F] = 0x1D9F;
        mirror_r[0x19BC] = mirror_w[0x19BC] = 0x1DBC;
        mirror_r[0x19BD] = mirror_w[0x19BD] = 0x1DBD;
        mirror_r[0x19BE] = mirror_w[0x19BE] = 0x1DBE;
        mirror_r[0x19BF] = mirror_w[0x19BF] = 0x1DBF;
    } // elif (memory[0x73E] != 0x1D) assert(0); // not fixed version either, so panic!

    pvibase = 0x1F00;
}

EXPORT UBYTE loadrand(void)
{   // assert(recmode == RECMODE_PLAY);
    // assert(machine == ELEKTOR);
    return IOBuffer[offset++];
}
EXPORT void saverand(UBYTE value)
{   // assert(recmode == RECMODE_RECORD);
    // assert(machine == ELEKTOR);

    OutputBuffer[0] = value;
    DISCARD fwrite(OutputBuffer, 1, 1, MacroHandle); // should really check return code
}
