// MODULE STRUCTURES------------------------------------------------------

#define EQUIVALENTS 962 // actual count of elements
MODULE struct
{   char*  text;
    UWORD  number;
} equivalents[EQUIVALENTS] = {
// Arcadia (0..28)
{ "P1PADDLE"     , A_P1PADDLE      }, //  0
{ "P2PADDLE"     , A_P2PADDLE      },
{ "SPRITECOLLIDE", A_SPRITECOLLIDE },
{ "BGCOLLIDE"    , A_BGCOLLIDE     },
{ "SPRITES01CTRL", A_SPRITES01CTRL },
{ "SPRITES23CTRL", A_SPRITES23CTRL }, //  5
{ "BGCOLOUR"     , A_BGCOLOUR      },
{ "RESOLUTION"   , A_RESOLUTION    },
{ "CONSOLE"      , A_CONSOLE       },
{ "P2PALLADIUM"  , A_P2PALLADIUM   },
{ "P2RIGHTKEYS"  , A_P2RIGHTKEYS   }, // 10
{ "P2MIDDLEKEYS" , A_P2MIDDLEKEYS  },
{ "P2LEFTKEYS"   , A_P2LEFTKEYS    },
{ "P1PALLADIUM"  , A_P1PALLADIUM   },
{ "P1RIGHTKEYS"  , A_P1RIGHTKEYS   },
{ "P1MIDDLEKEYS" , A_P1MIDDLEKEYS  }, // 15
{ "P1LEFTKEYS"   , A_P1LEFTKEYS    },
{ "CHARLINE"     , A_CHARLINE      },
{ "VOLUME"       , A_VOLUME        },
{ "PITCH"        , A_PITCH         },
{ "VSCROLL"      , A_VSCROLL       }, // 20
{ "SPRITE3X"     , A_SPRITE3X      },
{ "SPRITE3Y"     , A_SPRITE3Y      },
{ "SPRITE2X"     , A_SPRITE2X      },
{ "SPRITE2Y"     , A_SPRITE2Y      },
{ "SPRITE1X"     , A_SPRITE1X      }, // 25
{ "SPRITE1Y"     , A_SPRITE1Y      },
{ "SPRITE0X"     , A_SPRITE0X      },
{ "SPRITE0Y"     , A_SPRITE0Y      }, // 28
// Interton/Elektor (29..69)
{ "P1PADDLE"     , 0x1F00 + PVI_P1PADDLE      }, // 29
{ "P2PADDLE"     , 0x1F00 + PVI_P2PADDLE      },
{ "SPRITECOLLIDE", 0x1F00 + PVI_SPRITECOLLIDE },
{ "BGCOLLIDE"    , 0x1F00 + PVI_BGCOLLIDE     },
{ "SPR01COLOURS" , 0x1F00 + PVI_SPR01COLOURS  },
{ "SPR23COLOURS" , 0x1F00 + PVI_SPR23COLOURS  }, // 34
{ "BGCOLOUR"     , 0x1F00 + PVI_BGCOLOUR      },
{ "CONSOLE"      , IE_CONSOLE                 },
{ "P2RIGHTKEYS"  , IE_P2RIGHTKEYS             },
{ "P2MIDDLEKEYS" , IE_P2MIDDLEKEYS            },
{ "P2LEFTKEYS"   , IE_P2LEFTKEYS              }, // 39
{ "P1RIGHTKEYS"  , IE_P1RIGHTKEYS             },
{ "P1MIDDLEKEYS" , IE_P1MIDDLEKEYS            },
{ "P1LEFTKEYS"   , IE_P1LEFTKEYS              },
{ "PITCH"        , 0x1F00 + PVI_PITCH         },
{ "SPRITE3AX"    , 0x1F00 + PVI_SPRITE3AX     }, // 44
{ "SPRITE3AY"    , 0x1F00 + PVI_SPRITE3AY     },
{ "SPRITE2AX"    , 0x1F00 + PVI_SPRITE2AX     },
{ "SPRITE2AY"    , 0x1F00 + PVI_SPRITE2AY     },
{ "SPRITE1AX"    , 0x1F00 + PVI_SPRITE1AX     },
{ "SPRITE1AY"    , 0x1F00 + PVI_SPRITE1AY     }, // 49
{ "SPRITE0AX"    , 0x1F00 + PVI_SPRITE0AX     },
{ "SPRITE0AY"    , 0x1F00 + PVI_SPRITE0AY     },
{ "SPRITE3BX"    , 0x1F00 + PVI_SPRITE3BX     },
{ "SPRITE3BY"    , 0x1F00 + PVI_SPRITE3BY     },
{ "SPRITE2BX"    , 0x1F00 + PVI_SPRITE2BX     }, // 54
{ "SPRITE2BY"    , 0x1F00 + PVI_SPRITE2BY     },
{ "SPRITE1BX"    , 0x1F00 + PVI_SPRITE1BX     },
{ "SPRITE1BY"    , 0x1F00 + PVI_SPRITE1BY     },
{ "SPRITE0BX"    , 0x1F00 + PVI_SPRITE0BX     },
{ "SPRITE0BY"    , 0x1F00 + PVI_SPRITE0BY     }, // 59
{ "SCORECTRL"    , 0x1F00 + PVI_SCORECTRL     },
{ "SCORELT"      , 0x1F00 + PVI_SCORELT       },
{ "SCORERT"      , 0x1F00 + PVI_SCORERT       },
{ "HORIZ1"       , 0x1F00 + PVI_HORIZ1        },
{ "HORIZ2"       , 0x1F00 + PVI_HORIZ2        }, // 64
{ "HORIZ3"       , 0x1F00 + PVI_HORIZ3        },
{ "HORIZ4"       , 0x1F00 + PVI_HORIZ4        },
{ "HORIZ5"       , 0x1F00 + PVI_HORIZ5        },
{ "SIZES"        , 0x1F00 + PVI_SIZES         },
{ "NOISE"        , IE_NOISE                   }, // 69
// we don't support eg. VERT, as it is really just the start of a larger area (ie. a multi-byte region).
// Elektor (70..324) (221 BIOS labels, 34 hardware registers)
{ "RESET"        ,   0x0           },
{ "INTRR"        ,   0x3           },
{ "BVEC1"        ,   0x6           }, // ROM data?
{ "BVEC2"        ,   0x8           }, // ROM data?
{ "START"        ,   0xA           },
{ "INIT0"        ,  0x23           },
{ "INIT1"        ,  0x28           },
{ "START1"       ,  0x38           },
{ "MWAIT0"       ,  0x45           },
{ "MWAIT1"       ,  0x47           },
{ "MONINT"       ,  0x4B           },
{ "FREFR0"       ,  0x4E           },
{ "FREEF1"       ,  0x57           },
{ "FILELN"       ,  0x71           },
{ "FREFR1"       ,  0x77           },
{ "FREFR2"       ,  0x7A           }, // display last line only
{ "MPOBJ1"       ,  0xAD           }, // ROM data
{ "MPOBJ2"       ,  0xB1           }, // ROM data
{ "MPOBJ3"       ,  0xB5           }, // ROM data
{ "MPOBJ4"       ,  0xB9           }, // ROM data
{ "MKEY"         ,  0xBD           },
{ "MKEY1"        ,  0xCA           },
{ "MKEY2"        ,  0xCD           },
{ "MKEYR"        ,  0xD4           },
{ "MKEY3"        ,  0xDE           },
{ "MKEY5"        ,  0xEF           },
{ "MKEY6"        ,  0xFD           },
{ "FNOP"         , 0x10C           },
{ "FMEM"         , 0x10D           },
{ "FBK"          , 0x110           },
{ "FREG"         , 0x113           },
{ "FINIT"        , 0x116           },
{ "FPC"          , 0x119           },
{ "FRC"          , 0x11C           },
{ "FWC"          , 0x11F           },
{ "KBFTBL"       , 0x122           }, // ROM data
{ "SAVE"         , 0x13E           },
{ "SAVE1"        , 0x161           }, // initiate PVI
{ "CLROBJ"       , 0x16E           }, // clear objects
{ "PVIPAR"       , 0x177           }, // ROM data
{ "KBSCAN"       , 0x181           }, // keyboard scan
{ "KBSC0"        , 0x18A           },
{ "KBSC12"       , 0x193           },
{ "IA00"         , 0x195           },
{ "IA01"         , 0x198           },
{ "IA02"         , 0x19B           },
{ "IA03"         , 0x1A0           },
{ "IA04"         , 0x1A3           },
{ "KBSC5"        , 0x1B6           },
{ "KBSC6"        , 0x1B8           },
{ "KBSC7"        , 0x1BD           },
{ "KBSC1"        , 0x1C0           },
{ "KBSC2"        , 0x1C3           },
{ "KBSC3"        , 0x1CF           },
{ "KBSC8"        , 0x1D9           },
{ "KBSC11"       , 0x1DC           },
{ "KBSC10"       , 0x1DF           },
{ "KBSC4"        , 0x1E3           },
{ "KBSC9"        , 0x1E9           },
{ "KBSBR"        , 0x1EE           },
{ "KBSBR0"       , 0x1F4           },
{ "KBSBR4"       , 0x1FB           },
{ "KBSBR2"       , 0x1FD           },
{ "KBSBR1"       , 0x1FF           },
{ "LINE"         , 0x20E           }, // translate MLINE to display
{ "LINE2"        , 0x212           },
{ "LINE07"       , 0x21E           },
{ "LINE6"        , 0x234           },
{ "LINE7"        , 0x23A           },
{ "LINE8"        , 0x23C           },
{ "CHARPS"       , 0x24B           },
{ "LINE05"       , 0x255           },
{ "LINE09"       , 0x25B           },
{ "LINE06"       , 0x25F           },
{ "IMGTBL"       , 0x27B           }, // ROM data
{ "SCROLL"       , 0x2CF           }, // scroll, 8 spaces to MLINE
{ "SCROL1"       , 0x2D1           },
{ "SCROL3"       , 0x2D9           }, // load 8 spaces to MLINE
{ "SCROL4"       , 0x2DB           },
{ "NEWMES"       , 0x2E3           }, // scroll, message to MLINE
{ "MESSAG"       , 0x2EA           }, // output message to MLINE
{ "MESSL"        , 0x2F5           }, // ROM data
{ "ASMDAT"       , 0x31D           }, // assemble data
{ "ASSMC"        , 0x328           },
{ "ASSMC1"       , 0x332           },
{ "STRDAT"       , 0x339           },
{ "RESDAT"       , 0x340           },
{ "LOADAT"       , 0x346           },
{ "OUTADD"       , 0x34E           }, // output double byte to MLINE
{ "OUTADR"       , 0x350           }, // output double byte to MLINE
{ "OUTBYT"       , 0x354           }, // output single byte to MLINE
{ "NIBL"         , 0x35E           }, // split register
{ "OUTNAD"       , 0x368           },
{ "OUTADS"       , 0x36C           },
{ "SPACES"       , 0x377           },
{ "STDATA"       , 0x381           },
{ "STDAT1"       , 0x392           },
{ "STDAT2"       , 0x39B           },
{ "INCADR"       , 0x39F           }, // increment double byte
{ "REG01"        , 0x3B0           },
{ "REG1"         , 0x3B8           },
{ "REG7"         , 0x3D1           },
{ "REG2"         , 0x3D6           },
{ "IAREG"        , 0x3DB           },
{ "REG3"         , 0x3E0           },
{ "REG4"         , 0x3F4           },
{ "REG5"         , 0x400           },
{ "MEM0"         , 0x40C           },
{ "MEM1"         , 0x415           },
{ "MEM2"         , 0x41C           },
{ "MEM3"         , 0x42E           },
{ "MEM4"         , 0x43E           },
{ "MEM7"         , 0x44D           },
{ "MEM9"         , 0x452           },
{ "MEM8"         , 0x465           },
{ "MEM5"         , 0x467           },
{ "MEM6"         , 0x46A           },
{ "MEMFS3"       , 0x47D           },
{ "MEMBYT"       , 0x480           }, // output single byte to screen
{ "MEMLIN"       , 0x483           },
{ "MEMFS7"       , 0x486           },
{ "FMEM1"        , 0x495           },
{ "FMEM3"        , 0x499           },
{ "FMEM2"        , 0x4A2           },
{ "BKSC"         , 0x4A9           },
{ "FBK1"         , 0x4C3           },
{ "FBK2"         , 0x4CB           },
{ "FBK3"         , 0x4D1           },
{ "IABK"         , 0x4D6           },
{ "FBK4"         , 0x4DB           },
{ "FBK5"         , 0x4DD           },
{ "FBK20"        , 0x4F5           },
{ "FBK21"        , 0x50A           },
{ "GO0"          , 0x50E           },
{ "GO4"          , 0x515           },
{ "GO3"          , 0x529           }, // output double byte to screen
{ "GOLIN"        , 0x52C           },
{ "GO1"          , 0x52F           }, // assemble data on screen
{ "GO2"          , 0x532           },
{ "ZBRR1"        , 0x537           }, // ROM data?
{ "ZBRR2"        , 0x539           }, // ROM data?
{ "UMODE"        , 0x53B           }, // ROM data
{ "STRTUP"       , 0x540           },
{ "BREAK1"       , 0x594           },
{ "BREAKM"       , 0x5A4           },
{ "BREAK2"       , 0x5B2           },
{ "PCEQBK"       , 0x5C4           },
{ "BRKSBR"       , 0x5CD           },
{ "BRKSB1"       , 0x5E0           },
{ "WCAS0"        , 0x5E8           },
{ "WCAS1"        , 0x5F3           },
{ "WCAS2"        , 0x5F7           },
{ "WCAS3"        , 0x602           }, // scroll, message to screen
{ "WCALIN"       , 0x605           },
{ "WCAS4"        , 0x608           },
{ "WCAS6"        , 0x610           },
{ "WCAS2A"       , 0x626           },
{ "WCAS7"        , 0x628           },
{ "WCAS8"        , 0x63C           },
{ "WCASF1"       , 0x642           },
{ "WCAS9"        , 0x64A           },
{ "BLOCK"        , 0x655           },
{ "WCASB"        , 0x671           },
{ "WCAS10"       , 0x681           },
{ "IBOUT"        , 0x690           },
{ "WCAS11"       , 0x699           },
{ "WCAS12"       , 0x6A4           },
{ "WCAS13"       , 0x6B8           },
{ "BOUT"         , 0x6D0           },
{ "COUT"         , 0x6D3           },
{ "COUT1"        , 0x6DA           },
{ "COUT2"        , 0x6E1           },
{ "COUT3"        , 0x6E3           },
{ "ONE"          , 0x6EA           },
{ "ZERO"         , 0x6EE           },
{ "DELAY"        , 0x6F2           },
{ "PULSE"        , 0x6F7           }, // delay
{ "CHIN"         , 0x709           },
{ "CHI1"         , 0x70D           },
{ "CHI2"         , 0x710           },
{ "CHI3"         , 0x712           },
{ "CHI4"         , 0x71B           },
{ "CBCC"         , 0x726           },
{ "RBIT"         , 0x731           },
{ "RBIT1"        , 0x734           },
{ "RBIT2"        , 0x739           },
{ "RBIT3"        , 0x73B           },
{ "RBIT4"        , 0x73D           },
{ "RBIT5"        , 0x747           },
{ "RCAS0"        , 0x758           },
{ "RCAS7"        , 0x764           },
{ "CHLINE"       , 0x76A           },
{ "CHLIN1"       , 0x76D           },
{ "RCAS8"        , 0x774           },
{ "RCAS2"        , 0x778           },
{ "RCAS1"        , 0x788           },
{ "ICHIN1"       , 0x797           },
{ "IOBJA"        , 0x79E           },
{ "RCAS3"        , 0x7A8           },
{ "RCAS4"        , 0x7B0           },
{ "RCAS9"        , 0x7CE           },
{ "ICHIN"        , 0x7D1           },
{ "RCAS5"        , 0x7D9           },
{ "RCAS6"        , 0x7EE           },
{ "RCASER"       , 0x7F4           },
{ "MONOB"        , E_MONOB         }, // RAM data
{ "MLINE"        , E_MLINE         }, // RAM data
{ "FSEQ"         , E_FSEQ          }, // RAM data (aka SILENC)
{ "SILENC"       , E_SILENC        }, // RAM data (aka FSEQ)
{ "ENTM"         , E_ENTM          }, // RAM data
{ "MFUNC"        , E_MFUNC         }, // RAM data
{ "MSCR"         , E_MSCR          }, // RAM data
{ "RKBST"        , E_RKBST         }, // RAM data
{ "LKBST"        , E_LKBST         }, // RAM data
{ "MKBST"        , E_MKBST         }, // RAM data
{ "FSCRM"        , E_FSCRM         }, // RAM data
{ "REGM"         , E_REGM          }, // RAM data
{ "BK1"          , E_BK1           }, // RAM data
{ "BK2"          , E_BK2           }, // RAM data
{ "INTADR"       , E_INTADR        }, // RAM data
{ "PC"           , E_PC            }, // RAM data
{ "PITCHA1_L"    , E_PITCHA1_L     },
{ "PITCHA1_H"    , E_PITCHA1_H     },
{ "PITCHB1_L"    , E_PITCHB1_L     },
{ "PITCHB1_H"    , E_PITCHB1_H     },
{ "PITCHC1_L"    , E_PITCHC1_L     },
{ "PITCHC1_H"    , E_PITCHC1_H     },
{ "PITCHD1"      , E_PITCHD1       },
{ "MIXER1"       , E_MIXER1        },
{ "AMPLITUDEA1"  , E_AMPLITUDEA1   },
{ "AMPLITUDEB1"  , E_AMPLITUDEB1   },
{ "AMPLITUDEC1"  , E_AMPLITUDEC1   },
{ "PERIOD1_L"    , E_PERIOD1_L     },
{ "PERIOD1_H"    , E_PERIOD1_H     },
{ "SHAPE1"       , E_SHAPE1        },
{ "PORTA1"       , E_PORTA1        },
{ "PORTB1"       , E_PORTB1        },
{ "PITCHA2_L"    , E_PITCHA2_L     },
{ "PITCHA2_H"    , E_PITCHA2_H     },
{ "PITCHB2_L"    , E_PITCHB2_L     },
{ "PITCHB2_H"    , E_PITCHB2_H     },
{ "PITCHC2_L"    , E_PITCHC2_L     },
{ "PITCHC2_H"    , E_PITCHC2_H     },
{ "PITCHD2"      , E_PITCHD2       },
{ "MIXER2"       , E_MIXER2        },
{ "AMPLITUDEA2"  , E_AMPLITUDEA2   },
{ "AMPLITUDEB2"  , E_AMPLITUDEB2   },
{ "AMPLITUDEC2"  , E_AMPLITUDEC2   },
{ "PERIOD2_L"    , E_PERIOD2_L     },
{ "PERIOD2_H"    , E_PERIOD2_H     },
{ "SHAPE2"       , E_SHAPE2        },
{ "PORTA2"       , E_PORTA2        },
{ "PORTB2"       , E_PORTB2        },
{ "CASIN"        , E_CASIN         },
{ "CASOUT"       , E_CASOUT        }, // 324
/* These are listed as useful routines in the "TV Games Computer" book but
have no official name/label:
  {  0x55, "DISPLAY6LINES" }, // "display six lines"
  {  0x9E, "CLEARDUPS"     }, // "clear duplicates"
  {  0xA0, "LOADVODDUPS"   }, // "load VOD duplicates"
  { 0x16F, "LOADOBJECTS"   }, // "load objects"
  { 0x379, "LDSPCS2MLINE"  }, // "load spaces to MLINE"
  { 0x42B, "ADDRDTA2MLINE" }, // "address + data to MLINE"
  { 0x470, "OUT3BYTS2SCRN" }, // "output 3 bytes to screen"
We don't support eg. RANDOM2, what is the point? */
// coin-ops
{ "P1PADDLE"      ,         PVI_P1PADDLE      }, // MWX  0 325
{ "P2PADDLE"      ,         PVI_P2PADDLE      }, // MWX
{ "SPRITECOLLIDE" ,         PVI_SPRITECOLLIDE }, // MWX
{ "BGCOLLIDE"     ,         PVI_BGCOLLIDE     }, // MWX
{ "SPR01COLOURS"  ,         PVI_SPR01COLOURS  }, // MWX
{ "SPR23COLOURS"  ,         PVI_SPR23COLOURS  }, // MWX  5
{ "BGCOLOUR"      ,         PVI_BGCOLOUR      }, // MWX
{ "PITCH"         ,         PVI_PITCH         }, // MWX
{ "SPRITE3AX"     ,         PVI_SPRITE3AX     }, // MWX
{ "SPRITE3AY"     ,         PVI_SPRITE3AY     }, // MWX
{ "SPRITE2AX"     ,         PVI_SPRITE2AX     }, // MWX 10
{ "SPRITE2AY"     ,         PVI_SPRITE2AY     }, // MWX
{ "SPRITE1AX"     ,         PVI_SPRITE1AX     }, // MWX
{ "SPRITE1AY"     ,         PVI_SPRITE1AY     }, // MWX
{ "SPRITE0AX"     ,         PVI_SPRITE0AX     }, // MWX
{ "SPRITE0AY"     ,         PVI_SPRITE0AY     }, // MWX 15
{ "SPRITE3BX"     ,         PVI_SPRITE3BX     }, // MWX
{ "SPRITE3BY"     ,         PVI_SPRITE3BY     }, // MWX
{ "SPRITE2BX"     ,         PVI_SPRITE2BX     }, // MWX
{ "SPRITE2BY"     ,         PVI_SPRITE2BY     }, // MWX
{ "SPRITE1BX"     ,         PVI_SPRITE1BX     }, // MWX 20
{ "SPRITE1BY"     ,         PVI_SPRITE1BY     }, // MWX
{ "SPRITE0BX"     ,         PVI_SPRITE0BX     }, // MWX
{ "SPRITE0BY"     ,         PVI_SPRITE0BY     }, // MWX
{ "SCORECTRL"     ,         PVI_SCORECTRL     }, // MWX
{ "SCORELT"       ,         PVI_SCORELT       }, // MWX 25
{ "SCORERT"       ,         PVI_SCORERT       }, // MWX
{ "HORIZ1"        ,         PVI_HORIZ1        }, // MWX
{ "HORIZ2"        ,         PVI_HORIZ2        }, // MWX
{ "HORIZ3"        ,         PVI_HORIZ3        }, // MWX
{ "HORIZ4"        ,         PVI_HORIZ4        }, // MWX 30
{ "HORIZ5"        ,         PVI_HORIZ5        }, // MWX 31 356
{ "SIZES"         ,         PVI_SIZES         }, // MW- 32
{ "P3PADDLE"      , 0x100 + PVI_P1PADDLE      }, // MW-
{ "P4PADDLE"      , 0x100 + PVI_P2PADDLE      }, // MW-
{ "SPRITECOLLIDE2", 0x100 + PVI_SPRITECOLLIDE }, // MW- 35
{ "BGCOLLIDE2"    , 0x100 + PVI_BGCOLLIDE     }, // MW-
{ "SPR45COLOURS"  , 0x100 + PVI_SPR01COLOURS  }, // MW-
{ "SPR67COLOURS"  , 0x100 + PVI_SPR23COLOURS  }, // MW-
{ "BGCOLOUR2"     , 0x100 + PVI_BGCOLOUR      }, // MW-
{ "PITCH2"        , 0x100 + PVI_PITCH         }, // MW- 40
{ "SPRITE7AX"     , 0x100 + PVI_SPRITE3AX     }, // MW-
{ "SPRITE7AY"     , 0x100 + PVI_SPRITE3AY     }, // MW-
{ "SPRITE6AX"     , 0x100 + PVI_SPRITE2AX     }, // MW-
{ "SPRITE6AY"     , 0x100 + PVI_SPRITE2AY     }, // MW-
{ "SPRITE5AX"     , 0x100 + PVI_SPRITE1AX     }, // MW- 45
{ "SPRITE5AY"     , 0x100 + PVI_SPRITE1AY     }, // MW-
{ "SPRITE4AX"     , 0x100 + PVI_SPRITE0AX     }, // MW-
{ "SPRITE4AY"     , 0x100 + PVI_SPRITE0AY     }, // MW-
{ "SPRITE7BX"     , 0x100 + PVI_SPRITE3BX     }, // MW-
{ "SPRITE7BY"     , 0x100 + PVI_SPRITE3BY     }, // MW- 50
{ "SPRITE6BX"     , 0x100 + PVI_SPRITE2BX     }, // MW-
{ "SPRITE6BY"     , 0x100 + PVI_SPRITE2BY     }, // MW-
{ "SPRITE5BX"     , 0x100 + PVI_SPRITE1BX     }, // MW-
{ "SPRITE5BY"     , 0x100 + PVI_SPRITE1BY     }, // MW-
{ "SPRITE4BX"     , 0x100 + PVI_SPRITE0BX     }, // MW- 55
{ "SPRITE4BY"     , 0x100 + PVI_SPRITE0BY     }, // MW-
{ "SCORECTRL2"    , 0x100 + PVI_SCORECTRL     }, // MW-
{ "SCORELT2"      , 0x100 + PVI_SCORELT       }, // MW-
{ "SCORERT2"      , 0x100 + PVI_SCORERT       }, // MW-
{ "HORIZ6"        , 0x100 + PVI_HORIZ1        }, // MW- 60
{ "HORIZ7"        , 0x100 + PVI_HORIZ2        }, // MW-
{ "HORIZ8"        , 0x100 + PVI_HORIZ3        }, // MW-
{ "HORIZ9"        , 0x100 + PVI_HORIZ4        }, // MW-
{ "HORIZ10"       , 0x100 + PVI_HORIZ5        }, // MW-
{ "SIZES2"        , 0x100 + PVI_SIZES         }, // MW- 65 390
{ "P5PADDLE"      , 0x200 + PVI_P1PADDLE      }, // -W- 66
{ "P6PADDLE"      , 0x200 + PVI_P2PADDLE      }, // -W-
{ "SPRITECOLLIDE3", 0x200 + PVI_SPRITECOLLIDE }, // -W-
{ "BGCOLLIDE3"    , 0x200 + PVI_BGCOLLIDE     }, // -W-
{ "SPR89COLOURS"  , 0x200 + PVI_SPR01COLOURS  }, // -W- 70
{ "SPR1011COLOURS", 0x200 + PVI_SPR23COLOURS  }, // -W-
{ "BGCOLOUR3"     , 0x200 + PVI_BGCOLOUR      }, // -W-
{ "PITCH3"        , 0x200 + PVI_PITCH         }, // -W-
{ "SPRITE11AX"    , 0x200 + PVI_SPRITE3AX     }, // -W-
{ "SPRITE11AY"    , 0x200 + PVI_SPRITE3AY     }, // -W- 75
{ "SPRITE10AX"    , 0x200 + PVI_SPRITE2AX     }, // -W-
{ "SPRITE10AY"    , 0x200 + PVI_SPRITE2AY     }, // -W-
{ "SPRITE9AX"     , 0x200 + PVI_SPRITE1AX     }, // -W-
{ "SPRITE9AY"     , 0x200 + PVI_SPRITE1AY     }, // -W-
{ "SPRITE8AX"     , 0x200 + PVI_SPRITE0AX     }, // -W- 80
{ "SPRITE8AY"     , 0x200 + PVI_SPRITE0AY     }, // -W-
{ "SPRITE11BX"    , 0x200 + PVI_SPRITE3BX     }, // -W-
{ "SPRITE11BY"    , 0x200 + PVI_SPRITE3BY     }, // -W-
{ "SPRITE10BX"    , 0x200 + PVI_SPRITE2BX     }, // -W-
{ "SPRITE10BY"    , 0x200 + PVI_SPRITE2BY     }, // -W- 85
{ "SPRITE9BX"     , 0x200 + PVI_SPRITE1BX     }, // -W-
{ "SPRITE9BY"     , 0x200 + PVI_SPRITE1BY     }, // -W-
{ "SPRITE8BX"     , 0x200 + PVI_SPRITE0BX     }, // -W-
{ "SPRITE8BY"     , 0x200 + PVI_SPRITE0BY     }, // -W-
{ "SCORECTRL3"    , 0x200 + PVI_SCORECTRL     }, // -W- 90
{ "SCORELT3"      , 0x200 + PVI_SCORELT       }, // -W-
{ "SCORERT3"      , 0x200 + PVI_SCORERT       }, // -W-
{ "HORIZ11"       , 0x200 + PVI_HORIZ1        }, // -W-
{ "HORIZ12"       , 0x200 + PVI_HORIZ2        }, // -W-
{ "HORIZ13"       , 0x200 + PVI_HORIZ3        }, // -W- 95
{ "HORIZ14"       , 0x200 + PVI_HORIZ4        }, // -W-
{ "HORIZ15"       , 0x200 + PVI_HORIZ5        }, // -W-
{ "SIZES3"        , 0x200 + PVI_SIZES         }, // -W- 98 423
// M = Malzak, W = Galaxia, X = Astro Wars
// Chaos (424..538)
{ "LINEIN"       , 0x0039 }, // 424
{ "HEX"          , 0x00DD },
{ "READY"        , 0x0205 },
{ "CMD_EXEC"     , 0x036E },
{ "CMD_EXEC_1"   , 0x0376 },
{ "CMD_EXEC_2"   , 0x0386 },
{ "CMD_EXEC_3"   , 0x0394 },
{ "CMD_EXEC_4"   , 0x039B },
{ "CMD_EXEC_5"   , 0x03AA },
{ "CMD_EXEC_6"   , 0x03BB },
{ "CMD_EXEC_7"   , 0x03C1 },
{ "CMD_EXEC_8"   , 0x03C8 },
{ "CMD_EXEC_9"   , 0x03D8 },
{ "CMD_EXEC_10"  , 0x03E1 },
{ "CMD_EXEC_11"  , 0x03F8 },
{ "CMD_EXEC_12"  , 0x03FB },
{ "CMD_REBOOT"   , 0x14C0 },
{ "CMD_TYPE"     , 0x14C5 },
{ "CMD_TYPE_1"   , 0x14CD },
{ "CMD_TYPE_2"   , 0x14D4 },
{ "CMD_TYPESL"   , 0x14E3 },
{ "CMD_TYPESL_1" , 0x14EB },
{ "CMD_TYPESL_2" , 0x14F2 },
{ "CMD_LIST"     , 0x1501 },
{ "CMD_LIST_1"   , 0x1514 },
{ "CMD_LIST_2"   , 0x1526 },
{ "CMD_LOAD"     , 0x152F },
{ "CMD_LOAD_1"   , 0x1541 },
{ "CMD_LOAD_2"   , 0x1552 },
{ "CMD_SAVE"     , 0x1560 },
{ "CMD_SAVE_1"   , 0x158C },
{ "CMD_VERIFY"   , 0x15A3 },
{ "CMD_VERIFY_1" , 0x15B1 },
{ "CMD_VERIFY_2" , 0x15D5 },
{ "CMD_VERIFY_3" , 0x15DF },
{ "CMD_CONTROL"  , 0x15E8 },
{ "CMD_FILL"     , 0x15F1 },
{ "CMD_FILL_1"   , 0x15FE },
{ "CMD_MEMSET"   , 0x160C },
{ "CMD_MEMSET_1" , 0x160F },
{ "CMD_MEMDIS"   , 0x1624 }, // MEMDIS sublabels are not implemented (because of suspect dump)
{ "CMD_RUNHEX"   , 0x1662 },
{ "CMD_RUNHEX_1" , 0x166C },
{ "CMD_RUNHEX_2" , 0x1680 },
{ "CMD_EXECUTE"  , 0x168B },
{ "CMD_RUN"      , 0x1694 },
{ "CMD_RUN_1"    , 0x169B },
{ "CMD_RUN_2"    , 0x16A1 },
{ "CMD_BPSET"    , 0x16B1 },
{ "CMD_BPSET_1"  , 0x16C9 },
{ "CMD_BPCLR"    , 0x16E4 },
{ "CMD_END"      , 0x1733 },
{ "CMD_END_1"    , 0x1742 },
{ "CMD_PORT"     , 0x1745 },
{ "CMD_DIR"      , 0x175E },
{ "CMD_ACCESS"   , 0x176F },
{ "CMD_OPEN"     , 0x1775 },
{ "CMD_OPEN_1"   , 0x1789 },
{ "CMD_CLOSE"    , 0x178F },
{ "CMD_CLOSE_1"  , 0x17A9 },
{ "CMD_CLOSE_2"  , 0x17B7 },
{ "CMD_COPY"     , 0x17C4 },
{ "CMD_COPY_1"   , 0x17D4 },
{ "CMD_COPY_2"   , 0x17DF },
{ "CMD_COPY_3"   , 0x17E4 },
{ "CMD_COPY_4"   , 0x17F2 },
{ "CMD_COPY_5"   , 0x17FC },
{ "CMD_LOWERCASE", 0x180B },
{ "CMD_INPUT"    , 0x1814 },
{ "CMD_INPUT_1"  , 0x1822 },
{ "CMD_INPUT_2"  , 0x1839 },
{ "CMD_INPUT_3"  , 0x1845 },
{ "CMD_LET"      , 0x184E },
{ "CMD_LET_1"    , 0x1872 },
{ "CMD_LET_2"    , 0x1884 },
{ "CMD_LET_3"    , 0x1899 },
{ "CMD_LET_4"    , 0x18AF },
{ "CMD_LET_5"    , 0x18BE },
{ "CMD_ASCDIS"   , 0x18CA },
{ "CMD_ASCDIS_1" , 0x18D7 },
{ "CMD_ASCDIS_2" , 0x18DF },
{ "CMD_ASCDIS_3" , 0x18E8 },
{ "CMD_ASCDIS_4" , 0x18EA },
{ "CMD_FIND"     , 0x18FC },
{ "CMD_FIND_1"   , 0x1900 },
{ "CMD_FIND_2"   , 0x1914 },
{ "CMD_FIND_3"   , 0x1916 },
{ "CMD_FIND_4"   , 0x1923 },
{ "CMD_FIND_5"   , 0x1933 },
{ "CMD_DEVFIVE"  , 0x193B },
{ "CMD_ASK"      , 0x194D },
{ "CMD_ASK_1"    , 0x194F },
{ "CMD_ASK_2"    , 0x1961 },
{ "CMD_ASK_3"    , 0x1975 },
{ "CMD_ASK_4"    , 0x1986 },
{ "CMD_ASK_5"    , 0x1992 },
{ "CMD_READ"     , 0x19A7 },
{ "CMD_READ_1"   , 0x19B8 },
{ "CMD_READ_2"   , 0x19C6 },
{ "CMD_READ_3"   , 0x19CC },
{ "CMD_IF"       , 0x19D5 },
{ "CMD_IF_1"     , 0x19E3 },
{ "CMD_IF_2"     , 0x19F4 },
{ "CMD_IF_3"     , 0x1A07 },
{ "CMD_IF_4"     , 0x1A11 },
{ "CMD_IF_5"     , 0x1A1E },
{ "CMD_GOTO"     , 0x1A29 },
{ "CMD_GOTO_1"   , 0x1A41 },
{ "CMD_GOTO_2"   , 0x1A48 },
{ "CMD_GOTO_3"   , 0x1A53 },
{ "CMD_GOTO_4"   , 0x1A58 },
{ "CMD_GOTO_5"   , 0x1A60 },
{ "OPENS"        , 0x7403 },
{ "CLOSE"        , 0x7409 },
{ "CHAR"         , 0x740F }, // 538
// Dolphin (539..552)
{ "MO"           ,    0x0 }, // 539
{ "RELES"        ,   0x27 },
{ "COUUT"        ,   0x75 },
{ "HEXKY"        ,   0x86 },
{ "OUTPT"        ,   0xAC },
{ "DEL95"        ,   0xB6 },
{ "DELAY"        ,   0xB8 },
{ "DISP1"        ,   0xD4 },
{ "DISP2"        ,   0xD7 },
{ "DISPL"        ,   0xCB },
{ "CONVT"        ,   0xDE },
{ "SSGTB"        ,   0xF0 },
{ "MONI"         ,  0x100 },
{ "MONA"         ,  0xC00 }, // 552
// PIPBUG (553..655)
{ "INIT"         ,    0x0 }, // ROM code
{ "AINI"         ,    0x3 }, // ROM code
{ "VEC"          ,   0x19 }, // ROM data (pointers)
{ "EBUG"         ,   0x1D }, // ROM code
{ "MBUG"         ,   0x22 }, // ROM code
{ "LINE"         ,   0x5B }, // ROM code
{ "LLIN"         ,   0x60 }, // ROM code
{ "ALIN"         ,   0x79 }, // ROM code
{ "ELIN"         ,   0x7D }, // ROM code
{ "CLIN"         ,   0x7F }, // ROM code
{ "DLIN"         ,   0x84 }, // ROM code
{ "CRLF"         ,   0x8A }, // ROM code
{ "BLIN"         ,   0x95 }, // ROM code
{ "STRT"         ,   0xA4 }, // ROM code
{ "ALTE"         ,   0xAB }, // ROM code
{ "LALT"         ,   0xAE }, // ROM code
{ "CALT"         ,   0xD2 }, // ROM code
{ "DALT"         ,   0xE3 }, // ROM code
{ "SREG"         ,   0xF4 }, // ROM code
{ "LSRE"         ,   0xF7 }, // ROM code
{ "ASRE"         ,  0x116 }, // ROM code
{ "BSRE"         ,  0x12A }, // ROM code
{ "CSRE"         ,  0x132 }, // ROM code
{ "GOTO"         ,  0x13A }, // ROM code
{ "BK01"         ,  0x160 }, // ROM code
{ "BK02"         ,  0x16E }, // ROM code
{ "BKEN"         ,  0x17A }, // ROM code
{ "CLBK"         ,  0x1AB }, // ROM code
{ "CLR"          ,  0x1CA }, // ROM code
{ "NOK"          ,  0x1D7 }, // ROM code
{ "BKPT"         ,  0x1E5 }, // ROM code
{ "DISP"         ,  0x222 }, // ROM code
{ "BIN"          ,  0x224 }, // ROM code
{ "CBCC"         ,  0x23D }, // ROM code
{ "LKUP"         ,  0x246 }, // ROM code
{ "ALKU"         ,  0x248 }, // ROM code
{ "ABRT"         ,  0x250 }, // ROM code
{ "ANSI"         ,  0x259 }, // ROM data
{ "BOUT"         ,  0x269 }, // ROM code
{ "CHIN"         ,  0x286 }, // ROM code
{ "ACHI"         ,  0x28F }, // ROM code
{ "BCHI"         ,  0x296 }, // ROM code
{ "DLAY"         ,  0x2A8 }, // ROM code
{ "DLY"          ,  0x2AD }, // ROM code
{ "COUT"         ,  0x2B4 }, // ROM code
{ "ACOU"         ,  0x2C1 }, // ROM code
{ "ONE"          ,  0x2CA }, // ROM code
{ "ZERO"         ,  0x2CC }, // ROM code
{ "DNUM"         ,  0x2D5 }, // ROM code
{ "GNUM"         ,  0x2DB }, // ROM code
{ "LNUM"         ,  0x2E1 }, // ROM code
{ "BNUM"         ,  0x2F2 }, // ROM code
{ "CNUM"         ,  0x2F5 }, // ROM code
{ "DUMP"         ,  0x310 }, // ROM code
{ "FDUM"         ,  0x325 }, // ROM code
{ "CDUM"         ,  0x351 }, // ROM code
{ "FORM"         ,  0x35B }, // ROM code
{ "GAP"          ,  0x35F }, // ROM code
{ "AGAP"         ,  0x361 }, // ROM code
{ "ADUM"         ,  0x369 }, // ROM code
{ "BDUM"         ,  0x36B }, // ROM code
{ "DDUM"         ,  0x386 }, // ROM code
{ "EDUM"         ,  0x39A }, // ROM code
{ "LOAD"         ,  0x3B5 }, // ROM code
{ "ALOA"         ,  0x3D4 }, // ROM code
{ "BLOA"         ,  0x3E1 }, // ROM code
{ "CLOA"         ,  0x3F5 }, // ROM code
{ "COM"          , T_COM  }, // RAM data
{ "XGOT"         , T_XGOT }, // RAM code?
{ "TEMP"         , T_TEMP }, // RAM data
{ "TEMQ"         , T_TEMQ }, // RAM data
{ "TEMR"         , T_TEMR }, // RAM data
{ "TEMS"         , T_TEMS }, // RAM data
{ "BUFF"         , T_BUFF }, // RAM data
{ "BPTR"         , T_BPTR }, // RAM data
{ "MCNT"         , T_MCNT }, // RAM data
{ "CNT"          , T_CNT  }, // RAM data
{ "CODE"         , T_CODE }, // RAM data
{ "OKGO"         , T_OKGO }, // RAM data
{ "BCC"          , T_BCC  }, // RAM data
{ "MARK"         , T_MARK }, // RAM data
{ "HDAT"         , T_HDAT }, // RAM data
{ "LDAT"         , T_LDAT }, // RAM data
{ "HADR"         , T_HADR }, // RAM data
{ "LADR"         , T_LADR }, // RAM data
// should we perhaps have START_H, START_L, etc.?
// should we perhaps have LIFECHIN, LIFECOUT, LIFECRLF, etc.?
{ "START"        , 0x2FFA }, // RAM data
{ "ZEND"         , 0x2FFC }, // RAM data (END is reserved by VACS!)
{ "NEW"          , 0x2FFE }, // RAM data
{ "GPAR"         , 0x3C07 }, // EPROM subroutine
{ "INCRT"        , 0x3C2A }, // EPROM subroutine
{ "PADR"         , 0x3C3C }, // EPROM subroutine
{ "HEXLIST"      , 0x3C50 }, // EPROM subroutine
{ "SEARCH"       , 0x3C6A }, // EPROM subroutine
{ "HEXIN"        , 0x3C8A }, // EPROM subroutine
{ "VERIFY"       , 0x3CDD }, // EPROM subroutine
{ "OK"           , 0x3CF8 }, // EPROM code section
{ "FAULTY"       , 0x3D0E }, // EPROM code section
{ "MOVE"         , 0x3D3B }, // EPROM subroutine
{ "Z3OUT"        , 0x3DBE }, // EPROM subroutine (300 baud)
{ "Z3IN"         , 0x3DE4 }, // EPROM subroutine (300 baud)
{ "ZDUMP"        , 0x3E02 }, // EPROM subroutine (300 baud)
{ "ZLOAD"        , 0x3E53 }, // EPROM subroutine (300 baud)
{ "ZVERIFY"      , 0x3EA2 }, // EPROM subroutine (300 baud)
// Instructor (656..666)
{ "IOPORT"       ,  0xFFF }, // RAM I/O port
{ "DISLSD_SUB"   , 0x1A76 }, // ROM code
{ "GNPA_SUB"     , 0x1B20 }, // ROM code
{ "MOV_SUB"      , 0x1DB6 }, // ROM code
{ "DISPLY_SUB"   , 0x1E13 }, // ROM code
{ "USRDSP_SUB"   , 0x1FD5 }, // ROM code
{ "USRDSP"       , 0x1FE6 }, // ROM vector to ROM code
{ "DISPLY"       , 0x1FEC }, // ROM vector to ROM code
{ "DISLSD"       , 0x1FF4 }, // ROM vector to ROM code
{ "GNPA"         , 0x1FFC }, // ROM vector to ROM code
{ "MOV"          , 0x1FFE }, // ROM vector to ROM code
// CD2650 (667..729)
{ "INIT"         ,   0x00 }, // ROM code
{ "L1"           ,   0x13 }, // ROM code
{ "LFCR"         ,   0x24 }, // ROM code
{ "L2"           ,   0x3C }, // ROM code
{ "HXOT"         ,   0x6A }, // ROM code
{ "RETU"         ,   0x83 }, // ROM code
{ "SAVR"         ,   0x88 }, // ROM code
{ "SAVER"        ,   0x88 }, // ROM code (synonym for SAVR - see "2650 Computer User Notes" #1, p. 4)
{ "BPSV"         ,   0xAC }, // ROM code
{ "CLRB"         ,   0xBB }, // ROM code
{ "WRAD"         ,   0xDB }, // ROM code
{ "RUNT"         ,   0xF0 }, // ROM code
{ "BKPT"         ,   0xF8 }, // ROM code
{ "INSP"         ,  0x122 }, // ROM code
{ "STRR"         ,  0x14C }, // ROM code
{ "WRBL"         ,  0x170 }, // ROM code
{ "WBLK"         ,  0x170 }, // ROM code (synonym for WRBL used by Editor/Assembler)
{ "SETR"         ,  0x176 }, // ROM code
{ "ADDR"         ,  0x185 }, // ROM code
{ "DECR"         ,  0x19A }, // ROM code
{ "TABL"         ,  0x19D }, // ROM data
{ "HTBL"         ,  0x1A6 }, // ROM data
{ "INHX"         ,  0x1B6 }, // ROM code
{ "KRAM"         ,  0x1CE }, // ROM code
{ "NADD"         ,  0x1D1 }, // ROM code
{ "NOCH"         ,  0x1E6 }, // ROM code
{ "TPOT"         ,  0x1FB }, // ROM code
{ "NEWL"         ,  0x239 }, // ROM code
{ "ENDT"         ,  0x249 }, // ROM code
{ "SERO"         ,  0x24F }, // ROM code
{ "NXTB"         ,  0x253 }, // ROM code
{ "ONE"          ,  0x264 }, // ROM code
{ "ZERO"         ,  0x266 }, // ROM code
{ "D2"           ,  0x26F }, // ROM code
{ "D1"           ,  0x273 }, // ROM code
{ "D6"           ,  0x278 }, // ROM code
{ "EXEC"         ,  0x27F }, // ROM code
{ "RETN"         ,  0x288 }, // ROM code
{ "COLO"         ,  0x28B }, // ROM code
{ "WAIT"         ,  0x28E }, // ROM code
{ "VERI"         ,  0x2A0 }, // ROM code
{ "NEWC"         ,  0x2CE }, // ROM code
{ "SERI"         ,  0x2E9 }, // ROM code
{ "NOST"         ,  0x2ED }, // ROM code
{ "NEXT"         ,  0x2F8 }, // ROM code
{ "TPIN"         ,  0x30F }, // ROM code
{ "NATC"         ,  0x31A }, // ROM code
{ "KBIN"         ,  0x328 }, // ROM code
{ "L11"          ,  0x353 }, // ROM code
{ "ERRR"         ,  0x37C }, // ROM code
{ "WCHR"         ,  0x396 }, // ROM code
{ "GO"           ,  0x39F }, // ROM code
{ "COMD"         ,  0x3C0 }, // ROM code
{ "LENT"         , C_LENT }, // RAM data
{ "BKP1"         , C_BKP1 }, // RAM data
{ "BKP2"         , C_BKP2 }, // RAM data
{ "BPD1"         , C_BPD1 }, // RAM data
{ "BPD2"         , C_BPD2 }, // RAM data
{ "SUMC"         , C_SUMC }, // RAM data
{ "ADD1"         , C_ADD1 }, // RAM data
{ "ADD2"         , C_ADD2 }, // RAM data
{ "CUR1"         , C_CUR1 }, // RAM data
{ "CUR2"         , C_CUR2 }, // RAM data
// Phunsy (730..961) (! = unused)
{ "RESET"        ,    0x0 }, // !
{ "WRTSP"        ,    0x3 },
{ "WRTZV"        ,    0x5 },
{ "REDZV"        ,    0x8 },
{ "WRTCR"        ,    0xB },
{ "CHIZV"        ,   0x14 },
{ "WRTDX"        ,   0x17 },
{ "ZB1VR"        ,   0x1D }, // !
{ "CMTBSV"       ,   0x22 },
{ "ICTBSV"       ,   0x24 },
{ "DCTBSV"       ,   0x26 },
{ "PSTBSV"       ,   0x28 },
{ "PLTBSV"       ,   0x2A },
{ "ADTBSV"       ,   0x2C },
{ "SBTBSV"       ,   0x2E },
{ "TINPRV"       ,   0x30 },
{ "TEHEXV"       ,   0x32 }, // !
{ "GTHEXV"       ,   0x34 },
{ "WRTBSV"       ,   0x36 },
{ "WCHEXV"       ,   0x38 },
{ "CHESCV"       ,   0x3A },
{ "ZB2VR"        ,   0x3C }, // !
{ "ZB2VRA"       ,   0x3D }, // !
{ "CMTBS"        ,   0x40 },
{ "CMTBSA"       ,   0x51 },
{ "ICTBS"        ,   0x54 },
{ "DCTBS"        ,   0x6A },
{ "PSTBS"        ,   0x80 },
{ "PLTBS"        ,   0x91 },
{ "PLTBSA"       ,   0x9D },
{ "PLTBSB"       ,   0xA0 },
{ "ADTBS"        ,   0xA3 },
{ "SBTBS"        ,   0xB9 },
{ "TEHEX"        ,   0xDB },
{ "TINPR"        ,   0xCD },
{ "TEHEXA"       ,   0xEC },
{ "TEHEXB"       ,   0xF0 },
{ "GTHEX"        ,   0xF4 },
{ "GTHEXA"       ,   0xF7 },
{ "GTHEXB"       ,  0x100 },
{ "GTHEXC"       ,  0x10B },
{ "GTHEXD"       ,  0x111 },
{ "GTHEXE"       ,  0x117 },
{ "WRTBS"        ,  0x12B },
{ "WCHEX"        ,  0x133 },
{ "WCHEXA"       ,  0x141 },
{ "INPRT"        ,  0x14B },
{ "INPRTA"       ,  0x157 },
{ "INPRTB"       ,  0x15A },
{ "INPRTC"       ,  0x160 },
{ "INPRTD"       ,  0x167 },
{ "INPRTE"       ,  0x175 },
{ "INPRTF"       ,  0x17D },
{ "CHESC"        ,  0x18A },
{ "ERROR"        ,  0x196 },
{ "ERRORA"       ,  0x198 },
{ "ERRORB"       ,  0x19F },
{ "ERRDAT"       ,  0x1A6 },
{ "ERRDEND"      ,  0x1AE }, // ERRDEND and TYPWR are both equal to $1AE
{ "TYPWR"        ,  0x1AE },
{ "MONML"        ,  0x1B7 },
{ "MONMLA"       ,  0x1C9 },
{ "MONMLB"       ,  0x1DF },
{ "MONMLC"       ,  0x1F4 },
{ "MONMLD"       ,  0x1FF },
{ "MONMLE"       ,  0x209 },
{ "MONMLF"       ,  0x211 },
{ "MONMLG"       ,  0x21A },
{ "MONMLH"       ,  0x22C },
{ "MONMLI"       ,  0x22E },
{ "MNCMDA"       ,  0x245 },
{ "MNCMDB"       ,  0x257 },
{ "MNCMDC"       ,  0x269 },
{ "CHHXD"        ,  0x289 },
{ "CHHXDA"       ,  0x293 },
{ "CHHXDB"       ,  0x2A3 },
{ "CHHXDC"       ,  0x2A9 },
{ "CHHXDD"       ,  0x2B1 },
{ "INMEM"        ,  0x2B8 },
{ "INMEMA"       ,  0x2C0 },
{ "INMEMB"       ,  0x2CC },
{ "INMEMC"       ,  0x2D4 },
{ "INMEMD"       ,  0x2E0 },
{ "INMEME"       ,  0x2E2 },
{ "CGMEM"        ,  0x301 },
{ "CGMEMA"       ,  0x313 },
{ "CGMEMB"       ,  0x31D },
{ "MOMEM"        ,  0x320 },
{ "MOMEMA"       ,  0x331 },
{ "MOMEMB"       ,  0x347 },
{ "VYMEM"        ,  0x35D },
{ "VYMEMA"       ,  0x365 },
{ "VYMEMB"       ,  0x36A },
{ "VYMEMC"       ,  0x37E },
{ "VYMEMD"       ,  0x392 },
{ "VYMEME"       ,  0x396 },
{ "WRCAS"        ,  0x3A8 },
{ "HEADR"        ,  0x3DE },
{ "HEADRA"       ,  0x3E0 },
{ "HEADRB"       ,  0x3E6 },
{ "HEADRC"       ,  0x3E9 },
{ "HEADRD"       ,  0x3F0 },
{ "WRCLP"        ,  0x403 },
{ "WRCLPA"       ,  0x418 },
{ "WCBYT"        ,  0x423 },
{ "WCBYTA"       ,  0x425 },
{ "WCBYTB"       ,  0x42C },
{ "WCBYTC"       ,  0x42E },
{ "WCBYTD"       ,  0x437 },
{ "WCBYTE"       ,  0x439 },
{ "IDCRT"        ,  0x446 },
{ "RDCAS"        ,  0x460 },
{ "RDCASA"       ,  0x479 },
{ "RDCASB"       ,  0x49F },
{ "RDHDR"        ,  0x4B9 },
{ "RDHDRA"       ,  0x4BF },
{ "RDHDRB"       ,  0x4C5 },
{ "RDCLP"        ,  0x4C9 },
{ "RDCLPA"       ,  0x4E0 },
{ "RDBYT"        ,  0x4E5 },
{ "RDBYTA"       ,  0x4E8 },
{ "RDBYTB"       ,  0x4EF },
{ "RDBIT"        ,  0x4F4 },
{ "RDBITA"       ,  0x4F6 },
{ "RDBITB"       ,  0x4FE },
{ "RDBITC"       ,  0x500 },
{ "RDBITD"       ,  0x506 },
{ "RDBITE"       ,  0x50B },
{ "MDCRP"        ,  0x50E },
{ "MDCRPA"       ,  0x512 },
{ "SETUP"        ,  0x515 },
{ "SETUPA"       ,  0x522 },
{ "SETUPB"       ,  0x527 },
{ "SETQP"        ,  0x52D },
{ "GOMEM"        ,  0x53E },
{ "DPBNK"        ,  0x547 },
{ "PRMEM"        ,  0x550 },
{ "PRMEMA"       ,  0x558 },
{ "PRMEMB"       ,  0x55E },
{ "IDENT"        ,  0x56D },
{ "IDENTA"       ,  0x571 },
{ "IDTDAT"       ,  0x57B },
{ "IOPTRS"       ,  0x5A2 },
{ "MINIT"        ,  0x5AE },
{ "MINITA"       ,  0x5C1 },
{ "MINITB"       ,  0x5CE },
{ "CHINP"        ,  0x5E0 },
{ "KEYIN"        ,  0x5E6 },
{ "KEYINA"       ,  0x5E9 },
{ "KEYINB"       ,  0x5F2 },
{ "WCHAR"        ,  0x5FA },
{ "WCHARA"       ,  0x605 },
{ "WCHARB"       ,  0x617 },
{ "WCHARC"       ,  0x630 },
{ "WCHARD"       ,  0x632 },
{ "WCHARE"       ,  0x63B },
{ "WCHARF"       ,  0x63F },
{ "WCHARG"       ,  0x642 },
{ "WCDATA"       ,  0x655 },
{ "WCDATB"       ,  0x667 },
{ "CHVRL"        ,  0x677 },
{ "CHVRLA"       ,  0x68C },
{ "CHVRLB"       ,  0x68F },
{ "CHVRLC"       ,  0x694 },
{ "CHHRL"        ,  0x697 },
{ "CHHRLA"       ,  0x6A6 },
{ "RICUR"        ,  0x6A8 },
{ "RICURA"       ,  0x6B0 },
{ "SCLEP"        ,  0x6B2 },
{ "STCRH"        ,  0x6B5 },
{ "DOCUR"        ,  0x6C1 },
{ "DOCURA"       ,  0x6C6 },
{ "DOCURB"       ,  0x6C8 },
{ "SCUPP"        ,  0x6DB },
{ "STCRV"        ,  0x6DE },
{ "LECUR"        ,  0x6F4 },
{ "LECURA"       ,  0x6FD },
{ "SCRIP"        ,  0x6FF },
{ "UPCUR"        ,  0x705 },
{ "UPCURA"       ,  0x70C },
{ "SCLOP"        ,  0x720 },
{ "RSTSC"        ,  0x726 },
{ "CLSCR"        ,  0x737 },
{ "CRETN"        ,  0x740 },
{ "CRETNA"       ,  0x755 },
{ "CRETNB"       ,  0x761 },
{ "CLCEL"        ,  0x76E },
{ "CLCELA"       ,  0x77C },
{ "CLCEP"        ,  0x782 },
{ "CLCEPA"       ,  0x788 },
{ "CLCEPB"       ,  0x797 },
{ "BELLR"        ,  0x79E },
{ "BELLRA"       ,  0x7A1 },
{ "BELLRB"       ,  0x7A6 },
{ "SROUT"        ,  0x7AB },
{ "SROUTA"       ,  0x7B4 },
{ "DCHIN"        ,  0x7C4 },
{ "DELAY"        ,  0x7C7 },
{ "DELAYA"       ,  0x7CB }, // !
{ "DELAYB"       ,  0x7CD }, // !
{ "DELAYC"       ,  0x7CF },
{ "DELAYD"       ,  0x7D3 }, // !
{ "DELAYE"       ,  0x7D5 }, // !
{ "SERIN"        ,  0x7D8 },
{ "SERINA"       ,  0x7DD },
{ "SERINB"       ,  0x7E3 },
{ "SERINC"       ,  0x7EA },
{ "MRAM"         ,  0xE00 },
{ "ZB1A"         ,  0xEE0 },
{ "ZB2A"         ,  0xEE2 },
{ "CMAD"         ,  0xEE4 },
{ "ERET"         ,  0xEE6 },
{ "IOAD"         ,  0xEE8 },
{ "IIAD"         ,  0xEEA },
{ "ICAD"         ,  0xEEC },
{ "BRTRES"       ,  0xEEE },
{ "CURRES"       ,  0xEEF },
{ "UPSTRE"       ,  0xEF0 },
{ "LESTRE"       ,  0xEF1 },
{ "LOENRE"       ,  0xEF2 },
{ "RIENRE"       ,  0xEF3 },
{ "CURS"         ,  0xEF4 },
{ "COMRES"       ,  0xEF6 },
{ "CPORES"       ,  0xEF7 },
{ "STAD"         ,  0xEF8 },
{ "ENAD"         ,  0xEFA },
{ "TOAD"         ,  0xEFC },
{ "TBSR"         ,  0xEFE },
{ "INPRAM"       ,  0xF00 },
{ "SCREEN"       , 0x1000 }, // !
{ "USTRT"        , 0x1800 },
{ "QSTRT"        , 0x4000 } // 961
};

EXPORT const STRPTR opcodename[256] = {
"-------", // $00
"LODZ r1",
"LODZ r2",
"LODZ r3",
"LODI,r0",
"LODI,r1",
"LODI,r2",
"LODI,r3",
"LODR,r0",
"LODR,r1",
"LODR,r2",
"LODR,r3",
"LODA,r0",
"LODA,r1",
"LODA,r2",
"LODA,r3",
"-------", // $10
"-------",
"SPSU",
"SPSL",
"RETC,eq",
"RETC,gt",
"RETC,lt",
"RETC,un",
"BCTR,eq",
"BCTR,gt",
"BCTR,lt",
"BCTR,un",
"BCTA,eq",
"BCTA,gt",
"BCTA,lt",
"BCTA,un",
"EORZ r0", // $20
"EORZ r1",
"EORZ r2",
"EORZ r3",
"EORI,r0",
"EORI,r1",
"EORI,r2",
"EORI,r3",
"EORR,r0",
"EORR,r1",
"EORR,r2",
"EORR,r3",
"EORA,r0",
"EORA,r1",
"EORA,r2",
"EORA,r3",
"REDC,r0", // $30
"REDC,r1",
"REDC,r2",
"REDC,r3",
"RETE,eq",
"RETE,gt",
"RETE,lt",
"RETE,un",
"BSTR,eq",
"BSTR,gt",
"BSTR,lt",
"BSTR,un",
"BSTA,eq",
"BSTA,gt",
"BSTA,lt",
"BSTA,un",
"HALT", // $40
"ANDZ r1",
"ANDZ r2",
"ANDZ r3",
"ANDI,r0",
"ANDI,r1",
"ANDI,r2",
"ANDI,r3",
"ANDR,r0",
"ANDR,r1",
"ANDR,r2",
"ANDR,r3",
"ANDA,r0",
"ANDA,r1",
"ANDA,r2",
"ANDA,r3",
"RRR,r0", // $50
"RRR,r1",
"RRR,r2",
"RRR,r3",
"REDE,r0",
"REDE,r1",
"REDE,r2",
"REDE,r3",
"BRNR,r0",
"BRNR,r1",
"BRNR,r2",
"BRNR,r3",
"BRNA,r0",
"BRNA,r1",
"BRNA,r2",
"BRNA,r3",
"IORZ r0", // $60
"IORZ r1",
"IORZ r2",
"IORZ r3",
"IORI,r0",
"IORI,r1",
"IORI,r2",
"IORI,r3",
"IORR,r0",
"IORR,r1",
"IORR,r2",
"IORR,r3",
"IORA,r0",
"IORA,r1",
"IORA,r2",
"IORA,r3",
"REDD,r0", // $70
"REDD,r1",
"REDD,r2",
"REDD,r3",
"CPSU",
"CPSL",
"PPSU",
"PPSL",
"BSNR,r0",
"BSNR,r1",
"BSNR,r2",
"BSNR,r3",
"BSNA,r0",
"BSNA,r1",
"BSNA,r2",
"BSNA,r3",
"ADDZ r0", // $80
"ADDZ r1",
"ADDZ r2",
"ADDZ r3",
"ADDI,r0",
"ADDI,r1",
"ADDI,r2",
"ADDI,r3",
"ADDR,r0",
"ADDR,r1",
"ADDR,r2",
"ADDR,r3",
"ADDA,r0",
"ADDA,r1",
"ADDA,r2",
"ADDA,r3",
"-------", // $90
"-------",
"LPSU",
"LPSL",
"DAR,r0",
"DAR,r1",
"DAR,r2",
"DAR,r3",
"BCFR,eq",
"BCFR,gt",
"BCFR,lt",
"ZBRR",
"BCFA,eq",
"BCFA,gt",
"BCFA,lt",
"BXA,r3",
"SUBZ r0", // $A0
"SUBZ r1",
"SUBZ r2",
"SUBZ r3",
"SUBI,r0",
"SUBI,r1",
"SUBI,r2",
"SUBI,r3",
"SUBR,r0",
"SUBR,r1",
"SUBR,r2",
"SUBR,r3",
"SUBA,r0",
"SUBA,r1",
"SUBA,r2",
"SUBA,r3",
"WRTC,r0", // $B0
"WRTC,r1",
"WRTC,r3",
"WRTC,r3",
"TPSU",
"TPSL",
"-------",
"-------",
"BSFR",
"BSFR",
"BSFR",
"ZBSR",
"BSFA",
"BSFA",
"BSFA",
"BSXA,r3",
"NOP", // $C0
"STRZ r1",
"STRZ r2",
"STRZ r3",
"-------",
"-------",
"-------",
"-------",
"STRR,r0",
"STRR,r1",
"STRR,r2",
"STRR,r3",
"STRA,r0",
"STRA,r1",
"STRA,r2",
"STRA,r3",
"RRL,r0", // $D0
"RRL,r1",
"RRL,r2",
"RRL,r3",
"WRTE,r0",
"WRTE,r1",
"WRTE,r2",
"WRTE,r3",
"BIRR,r0",
"BIRR,r1",
"BIRR,r2",
"BIRR,r3",
"BIRA,r0",
"BIRA,r1",
"BIRA,r2",
"BIRA,r3",
"COMZ,r0", // $E0
"COMZ,r1",
"COMZ,r2",
"COMZ,r3",
"COMI,r0",
"COMI,r1",
"COMI,r2",
"COMI,r3",
"COMR,r0",
"COMR,r1",
"COMR,r2",
"COMR,r3",
"COMA,r0",
"COMA,r1",
"COMA,r2",
"COMA,r3",
"WRTD,r0", // $F0
"WRTD,r1",
"WRTD,r2",
"WRTD,r3",
"TMI,r0",
"TMI,r1",
"TMI,r2",
"TMI,r3",
"BDRR,r0",
"BDRR,r1",
"BDRR,r2",
"BDRR,r3",
"BDRA,r0",
"BDRA,r1",
"BDRA,r2",
"BDRA,r3"  // $FF
};

EXPORT UWORD default_console[4] =
{   SCAN_F1,
    SCAN_F2,
    SCAN_F3,
    SCAN_F4
};

#ifdef AMIGA
EXPORT UWORD default_keypads[2][NUMKEYS] =
{ { SCAN_SPACEBAR,
    SCAN_A1, SCAN_A2,   SCAN_A3,
    SCAN_Q,  SCAN_W,    SCAN_E,
    SCAN_A,  SCAN_S,    SCAN_D,
    SCAN_Z,  SCAN_X,    SCAN_C,
    SCAN_A4, SCAN_R,    SCAN_F,    SCAN_V,
    SCAN_UP, SCAN_DOWN, SCAN_LEFT, SCAN_RIGHT,
    SCAN_A5, SCAN_A6,   SCAN_A7,
    UNASSIGNED, UNASSIGNED, UNASSIGNED, UNASSIGNED
  },
  /* ( ) / *
     7 8 9 -
     4 5 6 +
     1 2 3 E
     -0- . n */
  { SCAN_N0,
    SCAN_OB, SCAN_CB,  SCAN_SL,
    SCAN_N7, SCAN_N8,  SCAN_N9,
    SCAN_N4, SCAN_N5,  SCAN_N6,
    SCAN_N1, SCAN_N2,  SCAN_N3,
    SCAN_AS, SCAN_MI,  SCAN_PL,   SCAN_NE,
    SCAN_I , SCAN_K,   SCAN_J,    SCAN_L,
    SCAN_ND, SCAN_DEL, SCAN_HELP,
    SCAN_U,  SCAN_O,   SCAN_M,    SCAN_FULLSTOP
} };
#endif
#ifdef WIN32
EXPORT UWORD default_keypads[2][NUMKEYS] =
{ { SCAN_SPACEBAR,                                 //  0     (1st firebutton)
    SCAN_A1, SCAN_A2,   SCAN_A3,                   //  1.. 3 (1st row)
    SCAN_Q,  SCAN_W,    SCAN_E,                    //  4.. 6 (2nd row)
    SCAN_A,  SCAN_S,    SCAN_D,                    //  7.. 9 (3rd row)
    SCAN_Z,  SCAN_X,    SCAN_C,                    // 10..12 (4th row)
    SCAN_A4, SCAN_R,    SCAN_F,    SCAN_V,         // 13..16 (Palladium keys)
    SCAN_UP, SCAN_DOWN, SCAN_LEFT, SCAN_RIGHT,     // 17..20 (orthagonal paddles)
    SCAN_A5, SCAN_A6,   SCAN_A7,                   // 21..23 (2nd..4th firebuttons)
    UNASSIGNED, UNASSIGNED, UNASSIGNED, UNASSIGNED // 24..27 (diagonal paddles)
  },
  /* N / * -
     7 8 9 +
     4 5 6 +
     1 2 3 E
     -0- . n */
  { SCAN_N0,                                       //  0     (1st firebutton)
    SCAN_NL, SCAN_SL, SCAN_AS,                     //  1.. 3 (1st row)
    SCAN_N7, SCAN_N8, SCAN_N9,                     //  4.. 6 (2nd row)
    SCAN_N4, SCAN_N5, SCAN_N6,                     //  7.. 9 (3rd row)
    SCAN_N1, SCAN_N2, SCAN_N3,                     // 10..12 (4th row)
    SCAN_MI, SCAN_PL, SCAN_NE,   SCAN_ND,          // 13..16 (Palladium keys)
    SCAN_I , SCAN_K,  SCAN_J,    SCAN_L,           // 17..20 (orthagonal paddles)
    SCAN_DEL,SCAN_END,SCAN_PGDN,                   // 21..23 (2nd..4th firebuttons)
    SCAN_U,  SCAN_O,  SCAN_M,    SCAN_FULLSTOP     // 24..27 (diagonal paddles)
} };
#endif

EXPORT const struct KeyRectStruct keyrect[MACHINES][KEYS] = { // they go left, top, width, height
// ARCADIA
{
{ 174,  73, 14,  9 }, // START
{ 193,  73, 14,  9 }, // A
{ 212,  73, 14,  9 }, // B
{ 168, 115, 36,  9 }, // RESET

{  37,  96, 14,  9 }, // '1'
{  38, 109, 14,  9 }, // '4'
{  39, 122, 14,  9 }, // '7'
{  40, 135, 14,  9 }, // 'Cl'
{  58,  95, 14,  9 }, // '2'
{  59, 108, 14,  9 }, // '5'
{  60, 121, 14,  9 }, // '8'
{  61, 134, 14,  9 }, // '0'
{  79,  94, 14,  9 }, // '3'
{  80, 107, 14,  9 }, // '6'
{  81, 120, 14,  9 }, // '9'
{  82, 133, 14,  9 }, // 'En'

{ 272,  90, 15,  9 }, // '1'
{ 272, 102, 15,  9 }, // '4'
{ 272, 115, 15,  9 }, // '7'
{ 272, 127, 15,  9 }, // 'Cl'
{ 293,  90, 15,  9 }, // '2'
{ 293, 102, 15,  9 }, // '5'
{ 293, 115, 15,  9 }, // '8'
{ 293, 127, 15,  9 }, // '0'
{ 314,  90, 15,  9 }, // '3'
{ 314, 102, 15,  9 }, // '6'
{ 314, 115, 15,  9 }, // '9'
{ 314, 127, 15,  9 }, // 'En'

{  57,  30,  8,  8 }, // 'I'
{  41,  45,  8,  8 }, // 'J'
{  57,  62,  8,  8 }, // 'K'
{  73,  45,  8,  8 }, // 'L'

{ 295,  29,  8,  8 }, // up
{ 278,  44,  8,  8 }, // left
{ 295,  57,  8,  8 }, // down
{ 310,  44,  8,  8 }, // right

{  36,  83, 14,  9 }, // p1 '2'
{  78,  81, 14,  9 }, // p1 '2'
{ 272,  78, 15,  9 }, // p2 '2'
{ 314,  78, 15,  9 }  // p2 '2'
},
// INTERTON
{
{ 199, 172, 29, 28 }, // START
{ 166, 172, 29, 28 }, // A
{   0,   0,  0,  0 }, // B (impossible)
{ 133, 172, 29, 28 }, // RESET

{  23, 134, 15,  9 }, // '1'
{  23, 151, 15,  9 }, // '4'
{  23, 168, 15,  9 }, // '7'
{  23, 185, 15,  9 }, // 'Cl'
{  42, 134, 15,  9 }, // '2'
{  42, 151, 15,  9 }, // '5'
{  42, 168, 15,  9 }, // '8'
{  42, 185, 15,  9 }, // '0'
{  61, 134, 15,  9 }, // '3'
{  61, 151, 15,  9 }, // '6'
{  61, 168, 15,  9 }, // '9'
{  61, 185, 15,  9 }, // 'En'

{ 249, 134, 15,  9 }, // '1'
{ 249, 150, 15,  9 }, // '4'
{ 249, 167, 15,  9 }, // '7'
{ 249, 183, 15,  9 }, // 'Cl'
{ 268, 134, 15,  9 }, // '2'
{ 268, 150, 15,  9 }, // '5'
{ 268, 167, 15,  9 }, // '8'
{ 268, 183, 15,  9 }, // '0'
{ 287, 134, 15,  9 }, // '3'
{ 287, 150, 15,  9 }, // '6'
{ 287, 167, 15,  9 }, // '9'
{ 287, 183, 15,  9 }, // 'En'

{  49,  55,  8,  8 }, // 'I'
{  30,  71,  8,  8 }, // 'J'
{  49,  87,  8,  8 }, // 'K'
{  66,  71,  8,  8 }, // 'L'

{ 268,  56,  8,  8 }, // up
{ 251,  72,  8,  8 }, // left
{ 268,  88,  8,  8 }, // down
{ 286,  72,  8,  8 }, // right

{  23, 117, 15,  9 }, // p1 '2'
{  61, 117, 15,  9 }, // p1 '2'

{ 249, 117, 15,  9 }, // p2 '2'
{ 287, 117, 15,  9 }  // p2 '2'
},
// ELEKTOR
{
{  21, 100, 29, 25 }, // START
{  21,  62, 29, 25 }, // UC
{  21, 138, 29, 26 }, // LC
{  21, 177, 29, 25 }, // RESET

{  77,  62, 28, 25 }, // RCAS
{  77, 100, 28, 25 }, // BP1/2
{  77, 138, 28, 26 }, // PC
{  77, 177, 28, 25 }, // -
{ 104,  62, 29, 25 }, // WCAS
{ 104, 100, 29, 25 }, // REG
{ 104, 138, 29, 26 }, // MEM
{ 104, 177, 29, 25 }, // +
{ 132,  62, 28, 25 }, // C
{ 132, 100, 28, 25 }, // 8
{ 132, 138, 28, 26 }, // 4
{ 132, 177, 28, 25 }, // 0

{ 203,  62, 28, 25 }, // D
{ 203, 100, 28, 25 }, // 9
{ 203, 138, 28, 26 }, // 5
{ 203, 177, 28, 25 }, // 1
{ 230,  62, 29, 25 }, // E
{ 230, 100, 29, 25 }, // A
{ 230, 138, 29, 26 }, // 6
{ 230, 177, 29, 25 }, // 2
{ 258,  62, 28, 25 }, // F
{ 258, 100, 28, 25 }, // B
{ 258, 138, 28, 26 }, // 7
{ 258, 177, 28, 25 }, // 3

{ 115,  21,  8,  8 }, // 'I'
{ 109,  27,  8,  8 }, // 'J'
{ 115,  33,  8,  8 }, // 'K'
{ 121,  27,  8,  8 }, // 'L'

{ 240,  21,  8,  8 }, // up
{ 234,  27,  8,  8 }, // left
{ 240,  33,  8,  8 }, // down
{ 246,  27,  8,  8 }  // right
},
// PIPBUG
{ { 0, 0, 0, 0 } },
// INSTRUCTO
{
{ 183, 147, 11, 10 }, // SENS
{ 183, 160, 11, 10 }, // INT
{ 182, 174, 11, 10 }, // MON
{ 182, 188, 11, 10 }, // RESET
{ 197, 147, 11, 10 }, // WCAS
{ 197, 160, 11, 10 }, // RCAS
{ 197, 174, 11, 10 }, // STEP
{ 197, 188, 11, 10 }, // RUN
{ 212, 147, 11, 10 }, // BKPT
{ 212, 160, 11, 10 }, // REC
{ 212, 174, 11, 10 }, // MEM
{ 212, 188, 11, 10 }, // ENT/NXT
{ 251, 146, 11, 10 }, // C
{ 252, 159, 11, 10 }, // 8
{ 252, 173, 11, 10 }, // 4
{ 253, 187, 11, 10 }, // 0

/*         11
  12345678901
 1###########
 2#         #
 3#  12345  #
 4#  2      #
 5#  3      #
 6#  4      #
 7#  5      #
 8#  6      #
 9#         #
10########### */

{ 266, 146, 11, 10 }, // D
{ 267, 159, 11, 10 }, // 9
{ 267, 173, 11, 10 }, // 5
{ 268, 187, 11, 10 }, // 1
{ 280, 146, 11, 10 }, // E
{ 281, 159, 11, 10 }, // A
{ 282, 173, 11, 10 }, // 6
{ 283, 187, 11, 10 }, // 2
{ 295, 146, 11, 10 }, // F
{ 296, 159, 11, 10 }, // B
{ 297, 173, 11, 10 }, // 7
{ 298, 187, 11, 10 }  // 3
},
// CD2650
{ { 0, 0, 0, 0 } },
// ASTROWARS
{
{ 189,  20, 10, 10 }, // Fire
{ 242,  20, 10, 10 }, // 1P
{ 275,  20, 10, 10 }, // 2P
{  85,  20, 10, 10 }, // left
{ 111,  20, 10, 10 }  // right
},
// GALAXIA
{
{ 239,  50, 11, 10 }, // Fire
{ 332,  50, 11, 10 }, // 1P
{ 392,  50, 11, 10 }, // 2P
{  48,  50, 11, 10 }, // left
{  96,  50, 11, 10 }  // right
},
// MALZAK
{
{ 171,  60, 11, 10 }, // Fire
{ 271,  45, 11, 10 }, // 1P
{ 332,  45, 11, 10 }, // 2P
{  65,  30,  9, 10 }, // up
{  85,  36,  9, 10 }, // up-right
{  95,  51,  9, 10 }, // right
{  81,  66,  9, 10 }, // down-right
{  56,  76,  9, 10 }, // down
{  35,  67,  9, 10 }, // down-left
{  28,  51,  9, 10 }, // left
{  43,  38,  9, 10 }  // up-left
},
// CHAOS
{ { 0, 0, 0, 0 } },
// DOLPHIN
{
{  19, 148, 39, 40 }, // M
{  19, 212, 39, 40 }, // P
{  82,  20, 39, 40 }, // C
{  82,  84, 39, 40 }, // 8
{  82, 148, 39, 40 }, // 4
{  82, 212, 39, 40 }, // 0
{ 144,  20, 39, 40 }, // D
{ 144,  84, 39, 40 }, // 9
{ 144, 148, 39, 40 }, // 5
{ 144, 212, 39, 40 }, // 1
{ 207,  20, 39, 40 }, // E
{ 207,  84, 39, 40 }, // A
{ 207, 148, 39, 40 }, // 6
{ 207, 212, 39, 40 }, // 2
{ 270,  20, 39, 40 }, // F
{ 270,  84, 39, 40 }, // B
{ 270, 148, 39, 40 }, // 7
{ 270, 212, 39, 40 }  // 3
},
// PHUNSY
{ { 0, 0, 0, 0 } }
};

MODULE struct
{   const UWORD address;
    const UBYTE mask;
} a_keyemul[40] =
{   { A_CONSOLE,      0x01 }, // START
    { A_CONSOLE,      0x02 }, // A
    { A_CONSOLE,      0x04 }, // B
    { 0,                 0 }, // RESET
    { A_P1LEFTKEYS,   0x08 }, // p1 '1'
    { A_P1LEFTKEYS,   0x04 }, // p1 '4'
    { A_P1LEFTKEYS,   0x02 }, // p1 '7'
    { A_P1LEFTKEYS,   0x01 }, // p1 'Cl'
    { A_P1MIDDLEKEYS, 0x08 }, // p1 '2'
    { A_P1MIDDLEKEYS, 0x04 }, // p1 '5'
    { A_P1MIDDLEKEYS, 0x02 }, // p1 '8'
    { A_P1MIDDLEKEYS, 0x01 }, // p1 '0'
    { A_P1RIGHTKEYS,  0x08 }, // p1 '3'
    { A_P1RIGHTKEYS,  0x04 }, // p1 '6'
    { A_P1RIGHTKEYS,  0x02 }, // p1 '9'
    { A_P1RIGHTKEYS,  0x01 }, // p1 'En'
    { A_P2LEFTKEYS,   0x08 }, // p2 '1'
    { A_P2LEFTKEYS,   0x04 }, // p2 '4'
    { A_P2LEFTKEYS,   0x02 }, // p2 '7'
    { A_P2LEFTKEYS,   0x01 }, // p2 'Cl'
    { A_P2MIDDLEKEYS, 0x08 }, // p2 '2'
    { A_P2MIDDLEKEYS, 0x04 }, // p2 '5'
    { A_P2MIDDLEKEYS, 0x02 }, // p2 '8'
    { A_P2MIDDLEKEYS, 0x01 }, // p2 '0'
    { A_P2RIGHTKEYS,  0x08 }, // p2 '3'
    { A_P2RIGHTKEYS,  0x04 }, // p2 '6'
    { A_P2RIGHTKEYS,  0x02 }, // p2 '9'
    { A_P2RIGHTKEYS,  0x01 }, // p2 'En'
    { 0,                 0 }, // p1 up
    { 0,                 0 }, // p1 left
    { 0,                 0 }, // p1 down
    { 0,                 0 }, // p1 right
    { 0,                 0 }, // p2 up
    { 0,                 0 }, // p2 left
    { 0,                 0 }, // p2 down
    { 0,                 0 }, // p2 right
    { A_P1MIDDLEKEYS, 0x08 }, // p1 '2'
    { A_P1MIDDLEKEYS, 0x08 }, // p1 '2'
    { A_P2MIDDLEKEYS, 0x08 }, // p1 '2'
    { A_P2MIDDLEKEYS, 0x08 }  // p1 '2'
}, i_keyemul[40] =
{   { IE_CONSOLE,      0x40 }, // START
    { IE_CONSOLE,      0x80 }, // A
    { 0,                  0 }, // B
    { 0,                  0 }, // RESET
    { IE_P1LEFTKEYS,   0x80 }, // p1 '1'
    { IE_P1LEFTKEYS,   0x40 }, // p1 '4'
    { IE_P1LEFTKEYS,   0x20 }, // p1 '7'
    { IE_P1LEFTKEYS,   0x10 }, // p1 'Cl'
    { IE_P1MIDDLEKEYS, 0x80 }, // p1 '2'
    { IE_P1MIDDLEKEYS, 0x40 }, // p1 '5'
    { IE_P1MIDDLEKEYS, 0x20 }, // p1 '8'
    { IE_P1MIDDLEKEYS, 0x10 }, // p1 '0'
    { IE_P1RIGHTKEYS,  0x80 }, // p1 '3'
    { IE_P1RIGHTKEYS,  0x40 }, // p1 '6'
    { IE_P1RIGHTKEYS,  0x20 }, // p1 '9'
    { IE_P1RIGHTKEYS,  0x10 }, // p1 'En'
    { IE_P2LEFTKEYS,   0x80 }, // p2 '1'
    { IE_P2LEFTKEYS,   0x40 }, // p2 '4'
    { IE_P2LEFTKEYS,   0x20 }, // p2 '7'
    { IE_P2LEFTKEYS,   0x10 }, // p2 'Cl'
    { IE_P2MIDDLEKEYS, 0x80 }, // p2 '2'
    { IE_P2MIDDLEKEYS, 0x40 }, // p2 '5'
    { IE_P2MIDDLEKEYS, 0x20 }, // p2 '8'
    { IE_P2MIDDLEKEYS, 0x10 }, // p2 '0'
    { IE_P2RIGHTKEYS,  0x80 }, // p2 '3'
    { IE_P2RIGHTKEYS,  0x40 }, // p2 '6'
    { IE_P2RIGHTKEYS,  0x20 }, // p2 '9'
    { IE_P2RIGHTKEYS,  0x10 }, // p2 'En'
    { 0,                  0 }, // p1 up
    { 0,                  0 }, // p1 left
    { 0,                  0 }, // p1 down
    { 0,                  0 }, // p1 right
    { 0,                  0 }, // p2 up
    { 0,                  0 }, // p2 left
    { 0,                  0 }, // p2 down
    { 0,                  0 }, // p2 right
    { IE_P1MIDDLEKEYS, 0x80 }, // p1 '2'
    { IE_P1MIDDLEKEYS, 0x80 }, // p1 '2'
    { IE_P2MIDDLEKEYS, 0x80 }, // p1 '2'
    { IE_P2MIDDLEKEYS, 0x80 }  // p1 '2'
}, e_keyemul[36] =
{   { IE_CONSOLE,      0x40 }, // START
    { IE_CONSOLE,      0x80 }, // UC
    { IE_CONSOLE,      0x20 }, // LC
    { IE_CONSOLE,      0x10 }, // RESET
    { IE_P1LEFTKEYS,   0x80 }, // p1
    { IE_P1LEFTKEYS,   0x40 }, // p1
    { IE_P1LEFTKEYS,   0x20 }, // p1
    { IE_P1LEFTKEYS,   0x10 }, // p1
    { IE_P1MIDDLEKEYS, 0x80 }, // p1
    { IE_P1MIDDLEKEYS, 0x40 }, // p1
    { IE_P1MIDDLEKEYS, 0x20 }, // p1
    { IE_P1MIDDLEKEYS, 0x10 }, // p1
    { IE_P1RIGHTKEYS,  0x80 }, // p1
    { IE_P1RIGHTKEYS,  0x40 }, // p1
    { IE_P1RIGHTKEYS,  0x20 }, // p1
    { IE_P1RIGHTKEYS,  0x10 }, // p1
    { IE_P2LEFTKEYS,   0x80 }, // p2
    { IE_P2LEFTKEYS,   0x40 }, // p2
    { IE_P2LEFTKEYS,   0x20 }, // p2
    { IE_P2LEFTKEYS,   0x10 }, // p2
    { IE_P2MIDDLEKEYS, 0x80 }, // p2
    { IE_P2MIDDLEKEYS, 0x40 }, // p2
    { IE_P2MIDDLEKEYS, 0x20 }, // p2
    { IE_P2MIDDLEKEYS, 0x10 }, // p2
    { IE_P2RIGHTKEYS,  0x80 }, // p2
    { IE_P2RIGHTKEYS,  0x40 }, // p2
    { IE_P2RIGHTKEYS,  0x20 }, // p2
    { IE_P2RIGHTKEYS,  0x10 }, // p2
    { 0,                  0 }, // p1 up
    { 0,                  0 }, // p1 left
    { 0,                  0 }, // p1 down
    { 0,                  0 }, // p1 right
    { 0,                  0 }, // p2 up
    { 0,                  0 }, // p2 left
    { 0,                  0 }, // p2 down
    { 0,                  0 }  // p2 right
}, s_keyemul[28] =
{   { 0,    0x1 }, // SENS
    { 0,    0x2 }, // INT
    { 0,    0x4 }, // MON
    { 0,    0x8 }, // RST
    { 1,    0x1 }, // WCAS
    { 1,    0x2 }, // RCAS
    { 1,    0x4 }, // STEP
    { 1,    0x8 }, // RUN
    { 2,    0x1 }, // BKPT
    { 2,    0x2 }, // REC
    { 2,    0x4 }, // MEM
    { 2,    0x8 }, // ENT NXT
    { 3,    0x8 }, // C
    { 3,    0x4 }, // 8
    { 3,    0x2 }, // 4
    { 3,    0x1 }, // 0
    { 4,    0x8 }, // D
    { 4,    0x4 }, // 9
    { 4,    0x2 }, // 5
    { 4,    0x1 }, // 1
    { 5,    0x8 }, // E
    { 5,    0x4 }, // A
    { 5,    0x2 }, // 6
    { 5,    0x1 }, // 2
    { 6,    0x8 }, // F
    { 6,    0x4 }, // B
    { 6,    0x2 }, // 7
    { 6,    0x1 }  // 3
}, m_keyemul[11] =
{   { 0,    0x10 }, // fire
    { 0,    0x04 }, // 1P
    { 0,    0x08 }, // 2P
    { 0,    0x80 }, // up
    { 0,    0xA0 }, // up-right
    { 0,    0x20 }, // right
    { 0,    0x22 }, // down-right
    { 0,    0x02 }, // down
    { 0,    0x42 }, // down-left
    { 0,    0x40 }, // left
    { 0,    0xC0 }  // up-left
}, g_keyemul[5] =
{   { 0,    0x30 }, // fire
    { 0,    0x01 }, // 1P
    { 0,    0x02 }, // 2P
    { 1,    0x14 }, // left
    { 1,    0x28 }  // right
}, dolphin_keyemul[28] =
{   { 1,    0x1 }, // WCAS
    { 2,    0x1 }, // BKPT
    { 3,    0x8 }, // C
    { 3,    0x4 }, // 8
    { 3,    0x2 }, // 4
    { 3,    0x1 }, // 0
    { 4,    0x8 }, // D
    { 4,    0x4 }, // 9
    { 4,    0x2 }, // 5
    { 4,    0x1 }, // 1
    { 5,    0x8 }, // E
    { 5,    0x4 }, // A
    { 5,    0x2 }, // 6
    { 5,    0x1 }, // 2
    { 6,    0x8 }, // F
    { 6,    0x4 }, // B
    { 6,    0x2 }, // 7
    { 6,    0x1 }  // 3
};

MODULE const float idealfreq[256] = {
  (float)    0.0 , //   0 $00
  (float) 3937.00, //   1 $01
  (float) 2624.67, //   2 $02
  (float) 1968.50, //   3 $03
  (float) 1568.00, //   4 $04 vhigh  G
  (float) 1318.50, //   5 $05 vhigh  E
  (float) 1108.70, //   6 $06 vhigh  C#
  (float)  987.80, //   7 $07 high   B
  (float)  880.00, //   8 $08 high   A
  (float)  783.99, //   9 $09 high   G
  (float)  698.46, //  10 $0A high   F
  (float)  659.26, //  11 $0B high   E
  (float)  622.25, //  12 $0C high   D#
  (float)  554.37, //  13 $0D high   C#
  (float)  523.25, //  14 $0E high   C
  (float)  493.88, //  15 $0F middle B
  (float)  466.16, //  16 $10 middle A#
  (float)  440.00, //  17 $11 middle A
  (float)  415.30, //  18 $12 middle G#
  (float)  392.00, //  19 $13 middle G
  (float)  369.99, //  20 $14 middle F#
  (float)  349.23, //  21 $15 middle F
  (float)  349.23, //  22 $16 (342.35)
  (float)  329.63, //  23 $17 middle E
  (float)  311.13, //  24 $18 middle D#
  (float)  293.66, //  25 $19 (302.84)
 // needs to be D not D# for (Arcadia) SUPERBUG
 // needs to be D# not D for (Arcadia) GUNDAM
  (float)  293.66, //  26 $1A middle D
  (float)  277.18, //  27 $1B middle C#
  0.0,             //  28 $1C (271.52)
// needs to be C# not C for (Arcadia)  GUNDAM
// needs to be C not C# for (Interton) MUSICALG
  (float)  261.63, //  29 $1D middle C
  (float)  246.94, //  30 $1E (254.00)
  (float)  246.94, //  31 $1F low    B
  (float)  233.08, //  32 $20 (238.61)
  (float)  233.08, //  33 $21 low    A#
  (float)  220.00, //  34 $22 (224.97)
  (float)  220.00, //  35 $23 low    A
  (float)  207.65, //  36 $24 (212.81)
  (float)  207.65, //  37 $25 low    G#
  (float)  196.00, //  38 $26 (201.90) - arguable
  (float)  196.00, //  39 $27 low    G
  (float)  196.00, //  40 $28 (192.05)
  (float)  184.99, //  41 $29 (187.48)
  (float)  184.99, //  42 $2A low    F#
  (float)  174.61, //  43 $2B (178.95)
  (float)  174.61, //  44 $2C low    F
  (float)  174.61, //  45 $2D (171.17)
  (float)  164.81, //  46 $2E (167.53)
  (float)  164.81, //  47 $2F low    E
  (float)  155.56, //  48 $30 (160.69) - arguable
  (float)  155.56, //  49 $31 low    D#
  (float)  155.56, //  50 $32 (154.39)
  (float)  146.83, //  51 $33 (151.42)
  (float)  146.83, //  52 $34 (148.57)
  (float)  146.83, //  53 $35 low    D
  (float)  146.83, //  54 $36 (143.16) - arguable
  (float)  138.59, //  55 $37 (140.61)
  (float)  138.59, //  56 $38 low    C#
  (float)  130.81, //  57 $39 (135.76) - arguable
  (float)  130.81, //  58 $3A (133.46)
  (float)  130.81, //  59 $3B low    C
  (float)  130.81, //  60 $3C (129.08)
  (float)  130.81, //  61 $3D (127.00)
  (float)  123.47, //  62 $3E (124.98)
  (float)  123.47, //  63 $3F vlow   B
  (float)  116.54, //  64 $40 (121.14) - arguable
  (float)  116.54, //  65 $41 (119.30)
  (float)  116.54, //  66 $42 vlow   A#
  (float)  116.54, //  67 $43 (115.79)
  (float)  116.54, //  68 $44 (114.12) - arguable
  (float)  110.00, //  69 $45 (112.49)
  (float)  110.00, //  70 $46 vlow   A
  (float)  110.00, //  71 $47 (109.36)
  (float)  110.00, //  72 $48 (107.86)
  (float)  103.82, //  73 $49 (106.41)
  (float)  103.82, //  74 $4A (104.99)
  (float)  103.82, //  75 $4B vlow   G#
  (float)  103.82, //  76 $4C (102.26)
  (float)  103.82, //  77 $4D (100.95)
  (float)   98.00, //  78 $4E ( 99.67)
  (float)   98.00, //  79 $4F vlow   G
  (float)   98.00, //  80 $50 ( 97.21)
  (float)   98.00, //  81 $51 ( 96.02)
  (float)   98.00, //  82 $52 ( 94.87) // needs to be G not F# for (Arcadia) GRIDIRON
  (float)   92.49, //  83 $53 ( 93.74)
  (float)   92.49, //  84 $54 vlow   F#
  (float)   92.49, //  85 $55 ( 91.56)
  (float)   92.49, //  86 $56 ( 90.51) - arguable
  (float)   87.30, //  87 $57 ( 89.48)
  (float)   87.30, //  88 $58 ( 88.47)
  (float)   87.30, //  89 $59 vlow   F
  (float)   87.30, //  90 $5A ( 86.53)
  (float)   87.30, //  91 $5B ( 85.59)
  (float)   82.40, //  92 $5C ( 84.67) - arguable
  (float)   82.40, //  93 $5D ( 83.77)
  (float)   82.40, //  94 $5E ( 82.88)
  (float)   82.40, //  95 $5F vlow   E
  (float)   82.40, //  96 $60 ( 81.18)
  (float)   82.40, //  97 $61 ( 80.35)
  (float)   77.78, //  98 $62 ( 79.54)
  (float)   77.78, //  99 $63 ( 78.74)
  (float)   77.78, // 100 $64 vlow   D#
  (float)   77.78, // 101 $65 ( 77.20)
  (float)   77.78, // 102 $66 ( 76.45)
  (float)   73.41, // 103 $67 ( 75.71)
  (float)   73.41, // 104 $68 ( 74.99)
  (float)   73.41, // 105 $69 ( 74.28)
  (float)   73.41, // 106 $6A ( 73.59)
  (float)   73.41, // 107 $6B vlow   D
  (float)   73.41, // 108 $6C ( 72.24)
  (float)   73.41, // 109 $6D ( 71.58)
  (float)   69.29, // 110 $6E ( 70.94)
  (float)   69.29, // 111 $6F ( 70.30)
  (float)   69.29, // 112 $70 vlow   C#
  (float)   69.29, // 113 $71 ( 69.07)
  (float)   69.29, // 114 $72 ( 68.47)
  (float)   69.29, // 115 $73 ( 67.88)
  (float)   65.40, // 116 $74 ( 67.30)
  (float)   65.40, // 117 $75 ( 66.73)
  (float)   65.40, // 118 $76 ( 66.17)
  (float)   65.40, // 119 $77 vlow   C
  (float)   65.40, // 120 $78 ( 65.07)
  (float)   65.40, // 121 $79 ( 64.54)
  (float)   65.40, // 122 $7A ( 64.02)
  (float)   61.73, // 123 $7B ( 63.50)
  (float)   61.73, // 124 $7C xlow   B
  (float)   61.73, // 125 $7D ( 62.49)
  (float)   61.73, // 126 $7E ( 62.00)
  (float)   61.73, // 127 $7F ( 61.52)
  (float)   61.73, // 128 $80 ( 61.03876)
  (float)   58.270,// 129 $81 ( 60.56923) - arguable
  (float)   58.270,// 130 $82 ( 60.10687)
  (float)   58.270,// 131 $83 ( 59.65152)
  (float)   58.270,// 132 $84 ( 59.20301)
  (float)   58.270,// 133 $85 ( 58.76119)
  (float)   58.270,// 134 $86 xlow   A#
  (float)   58.270,// 135 $87 ( 57.89706)
  (float)   58.270,// 136 $88 ( 57.47445)
  (float)   58.270,// 137 $89 ( 57.05797)
  (float)   55.000,// 138 $8A ( 56.64748) - arguable
  (float)   55.000,// 139 $8B ( 56.24286)
  (float)   55.000,// 140 $8C ( 55.84397)
  (float)   55.000,// 141 $8D ( 55.45070)
  (float)   55.000,// 142 $8E xlow   A
  (float)   55.000,// 143 $8F ( 54.68056)
  (float)   55.000,// 144 $90 ( 54.30345)
  (float)   55.000,// 145 $91 ( 53.93151)
  (float)   55.000,// 146 $92 ( 53.56462)
  (float)   51.913,// 147 $93 ( 53.20270)
  (float)   51.913,// 148 $94 ( 52.84564)
  (float)   51.913,// 149 $95 ( 52.49333)
  (float)   51.913,// 150 $96 ( 52.14569)
  (float)   51.913,// 151 $97 xlow   G#
  (float)   51.913,// 152 $98 ( 51.46405)
  (float)   51.913,// 153 $99 ( 51.12987)
  (float)   51.913,// 154 $9A ( 50.80000)
  (float)   48.999,// 155 $9B ( 50.47436) - arguable
  (float)   48.999,// 156 $9C ( 50.15287)
  (float)   48.999,// 157 $9D ( 49.83544)
  (float)   48.999,// 158 $9E ( 49.52201)
  (float)   48.999,// 159 $9F ( 49.21250)
  (float)   48.999,// 160 $A0 xlow   G
  (float)   48.999,// 161 $A1 ( 48.60494)
  (float)   48.999,// 162 $A2 ( 48.30675)
  (float)   48.999,// 163 $A3 ( 48.01220)
  (float)   46.249,// 164 $A4 ( 47.72121) - arguable
  (float)   46.249,// 165 $A5 ( 47.43373)
  (float)   46.249,// 166 $A6 ( 47.14970)
  (float)   46.249,// 167 $A7 ( 46.86905)
  (float)   46.249,// 168 $A8 ( 46.59172)
  (float)   46.249,// 169 $A9 xlow   F#
  (float)   46.249,// 170 $AA ( 46.04678)
  (float)   46.249,// 171 $AB ( 45.77907)
  (float)   46.249,// 172 $AC ( 45.51445)
  (float)   46.249,// 173 $AD ( 45.25287)
  (float)   43.654,// 174 $AE ( 44.99429) - arguable
  (float)   43.654,// 175 $AF ( 44.73864)
  (float)   43.654,// 176 $B0 ( 44.48587)
  (float)   43.654,// 177 $B1 ( 44.23595)
  (float)   43.654,// 178 $B2 ( 43.98883)
  (float)   43.654,// 179 $B3 xlow   F
  (float)   43.654,// 180 $B4 ( 43.50276)
  (float)   43.654,// 181 $B5 ( 43.26374)
  (float)   43.654,// 182 $B6 ( 43.02732)
  (float)   43.654,// 183 $B7 ( 42.79348)
  (float)   43.654,// 184 $B8 ( 42.56216)
  (float)   41.203,// 185 $B9 ( 42.33333)
  (float)   41.203,// 186 $BA ( 42.10695)
  (float)   41.203,// 187 $BB ( 41.88298)
  (float)   41.203,// 188 $BC ( 41.66138)
  (float)   41.203,// 189 $BD ( 41.44210)
  (float)   41.203,// 190 $BE xlow   E
  (float)   41.203,// 191 $BF ( 41.01042)
  (float)   41.203,// 192 $C0 ( 40.79493)
  (float)   41.203,// 193 $C1 ( 40.58763)
  (float)   41.203,// 194 $C2 ( 40.37949)
  (float)   41.203,// 195 $C3 ( 40.17347)
  (float)   38.891,// 196 $C4 ( 39.96954)
  (float)   38.891,// 197 $C5 ( 39.76768)
  (float)   38.891,// 198 $C6 ( 39.56784)
  (float)   38.891,// 199 $C7 ( 39.37000)
  (float)   38.891,// 200 $C8 ( 39.17413)
  (float)   38.891,// 201 $C9 xlow   D#
  (float)   38.891,// 202 $CA ( 38.78818)
  (float)   38.891,// 203 $CB ( 38.59804)
  (float)   38.891,// 204 $CC ( 38.40976)
  (float)   38.891,// 205 $CD ( 38.22330)
  (float)   38.891,// 206 $CE ( 38.03865)
  (float)   38.891,// 207 $CF ( 37.85577)
  (float)   36.708,// 208 $D0 ( 37.67464)
  (float)   36.708,// 209 $D1 ( 37.49524)
  (float)   36.708,// 210 $D2 ( 37.31754)
  (float)   36.708,// 211 $D3 ( 37.14151)
  (float)   36.708,// 212 $D4 ( 36.96714)
  (float)   36.708,// 213 $D5 ( 36.79439)
  (float)   36.708,// 214 $D6 xlow   D
  (float)   36.708,// 215 $D7 ( 36.45370)
  (float)   36.708,// 216 $D8 ( 36.28571)
  (float)   36.708,// 217 $D9 ( 36.11927)
  (float)   36.708,// 218 $DA ( 35.95434)
  (float)   36.708,// 219 $DB ( 35.79091)
  (float)   36.708,// 220 $DC ( 35.62896) - arguable
  (float)   34.648,// 221 $DD ( 35.46847)
  (float)   34.648,// 222 $DE ( 35.30942)
  (float)   34.648,// 223 $DF ( 35.15179)
  (float)   34.648,// 224 $E0 ( 34.99556)
  (float)   34.648,// 225 $E1 ( 34.84071)
  (float)   34.648,// 226 $E2 xlow   C#
  (float)   34.648,// 227 $E3 ( 34.53509)
  (float)   34.648,// 228 $E4 ( 34.38428)
  (float)   34.648,// 229 $E5 ( 34.23478)
  (float)   34.648,// 230 $E6 ( 34.08658)
  (float)   34.648,// 231 $E7 ( 33.93966)
  (float)   34.648,// 232 $E8 ( 33.79399)
  (float)   34.648,// 233 $E9 ( 33.64957) - arguable
  (float)   32.703,// 234 $EA ( 33.50638)
  (float)   32.703,// 235 $EB ( 33.36441)
  (float)   32.703,// 236 $EC ( 33.22363)
  (float)   32.703,// 237 $ED ( 33.08403)
  (float)   32.703,// 238 $EE ( 32.94561)
  (float)   32.703,// 239 $EF ( 32.80833)
  (float)   32.703,// 240 $F0 xlow   C
  (float)   32.703,// 241 $F1 ( 32.53719)
  (float)   32.703,// 242 $F2 ( 32.40329)
  (float)   32.703,// 243 $F3 ( 32.27049)
  (float)   32.703,// 244 $F4 ( 32.13877)
  (float)   32.703,// 245 $F5 ( 32.00813)
  (float)   32.703,// 246 $F6 ( 31.87854)
  (float)   32.703,// 247 $F7 ( 31.75000) - arguable
  (float)   30.868,// 248 $F8 ( 31.62249)
  (float)   30.868,// 249 $F9 ( 31.49600)
  (float)   30.868,// 250 $FA ( 31.37052)
  (float)   30.868,// 251 $FB ( 31.24603)
  (float)   30.868,// 252 $FC ( 31.12253)
  (float)   30.868,// 253 $FD ( 31.00000)
  (float)   30.868,// 254 $FE xxlow  B
  (float)   30.868,// 255 $FF ( 30.75781)
};

EXPORT struct HiScoreStruct hiscore[HISCORES] = {
{ { 0x1802, 0x180C,      0,      0 }, 2, 0x01, 0, "", "" }, //  0. 3D Soccer (p1, p2)
{ { 0x1816, 0x181D,      0,      0 }, 3, 0x01, 0, "", "" }, //  1. Alien Invaders (normal, high)
{ { 0x1805, 0x180A,      0,      0 }, 2, 0x01, 0, "", "" }, //  2. American Football (p1, p2)
{ { 0x1800, 0x180A,      0,      0 }, 6, 0x01, 0, "", "" }, //  3. Astro Invader (normal, high)
{ { 0x1810, 0x181E,      0,      0 }, 2, 0x01, 0, "", "" }, //  4. Baseball (home, visitors)
{ { 0x1831, 0x1839,      0,      0 }, 4, 0x01, 0, "", "" }, //  5. Basketball (p1, p2)
// Basketball might be less than 4 digits but is at least 1 digit
{ { 0x1814, 0x1819,      0,      0 }, 3, 0x01, 0, "", "" }, //  6. Boxing (p1, p2)
{ { 0x1800, 0x180B, 0x1811, 0x1816 }, 4, 0x01, 0, "", "" }, //  7. Breakaway (p1, p2, normal, high)
{ { 0x1800, 0x180E, 0x1860, 0x186E }, 2, 0x01, 0, "", "" }, //  8. Capture (p1, p2, p1 previous, p2 previous)
{ { 0x1800, 0x1809,      0,      0 }, 6, 0x01, 0, "", "" }, //  9. Cat Trax (normal, high)
{ { 0x1805, 0x180B,      0,      0 }, 5, 0x01, 0, "", "" }, // 10. Circus (p1, p2)
// Capture has 6 more previous scores that we don't handle
{ { 0x1826, 0x1856, 0x1896,      0 }, 5, 0x01, 0, "", "" }, // 11. Crazy Clitlicker (normal, normal, high)
{ { 0x1810, 0x1819,      0,      0 }, 6, 0x01, 0, "", "" }, // 12. Cock Gobbler (normal, high)
{ { 0x1801,      0,      0,      0 }, 5, 0x01, 0, "", "" }, // 13. Doraemon
{ { 0x1801, 0x180B,      0,      0 }, 5, 0x01, 0, "", "" }, // 14. Dr. Slump (normal, high)
{ { 0x1800, 0x180B,      0,      0 }, 5, 0x01, 0, "", "" }, // 15. Escape (normal, high)
{ { 0x18CB,      0,      0,      0 }, 5, 0x01, 0, "", "" }, // 16. Sprogger
{ { 0x1810, 0x181A,      0,      0 }, 6, 0x01, 0, "", "" }, // 17. Fucking Fish (high, normal)
{ { 0x1800, 0x180A,      0,      0 }, 6, 0x01, 0, "", "" }, // 18. Gundam (normal, high)
{ { 0x1810, 0x181B,      0,      0 }, 5, 0x01, 0, "", "" }, // 19. Homo (normal, high)
{ { 0x1801, 0x180B,      0,      0 }, 4, 0x01, 0, "", "" }, // 20. JTron (high, normal)
{ { 0x1810, 0x181B,      0,      0 }, 5, 0x01, 0, "", "" }, // 21. Jump Bug (normal, high)
{ { 0x1800, 0x180B,      0,      0 }, 5, 0x01, 0, "", "" }, // 22. Jungler (normal, high)
{ { 0x1800, 0x180B,      0,      0 }, 5, 0x01, 0, "", "" }, // 23. Spackross (normal, high)
{ { 0x1801, 0x180A,      0,      0 }, 6, 0x01, 0, "", "" }, // 24. Missile War (normal, high)
// Missile War might be less (or more) than 6 digits but is at least 4 digits
{ { 0x1AC1, 0x1ACC,      0,      0 }, 2, 0x01, 0, "", "" }, // 25. Monaco Grand Prix (p1, p2)
{ { 0x1800, 0x1809,      0,      0 }, 6, 0x01, 0, "", "" }, // 26. Nibblemen/Super Cock Gobbler (normal, high)
{ { 0x1819, 0x188B,      0,      0 }, 5, 0x01, 0, "", "" }, // 27. Pararooter (normal, high)
{ { 0x1800, 0x180B,      0,      0 }, 5, 0x01, 0, "", "" }, // 28. Herpes (normal, high)
{ { 0x1800, 0x180B,      0,      0 }, 5, 0x01, 0, "", "" }, // 29. R2D Tank (normal, high)
{ { 0x1802, 0x1809,      0,      0 }, 5, 0x01, 0, "", "" }, // 30. Red Snatch (normal, high)
{ { 0x1800, 0x180B,      0,      0 }, 5, 0x01, 0, "", "" }, // 31. Robot Killer (normal, high)
{ { 0x1801, 0x1807,      0,      0 }, 5, 0x01, 0, "", "" }, // 32. Root 69 (normal, high)
{ { 0x1812, 0x181C,      0,      0 }, 2, 0x01, 0, "", "" }, // 33. 2D Wogball (p1, p2)
{ { 0x1800, 0x180A,      0,      0 }, 6, 0x01, 0, "", "" }, // 34. Space Attack/Space War (normal, high)
{ { 0x180A, 0x1879,      0,      0 }, 4, 0x01, 0, "", "" }, // 35. Space Mission (normal, normal)
{ { 0x1800, 0x180C,      0,      0 }, 4, 0x01, 0, "", "" }, // 36. Space Rooters (normal, high)
{ { 0x1800, 0x180C,      0,      0 }, 4, 0x01, 0, "", "" }, // 37. Space Squadron (normal, high)
{ { 0x1AB0, 0x1ABC,      0,      0 }, 4, 0x01, 0, "", "" }, // 38. Space Vultures (normal, high)
{ { 0x1800, 0x180B,      0,      0 }, 5, 0x01, 0, "", "" }, // 39. Spiders (normal, high)
{ { 0x1807,      0,      0,      0 }, 6, 0x01, 0, "", "" }, // 40. Super Buggery 1 (normal, high)
// Super Bug might be more than 6 digits
{ { 0x1807,      0,      0,      0 }, 6, 0x01, 0, "", "" }, // 41. Super Bug 2 (normal, high)
{ { 0x1800, 0x180A,      0,      0 }, 5, 0x01, 0, "", "" }, // 42. Spanks a Lot (normal, high)
{ { 0x1A07, 0x1A08,      0,      0 }, 4, 0x10, 0, "", "" }, // 43. Titris (p1, p2)
{ { 0x1810, 0x181B,      0,      0 }, 5, 0x01, 0, "", "" }, // 44. The End (normal, high)
{ { 0x1800, 0x180A,      0,      0 }, 5, 0x01, 0, "", "" }, // 45. Turtles/Gerbils (normal, high)
{ { 0x1B81, 0x1A61, 0x1921,      0 }, 5,  -32, 0, "", "" }, // 46. Astro Wars (p1, high, p2)
{ { 0x1B81, 0x1A41, 0x1901,      0 }, 5,  -32, 0, "", "" }, // 47. Galaxia (p1, high, p2)
{ { 0x1843, 0x1850, 0x185D,      0 }, 6, 0x01, 0, "", "" }, // 48. Malzak 1 (p1, high, p2)
{ { 0x1843, 0x1850, 0x185D,      0 }, 6, 0x01, 0, "", "" }  // 49. Malzak 2 (p1, high, p2)
};

/* HS_#?_POS must accord with the above table!
Unsupported:
{ 0x1854, 0x18C4, 0x1848, 0x18B8, 3, 0x01 }, // 3D Bowling (p1, p2, p1 previous, p2 previous)
3D Bowling has 2 more previous scores that we don't handle
unfortunately, 3D Bowling also uses $185x for other purposes
{ 0x18B3, 0x18BB,      0,      0, 2, 0x01 }, // Auto Race (p1, p2)
 Auto Race (each 2-player game is "first to 20")
 Battle
*Blackjack/Poker
 Brain Quiz (probably tiles are used for other purposes)
 Combat (each game is "first to 20")
 Dictionary
 Golf (but good scores are low)
*Grand Slam Tennis (but remember 0s are Os)
*Horse Racing
 Ocean Battle
 Star Chess
* = might be supportable */

const struct
{   const UWORD address;
    const STRPTR name;
} game_equivalents[] = {
// Guessing Game (machine code version)
{ 0x0440, "STRT"   }, //   0 C
{ 0x0442, "FZ"     }, //   1 C
{ 0x0445, "F1"     }, //   2 C
{ 0x0447, "F2"     }, //   3 C
{ 0x0450, "F3"     }, //   4 C
{ 0x0452, "F4"     }, //   5 C
{ 0x045E, "F5"     }, //   6 C
{ 0x046B, "F6"     }, //   7 C
{ 0x047A, "F7"     }, //   8 C
{ 0x0482, "F8"     }, //   9 C
{ 0x0493, "INPT"   }, //  10 C
{ 0x04A6, "PRNT"   }, //  11 C
{ 0x04B1, "MSAG"   }, //  12 D
// Maths Demonstration
{ 0x0440, "STRT"   }, //  13 C
{ 0x0447, "F1"     }, //  14 C
{ 0x0458, "SUBT"   }, //  15 C
{ 0x0460, "MOD"    }, //  16 C
{ 0x046E, "F2"     }, //  17 C
{ 0x0481, "F3"     }, //  18 C
{ 0x0492, "F5"     }, //  19 C
{ 0x0499, "F4"     }, //  20 C
{ 0x049B, "F6"     }, //  21 C
{ 0x04A5, "F7"     }, //  22 C
{ 0x04AF, "SUB2"   }, //  23 C
{ 0x04B4, "SUB1"   }, //  24 C
{ 0x04C9, "END"    }, //  25 C
{ 0x04CB, "F8"     }, //  26 C
{ 0x04D7, "FA"     }, //  27 C
{ 0x04DD, "MSAG"   }, //  28 D
// Message Editor
{ 0x0440, "F1"     }, //  29 C
{ 0x0460, "FT"     }, //  30 C
{ 0x0462, "FZ"     }, //  31 C
{ 0x0476, "FP"     }, //  32 C
{ 0x0489, "F2"     }, //  33 C
{ 0x048B, "FC"     }, //  34 C
{ 0x048D, "PRNT"   }, //  35 C
{ 0x0493, "FR"     }, //  36 C
{ 0x0499, "F4"     }, //  37 C
{ 0x04AA, "M1"     }, //  38 D
{ 0x04AE, "M2"     }, //  39 D
{ 0x04B4, "TEXT"   }, //  40 D
// Nim (PIPBUG)
{ 0x0440, "STRT"   }, //  41 C
{ 0x0449, "FH"     }, //  42 C
{ 0x0457, "F1"     }, //  43 C
{ 0x0460, "F2"     }, //  44 C
{ 0x0466, "F3"     }, //  45 C
{ 0x047A, "F4"     }, //  46 C
{ 0x047E, "F5"     }, //  47 C
{ 0x049A, "F6"     }, //  48 C
{ 0x04A1, "F8"     }, //  49 C
{ 0x04A7, "FA"     }, //  50 C
{ 0x04AC, "F9"     }, //  51 C
{ 0x04AF, "F7"     }, //  52 C
{ 0x04B3, "PRNT"   }, //  53 C
{ 0x04BC, "MSGE"   }, //  54 D
// Random Number Generator
{ 0x045F, "F1"     }, //  55 C
{ 0x0465, "F3"     }, //  56 C
{ 0x0474, "F4"     }, //  57 C
{ 0x0476, "F5"     }, //  58 C
{ 0x047C, "F6"     }, //  59 C
{ 0x048B, "IN"     }, //  60 C
{ 0x0498, "INPT"   }, //  61 C
{ 0x04A0, "F8"     }, //  62 C
{ 0x04A4, "F7"     }, //  63 C
{ 0x04AE, "F9"     }, //  64 C
{ 0x04BC, "PRNT"   }, //  65 C
{ 0x04C5, "MSG"    }, //  66 D
// 12K BASIC (CD2650)
{ 0x179C, "IPUSP"  }, //  67 D
{ 0x179E, "NEWC7"  }, //  68 C
{ 0x17A6, "NEWC8"  }, //  69 C
{ 0x17AD, "NEWC9"  }, //  70 C
{ 0x17AF, "NEWC10" }, //  71 C
{ 0x17B3, "ZTOFF"  }, //  72 C
{ 0x17B7, "ZOUT1"  }, //  73 C
{ 0x17BE, "ZOUT2"  }, //  74 C
{ 0x17C3, "ZWAIT"  }, //  75 C
{ 0x17C9, "ZLOOP"  }, //  76 C
{ 0x17D0, "ZTON"   }, //  77 C
{ 0x17D4, "ZREAD"  }, //  78 C
{ 0x17D9, "ZWRITE" }, //  79 C
{ 0x1796, "WHYAT"  }, //  80 C
{ 0x200A, "TABEND" }, //  81 P
{ 0x2031, "BASIC4" }, //  82 C
{ 0x204C, "BASIC3" }, //  83 C
{ 0x212D, "DATPNT" }, //  84 D
{ 0x212E, "PDATA"  }, //  85 D
{ 0x2252, "PURGES" }, //  86 C
{ 0x229F, "DOLFCR" }, //  87 D
{ 0x22A2, "PUSP"   }, //  88 P
{ 0x22B8, "PRNTLL" }, //  89 C
{ 0x249B, "PRNTD6" }, //  90 C
{ 0x24C5, "SENDIT" }, //  91 C
{ 0x254B, "INON"   }, //  92 D
{ 0x2634, "ERWAIT" }, //  93 D
{ 0x2F4C, "ERR2"   }, //  94 C
{ 0x3066, "COMN3"  }, //  95 C
{ 0x30B5, "INCSP2" }, //  96 C
{ 0x30D7, "SP"     }, //  97 D
{ 0x334E, "CTEMP"  }, //  98 D
{ 0x3DF7, "BTODS"  }, //  99 C
{ 0x3E06, "BTOD2"  }, // 100 C
{ 0x3E34, "BDS"    }, // 101 C
{ 0x3E37, "BASIC2" }, // 102 C
{ 0x3E40, "PURGET" }, // 103 C
{ 0x3FE2, "NEWC3"  }, // 104 C
{ 0x3FE7, "NEWC3A" }, // 105 C
{ 0x3FEA, "NEWC3B" }, // 106 C
{ 0x3FEB, "NEWC4"  }, // 107 C
{ 0x3FEE, "NEWC5"  }, // 108 C
{ 0x3FF5, "NEWC6"  }, // 109 C
{ 0x4591, "ERASE"  }, // 110 C
{ 0x4A7F, "DISP"   }, // 111 C
{ 0x51FC, "AOK"    }, // 112 C
// Hangman (CD2650)
{ 0x1510, "SETUP"  }, // 113 C
{ 0x1517, "L1"     }, // 114 C
{ 0x152D, "L2"     }, // 115 C
{ 0x1538, "WDSET"  }, // 116 C
{ 0x153D, "WDIN"   }, // 117 C
{ 0x155A, "L3"     }, // 118 C
{ 0x156B, "L4"     }, // 119 C
{ 0x1576, "START"  }, // 120 C
{ 0x157C, "TURN"   }, // 121 C
{ 0x1594, "CNTDN"  }, // 122 C
{ 0x1599, "WRONG"  }, // 123 C
{ 0x159E, "DEL"    }, // 124 C
{ 0x159F, "PRAYS"  }, // 125 C
{ 0x15C1, "L5"     }, // 126 C
{ 0x15C6, "PRAY"   }, // 127 C
{ 0x15CB, "L6"     }, // 128 C
{ 0x15D5, "PGSS"   }, // 129 C
{ 0x15D7, "L7"     }, // 130 C
{ 0x15E2, "CONT1"  }, // 131 C
{ 0x15EC, "L8"     }, // 132 C
{ 0x15F7, "CONT2"  }, // 133 C
{ 0x15F8, "CKARY"  }, // 134 C
{ 0x15FE, "L9"     }, // 135 C
{ 0x1609, "CONT3"  }, // 136 C
{ 0x160C, "WINCK"  }, // 137 C
{ 0x160F, "L10"    }, // 138 C
{ 0x161C, "LOSE"   }, // 139 C
{ 0x1621, "L11"    }, // 140 C
{ 0x162C, "CONT4"  }, // 141 C
{ 0x1631, "L12"    }, // 142 C
{ 0x163A, "OUT"    }, // 143 C
{ 0x163F, "L13"    }, // 144 C
{ 0x164A, "CONT5"  }, // 145 C
{ 0x1650, "WIN"    }, // 146 C
{ 0x1655, "L14"    }, // 147 C
{ 0x1660, "CONT6"  }, // 148 C
{ 0x1662, "HDNG"   }, // 149 C
{ 0x1700, "MSG1"   }, // 150 D
{ 0x1735, "MSG2"   }, // 151 D
{ 0x176A, "MSG3"   }, // 152 D
{ 0x1773, "MSG4"   }, // 153 D
{ 0x177B, "MSG5"   }, // 154 D
{ 0x1794, "MSG6"   }, // 155 D
{ 0x179C, "MSG7"   }, // 156 D
{ 0x17B7, "WDCNT"  }, // 157 D
{ 0x17B8, "GSCNT"  }, // 158 D
{ 0x17B9, "ARY1"   }, // 159 D
{ 0x17CD, "ARY2"   }, // 160 D
// Memory Test (CD2650)
{ 0x1512, "STARTT" }, // 161 C
{ 0x1513, "ENDT"   }, // 162 C
{ 0x1514, "START"  }, // 163 C
{ 0x151A, "STRT"   }, // 164 C
{ 0x1523, "WRT"    }, // 165 C
{ 0x1526, "WSTL"   }, // 166 C
{ 0x1528, "WRTLP"  }, // 167 C
{ 0x1531, "WTSKP"  }, // 168 C
{ 0x1548, "RAMPTR" }, // 169 D
{ 0x154A, "RD"     }, // 170 C
{ 0x154C, "RSTL"   }, // 171 C
{ 0x154E, "RDLP"   }, // 172 C
{ 0x155A, "RDSKP"  }, // 173 C
{ 0x1573, "TMP0"   }, // 174 D
{ 0x1577, "ERROR"  }, // 175 C
// Morse Code (CD2650)
{ 0x3500, "START"  }, // 176 C
{ 0x3502, "TIME1"  }, // 177 D
{ 0x3503, "TIME2"  }, // 178 D
{ 0x3504, "STRT"   }, // 179 C
{ 0x3523, "RESTRT" }, // 180 C
{ 0x353B, "SENDIT" }, // 181 C
{ 0x3542, "RET"    }, // 182 C
{ 0x3549, "DIT"    }, // 183 C
{ 0x3552, "LOOP1"  }, // 184 C
{ 0x355C, "DAH"    }, // 185 C
{ 0x3563, "LITLOP" }, // 186 C
{ 0x3569, "LOOP2"  }, // 187 C
{ 0x3577, "INC"    }, // 188 C
{ 0x3586, "PTR1"   }, // 189 D
{ 0x3587, "PTR2"   }, // 190 D
{ 0x3588, "TXTPTR" }, // 191 D
{ 0x358A, "TEMP"   }, // 192 D
{ 0x358B, "TEMP2"  }, // 193 D
{ 0x358C, "TEMP3"  }, // 194 D
{ 0x358D, "GETC"   }, // 195 C
{ 0x35B4, "CHECK"  }, // 196 C
{ 0x35BA, "LOOKUP" }, // 197 C
{ 0x35C1, "GAP"    }, // 198 C
{ 0x35C3, "XX"     }, // 199 C
{ 0x35C9, "LOOP3"  }, // 200 C
{ 0x35D0, "PAUSE"  }, // 201 C
{ 0x35D6, "LOOP4"  }, // 202 C
{ 0x35DB, "SPACE"  }, // 203 C
{ 0x35E7, "ENDLIN" }, // 204 C
{ 0x35F3, "ERASE"  }, // 205 C
{ 0x35F5, "LOOP5"  }, // 206 C
{ 0x35FB, "GETIME" }, // 207 C
{ 0x361A, "DELAY"  }, // 208 C
{ 0x361E, "ZZ"     }, // 209 C
{ 0x3627, "PRINT"  }, // 210 C
{ 0x3639, "INFO"   }, // 211 D
{ 0x3692, "TABLE"  }, // 212 D
// TV Typewriter
{ 0x1600, "TVT"    }, // 213 C
{ 0x1610, "BACK"   }, // 214 C
// TV Typewriter with Scrolling
{ 0x1600, "TVT"    }, // 215 C
{ 0x1614, "BACK"   }, // 216 C
{ 0x1632, "SCROLL" }, // 217 C
{ 0x164F, "LOOPB"  }, // 218 C
{ 0x1653, "LOOPA"  }, // 219 C
{ 0x1673, "RETN"   }, // 220 C
{ 0x1674, "SA"     }, // 221 D
{ 0x1676, "SB"     }, // 222 D
// Backup
{ 0x1510, "BEGIN"  }, // 223 C
{ 0x152D, "MS01"   }, // 224 C
{ 0x152F, "MS01A"  }, // 225 C
{ 0x153A, "INPUT"  }, // 226 C
{ 0x1540, "MS02"   }, // 227 C
{ 0x1545, "MS02A"  }, // 228 C
{ 0x1550, "GO"     }, // 229 C
{ 0x1558, "DL2"    }, // 230 C
{ 0x155A, "DL3"    }, // 231 C
{ 0x1566, "START"  }, // 232 C
{ 0x156B, "MS03A"  }, // 233 C
{ 0x1576, "STR1"   }, // 234 C
{ 0x15B6, "MS04"   }, // 235 C
{ 0x15C1, "STOP"   }, // 236 C
// Linearisatie (PIPBUG)
{ 0x6D00, "PRO1"   }, // 237 C
{ 0x6D22, "PRO2"   }, // 238 C
{ 0x6D44, "INL"    }, // 239 C
{ 0x6D46, "INL1"   }, // 240 C
{ 0x6D4C, "WAIT"   }, // 241 C
{ 0x6D58, "INL2"   }, // 242 C
{ 0x6D98, "TAB1"   }, // 243 C
{ 0x6D9C, "TAB2"   }, // 244 C
{ 0x6DC4, "CORR"   }, // 245 C
{ 0x6DE4, "COR1"   }, // 246 C
{ 0x6E05, "SUB1"   }, // 247 C
{ 0x6E3F, "SUB2"   }, // 248 C
{ 0x6E65, "FOUT"   }, // 249 C
{ 0x6E8D, "COR2"   }, // 250 C
{ 0x6EB2, "UITV"   }, // 251 C
{ 0x6F87, "LODU"   }, // 252 C
{ 0x6FA0, "LODV"   }, // 253 C
{ 0x6FB9, "ZIZO"   }, // 254 C
{ 0x70B7, "LODX"   }, // 255 C
{ 0x70D0, "LODY"   }, // 256 C
{ 0x70E9, "FORM"   }, // 257 C (conflicts with PIPBUG BIOS FORM!)
{ 0x70F0, "LUS1"   }, // 258 C
{ 0x7103, "LUSN"   }, // 259 C
{ 0x711A, "LUS2"   }, // 260 C
{ 0x7126, "POS"    }, // 261 C
{ 0x7132, "LUS3"   }, // 262 C
{ 0x713E, "TYPE"   }, // 263 C
{ 0x714B, "SAMP"   }, // 264 C
{ 0x7158, "CONX"   }, // 265 C
{ 0x715A, "CON"    }, // 266 C
{ 0x7169, "CONY"   }, // 267 C
{ 0x716D, "CONU"   }, // 268 C
{ 0x7171, "CONV"   }, // 269 C
{ 0x7175, "OUT"    }, // 270 C
{ 0x71A2, "TEXT"   }, // 271 C
{ 0x71A4, "LP1"    }, // 272 C
{ 0x71AE, "VIS"    }, // 273 C
{ 0x71BE, "NIN"    }, // 274 C
{ 0x71C6, "SMPY"   }, // 275 C
{ 0x71D1, "LO00"   }, // 276 C
{ 0x71DE, "LOC1"   }, // 277 C
{ 0x71E0, "LOC2"   }, // 278 C
{ 0x71EB, "LOC4"   }, // 279 C
{ 0x71ED, "LOC5"   }, // 280 C
{ 0x71F9, "TXT",   }, // 281 D
{ 0x7246, "PE",    }, // 282 D
{ 0x7249, "Q",     }, // 283 D
{ 0x724B, "FP",    }, // 284 D
{ 0x724D, "ITER"   }, // 285 D
{ 0x724E, "ALFA"   }, // 286 D
{ 0x724F, "BETA"   }, // 287 D
{ 0x7250, "AREA"   }, // 288 D
{ 0x7251, "F"      }, // 289 D
{ 0x7255, "FXH"    }, // 290 D
{ 0x7355, "FXL"    }, // 291 D
{ 0x7455, "FYH"    }, // 292 D
{ 0x7555, "FYL"    }, // 293 D
{ 0x7655, "FUH"    }, // 294 D
{ 0x7755, "FUL"    }, // 295 D
{ 0x7855, "FVH"    }, // 296 D
{ 0x7955, "FVL"    }, // 297 D
{ 0x7A55, "A"      }, // 298 D
{ 0x7A56, "B"      }, // 299 D
{ 0x7A57, "PUNT"   }, // 300 D
{ 0x7A58, "X"      }, // 301 D
{ 0x7A5A, "Y"      }, // 302 D
{ 0x7A5C, "U"      }, // 303 D
{ 0x7A5E, "V"      }, // 304 D
{ 0x7A60, "OPR1"   }, // 305 D
{ 0x7A62, "OPR2"   }, // 306 D
{ 0x7A63, "RSLT"   }, // 307 D
// Editor/Assembler (CD2650)
{ 0x0E3A, "ERRS"   }, // 308 D
{ 0x2004, "TABLE"  }, // 309 D
{ 0x20D7, "EDITOR" }, // 310 C
{ 0x20DD, "RETURN" }, // 311 C
{ 0x2657, "PAUSE"  }, // 312 C
{ 0x2F04, "PASS2"  }, // 313 C
// Frogger 1.25 (Arcadia)
{    0x4, "BOOT"           }, // 314 C
{    0xD, "BOOT_1"         }, // 315 C
{   0x11, "BOOT_2"         }, //     C
{   0x16, "BOOT_3"         }, //     C
{   0x3A, "BOOT_4"         }, //     C
{   0x45, "NEWGAME"        }, //     C
{   0xAE, "HANGON"         }, // 320 C
{   0xB7, "HANGON_1"       }, //     C
{   0xC0, "MAINLOOP"       }, //     C
{  0x10E, "THIS"           }, //     C
{  0x120, "THIS_1"         }, //     C
{  0x122, "THIS_2"         }, // 325 C
{  0x12C, "THIS_3"         }, //     C
{  0x136, "WAITVBL"        }, //     C
{  0x1B9, "WAITVBL_2"      }, //     C
{  0x22E, "WAITVBL_3"      }, //     C
{  0x2AB, "WAITVBL_4"      }, // 330 C
{  0x328, "WAITVBL_5"      }, //     C
{  0x39D, "WAITVBL_6"      }, //     C
{  0x3AA, "WAITVBL_7"      }, //     C
{  0x424, "WAITVBL_8"      }, //     C
{  0x499, "WAITVBL_9"      }, // 335 C
{  0x50E, "WAITVBL_10"     }, //     C
{  0x583, "WAITVBL_11"     }, //     C
{  0x5F8, "WAITVBL_12"     }, //     C
{  0x605, "WAITVBL_13"     }, //     C
{  0x60E, "WAITVBL_14"     }, // 340 C
{  0x653, "COLLIDECHECK"   }, //     C
{  0x660, "COLLIDECHECK_1" }, //     C
{  0x67A, "SOUTH"          }, //     C
{  0x685, "MOVEX"          }, //     C
{  0x695, "MOVEX_1"        }, // 345 C
{  0x6A5, "MOVEX_2"        }, //     C
{  0x6B4, "MOVEY"          }, //     C
{  0x6C4, "MOVEY_1"        }, //     C
{  0x6DB, "FROGRT"         }, //     C
{  0x6F2, "FROGRT_END"     }, // 350 C
{  0x6F3, "FROGLT"         }, //     C
{  0x70A, "FROGLT_END"     }, //     C
{  0x70B, "LADYRT"         }, //     C
{  0x71E, "KILLLADY"       }, //     C
{  0x72D, "FAST"           }, // 355 C
{  0x755, "LADYFAST_END"   }, //     C
{  0x756, "COPYFASTRT"     }, //     C
{  0x75C, "MEDIUM"         }, //     C
{  0x7A0, "LADYMED_END"    }, //     C
{  0x7A1, "COPYMEDLT"      }, // 360 C
{  0x7A7, "COPYMEDRT"      }, //     C
{  0x7AD, "SLOW"           }, //     C
{  0x7E1, "LADYSLOW_END"   }, //     C
{  0x7E2, "COPYSLOWLT"     }, //     C
{  0x7E8, "COPYSLOWRT"     }, // 365 C
{  0x7EE, "MOVEUP"         }, //     C
{  0x808, "MOVEUP_1"       }, //     C
{  0x81C, "MOVEUP_2"       }, //     C
{  0x81D, "MOVEUP_3"       }, //     C
{  0x83F, "PUTFROG_1"      }, // 370 C
{  0x84B, "NOTHOME"        }, //     C
{  0x86A, "PUTFROG_2"      }, //     C
{  0x876, "NOTHOME_1"      }, //     C
{  0x895, "PUTFROG_3"      }, //     C
{  0x8A1, "NOTHOME_2"      }, // 375 C
{  0x8C0, "PUTFROG_4"      }, //     C
{  0x8CC, "NOTHOME_3"      }, //     C
{  0x8EB, "PUTFROG_5"      }, //     C
{  0x8F7, "NOTHOME_4"      }, //     C
{  0x8FB, "MOVEDOWN"       }, // 380 C
{  0x915, "MOVEDOWN_1"     }, //     C
{  0x919, "MOVELT"         }, //     C
{  0x933, "MOVELT_1"       }, //     C
{  0x937, "MOVERT"         }, //     C
{  0x951, "MOVERT_1"       }, // 385 C
{  0x955, "DECTIME"        }, //     C
{  0x961, "DECTIME_1"      }, //     C
{  0x97E, "NEXT"           }, //     C
{  0x9BD, "PUTFLY_1"       }, //     C
{  0x9FB, "PUTFLY_1ST"     }, // 390 C
{  0x9B0, "MAKECROC"       }, //     C
{  0xA0C, "PUTFLY_2ND"     }, //     C
{  0xA1D, "PUTFLY_3RD"     }, //     C
{  0xA2E, "PUTFLY_4TH"     }, //     C
{  0xA3E, "DECTIME_END"    }, // 395 C
{  0xA3F, "KILLFLY"        }, //     C
{  0xA53, "DRAWSCREEN"     }, //     C
{  0xA55, "DRAWSCREEN_1"   }, //     C
{  0xA5F, "DRAWSCREEN_2"   }, //     C
{  0xA69, "DRAWSCREEN_3"   }, // 400 C
{  0xA72, "DIEROUTINE"     }, //     C
{  0xA74, "DIEROUTINE_2"   }, //     C
{  0xA89, "DIEROUTINE_3"   }, //     C
{  0xA97, "DIEROUTINE_4"   }, //     C
{  0xAA5, "DIEROUTINE_5"   }, // 405 C
{  0xAB1, "DIEROUTINE_END" }, //     C
{  0xAB5, "GAMEOVER"       }, //     C
{  0xAB7, "GAMEOVER_1"     }, //     C
{  0xABF, "TITLESCREEN"    }, //     C
{  0xACD, "TITLESCREEN_1"  }, // 410 C
{  0xAE5, "GAMEOVERDATA"   }, //     D
{  0xAEF, "FROGGERDATA"    }, //     D
{  0xAF7, "LIVEROUTINE"    }, //     C
{  0xB0E, "LIVEROUTINE_1"  }, //     C
{  0xB4A, "LIVEROUTINE_2"  }, // 415 C
{  0xB56, "LIVEROUTINE_3"  }, //     C
{  0xB62, "LIVEROUTINE_4"  }, //     C
{  0xB87, "LIVEROUTINE_5"  }, //     C
{  0xBAA, "LIVEROUTINE_END"}, //     C
{  0xBAB, "PRINTTIME"      }, // 420 C
{  0xBC4, "ADDSCORE"       }, //     C
{  0xBFF, "ADDSCORE_2"     }, //     C
{  0xC0D, "ADDSCORE_3"     }, //     C
{  0xC12, "ADDSCORE_4"     }, //     C
{  0xC15, "PRINTSCORE"     }, // 425 C
{  0xC45, "SCREENDATA"     }, //     D
{  0xD15, "UDCDATA"        }, //     D
{  0xD35, "LILIESDATA"     }, //     D
{  0xD65, "DEADDATA"       }, //     D
{  0xD6D, "SPRITEDATA"     }, // 430 D
{  0xD85, "FLYDATA"        }, //     D
{  0xD8D, "CROCDATA"       }, //     D
{  0xD95, "SOUND_MOVE"     }, //     C
{  0xDAB, "SOUND_HOME"     }, //     C
{  0xDBC, "SOUND_HOME_1"   }, // 435 C
{  0xDC7, "SOUND_HOME_2"   }, //     C
{  0xDDF, "TENSLOOP"       }, //     C
{  0xDE6, "TENSDONE"       }, //     C
{  0xDED, "ONESLOOP"       }, //     C
{  0xDF4, "ONESDONE"       }, // 440 C
{  0xE03, "SOUND_HOME_END" }, //     C
{  0xE04, "SOUND_DIE"      }, //     C
{  0xE0E, "SOUND_DIE_1"    }, //     C
{  0xE13, "SOUND_DIE_2"    }, //     C
{  0xE38, "MAKEFLY"        }, // 445 C
{  0xE48, "MAKELADY"       }, //     C
{  0xE88, "MAKELADY_3RDROW"}, //     C
{  0xE98, "MAKELADY_4THROW"}, //     C
{  0xEA1, "MAKELADY_OK"    }, //     C
{  0xEAB, "MAKELADY_END"   }, // 450 C
{  0xEAC, "MOVESNAKE"      }, //     C
{  0xEB7, "MOVESNAKE_1"    }, //     C
{  0xEDE, "MOVESNAKE_2"    }, //     C
{  0xEE7, "SNAKEDATA_1"    }, //     D
{  0xEE8, "SNAKEDATA_2"    }, // 455 D
{  0xEE9, "SNAKEDATA_3"    }, //     D
{ 0x18D1, "FASTRTPOS"      }, //     D
{ 0x18D3, "MONOTONIC"      }, //     D
{ 0x18D4, "MEDLTPOS"       }, //     D
{ 0x18D5, "MEDRTPOS"       }, // 460 D
{ 0x18D6, "SLOWLTPOS"      }, //     D
{ 0x18D7, "SLOWRTPOS"      }, //     D
{ 0x18D8, "P1PADDLECOPY"   }, //     D
{ 0x18D9, "FRAME"          }, //     D
{ 0x18DA, "LILYFRAME"      }, // 465 D
{ 0x18DE, "SLOWNUM"        }, //     D
{ 0x18DF, "MEDNUM"         }, //     D
{ 0x18E0, "FASTNUM"        }, //     D
{ 0x18E1, "TIME"           }, //     D
{ 0x18E2, "FLYX"           }, // 470 D
{ 0x18E3, "MOVES"          }, //     D
{ 0x18E4, "FLYTIME"        }, //     D
{ 0x18E5, "CROCFLAG"       }, //     D
{ 0x18E6, "SCORE_H"        }, //     D
{ 0x18E7, "SCORE_L"        }, // 475 D
{ 0x18E8, "FURTHEST"       }, //     D
{ 0x18E9, "LADY"           }, //     D
{ 0x18EA, "EXTRALIFE"      }, //     D
{ 0x18EB, "KEYS1"          }, //     D
{ 0x18EC, "KEYS2"          }, // 480 D
{ 0x18ED, "KEYS3"          }, //     D
{ 0x18EE, "LADYROW"        }, //     D
{ 0x18EF, "LEVEL"          }, //     D
{ 0x18F8, "SNAKEDIR"       }, //     D
{ 0x18F9, "SNAKEFRAME"     }, // 485 D
{ 0x18FA, "SPRCOLLIDECOPY" }, //     D
{ 0x18FB, "BGCOLLIDECOPY"  }, //     D
{ 0x1A00, "SLOWTICKER"     }, //     D
{ 0x1A01, "MEDIUMTICKER"   }, //     D
{ 0x1A02, "FASTTICKER"     }, // 490 D
{ 0x1A03, "FRESHMEDRT"     }, //     D
{ 0x1A04, "FRESHMEDLT"     }, //     D
{ 0x1A05, "FRESHFASTRT"    }, //     D
{ 0x1A06, "FRESHSLOWRT"    }, //     D
{ 0x1A07, "FRESHSLOWLT"    }, // 495 D
// JTron 1.21 (Arcadia)
{    0x4, "BOOT"           }, // 496 C
{    0xD, "BOOT_1"         }, //     C
{   0x11, "BOOT_2"         }, //     C
{   0x16, "BOOT_3"         }, //     C
{   0x4B, "PRINTTEXT"      }, // 500 C
{   0x5A, "WAITKEY"        }, //     C
{   0x7E, "NEWGAME"        }, //     C
{   0xB2, "LOOP"           }, //     C
{   0xE1, "NOTYET"         }, //     C
{  0x11D, "LOOP_1"         }, // 505 C
{  0x11F, "LOOP_2"         }, //     C
{  0x149, "CHECKMOVE"      }, //     C
{  0x151, "CHECKLEFT"      }, //     C
{  0x178, "NOLEFT"         }, //     C
{  0x17B, "CHECKRIGHT"     }, // 510 C
{  0x1A2, "NORIGHT"        }, //     C
{  0x1A5, "CHECKUP"        }, //     C
{  0x1CC, "NOUP"           }, //     C
{  0x1CF, "CHECKDOWN"      }, //     C
{  0x1F6, "NODOWN"         }, // 515 C
{  0x1F9, "WAITVBL"        }, //     C
{  0x201, "WAITVBL_1"      }, //     C
{  0x217, "GAMEOVER"       }, //     C
{  0x241, "GAMEOVER_1"     }, //     C
{  0x221, "BETTER"         }, // 520 C
{  0x233, "WORSE"          }, //     C
{  0x236, "EQUAL"          }, //     C
{  0x247, "SADSOUND"       }, //     C
{  0x24E, "SADSOUND_1"     }, //     C
{  0x253, "SADSOUND_2"     }, // 525 C
{  0x261, "HAPPYSOUND"     }, //     C
{  0x268, "HAPPYSOUND_1"   }, //     C
{  0x26D, "HAPPYSOUND_2"   }, //     C
{  0x277, "GETPIXEL"       }, //     C
{  0x27E, "SETPIXEL"       }, // 530 C
{  0x28C, "CONVERT"        }, //     C
{  0x2A0, "CONVERTUPPER"   }, //     C
{  0x2A2, "CONVERT_1"      }, //     C
{  0x2BD, "CONVERT_2"      }, //     C
{  0x2D0, "XTABLE1"        }, // 535 D
{  0x2FC, "XTABLE2"        }, //     D
{  0x328, "YTABLE1"        }, //     D
{  0x359, "HIGHBYTE"       }, //     C
{  0x366, "SHOWHIGHBYTE"   }, //     C
{  0x37F, "SHOWLOWBYTE"    }, // 540 C
{  0x398, "CLEARSCREEN"    }, //     C
{  0x39B, "CLEARSCREEN_1"  }, //     C
{  0x3A9, "DRAWFIELD"      }, //     C
{  0x3B5, "DRAWFIELD_1"    }, //     C
{  0x3C5, "DRAWFIELD_2"    }, // 545 C
{  0x3DB, "PRINTHIGHSCORE" }, //     C
{  0x40C, "PUTGEM"         }, //     C
{  0x418, "PUTGEM_1"       }, //     C
{  0x420, "PUTGEM_2"       }, //     C
{  0x431, "PUTGEM_3"       }, // 550 C
{  0x439, "PUTGEM_4"       }, //     C
{  0x45F, "PUTGEM_5"       }, //     C
{  0x487, "PUTGEM_6"       }, //     C
{  0x489, "PUTGEM_7"       }, //     C
{  0x49B, "CHECKGEM"       }, // 555 C
{  0x4A9, "CHECKGEM_1"     }, //     C
{  0x4B2, "CHECKGEM_2"     }, //     C
{  0x4C7, "CHECKGEM_3"     }, //     C
{  0x4CB, "TEXT"           }, //     D
{  0x50C, "GEMPOS"         }, // 560 D
{  0x53A, "GEMSIZE"        }, //     D
{ 0x18D0, "JTRONX"         }, //     D
{ 0x18D1, "JTRONY"         }, //     D
{ 0x18D2, "ARCADIAX"       }, //     D
{ 0x18D4, "OFFSET"         }, // 565 D
{ 0x18D5, "BITOFFSET"      }, //     D
{ 0x18D6, "PLAYERX"        }, //     D
{ 0x18D7, "PLAYERY"        }, //     D
{ 0x18D8, "PLAYERXDELTA"   }, //     D
{ 0x18D9, "PLAYERYDELTA"   }, // 570 D
{ 0x18DA, "PTR_B"          }, //     D (duplicate of PTR_H)
{ 0x18DA, "PTR_H"          }, //     D (duplicate of PTR_B)
{ 0x18DC, "MOVED"          }, //     D
{ 0x18DD, "COLOUR"         }, //     D
{ 0x18DE, "SCORE_H"        }, // 575 D
{ 0x18DF, "SCORE_L"        }, //     D
{ 0x18F8, "HIGHSCORE_H"    }, //     D
{ 0x18F9, "HIGHSCORE_L"    }, //     D
{ 0x18FA, "UPKEY"          }, //     D
{ 0x18FB, "DOWNKEY"        }, // 580 D
{ 0x1AD0, "LEFTKEY"        }, //     D
{ 0x1AD1, "RIGHTKEY"       }, //     D
{ 0x1AD2, "GEMX"           }, //     D
{ 0x1AD3, "GEMY"           }, //     D
{ 0x1AD4, "GEMFLAG"        }, // 585 D
{ 0x1AD5, "MONOTONIC"      }, //     D
{ 0x1AD6, "NEXTLEVEL"      }, // 587 D
// Breakaway (Arcadia)
{  0x03F, "MAINLOOP"       }, // 588 C
{  0x0EF, "CHECKUPDATE"    }, //     C
{  0x10E, "COUNTDOWN"      }, // 590 C
{  0x230, "COLLIDE"        }, //     C
{  0x320, "CANCEL_YMOVE"   }, //     C
{  0x327, "CANCEL_XMOVE"   }, //     C
{  0x3C2, "MOVEBALL_SPECIAL"},//     C
{  0x433, "MOVE_BALL"      }, // 595 C
{  0x475, "MOVE"           }, //     C
{  0x5B7, "FORCE_R0_IN_35_A0"},//    C
{  0x5D7, "MOVE_BAT"       }, //     C
{  0x6F8, "DRAWBALLLOWERHALF"},//    C
{  0x6BA, "INCSCORE"       }, // 600 C
{  0x786, "DRAWBALL"       }, //     C
{  0x9FA, "SCREENHITOMEM"  }, //     C
{  0xA05, "INITIALISE"     }, //     C
{  0xA2A, "LOADGRAPHICS"   }, //     C
{  0xA3A, "MEMHITOSCREEN"  }, // 605 C
{  0xA98, "BUILDDISPLAY"   }, //     C
{  0xBD0, "WHEE_NOISE"     }, //     C
{  0xCD0, "BUMP_CLOCK"     }, //     C
{  0xFD0, "GAMEOVER"       }, //     C
{ 0x18D3, "TIMEOUT"        }, // 610 D
{ 0x18D7, "NEWX"           }, //     D
{ 0x18D8, "NEWY"           }, //     D
{ 0x18D9, "OLDBATX"        }, //     D
{ 0x18DA, "TIMEENDCTR"     }, //     D
{ 0x18E0, "FIRE_1"         }, // 615 D
{ 0x18E1, "FIRE_2"         }, //     D
{ 0x18E9, "VGAME_COLLSIDE" }, //     D
{ 0x18EC, "DIRECTION"      }, //     D
{ 0x18ED, "BALLY_OLD"      }, //     D
{ 0x18EE, "BALLX_OLD"      }, // 620 D
{ 0x18EF, "GAME_IN_PLAY"   }, //     D
{ 0x18F2, "BALLY"          }, //     D
{ 0x18F3, "BALLX"          }, //     D
{ 0x18F4, "BATY"           }, //     D
{ 0x18F5, "BATX"           }, // 625 D
{ 0x18F6, "BATY2"          }, //     D
{ 0x18F7, "BATX2"          }, //     D
{ 0x18F8, "CLOCK_L"        }, //     D
{ 0x18F9, "CLOCK_H"        }, //     D
{ 0x1AD0, "DOT_X"          }, // 630 D
{ 0x1AE0, "DOT_Y"          }, //     D
{ 0x1AF4, "COLLISION1"     }, //     D
{ 0x1AF5, "COLLISION2"     }, //     D
{ 0x1AF6, "PADDLE2"        }, //     D
{ 0x1AF7, "PADDLE1"        }, // 635 D
{ 0x1AF8, "HI0"            }, //     D
{ 0x1AF9, "HI1"            }, //     D
{ 0x1AFA, "HI2"            }, //     D
{ 0x1AFB, "HI3"            }, //     D
{ 0x1AFC, "GAMENUMBER"     }, // 640 D
{ 0x1AFD, "BATSIZE"        }, // 641 D
// Testez vos Reflexes (Dolphin)
{    0x0, "REFL1"          }, // 642
{    0x4, "REFL2"          },
{   0x11, "REFL3"          },
{   0x15, "REFL4"          }, // 645
{   0x17, "REFL5"          },
{   0x23, "REFL6"          },
{   0x27, "REFL7"          },
{   0x2F, "REFL8"          },
{   0x3F, "REFL9"          }, // 650
{   0x47, "REFL10"         },
{   0x49, "REFL11"         },
{   0x61, "REFL12"         },
{   0x67, "REFL13"         }  // 654
};

EXPORT const STRPTR asciiname[32] =
{   "NUL", // $00 NULl
    "SOH", // $01 Start Of Heading
    "STX", // $02 Start of TeXt
    "ETX", // $03 End of TeXt
    "EOT", // $04 End Of Transmission
    "ENQ", // $05 ENQuiry
    "ACK", // $06 ACKnowledge
    "BEL", // $07 BELl
    "BS",  // $08 BackSpace
    "HT",  // $09 Horizontal Tab
    "LF",  // $0A Line Feed
    "VT",  // $0B Vertical Tab
    "FF",  // $0C Form Feed
    "CR",  // $0D Carriage Return
    "SO",  // $0E Shift Out
    "SI",  // $0F Shift In
    "DLE", // $10 Data Link Escape
    "DC1", // $11 Device Control 1
    "DC2", // $12 Device Control 2
    "DC3", // $13 Device Control 3
    "DC4", // $14 Device Control 4
    "NAK", // $15 Negative AcKnowledge
    "SYN", // $16 SYNchonous idle
    "ETB", // $17 End of Transmission Block
    "CAN", // $18 CANcel
    "EM",  // $19 End of Medium
    "SUB", // $1A SUBstitute
    "ESC", // $1B ESCape
    "FS",  // $1C File Separator
    "GS",  // $1D Group Separator
    "RS",  // $1E Record Separator
    "US"   // $1F Unit Separator
};

/* CD32 gamepads are like this:

Red    = Select  = 1st = bottom left     GY
Blue   = Stop    = 2nd = bottom right    RB
Yellow = Repeat  = 3rd = top    right
Green  = Shuffle = 4th = top    left

Known:
 all dumped ROMs, good and bad, including overdumps
 enhanced versions of games
 non-obsolete compatibility-patched versions of games
 latest versions of homebrew games
 latest versions of homebrew examples
 available older versions of homebrews
 ESS software (games and utilities)
 TVGC book programs
 obsolete compatibility-patched versions of games
  (except unavailable older versions thereof)
not known:
 trimmed dumps
 unavailable older versions of homebrews
 trimmed/overdumped homebrews

The .machine element of this array is redundant, as it can be derived
from the .memmap element.
*/
