#include <windows.h>

#include "ibm.h"
#include "aa.h"

#include "sapi.h"

EXPORT       int         speakable        = FALSE;

MODULE       ISpVoice*   gpIVTxt          = NULL;

IMPORT       int         consoleopen,
                         usespeech;
IMPORT const char        g_szClassName[];
IMPORT       UBYTE       SpeakBuffer[80 + 1];

EXPORT void speech_init(void)
{   if
    (   FAILED(CoInitialize(NULL))
     || FAILED(CoCreateInstance
        (   (REFCLSID) &CLSID_SpVoice,
            NULL,
            CLSCTX_ALL,
            (REFIID) &IID_ISpVoice,
            (LPVOID *) &gpIVTxt
    )   ))
    {   usespeech = FALSE;
        // no window open at this point, so don't call updatemenu()
        return;
    }
   
    speakable = TRUE;
}

EXPORT void speech_die(void)
{   if (gpIVTxt)
    {   gpIVTxt->lpVtbl->Release(gpIVTxt);
	    gpIVTxt = NULL;
    }
    CoUninitialize(); // is this safe even if CoInitialize() failed?
}

EXPORT void speak(void)
{   PERSIST unsigned short UnicodeSpeakBuffer[80 + 1];

    // assert(speakable);
    DISCARD MultiByteToWideChar(CP_ACP, MB_PRECOMPOSED, SpeakBuffer, -1, UnicodeSpeakBuffer, 80); // or should we use 81?
    gpIVTxt->lpVtbl->Speak(gpIVTxt, UnicodeSpeakBuffer, SVSFlagsAsync, NULL);
}
