#define DEF_DN 1 // was  4
#define DEF_TO 2 // was 16

/* 0 = don't multiplex      (1)
   1 = repeat last frame    (1:1)
   2 = repeat last 2 frames (1:1:1 or 2:2)
   3 = repeat last 3 frames (1:1:1:1)
   5 = repeat last 5 frames */

// Games marked with '!' require correct positional layout of joypad buttons, as indicated.
// IBM interprets & as underliner, so we use + instead.
EXPORT const struct KnownStruct known[KNOWNGAMES] = {
                                                      // lt  dn  rt  up  up  dn  lt  rt                                                                                                                              01 02 03 12 13 23   b0 b1 b2 b3   01 02 03 12 13 23 b0 b1 b2 b3
  { ARCADIA , MEMMAP_I,       0xA23C7A01,  6 * KILOBYTE,  2,  4,  0, 10, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "golf",     "Golf"                                           , "UA Ltd., 198x"                              , "MPT-03 MG-324",                                    22, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // GOLF (must be at GOLFPOS, and memmap must be MEMMAP_I!)
  { ARCADIA , MEMMAP_ARCADIA, 0xB0B98A92,  4 * KILOBYTE,  2,  5,  8,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "soccer",   "Soccer"                                         , "UA Ltd., 1982"                              , "Emerson #16 (#1005)",                              31, 33,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // 2DSOCCER
  { ARCADIA , MEMMAP_ARCADIA, 0x4DA68DF8,  8 * KILOBYTE,  2,  5,  8,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, TRUE,  TRUE , 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "3dsoccer", "3D Soccer (Emerson version?)"                   , "UA Ltd., 1983"                              , "Emerson? #? (#?)",                                128,  0,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // 3DSOCCEA
  { ARCADIA , MEMMAP_ARCADIA, 0x1B5BE22A,  8 * KILOBYTE,  2,  5,  8,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, TRUE,  TRUE , 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "3dsoccer", "3D Soccer (Tele-Fever version)"                 , "UA Ltd., 1983"                              , "Tele-Fever #?",                                   129,  0,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // 3DSOCCEB
  { ARCADIA , MEMMAP_ARCADIA, 0x1F65B21E,  4 * KILOBYTE,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,         1,     16,                0,       0,          0, 0, DUMP_GOOD,   { 0,25, 0,25, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "alieninv", "Alien Invaders"                                 , "UA Ltd., 1982"                              , "Emerson #8 (#1003)",                               28,  1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // ALIENINV
  { ARCADIA , MEMMAP_ARCADIA, 0xDDCF5B2C,  4 * KILOBYTE,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT, 0x50 | 3, FALSE, TRUE , BLACK,      1,      2,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0,25, 0},{ 0,25, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "astroinv", "Astro Invader"                                  , "UA Ltd., 1982"                              , "Emerson? #? (#?)",                                 12,  3,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // ASTROINV
  { ARCADIA , MEMMAP_ARCADIA, 0x99AC48CA,  4 * KILOBYTE,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 1, 1, 1, 0, 0, 0},{ 0, 0, 0, 0},{ 1, 0, 0, 1, 1, 0},{ 0, 0, 0, 0}, "autorace", "Auto Race"                                      , "UA Ltd., 198x"                              , "MPT-03 MG-320",                                   130, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // AUTORACE
  { ARCADIA , MEMMAP_ARCADIA, 0x1CF08155,  4 * KILOBYTE, 10, 11,  0,  5, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "baseball", "Baseball"                                       , "UA Ltd., 1982"                              , "Emerson #15 (#1004)",                             131,  4,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // BASEBALL
  { ARCADIA , MEMMAP_ARCADIA, 0xE93938F6,  4 * KILOBYTE,  4,  1,  7,  5, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "basketba", "Basketball"                                     , "UA Ltd., 198x"                              , "MPT-03 MG-303",                                    13,  5,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // BASKETBA
  { ARCADIA , MEMMAP_ARCADIA, 0x6818C8BD,  4 * KILOBYTE,  2,  1, 10,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "battle",   "Battle"                                         , "UA Ltd., 198x"                              , "Palladium 775/126",                                16, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // BATTLE
  { ARCADIA , MEMMAP_ARCADIA, 0x0930CE04,  4 * KILOBYTE, 11, 10,  0,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "blackjac", "Blackjack/Poker"                                , "UA Ltd., 1982"                              , "MPT-03 MG-315",                                   132, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // BLACKJAC
  { ARCADIA , MEMMAP_ARCADIA, 0xF3C08E19,  4 * KILOBYTE,  2, 11,  8, 10, 10, 11,  7,  9, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 1, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 1, 0, 0, 0}, "bowling",  "3D Bowling"                                     , "UA Ltd., 198x"                              , "Emerson #13 (#1008)",                               9, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, //!BOWLING
  { ARCADIA , MEMMAP_ARCADIA, 0x9240891B,  4 * KILOBYTE,  2,  7,  9,  1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "boxing",   "Boxing"                                         , "UA Ltd., 198x"                              , "MPT-03 MG-321",                                    17,  6,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // BOXING
  { ARCADIA , MEMMAP_ARCADIA, 0xCA58B3F8,  4 * KILOBYTE,  7,  2,  9,  4,  5,  0,  7,  9, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "brainqui", "Brain Quiz"                                     , "UA Ltd., 1982"                              , "Emerson #6 (#1012)",                              133, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, //!BRAINQUI
  { ARCADIA , MEMMAP_ARCADIA, 0x33C348C1,  4 * KILOBYTE,  0,  5,  2,  5, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   {25, 0, 0,25,25, 0},{ 0,25, 0, 0},{25, 0, 0,25,25, 0},{ 0,25, 0, 0}, "breakawa", "Breakaway"                                      , "UA Ltd., 1982"                              , "Emerson #17 (#1018)",                              18,  7, 588, 641, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // BREAKAWA
  { ARCADIA , MEMMAP_ARCADIA, 0xAEB803E4,  2 * KILOBYTE,  2,  2,  2,  2,  5,  0,  7,  9, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "capture",  "Capture"                                        , "UA Ltd., 1982"                              , "Emerson #19 (#1002)",                              19,  8,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // CAPTURE
  { ARCADIA , MEMMAP_ARCADIA, 0xFD2CF496,  4 * KILOBYTE,  2,  1,  3,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 1, 1, 1, 0, 0, 0},{ 1, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "cattrax",  "Cat Trax"                                       , "UA Ltd., 1982"                              , "Emerson #1 (#1001)",                               20,  9,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // CATTRAX
  { ARCADIA , MEMMAP_ARCADIA, 0x086EBC8C,  4 * KILOBYTE,  2,  2,  2,  2, -1, -1, -1, -1, TRUE , SENSITIVITY_HIGH   ,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 1, 0, 1, 1},{ 0, 0, 0, 1},{ 0, 1, 0, 1, 0, 1},{ 0, 0, 1, 0}, "circus",   "Circus"                                         , "UA Ltd., 1983"                              , "MPT-03 MG-318",                                   134, 10,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // CIRCUS
  { ARCADIA , MEMMAP_ARCADIA, 0xA6BFFA9E,  4 * KILOBYTE,  2,  1, 10, 11, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 1, 1, 1, 0, 0, 0},{ 0, 0, 0, 0},{ 1, 0, 0, 1, 1, 0},{ 0, 0, 0, 0}, "combat",   "Combat"                                         , "UA Ltd., 198x"                              , "MPT-03 MG-314",                                   135, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // COMBAT
  { ARCADIA , MEMMAP_ARCADIA, 0x76E773FA,  4 * KILOBYTE,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, TRUE , TRUE , 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "crazycli", "Crazy Climber"                                  , "UA Ltd., 1982"                              , "Orbit MG-325",                                    136, 11,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // CRAZYCLI
  { ARCADIA , MEMMAP_ARCADIA, 0xE84DF2EF,  2 * KILOBYTE,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, TRUE , TRUE , 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 1, 0, 1, 1},{ 0, 0, 0, 0}, "",         "Crazy Gobbler"                                  , "UA Ltd. (Andrew Choi), 1982"                , "Hanimex #1 (#1020)",                              137, 12,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // CRAZYGOB
  { ARCADIA , MEMMAP_ARCADIA, 0x62C45881,  8 * KILOBYTE,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT, 0xC0 | 3, FALSE, TRUE , 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "doraemon", "Doraemon"                                       , "Bandai, 1983"                               , "Bandai #52",                                      138, 13,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // DORAEMON
  { ARCADIA , MEMMAP_ARCADIA, 0x927C375A,  8 * KILOBYTE,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT, 0xC0 | 2, FALSE, TRUE , 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 1, 1, 1, 1},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "dr-slump", "Dr. Slump"                                      , "Bandai, 1983"                               , "Bandai #51",                                      139, 14,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // DR-SLUMP
  { ARCADIA , MEMMAP_ARCADIA, 0xFC7EBA76,  4 * KILOBYTE,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 1, 0, 1, 0, 1},{ 0, 0, 1, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "escape",   "Escape"                                         , "UA Ltd., 1982"                              , "Emerson #3 (#1015)",                              140, 15,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // ESCAPE
  { ARCADIA , MEMMAP_ARCADIA, 0x77C19320,  8 * KILOBYTE,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT, 0x00 | 1, TRUE , TRUE , 16,         4,      8,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "funkfish", "Funky Fish"                                     , "UA Ltd. (Chris Capener), 1983"              , "Emerson #4 (#1011)",                               21, 17,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // FUNKFISH
  { ARCADIA , MEMMAP_ARCADIA, 0x22624414,  6 * KILOBYTE,  1,  7, 11, 10, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "gridiron", "American Football"                              , "UA Ltd., 1982"                              , "Emerson #14 (#1017)",                              11,  2,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // GRIDIRON
  { ARCADIA , MEMMAP_ARCADIA, 0x1CEC4B21,  8 * KILOBYTE,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, TRUE,  TRUE , 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "hobo",     "Hobo"                                           , "UA Ltd., 1983"                              , "Emerson? #? (#?)",                                141, 19,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // HOBO
  { ARCADIA , MEMMAP_ARCADIA, 0x560DAA7F,  4 * KILOBYTE,  1,  2,  3,  4, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "horserac", "Horse Racing"                                   , "UA Ltd., 198x"                              , "Palladium 775/177",                                25, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // HORSERAC
  { ARCADIA , MEMMAP_ARCADIA, 0x97060A54,  8 * KILOBYTE,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, TRUE , TRUE , BLACK,      1,      2,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 1, 0, 0}, "jumpbug",  "Jump Bug (Emerson? version)"                    , "UA Ltd., 1982"                              , "Emerson? #? (#?)",                                142, 21,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // JUMPBUGA
  { ARCADIA , MEMMAP_ARCADIA, 0xDC0264B8,  8 * KILOBYTE,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, TRUE , TRUE , BLACK,      1,      2,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 1, 0, 0}, "jumpbug",  "Jump Bug (Tele-Fever version)"                  , "UA Ltd., 1982"                              , "Tele-Fever #?",                                   143, 21,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // JUMPBUGB
  { ARCADIA , MEMMAP_ARCADIA, 0xDFB5DD55,  8 * KILOBYTE,  2,  1,  7,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT, 0x70 | 2, FALSE, TRUE , 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "jungler",  "Jungler"                                        , "UA Ltd., 1982"                              , "Emerson #23 (#1023)",                              26, 22,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // JUNGLER
  { ARCADIA , MEMMAP_ARCADIA, 0x4C885AF2,  8 * KILOBYTE,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT, 0xC0 | 5, FALSE, TRUE , 16,         2,      3,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "macross",  "Super Dimension Fortress Macross"               , "Bandai, 1983"                               , "Bandai #53",                                      126, 23,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // MACROSS
  { ARCADIA , MEMMAP_ARCADIA, 0xA615F068,  4 * KILOBYTE,  1,  3,  3,  1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "missilew", "Missile War"                                    , "UA Ltd., 1982"                              , "Emerson #10 (#1010)",                             144, 24,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, //!MISSILEW (2:2:2:2 UDCs) - enemy bullets
  { ARCADIA , MEMMAP_ARCADIA, 0x5E033F9C,  4 * KILOBYTE,  7,  0,  9,  5,  5,  0,  7,  9, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "monaco",   "Monaco Grand Prix"                              , "UA Ltd., 1982"                              , "Palladium 775/096",                                27, 25,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, //!MONACO
  { ARCADIA , MEMMAP_ARCADIA, 0x7832F7AD,  4 * KILOBYTE,  2,  1,  3,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 1, 1, 1, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "nibble",   "Nibblemen"                                      , "UA Ltd., 1982"                              , "Ormatu MG-316",                                    20, 26,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // NIBBLE
  { ARCADIA , MEMMAP_ARCADIA, 0x4F538848,  4 * KILOBYTE,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , BLACK,      1,      3,                0,       0,          0, 0, DUMP_GOOD,   {25,25,25, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "parashoo", "Parashooter"                                    , "UA Ltd., 1982"                              , "Ormatu MG-319",                                   172, 27,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // PARASHOO
  { ARCADIA , MEMMAP_ARCADIA, 0x449E80CB,  4 * KILOBYTE,  2, 10, 11,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   {25,25,25, 0, 0, 0},{ 0, 0, 0, 0},{25, 0, 0,25,25, 0},{ 0, 0, 0, 0}, "oceanbat", "Ocean Battle"                                   , "UA Ltd., 1982"                              , "Emerson #11 (#1009)",                              24, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, //!OCEANBAT (this game supports analog during combat)
  { ARCADIA , MEMMAP_ARCADIA, 0x4F19FD9B,  8 * KILOBYTE,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , BLACK,      1,      2,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "pleiades", "Pleiades"                                       , "UA Ltd., 1983"                              , "Emerson? #? (#?)",                                 29, 28,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // PLEIADES
  { ARCADIA , MEMMAP_ARCADIA, 0xA0626E23,  4 * KILOBYTE,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT, 0xB0 | 2, TRUE , TRUE , 16,         1,      4,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "r2dtank",  "R2D Tank"                                       , "UA Ltd., 1982"                              , "Emerson? #? (#?)",                                 30, 29,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // R2DTANK
  { ARCADIA , MEMMAP_ARCADIA, 0xA06F284B,  4 * KILOBYTE,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT, 0x00 | 1, TRUE , TRUE , BLACK,      1,      2,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "redclash", "Red Clash"                                      , "UA Ltd., 1982"                              , "Emerson #12 (#1020)",                             145, 30,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // REDCLASH
  { ARCADIA , MEMMAP_ARCADIA, 0x4671B7F7,  4 * KILOBYTE,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 1, 0, 1, 0, 1},{ 0, 0, 1, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Robot Killer"                                   , "UA Ltd., 1982"                              , "Emerson? #? (#?)",                                140, 31,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // ROBOTKIL (40)
  { ARCADIA , MEMMAP_ARCADIA, 0x8169864E,  8 * KILOBYTE,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "route16",  "Route 16"                                       , "UA Ltd., 1983"                              , "Emerson? #? (#?)",                                146, 32,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // ROUTE16
  { ARCADIA , MEMMAP_ARCADIA, 0xE3794A2C,  4 * KILOBYTE,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT, 0x30 | 1, TRUE , TRUE , BLACK,      1,      2,                0,       0,          0, 0, DUMP_GOOD,   { 0,25, 0,25, 0,25},{ 0, 0, 0, 0},{ 0,25, 0,25, 0,25},{ 0, 0, 0, 0}, "sattack",  "Space Attack (Emerson version)"                 , "UA Ltd. (Andrew Choi), 1982"                , "Emerson #2 (#1013)",                               32, 34,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // SATTACKA
  { ARCADIA , MEMMAP_ARCADIA, 0x669632EC,  2 * KILOBYTE,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT, 0x30 | 1, TRUE , TRUE , BLACK,      1,      2,                0,       0,          0, 0, DUMP_GOOD,   { 0,25, 0,25, 0,25},{ 0, 0, 0, 0},{ 0,25, 0,25, 0,25},{ 0, 0, 0, 0}, "sattack",  "Space Attack (unknown version)"                 , "UA Ltd. (Andrew Choi), 1982"                , "?",                                                32, 34,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // SATTACKB
  { ARCADIA , MEMMAP_ARCADIA, 0xC91828CB,  2 * KILOBYTE,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT, 0x30 | 1, TRUE , TRUE , BLACK,      1,      2,                0,       0,          0, 0, DUMP_GOOD,   { 0,25, 0,25, 0,25},{ 0, 0, 0, 0},{ 0,25, 0,25, 0,25},{ 0, 0, 0, 0}, "sattack",  "Space War (prototype)"                          , "UA Ltd. (Andrew Choi), 1982"                , "Hanimex #2 (#1016)",                               32, 34,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // SATTACKC
  { ARCADIA , MEMMAP_ARCADIA, 0x3FF224E5,  4 * KILOBYTE,  2,  7,  8,  9, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , BLACK, DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "smission", "Space Mission"                                  , "UA Ltd., 1982"                              , "Emerson #9 (#1019)",                               33, 35,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // SMISSION
  { ARCADIA , MEMMAP_ARCADIA, 0xBB88DAEA,  4 * KILOBYTE,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT, 0x40 | 3, TRUE , TRUE , 16,         1,      2,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0,25,25, 0, 0, 0},{ 0, 0, 0, 0}, "spiders",  "Spiders"                                        , "UA Ltd., 1982"                              , "Emerson #24 (#1024)",                              36, 39,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // SPIDERS
  { ARCADIA , MEMMAP_ARCADIA, 0x88DEFACF,  4 * KILOBYTE,  2,  3,  2,  3, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , BLACK,      1,      2,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "sraiders", "Space Raiders"                                  , "UA Ltd., 1982"                              , "Emerson #5 (#1016)",                               34, 36,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // SRAIDERS (1:1 UDCs) - enemies
  { ARCADIA , MEMMAP_ARCADIA, 0xCAA5F449,  4 * KILOBYTE,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , BLACK,      1,      2,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "ssquadro", "Space Squadron"                                 , "UA Ltd., 1982"                              , "Emerson? #? (#?)",                                127, 37,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // SSQUADRO (1:1 UDCs) - enemies
  { ARCADIA , MEMMAP_ARCADIA, 0x83E6E40B,  4 * KILOBYTE,  4,  2, 10, 11,  5,  0,  7,  9, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , BLACK, DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "starches", "Star Chess"                                     , "UA Ltd., 1982"                              , "Emerson #18 (#1006)",                              37, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // STARCHES
  { ARCADIA , MEMMAP_ARCADIA, 0x08D8B186,  4 * KILOBYTE,  2,  1,  3,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 1, 1, 1, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "nibble",   "Super Gobbler"                                  , "UA Ltd., 1982"                              , "Emerson? #? (#?)",                                 20, 26,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // SUPERGOB (50)
  { ARCADIA , MEMMAP_ARCADIA, 0x7666A712,  6 * KILOBYTE,  2,  1,  2,  1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT, 0x70 | 7, FALSE, TRUE , BLACK,      1,      3,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0,25,25, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "svulture", "Space Vultures"                                 , "UA Ltd., 1982"                              , "Emerson #7 (#1014)",                               35, 38,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // SVULTURE
  { ARCADIA , MEMMAP_ARCADIA, 0x0076422E,  4 * KILOBYTE,  2,  3,  1,  7, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT, 0x70 | 3, FALSE, TRUE , 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   {25, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "tanksalo", "Tanks a Lot"                                    , "UA Ltd., 1982"                              , "Emerson #20 (#1007)",                              38, 42,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // TANKSALO
  { ARCADIA , MEMMAP_ARCADIA, 0x8BF2DFA9,  8 * KILOBYTE,  2,  3,  2,  3, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT, 0x00 | 1, FALSE, TRUE , 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "tennis",   "Grand Slam Tennis"                              , "UA Ltd. (Tom Pittman), 1982"                , "Emerson #21 (#1021)",                              23, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // TENNIS
  { ARCADIA , MEMMAP_ARCADIA, 0xE66F362D,  4 * KILOBYTE,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT, 0x70 | 3, TRUE , TRUE , BLACK,      1,      2,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "the-end",  "The End"                                        , "UA Ltd., 1982"                              , "Emerson? #? (#?)",                                 36, 44,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // THE-END
  { ARCADIA , MEMMAP_ARCADIA, 0x306E39C1,  8 * KILOBYTE,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT, 0xC0 | 1, TRUE , TRUE , 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "turtles",  "Turtles/Turpin"                                 , "UA Ltd., 1982"                              , "Emerson #34 (#1034)",                              36, 45,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // TURTLES
  { ARCADIA , MEMMAP_I,       0x6289F607, 12 * KILOBYTE, 12, 13, 14, 15, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "dictiona", "Dictionary (English + German)"                  , "UA Ltd., 198x"                              , "Palladium 775/118",                                10, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // VIDLEXEG
  { ARCADIA , MEMMAP_I,       0x0739504D, 12 * KILOBYTE, 12, 13, 14, 15, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "dictiona", "Dictionary (German + English)"                  , "UA Ltd., 198x"                              , "Palladium 775/118",                                10, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // VIDLEXGE
  { ARCADIA , MEMMAP_ARCADIA, 0x2A3A5C91,  8 * KILOBYTE,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT, 0xC0 | 2, FALSE, TRUE , YELLOW,     2,      3,                0,       0,          0, 0, DUMP_BAD,    { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Mobile Soldier Gundam (bad dump) (obsolete)"    , "Bandai, 1983"                               , "Bandai #50",                                      126, 18,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // GUNDAM-
  { ARCADIA , MEMMAP_ARCADIA, 0xC1146B0B,  4 * KILOBYTE,  7,  8,  9,  5,  5,  8,  7,  9, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Frogger 1.23 (obsolete)"                        , "Amigan Software, 200x"                      , "-",                                                40, 16,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, //!FROGGER
  { ARCADIA , MEMMAP_ARCADIA, 0x63513991,  2 * KILOBYTE,  7,  8,  9,  5,  5,  8,  7,  9, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   {25,25,25, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "JTron 1.14 (obsolete)"                          , "Amigan Software, 2003-2006"                 , "-",                                                40, 20,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, //!JTRON    (60)
  { ARCADIA , MEMMAP_ARCADIA, 0x296C8465,  4 * KILOBYTE,  7,  0,  9,  2,  2,  0,  7,  9, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "tetris",   "Tetris"                                         , "Peter Trauner, 2003"                        , "-",                                                39, 43,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, //!TETRIS
  { ARCADIA , MEMMAP_ARCADIA, 0xC1FB9F3C,  6 * KILOBYTE,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,         1,     16,                0,       0,          0, 0, DUMP_GOOD,   { 0,25, 0,25, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "alieninv", "Alien Invaders (enhanced), original background" , "Amigan Software, 2003-2004"                 , "Emerson #8 (#1003)",                               28,  1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // ALIENIN1
  { ARCADIA , MEMMAP_ARCADIA, 0x5F77087A,  6 * KILOBYTE,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,         1,     16,                0,       0,          0, 0, DUMP_GOOD,   { 0,25, 0,25, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "alieninv", "Alien Invaders (enhanced), background #2"       , "Amigan Software, 2003-2004"                 , "Emerson #8 (#1003)",                               28,  1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // ALIENIN2
  { ARCADIA , MEMMAP_ARCADIA, 0x6F68DCD1,  6 * KILOBYTE,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,         1,     16,                0,       0,          0, 0, DUMP_GOOD,   { 0,25, 0,25, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "alieninv", "Alien Invaders (enhanced), background #3"       , "Amigan Software, 2003-2004"                 , "Emerson #8 (#1003)",                               28,  1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // ALIENIN3
  { ARCADIA , MEMMAP_ARCADIA, 0x9F915C41,  6 * KILOBYTE,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,         1,     16,                0,       0,          0, 0, DUMP_GOOD,   { 0,25, 0,25, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "alieninv", "Alien Invaders (enhanced), background #4"       , "Amigan Software, 2003-2004"                 , "Emerson #8 (#1003)",                               28,  1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // ALIENIN4
  { ARCADIA , MEMMAP_ARCADIA, 0x881E11AC,  6 * KILOBYTE,  2,  4,  0, 10, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "golf",     "Golf (patched)"                                 , "Amigan Software, 2005-2006"                 , "MPT MG-324",                                       22, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // GOLF!
  { ARCADIA , MEMMAP_ARCADIA, 0x0F34FFBB,  8 * KILOBYTE,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT, 0xC0 | 2, FALSE, TRUE , BLUE,       2,      3,                0,       0,          0, 0, DUMP_BAD,    { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Mobile Soldier Gundam (semi-fixed) (obsolete)"  , "Amigan Software, 2003"                      , "Bandai #50",                                      126, 18,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // GUNDAM!
  { ARCADIA , MEMMAP_ARCADIA, 0xA6E9A90F,  6 * KILOBYTE,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , BLACK,      1,      2,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "ssquadro", "Space Squadron (enhanced)"                      , "Amigan Software, 2003-2004"                 , "Emerson? #? (#?)",                                127, 37,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // SSQUADR!
  { ARCADIA , MEMMAP_ARCADIA, 0xB46CACD8,  4 * KILOBYTE,  4,  2, 10, 11,  5,  0,  7,  9, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , BLACK, DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "starches", "Star Chess (enhanced)"                          , "Amigan Software, 2005"                      , "Emerson #18 (#1006)",                              37, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // STARCHE!
  { INTERTON, MEMMAP_A,       0xA0F5320A,  2 * KILOBYTE, 10, 11, 10, 11, -1, 11, -1, 10, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 2, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "challeng", "4 in a Row"                                     , "?, 19xx"                                    , "Interton #15",                                     74, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // 4INAROW  (variant of CHALLEN-)
  { INTERTON, MEMMAP_A,       0xA8503624,  2 * KILOBYTE,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_SUSPECT,{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "airseaat", "Air/Sea Attack (suspect dump)"                  , "?, 19xx"                                    , "Fountain #5",                                      99, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // AIRSEAAT (suspect dump) (variant of AIRSEABA)
  { INTERTON, MEMMAP_A,       0xF3D37699,  2 * KILOBYTE,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "airseaat", "Air/Sea Battle"                                 , "?, 19xx"                                    , "Interton #7",                                      99, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // AIRSEABA (variant of AIRSEAAT)
  { INTERTON, MEMMAP_C,       0x08CD8135,  4 * KILOBYTE,  2,  0, 10, 11, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE,      60, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "backgamm", "Backgammon"                                     , "?, 19xx"                                    , "Interton #36",                                    119, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // BACKGAMM
  { INTERTON, MEMMAP_A,       0xEC2A91B3,  2 * KILOBYTE,  2,  1,  3,  9, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "blackjac", "Blackjack"                                      , "?, 19xx"                                    , "Fountain #3/Interton #2",                          97, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // BLACKJAC
  { INTERTON, MEMMAP_A,       0xA47FE1BF,  2 * KILOBYTE,  2,  2,  2,  2, -1, -1, -1, -1, TRUE , SENSITIVITY_VLOW   ,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0,25, 0,25, 0,25},{ 0, 0, 0, 0},{ 0, 0,25, 0,25,25},{ 0, 0, 0, 0}, "bowling",  "Bowling"                                        , "?, 19xx"                                    , "Interton #25",                                    111, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // BOWLING
  { INTERTON, MEMMAP_B,       0x922C9F0D,  4 * KILOBYTE,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "boxing",   "Boxing"                                         , "?, 19xx"                                    , "Interton #18",                                    107, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // BOXING   (variant of PRIZEFI-)
  { INTERTON, MEMMAP_A,       0x619C07C9,  2 * KILOBYTE,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "capture",  "Capture"                                        , "?, 19xx"                                    , "Fountain #24/Interton #21",                       109, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // CAPTURE
  { INTERTON, MEMMAP_A,       0x5C7F11E0,  2 * KILOBYTE,  2,  1,  3,  0, -1, -1, -1, -1, TRUE , SENSITIVITY_MEDIUM ,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "grndprix", "Car Races"                                      , "?, 19xx"                                    , "Fountain #2",                                      96, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // CARRACES (variant of GRNDPRIX)
  { INTERTON, MEMMAP_A,       0x50FD6A18,  2 * KILOBYTE,  2,  0, 11, 10, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO,              251, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "casino",   "Casino"                                         , "?, 19xx"                                    , "Interton #31",                                    116, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // CASINO
  { INTERTON, MEMMAP_C,       0xE9C53288,  4 * KILOBYTE,  1,  4,  7, 10, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO,              252, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "chess1",   "Chess"                                          , "?, 19xx"                                    , "Interton #13",                                    104, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // CHESS1
  { INTERTON, MEMMAP_D,       0x1B948AEB,  6 * KILOBYTE,  1,  4,  7, 10, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO,              252, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "chess2",   "Chess 2"                                        , "?, 19xx"                                    , "Interton #22",                                    104, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // CHESS2
  { INTERTON, MEMMAP_A,       0x0AB80F3E,  2 * KILOBYTE,  2,  2,  2,  2, -1, -1, -1, -1, TRUE , SENSITIVITY_MEDIUM ,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0,25, 0,25, 0,25},{ 0, 0,25, 0},{ 0, 0,25, 0,25,25},{ 0, 0, 0,25}, "circus",   "Circus"                                         , "?, 19xx"                                    , "Fountain #13/Interton #17",                       106, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // CIRCUS
  { INTERTON, MEMMAP_B,       0x11DD7F0D,  4 * KILOBYTE,  2,  1,  3,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE,      51, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "cockpit",  "Cockpit"                                        , "Interton (Martin Greiner), 19xx"            , "Interton #28",                                    113, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // COCKPIT
  { INTERTON, MEMMAP_A,       0x52B8C6E7,  2 * KILOBYTE, 11,  2,  0, 10, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "codebrea", "Codebreaker"                                    , "?, 19xx"                                    , "Fountain #10",                                     47, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // CODEBREA (variant of MASTERMI) (kludging doesn't seem to work for this one)
  { INTERTON, MEMMAP_A,       0x5E8EE224,  2 * KILOBYTE,  2,  1,  3,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 1, 1,25, 1, 1, 1},{ 0, 0, 0, 0},{ 1, 1, 1,25, 1, 1},{ 0, 0, 0, 0}, "combat",   "Tank/Plane Battle"                              , "?, 19xx"                                    , "Fountain #4",                                      95, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // COMBATA  (variant of COMBATB)
  { INTERTON, MEMMAP_A,       0x468E4779,  2 * KILOBYTE,  2,  1,  3,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 1, 1,25, 1, 1, 1},{ 0, 0, 0, 0},{ 1, 1, 1,25, 1, 1},{ 0, 0, 0, 0}, "combat",   "Tank Battle/Plane Battle"                       , "?, 19xx"                                    , "Interton #4",                                      95, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // COMBATB  (variant of COMBATA)
  { INTERTON, MEMMAP_C,       0x7B868473,  4 * KILOBYTE,  2,  1,  3,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO,              220, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "draughts", "Draughts"                                       , "?, 19xx"                                    , "Interton #26",                                      4, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // DRAUGHTS
  { INTERTON, MEMMAP_B,       0xD399CE07,  4 * KILOBYTE,  2, 11,  6,  1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE,      53, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "golf",     "Golf"                                           , "?, 19xx"                                    , "Interton #27",                                    112, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // GOLF     (variant or overdump of GOLF-)
  { INTERTON, MEMMAP_A,       0x2C770DC3,  2 * KILOBYTE,  2,  1,  3,  0, -1, -1, -1, -1, TRUE , SENSITIVITY_MEDIUM ,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "grndprix", "Grand Prix"                                     , "?, 19xx"                                    , "Interton #1",                                      96, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // GRNDPRIX (variant of CARRACES)
  { INTERTON, MEMMAP_A,       0xFF39521A,  2 * KILOBYTE,  7,  0,  9,  5, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   {25,25,25, 0, 0, 0},{ 0, 0, 0, 0},{ 0,25, 0,25, 0,25},{ 0, 0, 0, 0}, "headon",   "Head On"                                        , "Radofin, 19xx"                              , "Fountain #20",                                      5, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, //!HEADON
  { INTERTON, MEMMAP_A,       0xAAEA290F,  2 * KILOBYTE,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "horserac", "Hippodrome"                                     , "?, 19xx"                                    , "Interton #11",                                     88, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // HIPPODRO (variant of HORSERAC)
  { INTERTON, MEMMAP_A,       0x4339E630,  2 * KILOBYTE,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_SUSPECT,{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "horserac", "Horse Racing (suspect dump)"                    , "?, 19xx"                                    , "Fountain #12",                                     88, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // HORSERAC (suspect dump) (variant of HIPPODRO)
  { INTERTON, MEMMAP_A,       0x31978AD4,  2 * KILOBYTE,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0,25, 0,25, 0,25},{ 0, 0, 0, 0},{ 0, 0,25, 0,25,25},{ 0, 0, 0, 0}, "hunting",  "Hunting"                                        , "?, 19xx"                                    , "Interton #12",                                    103, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // HUNTING  (variant of SHOOTGAL)
  { INTERTON, MEMMAP_A,       0xB3ED1129,  2 * KILOBYTE,  2,  3,  4,  5, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , BLACK, DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "hyperspa", "Hyperspace"                                     , "Interton, 19xx"                             , "Interton #38",                                    121, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // HYPERSPA
  { INTERTON, MEMMAP_A,       0x6AE47072,  2 * KILOBYTE,  2,  1,  3,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , BLUE,  DEF_DN, DEF_TO, PVI_LATESTSPRITE,     254,        278, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "invaders", "Invaders (Fountain version)"                    , "UA Ltd.? (Andrew Choi), 19xx"               , "Fountain #27",                                    117, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // INVADERA (variant of INVADERB)
  { INTERTON, MEMMAP_A,       0x9497204A,  2 * KILOBYTE,  2,  1,  3,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , BLUE,  DEF_DN, DEF_TO, PVI_LATESTSPRITE,     254,        278, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "invaders", "Invaders (Interton version)"                    , "UA Ltd.? (Andrew Choi), 19xx"               , "Interton #32",                                    117, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // INVADERB (variant of INVADERA)
  { INTERTON, MEMMAP_A,       0x7B2B2B61,  2 * KILOBYTE,  2,  1,  3,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "supermaz", "Labyrinth"                                      , "?, 19xx"                                    , "Interton #9",                                     101, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // LABYRINT (variant of SUPERMA-)
  { INTERTON, MEMMAP_A,       0xC44FABB1,  2 * KILOBYTE,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , BLACK, DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 1, 0, 1, 1},{ 0, 0, 0, 1},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "laseratt", "Laser Attack"                                   , "Radofin (Hans Beiling?), 19xx"              , "Fountain #31",                                     41, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // LASERATT
  { INTERTON, MEMMAP_A,       0x52B8C6E7,  2 * KILOBYTE, 11,  2,  0, 10, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "codebrea", "Mastermind"                                     , "?, 19xx"                                    , "Interton #16",                                     47, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // MASTERMI (variant of CODEBREA)
  { INTERTON, MEMMAP_A,       0x66C5975E,  2 * KILOBYTE,  2,  1,  3,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "math2",    "Math 2"                                         , "?, 19xx"                                    , "Fountain #8/Interton #6",                           6, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // MATH2
  { INTERTON, MEMMAP_A,       0xE38E0C03,  2 * KILOBYTE,  2,  1,  3,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "math1",    "Mathematics 1"                                  , "?, 19xx"                                    , "Interton #5",                                       6, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // MATHEMA1 (variant of MATH1-)
  { INTERTON, MEMMAP_B,       0xA640A330,  4 * KILOBYTE,  2,  1,  3,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE,      54, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "metropol", "Metropolis/Hangman"                             , "? (Paul-Jrgen Dickers), 19xx"              , "Interton #29",                                    114, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // METROPOL
  { INTERTON, MEMMAP_B,       0x27CCE96F,  4 * KILOBYTE,  0,  0,  0,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 1, 0, 1, 1},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "spidersw", "Monster Man"                                    , "?, 19xx"                                    , "Interton #37",                                    120, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // MONSTERM (variant of SPIDERS-)
  { INTERTON, MEMMAP_B,       0x55011F0A,  4 * KILOBYTE,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_VHIGH  ,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 1, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "motocros", "Motocross"                                      , "Interton (Hans Bieling), 1979?"             , "Interton #14",                                     94, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // MOTOCROS
  { INTERTON, MEMMAP_A,       0xD68DA80A,  2 * KILOBYTE,  2,  1,  3,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "musicalg", "Musical Games"                                  , "?, 19xx"                                    , "Fountain #17/Interton #20",                         7, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // MUSICALG
  { INTERTON, MEMMAP_A,       0x682B876A,  2 * KILOBYTE,  2,  1,  3,  2, -1, -1, -1, -1, TRUE , SENSITIVITY_MEDIUM ,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   {25,25,25, 0, 0, 0},{ 0, 0, 0, 0},{25, 0, 0,25,25, 0},{ 0, 0, 0, 0}, "olympics", "Olympics"                                       , "UA Ltd.? (Andrew Choi?), 19xx"              , "Fountain #1/Interton #3",                          98, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // OLYMPICS
  { INTERTON, MEMMAP_A,       0xC6B2CD9A,  2 * KILOBYTE,  2,  1,  3,  4, -1, -1,  1,  3, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO,              267, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   {25,25,25, 0, 0, 0},{25, 0, 0, 0},{25,25,25, 0, 0, 0},{25, 0, 0, 0}, "pinball",  "Electronic Pinball"                             , "?, 19xx"                                    , "Fountain #25",                                    105, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // PINBALLA (variant of PINBALLB)
  { INTERTON, MEMMAP_A,       0xADD99C6E,  2 * KILOBYTE,  2,  1,  3,  4, -1, -1,  1,  3, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO,              267, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   {25,25,25, 0, 0, 0},{25, 0, 0, 0},{25,25,25, 0, 0, 0},{25, 0, 0, 0}, "pinball",  "Pinball"                                        , "?, 19xx"                                    , "Interton #23",                                    105, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // PINBALLB (variant of PINBALLA)
  { INTERTON, MEMMAP_A,       0x2AEB516E,  2 * KILOBYTE,  2,  1,  3,  0, -1, -1, -1, -1, TRUE , SENSITIVITY_MEDIUM ,        0, FALSE, TRUE , BLACK, DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "planetde", "Planet Defender"                                , "?, 19xx"                                    , "Fountain #33",                                    124, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // PLANETDE
  { INTERTON, MEMMAP_A,       0x9C8E7DE6,  2 * KILOBYTE,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0,25, 0,25, 0,25},{ 0, 0, 0, 0},{ 0, 0,25, 0,25,25},{ 0, 0, 0, 0}, "shootgal", "Shooting Gallery"                               , "?, 19xx"                                    , "Fountain #6",                                     103, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // SHOOTGAL (variant of HUNTING)
  { INTERTON, MEMMAP_A,       0xB589F093,  2 * KILOBYTE,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   {25,25,25, 0, 0, 0},{25, 0, 0, 0},{25, 0, 0,25,25, 0},{ 0,25, 0, 0}, "",         "Shoot Out"                                      , "UA Ltd.? (Andrew Choi), 1981"               , "Fountain #29",                                    125, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // SHOOTOUT
  { INTERTON, MEMMAP_A,       0x87977F92,  2 * KILOBYTE,  2,  6,  9, 11, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE,      57, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "soccer",   "Soccer (Fountain version)"                      , "?, 19xx"                                    , "Fountain #15",                                    110, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // SOCCERA  (variant of SOCCERB)
  { INTERTON, MEMMAP_A,       0x05AF8228,  2 * KILOBYTE,  2,  6,  9, 11, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE,      57, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "soccer",   "Soccer (Interton version)"                      , "?, 19xx"                                    , "Interton #24",                                    110, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // SOCCERB  (variant of SOCCERA)
  { INTERTON, MEMMAP_A,       0x08209D98,  2 * KILOBYTE,  7,  0,  9,  5, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE,      49, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "solitair", "Solitaire"                                      , "Interton, 19xx"                             , "Interton #30",                                    115, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // SOLITAIR (CPL of >= 89 also works)
  { INTERTON, MEMMAP_A,       0xB1C31F9A,  2 * KILOBYTE,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , PURPLE,DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "spacewar", "Space War"                                      , "?, 19xx"                                    , "Fountain #30/Interton #19",                       108, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // SPACEWAR
  { INTERTON, MEMMAP_A,       0xA46C2F9E,  2 * KILOBYTE,  2,  1,  3,  0, -1, -1, -1, -1, TRUE,  SENSITIVITY_LOW    ,        0, FALSE, TRUE , BLACK, DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   {25, 0, 0,25,25, 0},{ 0, 0, 0, 0},{ 0, 0,25, 0,25,25},{ 0, 0, 0, 0}, "",         "Super Invaders"                                 , "?, 19xx"                                    , "Interton #33",                                    118, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // SUPERINV
  { INTERTON, MEMMAP_B,       0x306E37BB,  4 * KILOBYTE,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Super-Space"                                    , "Interton, 19xx"                             , "Interton #40",                                    122, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // SUPERSPA
  { INTERTON, MEMMAP_A,       0xEA8F717F,  2 * KILOBYTE,  2,  1,  3,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "treasure", "Treasure Hunt"                                  , "?, 19xx"                                    , "Fountain #18/Interton #8",                        100, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // TREASURE
  { INTERTON, MEMMAP_B,       0xBDD652B7,  4 * KILOBYTE,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO,              275, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "wintersp", "Winter Sports"                                  , "Interton, 19xx"                             , "Interton #10",                                    102, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // WINTERSP
  { INTERTON, MEMMAP_A,       0x8AB96827,  2 * KILOBYTE, 10, 11, 10, 11, -1, 11, -1, 10, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 2, DUMP_BAD,    { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "challeng", "Challenge (bad dump)"                           , "?, 19xx"                                    , "Fountain #9",                                      74, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // CHALLEN- (variant of 4INAROW)
  { INTERTON, MEMMAP_A,       0x3CF3BAF6,  2 * KILOBYTE,  2, 11,  6,  1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE,      53, PVI_VBLANK, 0, DUMP_BAD,    { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "golf",     "Golf (bad dump)"                                , "?, 19xx"                                    , "Fountain #19",                                    112, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // GOLF-    (variant or underdump of GOLF)
  { INTERTON, MEMMAP_A,       0x2737D62D,  2 * KILOBYTE,  2,  1,  3,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_BAD,    { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Super Knockout (bad dump)"                      , "?, 19xx"                                    , "Fountain #26",                              I_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // KNOCKOU-
  { INTERTON, MEMMAP_A,       0x9E3AB142,  2 * KILOBYTE,  2,  1,  3,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_BAD,    { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "math1",    "Maths 1 (bad dump)"                             , "?, 19xx"                                    , "Fountain #7",                                       6, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // MATH1-   (variant of MATHEMA1)
  { INTERTON, MEMMAP_A,       0x4D37502D,  2 * KILOBYTE,  2,  1,  3,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_BAD,    { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "math1",    "Mathematics 1 (bad dump)"                       , "?, 19xx"                                    , "Interton #5?",                                      6, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // alternate bad dump of of MATHEMA1
  { INTERTON, MEMMAP_A,       0xA931407C,  2 * KILOBYTE,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_BAD,    { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "boxing",   "Prizefight (bad dump)"                          , "?, 19xx"                                    , "Fountain #14",                                    107, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // PRIZEFI- (variant of BOXING)
  { INTERTON, MEMMAP_A,       0xE5E4C37B,  2 * KILOBYTE,  0,  0,  0,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_BAD,    { 0, 0, 1, 0, 1, 1},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "spidersw", "Spider\'s Web (bad dump)"                       , "?, 19xx"                                    , "Fountain #22",                                    120, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // SPIDERS- (variant of MONSTERM)
  { INTERTON, MEMMAP_A,       0x4D3F9CFB,  2 * KILOBYTE,  2,  1,  3,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_BAD,    { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "supermaz", "Super Maze (bad dump)"                          , "?, 19xx"                                    , "Fountain #11",                                    101, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // SUPERMA- (variant of LABYRINT)
  { ELEKTOR , MEMMAP_E,       0x45494CBC,  7 * KILOBYTE, 10, 11, 10, 11, -1, 11, -1, 10, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "4 in a Row (ESS-003-4) (overdump)"              , "Philips, 1979"                              , "ESS-003-4",                                        74, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_E,       0x18288A02,  7 * KILOBYTE,  4,  8,  6,  2,  2,  8,  4,  6, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE,      47, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Surround (ESS-003-5) (overdump)"                , "Philips, 1979"                              , "ESS-003-5",                                        67, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, //!E/-
  { ELEKTOR , MEMMAP_E,       0x2DC0DD9E,  7 * KILOBYTE,  2,  1,  3,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "PVI Programming (ESS-006-2) (overdump)"         , "Elektor (Paul V. Holmes), 1979"             , "ESS-006-2",                                       147, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_E,       0x1D8C1EA5,  7 * KILOBYTE,  8,  8,  8,  8,  5,  0,  7,  9, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, BLUE,  DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "07-5",     "Rocket Shooting (overdump)"                     , "Elektor (Paul V. Holmes), 1979"             , "ESS-006-3",                                        81, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, //!E/-
  { ELEKTOR , MEMMAP_E,       0x7585F58E,  7 * KILOBYTE,  3,  6,  9, 11, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Mastermind (overdump)"                          , "H. Trndle, 1980"                           , "ESS-007-1",                                        48, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_E,       0x63F7D8FE,  7 * KILOBYTE, 11,  2,  0, 10, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Code Breaker (overdump)"                        , "K. Reilly + P. Williams, 1980"              , "ESS-007-2",                                        47, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_E,       0x2DB9E572,  7 * KILOBYTE,  1,  5,  0, 10, 11, 11, 10, 10, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 2, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Reversi (overdump)"                             , "H. Trndle, 1980"                           , "ESS-007-3",                                        69, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_E,       0xD4523830,  7 * KILOBYTE,  1,  1,  1,  1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Amazone (overdump)"                             , "Elektor (Paul V. Holmes), 1980"             , "ESS-007-4",                                        44, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_E,       0xE9403961,  7 * KILOBYTE,  8,  8,  8,  8,  5,  0,  7,  9, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, BLACK, DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "07-5",     "Space Shoot-Out (overdump)"                     , "Elektor (Paul V. Holmes), 1980"             , "ESS-007-5",                                        81, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, //!E/-
  { ELEKTOR , MEMMAP_E,       0xDD59FC15,  7 * KILOBYTE, 10, 11, 10, 11, -1, 11, -1, 10, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "4 in a Row (ESS-007-6) (overdump)"              , "Philips + H. Trndle, 1979-1980"            , "ESS-007-6",                                        74, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_E,       0xF8D8218B,  7 * KILOBYTE, 10, 11, 10, 11, -1, 11, -1, 10, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "4 in a Row (ESS-007-7) (overdump)"              , "Philips + H. Trndle, 1979-1980"            , "ESS-007-7",                                        74, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_E,       0x80E543D2,  7 * KILOBYTE,  2, 10,  0, 11, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Jackpot (overdump)"                             , "Elektor (Paul V. Holmes), 1980"             , "ESS-007-8",                                        68, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_E,       0xE6262205,  7 * KILOBYTE,  4,  8,  6,  2,  2,  8,  4,  6, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE,      47, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Surround (ESS-007-9) (overdump)"                , "Philips, 1979-1980"                         , "ESS-007-9",                                        67, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, //!E/-
  { ELEKTOR , MEMMAP_E,       0x309A17A5,  7 * KILOBYTE,  2,  1,  3,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "09-1",     "Aggressor (overdump)"                           , "M. Norman, 198x"                            , "ESS-009-1",                                        82, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_E,       0xFC32C62A,  7 * KILOBYTE,  8,  3,  1,  8, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Offshore Fishing (overdump)"                    , "M. Norman, 198x"                            , "ESS-009-2",                                        58, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_E,       0xE7A63D7F,  8 * KILOBYTE,  3,  2,  1,  3, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 1, 0, 1, 0, 1},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Circledrive"                                    , "M. Norman, 198x"                            , "ESS-009-3",                                         8, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_E,       0xC782D585,  7 * KILOBYTE,  0,  2,  5,  1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Seawar (overdump)"                              , "Paul-Jrgen Dickers, 198x"                  , "ESS-009-4",                                        46, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_ELEKTOR, 0x7AE45C16,  7 * KILOBYTE, 10,  0, 11,  7, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO,              265, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Memory (overdump)"                              , "Paul-Jrgen Dickers, 198x"                  , "ESS-009-5",                                        62, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/F
  { ELEKTOR , MEMMAP_ELEKTOR, 0x64BEF839,  7 * KILOBYTE,  1,  0, 10,  1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO,              257, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 1, 0, 1, 1},{ 0, 0, 0, 1},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "09-6",     "Labyrinth"                                      , "Elektor (Paul V. Holmes), 198x"             , "ESS-009-6",                                        51, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/F
  { ELEKTOR , MEMMAP_E,       0xBD495BED,  7 * KILOBYTE,  1,  1,  1,  1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 1, 0, 0, 1, 1, 0},{ 0, 1, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Destroyer (overdump)"                           , "G. Roberts, 198x"                           , "ESS-009-7",                                        59, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_E,       0x62B18147,  7 * KILOBYTE,  8,  1,  8,  1,  5,  0,  7,  9, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, BLACK, DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Starship Enterprise (overdump)"                 , "M. Norman, 198x"                            , "ESS-009-8",                                        60, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_E,       0x95A254AA,  7 * KILOBYTE,  0, 10,  6,  9, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Blackjack (overdump)"                           , "M. Norman, 198x"                            , "ESS-009-9",                                        61, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_E,       0x231B2427,  7 * KILOBYTE, 10,  0, 11, 10, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, TRUE,  EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Card Trick (overdump)"                          , "Paul-Jrgen Dickers, 198x"                  , "ESS-009-A",                                        52, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_E,       0x90CADC60,  7 * KILOBYTE, 10,  0, 11,  9, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Awari (overdump)"                               , "Martin Greiner, 198x"                       , "ESS-009-B",                                        53, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_E,       0xE9F2688E,  7 * KILOBYTE,  3,  3,  3,  3, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, TRUE,  EFLAG, BLACK, DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 1, 0, 0, 1, 1, 0},{ 0, 0, 0, 0}, "",         "UFO Shooting (overdump)"                        , "P. Schmid, 198x"                            , "ESS-009-C",                                        54, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_E,       0xBDC3DA72,  7 * KILOBYTE,  8,  1, 11,  8, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0,10, 0,10, 0},{ 0, 0, 0, 1},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Raster (overdump)"                              , "G. Roberts, 198x"                           , "ESS-009-D",                                        55, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_E,       0x83538875,  7 * KILOBYTE,  2,  1,  3,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE,      57, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Nim (overdump)"                                 , "H. Trndle, 198x"                           , "ESS-009-E",                                        56, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_E,       0x21E8568B,  7 * KILOBYTE,  7,  0,  9,  5, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Solitaire (overdump)"                           , "G. Roberts, 198x"                           , "ESS-009-F",                                        57, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_F,       0xE02FDA29,  8 * KILOBYTE,  7,  1,  9,  8, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, BLUE,  DEF_DN, DEF_TO, PVI_LATESTSPRITE,      64, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Invaders"                                       , "M. Norman, 198x"                            , "ESS-010-1",                                        43, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, //!E/-
  { ELEKTOR , MEMMAP_F,       0xC15FF62B,  7 * KILOBYTE,  1,  2,  3,  2, -1, -1,  1,  3, FALSE, SENSITIVITY_DEFAULT,        0, TRUE,  EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Pinball (overdump)"                             , "Martin Greiner, 198x"                       , "ESS-010-2",                                        73, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, //!-/F
  { ELEKTOR , MEMMAP_E,       0x8EDE9085,  7 * KILOBYTE,  2,  6,  9,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0,25, 0, 0, 0},{25, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "10-3",     "Helicopter (overdump)"                          , "C. Mnnchen, 198x"                          , "ESS-010-3",                                        72, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_E,       0x7EC3B97F,  7 * KILOBYTE, 10,  0, 11, 10, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, TRUE,  EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE,      55, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Hard Nut (overdump)"                            , "Paul-Jrgen Dickers, 198x"                  , "ESS-010-4",                                        83, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, //!E/-
  { ELEKTOR , MEMMAP_E,       0xF193C235,  7 * KILOBYTE,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0,25, 0,25, 0,25},{ 0, 0,25, 0},{ 0, 0,25, 0,25,25},{ 0, 0, 0,25}, "10-5",     "Catapult (overdump)"                            , "M. Norman, 198x"                            , "ESS-010-5",                                        71, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_F,       0xDBD484BB,  7 * KILOBYTE,  2,  3, 11, 10, -1, -1, -1, -1, TRUE,  SENSITIVITY_MEDIUM ,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE,      58, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Pilot (overdump)"                               , "Martin Greiner, 198x"                       , "ESS-010-6",                                        70, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // -/F
  { ELEKTOR , MEMMAP_E,       0x2066116A,  7 * KILOBYTE,  2,  2,  2,  2, -1, -1, -1, -1, TRUE,  SENSITIVITY_LOW    ,        0, FALSE, EFLAG, BLUE,  DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   {25, 0, 0,25,25, 0},{ 0,25, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Attack from Space (overdump)"                   , "M. Godfrey, 198x"                           , "ESS-010-7",                                        77, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_E,       0xC31C0B56,  7 * KILOBYTE, 10,  9,  8,  7, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Reverse (overdump)"                             , "Martin Greiner, 198x"                       , "ESS-010-8",                                        84, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_E,       0xDA58E218,  8 * KILOBYTE,  8,  1,  3,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, BLUE,  DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Rocket Hunting"                                 , "M. Norman, 198x"                            , "ESS-010-9",                                        75, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_F,       0x8B66AC75,  7 * KILOBYTE,  1,  2,  3,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO,              258, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Basketball"                                     , "Martin Greiner, 198x"                       , "ESS-010-A",                                        76, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, //!-/F
  { ELEKTOR , MEMMAP_E,       0xE62573E0,  7 * KILOBYTE,  2,  2,  2,  2, -1, -1, -1, -1, TRUE,  SENSITIVITY_MEDIUM ,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO,              220, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0,25, 0,25, 0,25},{ 0, 0,25, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "10-b",     "Bursting Balloons (overdump)"                   , "H. Jansen, 198x"                            , "ESS-010-B",                                        85, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_F,       0x49E69462,  7 * KILOBYTE, 10,  0, 11,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, TRUE,  EFLAG, 16,    DEF_DN, DEF_TO,              266,      54, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Galgenspiel"                                    , "Paul-Jrgen Dickers, 198x"                  , "ESS-010-E",                                        45, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // -/F
  { ELEKTOR , MEMMAP_F,       0x426B44D8,  7 * KILOBYTE, 10,  0, 11,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, TRUE,  EFLAG, 16,    DEF_DN, DEF_TO,              266,      54, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Hangman"                                        , "Paul-Jrgen Dickers + Paul V. Holmes, 198x" , "ESS-010-F",                                        45, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // -/F
  { ELEKTOR , MEMMAP_E,       0x994BC0EA,  7 * KILOBYTE,  8,  1,  1,  8, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Snakes and Ladders (overdump)"                  , "G. M. Robert, 198x"                         , "ESS-011-1",                                        90, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_E,       0xEC20152C,  7 * KILOBYTE,  7,  3,  9,  1, -1, -1,  7,  9, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE,      61, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "11-2",     "Molebasher (overdump)"                          , "G. M. Robert, 198x"                         , "ESS-011-2",                                        91, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, //!E/-
  { ELEKTOR , MEMMAP_E,       0x09EF8D41,  7 * KILOBYTE,  8,  8,  8,  8, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL,        289, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Snap (overdump)"                                , "V. W. Trumann, 198x"                        , "ESS-011-3",                                        92, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_ELEKTOR, 0x5206E5CF,  7 * KILOBYTE,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Mazes (overdump)"                               , "B. A. Sedoni, 198x"                         , "ESS-011-4",                                        93, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/F
  { ELEKTOR , MEMMAP_ELEKTOR, 0x597615A6,  7 * KILOBYTE,  8,  1,  3,  2,  1, -1,  7,  9, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, BLUE,       1,      2, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 1, 1, 1, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Asteroids (overdump)"                           , "M. V. Norman, 198x"                         , "ESS-011-5",                                        79, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/F
  { ELEKTOR , MEMMAP_F,       0x015E3686,  7 * KILOBYTE,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_VHIGH  ,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE,      56,        282, 1, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Dragster"                                       , "Hans-Heinz Bieling, 198x"                   , "ESS-011-6",                                        94, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // -/F
  { ELEKTOR , MEMMAP_E,       0xF5789409,  7 * KILOBYTE,  2,  1,  3,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, BLUE,  DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "11-7",     "Omega Landing (overdump)"                       , "W. Sembritzki, 198x"                        , "ESS-011-7",                                        49, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_E,       0x43E6DB7A,  7 * KILOBYTE,  1,  1,  1,  1, -1, -1, -1, -1, TRUE,  SENSITIVITY_MEDIUM ,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0,25, 0,25, 0,25},{ 0, 0,25, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "10-b",     "Breakout (overdump)"                            , "H. Jansen + N. Hagemann, 198x"              , "ESS-011-8",                                        86, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_F,       0x743DFF28,  7 * KILOBYTE,  2,  1,  3,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 1, 1, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "11-9",     "Tiny Tim (overdump)"                            , "W. Sembritzki, 198x"                        , "ESS-011-9",                                        50, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // -/F
  { ELEKTOR , MEMMAP_E,       0xD85303AD,  7 * KILOBYTE,  2, 10, 11,  1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Horse Race + Jackpot (overdump)"                , "C. Isoart, 198x"                            , "ESS-011-A",                                        89, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_E,       0x77523CC2,  7 * KILOBYTE,  2,  1,  3,  0, -1, -1, -1, -1, TRUE,  SENSITIVITY_HIGH   ,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE,      55, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "11-b",     "Newton (overdump)"                              , "Peter Marschat, 198x"                       , "ESS-011-B",                                        78, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_F,       0xEBAB31FD,  7 * KILOBYTE,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Horse Races (overdump)"                         , "B. A. Sedonir, 198x"                        , "ESS-011-C",                                        88, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // -/F
  { ELEKTOR , MEMMAP_E,       0xF55DD406,  7 * KILOBYTE,  1,  1,  1,  1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 1, 1, 1, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Painting (overdump)"                            , "W. Sembritzki, 198x"                        , "ESS-011-D",                                        64, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_E,       0xED484047,  7 * KILOBYTE,  2,  2,  2,  2, -1, -1, -1, -1, TRUE , SENSITIVITY_MEDIUM ,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE,      79, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Submarines + Racing (overdump)"                 , "R. Lange, 198x"                             , "ESS-011-E",                                        65, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_F,       0x46D5A0EE,  7 * KILOBYTE,  1,  1,  1,  1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, BLACK,      1,     50, PVI_LATESTSPRITE,      60, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "11-f",     "Cosmic Adventure"                               , "N. Hagemann, 198x"                          , "ESS-011-F",                                        63, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // -/F
  { ELEKTOR , MEMMAP_E,       0x0D7D868E,  7 * KILOBYTE,  2,  1,  3,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Play with the PVI (overdump)"                   , "?, 1979"                                    , "ESS-003-1",                                       148, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_E,       0x10991986,  7 * KILOBYTE,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Clock (overdump)"                               , "?, 1979"                                    , "ESS-003-2",                                       149, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_E,       0x51B61371,  7 * KILOBYTE,  2,  1,  3,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO,              228, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Music Box (overdump)"                           , "Philips, 1979"                              , "ESS-003-3",                                        66, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_E,       0x94984EB9,  7 * KILOBYTE, 10, 10, 10, 10, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Locomotive (overdump)"                          , "Elektor (Andr Pauptit), 1979"              , "ESS-003-6",                                       150, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_E,       0x9CA4965D,  7 * KILOBYTE,  2,  1,  3,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Picture Pattern (overdump)"                     , "Elektor (Paul V. Holmes), 1979"             , "ESS-006-1",                                       151, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_E,       0x18A53913,  7 * KILOBYTE, 10, 10, 10, 10, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Shapes (overdump)"                              , "P. Williams, 1980"                          , "ESS-007-A",                                       152, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_E,       0xA7B77712,  7 * KILOBYTE,  2,  1,  3,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO,              228, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Piano (overdump)"                               , "Philips, 1979-1980"                         , "ESS-007-B",                                        66, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_E,       0xAEFB870B,  7 * KILOBYTE,  2,  1,  3,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "PVI Programming (ESS-007-C) (overdump)"         , "Elektor (Paul V. Holmes), 1979-1980"        , "ESS-007-C",                                       147, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_E,       0xF06467B4,  8 * KILOBYTE,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Disassembler"                                   , "Manfred Saliger + Paul V. Holmes, 1980"     , "ESS-007-D",                                       153, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_E,       0x9CA4965D,  7 * KILOBYTE,  2,  1,  3,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Test Patterns (overdump)"                       , "Elektor (Paul V. Holmes), 1979-1980"        , "ESS-007-E",                                       151, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_E,       0x5BEE68A3,  7 * KILOBYTE,  0, 10,  7, 11, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Lotto (overdump)"                               , "Manfred Saliger, 1980"                      , "ESS-007-F",                                       154, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_F,       0xAD39EDC6,  7 * KILOBYTE,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Fr Elise (overdump)"                           , "K. Schuster, 198x"                          , "ESS-010-C",                                        87, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // -/F
  { ELEKTOR , MEMMAP_F,       0x755114C2,  7 * KILOBYTE,  2,  1,  3,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Editor"                                         , "Elektor (Paul V. Holmes), 198x"             , "ESS-010-D",                                       155, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // -/F
  { ELEKTOR , MEMMAP_F,       0x902A3B8C,  7 * KILOBYTE,  2,  1,  3,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE,      54, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Change Words for Hangman (overdump)"            , "Elektor (Paul V. Holmes), 198x"             , "ESS-010-1x",                                      156, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // -/F
  { ELEKTOR , MEMMAP_E,       0x9653ABA1,  4 * KILOBYTE,  0,  0,  0,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Add 2 (overdump)"                               , "Elektor, 1981"                              , "Pages 96-97",                               E_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_E,       0x22180C05,  4 * KILOBYTE,  0,  0,  0,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Add 4 (overdump)"                               , "Elektor, 1981"                              , "Pages 96-97",                               E_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_E,       0x3E1B794C,  4 * KILOBYTE,  0,  0,  0,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Minus 2 (overdump)"                             , "Elektor, 1981"                              , "Pages 96-97",                               E_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_E,       0x1E982CA3,  4 * KILOBYTE,  0,  0,  0,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Minus 4 (overdump)"                             , "Elektor, 1981"                              , "Pages 96-98",                               E_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_F,       0xAAAC97CC,  4 * KILOBYTE,  2,  1,  3,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Explosion aka Table 42 (overdump)"              , "Elektor, 1981"                              , "Page 181",                                  E_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // -/F
  { ELEKTOR , MEMMAP_F,       0xCDAE1CFD,  4 * KILOBYTE,  2,  1,  3,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Gunshot aka Table 42 (overdump)"                , "Elektor, 1981"                              , "Page 181",                                  E_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // -/F
  { ELEKTOR , MEMMAP_E,       0xD5522589,  4 * KILOBYTE,  2,  1,  3,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_VLOW   ,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Joystick aka Table 23 (overdump)"               , "Elektor, 1981"                              , "Pages 118-119",                             E_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_E,       0x12EFAD0F,  4 * KILOBYTE,  2,  1,  3,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Message aka Table 15 (overdump)"                , "Elektor, 1981"                              , "Pages 103-104",                             E_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_E,       0xA1553056,  4 * KILOBYTE,  2,  1,  3,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Practice (overdump)"                            , "Elektor, 1981"                              , "Page 94",                                   E_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_F,       0x65B54C14,  4 * KILOBYTE,  2,  1,  3,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Siren (overdump)"                               , "Elektor, 1981"                              , "Page 181",                                  E_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // -/F
  { ELEKTOR , MEMMAP_E,       0x4E917AD2,  4 * KILOBYTE,  2,  1,  3,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Steam Engine 1 aka Table 3 (overdump)"          , "Elektor, 1981"                              , "Page 34-35",                                E_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_E,       0xACDC1E77,  4 * KILOBYTE,  3,  3,  3,  3,  5,  0,  7,  9, FALSE, SENSITIVITY_DEFAULT,        0, TRUE,  EFLAG, BLUE,  DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Table A (overdump)"                             , "Elektor, 1981"                              , "Page 73",                                         149, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_E,       0x740B53EA,  4 * KILOBYTE,  3,  3,  3,  3,  5,  0,  7,  9, FALSE, SENSITIVITY_DEFAULT,        0, TRUE,  EFLAG, BLUE,  DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Table B (overdump)"                             , "Elektor, 1981"                              , "Pages 73-76",                                     149, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_E,       0x686C7949,  4 * KILOBYTE,  3,  3,  3,  3,  5,  0,  7,  9, FALSE, SENSITIVITY_DEFAULT,        0, TRUE,  EFLAG, BLUE,  DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Table C (overdump)"                             , "Elektor, 1981"                              , "Pages 73-79",                                     157, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_E,       0xBCDD4049,  4 * KILOBYTE,  3,  3,  3,  3,  5,  0,  7,  9, FALSE, SENSITIVITY_DEFAULT,        0, TRUE,  EFLAG, BLUE,  DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Table D (overdump)"                             , "Elektor, 1981"                              , "Pages 73-83",                                     158, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_E,       0xF49B658B,  4 * KILOBYTE,  3,  3,  3,  3,  5,  0,  7,  9, FALSE, SENSITIVITY_DEFAULT,        0, TRUE,  EFLAG, BLUE,  DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Table E (overdump)"                             , "Elektor, 1981"                              , "Pages 73-75",                                     158, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_F,       0x06599141,  4 * KILOBYTE,  2,  1,  3,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Wedding March (overdump)"                       , "Elektor, 1981"                              , "Pages 183-184",                             E_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // -/F
  { ELEKTOR , MEMMAP_F,       0x7DCCBA1A,  4 * KILOBYTE,  2,  1,  3,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Wolf Whistle (overdump)"                        , "Elektor, 1981"                              , "Page 182",                                  E_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // -/F
  { ARCADIA , MEMMAP_ARCADIA, 0x82D049D7,  8 * KILOBYTE,  2,  1,  3,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 1, 1, 1, 0, 0, 0},{ 0, 0, 0, 0},{ 1, 0, 0, 1, 1, 0},{ 0, 0, 0, 0}, "combat",   "Combat (overdump)"                              , "UA Ltd., 198x"                              , "MPT-03 MG-314",                                   135, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN },
  { ARCADIA , MEMMAP_ARCADIA, 0x7F674C85,  4 * KILOBYTE,  2,  1,  3,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, TRUE , TRUE , 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 1, 0, 1, 1},{ 0, 0, 0, 0}, "",         "Crazy Gobbler (overdump)"                       , "UA Ltd. (Andrew Choi) 1982"                 , "Hanimex #1 (#1020)",                              137, 12,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN },
  { ARCADIA , MEMMAP_ARCADIA, 0x06A86F4A,  8 * KILOBYTE,  2,  1,  3,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT, 0x00 | 1, TRUE , TRUE , BLACK,      1,      2,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "redclash", "Red Clash (overdump)"                           , "UA Ltd., 1982"                              , "Emerson #12 (#1020)",                             145, 30,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN },
  { ARCADIA , MEMMAP_ARCADIA, 0xF9D9EC5B,  8 * KILOBYTE,  2,  1,  3,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT, 0x40 | 3, TRUE , TRUE , 16,         1,      2,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0,25,25, 0, 0, 0},{ 0, 0, 0, 0}, "spiders",  "Spiders (overdump)"                             , "UA Ltd., 1982"                              , "Emerson #24 (#1024)",                              36, 39,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN },
  { ARCADIA , MEMMAP_ARCADIA, 0xA2757E4F,  2 * KILOBYTE,  2,  1,  3,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "4 Sprites"                                      , "Charles Eurich, 2006"                       , "-",                                               169, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN },
  { ARCADIA , MEMMAP_ARCADIA, 0x174EEBF4,  2 * KILOBYTE,  2,  1,  3,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "4 UDCs"                                         , "Charles Eurich, 2006"                       , "-",                                               169, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN },
  { ARCADIA , MEMMAP_ARCADIA, 0xC8604449,  2 * KILOBYTE,  2,  1,  3,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Animate"                                        , "Charles Eurich, 2006"                       , "-",                                               169, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN },
  { ARCADIA , MEMMAP_ARCADIA, 0x995904CC,  2 * KILOBYTE,  2,  1,  3,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Boot Initialization"                            , "Charles Eurich, 2006"                       , "-",                                               169, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN },
  { ARCADIA , MEMMAP_ARCADIA, 0xD7F47588,  4 * KILOBYTE,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Boxer (obsolete)"                               , "Charles Eurich, 2006"                       , "-",                                         A_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN },
  { ARCADIA , MEMMAP_ARCADIA, 0xA2BA446C,  2 * KILOBYTE,  2,  1,  3,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Character Show"                                 , "Charles Eurich, 2006"                       , "-",                                               169, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN },
  { ARCADIA , MEMMAP_ARCADIA, 0x83633401,  2 * KILOBYTE,  2,  1,  3,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Music"                                          , "Charles Eurich, 2006"                       , "-",                                               169, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN },
  { ARCADIA , MEMMAP_ARCADIA, 0x4753B462,  2 * KILOBYTE,  1,  2,  3,  4, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Read Buttons"                                   , "Charles Eurich, 2006"                       , "-",                                         A_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN },
  { ARCADIA , MEMMAP_ARCADIA, 0xD2C7E59C,  2 * KILOBYTE,  2,  1,  3,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_VLOW   ,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Read Paddles"                                   , "Charles Eurich, 2006"                       , "-",                                               171, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN },
  { ARCADIA , MEMMAP_ARCADIA, 0x13244D23,  2 * KILOBYTE,  2,  1,  3,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Show Text"                                      , "Charles Eurich, 2006"                       , "-",                                               169, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN },
  { ARCADIA , MEMMAP_ARCADIA, 0xEC652918,  2 * KILOBYTE,  2,  1,  3,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Character Test 1.12"                            , "Peter Trauner, 2002"                        , "-",                                               169, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN },
  { ARCADIA , MEMMAP_ARCADIA, 0x09B804ED,  2 * KILOBYTE,  2,  1,  3,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Hello 1.02"                                     , "Adam Trionfo, 2002"                         , "-",                                               169, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN },
  { ARCADIA , MEMMAP_ARCADIA, 0xFD175D72,  2 * KILOBYTE,  2,  1,  3,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , BLACK, DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Mothership 1.05"                                , "Adam Trionfo, 2002"                         , "-",                                               169, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN },
  { ARCADIA , MEMMAP_ARCADIA, 0x365856B4,  2 * KILOBYTE,  2,  1,  3,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Sprite 1.02"                                    , "Adam Trionfo, 2002"                         , "-",                                               169, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN },
  { ARCADIA , MEMMAP_ARCADIA, 0x55B4B1F6,  2 * KILOBYTE,  2,  1,  3,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT, 0x00 | 1, FALSE, TRUE , 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 1, 1, 1, 0, 0, 0},{ 0, 0, 0, 0},{ 1, 0, 0, 1, 1, 0},{ 0, 0, 0, 0}, "",         "8 Sprites"                                      , "Gavin Turner, 2007"                         , "-",                                               169, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN },
  { ARCADIA , MEMMAP_ARCADIA, 0x3EDD2C71,  2 * KILOBYTE,  2,  1,  3,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Target 1"                                       , "Gavin Turner, 2005"                         , "-",                                               169, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN },
  { ARCADIA , MEMMAP_ARCADIA, 0xF446A67F,  2 * KILOBYTE,  2,  1,  3,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Target 2"                                       , "Gavin Turner, 2006"                         , "-",                                               169, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN },
  { ARCADIA , MEMMAP_ARCADIA, 0xF848668B,  2 * KILOBYTE,  2,  1,  3,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Colours 1.02"                                   , "Amigan Software, 2005-2006"                 , "-",                                               169, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN },
  { ARCADIA , MEMMAP_ARCADIA, 0xE68C5C15,  2 * KILOBYTE,  2,  1,  3,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Horizontal Scroll 1.01"                         , "Amigan Software, 2003-2005"                 , "-",                                               169, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN },
  { ARCADIA , MEMMAP_ARCADIA, 0xFC4D7DC7,  2 * KILOBYTE,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT, 0x00 | 1, FALSE, TRUE , 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Multiplex 3.2"                                  , "Amigan Software, 2003-2006"                 , "-",                                               164, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN },
  { ARCADIA , MEMMAP_ARCADIA, 0xC8E0C20B,  2 * KILOBYTE,  2,  1,  3,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Sound 3.0"                                      , "Amigan Software, 2003-2006"                 , "-",                                               165, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN },
  { ARCADIA , MEMMAP_ARCADIA, 0x2C402930,  2 * KILOBYTE,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Tester 1 1.02"                                  , "Amigan Software, 2006"                      , "-",                                               166, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN },
  { ARCADIA , MEMMAP_ARCADIA, 0x88078F4B,  2 * KILOBYTE,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Tester 2 1.01"                                  , "Amigan Software, 2007"                      , "-",                                               166, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN },
  { ARCADIA , MEMMAP_ARCADIA, 0xD4BE78B1,  2 * KILOBYTE,  5,  8,  8,  5,  5,  8, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Vertical Scroll 1.02"                           , "Amigan Software, 2005-2006"                 , "-",                                               163, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN },
  { ELEKTOR,  MEMMAP_F,       0x407740F1,  4 * KILOBYTE,  2,  2,  2,  2,  8,  0, 10, 11, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Tester 1 1.01"                                  , "Amigan Software, 2006"                      , "-",                                               167, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { ARCADIA , MEMMAP_I,       0xE0A9DD9A,  4 * KILOBYTE,  2,  1,  3,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "dictiona", "Dictionary (main cart only)"                    , "UA Ltd., 198x"                              , "Palladium 775/118",                                10, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // VIDLEX
  { ARCADIA , MEMMAP_I,       0x320B0A9D,  4 * KILOBYTE,  2,  1,  3,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "dictiona", "Dictionary (English subcart only)"              , "UA Ltd., 198x"                              , "Palladium 775/118",                                10, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // VIDLEXE
  { ARCADIA , MEMMAP_I,       0xB2B9B5D8,  4 * KILOBYTE,  2,  1,  3,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "dictiona", "Dictionary (German subcart only)"               , "UA Ltd., 198x"                              , "Palladium 775/118",                                10, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // VIDLEXG
  { ARCADIA , MEMMAP_ARCADIA, 0xB10A08B5,  8 * KILOBYTE,  2,  1,  3,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "gridiron", "American Football (overdump)"                   , "UA Ltd., 1982"                              , "Emerson #14 (#1017)",                              11,  2,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN },
  { ARCADIA , MEMMAP_ARCADIA, 0x28AD5BCF,  8 * KILOBYTE,  2,  1,  3,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 1, 1, 1, 0, 0, 0},{ 0, 0, 0, 0},{ 1, 0, 0, 1, 1, 0},{ 0, 0, 0, 0}, "autorace", "Auto Race (overdump?)"                          , "UA Ltd., 198x"                              , "MPT-03 MG-320",                                   130, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN },
  { ARCADIA , MEMMAP_ARCADIA, 0xFF013B36,  4 * KILOBYTE,  7,  8,  9,  5,  5,  8,  7,  9, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Frogger 1.03 (obsolete)"                        , "Amigan Software, 200x"                      , "-",                                                40, 16,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // "Frogger v1.03 (200x)(Amigan Software).bin"
  { ARCADIA , MEMMAP_ARCADIA, 0x8286BC61,  2 * KILOBYTE,  7,  8,  9,  5,  5,  8,  7,  9, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   {25,25,25, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "JTron 1.0? (obsolete)"                          , "Amigan Software, 2003?"                     , "-",                                                40, 20,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // "JTron (2003)(Amigan Software)(PD).bin"
  { ARCADIA , MEMMAP_ARCADIA, 0xAC32E456,  2 * KILOBYTE,  7,  8,  9,  5,  5,  8,  7,  9, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   {25,25,25, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "JTron 1.1 (obsolete)"                           , "Amigan Software, 2003?"                     , "-",                                                40, 20,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // "JTron v1.1 (2003)(Amigan Software).bin"
  { INTERTON, MEMMAP_B,       0x78E94A1B,  4 * KILOBYTE,  2,  1,  3,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "math2",    "Math 2 (patched) (obsolete)"                    , "Amigan Software, 200x"                      , "Fountain #8/Interton #6",                           6, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // MATH2!   (F+I)
  { ELEKTOR,  MEMMAP_E,       0x6158CB0C,  8 * KILOBYTE,  3,  2,  1,  3, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 1, 0, 1, 0, 1},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Circledrive (patch 1.0) (obsolete)"             , "Amigan Software, 200x"                      , "ESS-009-3",                                         8, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR,  MEMMAP_F,       0x816CBEEE,  4 * KILOBYTE,  2,  1,  3,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Tester 2 1.0 (obsolete)"                        , "Amigan Software, 2007"                      , "-",                                               168, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { ELEKTOR , MEMMAP_F,       0xD458DC0E,  7 * KILOBYTE,  1,  1,  1,  1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, BLACK,      1,     50, PVI_LATESTSPRITE,      60, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "11-f",     "Cosmic Adventure (enhanced)"                    , "Amigan Software, 2007"                      , "ESS-011-F",                                        63, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // -/F
  { ARCADIA , MEMMAP_ARCADIA, 0x5034F5A1,  4 * KILOBYTE,  7,  8,  9,  5,  5,  8,  7,  9, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Frogger 1.24 (obsolete)"                        , "Amigan Software, 2004-2007"                 , "-",                                                40, 16,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN },
  { ARCADIA , MEMMAP_ARCADIA, 0x566C78A0,  6 * KILOBYTE,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT, 0x70 | 3, TRUE , TRUE , BLACK,      1,      2,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "the-end",  "The End (enhanced)"                             , "Amigan Software, 2007"                      , "Emerson? #? (#?)",                                 36, 44,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // THE-END!
  { ELEKTOR,  MEMMAP_F,       0x53277284,  4 * KILOBYTE,  2,  1,  3,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Tester 2 1.01"                                  , "Amigan Software, 2007"                      , "-",                                               168, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { ELEKTOR , MEMMAP_E,       0x3B7977ED,  4 * KILOBYTE, 10, 11, 10, 11, -1, 11, -1, 10, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "4 in a Row (ESS-003-4) (patched)"               , "Amigan Software, 2007"                      , "ESS-003-4",                                        74, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_E,       0x632DAE6D,  4 * KILOBYTE, 10, 11, 10, 11, -1, 11, -1, 10, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "4 in a Row (ESS-007-6) (patched)"               , "Amigan Software, 2007"                      , "ESS-007-6",                                        74, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_E,       0xA6ED702F,  4 * KILOBYTE, 10, 11, 10, 11, -1, 11, -1, 10, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "4 in a Row (ESS-007-7) (patched)"               , "Amigan Software, 2007"                      , "ESS-007-7",                                        74, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { INTERTON, MEMMAP_A,       0x35C47832,  2 * KILOBYTE, 10, 11, 10, 11, -1, 11, -1, 10, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "challeng", "4 in a Row (patched)"                           , "Amigan Software, 2007"                      , "Interton #15",                                     74, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // 4INAROW! (variant of CHALLEN-)
  { ARCADIA , MEMMAP_ARCADIA, 0x617EEB43,  8 * KILOBYTE,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, TRUE,  TRUE , 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "hobo",     "Hobo (enhanced)"                                , "Amigan Software, 2002-2007"                 , "Emerson? #? (#?)",                                141, 19,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // HOBO!
  { ARCADIA , MEMMAP_ARCADIA, 0x9AEADFB9,  4 * KILOBYTE,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT, 0x30 | 1, TRUE , TRUE , BLACK,      1,      2,                0,       0,          0, 0, DUMP_GOOD,   { 0,25, 0,25, 0,25},{ 0, 0, 0, 0},{ 0,25, 0,25, 0,25},{ 0, 0, 0, 0}, "sattack",  "Space Attack (unknown) (MESS V2 patch 1.0)"     , "Amigan Software, 200x"                      , "?",                                                32, 34,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // SATTACB! (withdrawn but not obsolete)
  { ARCADIA , MEMMAP_ARCADIA, 0x3C6F916C,  2 * KILOBYTE,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT, 0x30 | 1, TRUE , TRUE , BLACK,      1,      2,                0,       0,          0, 0, DUMP_GOOD,   { 0,25, 0,25, 0,25},{ 0, 0, 0, 0},{ 0,25, 0,25, 0,25},{ 0, 0, 0, 0}, "sattack",  "Space War (prototype) (MESS V2 patch 1.1)"      , "Amigan Software, 200x"                      , "Hanimex #2 (#1016)",                               32, 34,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // SATTACC! (withdrawn but not obsolete)
  { ARCADIA , MEMMAP_ARCADIA, 0x58B80428,  6 * KILOBYTE,  2,  2,  2,  2, -1, -1, -1, -1, TRUE , SENSITIVITY_HIGH   ,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 1, 0, 1, 1},{ 0, 0, 0, 1},{ 0, 1, 0, 1, 0, 1},{ 0, 0, 1, 0}, "circus",   "Circus (MESS V1 patch 2.0) (obsolete)"          , "Amigan Software, 200x"                      , "MPT-03 MG-318",                                   134, 10,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // CIRCUS!
  { ARCADIA , MEMMAP_ARCADIA, 0x09A474AE,  8 * KILOBYTE,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT, 0xC0 | 3, FALSE, TRUE , 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "doraemon", "Doraemon (MESS V1 patch 1.0) (obsolete)"        , "Amigan Software, 200x"                      , "Bandai #52",                                      138, 13,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // DORAEMO!
  { ARCADIA , MEMMAP_ARCADIA, 0xE462FA6E,  8 * KILOBYTE,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT, 0xC0 | 2, FALSE, TRUE , 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 1, 1, 1, 1},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "dr-slump", "Dr. Slump (MESS V1 patch 1.1) (obsolete)"       , "Amigan Software, 200x"                      , "Bandai #51",                                      139, 14,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // DR-SLUM!
  { ARCADIA , MEMMAP_I,       0x3859D736, 10 * KILOBYTE,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, TRUE,  TRUE , 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "hobo",     "Hobo (MESS V1 patch 2.0) (obsolete)"            , "Amigan Software, 200x"                      , "Emerson? #? (#?)",                                141, 19,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // HOBO!
  { ARCADIA , MEMMAP_ARCADIA, 0x1A3082F9,  8 * KILOBYTE,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, TRUE , TRUE , BLACK,      1,      2,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 1, 0, 0}, "jumpbug",  "Jump Bug (Emerson) (MESS V1 patch 1.0) (obs.)"  , "Amigan Software, 200x"                      , "Emerson? #? (#?)",                                142, 21,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // JUMPBUG!
  { ARCADIA , MEMMAP_ARCADIA, 0xFF4BC6FF,  4 * KILOBYTE,  2,  1,  3,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 1, 1, 1, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "nibble",   "Nibblemen (MESS V1 patch 1.0) (obsolete)"       , "Amigan Software, 200x"                      , "Ormatu MG-316",                                    20, 26,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // NIBBLE!
  { ARCADIA , MEMMAP_ARCADIA, 0xDBB340BF,  4 * KILOBYTE,  2, 10, 11,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   {25,25,25, 0, 0, 0},{ 0, 0, 0, 0},{25, 0, 0,25,25, 0},{ 0, 0, 0, 0}, "oceanbat", "Ocean Battle (MESS V1 patch 1.0) (obsolete)"    , "Amigan Software, 200x"                      , "Emerson #11 (#1009)",                              24, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, //!OCEANBA!
  { ARCADIA , MEMMAP_ARCADIA, 0x56C4E008,  4 * KILOBYTE,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT, 0x00 | 1, TRUE , TRUE , BLACK,      1,      2,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "redclash", "Red Clash (MESS V1 patch 1.0) (obsolete)"       , "Amigan Software, 200x"                      , "Emerson #12 (#1020)",                             145, 30,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // REDCLAS!
  { ARCADIA , MEMMAP_ARCADIA, 0x8543544E,  4 * KILOBYTE,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT, 0x40 | 3, TRUE , TRUE , 16,         1,      2,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0,25,25, 0, 0, 0},{ 0, 0, 0, 0}, "spiders",  "Spiders (MESS V1 patch 1.0) (obsolete)"         , "Amigan Software, 200x"                      , "Emerson #24 (#1024)",                              36, 39,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // SPIDERS!
  { ARCADIA , MEMMAP_ARCADIA, 0xEACD58B4,  4 * KILOBYTE,  2,  1,  3,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 1, 1, 1, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "supergob", "Super Gobbler (MESS V1 patch 1.0) (obsolete)"   , "Amigan Software, 200x"                      , "Emerson? #? (#?)",                                 20, 26,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // SUPERGO!
  { ARCADIA , MEMMAP_ARCADIA, 0xD1987FF5,  8 * KILOBYTE,  2,  1,  2,  1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT, 0x70 | 7, FALSE, TRUE , BLACK,      1,      3,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0,25,25, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "svulture", "Space Vultures (MESS V1 patch 1.2) (obsolete)"  , "Amigan Software, 200x"                      , "Emerson #7 (#1014)",                               35, 38,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // SVULTUR!
  { ARCADIA , MEMMAP_ARCADIA, 0xEC69267D,  8 * KILOBYTE,  2,  3,  2,  3, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT, 0x00 | 1, FALSE, TRUE , 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "tennis",   "Grand Slam Tennis (MESS V1 patch 1.0) (obs.)"   , "Amigan Software, 200x"                      , "Emerson #21 (#1021)",                              23, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // TENNIS!
  { ELEKTOR , MEMMAP_E,       0x337E7A3C,  4 * KILOBYTE,  2,  1,  3,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Play with the PVI"                              , "?, 1979"                                    , "ESS-003-1",                                       148, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_E,       0x4A75D8EB,  4 * KILOBYTE,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Clock"                                          , "?, 1979"                                    , "ESS-003-2",                                       149, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_E,       0x8A78E207,  4 * KILOBYTE,  2,  1,  3,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO,              228, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Music Box"                                      , "Philips, 1979"                              , "ESS-003-3",                                        66, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_E,       0xA8FE170D,  4 * KILOBYTE, 10, 11, 10, 11, -1, 11, -1, 10, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "4 in a Row (ESS-003-4)"                         , "Philips, 1979"                              , "ESS-003-4",                                        74, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_E,       0x6D15B13E,  4 * KILOBYTE,  4,  8,  6,  2,  2,  8,  4,  6, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE,      47, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Surround (ESS-003-5)"                           , "Philips, 1979"                              , "ESS-003-5",                                        67, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, //!E/-
  { ELEKTOR , MEMMAP_E,       0xD97B72D0,  4 * KILOBYTE, 10, 10, 10, 10, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Locomotive"                                     , "Elektor (Andr Pauptit), 1979"              , "ESS-003-6",                                       150, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_E,       0xDDB40355,  4 * KILOBYTE,  2,  1,  3,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Picture Pattern"                                , "Elektor (Paul V. Holmes), 1979"             , "ESS-006-1",                                       151, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_E,       0xE0501EC9,  4 * KILOBYTE,  2,  1,  3,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "PVI Programming (ESS-006-2)"                    , "Elektor (Paul V. Holmes), 1979"             , "ESS-006-2",                                       147, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_E,       0x6D4637D2,  4 * KILOBYTE,  8,  8,  8,  8,  5,  0,  7,  9, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, BLUE,  DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "07-5",     "Rocket Shooting"                                , "Elektor (Paul V. Holmes), 1979"             , "ESS-006-3",                                        81, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, //!E/-
  { ELEKTOR , MEMMAP_E,       0xCDB52816,  4 * KILOBYTE,  3,  6,  9, 11, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Mastermind"                                     , "H. Trndle, 1980"                           , "ESS-007-1",                                        48, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_E,       0x8BC0C329,  4 * KILOBYTE, 11,  2,  0, 10, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Code Breaker"                                   , "K. Reilly + P. Williams, 1980"              , "ESS-007-2",                                        47, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_E,       0x0BB4A564,  4 * KILOBYTE,  1,  5,  0, 10, 11, 11, 10, 10, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 2, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Reversi"                                        , "H. Trndle, 1980"                           , "ESS-007-3",                                        69, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_E,       0xF42B24A5,  4 * KILOBYTE,  1,  1,  1,  1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Amazone"                                        , "Elektor (Paul V. Holmes), 1980"             , "ESS-007-4",                                        44, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_E,       0x608FE606,  4 * KILOBYTE,  8,  8,  8,  8,  5,  0,  7,  9, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, BLACK, DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "07-5",     "Space Shoot-Out"                                , "Elektor (Paul V. Holmes), 1980"             , "ESS-007-5",                                        81, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, //!E/-
  { ELEKTOR , MEMMAP_E,       0xF0AACE8D,  4 * KILOBYTE, 10, 11, 10, 11, -1, 11, -1, 10, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "4 in a Row (ESS-007-6)"                         , "Philips + H. Trndle, 1979-1980"            , "ESS-007-6",                                        74, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_E,       0x356A10CF,  4 * KILOBYTE, 10, 11, 10, 11, -1, 11, -1, 10, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "4 in a Row (ESS-007-7)"                         , "Philips + H. Trndle, 1979-1980"            , "ESS-007-7",                                        74, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_E,       0x6EE082D5,  4 * KILOBYTE,  2, 10,  0, 11, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Jackpot"                                        , "Elektor (Paul V. Holmes), 1980"             , "ESS-007-8",                                        68, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_E,       0xC36F5BDA,  4 * KILOBYTE,  4,  8,  6,  2,  2,  8,  4,  6, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE,      47, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Surround (ESS-007-9)"                           , "Philips, 1979-1980"                         , "ESS-007-9",                                        67, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, //!E/-
  { ELEKTOR , MEMMAP_E,       0xA37CE1E4,  3 * KILOBYTE, 10, 10, 10, 10, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Shapes"                                         , "P. Williams, 1980"                          , "ESS-007-A",                                       152, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_E,       0x59C2268B,  3 * KILOBYTE,  2,  1,  3,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO,              228, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Piano"                                          , "Philips, 1979-1980"                         , "ESS-007-B",                                        66, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_E,       0xB3FC6C67,  4 * KILOBYTE,  2,  1,  3,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "PVI Programming (ESS-007-C)"                    , "Elektor (Paul V. Holmes), 1979-1980"        , "ESS-007-C",                                       147, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_E,       0xDDB40355,  4 * KILOBYTE,  2,  1,  3,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Test Patterns"                                  , "Elektor (Paul V. Holmes), 1979-1980"        , "ESS-007-E",                                       151, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_E,       0x2C0B67B9,  4 * KILOBYTE,  0, 10,  7, 11, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Lotto"                                          , "Manfred Saliger, 1980"                      , "ESS-007-F",                                       154, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_E,       0x900D9E22,  4 * KILOBYTE,  2,  1,  3,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "09-1",     "Aggressor"                                      , "M. Norman, 198x"                            , "ESS-009-1",                                        82, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_E,       0x5AFF5E53,  4 * KILOBYTE,  8,  3,  1,  8, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Offshore Fishing"                               , "M. Norman, 198x"                            , "ESS-009-2",                                        58, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_E,       0x6C09F1E3,  4 * KILOBYTE,  0,  2,  5,  1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Seawar"                                         , "Paul-Jrgen Dickers, 198x"                  , "ESS-009-4",                                        46, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_ELEKTOR, 0x43B3295C,  5 * KILOBYTE, 10,  0, 11,  7, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO,              265, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Memory"                                         , "Paul-Jrgen Dickers, 198x"                  , "ESS-009-5",                                        62, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/F
  { ELEKTOR , MEMMAP_E,       0xA19AB7FB,  4 * KILOBYTE,  1,  1,  1,  1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 1, 0, 0, 1, 1, 0},{ 0, 1, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Destroyer"                                      , "G. Roberts, 198x"                           , "ESS-009-7",                                        59, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_E,       0xEEA5525D,  4 * KILOBYTE,  8,  1,  8,  1,  5,  0,  7,  9, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, BLACK, DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Starship Enterprise"                            , "M. Norman, 198x"                            , "ESS-009-8",                                        60, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_E,       0xAD905B98,  4 * KILOBYTE,  0, 10,  6,  9, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Blackjack"                                      , "M. Norman, 198x"                            , "ESS-009-9",                                        61, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_E,       0x068165A0,  4 * KILOBYTE, 10,  0, 11, 10, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, TRUE,  EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Card Trick"                                     , "Paul-Jrgen Dickers, 198x"                  , "ESS-009-A",                                        52, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_E,       0x8C1579D0,  4 * KILOBYTE, 10,  0, 11,  9, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Awari"                                          , "Martin Greiner, 198x"                       , "ESS-009-B",                                        53, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_E,       0x7BE35693,  4 * KILOBYTE,  3,  3,  3,  3, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, TRUE,  EFLAG, BLACK, DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 1, 0, 0, 1, 1, 0},{ 0, 0, 0, 0}, "",         "UFO Shooting"                                   , "P. Schmid, 198x"                            , "ESS-009-C",                                        54, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_E,       0x567D3224,  4 * KILOBYTE,  8,  1, 11,  8, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0,10, 0,10, 0},{ 0, 0, 0, 1},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Raster"                                         , "G. Roberts, 198x"                           , "ESS-009-D",                                        55, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_E,       0xFC329059,  4 * KILOBYTE,  2,  1,  3,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE,      57, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Nim"                                            , "H. Trndle, 198x"                           , "ESS-009-E",                                        56, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_E,       0xA3525ACC,  4 * KILOBYTE,  7,  0,  9,  5, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Solitaire"                                      , "G. Roberts, 198x"                           , "ESS-009-F",                                        57, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_F,       0xF4E4D797,  6 * KILOBYTE,  1,  2,  3,  2, -1, -1,  1,  3, FALSE, SENSITIVITY_DEFAULT,        0, TRUE,  EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE,      87, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Pinball"                                        , "Martin Greiner, 198x"                       , "ESS-010-2",                                        73, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, //!-/F
  { ELEKTOR , MEMMAP_E,       0x13E56649,  4 * KILOBYTE,  2,  6,  9,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0,25, 0, 0, 0},{25, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "10-3",     "Helicopter"                                     , "C. Mnnchen, 198x"                          , "ESS-010-3",                                        72, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_E,       0x28828BCC,  4 * KILOBYTE, 10,  0, 11, 10, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, TRUE,  EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE,      55, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Hard Nut"                                       , "Paul-Jrgen Dickers, 198x"                  , "ESS-010-4",                                        83, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, //!E/-
  { ELEKTOR , MEMMAP_E,       0x410D3424,  4 * KILOBYTE,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0,25, 0,25, 0,25},{ 0, 0,25, 0},{ 0, 0,25, 0,25,25},{ 0, 0, 0,25}, "10-5",     "Catapult"                                       , "M. Norman, 198x"                            , "ESS-010-5",                                        71, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_F,       0x9C6B6EBB,  6 * KILOBYTE,  2,  3, 11, 10, -1, -1, -1, -1, TRUE,  SENSITIVITY_MEDIUM ,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE,      58, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Pilot"                                          , "Martin Greiner, 198x"                       , "ESS-010-6",                                        70, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // -/F
  { ELEKTOR , MEMMAP_E,       0x0048322B,  4 * KILOBYTE,  2,  2,  2,  2, -1, -1, -1, -1, TRUE,  SENSITIVITY_LOW    ,        0, FALSE, EFLAG, BLUE,  DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   {25, 0, 0,25,25, 0},{ 0,25, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Attack from Space"                              , "M. Godfrey, 198x"                           , "ESS-010-7",                                        77, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_E,       0x15A90EB4,  4 * KILOBYTE, 10,  9,  8,  7, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Reverse"                                        , "Martin Greiner, 198x"                       , "ESS-010-8",                                        84, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_E,       0xE34220A0,  4 * KILOBYTE,  2,  2,  2,  2, -1, -1, -1, -1, TRUE,  SENSITIVITY_MEDIUM ,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO,              220, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0,25, 0,25, 0,25},{ 0, 0,25, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "10-b",     "Bursting Balloons"                              , "H. Jansen, 198x"                            , "ESS-010-B",                                        85, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_F,       0x5D1C7D36,  6 * KILOBYTE,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Fr Elise"                                      , "K. Schuster, 198x"                          , "ESS-010-C",                                        87, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // -/F
  { ELEKTOR , MEMMAP_F,       0x09317D8A,  4 * KILOBYTE,  2,  1,  3,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE,      54, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Change Words for Hangman"                       , "Elektor (Paul V. Holmes), 198x"             , "ESS-010-1x",                                      156, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // -/F
  { ELEKTOR , MEMMAP_E,       0x1527E074,  4 * KILOBYTE,  8,  1,  1,  8, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Snakes and Ladders"                             , "G. M. Robert, 198x"                         , "ESS-011-1",                                        90, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_E,       0x48EBA79F,  4 * KILOBYTE,  7,  3,  9,  1, -1, -1,  7,  9, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE,      61, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "11-2",     "Molebasher"                                     , "G. M. Robert, 198x"                         , "ESS-011-2",                                        91, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, //!E/-
  { ELEKTOR , MEMMAP_E,       0x46E1C06B,  4 * KILOBYTE,  8,  8,  8,  8, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL,        289, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Snap"                                           , "V. W. Trumann, 198x"                        , "ESS-011-3",                                        92, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_ELEKTOR, 0xB03A3EBD,  5 * KILOBYTE,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Mazes"                                          , "B. A. Sedoni, 198x"                         , "ESS-011-4",                                        93, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/F
  { ELEKTOR , MEMMAP_ELEKTOR, 0xD194B2D9,  6 * KILOBYTE,  8,  1,  3,  2,  1, -1,  7,  9, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, BLUE,       1,      2, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 1, 1, 1, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Asteroids"                                      , "M. V. Norman, 198x"                         , "ESS-011-5",                                        79, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/F
  { ELEKTOR , MEMMAP_E,       0x429D0A9B,  4 * KILOBYTE,  2,  1,  3,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, BLUE,  DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "11-7",     "Omega Landing"                                  , "W. Sembritzki, 198x"                        , "ESS-011-7",                                        49, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_E,       0xAB065283,  4 * KILOBYTE,  1,  1,  1,  1, -1, -1, -1, -1, TRUE,  SENSITIVITY_MEDIUM ,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0,25, 0,25, 0,25},{ 0, 0,25, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "10-b",     "Breakout"                                       , "H. Jansen + N. Hagemann, 198x"              , "ESS-011-8",                                        86, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_F,       0xB5A9FEDD,  5 * KILOBYTE,  2,  1,  3,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 1, 1, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "11-9",     "Tiny Tim"                                       , "W. Sembritzki, 198x"                        , "ESS-011-9",                                        50, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // -/F
  { ELEKTOR , MEMMAP_E,       0x4EE3AE0F,  4 * KILOBYTE,  2, 10, 11,  1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Horse Race + Jackpot"                           , "C. Isoart, 198x"                            , "ESS-011-A",                                        89, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_E,       0xF544EEF0,  4 * KILOBYTE,  2,  1,  3,  0, -1, -1, -1, -1, TRUE,  SENSITIVITY_HIGH   ,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE,      55, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "11-b",     "Newton"                                         , "Peter Marschat, 198x"                       , "ESS-011-B",                                        78, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_F,       0xB41E503E,  5 * KILOBYTE,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Horse Races"                                    , "B. A. Sedonir, 198x"                        , "ESS-011-C",                                        88, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // -/F
  { ELEKTOR , MEMMAP_E,       0x2F10BEE0,  4 * KILOBYTE,  1,  1,  1,  1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 1, 1, 1, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Painting"                                       , "W. Sembritzki, 198x"                        , "ESS-011-D",                                        64, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_E,       0x347C584B,  4 * KILOBYTE,  2,  2,  2,  2, -1, -1, -1, -1, TRUE , SENSITIVITY_MEDIUM ,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE,      79, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Submarines + Racing"                            , "R. Lange, 198x"                             , "ESS-011-E",                                        65, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_E,       0x24DAED9C,  3 * KILOBYTE,  0,  0,  0,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Add 2 (untrimmed)"                              , "Elektor, 1981"                              , "Pages 96-97",                               E_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_E,       0xE1742A1C,  3 * KILOBYTE,  0,  0,  0,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Add 4 (untrimmed)"                              , "Elektor, 1981"                              , "Pages 96-97",                               E_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_E,       0x7256458B,  3 * KILOBYTE,  0,  0,  0,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Minus 2 (untrimmed)"                            , "Elektor, 1981"                              , "Pages 96-97",                               E_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_E,       0xAB977B2D,  3 * KILOBYTE,  0,  0,  0,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Minus 4 (untrimmed)"                            , "Elektor, 1981"                              , "Pages 96-98",                               E_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_F,       0x2AF63BB3,  3 * KILOBYTE,  2,  1,  3,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Explosion aka Table 42 (untrimmed)"             , "Elektor, 1981"                              , "Page 181",                                  E_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // -/F
  { ELEKTOR , MEMMAP_F,       0xC74E777E,  3 * KILOBYTE,  2,  1,  3,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Gunshot aka Table 42 (untrimmed)"               , "Elektor, 1981"                              , "Page 181",                                  E_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // -/F
  { ELEKTOR , MEMMAP_E,       0x18E5FE63,  3 * KILOBYTE,  2,  1,  3,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_VLOW   ,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Joystick aka Table 23 (untrimmed)"              , "Elektor, 1981"                              , "Pages 118-119",                             E_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_E,       0x449032CB,  3 * KILOBYTE,  2,  1,  3,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Message aka Table 15 (untrimmed)"               , "Elektor, 1981"                              , "Pages 103-104",                             E_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_E,       0x97B0FBEC,  3 * KILOBYTE,  2,  1,  3,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Practice (untrimmed)"                           , "Elektor, 1981"                              , "Page 94",                                   E_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_F,       0xD849F992,  3 * KILOBYTE,  2,  1,  3,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Siren (untrimmed)"                              , "Elektor, 1981"                              , "Page 181",                                  E_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // -/F
  { ELEKTOR , MEMMAP_E,       0xD20C783D,  3 * KILOBYTE,  2,  1,  3,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Steam Engine 1 aka Table 3 (untrimmed)"         , "Elektor, 1981"                              , "Pages 34-35",                               E_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_E,       0x7503552D,  3 * KILOBYTE,  3,  3,  3,  3,  5,  0,  7,  9, FALSE, SENSITIVITY_DEFAULT,        0, TRUE,  EFLAG, BLUE,  DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Table A (untrimmed)"                            , "Elektor, 1981"                              , "Page 73",                                         149, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, //*E/-
  { ELEKTOR , MEMMAP_E,       0x03EEBDFE,  3 * KILOBYTE,  3,  3,  3,  3,  5,  0,  7,  9, FALSE, SENSITIVITY_DEFAULT,        0, TRUE,  EFLAG, BLUE,  DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Table B (untrimmed)"                            , "Elektor, 1981"                              , "Pages 73-76",                                     149, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, //*E/-
  { ELEKTOR , MEMMAP_E,       0xA82DFDD4,  3 * KILOBYTE,  3,  3,  3,  3,  5,  0,  7,  9, FALSE, SENSITIVITY_DEFAULT,        0, TRUE,  EFLAG, BLUE,  DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Table C (untrimmed)"                            , "Elektor, 1981"                              , "Pages 73-79",                                     157, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, //*E/-
  { ELEKTOR , MEMMAP_E,       0x5BC2E300,  3 * KILOBYTE,  3,  3,  3,  3,  5,  0,  7,  9, FALSE, SENSITIVITY_DEFAULT,        0, TRUE,  EFLAG, BLUE,  DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Table D (untrimmed)"                            , "Elektor, 1981"                              , "Pages 73-83",                                     158, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, //*E/-
  { ELEKTOR , MEMMAP_E,       0xA7B6456D,  3 * KILOBYTE,  3,  3,  3,  3,  5,  0,  7,  9, FALSE, SENSITIVITY_DEFAULT,        0, TRUE,  EFLAG, BLUE,  DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Table E (untrimmed)"                            , "Elektor, 1981"                              , "Pages 73-85",                                     158, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, //*E/-
  { ELEKTOR , MEMMAP_F,       0x8CCB4AFF,  3 * KILOBYTE,  2,  1,  3,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Wedding March (untrimmed)"                      , "Elektor, 1981"                              , "Pages 183-184",                             E_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // -/F
  { ELEKTOR , MEMMAP_F,       0xE68C74DB,  3 * KILOBYTE,  2,  1,  3,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Wolf Whistle (untrimmed)"                       , "Elektor, 1981"                              , "Page 182",                                  E_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // -/F
  { ELEKTOR , MEMMAP_E,       0x049B13BE,           774,  2,  1,  3,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Play with the PVI"                              , "?, 1979"                                    , "ESS-003-1",                                       148, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_TVC }, // E/- $900/$900 spielen_mit_dem_pvi
  { ELEKTOR , MEMMAP_E,       0x3EB20A14,           774,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Clock"                                          , "?, 1979"                                    , "ESS-003-2",                                       149, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_TVC }, // E/-           uhr
  { ELEKTOR , MEMMAP_E,       0x27936552,           774,  2,  1,  3,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO,              228, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Music Box"                                      , "Philips, 1979"                              , "ESS-003-3",                                        66, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_TVC }, // E/-           musikbox
  { ELEKTOR , MEMMAP_E,       0xDB0AC12C,          1797, 10, 11, 10, 11, -1, 11, -1, 10, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "4 in a Row (ESS-003-4)"                         , "Philips, 1979"                              , "ESS-003-4",                                        74, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_TVC }, // E/-           4_in_einer_reihe_ess034
  { ELEKTOR , MEMMAP_E,       0x1EE1671F,          1797,  4,  8,  6,  2,  2,  8,  4,  6, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE,      47, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Surround (ESS-003-5)"                           , "Philips, 1979"                              , "ESS-003-5",                                        67, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_TVC }, //!E/- $900/$900 surround
  { ELEKTOR , MEMMAP_E,       0x4071464B,           774, 10, 10, 10, 10, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Locomotive"                                     , "Elektor (Andr Pauptit), 1979"              , "ESS-003-6",                                       150, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_TVC }, // E/-           demonstrationsprogramm
  { ELEKTOR , MEMMAP_E,       0xF6EDB39A,          1861,  2,  1,  3,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Picture Pattern"                                , "Elektor (Paul V. Holmes), 1979"             , "ESS-006-1",                                       151, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_TVC }, // E/- $8C0/$8C0 bildmuster
  { ELEKTOR , MEMMAP_E,       0x93A4C8E8,          1797,  2,  1,  3,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "PVI Programming (ESS-006-2)"                    , "Elektor (Paul V. Holmes), 1979"             , "ESS-006-2",                                       147, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_TVC }, // E/- $900/$900 pvi_programmierung_ess062
  { ELEKTOR , MEMMAP_E,       0xF8B41252,          1077,  8,  8,  8,  8,  5,  0,  7,  9, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, BLUE,  DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "07-5",     "Rocket Shooting"                                , "Elektor (Paul V. Holmes), 1979"             , "ESS-006-3",                                        81, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_TVC }, //!E/- $8C0/$900 rakete_abschiessen
  { ELEKTOR , MEMMAP_E,       0xBC5443B5,          1747,  3,  6,  9, 11, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Mastermind"                                     , "H. Trndle, 1980"                           , "ESS-007-1",                                        48, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_TVC }, // E/-
  { ELEKTOR , MEMMAP_E,       0x8FA9AAAF,          1541, 11,  2,  0, 10, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Code Breaker"                                   , "K. Reilly + P. Williams, 1980"              , "ESS-007-2",                                        47, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_TVC }, // E/- $900/$900 kode_knacker
  { ELEKTOR , MEMMAP_E,       0x78407345,          1797,  1,  5,  0, 10, 11, 11, 10, 10, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 2, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Reversi"                                        , "H. Trndle, 1980"                           , "ESS-007-3",                                        69, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_TVC }, // E/- $900/$900 reversi
  { ELEKTOR , MEMMAP_E,       0xCCDF96C7,          1850,  1,  1,  1,  1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Amazone"                                        , "Elektor (Paul V. Holmes), 1980"             , "ESS-007-4",                                        44, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_TVC }, // E/-           amazone
  { ELEKTOR , MEMMAP_E,       0x6B1B3DF7,          1482,  8,  8,  8,  8,  5,  0,  7,  9, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, BLACK, DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "07-5",     "Space Shoot-Out"                                , "Elektor (Paul V. Holmes), 1980"             , "ESS-007-5",                                        81, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_TVC }, //!E/- $8C0/$900 weltraumschlacht
  { ELEKTOR , MEMMAP_E,       0xFB5369A2,          1285, 10, 11, 10, 11, -1, 11, -1, 10, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "4 in a Row (ESS-007-6)"                         , "Philips + H. Trndle, 1979-1980"            , "ESS-007-6",                                        74, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_TVC }, // E/-           4_in_einer_reihe_ess076
  { ELEKTOR , MEMMAP_E,       0x0F89B852,          1453, 10, 11, 10, 11, -1, 11, -1, 10, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "4 in a Row (ESS-007-7)"                         , "Philips + H. Trndle, 1979-1980"            , "ESS-007-7",                                        74, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_TVC }, // E/-           4_in_einer_reihe
  { ELEKTOR , MEMMAP_E,       0x15F1D592,          1826,  2, 10,  0, 11, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Jackpot"                                        , "Elektor (Paul V. Holmes), 1980"             , "ESS-007-8",                                        68, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_TVC }, // E/-
  { ELEKTOR , MEMMAP_E,       0xB09B8DFB,          1797,  4,  8,  6,  2,  2,  8,  4,  6, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE,      47, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Surround (ESS-007-9)"                           , "Philips, 1979-1980"                         , "ESS-007-9",                                        67, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_TVC }, //!E/- $900/$900 umzingelung
  { ELEKTOR , MEMMAP_E,       0x9853EB12,           511, 10, 10, 10, 10, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Shapes"                                         , "P. Williams, 1980"                          , "ESS-007-A",                                       152, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_TVC }, // E/- $900/$900 figurenraten
  { ELEKTOR , MEMMAP_E,       0xCAC3F0CD,           719,  2,  1,  3,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO,              228, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Piano"                                          , "Philips, 1979-1980"                         , "ESS-007-B",                                        66, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_TVC }, // E/-
  { ELEKTOR , MEMMAP_E,       0xC008BA46,          1797,  2,  1,  3,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "PVI Programming (ESS-007-C)"                    , "Elektor (Paul V. Holmes), 1979-1980"        , "ESS-007-C",                                       147, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_TVC }, // E/- $900/$900 pvi_programmierung
  { ELEKTOR , MEMMAP_E,       0x50BFE2F1,          5875,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Disassembler"                                   , "Manfred Saliger + Paul V. Holmes, 1980"     , "ESS-007-D",                                       153, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_TVC }, // E/-           disassembler
  { ELEKTOR , MEMMAP_E,       0xF6EDB39A,          1861,  2,  1,  3,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Test Patterns"                                  , "Elektor (Paul V. Holmes), 1979-1980"        , "ESS-007-E",                                       151, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_TVC }, // E/- $8C0/$8C0 testbilder
  { ELEKTOR , MEMMAP_E,       0x5FFFB198,          1797,  0, 10,  7, 11, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Lotto"                                          , "Manfred Saliger, 1980"                      , "ESS-007-F",                                       154, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_TVC }, // E/-           lotto
  { ELEKTOR , MEMMAP_E,       0xA472ED35,          1827,  2,  1,  3,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "09-1",     "Aggressor"                                      , "M. Norman, 198x"                            , "ESS-009-1",                                        82, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_TVC }, // E/-           angreifer
  { ELEKTOR , MEMMAP_E,       0x67C3D6D7,          1861,  8,  3,  1,  8, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Offshore Fishing"                               , "M. Norman, 198x"                            , "ESS-009-2",                                        58, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_TVC }, // E/- $8C0/$900 hochsee_angeln
  { ELEKTOR , MEMMAP_E,       0x00D8860D,          5874,  3,  2,  1,  3, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 1, 0, 1, 0, 1},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Circledrive"                                    , "M. Norman, 198x"                            , "ESS-009-3",                                         8, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_TVC }, // E/-           rundfahrt
  { ELEKTOR , MEMMAP_E,       0x1FFD27C2,          1797,  0,  2,  5,  1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Seawar"                                         , "Paul-Jrgen Dickers, 198x"                  , "ESS-009-4",                                        46, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_TVC }, // E/-           seekrieg
  { ELEKTOR , MEMMAP_ELEKTOR, 0xD339CBB7,          2390, 10,  0, 11,  7, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO,              265, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Memory"                                         , "Paul-Jrgen Dickers, 198x"                  , "ESS-009-5",                                        62, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_TVC }, // E/F $8C0/$900 memory
  { ELEKTOR , MEMMAP_ELEKTOR, 0x3F21BDF6,          4348,  1,  0, 10,  1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO,              257, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 1, 0, 1, 1},{ 0, 0, 0, 1},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "09-6",     "Labyrinth"                                      , "Elektor (Paul V. Holmes), 198x"             , "ESS-009-6",                                        51, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_TVC }, // E/F $8C0/$900 labyrinth
  { ELEKTOR , MEMMAP_E,       0xDCC5FC4F,          1784,  1,  1,  1,  1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 1, 0, 0, 1, 1, 0},{ 0, 1, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Destroyer"                                      , "G. Roberts, 198x"                           , "ESS-009-7",                                        59, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_TVC }, // E/-           zerstoerer
  { ELEKTOR , MEMMAP_E,       0xE9937B86,          1501,  8,  1,  8,  1,  5,  0,  7,  9, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, BLACK, DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Starship Enterprise"                            , "M. Norman, 198x"                            , "ESS-009-8",                                        60, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_TVC }, // E/-           raumschiff_enterprise
  { ELEKTOR , MEMMAP_E,       0x90ACD31C,          1861,  0, 10,  6,  9, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Blackjack"                                      , "M. Norman, 198x"                            , "ESS-009-9",                                        61, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_TVC }, // E/-           17_und_4
  { ELEKTOR , MEMMAP_E,       0x7FF32E0B,          1857, 10,  0, 11, 10, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, TRUE,  EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Card Trick"                                     , "Paul-Jrgen Dickers, 198x"                  , "ESS-009-A",                                        52, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_TVC }, // E/-           kartentrick
  { ELEKTOR , MEMMAP_E,       0xB129F154,          1861, 10,  0, 11,  9, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Awari"                                          , "Martin Greiner, 198x"                       , "ESS-009-B",                                        53, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_TVC }, // E/-           awari
  { ELEKTOR , MEMMAP_E,       0x825CAECC,           985,  3,  3,  3,  3, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, TRUE,  EFLAG, BLACK, DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 1, 0, 0, 1, 1, 0},{ 0, 0, 0, 0}, "",         "UFO Shooting"                                   , "P. Schmid, 198x"                            , "ESS-009-C",                                        54, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_TVC }, // E/- $8C0/$932 ufo_abschuss
  { ELEKTOR , MEMMAP_E,       0x84660731,          1332,  8,  1, 11,  8, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0,10, 0,10, 0},{ 0, 0, 0, 1},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Raster"                                         , "G. Roberts, 198x"                           , "ESS-009-D",                                        55, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_TVC }, // E/- $8C0/$900 raster
  { ELEKTOR , MEMMAP_E,       0xC8466D70,          1813,  2,  1,  3,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE,      57, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Nim"                                            , "H. Trndle, 198x"                           , "ESS-009-E",                                        56, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_TVC }, // E/-           nim
  { ELEKTOR , MEMMAP_E,       0x9E6ED248,          1861,  7,  0,  9,  5, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Solitaire"                                      , "G. Roberts, 198x"                           , "ESS-009-F",                                        57, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_TVC }, // E/-           solitaer
  { ELEKTOR , MEMMAP_F,       0x39402B84,          5874,  7,  1,  9,  8, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, BLUE,  DEF_DN, DEF_TO, PVI_LATESTSPRITE,      64, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Invaders"                                       , "M. Norman, 198x"                            , "ESS-010-1",                                        43, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_TVC }, // E/-           eindringlinge
  { ELEKTOR , MEMMAP_F,       0x5A2DA9C2,          3396,  1,  2,  3,  2, -1, -1,  1,  3, FALSE, SENSITIVITY_DEFAULT,        0, TRUE,  EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE,      87, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Pinball"                                        , "Martin Greiner, 198x"                       , "ESS-010-2",                                        73, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_TVC }, //!-/F           flipper
  { ELEKTOR , MEMMAP_E,       0x2ED9EECD,          1861,  2,  6,  9,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0,25, 0, 0, 0},{25, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "10-3",     "Helicopter"                                     , "C. Mnnchen, 198x"                          , "ESS-010-3",                                        72, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_TVC }, // E/- $8C0/$900 hubschrauber
  { ELEKTOR , MEMMAP_E,       0x5B765DED,          1797, 10,  0, 11, 10, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, TRUE,  EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE,      55, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Hard Nut"                                       , "Paul-Jrgen Dickers, 198x"                  , "ESS-010-4",                                        83, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_TVC }, //!E/-           harte_nuss
  { ELEKTOR , MEMMAP_E,       0xCEA44AF4,          1707,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0,25, 0,25, 0,25},{ 0, 0,25, 0},{ 0, 0,25, 0,25,25},{ 0, 0, 0,25}, "10-5",     "Catapult"                                       , "M. Norman, 198x"                            , "ESS-010-5",                                        71, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_TVC }, // E/-           katapult
  { ELEKTOR , MEMMAP_F,       0xA287992D,          3396,  2,  3, 11, 10, -1, -1, -1, -1, TRUE,  SENSITIVITY_MEDIUM ,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE,      58, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Pilot"                                          , "Martin Greiner, 198x"                       , "ESS-010-6",                                        70, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_TVC }, // -/F           pilot
  { ELEKTOR , MEMMAP_E,       0x3D74BAAF,          1861,  2,  2,  2,  2, -1, -1, -1, -1, TRUE,  SENSITIVITY_LOW    ,        0, FALSE, EFLAG, BLUE,  DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   {25, 0, 0,25,25, 0},{ 0,25, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Attack from Space"                              , "M. Godfrey, 198x"                           , "ESS-010-7",                                        77, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_TVC }, // E/-           angriff_aus_dem_all
  { ELEKTOR , MEMMAP_E,       0xDFDE0699,          1842, 10,  9,  8,  7, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Reverse"                                        , "Martin Greiner, 198x"                       , "ESS-010-8",                                        84, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_TVC }, // E/- $8C0/$900 reverse
  { ELEKTOR , MEMMAP_E,       0x76F288A3,          5875,  8,  1,  3,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, BLUE,  DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Rocket Hunting"                                 , "M. Norman, 198x"                            , "ESS-010-9",                                        75, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_TVC }, // E/- $8C0/$900
  { ELEKTOR , MEMMAP_E,       0xADB2A6AF,          5872,  8,  1,  3,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, BLUE,  DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_BAD,    { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Rocket Hunting (bad dump)"                      , "M. Norman, 198x"                            , "ESS-010-9",                                        75, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_TVC }, // E/- $8C3/$900 raketenjagd
  { ELEKTOR , MEMMAP_F,       0x36541AE3,          4165,  1,  2,  3,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO,              258, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Basketball"                                     , "Martin Greiner, 198x"                       , "ESS-010-A",                                        76, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_TVC }, //!-/F           basketball
  { ELEKTOR , MEMMAP_E,       0xDE7EA824,          1861,  2,  2,  2,  2, -1, -1, -1, -1, TRUE,  SENSITIVITY_MEDIUM ,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO,              220, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0,25, 0,25, 0,25},{ 0, 0,25, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "10-b",     "Bursting Balloons"                              , "H. Jansen, 198x"                            , "ESS-010-B",                                        85, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_TVC }, // E/- $8C0/$900 platzende_ballons_ess10b
  { ELEKTOR , MEMMAP_F,       0x42B805C6,          3158,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Fr Elise"                                      , "K. Schuster, 198x"                          , "ESS-010-C",                                        87, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_TVC }, // -/F           fuer_elise
  { ELEKTOR , MEMMAP_F,       0x9D1A5ED0,          1541,  2,  1,  3,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Editor"                                         , "Elektor (Paul V. Holmes), 198x"             , "ESS-010-D",                                       155, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_TVC }, // -/F           editor
  { ELEKTOR , MEMMAP_F,       0x4CB754CE,          4101, 10,  0, 11,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, TRUE,  EFLAG, 16,    DEF_DN, DEF_TO,              266,      54, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Galgenspiel"                                    , "Paul-Jrgen Dickers, 198x"                  , "ESS-010-E",                                        45, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_TVC }, // -/F           galgenspiel
  { ELEKTOR , MEMMAP_F,       0xFE5FCFB5,          4165, 10,  0, 11,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, TRUE,  EFLAG, 16,    DEF_DN, DEF_TO,              266,      54, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Hangman"                                        , "Paul-Jrgen Dickers + Paul V. Holmes, 198x" , "ESS-010-F",                                        45, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_TVC }, // -/F           hangman
  { ELEKTOR , MEMMAP_F,       0x3D4580A3,          1813,  2,  1,  3,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE,      54, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Change Words for Hangman"                       , "Elektor (Paul V. Holmes), 198x"             , "ESS-010-1",                                       156, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_TVC }, // -/Fx          wortaenderungsprogramm
  { ELEKTOR , MEMMAP_E,       0x281B68F0,          1861,  8,  1,  1,  8, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Snakes and Ladders"                             , "G. M. Robert, 198x"                         , "ESS-011-1",                                        90, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_TVC }, // E/-           schlangen_und_leitern
  { ELEKTOR , MEMMAP_E,       0x39B9616B,          1851,  7,  3,  9,  1, -1, -1,  7,  9, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE,      61, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "11-2",     "Molebasher"                                     , "G. M. Robert, 198x"                         , "ESS-011-2",                                        91, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_TVC }, //!E/- $8C0/$900 maulwurfschlaeger
  { ELEKTOR , MEMMAP_E,       0x7BDD48EF,          1861,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL,        289, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Snap"                                           , "V. W. Trumann, 198x"                        , "ESS-011-3",                                        92, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_TVC }, // E/-           identa
  { ELEKTOR , MEMMAP_ELEKTOR, 0xFB3727C4,          2130,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Mazes"                                          , "B. A. Sedoni, 198x"                         , "ESS-011-4",                                        93, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_TVC }, // E/F $8C0/$900 labyrinthe
  { ELEKTOR , MEMMAP_ELEKTOR, 0x6B20453B,          2954,  8,  1,  3,  2,  1, -1,  7,  9, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, BLUE,       1,      2, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 1, 1, 1, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Asteroids"                                      , "M. V. Norman, 198x"                         , "ESS-011-5",                                        79, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_TVC }, // E/F           asteroids
  { ELEKTOR , MEMMAP_F,       0x7F67C41A,          4101,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_VHIGH  ,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE,      56,        282, 1, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Dragster"                                       , "Hans-Heinz Bieling, 198x"                   , "ESS-011-6",                                        94, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_TVC }, // -/F           autorennen
  { ELEKTOR , MEMMAP_E,       0x7FA1821F,          1861,  2,  1,  3,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, BLUE,  DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "11-7",     "Omega Landing"                                  , "W. Sembritzki, 198x"                        , "ESS-011-7",                                        49, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_TVC }, // E/-           landemanoever
  { ELEKTOR , MEMMAP_E,       0x963ADA07,          1861,  1,  1,  1,  1, -1, -1, -1, -1, TRUE,  SENSITIVITY_MEDIUM ,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0,25, 0,25, 0,25},{ 0, 0,25, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "10-b",     "Breakout"                                       , "H. Jansen + N. Hagemann, 198x"              , "ESS-011-8",                                        86, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_TVC }, // E/- $8C0/$900 platzende_ballons
  { ELEKTOR , MEMMAP_F,       0x94417986,          2373,  2,  1,  3,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 1, 1, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "11-9",     "Tiny Tim"                                       , "W. Sembritzki, 198x"                        , "ESS-011-9",                                        50, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_TVC }, // -/F           der_kleine_tim
  { ELEKTOR , MEMMAP_E,       0x73DF268B,          1861,  2, 10, 11,  1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Horse Race + Jackpot"                           , "C. Isoart, 198x"                            , "ESS-011-A",                                        89, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_TVC }, // E/- $8C0/$900 pferdewette_einarmiger_bandit
  { ELEKTOR , MEMMAP_E,       0x86B038D1,          1797,  2,  1,  3,  0, -1, -1, -1, -1, TRUE,  SENSITIVITY_HIGH   ,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE,      55, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "11-b",     "Newton"                                         , "Peter Marschat, 198x"                       , "ESS-011-B",                                        78, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_TVC }, // E/-           apfelfangen
  { ELEKTOR , MEMMAP_F,       0x4CDBB610,          2373,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Horse Races"                                    , "B. A. Sedonir, 198x"                        , "ESS-011-C",                                        88, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_TVC }, // -/F $8C0/$900 springturnier
  { ELEKTOR , MEMMAP_E,       0x122C3664,          1861,  1,  1,  1,  1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 1, 1, 1, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Painting"                                       , "W. Sembritzki, 198x"                        , "ESS-011-D",                                        64, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_TVC }, // E/- $8C0/$900 malkasten
  { ELEKTOR , MEMMAP_E,       0xF9F6942A,          1860,  2,  2,  2,  2, -1, -1, -1, -1, TRUE,  SENSITIVITY_MEDIUM ,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE,      79, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Submarines + Racing"                            , "R. Lange, 198x"                             , "ESS-011-E",                                        65, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_TVC }, // E/- $8C0/$900 uboot_gegenverkehr
  { ELEKTOR , MEMMAP_F,       0xE059D788,          4573,  1,  1,  1,  1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, BLACK,      1,     50, PVI_LATESTSPRITE,      60, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "11-f",     "Cosmic Adventure"                               , "N. Hagemann, 198x"                          , "ESS-011-F",                                        63, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_TVC }, // -/F $8C0/$900 galactische_eroberung
  { ELEKTOR , MEMMAP_E,       0x57A7FE9E,            45,  0,  0,  0,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Add 2"                                          , "Elektor, 1981"                              , "Pages 96-97",                               E_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_TVC }, // E/-
  { ELEKTOR , MEMMAP_E,       0xBC3D5AB2,            65,  0,  0,  0,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Add 4"                                          , "Elektor, 1981"                              , "Pages 96-97",                               E_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_TVC }, // E/-
  { ELEKTOR , MEMMAP_E,       0x6CD80D9E,            45,  0,  0,  0,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Minus 2"                                        , "Elektor, 1981"                              , "Pages 96-97",                               E_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_TVC }, // E/-
  { ELEKTOR , MEMMAP_E,       0x03F71EAE,            65,  0,  0,  0,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Minus 4"                                        , "Elektor, 1981"                              , "Pages 96-98",                               E_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_TVC }, // E/-
  { ELEKTOR , MEMMAP_E,       0x0474A87C,           225,  2,  1,  3,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_VLOW   ,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Joystick aka Table 23"                          , "Elektor, 1981"                              , "Pages 118-119",                             E_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_TVC }, // E/-
  { ELEKTOR , MEMMAP_E,       0xF150EFA1,           414,  2,  1,  3,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Message aka Table 15"                           , "Elektor, 1981"                              , "Pages 103-104",                             E_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_TVC }, // E/- $8B9/$9C7
  { ELEKTOR , MEMMAP_E,       0x1D48BE29,            98,  2,  1,  3,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Practice"                                       , "Elektor, 1981"                              , "Page 94",                                   E_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_TVC }, // E/-
  { ELEKTOR , MEMMAP_E,       0x3ED1B240,           455,  2,  1,  3,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Steam Engine 1 aka Table 3"                     , "Elektor, 1981"                              , "Pages 34-35",                               E_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_TVC }, // E/-
  { ELEKTOR , MEMMAP_E,       0x26F6F864,            60,  3,  3,  3,  3,  5,  0,  7,  9, FALSE, SENSITIVITY_DEFAULT,        0, TRUE,  EFLAG, BLUE,  DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_BAD,    { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Table A (bad dump)"                             , "Elektor, 1981"                              , "Page 73",                                         149, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_TVC }, //*E/- aka ship.tvc
  { ELEKTOR , MEMMAP_E,       0xD7B6FC2B,            94,  3,  3,  3,  3,  5,  0,  7,  9, FALSE, SENSITIVITY_DEFAULT,        0, TRUE,  EFLAG, BLUE,  DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_BAD,    { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Table B (bad dump)"                             , "Elektor, 1981"                              , "Pages 73-76",                                     149, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_TVC }, //*E/-
  { ELEKTOR , MEMMAP_E,       0xDD2A5CAF,           175,  3,  3,  3,  3,  5,  0,  7,  9, FALSE, SENSITIVITY_DEFAULT,        0, TRUE,  EFLAG, BLUE,  DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_BAD,    { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Table C (bad dump)"                             , "Elektor, 1981"                              , "Pages 73-79",                                     157, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_TVC }, //*E/-
  { ELEKTOR , MEMMAP_E,       0x1315D774,           237,  3,  3,  3,  3,  5,  0,  7,  9, FALSE, SENSITIVITY_DEFAULT,        0, TRUE,  EFLAG, BLUE,  DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_BAD,    { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Table D (bad dump)"                             , "Elektor, 1981"                              , "Pages 73-83",                                     158, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_TVC }, //*E/-
  { ELEKTOR , MEMMAP_E,       0x1B3D8BDA,           278,  3,  3,  3,  3,  5,  0,  7,  9, FALSE, SENSITIVITY_DEFAULT,        0, TRUE,  EFLAG, BLUE,  DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_BAD,    { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Table E (bad dump)"                             , "Elektor, 1981"                              , "Pages 73-85",                                     158, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_TVC }, //*E/-
  { ELEKTOR , MEMMAP_E,       0x67BED55D,  8 * KILOBYTE,  3,  2,  1,  3, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 1, 0, 1, 0, 1},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Circledrive (patched)"                          , "Amigan Software, 2007"                      , "ESS-009-3",                                         8, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ARCADIA , MEMMAP_ARCADIA, 0xC00DE933,  2 * KILOBYTE,  2,  1,  3,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , BLACK, DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 1, 1, 1, 0, 0, 0},{ 0, 0, 0, 0},{ 1, 0, 0, 1, 1, 0},{ 0, 0, 0, 0}, "",         "Scroller 1.0"                                   , "Amigan Software, 2007"                      , "-",                                         A_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN },
  { ARCADIA , MEMMAP_ARCADIA, 0x2AE9ABE1,  2 * KILOBYTE,  2,  1,  3,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Arcadia stub 1.0"                               , "Amigan Software, 2007"                      , "-",                                         A_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN },
  { INTERTON, MEMMAP_A,       0x4CDC29A8,  2 * KILOBYTE,  2,  1,  3,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Interton stub 1.0"                              , "Amigan Software, 2007"                      , "-",                                         A_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN },
  { ELEKTOR , MEMMAP_E,       0x272D5A21,           237,  3,  3,  3,  3,  5,  0,  7,  9, FALSE, SENSITIVITY_DEFAULT,        0, TRUE,  EFLAG, BLUE,  DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_BAD,    { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Table D (bad dump) (untrimmed)"                 , "Elektor, 1981"                              , "Pages 73-83",                               E_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_E,       0xD38E95DB,           278,  3,  3,  3,  3,  5,  0,  7,  9, FALSE, SENSITIVITY_DEFAULT,        0, TRUE,  EFLAG, BLUE,  DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Table E (untrimmed)"                            , "Elektor, 1981"                              , "Pages 73-85",                               E_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_F,       0x124A4635,  8 * KILOBYTE,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_OK,     { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Rapid Loading Games loader (2716) (untrimmed)"  , "Elektor, 1982"                              , "Elektor mag, Sep 1982",                     E_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // -/F
  { ELEKTOR , MEMMAP_F,       0x379948D4,  8 * KILOBYTE,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_OK,     { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Rapid Loading Games loader (2732) (untrimmed)"  , "Elektor, 1982"                              , "Elektor mag, Sep 1982",                     E_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // -/F
  { ELEKTOR , MEMMAP_F,       0xC768BE9F,  8 * KILOBYTE,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_OK,     { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Rapid Loading Games saver (untrimmed)"          , "Elektor, 1982"                              , "Elektor mag, Sep 1982",                     E_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // -/F
  { ELEKTOR , MEMMAP_F,       0x98F99BB3,  9 * KILOBYTE,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_OK,     { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Rapid Loading Games calculator (untrimmed)"     , "Elektor, 1982"                              , "Elektor mag, Sep 1982",                     E_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // -/F (  9K)
  { ELEKTOR , MEMMAP_F,       0x71266A50,          8704,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_OK,     { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Rapid Loading Games calculator (untrimmed)"     , "Elektor, 1982"                              , "Elektor mag, Sep 1982",                     E_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // -/F (8.5K)
  { PIPBUG  , MEMMAP_J,       0x90D22938,          1280, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Answer Back"                                    , "Electronics Australia (Jamieson Rowe), 1977", "EA mag, Mar 1977 (2/CC/18)",                P_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PIPBUG  , MEMMAP_J,       0x9923E750,          1280, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Guessing Game (machine code version)"           , "Applied Technology (Perry Brown), 1977"     , "EA mag, Oct 1977 (2/CC/21)",                P_OVERLAY, -1,   0,  12, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PIPBUG  , MEMMAP_J,       0xCE23BADC,          1280, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Nim"                                            , "Applied Technology (Perry Brown), 1977"     , "EA mag, Oct 1977 (2/CC/21)",                P_OVERLAY, -1,  41,  54, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PIPBUG  , MEMMAP_J,       0x9370C383,          1280, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_BAD,    { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Message Editor (bad dump)"                      , "Applied Technology (Perry Brown), 1977"     , "EA mag, Oct 1977 (2/CC/21)",                P_OVERLAY, -1,  29,  40, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PIPBUG  , MEMMAP_J,       0x51BBD078,          1280, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Random Number Generator"                        , "Applied Technology (Perry Brown), 1977"     , "Applied Technology documents",              P_OVERLAY, -1,  55,  66, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { ARCADIA , MEMMAP_ARCADIA, 0x7C38DDCA,  8 * KILOBYTE,  2,  5,  8,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "3dsoccer", "3D Soccer (enhanced)"                           , "Amigan Software, 2008"                      , "Emerson? #? (#?)",                                128,  0,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // 3DSOCCE!
  { ARCADIA , MEMMAP_ARCADIA, 0xEDFFBB35,  6 * KILOBYTE,  1,  7, 11, 10, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "gridiron", "American Football (enhanced)"                   , "Amigan Software, 2008"                      , "Emerson #14 (#1017)",                              11,  2,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN }, // GRIDIRO!
  { ARCADIA , MEMMAP_I,       0x5C4CE2AA, 16 * KILOBYTE,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "16K Example 1.0 (rescinded)"                    , "Amigan Software, 2008"                      , "-",                                         A_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN },
  { ARCADIA , MEMMAP_ARCADIA, 0x42F106E3,  8 * KILOBYTE,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "8K Example 1.0"                                 , "Amigan Software, 2008"                      , "-",                                         A_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN },
  { ARCADIA , MEMMAP_I,       0x9841C45E, 31 * KILOBYTE,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "31K Example 1.0"                                , "Amigan Software, 2008"                      , "-",                                         A_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN },
  { ARCADIA , MEMMAP_ARCADIA, 0xBD6A6645,          4013,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "BoxBoy (alpha version) (obsolete)"              , "Charles Eurich, 2006-2008"                  , "-",                                         A_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN },
  { ELEKTOR , MEMMAP_F,       0x50BD3F22,          3072,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Noise Explosion (untrimmed)"                    , "Elektor, 1982"                              , "Elektor mag (German), Jul/Aug 1982, p. 63", E_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
 {INSTRUCTOR, MEMMAP_N,       0x6F4D74BB,          6080, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, PARALLEL_DEFAULT,    0,INTSEL_DEFAULT,INTDIR_DEFAULT,16,DEF_DN,DEF_TO,             0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "DISLSD Example"                                 , "Signetics, 1980"                            , "Page 21",                                   S_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
 {INSTRUCTOR, MEMMAP_N,       0x5E13E608,          6080, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, PARALLEL_DEFAULT,    0,INTSEL_DEFAULT,INTDIR_DEFAULT,16,DEF_DN,DEF_TO,             0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "DISPLY Example"                                 , "Signetics, 1980"                            , "Page 20",                                   S_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
 {INSTRUCTOR, MEMMAP_N,       0xB984BE9A,          6080, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, PARALLEL_DEFAULT,    0,INTSEL_DEFAULT,INTDIR_DEFAULT,16,DEF_DN,DEF_TO,             0,       0,          0, 0, DUMP_BAD,    { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "GNPA Example (bad dump)"                        , "Signetics, 1980"                            , "Pages 22-23",                               S_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // withdrawn
 {INSTRUCTOR, MEMMAP_N,       0x384F7922,          6080, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, PARALLEL_DEFAULT,    0,INTSEL_DEFAULT,INTDIR_DEFAULT,16,DEF_DN,DEF_TO,             0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "MOV Example"                                    , "Signetics, 1980"                            , "Page 19",                                   S_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
 {INSTRUCTOR, MEMMAP_N,       0x9326CE28,          6080, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, PARALLEL_DEFAULT,    0,INTSEL_DEFAULT,INTDIR_DEFAULT,16,DEF_DN,DEF_TO,             0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "USRDSP Example"                                 , "Signetics, 1980"                            , "Page 21",                                   S_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
 {INSTRUCTOR, MEMMAP_N,       0x9202DC0A,          6080, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, PARALLEL_DEFAULT,    0,INTSEL_DEFAULT,INTDIR_DEFAULT,16,DEF_DN,DEF_TO,             0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Show Keys 1.0 (obsolete)"                       , "Amigan Software, 2008"                      , "-",                                         S_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
 {INSTRUCTOR, MEMMAP_N,       0xC9FA8274,          6080, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, PARALLEL_DEFAULT,    0,INTSEL_DEFAULT,INTDIR_DEFAULT,16,DEF_DN,DEF_TO,             0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Scroller 1.0 (obsolete)"                        , "Amigan Software, 2008"                      , "-",                                         S_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PIPBUG  , MEMMAP_L,       0xD6D10B1B,          1792, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Hello World"                                    , "Peter Henderson, 2008"                      , "-",                                         P_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PIPBUG  , MEMMAP_J,       0xABA933D2,          1280, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Echo 1"                                         , "Peter Henderson, 2008"                      , "-",                                         P_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PIPBUG  , MEMMAP_J,       0x37C72FD2,          1280, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Echo 2"                                         , "Peter Henderson, 2008"                      , "-",                                         P_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PIPBUG  , MEMMAP_J,       0xDE57A772,          1280, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Message Editor"                                 , "Applied Technology (Perry Brown), 1977"     , "EA mag, Oct 1977 (2/CC/21)",                P_OVERLAY, -1,  29,  40, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PIPBUG  , MEMMAP_J,       0x93BAA70E,          1280, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Maths Demonstration"                            , "Applied Technology (Perry Brown), 1977"     , "EA mag, Oct 1977 (2/CC/21)",                P_OVERLAY, -1,  13,  28, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PIPBUG  , MEMMAP_L,       0xE16CC3C4,          2048, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_BAD,    { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Music (bad dump)"                               , "Peter and Hugh Campbell, 1978"              , "EA mag, Dec 1978 (8/M/32)",                 P_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PIPBUG  , MEMMAP_M,       0x59FA7A3D,          3840, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_BAD,    { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Life (patched) (bad dump) (obsolete)"           , "Peter and Hugh Campbell, 1978"              , "EA mag, Dec 1978 (8/M/32)",                 P_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PIPBUG  , MEMMAP_K,       0xE22924AF,          1536, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_BAD,    { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Rotate (bad dump)"                              , "Peter and Hugh Campbell, 1978"              , "EA mag, Dec 1978 (8/M/32)",                 P_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PIPBUG  , MEMMAP_K,       0x7ACEF614,          1536, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK,     { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Rotate"                                         , "Peter and Hugh Campbell, 1978"              , "EA mag, Dec 1978 (8/M/32)",                 P_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PIPBUG  , MEMMAP_M,       0x9E2D2B7B,          3840, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_BAD,    { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Life (patched) (bad dump) (obsolete)"           , "Peter and Hugh Campbell, 1978"              , "EA mag, Dec 1978 (8/M/32)",                 P_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PIPBUG  , MEMMAP_M,       0x4AE605CD,          3840, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK,     { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Life (patched)"                                 , "Peter and Hugh Campbell, 1978"              , "EA mag, Dec 1978 (8/M/32)",                 P_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // 480
  { PIPBUG  , MEMMAP_M,       0xD636F165,          3840, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK,     { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Life (patched) (autoprint)"                     , "Peter and Hugh Campbell, 1978"              , "EA mag, Dec 1978 (8/M/32)",                 P_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // 481
  { PIPBUG  , MEMMAP_L,       0xB3FA5B92,          2048, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK,     { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Music (Yankee Doodle)"                          , "Peter and Hugh Campbell, 1978"              , "EA mag, Dec 1978 (8/M/32)",                 P_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // 482 (MUSIC1POS)
  { PIPBUG  , MEMMAP_L,       0x2FFC5DCA,          2048, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK,     { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Music (Bach)"                                   , "Peter and Hugh Campbell, 1978"              , "EA mag, Dec 1978 (8/M/32)",                 P_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // 483 (MUSIC2POS)
  { PIPBUG  , MEMMAP_M,       0x26D39577,          3840, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK,     { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Life (unpatched)"                               , "Peter and Hugh Campbell, 1978"              , "EA mag, Dec 1978 (8/M/32)",                 P_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PIPBUG  , MEMMAP_P,       0x4F7C8279,          1280, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK,     { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Memory Test"                                    , "David Edwards, 1979"                        , "EA mag, Mar 1979 (8/M/35)",                 P_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // only actually needs MEMMAP_J but then only 5 bytes to test :-)
  { PIPBUG  , MEMMAP_M,       0x2D46C37F,          7680, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK,     { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Assembler + Disassembler"                       , "Jamieson Rowe, 1979"                        , "EA mag, Apr 1979 (8/M/37)",                 P_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PIPBUG  , MEMMAP_M,       0x665A295D,          7680, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK,     { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Assembler + Disassembler (with commenter)"      , "Jamieson Rowe, 1979"                        , "EA mag, Apr 1979 (8/M/37)",                 P_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PIPBUG  , MEMMAP_K,       0xA74C7291,          1536, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK,     { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Hello There"                                    , "Jamieson Rowe, 1979"                        , "EA mag, Apr 1979 (8/M/37)",                 P_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PIPBUG  , MEMMAP_M,       0x675F999D,  5 * KILOBYTE, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK,     { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Execute (4K version)"                           , "Ludi Kraus, 1980"                           , "EA mag, Apr 1980 (8/M/48)",                 P_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PIPBUG  , MEMMAP_M,       0xEE490FB9,  8 * KILOBYTE, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK,     { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Execute (7K version)"                           , "Ludi Kraus, 1980"                           , "EA mag, Apr 1980 (8/M/48)",                 P_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PIPBUG  , MEMMAP_P,       0xDBF5473E, 12 * KILOBYTE, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK,     { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Execute (11K version)"                          , "Ludi Kraus, 1980"                           , "EA mag, Apr 1980 (8/M/48)",                 P_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PIPBUG  , MEMMAP_J,       0x1E8AD4FC,          1174, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK,     { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Trace Routine"                                  , "Jamieson Rowe, 1980"                        , "EA mag, Feb 1980 (8/M/45)",                 P_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PIPBUG  , MEMMAP_P,       0x00DB8FF6,          1410, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK,     { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "2708 EPROM Programmer"                          , "David Edwards, 1979"                        , "EA mag, Feb 1979 (2/CC/35)",                P_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
 {INSTRUCTOR, MEMMAP_N,       0xCC130857,           458, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, PARALLEL_DEFAULT,    0,INTSEL_DEFAULT,INTDIR_DEFAULT,16,DEF_DN,DEF_TO,             0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Clock 1.0 (obsolete)"                           , "Amigan Software, 2008"                      , "-",                                         S_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { ELEKTOR , MEMMAP_E,       0x9AD4218C,          2408,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_OK,     { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Figure 26"                                      , "Elektor, 1981"                              , "Pages 88-89",                               E_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { ELEKTOR , MEMMAP_E,       0x2BB1A4D1,          2402,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_OK,     { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Figure 27"                                      , "Elektor, 1981"                              , "Pages 88-90",                               E_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { ELEKTOR , MEMMAP_E,       0xE203ADC4,          2849, 10, 10, 10, 10, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_OK,     { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Steam Engine 2"                                 , "Elektor, 1981"                              , "Pages 34-35 + 66",                          E_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { ELEKTOR , MEMMAP_E,       0x240A95B1,          2331,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_OK,     { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Clear Background aka Table 5"                   , "Elektor, 1981"                              , "Page 75",                                   E_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { ELEKTOR , MEMMAP_E,       0x424982C2,          2344,  0,  0,  0,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_OK,     { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Add 2"                                          , "Elektor, 1981"                              , "Pages 96-97",                               E_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { ELEKTOR , MEMMAP_E,       0x91409492,          2364,  0,  0,  0,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_OK,     { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Add 4"                                          , "Elektor, 1981"                              , "Pages 96-97",                               E_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { ELEKTOR , MEMMAP_E,       0x793671C2,          2344,  0,  0,  0,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_OK,     { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Minus 2"                                        , "Elektor, 1981"                              , "Pages 96-97",                               E_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { ELEKTOR , MEMMAP_E,       0x2E8AD08E,          2364,  0,  0,  0,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_OK,     { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Minus 4"                                        , "Elektor, 1981"                              , "Pages 96-98",                               E_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { ELEKTOR , MEMMAP_F,       0x4A858C39,          2349,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_OK,     { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Explosion aka Table 42"                         , "Elektor, 1981"                              , "Page 181",                                  E_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { ELEKTOR , MEMMAP_F,       0xEB89C9F9,          2349,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_OK,     { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Gunshot aka Table 42"                           , "Elektor, 1981"                              , "Page 181",                                  E_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { ELEKTOR , MEMMAP_E,       0xFB1B9B7B,          2524,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_VLOW,           0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_OK,     { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Joystick aka Table 23"                          , "Elektor, 1981"                              , "Pages 118-119",                             E_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { ELEKTOR , MEMMAP_E,       0x34DE1AB8,          2642,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_OK,     { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Message aka Table 15"                           , "Elektor, 1981"                              , "Pages 103-104",                             E_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { ELEKTOR , MEMMAP_F,       0x8BCD95A3,          2335,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_OK,     { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Noise Explosion"                                , "Elektor, 1982"                              , "Elektor mag (German), Jul/Aug 1982, p. 63", E_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { ELEKTOR , MEMMAP_F,       0xBBD1789D,          2396,  2,  1,  3,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Wolf Whistle"                                   , "Elektor, 1981"                              , "Page 182",                                  E_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { ELEKTOR , MEMMAP_E,       0x5258EF38,          2575,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_OK,     { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Page 91"                                        , "Elektor, 1981"                              , "Pages 88-91",                               E_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { ELEKTOR , MEMMAP_E,       0x8C023962,          2426,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_BAD,    { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Table 26 (incomplete)"                          , "Elektor, 1981"                              , "Pages 120 + 122",                           E_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { ELEKTOR , MEMMAP_E,       0xF0BAFD08,          2397,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_OK,     { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Practice"                                       , "Elektor, 1981"                              , "Page 94",                                   E_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { ELEKTOR , MEMMAP_F,       0xEF1D0A88,          2347,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_OK,     { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Siren"                                          , "Elektor, 1981"                              , "Page 181",                                  E_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { ELEKTOR , MEMMAP_E,       0x480EABEC,          2754,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_OK,     { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Steam Engine 1 aka Table 3"                     , "Elektor, 1981"                              , "Pages 34-35",                               E_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { ELEKTOR , MEMMAP_E,       0xEFB4CE80,          2341,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_OK,     { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Table 10"                                       , "Elektor, 1981"                              , "Pages 75 + 93",                             E_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { ELEKTOR , MEMMAP_E,       0xAF014C4E,          2394,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_OK,     { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Table 18"                                       , "Elektor, 1981"                              , "Page 110",                                  E_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { ELEKTOR , MEMMAP_E,       0x72E463BD,          2416,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_OK,     { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Table 19"                                       , "Elektor, 1981"                              , "Page 110",                                  E_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { ELEKTOR , MEMMAP_E,       0x1E2A5BFC,          2529,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_OK,     { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Table 20"                                       , "Elektor, 1981"                              , "Page 114",                                        159, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { ELEKTOR , MEMMAP_E,       0x1A78AC97,          2363,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_OK,     { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Table 28 (horizontal)"                          , "Elektor, 1981"                              , "Pages 124-125",                             E_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { ELEKTOR , MEMMAP_E,       0x86B80A5E,          2363,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_OK,     { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Table 28 (vertical)"                            , "Elektor, 1981"                              , "Pages 124-125",                             E_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { ELEKTOR , MEMMAP_E,       0x41A6BB49,          2320,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_BAD,    { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Table 29 (incomplete)"                          , "Elektor, 1981"                              , "Pages 127-128",                             E_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { ELEKTOR , MEMMAP_E,       0x7270F19D,          2320,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_BAD,    { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Table 30 (incomplete)"                          , "Elektor, 1981"                              , "Page 128",                                  E_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { ELEKTOR , MEMMAP_E,       0xE3B0A57D,          8110,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_OK,     { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Table 34"                                       , "Elektor, 1981"                              , "Page 138",                                  E_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { ELEKTOR , MEMMAP_E,       0x2E27E01F,          2606,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_OK,     { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Table 40"                                       , "Elektor, 1981"                              , "Pages 158-159",                             E_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { ELEKTOR , MEMMAP_E,       0x982238D5,          6513,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_OK,     { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Table 48"                                       , "Elektor, 1981"                              , "Page 196",                                  E_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { ELEKTOR , MEMMAP_E,       0x3FF48DD9,          2345,  3,  3,  3,  3,  5,  0,  7,  9, FALSE, SENSITIVITY_DEFAULT,        0, TRUE,  EFLAG, BLUE,  DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_OK,     { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Table A"                                        , "Elektor, 1981"                              , "Page 73",                                         149, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { ELEKTOR , MEMMAP_E,       0x457E0560,          2379,  3,  3,  3,  3,  5,  0,  7,  9, FALSE, SENSITIVITY_DEFAULT,        0, TRUE,  EFLAG, BLUE,  DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_OK,     { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Table B"                                        , "Elektor, 1981"                              , "Pages 73-76",                                     149, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { ELEKTOR , MEMMAP_E,       0x5760710C,          2460,  3,  3,  3,  3,  5,  0,  7,  9, FALSE, SENSITIVITY_DEFAULT,        0, TRUE,  EFLAG, BLUE,  DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_OK,     { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Table C"                                        , "Elektor, 1981"                              , "Pages 73-79",                                     157, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { ELEKTOR , MEMMAP_E,       0xD3EA3DAE,          2522,  3,  3,  3,  3,  5,  0,  7,  9, FALSE, SENSITIVITY_DEFAULT,        0, TRUE,  EFLAG, BLUE,  DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_OK,     { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Table D"                                        , "Elektor, 1981"                              , "Pages 73-83",                                     158, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { ELEKTOR , MEMMAP_E,       0xBEBC0210,          2561,  3,  3,  3,  3,  5,  0,  7,  9, FALSE, SENSITIVITY_DEFAULT,        0, TRUE,  EFLAG, BLUE,  DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_OK,     { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Table E"                                        , "Elektor, 1981"                              , "Pages 73-85",                                     158, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { ELEKTOR , MEMMAP_F,       0xEF4D20CC,          7808,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_OK,     { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Rapid Loading Games loader (2716 version)"      , "Elektor, 1982"                              , "Elektor mag, Sep 1982",                     E_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { ELEKTOR , MEMMAP_F,       0xA1341A1E,          7808,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_OK,     { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Rapid Loading Games loader (2732 version)"      , "Elektor, 1982"                              , "Elektor mag, Sep 1982",                     E_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { ELEKTOR , MEMMAP_F,       0x44F830A7,          7808,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_OK,     { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Rapid Loading Games saver"                      , "Elektor, 1982"                              , "Elektor mag, Sep 1982",                     E_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { ELEKTOR , MEMMAP_F,       0x71266A50,          8704,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_OK,     { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Rapid Loading Games calculation program"        , "Elektor, 1982"                              , "Elektor mag, Sep 1982",                     E_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PIPBUG  , MEMMAP_M,       0x6C99A293,          7680, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK,     { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Assembler + Disassembler (improved)"            , "Jamieson Rowe + A.M. Kollosche, 1979-1980"  , "EA mag, Feb 1980 (8/M/44)",                 P_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PIPBUG  , MEMMAP_M,       0x212600E5,          5359, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK,     { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Printer Routines"                               , "David Edwards, 1979"                        , "EA mag, Jan 1979 (2/CC/34)",                P_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // 535
  { PIPBUG  , MEMMAP_M,       0xD202EF8D,          1687, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_BAD,    { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Random Morse (bad dump)"                        , "Richard Rogers (VK7RO), 1979"               , "EA mag, Dec 1979 (8/M/43)",                 P_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // 536
  { INTERTON, MEMMAP_A,       0x214DC1A5,           598,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Picture 1.0 (obsolete)"                         , "Amigan Software, 2008"                      , "-",                                              123,  -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN },
  { PIPBUG  , MEMMAP_J,       0xAC149479,          1114, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "LED Demonstration"                              , "David Edwards, 1979"                        , "EA mag, Jun 1979 (2/CC/41)",                P_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PIPBUG  , MEMMAP_J,       0x695303AB,          1195, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Time"                                           , "David Edwards, 1979"                        , "EA mag, Jun 1979 (2/CC/41)",                P_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PIPBUG  , MEMMAP_M,       0xC7104AD9,          2680, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Othello (Reversi) 2.0"                          , "Chris Burrows, 1981-2008"                   , "-",                                         P_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { CD2650  , MEMMAP_CD2650,  0xDC66B7BD,          5678, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK,     { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "TV Typewriter"                                  , "Jeff Roloff, 1977"                          , "RE mag, Apr 1977",                          C_OVERLAY, -1, 213, 214, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PIPBUG  , MEMMAP_M,       0x60226348,          1687, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Random Morse"                                   , "Richard Rogers (VK7RO), 1979"               , "EA mag, Dec 1979 (8/M/43)",                 P_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // 542
  { CD2650  , MEMMAP_CD2650,  0xE1410A71,          5830, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Show Characters"                                , "Amigan Software, 2009"                      , "-",                                         C_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { CD2650  , MEMMAP_CD2650,  0x81B560BA,          6032, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_BAD,    { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Life (bad dump)"                                , "?, 19xx"                                    , "-",                                         C_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { CD2650  , MEMMAP_CD2650,  0xBFB7C8AB,          8928, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_BAD,    { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Alpha Chess 1.2 (bad dump)"                     , "Alpha Electronics (W.L. Green), 1979"       , "-",                                         C_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { CD2650  , MEMMAP_CD2650,  0x11384B50,         14336, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK,     { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Chess 3"                                        , "?, 19xx"                                    , "-",                                         C_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { CD2650  , MEMMAP_CD2650,  0xBF43D2C5,         14336, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK,     { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Chess 3 (patched)"                              , "Richard Rogers (VK7RO), 2009"               , "-",                                         C_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { CD2650  , MEMMAP_CD2650,  0x0B7BCB16,         10354, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK,     { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Alpha Chess 1.2"                                , "Alpha Electronics (W.L. Green), 1979"       , "-",                                         C_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PIPBUG  , MEMMAP_P,       0x76833C4F,          6145, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK,     { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "PIPBUG Chess"                                   , "A. Scott, 19xx"                             , "-",                                         P_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { CD2650  , MEMMAP_CD2650,  0x5B132C36,          6032, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK,     { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Life"                                           , "?, 19xx"                                    , "-",                                         C_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { CD2650  , MEMMAP_CD2650,  0x984CCACA,         23296, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_BAD,    { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "12K BASIC (bad dump)"                           , "Central Data, 19xx"                         , "-",                                         C_OVERLAY, -1,  67, 112, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { CD2650  , MEMMAP_CD2650,  0xA6FE01F8,         14335, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK,     { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Central Data Chess"                             , "Central Data?, 19xx"                        , "-",                                         C_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { CD2650  , MEMMAP_CD2650,  0x90E1D2B4,         13568, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK,     { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Editor/Assembler"                               , "Central Data?, 19xx"                        , "-",                                         C_OVERLAY, -1, 308, 313, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { CD2650  , MEMMAP_CD2650,  0xA1F5B8D4,         23296, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK,     { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "12K BASIC"                                      , "Central Data, 19xx"                         , "-",                                         C_OVERLAY, -1,  67, 112, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { CD2650  , MEMMAP_CD2650,  0x9D443A45,         23296, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK,     { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "12K BASIC (patched)"                            , "Amigan Software, 2009"                      , "-",                                         C_OVERLAY, -1,  67, 112, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { CD2650  , MEMMAP_CD2650,  0x52B98B0C,         23296, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK,     { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Lunar Lander (hacked for 12K BASIC) (withdrawn)", "Mike Herbach, 1978"                         , "CD2650 Newsletter #1",                      C_OVERLAY, -1,  67, 112, CL_12KB ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { CD2650  , MEMMAP_CD2650,  0x7DF6E15C,          5722, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Input"                                          , "Amigan Software, 2009"                      , "-",                                         C_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { CD2650  , MEMMAP_CD2650,  0xF1B3F931,         15740, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_BAD,    { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "FORTH (bad dump)"                               , "D. P. Hildyard, 1981"                       , "-",                                         C_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // "V5"
  { CD2650  , MEMMAP_CD2650,  0xAE83A52A,          5545, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK,     { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Memory Test"                                    , "Central Data, 1978"                         , "CD2650 Newsletter #1",                      C_OVERLAY, -1, 161, 175, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { CD2650  , MEMMAP_CD2650,  0x36D91FFC,         15756, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_BAD,    { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "FORTH (bad dump)"                               , "D. P. Hildyard, 1981"                       , "-",                                         C_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // "V8" (plus "<" fix)
  { CD2650  , MEMMAP_CD2650,  0xE14DCD93,         15756, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_BAD,    { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "FORTH (bad dump)"                               , "D. P. Hildyard, 1981"                       , "-",                                         C_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // "V8.1"
  { CD2650  , MEMMAP_CD2650,  0x931FE9E4,         15818, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_SUSPECT,{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "FORTH (suspect dump)"                           , "D. P. Hildyard, 1981"                       , "-",                                         C_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { CD2650  , MEMMAP_CD2650,  0x563D4E04,         32749, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK,     { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Pattern"                                        , "?, 19xx"                                    , "-",                                         C_OVERLAY, -1,  -1,  -1, CL_FORTH,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // surely we could trim this?
  { ARCADIA , MEMMAP_ARCADIA, 0xFEF2AAE9,  4 * KILOBYTE,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 1, 1, 1, 0, 0, 0},{ 1, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "superbug", "Super Bug"                                      , "UA Ltd., 1983"                              , "MPT-03 MG-333",                                    14, 40,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN },
  { ARCADIA , MEMMAP_ARCADIA, 0x1241F128,  8 * KILOBYTE,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT, 0xC0 | 2, FALSE, TRUE , BLUE,       2,      3,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Mobile Soldier Gundam"                          , "Bandai, 1983"                               , "Bandai #50",                                      126, 18,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN },
  { ARCADIA , MEMMAP_ARCADIA, 0xB38D4512,  2 * KILOBYTE,  7,  8,  9,  5,  5,  8,  7,  9, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   {25,25,25, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "JTron 1.2 (obsolete)"                           , "Amigan Software, 2003-2009"                 , "-",                                                40, 20,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN },
 {INSTRUCTOR, MEMMAP_N,       0x7F374754,           464, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, PARALLEL_DEFAULT,    0,INTSEL_DEFAULT,INTDIR_DEFAULT,16,DEF_DN,DEF_TO,             0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Show Keys 1.01 (obsolete)"                      , "Amigan Software, 2008-2009"                 , "-",                                         S_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
 {INSTRUCTOR, MEMMAP_N,       0xD53801D0,           358, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, PARALLEL_DEFAULT,    0,INTSEL_DEFAULT,INTDIR_DEFAULT,16,DEF_DN,DEF_TO,             0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Checksum 1.0 (obsolete)"                        , "Amigan Software, 2009"                      , "-",                                         S_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { ARCADIA , MEMMAP_ARCADIA, 0x94E86235,  4 * KILOBYTE,  7,  8,  9,  5,  5,  8,  7,  9, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Frogger 1.25"                                   , "Amigan Software, 2004-2009"                 , "-",                                                40, 16, 314, 495, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN },
  { ARCADIA , MEMMAP_ARCADIA, 0xA768C764,  2 * KILOBYTE,  2,  2,  2,  2,  5,  8,  7,  9, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   {25,25,25, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "JTron 1.21"                                     , "Amigan Software, 2003-2009"                 , "-",                                                42, 20, 496, 587, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN },
  { ARCADIA , MEMMAP_ARCADIA, 0x91A93F8E,           693,  2,  2,  2,  2,  2,  5,  4,  6, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Tester 3 1.0 (obsolete)"                        , "Amigan Software, 2009"                      , "-",                                                80, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN },
  { CD2650  , MEMMAP_CD2650,  0xAFCDD3E6,          5572, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_SUSPECT,{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Backup (suspect dump)"                          , "Ray Krygier, 1979"                          , "CD2650 Newsletter #3",                      C_OVERLAY, -1, 223, 236, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { ARCADIA , MEMMAP_ARCADIA, 0x6A822CEB,           806,  2,  2,  2,  2,  2,  5,  4,  6, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Tester 3 2.0"                                   , "Amigan Software, 2009"                      , "-",                                                80, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN },
 {INSTRUCTOR, MEMMAP_N,       0x74D9A2F3,           472, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, PARALLEL_DEFAULT,    0,INTSEL_DEFAULT,INTDIR_DEFAULT,16,DEF_DN,DEF_TO,             0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Show Keys 1.02 (obsolete)"                      , "Amigan Software, 2008-2009"                 , "-",                                         S_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
 {INSTRUCTOR, MEMMAP_N,       0x0B5EE1FC,           432, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, PARALLEL_DEFAULT,    0,INTSEL_DEFAULT,INTDIR_DEFAULT,16,DEF_DN,DEF_TO,             0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Scroller 2.0"                                   , "Amigan Software, 2008-2009"                 , "-",                                         S_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
 {INSTRUCTOR, MEMMAP_N,       0x51FBA2B7,           361, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, PARALLEL_DEFAULT,    0,INTSEL_DEFAULT,INTDIR_DEFAULT,16,DEF_DN,DEF_TO,             0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Checksum 1.01 (obsolete)"                       , "Amigan Software, 2009"                      , "-",                                         S_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
 {INSTRUCTOR, MEMMAP_N,       0xDA578FD4,           446, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, PARALLEL_DEFAULT,    0,INTSEL_ACLINE, INTDIR_DIRECT, 16,DEF_DN,DEF_TO,             0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Clock 2.0"                                      , "Amigan Software, 2008-2009"                 , "-",                                         S_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
 {INSTRUCTOR, MEMMAP_N,       0x0F454BE7,           472, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, PARALLEL_DEFAULT,    0,INTSEL_DEFAULT,INTDIR_DEFAULT,16,DEF_DN,DEF_TO,             0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Show Keys 1.03"                                 , "Amigan Software, 2008-2009"                 , "-",                                         S_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
 {INSTRUCTOR, MEMMAP_N,       0x16942A01,           361, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, PARALLEL_DEFAULT,    0,INTSEL_DEFAULT,INTDIR_DEFAULT,16,DEF_DN,DEF_TO,             0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Checksum 1.02"                                  , "Amigan Software, 2009"                      , "-",                                         S_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
 {INSTRUCTOR, MEMMAP_N,       0x8713EE17,           342, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, PARALLEL_DEFAULT,    0,INTSEL_DEFAULT,INTDIR_DEFAULT,16,DEF_DN,DEF_TO,             0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Bounce"                                         , "Amigan Software, 2009"                      , "-",                                         S_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
 {INSTRUCTOR, MEMMAP_N,       0x93489164,           285, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, PARALLEL_DEFAULT,    0,INTSEL_DEFAULT,INTDIR_DEFAULT,16,DEF_DN,DEF_TO,             0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Mirror"                                         , "Amigan Software, 2009"                      , "-",                                         S_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { ELEKTOR , MEMMAP_E,       0xA956C414,          8192,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_OK,     { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Table 26"                                       , "Elektor, 1981"                              , "Pages 120 + 122",                           E_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { ELEKTOR , MEMMAP_E,       0x06D2F312,          8192,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_OK,     { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Table 29"                                       , "Elektor, 1981"                              , "Pages 127-128",                             E_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { ELEKTOR , MEMMAP_E,       0x8AC52CB5,          8192,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_OK,     { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Table 30"                                       , "Elektor, 1981"                              , "Page 128",                                  E_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { ELEKTOR , MEMMAP_F,       0xECA0F1AB,          2795,  2,  1,  3,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Wedding March"                                  , "Elektor, 1981"                              , "Pages 183-184",                             E_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { ARCADIA , MEMMAP_ARCADIA, 0x4BA126E1,          8192,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "BoxBoy (beta version)"                          , "Charles Eurich, 2006-2008"                  , "-",                                               170, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN },
  { CD2650  , MEMMAP_CD2650,  0x2BB6EB71,          5752, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK,     { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "TV Typewriter with Scrolling"                   , "Randy Sebra, 1977"                          , "2650 Computer User Notes #2",               C_OVERLAY, -1, 215, 222, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { CD2650  , MEMMAP_CD2650,  0xCAE4E5EF,          5655, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_BAD,    { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Hangman (underdump)"                            , "Mike Herbach, 1977"                         , "2650 Computer User Notes #1 + #2",          C_OVERLAY, -1, 113, 160, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { CD2650  , MEMMAP_CD2650,  0x20783C16,          6113, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK,     { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Hangman"                                        , "Mike Herbach, 1977"                         , "2650 Computer User Notes #1 + #2",          C_OVERLAY, -1, 113, 160, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { CD2650  , MEMMAP_CD2650,  0x2366E3FD,         14017, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK,     { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Morse Code"                                     , "Mike Durham, 1979"                          , "CD2650 Newsletter #4",                      C_OVERLAY, -1, 176, 212, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { ELEKTOR , MEMMAP_F,       0xB07BCE61,  8 * KILOBYTE,  7,  1,  9,  8, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, EFLAG, BLUE,  DEF_DN, DEF_TO, PVI_LATESTSPRITE,      64, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Invaders"                                       , "M. Norman, 198x"                            , "ESS-010-1",                                        43, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, //!E/- (w/ relevant BIOS code included)
  { ARCADIA , MEMMAP_ARCADIA, 0x91A14527,  4 * KILOBYTE,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 1, 1, 1, 0, 0, 0},{ 1, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "superbug", "Super Bug 2 1.0 (obsolete)"                     , "Amigan Software, 2009"                      , "MPT-03 MG-333",                                    14, 41,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN },
  { ARCADIA , MEMMAP_ARCADIA, 0x15436F39,  4 * KILOBYTE,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 1, 1, 1, 0, 0, 0},{ 1, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "superbug", "Super Bug 2 1.0a"                               , "Amigan Software, 2009"                      , "MPT-03 MG-333",                                    14, 41,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN },
  { INTERTON, MEMMAP_A,       0xF96C3A8B,           483,  2,  3,  2,  3, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Picture 1.1"                                    , "Amigan Software, 2008-2009"                 , "-",                                               162, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN },
  { PIPBUG  , MEMMAP_P,       0xD37B3525,          1568, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Hangman"                                        , "Applied Technology, 197x"                   , "Games Pack #2",                             P_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PIPBUG  , MEMMAP_P,       0xB5C7557A,          1504, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Mastermind"                                     , "Applied Technology, 197x"                   , "Games Pack #2",                             P_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PIPBUG  , MEMMAP_P,       0xDCDAC3D8,          1280, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Russian Roulette"                               , "Applied Technology, 197x"                   , "Games Pack #2",                             P_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PIPBUG  , MEMMAP_P,       0xDFDB84F2,          2819, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "2650 Micro BASIC"                               , "Alan Peek, 1978"                            , "-",                                         P_OVERLAY, -1,  -1,  -1, CL_MB   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PIPBUG  , MEMMAP_P,       0x471B7560,          3505, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Lunar Lander (Micro BASIC version)"             , "Lionel Theunissen, 1979"                    , "-",                                         P_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PIPBUG  , MEMMAP_P,       0xD5304CB0,          1760, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Lunar Lander (machine code version) (unpatched)", "Applied Technology, 197x"                   , "Games Pack #2",                             P_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PIPBUG  , MEMMAP_P,       0xE34790BB,          2531, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Biorhythm Calculator (unpatched)"               , "Applied Technology, 197x"                   , "Games Pack #2",                             P_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PIPBUG  , MEMMAP_P,       0xD8434EE8,          2896, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Funny Farm Races (unpatched)"                   , "Applied Technology, 197x"                   , "Games Pack #2",                             P_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PIPBUG  , MEMMAP_P,       0xFA294265,          3345, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK,     { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Temperature Conversion"                         , "Syd Brooks, 1980"                           , "EA mag, Feb 1980 (8/M/46)",                 P_OVERLAY, -1,  -1,  -1, CL_MB   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PIPBUG  , MEMMAP_P,       0x5140E659,          3448, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK,     { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Radio Log"                                      , "Horst Leykam (VK2BHF), 1980"                , "EA mag, Feb 1980 (8/M/46)",                 P_OVERLAY, -1,  -1,  -1, CL_MB   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PIPBUG  , MEMMAP_P,       0x20A21396,          3149, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK,     { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Guessing Game (Micro BASIC version)"            , "?, 19xx"                                    , "EA mag, Apr 1979",                          P_OVERLAY, -1,  -1,  -1, CL_MB   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PIPBUG  , MEMMAP_P,       0x48D70AAE,          2531, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Biorhythm Calculator (patched)"                 , "Applied Technology, 197x"                   , "Games Pack #2",                             P_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PIPBUG  , MEMMAP_P,       0x54234BBB,          2896, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Funny Farm Races (patched)"                     , "Applied Technology, 197x"                   , "Games Pack #2",                             P_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PIPBUG  , MEMMAP_P,       0x071AB343,          1760, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Lunar Lander (machine code version) (patched)"  , "Applied Technology, 197x"                   , "Games Pack #2",                             P_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PIPBUG  , MEMMAP_P,       0x4999147F,         31334, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK,     { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Linearisatie"                                   , "Peter J.M. van Vugt, 1980"                  , "Linearisatie book, p. 137-150",             P_OVERLAY, -1, 237, 307, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { INTERTON, MEMMAP_A,       0x63CA6512,  2 * KILOBYTE,  2,  1,  3,  0, -1, -1, -1, -1, TRUE , SENSITIVITY_MEDIUM ,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE,     800, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "grndprix", "Grand Prix (patched)"                           , "Amigan Software, 2010"                      , "Interton #1",                                      96, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN },
  { INTERTON, MEMMAP_A,       0xAC1FA66C,  2 * KILOBYTE,  2,  1,  3,  0, -1, -1, -1, -1, TRUE , SENSITIVITY_MEDIUM ,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE,     800, PVI_VBLANK, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "grndprix", "Car Races (patched)"                            , "Amigan Software, 2010"                      , "Fountain #2",                                      96, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0x90DA3C55,         14336, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Othello"                                        , "Frank Philipse, 198x"                       , "08A/14A",                              PHUNSY_OVERLAY, -1,  -1,  -1, CL_MWB  ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PHUNSY  , MEMMAP_PHUNSY,  0x2027436D,         11264, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Moonlander"                                     , "Frank Philipse, 198x"                       , "08A/14A",                              PHUNSY_OVERLAY, -1,  -1,  -1, CL_MWB  ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PHUNSY  , MEMMAP_PHUNSY,  0xAA68BD29,          2304, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Hello (withdrawn)"                              , "Frank Philipse, 198x"                       , "-",                                    PHUNSY_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PHUNSY  , MEMMAP_PHUNSY,  0x5A44BB4D,         11264, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Go-Bang"                                        , "Frank Philipse, 198x"                       , "08A/14A",                              PHUNSY_OVERLAY, -1,  -1,  -1, CL_MWB  ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PHUNSY  , MEMMAP_PHUNSY,  0x39A7CE95,          8448, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Parallel Resistance Calculator"                 , "Frank Philipse, 198x"                       , "08A/14A",                              PHUNSY_OVERLAY, -1,  -1,  -1, CL_MWB  ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PHUNSY  , MEMMAP_PHUNSY,  0xF1D49C75,          8960, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Speed of Light Calculator"                      , "Frank Philipse, 198x"                       , "08A/14A",                              PHUNSY_OVERLAY, -1,  -1,  -1, CL_MWB  ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PHUNSY  , MEMMAP_PHUNSY,  0x35361B1D,          8960, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Day of the Week"                                , "Frank Philipse, 198x"                       , "08A/14A",                              PHUNSY_OVERLAY, -1,  -1,  -1, CL_MWB  ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PHUNSY  , MEMMAP_PHUNSY,  0x602B44BA,         12288, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Mastermind"                                     , "Frank Philipse, 198x"                       , "08A/14A",                              PHUNSY_OVERLAY, -1,  -1,  -1, CL_MWB  ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PHUNSY  , MEMMAP_PHUNSY,  0x555579E9,         10240, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Calendar (14A dump)"                            , "Frank Philipse, 198x"                       , "14A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MWB  ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PHUNSY  , MEMMAP_PHUNSY,  0x54D884F7,         10240, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Biorhythms (14A dump)"                          , "Frank Philipse, 198x"                       , "14A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MWB  ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PHUNSY  , MEMMAP_PHUNSY,  0xE69E19A8,          9216, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Lucifer (Nim)"                                  , "Frank Philipse, 198x"                       , "08A/14A",                              PHUNSY_OVERLAY, -1,  -1,  -1, CL_MWB  ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PHUNSY  , MEMMAP_PHUNSY,  0x82E04BBC,          9472, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Plot of Functions"                              , "Frank Philipse, 198x"                       , "08A/14A",                              PHUNSY_OVERLAY, -1,  -1,  -1, CL_MWB  ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PHUNSY  , MEMMAP_PHUNSY,  0x45280560,          7168, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_GOOD,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Boter Melk Kaas (Noughts and Crosses)"          , "Frank Philipse, 1980"                       , "-",                                    PHUNSY_OVERLAY, -1,  -1,  -1, CL_MWB  ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PHUNSY  , MEMMAP_PHUNSY,  0xDAE6E1AE,         10240, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Biorhythms (08A dump)"                          , "Frank Philipse, 1980"                       , "08A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MWB  ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PHUNSY  , MEMMAP_PHUNSY,  0x91CCC908,         10240, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Calendar (08A dump)"                            , "Frank Philipse, 1980"                       , "08A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MWB  ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { CD2650  , MEMMAP_CD2650,  0x3C1ABB1A,          8704, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "CD-BOOTS"                                       , "Frank Philipse?, 19xx"                      , "01A/02A",                              PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { CD2650  , MEMMAP_CD2650,  0x8EC12B52,         32768, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "CD-DOS"                                         , "Frank Philipse?, 19xx"                      , "01A/02A",                              PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { CD2650  , MEMMAP_CD2650,  0x9D9AF147,         12288, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "CD-POP"                                         , "Frank Philipse?, 19xx"                      , "01A/02A",                              PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PHUNSY  , MEMMAP_PHUNSY,  0xAF3B9181,         32768, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "MODEST (01A dump)"                              , "Philips?, 19xx"                             , "01A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PHUNSY  , MEMMAP_PHUNSY,  0x16F80D7F,         32768, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "MODEST (02A dump)"                              , "Philips?, 19xx"                             , "02A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PHUNSY  , MEMMAP_PHUNSY,  0x418391AF,          8192, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "PCITALK"                                        , "Frank Philipse, 1980"                       , "21B",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PHUNSY  , MEMMAP_PHUNSY,  0x56B897AA,         16384, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "PRMTHS"                                         , "Frank Philipse, 1980"                       , "01A/02A",                              PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PHUNSY  , MEMMAP_PHUNSY,  0x11747D68,          6162, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Character Set 1.0 (obsolete)"                   , "Amigan Software, 2010"                      , "-",                                    PHUNSY_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { CD2650  , MEMMAP_CD2650,  0x629EF147,         18944, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "CD-ALP (01B dump)"                              , "Central Data?, 19xx"                        , "01B",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { CD2650  , MEMMAP_CD2650,  0x74A0E6CE,         18944, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "CD-ALP (02B dump)"                              , "Central Data?, 19xx"                        , "02B",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { CD2650  , MEMMAP_CD2650,  0x555D3EE4,         23296, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "CD-BASIC"                                       , "Central Data?, 19xx"                        , "01B/02B",                              PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { CD2650  , MEMMAP_CD2650,  0x85D467DA,         10240, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "CD-CHR/M"                                       , "Central Data?, 19xx"                        , "01B/02B",                              PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { CD2650  , MEMMAP_CD2650,  0x885367C9,          9728, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "CD-CHR/O"                                       , "Central Data?, 19xx"                        , "01B/02B",                              PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { CD2650  , MEMMAP_CD2650,  0xC94D7257,          9216, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "CD-MOM/M"                                       , "Central Data?, 19xx"                        , "01B/02B",                              PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { CD2650  , MEMMAP_CD2650,  0xA2FC5A83,          9216, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "CD-MON/O"                                       , "Central Data?, 19xx"                        , "01B/02B",                              PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PHUNSY  , MEMMAP_PHUNSY,  0xD846438C,         12288, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "PMON0400"                                       , "Frank Philipse?, 19xx"                      , "03A/04A",                              PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PHUNSY  , MEMMAP_PHUNSY,  0x98BEC210,         12288, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "PMON0401"                                       , "Frank Philipse?, 19xx"                      , "03A/04A",                              PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PHUNSY  , MEMMAP_PHUNSY,  0x71FF9F54,         10240, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "PMON0402"                                       , "Frank Philipse?, 19xx"                      , "03A/04A",                              PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PHUNSY  , MEMMAP_PHUNSY,  0x35C5FF1E,         10240, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "PMON0403"                                       , "Frank Philipse?, 19xx"                      , "03A/04A",                              PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PHUNSY  , MEMMAP_PHUNSY,  0x5C8C5824,         10240, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "PMON0404 (03A dump)"                            , "Frank Philipse?, 19xx"                      , "03A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PHUNSY  , MEMMAP_PHUNSY,  0xCC9E07E9,         10240, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "PMON0404 (04A dump)"                            , "Frank Philipse?, 19xx"                      , "04A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PHUNSY  , MEMMAP_PHUNSY,  0x59F11CA2,          9216, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "PMONmini"                                       , "Frank Philipse?, 19xx"                      , "20A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PHUNSY  , MEMMAP_PHUNSY,  0x0DD52ACC,          7168, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "RAMTEST"                                        , "Frank Philipse?, 19xx"                      , "03A/04A",                              PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PHUNSY  , MEMMAP_PHUNSY,  0x29CDD699,         12288, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "DASS-004 (03A dump)"                            , "Frank Philipse?, 19xx"                      , "03A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PHUNSY  , MEMMAP_PHUNSY,  0x12753547,         12288, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "DASS-004 (04A dump)"                            , "Frank Philipse?, 19xx"                      , "04A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PHUNSY  , MEMMAP_PHUNSY,  0x0954192D,          3072, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "I/OPACK"                                        , "Frank Philipse?, 19xx"                      , "03A/04A",                              PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PHUNSY  , MEMMAP_PHUNSY,  0x8AED8CEA,         10752, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "KEYB-BEN"                                       , "Frank Philipse?, 19xx"                      , "03A/04A",                              PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PHUNSY  , MEMMAP_PHUNSY,  0x64337003,         12288, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "TRNR-001"                                       , "Frank Philipse?, 19xx"                      , "03A/04A",                              PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PHUNSY  , MEMMAP_PHUNSY,  0x0BE59E9F,          8192, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "LABHNDN (03A/04A dump)"                         , "Frank Philipse?, 19xx"                      , "03A/04A",                              PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PHUNSY  , MEMMAP_PHUNSY,  0x89E9B402,          8192, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "LABHNDN (20A dump)"                             , "Frank Philipse?, 19xx"                      , "20A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PHUNSY  , MEMMAP_PHUNSY,  0x2491C901,         12288, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "PDCR-006"                                       , "Frank Philipse?, 19xx"                      , "03A/04A",                              PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PHUNSY  , MEMMAP_PHUNSY,  0xE2B9093A,          9216, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "PH-CHR"                                         , "Frank Philipse?, 19xx"                      , "03A/04A",                              PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PHUNSY  , MEMMAP_PHUNSY,  0x0435EBFF,         16640, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "FORTH-00"                                       , "Frank Philipse?, 19xx"                      , "03B/04B",                              PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PHUNSY  , MEMMAP_PHUNSY,  0x52018336,         16640, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "FORTH-01"                                       , "Frank Philipse?, 19xx"                      , "07A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PHUNSY  , MEMMAP_PHUNSY,  0xA23EB27A,         31744, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "CDC-I/O"                                        , "Frank Philipse?, 19xx"                      , "05B/06B",                              PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PHUNSY  , MEMMAP_PHUNSY,  0x7E8B8BFB,          2560, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "COPY"                                           , "Frank Philipse?, 19xx"                      , "07A/13A",                              PHUNSY_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PHUNSY  , MEMMAP_PHUNSY,  0xC3E7AF53,         21504, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "PEDT-0A3"                                       , "Frank Philipse?, 19xx"                      , "07A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PHUNSY  , MEMMAP_PHUNSY,  0x0FC7C7FC,         23552, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "PEDT-004 (13A dump)"                            , "Frank Philipse?, 19xx"                      , "13A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PHUNSY  , MEMMAP_PHUNSY,  0x9CFC6A3A,         23552, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "PEDT-004 (21B dump)"                            , "Frank Philipse?, 19xx"                      , "21B",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PHUNSY  , MEMMAP_PHUNSY,  0xA7A1508E,         32768, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "PASS (07B dump)"                                , "Frank Philipse?, 19xx"                      , "07B",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PHUNSY  , MEMMAP_PHUNSY,  0x0171221F,         32768, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "PASS (13B dump)"                                , "Frank Philipse?, 19xx"                      , "13B",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PHUNSY  , MEMMAP_PHUNSY,  0x0A95F40B,          8192, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "BELMACH"                                        , "Frank Philipse?, 19xx"                      , "09A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // 668
  { PHUNSY  , MEMMAP_PHUNSY,  0x864900A3,         14336, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_BAD ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "BELMACH0 (bad dump) (obsolete)"                 , "J.F.P. Philipse, 1982"                      , "09A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PHUNSY  , MEMMAP_PHUNSY,  0x4221C840,         10240, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "BELCAL"                                         , "Frank Philipse?, 19xx"                      , "09A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MWB  ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PHUNSY  , MEMMAP_PHUNSY,  0x9182691A,         10240, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "BELINPUT"                                       , "Frank Philipse?, 19xx"                      , "09A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MWB  ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PHUNSY  , MEMMAP_PHUNSY,  0x56208C7A,         20480, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "LIEDJES"                                        , "Frank Philipse?, 19xx"                      , "09A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PHUNSY  , MEMMAP_PHUNSY,  0x9A40B04A,         14336, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "BIG-CHAR"                                       , "Frank Philipse?, 19xx"                      , "11B/17B",                              PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PHUNSY  , MEMMAP_PHUNSY,  0x611DD11A,         32768, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "HYRO-001 (11B dump)"                            , "Frank Philipse?, 19xx"                      , "11B",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PHUNSY  , MEMMAP_PHUNSY,  0x2AE443F7,         32768, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "HYRO-001 (17B dump)"                            , "Frank Philipse?, 19xx"                      , "17B",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PHUNSY  , MEMMAP_PHUNSY,  0x1B42C557,         15360, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "LKRANT"                                         , "Frank Philipse?, 19xx"                      , "11B/17B",                              PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PHUNSY  , MEMMAP_PHUNSY,  0x8DEA4645,          8192, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "L-KRANT"                                        , "Frank Philipse?, 19xx"                      , "11B/17B",                              PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PHUNSY  , MEMMAP_PHUNSY,  0xCD1A7186,          7168, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "GRAPHICS"                                       , "Frank Philipse?, 19xx"                      , "11B/17B",                              PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PHUNSY  , MEMMAP_PHUNSY,  0xC3B10C79,         12032, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "GRAPHS"                                         , "Frank Philipse?, 19xx"                      , "20B",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PHUNSY  , MEMMAP_PHUNSY,  0x37105BCE,         22528, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "HEXDUMP"                                        , "Frank Philipse?, 19xx"                      , "13B",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PHUNSY  , MEMMAP_PHUNSY,  0x506636CD,          2304, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "READHEX"                                        , "Frank Philipse?, 19xx"                      , "19A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PHUNSY  , MEMMAP_PHUNSY,  0x4CFC9A95,          3704, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "CLEARMEM"                                       , "Frank Philipse?, 19xx"                      , "13A/17A/19A/21B",                      PHUNSY_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PHUNSY  , MEMMAP_PHUNSY,  0xEEFB84D7,         31744, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "TPRINTER (13A/21B dump)"                        , "Frank Philipse?, 19xx"                      , "13A/21B",                              PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PHUNSY  , MEMMAP_PHUNSY,  0xDE374824,         31744, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "TPRINTER (17A dump)"                            , "Frank Philipse?, 19xx"                      , "17A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PHUNSY  , MEMMAP_PHUNSY,  0x5DF0B154,         20480, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "WRDCMB"                                         , "Frank Philipse?, 19xx"                      , "15B",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MWB  ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PHUNSY  , MEMMAP_PHUNSY,  0x93BAAB2F,         24576, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "PALASM (15B dump)"                              , "Frank Philipse?, 19xx"                      , "15B",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MWB  ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PHUNSY  , MEMMAP_PHUNSY,  0xF1E613A0,          8192, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "PALASM (21B dump)"                              , "Frank Philipse?, 19xx"                      , "21B",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PHUNSY  , MEMMAP_PHUNSY,  0xA3CCA516,          2560, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "SEND-JET"                                       , "Frank Philipse?, 19xx"                      , "20B",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PHUNSY  , MEMMAP_PHUNSY,  0x7B170E01,          2304, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "SEE-CHAR"                                       , "Frank Philipse?, 19xx"                      , "17A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PHUNSY  , MEMMAP_PHUNSY,  0x6B5BE73F,          2304, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "SEE-EXT (17A dump)"                             , "Frank Philipse?, 19xx"                      , "17A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PHUNSY  , MEMMAP_PHUNSY,  0xEBDAAFAB,          2099, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "SEE-EXT (20B dump)"                             , "Frank Philipse?, 19xx"                      , "20B",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // underdump?
  { PHUNSY  , MEMMAP_PHUNSY,  0x4006597B,          6400, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "SEE-C374"                                       , "Frank Philipse?, 19xx"                      , "17A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PHUNSY  , MEMMAP_PHUNSY,  0x1F65B60C,          2560, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "FLXWR-02"                                       , "Frank Philipse?, 19xx"                      , "17A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PHUNSY  , MEMMAP_PHUNSY,  0x17165F4A,          2304, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "SOUTCASS"                                       , "Frank Philipse?, 19xx"                      , "19A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PHUNSY  , MEMMAP_PHUNSY,  0x46BDA9EB,          6400, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "ROW->COL"                                       , "Frank Philipse?, 19xx"                      , "17A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PHUNSY  , MEMMAP_PHUNSY,  0x687EC5C7,          2304, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "64>374"                                         , "Frank Philipse?, 19xx"                      , "17A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PHUNSY  , MEMMAP_PHUNSY,  0x87AF5D76,         12288, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "TERML"                                          , "Frank Philipse?, 19xx"                      , "19A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PHUNSY  , MEMMAP_PHUNSY,  0x8CDD203F,          8704, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "PHCSRD"                                         , "Frank Philipse?, 19xx"                      , "19A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PHUNSY  , MEMMAP_PHUNSY,  0x04186200,          9648, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "OPCODES"                                        , "Frank Philipse?, 19xx"                      , "19A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PHUNSY  , MEMMAP_PHUNSY,  0x3A186126,          8192, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "PORT9600"                                       , "Frank Philipse?, 19xx"                      , "20B",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PHUNSY  , MEMMAP_PHUNSY,  0x73EA9546,          2560, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "FPRINTER"                                       , "Frank Philipse?, 19xx"                      , "21B",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PHUNSY  , MEMMAP_PHUNSY,  0x4CE099CE,         27136, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "TPRINT-S"                                       , "Frank Philipse?, 19xx"                      , "21B",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PHUNSY  , MEMMAP_PHUNSY,  0x05726629,          3072, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "CONV6>2"                                        , "Frank Philipse?, 19xx"                      , "20A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PHUNSY  , MEMMAP_PHUNSY,  0x7173282C,          3072, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "CONV2>0"                                        , "Frank Philipse?, 19xx"                      , "20A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PHUNSY  , MEMMAP_PHUNSY,  0x79C4074B,         16384, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "BAS-TEST"                                       , "Frank Philipse?, 19xx"                      , "20A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MWB  ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PHUNSY  , MEMMAP_PHUNSY,  0x6B90AAD9,         15104, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "MWBAS-06 (13A dump)"                            , "Ian Binnie?, 1979?"                         , "13A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PHUNSY  , MEMMAP_PHUNSY,  0x6E09D269,         23552, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "MWBAS-06 (14A dump)"                            , "Ian Binnie?, 1979?"                         , "14A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PHUNSY  , MEMMAP_PHUNSY,  0x2BF61D77,         32768, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "MWBAS-06 (20A dump)"                            , "Ian Binnie?, 1979?"                         , "20A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PHUNSY  , MEMMAP_PHUNSY,  0xB66CEB30,          9216, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "BASIO-20"                                       , "?, 19xx"                                    , "20A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PHUNSY  , MEMMAP_PHUNSY,  0x6C3C5CF7,         31744, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "MWBAS-05"                                       , "Ian Binnie?, 1979?"                         , "07A/08A",                              PHUNSY_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PHUNSY  , MEMMAP_PHUNSY,  0xFFE363D3,         23552, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "MWBAS-M6"                                       , "Ian Binnie?, 1979?"                         , "20A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PHUNSY  , MEMMAP_PHUNSY,  0x4F36E71B,         16384, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "MWBAS-00 (uppercase)"                           , "Ian Binnie?, 1979?"                         , "03B",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PHUNSY  , MEMMAP_PHUNSY,  0xA7505772,         16384, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "MWBAS-00 (lowercase)"                           , "Ian Binnie?, 1979?"                         , "03B/04B",                              PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PHUNSY  , MEMMAP_PHUNSY,  0x81DB3EF2,         32768, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "MODESTC (13A dump)"                             , "Philips?, 19xx"                             , "13A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PHUNSY  , MEMMAP_PHUNSY,  0xC624CEBA,         32512, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "MODESTC (19A/21B dump)"                         , "Philips?, 19xx"                             , "19A/21B",                              PHUNSY_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // underdump?
  { PHUNSY  , MEMMAP_PHUNSY,  0xFACD9077,         16128, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "MODESTM"                                        , "Philips?, 19xx"                             , "19A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PHUNSY  , MEMMAP_PHUNSY,  0x8EE8E48F,          3072, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "KRANT (11B dump)"                               , "?, 19xx"                                    , "11B",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // KRANT.1x1+2x2
  { PHUNSY  , MEMMAP_PHUNSY,  0x862116D1,          3072, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "KRANT (17B dump)"                               , "?, 19xx"                                    , "17B",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // KRANT.1x1+2x2
  { PHUNSY  , MEMMAP_PHUNSY,  0x86B3E3A2,         28672, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "PRPRG"                                          , "?, 19xx"                                    , "19A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // PRPRG.1x1+2x2
  { PHUNSY  , MEMMAP_PHUNSY,  0x783A20E6,         18432, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "CHRPRNTR"                                       , "?, 19xx"                                    , "11B/17B",                              PHUNSY_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // CHRPRNTR.1x1+2x2
  { PHUNSY  , MEMMAP_PHUNSY,  0xAC164A98,         32768, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "MWBAS-04 (05B dump)"                            , "Ian Binnie?, 1979?"                         , "05B",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // MWBAS-04.1x1+2x2
  { PHUNSY  , MEMMAP_PHUNSY,  0x9B99DD09,         32768, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "MWBAS-04 (06B dump)"                            , "Ian Binnie?, 1979?"                         , "06B",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // MWBAS-04.1x1+2x2
  { PHUNSY  , MEMMAP_PHUNSY,  0xA091D230,         32768, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "MODESTA"                                        , "Philips?, 19xx"                             , "10B",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // MODESTA.1x1+2x2
  { PHUNSY  , MEMMAP_PHUNSY,  0xAB0DA5BC,         32512, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "MODESTB (07A dump)"                             , "Philips?, 19xx"                             , "07A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // MODESTB.1x1+2x2
  { PHUNSY  , MEMMAP_PHUNSY,  0x9C50318B,         16128, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "MODESTB (07B/13B dump)"                         , "Philips?, 19xx"                             , "07B/13B",                              PHUNSY_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // MODESTB.1x1+2x2
  { PHUNSY  , MEMMAP_PHUNSY,  0xA0304BC3,          4096, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "QASS-003"                                       , "?, 19xx"                                    , "10B",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC , 0x1800, 0xF0, UBANKF         ,  0x800, UBANK0         ,  0x800, KIND_BIN }, // $1800..$1FFF in UF, $1800..$1FFF in U0
  { PHUNSY  , MEMMAP_PHUNSY,  0x8FE6D0F3, 20 * KILOBYTE, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "DAME"                                           , "?, 19xx"                                    , "19B",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC , 0x4000, 0x01, QBANK1         , 0x4000, QBANK2         , 0x1000, KIND_BIN }, // $4000..$7FFF in Q1, $4000..$4FFF in Q2
  { PHUNSY  , MEMMAP_PHUNSY,  0xB4224E60,  7 * KILOBYTE, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "PHEDTR2 @ $4000"                                , "?, 19xx"                                    , "05A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MC   , 0x4000, 0x00, QBANK0         ,      0,      0         ,      0, KIND_BIN }, // $4000..$5BFF in Q0
  { PHUNSY  , MEMMAP_PHUNSY,  0x18222D39,  7 * KILOBYTE, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "PHEDTR2 @ $2000"                                , "?, 19xx"                                    , "05A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC , 0x2000, 0x00, 0x2000         ,      0,      0         ,      0, KIND_BIN }, // $2000..$3BFF
  { PHUNSY  , MEMMAP_PHUNSY,  0x7E666B71,  5 * KILOBYTE, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "RUNLIGHT"                                       , "B.P.G., 1983"                               , "19B",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MC   ,  0x800, 0x00,  0x800         ,  0x400, 0x2000         , 0x1000, KIND_BIN }, //  $800.. $BFF, $2000..$2FFF
  { PHUNSY  , MEMMAP_PHUNSY,  0x0600F64E,  2 * KILOBYTE, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Clock (10A dump)"                               , "?, 19xx"                                    , "10A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC , 0x1800, 0xF0, UBANKF         ,      0,      0         ,      0, KIND_BIN }, // $1800..$1FFF in UF
  { PHUNSY  , MEMMAP_PHUNSY,  0xB51F51BA,  2 * KILOBYTE, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Clock (16A dump)"                               , "?, 19xx"                                    , "16A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC , 0x1800, 0xF0, UBANKF         ,      0,      0         ,      0, KIND_BIN }, // $1800..$1FFF in UF
  { PHUNSY  , MEMMAP_PHUNSY,  0x1A869555,  3 * KILOBYTE, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "CASSDISK"                                       , "?, 19xx"                                    , "16B",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC ,  0x800, 0x00,  0x800         ,  0x400, UBANK0         ,  0x800, KIND_BIN }, // startaddr might be $1800 instead (gives "INPUT ERROR" instead of nothing)?
  { PHUNSY  , MEMMAP_PHUNSY,  0xF1B23D52,  1 * KILOBYTE, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "KRANT (11B dump)"                               , "?, 19xx"                                    , "11B",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC ,  0x800, 0x00,  0x800         ,      0,      0         ,      0, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0xF97BCF0C,  1 * KILOBYTE, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "KRANT (17B dump)"                               , "?, 19xx"                                    , "17B",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC ,  0x800, 0x00,  0x800         ,      0,      0         ,      0, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0x2423109D,  8 * KILOBYTE, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "PRPRG"                                          , "?, 19xx"                                    , "19A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC , 0x4000, 0x00, QBANK0         , 0x1000, QBANK0 + 0x2000, 0x1000, KIND_BIN }, // $4000..$4FFF in Q0, $6000..$6FFF in Q0
  { PHUNSY  , MEMMAP_PHUNSY,  0xC0E6CD81,  8 * KILOBYTE, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "PALASM (15B dump)"                              , "?, 19xx"                                    , "15B",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MWB  , 0x4000, 0x00, 0x2000         ,      0,      0         ,      0, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0x68EFBD32,  4 * KILOBYTE, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "WRDCMB"                                         , "?, 19xx"                                    , "15B",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MWB  , 0x4000, 0x00, 0x2000         ,      0,      0         ,      0, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0x8BB30F85,  8 * KILOBYTE, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "BAS-TEST"                                       , "?, 19xx"                                    , "20A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MWB  , 0x4000, 0x00, 0x2000         ,      0,      0         ,      0, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0x27F43650,  2 * KILOBYTE, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "BELCAL"                                         , "?, 19xx"                                    , "09A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MWB  , 0x4000, 0x00, 0x2000         ,      0,      0         ,      0, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0xF457970A,  2 * KILOBYTE, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "BELINPUT"                                       , "?, 19xx"                                    , "09A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MWB  , 0x4000, 0x00, 0x2000         ,      0,      0         ,      0, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0x51F40839,           768, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "DAG-WEEK"                                       , "?, 19xx"                                    , "08A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MWB  , 0x4000, 0x00, 0x2000         ,      0,      0         ,      0, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0x46FFCBB9,          1280, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "PLOTEQU"                                        , "?, 19xx"                                    , "08A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MWB  , 0x4000, 0x00, 0x2000         ,      0,      0         ,      0, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0xBF331FBE,  2 * KILOBYTE, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "BIORITME (08A dump)"                            , "?, 19xx"                                    , "08A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MWB  , 0x4000, 0x00, 0x2000         ,      0,      0         ,      0, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0x310D7AE7,  2 * KILOBYTE, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "BIORITME (14A dump)"                            , "?, 19xx"                                    , "14A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MWB  , 0x4000, 0x00, 0x2000         ,      0,      0         ,      0, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0x95168F51,           768, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "E"                                              , "?, 19xx"                                    , "08A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MWB  , 0x4000, 0x00, 0x2000         ,      0,      0         ,      0, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0xBCD5A804,  1 * KILOBYTE, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "LUCIFER"                                        , "?, 19xx"                                    , "08A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MWB  , 0x4000, 0x00, 0x2000         ,      0,      0         ,      0, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0x17B53310,  3 * KILOBYTE, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "GO-BANG"                                        , "?, 19xx"                                    , "08A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MWB  , 0x4000, 0x00, 0x2000         ,      0,      0         ,      0, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0x6CE41166,  6 * KILOBYTE, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "OTHELLO"                                        , "?, 19xx"                                    , "08A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MWB  , 0x4000, 0x00, 0x2000         ,      0,      0         ,      0, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0x6DD6CB30,  3 * KILOBYTE, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "MAANLAND"                                       , "?, 19xx"                                    , "08A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MWB  , 0x4000, 0x00, 0x2000         ,      0,      0         ,      0, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0x709717AF,  4 * KILOBYTE, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "MMIND"                                          , "?, 19xx"                                    , "08A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MWB  , 0x4000, 0x00, 0x2000         ,      0,      0         ,      0, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0x49E669A5,           256, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "R-PAR"                                          , "?, 19xx"                                    , "08A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MWB  , 0x4000, 0x00, 0x2000         ,      0,      0         ,      0, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0xF4193718,  2 * KILOBYTE, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "KALENDER (08A dump)"                            , "?, 19xx"                                    , "08A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MWB  , 0x4000, 0x00, 0x2000         ,      0,      0         ,      0, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0x308087F9,  2 * KILOBYTE, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "KALENDER (14A dump)"                            , "?, 19xx"                                    , "14A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MWB  , 0x4000, 0x00, 0x2000         ,      0,      0         ,      0, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0xE7599D54,  2 * KILOBYTE, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "PALASM (21B dump)"                              , "?, 19xx"                                    , "21B",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC , 0x1800, 0x00, 0x2000         ,      0,      0         ,      0, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0xB3C45F50,  4 * KILOBYTE, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "DASS-004 (03A dump)"                            , "?, 19xx"                                    , "03A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC , 0x2000, 0x00, 0x2000         ,      0,      0         ,      0, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0x887CBC8E,  4 * KILOBYTE, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "DASS-004 (04A dump)"                            , "?, 19xx"                                    , "04A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC , 0x2000, 0x00, 0x2000         ,      0,      0         ,      0, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0x7E6D9998,  2 * KILOBYTE, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "DASS6800"                                       , "?, 19xx"                                    , "21A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MC   , 0x1800, 0x00, UBANK0         ,      0,      0         ,      0, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0xA69FF440,           256, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "300-BAUD"                                       , "?, 19xx"                                    , "10A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC ,  0x800, 0x00,  0x800         ,      0,      0         ,      0, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0xB4B3D08D,           512, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "SER-I/O"                                        , "?, 19xx"                                    , "10A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC ,  0x800, 0x00,  0x800         ,      0,      0         ,      0, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0x88721507,           512, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "FLXWR-02"                                       , "?, 19xx"                                    , "11A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC ,  0x800, 0x00,  0x800         ,      0,      0         ,      0, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0xE4A740A9,           256, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "ROW->COL (11A dump)"                            , "?, 19xx"                                    , "11A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MC   ,  0x900, 0x00,  0x900         ,      0,      0         ,      0, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0x26DFA53F,           256, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "ROW->COL (17A dump)"                            , "?, 19xx"                                    , "17A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC , 0x1800, 0x00, UBANK0         ,      0,      0         ,      0, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0x226A76DC,           256, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "SEE-CHAR"                                       , "?, 19xx"                                    , "11A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MC   ,  0x800, 0x00,  0x800         ,      0,      0         ,      0, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0x48A58A92,           256, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "SEE-EXT (11A dump)"                             , "?, 19xx"                                    , "11A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MC   ,  0x800, 0x00,  0x800         ,      0,      0         ,      0, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0x32269FE2,           256, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "SEE-EXT (17A dump)"                             , "?, 19xx"                                    , "17A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MC   ,  0x800, 0x00,  0x800         ,      0,      0         ,      0, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0x9B97D7FF,            51, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "SEE-EXT (20B dump)"                             , "?, 19xx"                                    , "20B",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MC   ,  0x800, 0x00,  0x800         ,      0,      0         ,      0, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0xF13354F7,  2 * KILOBYTE, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "BIG-CHAR"                                       , "?, 19xx"                                    , "11B",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC , 0x3000, 0x00, 0x3000         ,      0,      0         ,      0, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0x0BEA9471,  7 * KILOBYTE, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "LKRANT"                                         , "?, 19xx"                                    , "11B",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC , 0x2000, 0x00, 0x2000         ,      0,      0         ,      0, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0x9B55C8B1,  2 * KILOBYTE, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "L-KRANT"                                        , "?, 19xx"                                    , "11B",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC , 0x1800, 0x00, UBANK0         ,      0,      0         ,      0, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0xDB405535, 16 * KILOBYTE, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "HYRO-001 (11B dump)"                            , "?, 19xx"                                    , "11B",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC , 0x4000, 0x00, QBANK0         ,      0,      0         ,      0, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0x90B9C7D8, 16 * KILOBYTE, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "HYRO-001 (17B dump)"                            , "?, 19xx"                                    , "17B",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC , 0x4000, 0x00, QBANK0         ,      0,      0         ,      0, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0x5A3EAF93,  1 * KILOBYTE, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "GRAPHICS"                                       , "?, 19xx"                                    , "11B",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC , 0x1800, 0x00, UBANK0         ,      0,      0         ,      0, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0x66177DE6,          2560, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "CHRPRNTR"                                       , "?, 19xx"                                    , "11B",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MC   ,  0x900, 0x00,  0x900         ,  0x200, QBANK0         ,  0x800, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0x760EC0F0,  1 * KILOBYTE, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "I/OPACK"                                        , "?, 19xx"                                    , "03A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC ,  0x800, 0x00,  0x800         ,      0,      0         ,      0, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0x60B2795C,           512, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "KEYB-BEN"                                       , "?, 19xx"                                    , "03A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC , 0x2800, 0x00, 0x2800         ,      0,      0         ,      0, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0x1D5A106B,  2 * KILOBYTE, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "LABHNDN (03A dump)"                             , "?, 19xx"                                    , "03A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC , 0x1800, 0x00, UBANK0         ,      0,      0         ,      0, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0x9F563AF6,  2 * KILOBYTE, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "LABHNDN (20A dump)"                             , "?, 19xx"                                    , "20A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC , 0x1800, 0x00, UBANK0         ,      0,      0         ,      0, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0xBE9840C8,  4 * KILOBYTE, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "PDCR-006"                                       , "?, 19xx"                                    , "03A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC , 0x2000, 0x00, 0x2000         ,      0,      0         ,      0, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0x56BFDB4F,  1 * KILOBYTE, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "PH-CHR"                                         , "?, 19xx"                                    , "03A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC , 0x2000, 0x00, 0x2000         ,      0,      0         ,      0, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0x424FCA45,  4 * KILOBYTE, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "PMON0400"                                       , "?, 19xx"                                    , "03A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC , 0x2000, 0x00, 0x2000         ,      0,      0         ,      0, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0x02B74BD9,  4 * KILOBYTE, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "PMON0401"                                       , "?, 19xx"                                    , "03A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC , 0x2000, 0x00, 0x2000         ,      0,      0         ,      0, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0x15B35028,  2 * KILOBYTE, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "PMON0402"                                       , "?, 19xx"                                    , "03A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC , 0x2000, 0x00, 0x2000         ,      0,      0         ,      0, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0x51893062,  2 * KILOBYTE, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "PMON0403"                                       , "?, 19xx"                                    , "03A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC , 0x2000, 0x00, 0x2000         ,      0,      0         ,      0, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0x38C09758,  2 * KILOBYTE, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "PMON0404 (03A dump)"                            , "?, 19xx"                                    , "03A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC , 0x2000, 0x00, 0x2000         ,      0,      0         ,      0, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0xA8D2C895,  2 * KILOBYTE, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "PMON0404 (04A dump)"                            , "?, 19xx"                                    , "04A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC , 0x2000, 0x00, 0x2000         ,      0,      0         ,      0, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0xEDF7CED7,  1 * KILOBYTE, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "PMONmini"                                       , "?, 19xx"                                    , "16A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC , 0x2000, 0x00, 0x2000         ,      0,      0         ,      0, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0x9AF1F4D9,  1 * KILOBYTE, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "RAMTEST"                                        , "?, 19xx"                                    , "03A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC , 0x1800, 0x00, UBANK0         ,      0,      0         ,      0, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0xFE3AF9CA,  4 * KILOBYTE, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "TRNR-001"                                       , "?, 19xx"                                    , "03A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC , 0x2000, 0x00, 0x2000         ,      0,      0         ,      0, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0xA34CCDB5,  2 * KILOBYTE, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "MAXBUG3"                                        , "?, 19xx"                                    , "21A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC , 0x4800, 0x00, QBANK0 +  0x800,      0,      0         ,      0, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0x016BEA89,  2 * KILOBYTE, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "MAXCHAR"                                        , "?, 19xx"                                    , "21A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC , 0x4000, 0x00, QBANK0         ,      0,      0         ,      0, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0x8C910538,  2 * KILOBYTE, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "MAXCHAR+"                                       , "?, 19xx"                                    , "21A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC , 0x4000, 0x00, QBANK0         ,      0,      0         ,      0, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0x342BFE25,  2 * KILOBYTE, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "MBUG3-LT"                                       , "?, 19xx"                                    , "21A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC , 0x2000, 0x00, 0x2000         ,      0,      0         ,      0, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0x1E4890EC,           512, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "OPCD6800"                                       , "?, 19xx"                                    , "21A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC , 0x2000, 0x00, 0x2000         ,      0,      0         ,      0, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0xFB07AD63,          1456, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "OPCODES"                                        , "?, 19xx"                                    , "19A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC , 0x2000, 0x00, 0x2000         ,      0,      0         ,      0, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0x2172310B,  2 * KILOBYTE, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "SCR"                                            , "?, 19xx"                                    , "21A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC , 0x2000, 0x00, 0x2000         ,      0,      0         ,      0, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0x52C24E22,  1 * KILOBYTE, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "50-THEME"                                       , "?, 19xx"                                    , "08B",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MC   , 0x1800, 0x00, UBANK0         ,      0,      0         ,      0, KIND_BIN }, // 797
  { PHUNSY  , MEMMAP_PHUNSY,  0xFF03BC3F,  2 * KILOBYTE, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Boter Melk Kaas"                                , "J.F.P. Philipse, 1980"                      , "08B",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MC   , 0x1800, 0x00, UBANK0         ,      0,      0         ,      0, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0x9B2C2B91,           512, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "GEINTJE"                                        , "?, 19xx"                                    , "08B",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MC   , 0x1800, 0x00, UBANK0         ,      0,      0         ,      0, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0x1C3F5332,  2 * KILOBYTE, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "GETS-002"                                       , "?, 19xx"                                    , "08B",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MC   , 0x1800, 0x00, UBANK0         ,      0,      0         ,      0, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0xABD0C22A,           512, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "KLOK"                                           , "?, 19xx"                                    , "08B",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MC   , 0x1800, 0x00, UBANK0         ,      0,      0         ,      0, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0xD5D4A271,  2 * KILOBYTE, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "OTHELLO"                                        , "?, 19xx"                                    , "08B",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MC   , 0x1800, 0x00, UBANK0         ,      0,      0         ,      0, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0xB628EA59,  2 * KILOBYTE, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "PAUZE"                                          , "?, 19xx"                                    , "08B",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MC   , 0x1800, 0x00, UBANK0         ,      0,      0         ,      0, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0x75775AB2,           256, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "PIANO"                                          , "?, 19xx"                                    , "08B",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MC   , 0x1800, 0x00, UBANK0         ,      0,      0         ,      0, KIND_BIN }, // 804
  { PHUNSY  , MEMMAP_PHUNSY,  0x17006056,  2 * KILOBYTE, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "GRAPJE-1"                                       , "?, 19xx"                                    , "08B",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MC   , 0x1800, 0x00, UBANK0         ,      0,      0         ,      0, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0x36D0A0B3,  2 * KILOBYTE, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "GRAPJE-2"                                       , "?, 19xx"                                    , "08B",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MC   , 0x1800, 0x00, UBANK0         ,      0,      0         ,      0, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0xFDF3252B,  2 * KILOBYTE, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "GRAPJE-3"                                       , "?, 19xx"                                    , "08B",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MC   , 0x1800, 0x00, UBANK0         ,      0,      0         ,      0, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0x785A7B40,  2 * KILOBYTE, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "GRAPJE-4"                                       , "?, 19xx"                                    , "08B",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MC   , 0x1800, 0x00, UBANK0         ,      0,      0         ,      0, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0x0E14EAF3,  2 * KILOBYTE, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "GRAPJE-5"                                       , "?, 19xx"                                    , "08B",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MC   , 0x1800, 0x00, UBANK0         ,      0,      0         ,      0, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0x3103BD1A,           256, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "64>374"                                         , "?, 19xx"                                    , "17A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC ,  0x800, 0x00,  0x800         ,      0,      0         ,      0, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0x206455AF,           256, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "SEE-C374"                                       , "?, 19xx"                                    , "17A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC , 0x1800, 0x00, UBANK0         ,      0,      0         ,      0, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0x9E78DCA1,  7 * KILOBYTE, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "TPRINTER (13A dump)"                            , "?, 19xx"                                    , "13A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC , 0x6000, 0x01, QBANK1 + 0x2000,      0,      0         ,      0, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0xAEB41052,  7 * KILOBYTE, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "TPRINTER (17A dump)"                            , "?, 19xx"                                    , "17A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC , 0x6000, 0x00, QBANK0 + 0x2000,      0,      0         ,      0, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0x22A9EB09,          2560, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "TPRINT-S"                                       , "?, 19xx"                                    , "21B",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC , 0x6000, 0x00, QBANK0 + 0x2000,      0,      0         ,      0, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0xE4FD364D,           512, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "FPRINTER"                                       , "?, 19xx"                                    , "21B",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC ,  0x800, 0x00,  0x800         ,      0,      0         ,      0, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0x573C1F5B,  2 * KILOBYTE, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "PCITALK"                                        , "?, 19xx"                                    , "21B",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MC   , 0x1800, 0x00, UBANK0         ,      0,      0         ,      0, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0xABE4451C,  5 * KILOBYTE, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "PEDT-0A3"                                       , "?, 19xx"                                    , "07A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MC   , 0x4000, 0x00, QBANK0         ,      0,      0         ,      0, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0xFD3CC063,  7 * KILOBYTE, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "PEDT-004 (13A dump)"                            , "?, 19xx"                                    , "13A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MC   , 0x4000, 0x01, QBANK1         ,      0,      0         ,      0, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0x6E076DA5,  7 * KILOBYTE, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "PEDT-004 (21B dump)"                            , "?, 19xx"                                    , "21B",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MC   , 0x4000, 0x00, QBANK0         ,      0,      0         ,      0, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0x026A3945,  1 * KILOBYTE, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "BASIO-20"                                       , "?, 19xx"                                    , "20A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC , 0x2000, 0x00, 0x2000         ,      0,      0         ,      0, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0x0E29F1F1,  1 * KILOBYTE, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "CONV2>0"                                        , "?, 19xx"                                    , "20A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MC   ,  0x800, 0x00,  0x800         ,      0,      0         ,      0, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0x7A28BFF4,  1 * KILOBYTE, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "CONV6>2"                                        , "?, 19xx"                                    , "20A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MC   ,  0x800, 0x00,  0x800         ,      0,      0         ,      0, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0x34DB061D,           512, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "SEND-JET"                                       , "?, 19xx"                                    , "20B",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC ,  0x800, 0x00,  0x800         ,      0,      0         ,      0, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0x78A93E54,          3840, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "GRAPHS"                                         , "?, 19xx"                                    , "20B",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC , 0x2000, 0x00, 0x2000         ,      0,      0         ,      0, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0x2CA7EFD2,  2 * KILOBYTE, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "PORT9600"                                       , "?, 19xx"                                    , "20B",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MC   , 0x1800, 0x00, UBANK0         ,      0,      0         ,      0, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0xB3A47619, 16 * KILOBYTE, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "MX-SYST"                                        , "?, 19xx"                                    , "15A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC , 0x4000, 0x00, QBANK0         ,      0,      0         ,      0, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0x8FBE4973,  8 * KILOBYTE, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "MWBAS-00"                                       , "?, 19xx"                                    , "03B",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC , 0x2000, 0x00, 0x2000         ,      0,      0         ,      0, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0x57CBB00A, 16 * KILOBYTE, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "MWBAS-04 (05B dump)"                            , "?, 19xx"                                    , "05B",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MC   , 0x6000, 0x00, QBANK0 + 0x2000, 0x2000, QBANK0         , 0x2000, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0xD674D855, 16 * KILOBYTE, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "MWBAS-04 (06B dump)"                            , "?, 19xx"                                    , "06B",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MC   , 0x6000, 0x00, QBANK0 + 0x2000, 0x2000, QBANK0         , 0x2000, KIND_BIN }, // 06B+05B
  { PHUNSY  , MEMMAP_PHUNSY,  0x1CBF0481,  7 * KILOBYTE, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "MWBAS-05"                                       , "?, 19xx"                                    , "07A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MC   , 0x6000, 0x00, QBANK0 + 0x2000,      0,      0         ,      0, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0x0D555A8F,          6912, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "MWBAS-06 (13A dump)"                            , "?, 19xx"                                    , "13A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MC   , 0x2000, 0x00, 0x2000         ,      0,      0         ,      0, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0x9CF2D5F6,  7 * KILOBYTE, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "MWBAS-06 (14A dump)"                            , "?, 19xx"                                    , "14A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MC   , 0x4000, 0x00, QBANK0         ,      0,      0         ,      0, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0x0F36E30F,  8 * KILOBYTE, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "MWBAS-06 (20A dump)"                            , "?, 19xx"                                    , "20A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MC   , 0x6000, 0x00, QBANK0 + 0x2000,      0,      0         ,      0, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0x0D18644C,  7 * KILOBYTE, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "MWBAS-M6"                                       , "?, 19xx"                                    , "20A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC , 0x4000, 0x00, QBANK0         ,      0,      0         ,      0, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0x680EB5BA,  9 * KILOBYTE, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "MODEST (01A dump)"                              , "?, 19xx"                                    , "01A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC , 0x5C00, 0x00, QBANK0 + 0x1C00,      0,      0         ,      0, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0xD1CD2944,  9 * KILOBYTE, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "MODEST (02A dump)"                              , "?, 19xx"                                    , "02A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC , 0x5C00, 0x00, QBANK0 + 0x1C00,      0,      0         ,      0, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0x6AC1FFFB,  8 * KILOBYTE, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "MODESTB (07A dump)"                             , "?, 19xx"                                    , "07A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MC   ,  0xB00, 0x00,  0xB00         ,  0x100, QBANK0 + 0x2000, 0x1F00, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0x3BE0E8DE,  8 * KILOBYTE, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "MODESTB (07B dump)"                             , "?, 19xx"                                    , "07B",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MC   ,  0xB00, 0x00,  0xB00         ,  0x100, 0x2000         , 0x1F00, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0xA51BC08A,  8 * KILOBYTE, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "MODESTC (13A dump)"                             , "?, 19xx"                                    , "13A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MC   , 0x6000, 0x00, QBANK0 + 0x2000,      0,      0         ,      0, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0x6B740356,          7936, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "MODESTC (16B dump)"                             , "?, 19xx"                                    , "16B",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MC   , 0x6000, 0x00, QBANK0 + 0x2000,      0,      0         ,      0, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0xB307D0B4,          7936, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "MODESTM"                                        , "?, 19xx"                                    , "19A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC , 0x2000, 0x00, 0x2000         ,      0,      0         ,      0, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0x28A2DC4B,          8448, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "MODESTA"                                        , "?, 19xx"                                    , "10B",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MC   ,  0xB00, 0x00,  0xB00         ,  0x100, QBANK0 + 0x2000, 0x2000, KIND_BIN }, // 07A-MODESTB.1x2+10B-MODESTA.2x2
  { PHUNSY  , MEMMAP_PHUNSY,  0x7E5689AB,  8 * KILOBYTE, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "PRMTHS"                                         , "?, 19xx"                                    , "01A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC , 0x2000, 0x00, 0x2000         ,      0,      0         ,      0, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0x4E5C87E7,          8448, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "FORTH-00"                                       , "?, 19xx"                                    , "03B",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC , 0x2000, 0x00, 0x2000         , 0x2000, QBANK0         ,  0x100, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0x1868EF2E,          8448, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "FORTH-01"                                       , "?, 19xx"                                    , "07A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MC   , 0x2000, 0x00, 0x2000         , 0x2000, QBANK0         ,  0x100, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0xF15CD880,  1 * KILOBYTE, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "CDC-I/O"                                        , "?, 19xx"                                    , "05B",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC , 0x7800, 0x00, QBANK0 + 0x3800,      0,      0         ,      0, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0xE99C28F0,           512, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "COPY"                                           , "?, 19xx"                                    , "07A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MC   ,  0x800, 0x00,  0x800         ,      0,      0         ,      0, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0x1DFCD4A1, 16 * KILOBYTE, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "PASS (07B dump)"                                , "?, 19xx"                                    , "07B",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MC   , 0x4000, 0x00, QBANK0         ,      0,      0         ,      0, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0xBB2CA630, 16 * KILOBYTE, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "PASS (13B dump)"                                , "?, 19xx"                                    , "13B",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MC   , 0x4000, 0x00, QBANK0         ,      0,      0         ,      0, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0x59506E9F,            40, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "CLEARMEM"                                       , "?, 19xx"                                    , "13A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MC   ,  0xE50, 0x00,  0xE50         ,      0,      0         ,      0, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0xC4CA2EB8,  6 * KILOBYTE, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "HEXDUMP"                                        , "?, 19xx"                                    , "13B",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC , 0x4000, 0x01, QBANK1         ,      0,      0         ,      0, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0x1C2A7AFF,  2 * KILOBYTE, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "BELMACH"                                        , "?, 19xx"                                    , "09A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MC   , 0x1800, 0x00, UBANK0         ,      0,      0         ,      0, KIND_BIN }, // 852
  { PHUNSY  , MEMMAP_PHUNSY,  0xED3AE41E,  2 * KILOBYTE, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_BAD ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "BELMACH0 (bad dump) (obsolete)"                 , "J.F.P. Philipse, 1982"                      , "09A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC , 0x3000, 0x00, 0x3000         ,      0,      0         ,      0, KIND_BIN }, // 853
  { PHUNSY  , MEMMAP_PHUNSY,  0x633F801C,  4 * KILOBYTE, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "LIEDJES"                                        , "?, 19xx"                                    , "09A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC , 0x4000, 0x00, QBANK0         ,      0,      0         ,      0, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0x93396A01,           256, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "COPYOV"                                         , "?, 19xx"                                    , "16B",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MC   ,  0xA00, 0x00,  0xA00         ,      0,      0         ,      0, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0xE0A3751C,  2 * KILOBYTE, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "DISK"                                           , "?, 19xx"                                    , "16B",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC , 0x1800, 0x00, UBANK0         ,      0,      0         ,      0, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0xCB341A1D,  2 * KILOBYTE, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "MEMTA"                                          , "?, 19xx"                                    , "16B",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MC   , 0x1800, 0x00, UBANK0         ,      0,      0         ,      0, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0x65AC7D9A,  4 * KILOBYTE, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "ZOOI"                                           , "?, 19xx"                                    , "16B",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC , 0x2000, 0x00, 0x2000         ,      0,      0         ,      0, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0xB04FAAE4,           512, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "PHCSRD"                                         , "?, 19xx"                                    , "19A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC , 0x2000, 0x00, 0x2000         ,      0,      0         ,      0, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0x091B4E10,           256, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "READHEX"                                        , "?, 19xx"                                    , "19A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MC   ,  0x800, 0x00,  0x800         ,      0,      0         ,      0, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0x4E6B2797,           256, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "SOUTCASS"                                       , "?, 19xx"                                    , "19A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MC   ,  0x800, 0x00,  0x800         ,      0,      0         ,      0, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0x1DA6D4BF,  4 * KILOBYTE, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "TERML"                                          , "?, 19xx"                                    , "19A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC , 0x2000, 0x00, 0x2000         ,      0,      0         ,      0, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0xC2BA9A48,  2 * KILOBYTE, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "BELMACH0"                                       , "J.F.P. Philipse, 1982"                      , "09A",                                  PHUNSY_OVERLAY, -1,  -1,  -1, CL_MISC , 0x3000, 0x00, 0x3000         ,      0,      0         ,      0, KIND_BIN }, // 863
  { ELEKTOR , MEMMAP_E,       0x06707A15,  4 * KILOBYTE,  2,  1,  3,  0, -1, -1, -1, -1, TRUE,  SENSITIVITY_HIGH   ,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE,      55, PVI_VBLANK, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "11-b",     "Apple Tree (Apfelbaum)"                         , "Peter Marschat, 198x"                       , "-",                                                78, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_F,       0xC07F8ED1,  6 * KILOBYTE,  2,  1,  3,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Assembler"                                      , "Peter Marschat, 198x"                       , "-",                                               181, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // -/F
  { ELEKTOR , MEMMAP_E,       0x65EA39C3,          3414,  2,  1,  3,  0, -1, -1, -1, -1, TRUE,  SENSITIVITY_VLOW   ,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO,              250,      60, PVI_VBLANK, 0, DUMP_BAD ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Car Race (bad dump)"                            , "Peter Marschat, 198x"                       , "-",                                               177, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_F,       0xB3F5D504,          5200,  0, 11,  9,  6, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Disassembler"                                   , "Peter Marschat, 198x"                       , "-",                                               178, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // -/F
  { ELEKTOR , MEMMAP_E,       0x782C213E,  4 * KILOBYTE,  7,  5,  9,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Penalty (Elfmeter)"                             , "Peter Marschat, 198x"                       , "-",                                               174, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_E,       0x96CF615B,  4 * KILOBYTE,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , BLACK, DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Moonlanding for 1 (Mondflug)"                   , "Peter Marschat, 198x"                       , "-",                                               175, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_ELEKTOR, 0x29D1ADE1,          4375,  2,  1,  0, 11, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , BLACK, DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Moonlanding for 2 (Mondflug)"                   , "Peter Marschat, 198x"                       , "-",                                               176, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/F
  { ELEKTOR , MEMMAP_E,       0x64217BDB,          3488,  0,  7,  4,  5, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_BAD ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Sound and Colour (Senso) (bad dump)"            , "Peter Marschat, 1983"                       , "-",                                               180, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_F,       0xAA4EA16E,          5633,  2,  1,  3,  0, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Single Step"                                    , "Peter Marschat, 198x"                       , "-",                                               182, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // -/F
  { ELEKTOR , MEMMAP_E,       0xC60C2BC6,          3418,  2,  2,  2,  2, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, TRUE , 16,         5,     10, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Ticker"                                         , "Peter Marschat, 198x"                       , "-",                                               179, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_E,       0x1EEAFF84,          3552,  0,  7,  4,  5, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO, PVI_LATESTSPRITE, PVI_CPL, PVI_VBLANK, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Sound and Colour (Senso)"                       , "Peter Marschat, 1983"                       , "-",                                               180, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { ELEKTOR , MEMMAP_E,       0x08D46655,          3414,  2,  1,  3,  0, -1, -1, -1, -1, TRUE,  SENSITIVITY_VLOW   ,        0, FALSE, TRUE , 16,    DEF_DN, DEF_TO,              250,      60, PVI_VBLANK, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Car Race"                                       , "Peter Marschat, 198x"                       , "-",                                               177, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM }, // E/-
  { PHUNSY  , MEMMAP_PHUNSY,  0x6F578A9A,          6182, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Character Set 2.0"                              , "Amigan Software, 2010"                      , "-",                                    PHUNSY_OVERLAY, -1,  -1,  -1, CL_MC   ,      0,    0,      0         ,      0,      0         ,      0, KIND_PGM },
  { PHUNSY  , MEMMAP_PHUNSY,  0xD64DC7A4,  7 * KILOBYTE, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "EDITOR"                                         , "?, 19xx"                                    , "EDITOR.MDCR",                          PHUNSY_OVERLAY, -1,  -1,  -1, CL_MC   , 0x4000, 0x00, QBANK0         ,      0,      0         ,      0, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0x01D91E2A,  7 * KILOBYTE, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "MWBAS-07"                                       , "J.F.P. Philipse, 19xx-2010"                 , "BASIC/BASIC2.MDCR",                    PHUNSY_OVERLAY, -1,  -1,  -1, CL_MC   , 0x2000, 0x00, 0x2000         ,      0,      0         ,      0, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0xF846876E,          8448, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "FORTH-02"                                       , "?, 19xx"                                    , "MODESTB.MDCR",                         PHUNSY_OVERLAY, -1,  -1,  -1, CL_MC   , 0x2000, 0x00, 0x2000         , 0x2000, QBANK0         ,  0x100, KIND_BIN },
  { PHUNSY  , MEMMAP_PHUNSY,  0x66D710AB,           256, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "HELLO"                                          , "J.F.P. Philipse, 2010"                      , "-",                                    PHUNSY_OVERLAY, -1,  -1,  -1, CL_MC   ,  0x800, 0x00,  0x800         ,      0,      0         ,      0, KIND_BIN },
  { DOLPHIN , MEMMAP_DOLPHIN, 0xC4BED94B,           114, -1, -1, -1, -1, -1, -1, -1, -1, FALSE, SENSITIVITY_DEFAULT,        0, FALSE, FALSE, 16,    DEF_DN, DEF_TO,                0,       0,          0, 0, DUMP_OK  ,   { 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0},{ 0, 0, 0, 0, 0, 0},{ 0, 0, 0, 0}, "",         "Testez vos Reflexes"                            , "Daniel Roux, 1977"                          , "-",                                               183, -1, 642, 654, CL_MC   ,  0x800, 0x00,  0x800         ,      0,      0         ,      0, KIND_BIN }
}; //                                                    lt  dn  rt  up  up  dn  lt  rt
