#ifdef _lint
    #define WIN32
    #define _inline
#endif

#include "ibm.h"

#include <commctrl.h>
#include <mmreg.h>    // for eg. AVIFileOpen()
#include <vfw.h>      // for eg. PAVIFILE
#include <windowsx.h>

#define _WIN32_WINNT 0x0400 // otherwise we don't get DSBLOCK_ENTIREBUFFER, etc.

#include "resource.h"

#include <stdio.h>

#define EXEC_TYPES_H
#include "aa.h"
#define CATCOMP_NUMBERS
#define CATCOMP_BLOCK
#include "aa_strings.h"

#define TONELENGTH            2865 // enough to handle PITCH as high as 255 (ie. as low as 7874/256=30.75781Hz)
#define NOISELENGTH           (32 * KILOBYTE)

EXPORT       FLAG                 aborting;
EXPORT       UBYTE                spritecontents[10];
EXPORT       LPBITMAPINFOHEADER   AnimInfo        = NULL;
EXPORT       HDC                  ControlsRastPtr;
EXPORT       int                  ignorepaint,
                                  sparex,
                                  sparey,
                                  sprviewcolour,
                                  viewingsprite   = 0;
EXPORT       RECT                 axesrect;
EXPORT       HWND                 hRegionListBox  = NULL,
             // CPU chip...
             DataBusGad,
             AddrBusGad,
             RGad[7],
             CCGad,
             OneGad[10],
             RASGad[8],
             IARGad,
             ClockGad,
             FrameGad,
             RasterGad,
             TimeGad,
             // XVI chips...
             SPRITEnAXYGad[12],
             SPRITEnBXYGad[12],
             memorygad[MEMGADGETS],
             monitorgad[MONITORGADS],
             spritegad[80],
             // PSGs
             PITCHAGad[2],
             PITCHBGad[2],
             PITCHCGad[2],
             PERIODGad[2];
#ifdef USEDIRECTSOUND
    EXPORT struct IDirectSound*   lpds            = NULL;
#endif

EXPORT struct KindStruct filekind[KINDS] =
{ { ".IFF",
    "IFF ILBM (*.IFF, *.ILBM, *.LBM)\0*.IFF;*.ILBM;*.LBM\0All Files (*.*)\0*.*\0",
    NULL,
    NULL
  },
  { ".IFF",
    "IFF ACBM (*.IFF, *.ACBM)\0*.IFF;*.ACBM\0All Files (*.*)\0*.*\0",
    NULL,
    NULL
  },
  { ".BMP",
    "BMP (*.BMP)\0*.BMP\0All Files (*.*)\0*.*\0",
    NULL,
    NULL
  },
  { ".PCX",
    "PCX (*.PCX)\0*.PCX\0All Files (*.*)\0*.*\0",
    NULL,
    NULL
  },
  { ".BIN",
    "Arcadia/Interton/Dolphin/PHUNSY Program (*.BIN)\0*.BIN\0All Files (*.*)\0*.*\0",
    "bin_ext",
    "Emerson Arcadia 2001, Interton VC 4000, Dolphin or PHUNSY program"
  },
  { ".PGM",
    "Elektor/PIPBUG/SI50/CD2650/PHUNSY Program (*.PGM)\0*.PGM\0All Files (*.*)\0*.*\0",
    "pgm_ext",
    "Elektor TVGC, PIPBUG-based machine, Signetics Instructor 50, Central Data 2650 or PHUNSY program"
  },
  { ".TVC",
    "Elektor Program (*.TVC)\0*.TVC\0All Files (*.*)\0*.*\0",
    "tvc_ext",
    "Elektor TVGC program"
  },
  { ".COS",
    "Snapshot (*.COS)\0*.COS\0All Files (*.*)\0*.*\0",
    "cos_ext",
    "COmmon Snapshot format"
  },
  { ".COR",
    "Recording (*.COR)\0*.COR\0All Files (*.*)\0*.*\0",
    "cor_ext",
    "COmmon Recording format"
  },
  { ".EAP",
    "SpriteMakerEA Project (*.EAP)\0*.EAP\0All Files (*.*)\0*.*\0",
    NULL,
    NULL
  },
  { ".EAL",
    "TextMakerEA Project (*.EAL)\0*.EAL\0All Files (*.*)\0*.*\0",
    NULL,
    NULL
  },
  { ".AVI",
    "RIFF AVI Animation (*.AVI)\0*.AVI\0All Files (*.*)\0*.*\0",
    NULL,
    NULL
  },
  { ".ZIP",
    "ZIP Archive (*.ZIP)\0*.ZIP\0All Files (*.*)\0*.*\0",
    "zip_ext",
    "ZIP archived Signetics-based game"
  },
  { ".RAW",
    NULL,
    NULL,
    NULL,
  },
  { ".AOF",
    "Absolute Object Format (*.AOF)\0*.AOF\0All Files (*.*)\0*.*\0",
    "aof_ext",
    "Signetics Absolute Object Format"
} }; // fixextension() relies on this being fully populated!

EXPORT const int gadgetimage[9][2] =
{ { BIGGADGETS +  0, BIGGADGETS +  9 },
  { BIGGADGETS +  1, BIGGADGETS + 10 },
  { BIGGADGETS +  2, BIGGADGETS + 11 },
  { BIGGADGETS +  3, BIGGADGETS + 12 },
  { BIGGADGETS +  4, BIGGADGETS + 13 },
  { BIGGADGETS +  5, BIGGADGETS + 14 },
  { BIGGADGETS +  6, BIGGADGETS + 15 },
  { BIGGADGETS +  7, BIGGADGETS +  7 }, // same imagery for both states
  { BIGGADGETS +  8, BIGGADGETS +  8 }, // same imagery for both states
};

// IMPORTED VARIABLES-----------------------------------------------------

IMPORT       int                   assoc[7],
                                   ax[2],
                                   ay[2],
                                   autopause,
                                   CatalogPtr,
                                   charset,
                                   cli,
                                   clientwidth,
                                   clientheight,
                                   colourset,
                                   confine,
#ifndef _lint
                                   consoleopen,
#endif
                                   currentgame,
                                   crippled,
                                   destwidth,
                                   destheight,
                                   enhancestars,
                                   fastsize,
                                   fastwide,
                                   foundaofs,
                                   founddirs,
                                   foundgames,
                                   foundgood,
                                   foundbad,
                                   foundsnaps,
                                   foundicons,
                                   foundunknown,
                                   frameskip,
                                   fullscreen,
                                   game,
                                   highres,
                                   hostcontroller[2],
                                   hostvolume,
                                   key1,
                                   key2,
                                   key3,
                                   key4,
                                   language,
                                   loop,
                                   lowercase,
                                   machine,
                                   memmap,
                                   needaudit,
                                   pvibase,
                                   queuepos,
                                   rastlines,
                                   rastwidth,
                                   rastheight,
                                   realsize,
                                   realwide,
                                   reassociate,
                                   recmode,
                                   regionstart,
                                   rotate,
                                   s_intdir,
                                   s_intselector,
                                   s_io,
                                   sensitivity,
                                   showlegend,
                                   showmenubar,
                                   showpointer,
                                   showsidebar,
                                   showtoolbar,
                                   size,
                                   sourcewidth,
                                   sourceheight,
                                   starfield,
                                   stretch,
                                   toolbarheight,
                                   trace,
                                   useansi,
                                   useinternal,
                                   whichgame,
                                   whichoverlay,
                                   whichpen,
                                   wide,
                                   winheight,
                                   wsc,
                                   xmas,
                                   xoffset,
                                   yoffset;
IMPORT       FLAG                  capslock,
                                   guestplaying[14],
                                   jump,
                                   lame,
                                   opening,
                                   SampleOpened[SAMPLES],
                                   SamplePrepared[SAMPLES],
                                   showingpointer;
IMPORT       TEXT                  autotext[GAMEINFOLINES][80 + 1],
                                   fn_game[MAX_PATH + 1], // the entire pathname (path and file)
                                   hostname[256 + 1],
                                   olddir[MAX_PATH + 1],
                                   pathpart[MAX_PATH + 1],
                                   pgmtext[6 * KILOBYTE],
                                   ProgDir[MAX_PATH + 1],
                                   ProgName[MAX_PATH + 1],
                                   ProjectBuffer[PROJECTSIZE],
                                   thequeue[QUEUESIZE],
                                   titlebartext[MAX_PATH + 1 + TITLEBARTEXTLENGTH + 6 + 80]; // " (paused) (client)" is 9 bytes
IMPORT       UBYTE                 g_dips,
                                   s_toggles,
                                   jx[2], jy[2],
                                   KeyMatrix[64], // to allow keycodes up to 511
                                   memory[32768],
                                   oldflag,
                                   oldglow,
                                   oldrun,
                                   psu;
IMPORT       ASCREEN               screen[BOXWIDTH][BOXHEIGHT];
IMPORT       UBYTE*                SampleBuffer[SAMPLES];
IMPORT       ULONG                 analog,
                                   autofire,
                                   collisions,
                                   demultiplex,
                                   flagline,
                                   keyframes[SCANCODES],
                                   paused,
                                   pens[2][PENS],
                                   region,
                                   SampleLength[SAMPLES],
                                   sound,
                                   swapped,
                                   turbo;
IMPORT       ULONG                *display,
                                  *stars;
IMPORT       HMENU                 MenuPtr,
                                   PopUpMenuPtr;
IMPORT       HWND                  ConsoleWindowPtr,
                                   ControlsWindowPtr,
                                   DIPsWindowPtr,
                                   FPSPtr,
                                   GameInfoWindowPtr,
                                   hRegionListBox,
                                   hSideBar,
                                   hToolbar,
                                   ListeningWindowPtr,
                                   MainWindowPtr,
                                   MemoryWindowPtr,
                                   MonitorWindowPtr,
                                   PaletteWindowPtr,
                                   SpriteWindowPtr;
IMPORT       HDC                   OurhDC;
IMPORT       HBITMAP               OurhBitMap;
IMPORT       HFONT                 hRussianFont;
IMPORT       HWAVEOUT              hSample[SAMPLES];
IMPORT       HINSTANCE             InstancePtr;
IMPORT       HCURSOR               hArrow,
                                   hCross;
IMPORT const struct KeyRectStruct  keyrect[MACHINES][KEYS];
IMPORT       RECT                  therect;
IMPORT       POINT                 ThePoint;
IMPORT const int                   from_m_spr[8],
                                   from_g_w_spr[8],
                                   from_g_x_spr[8];
IMPORT const UBYTE                 from_a[16];
IMPORT const UWORD                 pvi_spritedata[4];
IMPORT const ULONG                 defpencolours[2][3][GUESTCOLOURS];
IMPORT const STRPTR                asciiname[32],
                                   overlays[OVERLAYS][33];
IMPORT const struct KnownStruct    known[KNOWNGAMES];
IMPORT       struct KeyNameStruct  keyname[SCANCODES];
IMPORT const struct MachineStruct  machines[MACHINES];
IMPORT const struct HostMachineStruct hostmachines[MACHINES];
IMPORT       struct LangStruct     langs[LANGUAGES];
IMPORT       int                   sidebar[FOUNDGAMES_MAX];
IMPORT       struct AuditStruct    auditlist[FOUNDGAMES_MAX];
IMPORT       struct HiScoreStruct  hiscore[HISCORES];
IMPORT       HANDLE                hConsole;
#ifdef USEDIRECTSOUND
    EXPORT   LPDIRECTSOUNDBUFFER  inst[7] = {NULL, NULL, NULL, NULL, NULL, NULL, NULL}; // for guest tone channels 0..6
#endif

#ifdef OLDWAY
IMPORT struct
{   BITMAPINFOHEADER Header;
    DWORD            Colours[3];
} TheBitMapInfo;
#endif
#ifdef NEWWAY
IMPORT BITMAPINFO    TheBitMapInfo;
#endif

MODULE       UBYTE                ToneBuffer[7][TONELENGTH],
                                  NoiseBuffer[7][NOISELENGTH];
MODULE       FLAG                 firstanim,
                                  iconified       = FALSE,
                                  resetdisabled,
                                  SoundOpened[14] = {FALSE, FALSE, FALSE, FALSE, FALSE, FALSE,
                                                     FALSE, FALSE, FALSE, FALSE, FALSE, FALSE,
                                                     FALSE, FALSE};
MODULE       int                  frameno,
                                  ToneLength[14];
MODULE       HWAVEOUT             hPSG[14];
MODULE       WAVEHDR              PSGHdr[14],
                                  SampleHdr[SAMPLES];
MODULE       PAVISTREAM           ps              = NULL,
                                  psCompressed    = NULL;
MODULE       PAVIFILE             pfile           = NULL;
MODULE       HDC                  AxesRastPtr;
#ifdef USEDIRECTSOUND
    MODULE   int                  currentinst     = INSTRUMENT_DEFAULT;
#endif

EXPORT const int menucode[MENUITEMS] =
{   ID_CONTROLLERS_ANALOG,
    ID_CONTROLLERS_AUTOFIRE,
    ID_OPTIONS_AUTOSAVE,
    ID_DEBUG_CHANGE,
    ID_DEBUG_CLEARBPS,
    ID_DEBUG_CLEARWPS,
    ID_FILE_CLIENT,
    ID_SPRITES_COLLISIONS,
    ID_VIEW_CONTROLS,
    ID_VIEW_CRAM,
    -1, // create icons
    ID_SPRITES_DEMULTIPLEX,
    ID_GRAPHICS_FLAGLINE,
    ID_GRAPHICS_FULLSCREEN,
    ID_HELP_ABOUT,
    -1, // host gameport 1
    ID_EDIT_PASTETEXT,
    ID_LOG_INSTRUCTIONS,
    ID_LOG_READWRITES,
    ID_LOG_EPROM,
    ID_MACRO_LOOP,
    ID_INPUT_FORCEFEEDBACK,
    -1, // machine
    -1, // macro
    ID_HELP_MANUAL,
    ID_VIEW_MENU,
    ID_VIEW_MONITOR,
    ID_GRAPHICS_NARROW,
    ID_FILE_OPEN,
    ID_SPEED_PAUSED,
    ID_VIEW_POINTER,
    ID_VIEW_PSGS,
    ID_FILE_QUICKLOAD,
    ID_FILE_QUICKSAVE,
    -1, // region
    ID_FILE_RESET,
    ID_FILE_RESETTOMONITOR,
    ID_FILE_REVERT,
    ID_DEBUG_RUNTODMA,
    ID_FILE_SAVESNP,
    ID_FILE_SAVEROM,
    ID_FILE_SAVETVC,
    ID_OPTIONS_SENSEGAME,
    ID_CONTROLLERS_SENSITIVITY,
    ID_FILE_SERVER,
    ID_DEBUG_CLEARBP,
    ID_DEBUG_CLEARWP,
    -1, // size
    ID_SOUND_ENABLED,
    ID_DEBUG_STEP,
    ID_GRAPHICS_STRETCH,
    ID_CONTROLLERS_SWAPPED,
    ID_VIEW_TITLE,
    ID_VIEW_TOOL,
    ID_LOG_TRACECPU,
    ID_MACHINE_USEHACKS,
    ID_SPEED_TURBO,
    ID_DEBUG_WATCHREADS,
    ID_DEBUG_CLI,
    ID_CONTROLLERS_REQUIREBUTTON,
    -1, // host gameport 2
    -1, // filter
    ID_VIEW_IMAGERY,
    ID_CONTROLLERS_ENABLE1ST,
    ID_LOG_MONITOR,
    ID_DEBUG_RUNTOINTERRUPT,
    ID_VIEW_BRAM,
    ID_LOG_SUBROUTINES,
    ID_GRAPHICS_DOTSPACE,
    ID_HELP_GAMINGGUIDE,
    ID_FILE_AUDIT,
    ID_VIEW_SIDEBAR,
    -1, // sort sidebar by
    ID_FILE_SAVEEAP,
    ID_GRAPHICS_GREYSCALE,
    ID_FILE_SAVEEAL,
    ID_DEBUG_RUNTOLOOPEND,
    ID_GRAPHICS_HIGHRES,
    ID_GRAPHICS_STARFIELD,
    ID_VIEW_SCREEN,
    ID_VIEW_UDCS,
    ID_VIEW_XVI,
    ID_DEBUG_RUNTORASTLINE,
    ID_DEBUG_RUNTORASTN,
    ID_DEBUG_RUNTOFRAME,
    ID_CONTROLLERS_REDEFINE,
    ID_GRAPHICS_FRAMESKIP,
    ID_SOUND_VOLUME,
    ID_CONTROLLERS_CONFINE,
    ID_LOG_VERBOSE,
    ID_LOG_ANSI,
    ID_SOUND_INTERNAL,
    ID_SPEED_AUTOPAUSE,
    ID_SOUND_SPEECH,
    ID_DEBUG_STEPOVER,
    ID_LOG_PRINTER,
    ID_DEBUG_USEGUIDEPIXEL,
    ID_DEBUG_RUNTOSUBEND,
    ID_GRAPHICS_UNDITHER,
    ID_MACRO_ANIMS,
    ID_GRAPHICS_RASTLINES,   // 100
    ID_HELP_GAMEINFO,
    ID_FILE_ICONIFY,
    ID_DEBUG_INTERRUPT,
    ID_GRAPHICS_CORNERS,
    ID_GRAPHICS_UNLIT,       // 105
    ID_SOUND_RETUNE,
    ID_EDIT_COPYTEXT,
    ID_MACHINE_LOWERCASE,
    ID_EDIT_PALETTE,
    ID_LOG_CONSOLE,          // 110
    ID_SPRITES_VISIBLE,
    ID_GRAPHICS_SHADOWS,
    ID_EDIT_DIPSWITCHES,
    ID_GRAPHICS_INVERSE,
    -1, // screen colour     // 115
    ID_GRAPHICS_SCALE2X,
    ID_EAP_SPRITES,
    ID_EAP_UDCS,
    ID_VIEW_HISCORES,
    ID_VIEW_NVRAM,           // 120
    -1, // language
    ID_HELP_CODINGGUIDE,
    ID_LOG_LOGTOFILE,
    ID_LOG_IOPORTS,
    ID_VIEW_MEMORY,          // 125
    -1, // priority
    ID_VIEW_COLOURRAM,
    ID_TOOLS_SPRMAKER,
    ID_TOOLS_TXTMAKER,
    ID_OPTIONS_CONFIRM,      // 130
    ID_INPUT_REARRANGE,
    ID_INPUT_CALIBRATE,
    ID_GRAPHICS_ROTATE,
    ID_DEBUG_IGNORE,
    ID_VIEW_PLAYFIELD,       // 135
    ID_LOG_PAUSE,
    ID_VIEW_ALLMEMORY,
    ID_FILE_EXIT,
    ID_FILE_UNICONIFY,
    ID_FILE_REGISTER,        // 140
    ID_VIEW_MRAM,
    ID_DEBUG_SETBP,
    ID_DEBUG_SETWP,
    ID_DEBUG_JUMP,
    ID_EDIT_COPY,            // 145
    ID_FILE_SAVEACBM,
    ID_FILE_SAVEBMP,
    ID_FILE_SAVEILBM,
    ID_FILE_SAVEPCX,
    ID_VIEW_CPU,             // 150
    ID_MACRO_STARTRECORDING,
    ID_MACRO_RESTARTPLAYBACK,
    ID_MACRO_STOP,
    ID_DEBUG_BREAKCONTINUE,
    -1, // run ARexx script  // 155
    -1, // crystal
    ID_TOOLS_SPRITEVIEWER
    -1, // CPU type
    -1  // mnemonic style    // 159
}, menucode2[MENUOPTS] =
{   ID_GRAPHICS_1XSIZE,
    ID_GRAPHICS_2XSIZE,
    ID_GRAPHICS_3XSIZE,
    ID_SPEED_SLOW,
    ID_SPEED_FAST,
    ID_MACHINE_ARCADIA,
    ID_MACHINE_INTERTON,
    ID_MACHINE_ELEKTOR,
    ID_MACHINE_PIPBUG,
    ID_MACHINE_INSTRUCTOR,
    ID_MACHINE_CD2650,       //  10
    ID_MACHINE_ASTROWARS,
    ID_MACHINE_GALAXIA,
    ID_MACHINE_M1,
    ID_MACHINE_M2,
    ID_MACHINE_CHAOS,
    ID_MACHINE_DOLPHIN,
    ID_MACRO_STARTRECORDING,
    ID_MACRO_RESTARTPLAYBACK,
    ID_MACRO_STOP,
    -1, // "Settings|Left controller >>"
    ID_LEFT_TRACKBALL,       //  21
    ID_LEFT_NONE,
    ID_LEFT_1STDJOY,
    ID_LEFT_2NDDJOY,
    ID_GRAPHICS_AMBER,
    -1, // 2nd left analog  joy
    -1, // 1st left digital pad
    -1, // 2nd left digital pad
    -1, // 1st left analog  pad
    -1, // 2nd left analog  pad
    -1, // "Settings|Right controller >>"
    ID_RIGHT_TRACKBALL,
    ID_RIGHT_NONE,           //  33
    ID_RIGHT_1STDJOY,
    ID_RIGHT_2NDDJOY,
    ID_GRAPHICS_GREEN,
    -1, // 2nd right analog  joy
    -1, // 1st right digital pad
    -1, // 2nd right digital pad
    -1, // 1st right analog  pad
    -1, // 2nd right analog  pad
    ID_SPEED_NTSC,
    ID_SPEED_PAL,
    ID_SORTBY_NAME,
    ID_SORTBY_MACHINE,       //  45
    ID_GRAPHICS_4XSIZE,
    ID_LANGUAGE_ENG,
    ID_LANGUAGE_HOL,         
    ID_LANGUAGE_FRA,
    ID_LANGUAGE_GER,
    ID_LANGUAGE_ITA,
    ID_LANGUAGE_RUS,
    ID_SPEED_HIGHPRI,
    ID_SPEED_NORMALPRI,
    ID_SPEED_LOWPRI,         // 55
    ID_LANGUAGE_SPA,
    ID_MACHINE_PHUNSY,
    ID_GRAPHICS_WHITE,
    ID_MACHINE_2650A,
    ID_MACHINE_2650B,        // 60
    ID_LOG_CALM,
    ID_LOG_SIGNETICS,        // 62
}, gadgetcode[] =
{   ID_GRAPHICS_FLAGLINE,    //  0
    ID_CONTROLLERS_AUTOFIRE, //  1
    ID_CONTROLLERS_SWAPPED,  //  2
    ID_SPEED_PAUSED,         //  3
    ID_SPEED_TURBO,          //  4
    ID_SPRITES_COLLISIONS,   //  5
    ID_SOUND_ENABLED,        //  6
    -1 // macro              //  7
};

#define SKYIMAGERY
// if you want moon/nebula/comet to be possible

#ifdef SKYIMAGERY
#define MOONFREQ         2
#define NEBULAFREQ       2
#define COMETFREQ        2
#define SMLMOONWIDTH    16
#define SMLMOONHEIGHT   16
#define SMLNEBULAWIDTH  16
#define SMLNEBULAHEIGHT 16
#define SMLCOMETWIDTH   32
#define SMLCOMETHEIGHT   7
#define BIGMOONWIDTH    32
#define BIGMOONHEIGHT   32
#define BIGNEBULAWIDTH  32
#define BIGNEBULAHEIGHT 32
#define BIGCOMETWIDTH   64
#define BIGCOMETHEIGHT  14
MODULE const ULONG bigmoonimagery[BIGMOONHEIGHT * BIGMOONWIDTH] = {
0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000,
0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000,
0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x020000, 0x140907, 0x382622, 0x5D4641,
0x674F49, 0x6F5752, 0x705B56, 0x5A4B47, 0x332725, 0x090606, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000,
0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x070000, 0x39201B, 0x553C35, 0x695149, 0x7B645D,
0x87706B, 0x735952, 0x775D55, 0x876F67, 0xA28E85, 0x9F8A81, 0x645551, 0x130E0D, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000,
0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x090000, 0x1E0604, 0x44261F, 0x62453B, 0x674C41, 0x6C5146,
0x523226, 0x553427, 0x66493E, 0x836760, 0x99827C, 0xA7928C, 0xAB968E, 0xA8948B, 0x524644, 0x020101, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000,
0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x020000, 0x080000, 0x230803, 0x311107, 0x472719, 0x6B4F42, 0x4D2D1D, 0x59392A,
0x573625, 0x512F20, 0x523121, 0x604032, 0x725549, 0x8F766E, 0x9B837D, 0xAC988F, 0xB3A19C, 0x887572, 0x0B0808, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000,
0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x170502, 0x391D11, 0x3A1B0C, 0x492B18, 0x593B26, 0x654934, 0x44220F, 0x472513,
0x51301D, 0x52301D, 0x53301E, 0x543221, 0x5B3929, 0x6E4E42, 0x7D6053, 0x866A5F, 0x968075, 0xAE9993, 0x968580, 0x0C090A, 0x000000, 0x000000, 0x000000, 0x000000,
0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x0D0100, 0x2A0D05, 0x3E1F0F, 0x4D321B, 0x4D2D15, 0x624429, 0x694C32, 0x4F2F17, 0x4F2D18,
0x512E19, 0x4D2914, 0x532E19, 0x5A3823, 0x664430, 0x62402A, 0x664431, 0x6D4C3A, 0x725241, 0x8B6E63, 0xAB968F, 0x8D7B78, 0x040202, 0x000000, 0x000000, 0x000000,
0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x020000, 0x1C0401, 0x3B1D0D, 0x3F200C, 0x4F3118, 0x5B3C1E, 0x6F4F32, 0x795E43, 0x61432B, 0x5F3F29,
0x4F2C16, 0x4E2B14, 0x583721, 0x62402C, 0x5A371F, 0x66432E, 0x70503C, 0x694632, 0x66432E, 0x6C4A36, 0x7F6151, 0xB39D96, 0x5A4C47, 0x000000, 0x000000, 0x000000,
0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x0F0100, 0x280C02, 0x3E2111, 0x492C17, 0x4C2B13, 0x5D3F21, 0x6F5133, 0x72593D, 0x80664D, 0x694C34,
0x57361D, 0x5A3A22, 0x5A3920, 0x58361D, 0x5B361D, 0x58321A, 0x593620, 0x5F3C26, 0x613F29, 0x6A4A34, 0x7C5D48, 0x8D6F61, 0xA3887F, 0x1F1816, 0x000000, 0x000000,
0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x010000, 0x1C0401, 0x36170B, 0x472A16, 0x4D2F1A, 0x4F321B, 0x5A3C1F, 0x72573A, 0x7A5D40, 0x74583C, 0x604125,
0x5B3C22, 0x624428, 0x72533C, 0x624028, 0x533018, 0x5D3A21, 0x613E25, 0x603D24, 0x66432B, 0x6A4930, 0x765640, 0x8A6C58, 0x977A6A, 0x836F68, 0x000000, 0x000000,
0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x080000, 0x301307, 0x422612, 0x4C2E1A, 0x523821, 0x543920, 0x5D3F25, 0x71563A, 0x7E6144, 0x775A3B, 0x705237,
0x68492D, 0x5E3E23, 0x674830, 0x68482F, 0x634227, 0x613F25, 0x67452C, 0x66432A, 0x69462B, 0x704E35, 0x795A41, 0x7F5F49, 0x83624C, 0xB19787, 0x1B1514, 0x000000,
0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x1A0400, 0x331506, 0x452915, 0x50341F, 0x5F412A, 0x5D3E23, 0x6D5137, 0x735739, 0x7F6547, 0x816549, 0x76593B,
0x75583C, 0x67482C, 0x654529, 0x644429, 0x6D4F34, 0x654529, 0x705036, 0x7B5C42, 0x7A5B40, 0x826449, 0x7C5D41, 0x86674D, 0x87664C, 0xA0846C, 0x5A4C46, 0x000000,
0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x250A03, 0x371A09, 0x4B2D1A, 0x50361F, 0x5C3E24, 0x5F3F22, 0x634529, 0x735639, 0x846A4F, 0x8F7355, 0x93775B,
0x7D6145, 0x725436, 0x6D4E30, 0x6C4C2F, 0x6B4C30, 0x715338, 0x856B51, 0x8F755A, 0x7E6045, 0x886A50, 0x816146, 0x917358, 0x94765B, 0x9C8065, 0x8C7865, 0x000000,
0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x2A1107, 0x361906, 0x482A14, 0x593C25, 0x61432A, 0x684D32, 0x62462E, 0x634628, 0x8A7157, 0x8A6F55, 0x8F7559,
0x8F755A, 0x836647, 0x795C3D, 0x795B3D, 0x82684B, 0x705235, 0x77593D, 0x806347, 0x876B51, 0x896F56, 0x93765B, 0xA28770, 0xB0957D, 0xAB9277, 0xBCA690, 0x020101,
0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x250D01, 0x40230C, 0x4B2F16, 0x6F543E, 0x5F4228, 0x65482E, 0x624429, 0x67492D, 0x73563B, 0x765A3C, 0x886B50,
0x91795E, 0x957A5E, 0x896E4F, 0x826953, 0x775B3F, 0x75583B, 0x7A5D40, 0x846648, 0x907557, 0xA69077, 0x9D8369, 0xA28770, 0xB69C85, 0xBFA68E, 0xC8B29A, 0x13100F,
0x000000, 0x000000, 0x000000, 0x000000, 0x060100, 0x270C07, 0x5E4633, 0x644B33, 0x6B5039, 0x5A3D23, 0x674B32, 0x63472B, 0x705339, 0x705339, 0x795C41, 0x7B5D41,
0x886B50, 0x94795E, 0x9E8468, 0x8C7356, 0x7A5D40, 0x8D7355, 0x866A4D, 0x7A5C3E, 0x8C7157, 0xAD9983, 0xA28A70, 0xB29980, 0xC0A88F, 0xD2BCA5, 0xD0BCA6, 0x221D1B,
0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x180501, 0x4C311E, 0x694E37, 0x695037, 0x674D33, 0x684D33, 0x6A4D35, 0x785D47, 0x72563D, 0x7A5E42, 0x76583B,
0x85684D, 0x93785D, 0x997F60, 0x988062, 0x84684A, 0x9F886B, 0xBAA68B, 0x9B8466, 0xA99278, 0xB8A388, 0xBFAA8E, 0xC4AE92, 0xC4AD92, 0xD3BFA7, 0xD3BFA8, 0x25201B,
0x000000, 0x000000, 0x000000, 0x000000, 0x010000, 0x1C0702, 0x452914, 0x664B37, 0x674D35, 0x735C44, 0x7A614A, 0x785E47, 0x7A614A, 0x7B614A, 0x74583B, 0x74573A,
0x745438, 0x86694D, 0x8E7254, 0x917A5C, 0x836749, 0x9B8367, 0xA88F71, 0xB0987C, 0xB09879, 0xBBA789, 0xC5B195, 0xC3AD91, 0xC2AB91, 0xC5B196, 0xD5BFAB, 0x181012,
0x000000, 0x000000, 0x000000, 0x000000, 0x010000, 0x2A0F03, 0x4A311D, 0x593E27, 0x664E37, 0x7A634E, 0x7E6651, 0x806954, 0x7E6952, 0x7B614B, 0x6B4F34, 0x715438,
0x6D4D2F, 0x755538, 0x8C6F55, 0x896F51, 0x967B5C, 0x9F886D, 0x9F876C, 0xAB9476, 0xB29B80, 0xB39E7F, 0xC4B095, 0xC0AC91, 0xC3AC92, 0xC3AC8F, 0xC9B49F, 0x040202,
0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x150502, 0x3F2415, 0x523928, 0x68513C, 0x7D6755, 0x7A634F, 0x877361, 0x8D7767, 0x79604A, 0x7B6049, 0x7B5D45,
0x7C5E45, 0x77573C, 0x8E755C, 0x937A61, 0x957B61, 0x9B8268, 0x9F866C, 0xB8A38B, 0xC3AF94, 0xAE9577, 0xC7B499, 0xC2AE92, 0xBAA387, 0xC7B299, 0xA0907E, 0x000000,
0x000000, 0x000000, 0x000000, 0x000000, 0x030100, 0x180503, 0x3C2014, 0x4D3326, 0x654E3D, 0x786253, 0x87715F, 0x9A8577, 0xA29183, 0x8B7462, 0x8C715D, 0x836751,
0x856750, 0x8C6F58, 0x8A705B, 0x8F735F, 0xA68E78, 0x9F8770, 0xA9937B, 0xB19B84, 0xBAA48A, 0xB1997B, 0xCCB8A0, 0xC4B096, 0xBCA88F, 0xD1BEA7, 0x6C6158, 0x000000,
0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x0D0000, 0x2E1408, 0x492E22, 0x6D564A, 0x856F66, 0x9E8B7F, 0xB3A298, 0xC8B8AF, 0xAD9C8D, 0x937C6B, 0x907766,
0x947967, 0x947868, 0x896C5A, 0x8E745F, 0x99816C, 0xBCA896, 0xB19C86, 0xA38C75, 0xB19A7F, 0xB0997C, 0xBEA98F, 0xC8B69F, 0xC2B09A, 0xCDBBA9, 0x231D1B, 0x000000,
0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x0C0000, 0x371F17, 0x452D23, 0x6C564C, 0x8D7870, 0xB3A49D, 0xB7A7A1, 0xCBBDB7, 0xC7B7AE, 0xA99489, 0x9C8679,
0xAD978C, 0xAB9687, 0x9D8476, 0xA38C7D, 0x9F8576, 0xB6A595, 0xB49F8A, 0xBBA793, 0xB09D87, 0xB39F87, 0xBBA48D, 0xBFAB93, 0xC8B6A3, 0x98887E, 0x000000, 0x000000,
0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x050001, 0x351C1A, 0x553D38, 0x766158, 0x998882, 0xB7A8A7, 0xAFA19A, 0xAD9C93, 0x998577, 0x937C6D, 0x917968,
0x9B8576, 0xA49182, 0x9D887A, 0xAD998B, 0xB3A091, 0xBAA797, 0xB4A391, 0xBBA995, 0xC7B5A4, 0xCCBAAA, 0xC0AE98, 0xC3B19D, 0xD3C0B1, 0x2E2826, 0x000000, 0x000000,
0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x1F0D0D, 0x48322B, 0x69544B, 0x86726B, 0xAD9E99, 0xBBACAA, 0xAD9D94, 0xC2B5AD, 0x927C6C, 0x9E8876,
0x9C8673, 0x9F8B7C, 0xA28C7E, 0xC1ADA2, 0xCEBDB0, 0xC1AF9F, 0xBEAB9A, 0xC4B2A1, 0xE5D6C9, 0xDBC9BA, 0xD7C3B4, 0xCCBAAA, 0x776A63, 0x000000, 0x000000, 0x000000,
0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x040000, 0x3E2823, 0x66534A, 0x816E65, 0x9A8882, 0xAFA09A, 0xB8AAA3, 0x877162, 0x7C6252, 0x9D8679,
0xA99483, 0xB39F92, 0xB49F92, 0xC6B3A8, 0xDBCCC1, 0xB39F8E, 0xBDA994, 0xCEBAAB, 0xD4C0B2, 0xD0BFB0, 0xD8C6BA, 0xA6978E, 0x080606, 0x000000, 0x000000, 0x000000,
0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x0D0505, 0x4B332F, 0x715B53, 0x8C7970, 0xA0908B, 0xB0A199, 0xAD9C90, 0xB5A498, 0xAA9789,
0xAE9A8E, 0xB19E91, 0xC7B5AB, 0xBDAB9E, 0xBCA89A, 0xB6A494, 0xC0AE9E, 0xC7B3A2, 0xD2BEB0, 0xD9C8BB, 0xBAA79E, 0x161211, 0x000000, 0x000000, 0x000000, 0x000000,
0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x261313, 0x412821, 0x745E57, 0x857267, 0x715A4E, 0x846D60, 0x988477, 0x9C897C,
0xA49183, 0xAA9689, 0xB3A093, 0xBEAB9F, 0xC7B5A8, 0xC1AEA2, 0xC8B7A9, 0xCCB7AB, 0xD2C0B5, 0xB1A09C, 0x161112, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000,
0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x170A09, 0x493028, 0x766059, 0x7A655A, 0x8B7771, 0x98867C, 0xAD9A92,
0xB8A79E, 0xBDAAA0, 0xBDAA9F, 0xC1AEA3, 0xCFBEB6, 0xCEBDB4, 0xCEBCB3, 0xD6C7BF, 0x786A67, 0x070505, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000,
0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x0F0504, 0x574242, 0x74615B, 0x847069, 0x907C74, 0xA6938C,
0xAA988E, 0xAD9B93, 0xAD9B90, 0xBDABA2, 0xC5B3AC, 0xC8B6B1, 0x8F817E, 0x251F1E, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000,
0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x030101, 0x251A1B, 0x534140, 0x7B6762, 0x8E7A73,
0x968179, 0xA4918D, 0x9E8C87, 0x80706C, 0x4B3F3D, 0x130F10, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000,
0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x050202,
0x070405, 0x030101, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000
}, smlmoonimagery[SMLMOONHEIGHT * SMLMOONWIDTH] = {
0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x050202, 0x251B19, 0x352927, 0x322927, 0x0F0B0A, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000,
0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x0B0101, 0x4D322A, 0x6E544B, 0x684C42, 0x7A5F57, 0xA08B84, 0x73635E, 0x151211, 0x000000, 0x000000, 0x000000,
0x000000, 0x000000, 0x000000, 0x000000, 0x170805, 0x36180B, 0x5C3F2D, 0x4C2B1A, 0x533120, 0x563524, 0x735548, 0x92796F, 0xA08C85, 0x2B2524, 0x000000, 0x000000,
0x000000, 0x000000, 0x000000, 0x0B0100, 0x381A0B, 0x513319, 0x6D4F34, 0x583721, 0x4F2C16, 0x5A3722, 0x623F2A, 0x6B4A36, 0x745342, 0x9A847C, 0x171312, 0x000000,
0x000000, 0x000000, 0x000000, 0x220A03, 0x472A16, 0x54361B, 0x73583A, 0x6F5339, 0x5C3C22, 0x624128, 0x59351C, 0x5E3B24, 0x67452E, 0x826450, 0x77625A, 0x000000,
0x000000, 0x000000, 0x080100, 0x3B1E0D, 0x533721, 0x5F4228, 0x785D3F, 0x775B3E, 0x694A2E, 0x66462C, 0x65452A, 0x6E4D34, 0x75553A, 0x7F5F46, 0x977963, 0x1D1816,
0x000000, 0x000000, 0x140702, 0x40230F, 0x5A3D25, 0x63462B, 0x795E42, 0x8F7357, 0x806447, 0x725436, 0x74563A, 0x83674C, 0x86694F, 0x92745B, 0xA3876D, 0x52483D,
0x000000, 0x000000, 0x150602, 0x533922, 0x654930, 0x64472D, 0x6E5137, 0x7C6044, 0x90765B, 0x8D7458, 0x7D6144, 0x7F6245, 0x9C846A, 0xA48B72, 0xC1A991, 0x73675A,
0x000000, 0x000000, 0x0D0301, 0x583D28, 0x6A5239, 0x71563F, 0x785D46, 0x76593C, 0x84674C, 0x947B5C, 0x907659, 0xAB9477, 0xB39D81, 0xC3AE92, 0xC8B298, 0x796C60,
0x000000, 0x000000, 0x100501, 0x4D3320, 0x715A46, 0x806955, 0x806853, 0x75583E, 0x75563A, 0x8D7359, 0x998065, 0xA89176, 0xB69F82, 0xC3AF94, 0xC2AB90, 0x5B5148,
0x000000, 0x000000, 0x0A0101, 0x402519, 0x745D50, 0x9D897B, 0xA99688, 0x8C7360, 0x8E725E, 0x8C715D, 0xA68F7A, 0xAB967E, 0xB39C80, 0xC6B299, 0xC7B49E, 0x241F1D,
0x000000, 0x000000, 0x040000, 0x422923, 0x826E65, 0xB4A5A0, 0xB6A59C, 0x9A8476, 0xA59183, 0xA38C7E, 0xB19C8D, 0xB7A591, 0xBEAB97, 0xBFAB95, 0x988A7E, 0x000000,
0x000000, 0x000000, 0x000000, 0x2A1917, 0x766259, 0xAC9D98, 0xAC9B92, 0x927B6B, 0xA69181, 0xB7A396, 0xC7B6A8, 0xC3B09E, 0xD9C7B9, 0xC8B7A9, 0x1F1C1A, 0x000000,
0x000000, 0x000000, 0x000000, 0x030101, 0x49322E, 0x8A766E, 0x948176, 0xA59285, 0xAB978B, 0xBDAB9F, 0xBFAC9E, 0xC7B4A5, 0xCBB9AF, 0x393330, 0x000000, 0x000000,
0x000000, 0x000000, 0x000000, 0x000000, 0x060202, 0x493632, 0x7F6B64, 0x9F8C84, 0xB3A198, 0xBAA89D, 0xCBB9B2, 0x968984, 0x1F1B1B, 0x000000, 0x000000, 0x000000,
0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x1E1617, 0x433836, 0x514643, 0x473F3D, 0x171313, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000
}, bignebulaimagery[BIGNEBULAHEIGHT * BIGNEBULAWIDTH] = {
0x0E010D, 0x0E0114, 0x0E0112, 0x0E010F, 0x0B0111, 0x0B0115, 0x0C0118, 0x0D0116, 0x0D011A, 0x0B011B, 0x0C011D, 0x0C0119, 0x0A0118, 0x0D011E, 0x0C0125, 0x10011F,
0x0F0128, 0x10011E, 0x13011A, 0x130119, 0x14011C, 0x12011E, 0x120116, 0x0F0117, 0x0E0115, 0x0E0117, 0x0E0118, 0x0C0110, 0x0D0115, 0x0A0115, 0x0B010C, 0x0B0112,
0x0F0115, 0x120117, 0x0D0114, 0x0C0112, 0x0B0117, 0x0B0115, 0x0C0117, 0x0E0118, 0x0D0120, 0x0C011D, 0x0F011C, 0x0D011B, 0x0E0118, 0x0C0124, 0x0F0128, 0x120122,
0x12012A, 0x130122, 0x14011E, 0x140124, 0x16011C, 0x14011D, 0x120115, 0x0F0110, 0x0E0114, 0x0E0112, 0x0E0114, 0x100115, 0x140329, 0x0D010F, 0x0C010E, 0x0C010B,
0x120123, 0x0C011A, 0x110117, 0x0D0117, 0x0D0117, 0x100117, 0x0F0118, 0x0F011D, 0x0E011A, 0x0E0120, 0x0F0125, 0x100124, 0x130120, 0x12012B, 0x12012E, 0x15012C,
0x14012F, 0x16012B, 0x1B012A, 0x150129, 0x170120, 0x14011F, 0x130117, 0x110114, 0x110117, 0x0F0117, 0x0E0114, 0x0D0116, 0x0F0116, 0x0C0110, 0x0C010A, 0x0C010C,
0x11011F, 0x10011A, 0x10011B, 0x0D0116, 0x0F0115, 0x0F0116, 0x110117, 0x11011D, 0x120121, 0x130126, 0x110124, 0x130127, 0x15012F, 0x170131, 0x19013D, 0x1D013A,
0x1B0142, 0x1F013B, 0x210137, 0x1F0136, 0x1B0129, 0x180120, 0x15011F, 0x12011B, 0x110117, 0x0F010F, 0x100117, 0x0D0115, 0x0E0114, 0x0F010D, 0x0B010C, 0x0D0115,
0x100112, 0x100116, 0x110118, 0x10011C, 0x10011F, 0x12011D, 0x110118, 0x130125, 0x13012E, 0x170135, 0x190137, 0x1C013C, 0x1E014D, 0x220152, 0x23015D, 0x26015A,
0x27015E, 0x280161, 0x29025B, 0x26014C, 0x22013D, 0x1D012C, 0x190120, 0x160125, 0x13011D, 0x110115, 0x0E0114, 0x0F010F, 0x0C0114, 0x0D0110, 0x0C0110, 0x0B0111,
0x0D0117, 0x10011D, 0x120121, 0x10011B, 0x14011E, 0x140123, 0x17012D, 0x160139, 0x1C0146, 0x200143, 0x25014E, 0x290154, 0x2D025F, 0x2F0362, 0x320467, 0x330568,
0x330568, 0x330667, 0x320468, 0x300361, 0x2B015A, 0x240157, 0x20013F, 0x1E012C, 0x16011F, 0x150117, 0x110114, 0x100112, 0x100112, 0x0D0110, 0x0D0110, 0x0D010E,
0x100119, 0x12011B, 0x14011C, 0x14011F, 0x150122, 0x18012C, 0x1B0134, 0x1C0141, 0x22014A, 0x28014E, 0x2E0354, 0x34075A, 0x380B63, 0x3E1169, 0x41146F, 0x401371,
0x3F1174, 0x3F126D, 0x3C0E6D, 0x390A6C, 0x330566, 0x300371, 0x290170, 0x220149, 0x1E012C, 0x1A0121, 0x160118, 0x120112, 0x100112, 0x120114, 0x0F010F, 0x0D010D,
0x110113, 0x140118, 0x14011A, 0x15011E, 0x190125, 0x1D0122, 0x200133, 0x26014A, 0x2D0352, 0x380B5B, 0x411565, 0x481E70, 0x4B2376, 0x4F2879, 0x522D82, 0x502984,
0x4E2686, 0x4B2384, 0x491F7F, 0x44187B, 0x401375, 0x3C0E73, 0x340578, 0x2C0267, 0x280142, 0x200129, 0x1A0120, 0x17011D, 0x17011B, 0x120117, 0x110111, 0x0D010D,
0x13011E, 0x130120, 0x150121, 0x18011F, 0x1D012C, 0x220133, 0x27013E, 0x310553, 0x3F1365, 0x4D2577, 0x573382, 0x603E8C, 0x64438F, 0x674693, 0x6C4D9B, 0x6E4FA1,
0x6B4BA5, 0x6746A2, 0x613E99, 0x57328E, 0x4E2786, 0x471D7C, 0x3D0E79, 0x360773, 0x2E0255, 0x260134, 0x220129, 0x1F0121, 0x1A0117, 0x160117, 0x140110, 0x10010E,
0x15011E, 0x160125, 0x19012D, 0x1F0139, 0x240142, 0x2B024E, 0x330756, 0x42166E, 0x522B80, 0x5F3D90, 0x6D4D9B, 0x7659A4, 0x7E61AB, 0x866BB1, 0x947ABA, 0x9880BF,
0x977FC0, 0x937ABE, 0x8B70B7, 0x7B5EAC, 0x68489C, 0x532E8B, 0x461B7E, 0x3C0E79, 0x350662, 0x2D0341, 0x290127, 0x22012A, 0x230124, 0x1A011A, 0x160115, 0x110111,
0x170130, 0x19012D, 0x1D0148, 0x250166, 0x2E0369, 0x360866, 0x421670, 0x502983, 0x5F3D93, 0x6F4FA2, 0x7E61AE, 0x8F75B9, 0x9D85C3, 0xAC97CB, 0xB9A6D1, 0xBFADD6,
0xBAA8D5, 0xB6A2D4, 0xAD98D0, 0xA08AC7, 0x8B70B8, 0x6D4D9F, 0x532D8B, 0x461B7D, 0x3E106A, 0x360844, 0x2D022D, 0x2C0231, 0x2C012D, 0x220120, 0x170113, 0x130113,
0x1A0149, 0x1D014D, 0x25016A, 0x2D0389, 0x370877, 0x42166F, 0x512B83, 0x613F95, 0x7153A3, 0x8165B1, 0x9A82C1, 0xB29ECE, 0xBEADD6, 0xC6B6DB, 0xC8B8DD, 0xC3B2DB,
0xB9A6D8, 0xB09BD2, 0xAF9AD2, 0xAE99D2, 0xA48DC9, 0x886DB5, 0x67469B, 0x512B87, 0x451A6C, 0x3A0D4B, 0x350739, 0x340630, 0x300430, 0x25011E, 0x1B0116, 0x160114,
0x1B0158, 0x21015E, 0x280173, 0x33058C, 0x3E128D, 0x4E2883, 0x634293, 0x7456A5, 0x896DB6, 0x9E87C4, 0xB29ED0, 0xC2B1D9, 0xC3B2D9, 0xC1AFD9, 0xB9A6D6, 0xB09CD0,
0xA791CC, 0xA08BC8, 0xA28CC7, 0xAB96CE, 0xB09CD2, 0x9E87C3, 0x7C60AB, 0x644394, 0x512A78, 0x421755, 0x3C0F42, 0x3A0B3C, 0x31042E, 0x25011E, 0x1E0112, 0x190115,
0x1E0157, 0x25016B, 0x2D027E, 0x380B93, 0x451B9A, 0x563194, 0x6E4EA0, 0x8266B2, 0x9D86C5, 0xB6A3D4, 0xB5A1D4, 0xB8A5D6, 0xAD99CE, 0xA791CB, 0xA089C8, 0x9B82C2,
0x977EBF, 0x9981C1, 0x9E86C4, 0xA18AC5, 0xAF9ACF, 0xA48EC8, 0x8E74B7, 0x72539F, 0x563282, 0x451A60, 0x3D114A, 0x390B3F, 0x32042C, 0x270125, 0x200115, 0x170118,
0x1D0157, 0x270168, 0x300486, 0x3C1098, 0x4B2399, 0x5F3B9D, 0x7557AA, 0x9075BC, 0xAD97D0, 0xB6A2D6, 0xAB96D0, 0xA28CC9, 0x9B82C2, 0x9B83C4, 0x9A83CA, 0x9B83CA,
0x977EC3, 0x957CBF, 0x987FC0, 0x9D85C3, 0xA893CB, 0xA58FC9, 0x9980C0, 0x7E61A9, 0x5D3B88, 0x4A2167, 0x40134F, 0x370940, 0x300430, 0x270125, 0x1C011D, 0x150119,
0x1F015F, 0x280168, 0x340684, 0x401599, 0x502AA0, 0x6543A4, 0x7E61B2, 0x9C84C4, 0xB5A0D6, 0xAF9AD3, 0xA48ECB, 0x987FC1, 0x987FC1, 0x9B83CB, 0xA993DD, 0xB4A0E4,
0x9E87D4, 0x957DC5, 0x937ABE, 0x9C84C4, 0xA590CA, 0xA691CA, 0x9C84C2, 0x8468AD, 0x664590, 0x4E266C, 0x3C0F4D, 0x33053F, 0x300333, 0x28012A, 0x1E0127, 0x19011E,
0x1E0163, 0x2A0272, 0x350786, 0x42179C, 0x522CA8, 0x6746AA, 0x8165B4, 0xA28BC8, 0xB9A5D7, 0xAD98D2, 0x9C84C6, 0x9980C6, 0x9981CB, 0xA28BD6, 0xC1B0EB, 0xE2DAF7,
0xA993DD, 0x957DC7, 0x977EC1, 0x9C83C3, 0xA48EC7, 0xA590C9, 0x9C85C3, 0x876CB1, 0x6C4C96, 0x4B226C, 0x380A4A, 0x2C0237, 0x280138, 0x20013D, 0x1C0137, 0x17012D,
0x1E0169, 0x290179, 0x340686, 0x4217A1, 0x522BAD, 0x6645AA, 0x8064B3, 0xA18AC6, 0xBAA6D6, 0xAF9AD1, 0x9D87C8, 0x9880C9, 0x967ECD, 0x977ED1, 0xA892DD, 0xB5A2E4,
0x9D85D3, 0x947AC3, 0x9B83C2, 0xA38DC6, 0xA690C9, 0x9F87C6, 0x9A81C3, 0x8B70B9, 0x684897, 0x481F6E, 0x360756, 0x270152, 0x230156, 0x1E0156, 0x1A0149, 0x160134,
0x1D0166, 0x260178, 0x33068D, 0x3F13A6, 0x4F28A5, 0x6341A2, 0x7C5FAE, 0x9C84C0, 0xB6A3D1, 0xB4A0D3, 0xA28DCA, 0x9A81C5, 0x957DC5, 0x9076C4, 0x947BC9, 0x9981CD,
0x957DC7, 0x977EC4, 0xA08AC8, 0xA893CD, 0xAB95CF, 0x9E86C6, 0x977EC2, 0x8266B2, 0x5E3C90, 0x461C6C, 0x340659, 0x250157, 0x20014E, 0x1A014F, 0x17014E, 0x150144,
0x1B0159, 0x230171, 0x310491, 0x3E11A6, 0x4A229C, 0x5D3A9A, 0x7557A7, 0x937AB8, 0xAE99C9, 0xB8A4D4, 0xAB97CF, 0xA18AC7, 0x9B83C3, 0x977EC2, 0x967CC2, 0x9880C4,
0x9D86C7, 0xA691CD, 0xAF9AD1, 0xB39FD3, 0xAC97D1, 0x9D86C7, 0x8D73BB, 0x7153A3, 0x542E87, 0x42176B, 0x35065C, 0x270156, 0x210147, 0x1B013D, 0x190145, 0x160149,
0x190148, 0x200169, 0x2A0286, 0x36089C, 0x441A99, 0x553096, 0x6B4A9D, 0x8469AE, 0xA38DC2, 0xB6A3D2, 0xB39FD2, 0xA994CD, 0xA38CC7, 0xA58FC8, 0xA590C9, 0xAB97CD,
0xB4A0D2, 0xBAA7D7, 0xB9A6D5, 0xB29ED1, 0xA28BC7, 0x9177BB, 0x7C5FAA, 0x603E90, 0x4A217C, 0x3D0F6C, 0x2F0258, 0x240152, 0x210147, 0x1B0141, 0x17013F, 0x170145,
0x16013E, 0x1C015B, 0x240178, 0x2E0387, 0x3B0F8F, 0x4B2490, 0x5E3B94, 0x7455A3, 0x8E74B4, 0xAA95C9, 0xB6A2D1, 0xB4A0D2, 0xB09BD0, 0xB3A0D0, 0xB8A5D3, 0xBEACD8,
0xC0AFD9, 0xBDAAD8, 0xB39FD2, 0xA48EC8, 0x967DBB, 0x8166AB, 0x674695, 0x50297D, 0x421574, 0x380A6D, 0x290156, 0x20014C, 0x1C0149, 0x190148, 0x16013C, 0x160141,
0x14012F, 0x190152, 0x1F0170, 0x290184, 0x330588, 0x3F1385, 0x4F298C, 0x613F95, 0x7759A3, 0x9379B9, 0xA892C8, 0xB39FD2, 0xB4A0D2, 0xB7A4D3, 0xBCA9D6, 0xBAA7D6,
0xB4A0D1, 0xA993CC, 0xA089C4, 0x9076B7, 0x8063A8, 0x6A4A95, 0x573383, 0x471D70, 0x3B0D62, 0x310455, 0x250140, 0x1E014E, 0x19014F, 0x190140, 0x150130, 0x140137,
0x140128, 0x150144, 0x1C0172, 0x25018D, 0x2A0285, 0x350777, 0x42157D, 0x4F2986, 0x614092, 0x7456A3, 0x896FB4, 0x9981C0, 0xA28CC7, 0xA58EC7, 0xA28BC5, 0x9B84C2,
0x947BBD, 0x896EB5, 0x8063AE, 0x7354A0, 0x664692, 0x56317E, 0x4A216E, 0x40135C, 0x36084C, 0x2B023B, 0x220130, 0x1E0141, 0x1A014C, 0x18013E, 0x16012C, 0x110125,
0x110122, 0x120138, 0x180160, 0x1F0180, 0x24017D, 0x2C0272, 0x360772, 0x41157C, 0x4C247F, 0x583489, 0x664599, 0x7254A4, 0x7B5EAA, 0x7D60AA, 0x7A5DA8, 0x7658A5,
0x6E4F9E, 0x674695, 0x5E3C8D, 0x583481, 0x522C76, 0x4B216B, 0x441860, 0x3F1353, 0x370947, 0x2B0233, 0x220132, 0x1B0140, 0x17013D, 0x12012A, 0x120125, 0x110124,
0x110121, 0x130128, 0x11013E, 0x1A0168, 0x200175, 0x26016F, 0x2C026C, 0x340672, 0x3A0B75, 0x411575, 0x49207E, 0x522D84, 0x5A3588, 0x5C3988, 0x5A3787, 0x553082,
0x502A79, 0x4D2572, 0x481F6A, 0x431862, 0x401459, 0x3E1156, 0x3B0E50, 0x380A45, 0x31043A, 0x29012F, 0x1F0138, 0x190146, 0x150129, 0x11011F, 0x0F011D, 0x0F011B,
0x100120, 0x110123, 0x130125, 0x150140, 0x19015E, 0x1F016A, 0x250164, 0x29016A, 0x2E026C, 0x30036A, 0x36086A, 0x3B0D6C, 0x42166A, 0x44196E, 0x431872, 0x41146F,
0x3D1063, 0x3E125B, 0x3A0D52, 0x34064C, 0x330648, 0x330549, 0x2E0238, 0x2B0236, 0x250134, 0x200144, 0x1A0142, 0x14012C, 0x110117, 0x0F010E, 0x0D0114, 0x0D0110,
0x100114, 0x10011C, 0x11011F, 0x110126, 0x140137, 0x17015A, 0x1D015C, 0x21015B, 0x25015D, 0x270161, 0x2A015C, 0x300361, 0x350663, 0x320562, 0x330661, 0x310466,
0x2F0354, 0x32054A, 0x2D0344, 0x280146, 0x260148, 0x26013B, 0x240131, 0x1E0132, 0x1C0139, 0x18013D, 0x15012F, 0x140116, 0x0F0110, 0x0E010D, 0x0B010A, 0x0C010F,
0x100216, 0x11021A, 0x0F0218, 0x14011E, 0x120223, 0x120232, 0x170148, 0x1A0152, 0x1C0149, 0x210151, 0x21014F, 0x270155, 0x2A014C, 0x25014D, 0x280141, 0x250149,
0x230139, 0x23012F, 0x20012E, 0x1E0142, 0x1E0151, 0x1F004E, 0x1B014D, 0x180144, 0x140134, 0x12012D, 0x110114, 0x0F010F, 0x0E0109, 0x0D0108, 0x0B0108, 0x0B010A,
0x0B0115, 0x0E0218, 0x0F0122, 0x0F0120, 0x12021E, 0x10011C, 0x100221, 0x11012F, 0x12022F, 0x160139, 0x1A0136, 0x1F013F, 0x1F0139, 0x1C0135, 0x1E0126, 0x1D0133,
0x1B0124, 0x1A011D, 0x18011A, 0x1A012D, 0x180134, 0x190134, 0x14012F, 0x150123, 0x11011D, 0x120119, 0x0E0111, 0x0E010D, 0x0E010C, 0x0C0108, 0x0A0108, 0x0B0108,
0x0C0110, 0x0B0118, 0x0A0116, 0x0A0119, 0x0C0116, 0x0B0120, 0x0B011B, 0x0B011D, 0x0C011D, 0x0B0124, 0x0E0123, 0x110122, 0x100120, 0x100125, 0x160125, 0x170120,
0x19011A, 0x180116, 0x160115, 0x15011B, 0x13011B, 0x150117, 0x130115, 0x10010E, 0x10010E, 0x0E010E, 0x0B010E, 0x0B010C, 0x0C0109, 0x0A0105, 0x0A0106, 0x0B0107,
0x0A0111, 0x09010E, 0x0A0110, 0x0A0110, 0x0A0112, 0x090110, 0x0B0112, 0x0C0110, 0x0C010F, 0x0C0111, 0x0B0111, 0x0D0112, 0x0C0118, 0x0C011D, 0x0C011C, 0x0E0118,
0x110115, 0x140115, 0x120114, 0x12011A, 0x120117, 0x110112, 0x100118, 0x0E0110, 0x0E010F, 0x0F0110, 0x0D010E, 0x0A010C, 0x0A0108, 0x0B0108, 0x090106, 0x0A0106
}, smlnebulaimagery[SMLNEBULAHEIGHT * SMLNEBULAWIDTH] = {
0x0F0113, 0x0D0112, 0x0B0114, 0x0D0117, 0x0C011C, 0x0D011B, 0x0C011D, 0x0F0123, 0x110125, 0x13011D, 0x14011D, 0x110115, 0x0E0114, 0x0E0114, 0x0E0219, 0x0C010E,
0x10011D, 0x0F0118, 0x0F0116, 0x10011A, 0x100120, 0x110125, 0x14012A, 0x170134, 0x190136, 0x1C0130, 0x170122, 0x130119, 0x100115, 0x0E0115, 0x0E0112, 0x0C010E,
0x0F0117, 0x11011C, 0x12011F, 0x140129, 0x1A013B, 0x200145, 0x270258, 0x2C0361, 0x2D0364, 0x2C025C, 0x230147, 0x1B012C, 0x14011A, 0x100112, 0x0E0111, 0x0C0110,
0x120118, 0x14011D, 0x190125, 0x1F013D, 0x2C0451, 0x3B0F61, 0x441A6F, 0x491F7A, 0x461B7B, 0x401475, 0x380A70, 0x2B0266, 0x20012E, 0x16011A, 0x130116, 0x0E010F,
0x140120, 0x190129, 0x24013C, 0x330955, 0x4F287B, 0x664693, 0x7455A0, 0x8265AD, 0x7F62B1, 0x6F50A3, 0x542E8B, 0x3D0F79, 0x2E034B, 0x230127, 0x1B011B, 0x130111,
0x1A013D, 0x250168, 0x370A6D, 0x512A83, 0x7051A2, 0x967EBD, 0xB3A0CF, 0xC1B0D8, 0xB6A3D5, 0xAB95CF, 0x896EB5, 0x542E8B, 0x3D0F59, 0x310432, 0x290227, 0x170114,
0x20015E, 0x300584, 0x4A228F, 0x7253A2, 0x9E87C5, 0xB8A5D5, 0xB6A3D3, 0xA993CC, 0x9E87C5, 0xA38CC8, 0xA893CB, 0x785AA5, 0x4B236C, 0x3B0D42, 0x2C0227, 0x1B0115,
0x230162, 0x380C8F, 0x58339F, 0x886DB7, 0xB29DD4, 0xA28CC9, 0x9A82C5, 0xA48ED5, 0x987FC7, 0x9981C1, 0xA691CA, 0x8E73B6, 0x57327B, 0x3A0C47, 0x2C022D, 0x1A011F,
0x24016E, 0x3B0F92, 0x5C38AA, 0x9177BD, 0xB49FD4, 0x9B83C7, 0x9A82D0, 0xC0AFE9, 0x9C84CE, 0x9C84C3, 0xA38DC8, 0x9278BC, 0x5A3582, 0x30054A, 0x220148, 0x190138,
0x20016A, 0x380C9A, 0x5631A0, 0x886DB3, 0xB4A0D0, 0xA28CC9, 0x967DC3, 0x977EC7, 0x9C84C8, 0xAA95CE, 0xA58ECB, 0x866AB4, 0x4F277B, 0x2D0359, 0x1E0148, 0x170148,
0x1B0152, 0x2D0488, 0x481F94, 0x7051A0, 0xA58EC4, 0xB29ED1, 0xAB96CC, 0xB29ED0, 0xBBA8D6, 0xB19CD0, 0x9379BA, 0x654393, 0x401472, 0x270153, 0x1C0146, 0x160140,
0x16013B, 0x22017D, 0x340882, 0x502A89, 0x785AA4, 0x9F88C3, 0xAD98CD, 0xAD98CD, 0x9E87C4, 0x896EB3, 0x6A4993, 0x4A216F, 0x330750, 0x210140, 0x190146, 0x14012E,
0x120129, 0x180162, 0x250175, 0x360973, 0x481E7D, 0x5D3990, 0x6C4B99, 0x684795, 0x5D3988, 0x512A76, 0x471D64, 0x3D1152, 0x2F0439, 0x1D013C, 0x13012C, 0x100120,
0x10011D, 0x12012B, 0x190156, 0x230161, 0x2A0265, 0x330665, 0x3B0F67, 0x3A0D6A, 0x370B57, 0x31064A, 0x2C0345, 0x270134, 0x1E013C, 0x16012D, 0x0F0110, 0x0D010F,
0x0F0217, 0x10011E, 0x120224, 0x14013B, 0x190140, 0x200146, 0x230142, 0x220139, 0x1F012A, 0x1C012E, 0x1C0142, 0x170139, 0x120126, 0x0F0110, 0x0D0109, 0x0B0109,
0x0B0112, 0x0A0113, 0x0B0116, 0x0B0117, 0x0B0118, 0x0E011A, 0x0E011F, 0x12011E, 0x150116, 0x140117, 0x130117, 0x100113, 0x0F010F, 0x0B010D, 0x0B0108, 0x0A0106
}, bigcometimagery[BIGCOMETHEIGHT * BIGCOMETWIDTH] = {
0x0F1313, 0x0F1313, 0x0F1313, 0x0F1213, 0x101214, 0x111214, 0x111214, 0x101214, 0x0F1214, 0x101214, 0x0F1214, 0x0F1314, 0x0F1314, 0x101415, 0x101315, 0x111315,
0x101314, 0x111313, 0x101314, 0x101415, 0x101415, 0x101415, 0x101415, 0x101415, 0x111516, 0x111516, 0x111517, 0x171D20, 0x1D2B31, 0x203B47, 0x10151A, 0x101517,
0x101518, 0x2C3032, 0x262928, 0x0F161B, 0x0F151D, 0x0F161C, 0x0E161D, 0x0D1620, 0x0E161F, 0x0D1725, 0x0D192A, 0x0B1C32, 0x0D1721, 0x0C1722, 0x0E1620, 0x0F151E,
0x10161B, 0x0D1722, 0x0D161D, 0x10151B, 0x10151E, 0x0F161F, 0x0F151A, 0x0F151B, 0x111515, 0x111515, 0x111516, 0x101519, 0x111415, 0x0F161E, 0x0F1519, 0x101415,
0x0F1312, 0x0F1313, 0x0F1312, 0x101213, 0x111214, 0x111214, 0x111214, 0x111214, 0x111214, 0x0F1214, 0x0F1314, 0x0F1314, 0x0F1314, 0x101415, 0x101315, 0x111315,
0x101315, 0x111315, 0x101415, 0x101415, 0x0F1518, 0x101416, 0x101416, 0x111416, 0x101418, 0x111418, 0x101518, 0x0F1D25, 0x122128, 0x0F161B, 0x0E1622, 0x0E1721,
0x10161A, 0x2B323A, 0x162129, 0x0B1827, 0x0D1622, 0x0D1724, 0x091829, 0x0A1829, 0x0A1C37, 0x395362, 0x061E39, 0x051D3D, 0x071C38, 0x081930, 0x0A182C, 0x09182D,
0x0A192D, 0x0A1826, 0x071A33, 0x081B35, 0x0D1624, 0x121928, 0x111823, 0x0F161A, 0x101518, 0x101518, 0x111417, 0x101416, 0x111416, 0x111416, 0x111418, 0x101415,
0x0F1314, 0x0F1314, 0x111313, 0x111314, 0x111214, 0x111214, 0x111214, 0x111214, 0x111214, 0x0F1314, 0x0F1314, 0x101315, 0x101315, 0x101415, 0x101415, 0x101315,
0x101415, 0x101416, 0x101419, 0x192128, 0x3E5156, 0x0F151C, 0x0F151C, 0x0D151E, 0x0D1621, 0x0B1724, 0x081F3E, 0x0B192A, 0x091A30, 0x091A2D, 0x071C37, 0x071D39,
0x071C36, 0x061C34, 0x071D3A, 0x051F3F, 0x03244D, 0x04295A, 0x022653, 0x123B67, 0x2A5C87, 0x032653, 0x032958, 0x012A5D, 0x143B64, 0x082C5A, 0x022454, 0x01285B,
0x02234F, 0x042148, 0x032046, 0x032450, 0x051F40, 0x071F41, 0x081B32, 0x09192D, 0x0D1826, 0x0D1621, 0x0E161E, 0x0E151C, 0x10151B, 0x101517, 0x101517, 0x101516,
0x0F1413, 0x121513, 0x242C2C, 0x2A363D, 0x2B313D, 0x25293C, 0x1E253C, 0x18253D, 0x15243C, 0x112440, 0x0F2645, 0x0E2847, 0x0B2948, 0x1A4466, 0x0D2D54, 0x082950,
0x062A53, 0x042B58, 0x042D5D, 0x033065, 0x06366A, 0x023369, 0x023973, 0x013875, 0x013A79, 0x003A7B, 0x014187, 0x014081, 0x013F81, 0x01407E, 0x02478A, 0x024586,
0x02478C, 0x024285, 0x014386, 0x02468B, 0x02478E, 0x024C94, 0x044F94, 0x225999, 0x054A90, 0x024891, 0x034792, 0x01438B, 0x1A659D, 0x044387, 0x02468E, 0x034289,
0x013C82, 0x01397E, 0x01377A, 0x013477, 0x013375, 0x01306F, 0x012C66, 0x032D64, 0x0D2E62, 0x032044, 0x032048, 0x051C39, 0x0A182A, 0x0D1723, 0x0C1724, 0x0C1620,
0x101413, 0x244247, 0xDBE5DD, 0xDAE7DE, 0xD4D7BA, 0xCEB87B, 0xBB7467, 0xAF6174, 0xA8618D, 0x9F6295, 0x9A669A, 0xA48FB7, 0x997FA8, 0x7461A4, 0x6F64A5, 0x5F68A7,
0x4C68A9, 0x3768A8, 0x2D69A8, 0x3A6DAA, 0x3B6DAA, 0x2E6CAB, 0x3075AD, 0x2373AC, 0x1B74AE, 0x1677AE, 0x0E7AAF, 0x0778AD, 0x087AAE, 0x067CAF, 0x0979AF, 0x338BB6,
0x067BAE, 0x077AAE, 0x137FB1, 0x077CAF, 0x0C7CAF, 0x067CB0, 0x067BAF, 0x0775AD, 0x0673AC, 0x056DAA, 0x066EAB, 0x056AA8, 0x0669A6, 0x0668A6, 0x0664A5, 0x0662A3,
0x055A9D, 0x075599, 0x05579C, 0x035097, 0x02468D, 0x023F88, 0x023E85, 0x053B7F, 0x0D3F7E, 0x022E6B, 0x012B64, 0x02275C, 0x012454, 0x062758, 0x032046, 0x041A37,
0x0F1314, 0x0F181B, 0x2A4F59, 0x5C7981, 0x7B8578, 0x8A7265, 0x8B4F61, 0x885075, 0x8D588A, 0x925A8D, 0x9F5C94, 0x9D5E99, 0x9E5F98, 0x9D5899, 0x9B5B9D, 0x9C5D9F,
0x975CA0, 0x8A63A3, 0x7D70AB, 0x7D71AB, 0x7774AE, 0x7275AE, 0x7579B0, 0x6277AF, 0x5074AE, 0x5279B0, 0x567CB1, 0x4A7AAF, 0x4378B0, 0x4375AF, 0x687BB1, 0x3E75AE,
0x1069A9, 0x0C6CA9, 0x1170AA, 0x2379B0, 0x327AB0, 0x076DAA, 0x066BA8, 0x066AA8, 0x056CA9, 0x066FA8, 0x066FA9, 0x0671AA, 0x0574AB, 0x0678AE, 0x0674AB, 0x0572AA,
0x0A70A9, 0x176EA9, 0x0867A6, 0x045FA4, 0x03589F, 0x02519A, 0x024690, 0x07448D, 0x023E84, 0x003980, 0x013679, 0x012F6A, 0x01285E, 0x032E65, 0x022555, 0x031F46,
0x0F1314, 0x101314, 0x111312, 0x111313, 0x121315, 0x111419, 0x101720, 0x0D1C2F, 0x0C243D, 0x092A4C, 0x0A325E, 0x0A3A6F, 0x0D447E, 0x114F8E, 0x1C5394, 0x375A9D,
0x305B9F, 0x3A63A6, 0x2D66A6, 0x2B64A8, 0x4669A8, 0x5070AD, 0x5272AD, 0x6072AC, 0x6D72AE, 0x4574AE, 0x2B6FAC, 0x246EAB, 0x166CAB, 0x246DAB, 0x196AA9, 0x0C68A8,
0x086CA9, 0x1572AC, 0x136FAB, 0x126DA9, 0x0D6BA9, 0x056BA8, 0x056BA8, 0x046AA7, 0x0469A6, 0x056CA6, 0x0670A9, 0x0675AC, 0x0772AC, 0x0773AB, 0x0872AA, 0x066FA9,
0x126CA7, 0x186EA9, 0x035BA1, 0x03569E, 0x05539C, 0x085098, 0x02458F, 0x07458E, 0x023D85, 0x013C83, 0x013170, 0x012B64, 0x012B64, 0x012557, 0x01224F, 0x021D43,
0x0F1314, 0x0F1314, 0x101312, 0x111213, 0x111214, 0x111213, 0x111212, 0x101214, 0x0F1313, 0x0F1313, 0x0F1313, 0x101315, 0x0F1315, 0x0E1418, 0x0E151B, 0x0D1722,
0x0B1A29, 0x09203A, 0x08284C, 0x053561, 0x034375, 0x024A85, 0x025392, 0x025997, 0x0362A1, 0x0263A3, 0x026AA6, 0x026CA8, 0x036DA9, 0x0468A7, 0x046EAA, 0x0371AC,
0x0374AC, 0x0479AE, 0x0475AC, 0x0976AE, 0x0370AA, 0x046EA9, 0x036AA7, 0x0369A8, 0x046BA9, 0x0B6AA8, 0x0A67A6, 0x0567A7, 0x106CA9, 0x0E6AA6, 0x0E65A5, 0x0360A2,
0x02549C, 0x01468C, 0x044A93, 0x01418A, 0x014189, 0x013D86, 0x01357C, 0x003477, 0x01306F, 0x012D69, 0x01285F, 0x02265A, 0x01265A, 0x02204A, 0x03234F, 0x07182D,
0x0F1314, 0x0F1314, 0x0F1312, 0x101213, 0x111214, 0x101213, 0x131214, 0x101214, 0x101214, 0x101214, 0x0F1314, 0x0F1314, 0x0F1314, 0x0F1314, 0x101414, 0x101314,
0x101315, 0x101415, 0x101415, 0x111415, 0x101416, 0x0F1519, 0x0E161C, 0x0C1723, 0x091D35, 0x062141, 0x022751, 0x285E8B, 0x022D60, 0x01316C, 0x01377A, 0x014085,
0x00428B, 0x01418A, 0x01408A, 0x034087, 0x013D83, 0x013B80, 0x05458B, 0x1E619E, 0x013F87, 0x023F86, 0x023980, 0x013B7F, 0x024187, 0x034890, 0x023C81, 0x01387D,
0x01367A, 0x003170, 0x002F6C, 0x012F6E, 0x012D6B, 0x012B65, 0x002C66, 0x012E6A, 0x01285D, 0x002555, 0x031F43, 0x071931, 0x061A36, 0x061B37, 0x091A30, 0x0E151E,
0x0F1314, 0x0F1314, 0x0F1313, 0x101213, 0x111214, 0x111214, 0x111214, 0x101214, 0x101214, 0x101214, 0x0F1314, 0x0F1314, 0x0F1314, 0x0F1314, 0x101315, 0x101315,
0x101315, 0x101315, 0x0F1413, 0x101315, 0x101317, 0x101415, 0x101416, 0x101416, 0x101516, 0x101417, 0x101517, 0x1B2225, 0x12181C, 0x0C1824, 0x0B1722, 0x051C36,
0x03244D, 0x13477D, 0x022657, 0x012A62, 0x012C6A, 0x012A63, 0x012C65, 0x01306A, 0x012656, 0x02214A, 0x02204A, 0x031F44, 0x041E3F, 0x051F43, 0x031F45, 0x061E3C,
0x071F3B, 0x081B30, 0x09192E, 0x081B35, 0x1B213D, 0x071C3B, 0x061C38, 0x051E3F, 0x071B37, 0x071B34, 0x0A192B, 0x0E1621, 0x0D1621, 0x0E151D, 0x0F151B, 0x0F1518,
0x0F1314, 0x0F1314, 0x0F1314, 0x101214, 0x111214, 0x111214, 0x111214, 0x101214, 0x0F1314, 0x0F1214, 0x0F1213, 0x0F1314, 0x0F1314, 0x0F1314, 0x101315, 0x101417,
0x0F1416, 0x152E31, 0x0E181A, 0x0F1418, 0x101414, 0x101414, 0x101415, 0x101415, 0x111515, 0x111515, 0x101417, 0x35423E, 0x141B1A, 0x10151A, 0x101517, 0x0F1519,
0x0F161A, 0x12282F, 0x0F151B, 0x0E161E, 0x0B1724, 0x081A30, 0x061D3C, 0x042046, 0x022556, 0x01265A, 0x012455, 0x022149, 0x20354B, 0x0C284B, 0x042049, 0x071B35,
0x081A30, 0x0B1723, 0x0E161F, 0x0E1620, 0x131928, 0x0D171F, 0x0E171E, 0x11151B, 0x0F161E, 0x10151C, 0x101518, 0x111416, 0x0F1518, 0x101516, 0x101516, 0x111415,
0x0F1313, 0x0F1313, 0x0F1313, 0x0F1213, 0x101214, 0x111214, 0x111214, 0x101214, 0x0F1314, 0x101214, 0x0F1213, 0x0F1314, 0x0F1314, 0x101314, 0x101314, 0x0F1415,
0x101416, 0x0F161A, 0x0F1415, 0x101315, 0x101413, 0x101414, 0x101415, 0x101417, 0x101415, 0x111516, 0x101415, 0x0F161A, 0x111416, 0x10151A, 0x101517, 0x101516,
0x111515, 0x111516, 0x111517, 0x111417, 0x0F1721, 0x0F151C, 0x101517, 0x101419, 0x0F151D, 0x0C1727, 0x122140, 0x081E3B, 0x1B3043, 0x0A2034, 0x051E3F, 0x061D3C,
0x051B38, 0x071B38, 0x0D1620, 0x0E161F, 0x0F151E, 0x0D1724, 0x091B33, 0x0D1926, 0x416163, 0x11161D, 0x0F151C, 0x1C2E34, 0x101516, 0x111516, 0x111414, 0x0F151A,
0x0F1312, 0x0F1313, 0x0F1312, 0x0F1313, 0x101214, 0x111214, 0x111214, 0x101214, 0x0F1314, 0x101214, 0x0F1213, 0x0F1314, 0x0F1314, 0x101314, 0x111314, 0x111314,
0x101517, 0x0F1417, 0x101415, 0x101418, 0x111413, 0x111414, 0x0F1416, 0x0F161C, 0x101415, 0x111515, 0x111516, 0x111516, 0x111516, 0x111516, 0x111516, 0x111416,
0x111417, 0x111516, 0x111516, 0x101417, 0x0F151A, 0x101417, 0x101417, 0x0F1924, 0x10161B, 0x101518, 0x101516, 0x0F151A, 0x0F151B, 0x101517, 0x101518, 0x0F151D,
0x0F151D, 0x0E1620, 0x0F151C, 0x0E161D, 0x0F151A, 0x101519, 0x10151A, 0x0E1724, 0x171921, 0x111418, 0x0F161D, 0x101519, 0x101416, 0x101515, 0x111515, 0x111415,
0x0F1312, 0x0F1313, 0x0F1312, 0x0F1313, 0x101214, 0x111214, 0x111214, 0x101214, 0x0F1314, 0x101214, 0x0F1214, 0x0F1314, 0x0F1314, 0x151919, 0x111413, 0x111413,
0x101316, 0x0E1419, 0x101413, 0x101413, 0x101414, 0x101415, 0x101415, 0x101415, 0x0F1619, 0x111416, 0x111516, 0x111516, 0x111516, 0x111516, 0x111416, 0x101515,
0x111515, 0x111518, 0x2C4E52, 0x101516, 0x111516, 0x111516, 0x111515, 0x111515, 0x111516, 0x111515, 0x111516, 0x111515, 0x111416, 0x10161A, 0x15181D, 0x0F181E,
0x10161B, 0x101516, 0x111516, 0x111516, 0x111516, 0x111516, 0x111516, 0x111415, 0x0F151A, 0x0E161D, 0x101516, 0x111516, 0x101515, 0x0E161D, 0x121518, 0x222A29
}, smlcometimagery[SMLCOMETHEIGHT * SMLCOMETWIDTH] = {
0x0F1313, 0x0F1213, 0x101214, 0x101214, 0x101214, 0x0F1314, 0x0F1314, 0x101315, 0x101314, 0x101415, 0x101416, 0x101416, 0x111417, 0x12191D, 0x18272F, 0x0F161D,
0x1E2328, 0x151E25, 0x0E1620, 0x0C1724, 0x172737, 0x091C35, 0x0A192B, 0x0C1726, 0x0C1724, 0x0B1828, 0x0F1722, 0x10161C, 0x101516, 0x101517, 0x101518, 0x101417,
0x101413, 0x1C2224, 0x1D2028, 0x161B28, 0x121B29, 0x0F1D2D, 0x112536, 0x0D1F33, 0x0A1F36, 0x0C2541, 0x153451, 0x082749, 0x06284F, 0x052E5C, 0x052D57, 0x043160,
0x04305F, 0x043163, 0x033872, 0x0F427A, 0x0D457F, 0x023774, 0x0E4479, 0x023571, 0x022E66, 0x022C62, 0x042859, 0x05234A, 0x0A1F3B, 0x091A2F, 0x0E1620, 0x0E161C,
0x152022, 0x8FA5A6, 0xAAA185, 0x9F5D6C, 0x9A5D8E, 0x9E6CA0, 0x92669F, 0x8161A2, 0x6964A5, 0x586EAA, 0x5471AC, 0x4B76AE, 0x3576AE, 0x2D7AAF, 0x2579AF, 0x387DB1,
0x0A73AC, 0x1379AE, 0x1378AE, 0x0671AB, 0x056FAA, 0x066EA9, 0x066FA9, 0x056BA7, 0x0B63A2, 0x055B9F, 0x024B93, 0x044088, 0x04397B, 0x012D69, 0x03285C, 0x031F46,
0x0F1314, 0x111313, 0x111315, 0x0F161D, 0x0D1D2C, 0x0D253D, 0x0F2F4E, 0x1B365C, 0x1F3E6A, 0x194A7F, 0x275994, 0x2E64A0, 0x2E6BA8, 0x146DA9, 0x106BAA, 0x0B6CAA,
0x0972AC, 0x0C72AB, 0x066DA9, 0x046AA8, 0x066AA7, 0x076DA9, 0x0B6FA9, 0x086AA6, 0x0B5D9E, 0x034F97, 0x044891, 0x033D84, 0x013578, 0x012B63, 0x012658, 0x031F43,
0x0F1314, 0x0F1213, 0x101213, 0x111214, 0x101214, 0x0F1314, 0x0F1314, 0x101314, 0x101315, 0x101415, 0x101417, 0x0F151B, 0x0C1A29, 0x152F46, 0x082443, 0x052A56,
0x063B78, 0x023473, 0x013474, 0x09407E, 0x01316B, 0x022D63, 0x033266, 0x032C60, 0x042855, 0x05244F, 0x092552, 0x032552, 0x042147, 0x081A30, 0x0A182B, 0x0D1620,
0x0F1313, 0x0F1213, 0x101214, 0x101214, 0x0F1214, 0x0F1314, 0x0F1314, 0x101415, 0x111B1E, 0x0F1517, 0x101414, 0x101415, 0x101415, 0x192021, 0x111619, 0x101517,
0x111A1D, 0x0F151A, 0x0C1724, 0x0A1A2D, 0x071E3D, 0x072146, 0x142B43, 0x051E3E, 0x081A31, 0x0E1620, 0x0F1722, 0x0D1824, 0x1C282E, 0x131B20, 0x101516, 0x101516,
0x0F1312, 0x0F1312, 0x101214, 0x101214, 0x0F1214, 0x0F1314, 0x101415, 0x111314, 0x0F1417, 0x101415, 0x101414, 0x101517, 0x101516, 0x111516, 0x111516, 0x111416,
0x111416, 0x172325, 0x101517, 0x10161A, 0x101518, 0x101517, 0x101518, 0x11161C, 0x0F151C, 0x101519, 0x101517, 0x10151A, 0x11161C, 0x101518, 0x101518, 0x161A1B
};
#endif

MODULE void checkcolours(void);
MODULE void generatewave(int channel, double hertz, int volume, FLAG noisy);
MODULE HANDLE MakeDib(HBITMAP hbitmap, UINT bits);
MODULE void sidebar_up(void);
MODULE void sidebar_down(void);

BOOL CALLBACK GameInfoDlgProc(HWND hwnd, UINT Message, WPARAM wParam, LPARAM lParam);
BOOL CALLBACK HiScoresDlgProc(HWND hwnd, UINT Message, WPARAM wParam, LPARAM lParam);
BOOL CALLBACK HostNameDlgProc(HWND hwnd, UINT Message, WPARAM wParam, LPARAM lParam);
BOOL CALLBACK   SpriteDlgProc(HWND hwnd, UINT Message, WPARAM wParam, LPARAM lParam);

EXPORT void handlekybd(UINT code)
{   if
    (   (   machine == PIPBUG
         || machine == CD2650
         || machine == CHAOS
         || machine == PHUNSY
        )
     && !paused
    )
    {   KeyMatrix[code / 8] |= (1 << (code % 8));
        keyframes[code]++;

        if (queuepos == QUEUESIZE)
        {   return;
        }

        if
        (   ctrl()
         && keyname[code].unshifted >= 'a'
         && keyname[code].unshifted <= 'z'
        )
        {   if
            (   keyname[code].unshifted == 'c'
             || keyname[code].unshifted == 'g' // Ctrl+G = ASCII 7 (BEL)
             || keyname[code].unshifted == 'h'
             || keyname[code].unshifted == 'j'
             || keyname[code].unshifted == 'm'
             || keyname[code].unshifted == 'z'
            )
            {   if (recmode != RECMODE_PLAY)
                {   enqueue(code, (TEXT) (keyname[code].unshifted - 'a' + 1)); // 1..26
/* If the user types Ctrl+G (BEL):
    PIPBUG echoes it
    CD2650 says "G?".
    Chaos ignores it */
#ifdef VERBOSE
                    T1; zprintf("Passing Ctrl+%c (%s) to guest.\n", keyname[code].shifted, asciiname[keyname[code].unshifted - 'a' + 1]); T2;
#endif
                }
                return; // we pass these to guest
        }   } // and intercept all others (eg. Ctrl+O, Ctrl+')
        elif (!ctrl() && shift())
        {   if (keyname[code].shifted)
            {   if (recmode != RECMODE_PLAY)
                {   enqueue(code, keyname[code].shifted);
                }
                return;
        }   }
        elif (!ctrl())
        {   if (capslock || !lowercase) // uppercase
            {   if (keyname[code].capslock)
                {   if (recmode != RECMODE_PLAY)
                    {   enqueue(code, keyname[code].capslock);
                    }
                    return;
            }   }
            else
            {   if (keyname[code].unshifted)
                {   if (recmode != RECMODE_PLAY)
                    {   if (machine == PIPBUG || machine == PHUNSY)
                        {   enqueue(code, keyname[code].unshifted);
                        } else
                        {   // assert(machine == CD2650 || machine == CHAOS);
                            enqueue(code, (TEXT) (keyname[code].capslock & 0x3F));
                    }   }
                    return;
    }   }   }   }

    if
    (   (!ctrl() && !shift())
     || code == SCAN_APOSTROPHE
     || code == SCAN_SEMICOLON
    )
    {   KeyMatrix[code / 8] |= (1 << (code % 8));
    }

    switch (code)
    {
    case SCAN_ESCAPE:
        if (!ctrl() && confirm())
        {   cleanexit(EXIT_SUCCESS);
        }
    acase SCAN_VOLDOWN:
        if (hostvolume > 0)
        {   sound_off(TRUE); // we want to force a refresh of the sound
            hostvolume--;
            sound_on();
        }
    acase SCAN_VOLUP:
        if (hostvolume < HOSTVOLUME_MAX)
        {   sound_off(TRUE); // we want to force a refresh of the sound
            hostvolume++;
            sound_on();
        }
    acase SCAN_BACKSPACE:
        if (ctrl() && !shift())
        {   if (trace) trace = FALSE; else trace = TRUE;
            updatemenu(MENUITEM_TRACECPU);
        }
    acase SCAN_WEB:
        openurl("http://amigan.yatho.com/");
 /* acase SCAN_RETURN:
        if (!ctrl() && !shift())
        {   docommand(MENUITEM_STEP);
        } */
    acase SCAN_BACKTICK:
        if (ctrl())
        {   if (shift())
            {   edit_dips();
            } else
            {   if (!crippled && game)
                {   docommand(MENUITEM_REVERT);
        }   }   }
    acase SCAN_A:
        if (ctrl() && !shift())
        {   if (!crippled && game)
            {   docommand(MENUITEM_SAVEROM);
        }   }
    acase SCAN_B:
        if (ctrl() && !shift())
        {   if
            (   machine == ARCADIA
             || machine == INTERTON
             || machine == ELEKTOR
             || machine == ASTROWARS
             || machine == GALAXIA
             || machine == MALZAK
            )
            {   if (autofire) autofire = FALSE; else autofire = TRUE; // foo = ~foo; doesn't always work!
                docommand(MENUITEM_AUTOFIRE);
        }   }
    acase SCAN_C:
        if (ctrl() && !shift())
        {   savescreenshot(KIND_BMP, FALSE, TRUE);
        }
    acase SCAN_D:
        if (ctrl() && !shift())
        {   if (machine == ARCADIA)
            {   if (demultiplex) demultiplex = FALSE; else demultiplex = TRUE; // foo = ~foo; doesn't always work!
                docommand(MENUITEM_DEMULTIPLEX);
        }   }
    acase SCAN_E:
        if (ctrl() && !shift())
        {   DISCARD wp_clearall();
        }
    acase SCAN_F:
        if (ctrl() && !shift())
        {   if (fullscreen && !AnimInfo)
            {   if (stretch)
                {   stretch = FALSE;
                } else
                {   stretch = TRUE;
                }
                docommand(MENUITEM_STRETCH);
        }   }
    acase SCAN_G:
        if (ctrl() && !shift())
        {   debug_set(KIND_BP);
        }
    acase SCAN_H:
        if (ctrl() && !shift())
        {   DISCARD bp_clearall();
        }
 /* acase SCAN_TAB:
        if (ctrl() && !shift())
        {   DISCARD BringWindowToTop(MainWindowPtr); // doesn't work, subwindows are always in front of main window :-(
        } */
    acase SCAN_I:
        if (ctrl() && !shift())
        {   if (showsidebar) showsidebar = FALSE; else showsidebar = TRUE;
            closewindow();
            openwindow();
        }
    acase SCAN_J:
#ifdef PROFILE
        if (ctrl() && shift())
        {   printprofile();
        }
#endif
        if (ctrl() && !shift())
        {   audit(TRUE);
        }
    acase SCAN_K:
        if (ctrl() && !shift())
        {   jump = FALSE;
            debug_edit();
        }
    acase SCAN_L:
        if (ctrl() && !shift())
        {   if
            (   machine == ARCADIA
             || machine == INTERTON
             || machine == ELEKTOR
             || machine == ASTROWARS
             || machine == GALAXIA
             || machine == MALZAK
            )
            {   if (collisions) collisions = FALSE; else collisions = TRUE; // foo = ~foo; doesn't always work!
                docommand(MENUITEM_COLLISIONS);
        }   }
    acase SCAN_M:
        if (ctrl() && !shift())
        {   if (showmenubar) showmenubar = FALSE; else showmenubar = TRUE; // foo = ~foo; doesn't always work!
            docommand(MENUITEM_MENUBAR);
        }
    acase SCAN_N:
        if (ctrl() && !shift() && !fullscreen && !AnimInfo)
        {   if (wide == 1)
            {   wide = realwide = 2;
            } else
            {   // assert(wide == 2);
                wide = realwide = 1;
            }
            updatemenu(MENUITEM_NARROW);
            resize(size);
        }
    acase SCAN_O:
        if (!crippled && ctrl() && !shift())
        {   project_open();
        }
    acase SCAN_P:
        if
        (   ctrl()
         && !shift()
         && (   machine == ARCADIA
             || machine == INTERTON
             || machine == ELEKTOR
             || machine == CD2650
        )   )
        {   if (flagline) flagline = FALSE; else flagline = TRUE; // foo = ~foo; doesn't always work!
            docommand(MENUITEM_FLAGLINE);
        }
    acase SCAN_R:
        if (ctrl() && !shift())
        {   project_save(KIND_COR);
        }
    acase SCAN_S:
        if (ctrl() && !shift())
        {   if (!crippled)
            {   project_save(KIND_COS);
        }   }
    acase SCAN_T:
    case SCAN_STOP:
        if (ctrl() && !shift())
        {   macro_stop();
        }
    acase SCAN_U:
        if (ctrl() && !shift())
        {   if (sound) sound = FALSE; else sound = TRUE; // foo = ~foo; doesn't always work!
            docommand(MENUITEM_SOUND);
        }
    acase SCAN_MUTE:
        if (!ctrl() && !shift())
        {   if (sound) sound = FALSE; else sound = TRUE; // foo = ~foo; doesn't always work!
            docommand(MENUITEM_SOUND);
        }
    acase SCAN_V:
        if (ctrl() && !shift())
        {   edit_pastetext();
        }
    acase SCAN_W:
        if (ctrl() && !shift())
        {   debug_set(KIND_WP);
        }
    acase SCAN_X:
        if (ctrl() && !shift())
        {   if (showpointer) showpointer = FALSE; else showpointer = TRUE;
            docommand(MENUITEM_POINTER);
        }
    acase SCAN_Y:
        if (ctrl() && !shift())
        {   if (loop) loop = FALSE; else loop = TRUE; // foo = ~foo; doesn't always work!
            updatemenu(MENUITEM_LOOP);
        }
    acase SCAN_Z:
        if (ctrl() && !shift())
        {   docommand(MENUITEM_STEP);
        }
    acase SCAN_F1:
        if (ctrl() && !shift() && !fullscreen && size != 1)
        {   resize(1);
        }
    acase SCAN_A1:
    case SCAN_N1:
        if (ctrl())
        {   if (shift())
            {   if
                (   machine == ARCADIA
                 || machine == INTERTON
                 || machine == ELEKTOR
                 || machine == ASTROWARS
                 || machine == GALAXIA
                 || machine == MALZAK
                )
                {   docommand(MENUITEM_RUNTORAST);
            }   }
            else
            {   if (!fullscreen && size != 1)
                {   resize(1);
        }   }   }
    acase SCAN_F2:
        if (ctrl() && !shift() && !fullscreen && size != 2)
        {   resize(2);
        }
    acase SCAN_A2:
    case SCAN_N2:
        if (ctrl())
        {   if (shift())
            {   if
                (   machine == ARCADIA
                 || machine == INTERTON
                 || machine == ELEKTOR
                 || machine == ASTROWARS
                 || machine == GALAXIA
                 || machine == MALZAK
                )
                {   docommand(MENUITEM_RUNTORASTN);
            }   }
            else
            {   if (!fullscreen && size != 2)
                {   resize(2);
        }   }   }
    acase SCAN_F3:
        if (ctrl() && !shift() && !fullscreen && size != 3)
        {   resize(3);
        }
    acase SCAN_A3:
    case SCAN_N3:
        if (ctrl())
        {   if (shift())
            {   if (machine == ARCADIA)
                {   docommand(MENUITEM_RUNTODMA);
            }   }
            else
            {   if (!fullscreen && size != 3)
                {   resize(3);
        }   }   }
    acase SCAN_F4:
        if (ctrl() && !shift() && !fullscreen && size != 4)
        {   resize(4);
        }
    acase SCAN_A4:
    case SCAN_N4:
        if (ctrl())
        {   if (shift())
            {   if
                (   machine == INTERTON
                 || machine == ELEKTOR
                 || machine == ASTROWARS
                 || machine == GALAXIA
                 || machine == MALZAK
                )
                {   docommand(MENUITEM_RUNTOINTERRUPT);
            }   }
            else
            {   if (!fullscreen && size != 4)
                {   resize(4);
        }   }   }
    acase SCAN_F5:
        if (!ctrl())
        {   if (shift())
            {   if
                (   machine == ELEKTOR
                 || machine == PIPBUG
                 || machine == INSTRUCTOR
                 || machine == CD2650
                )
                {   docommand(MENUITEM_RESETTOMONITOR);
            }   }
            else
            {   if (!crippled)
                {   project_reset(FALSE);
        }   }   }
    acase SCAN_A5:
    case SCAN_N5:
        if (ctrl() && shift())
        {   docommand(MENUITEM_RUNTOFRAME);
        }
    acase SCAN_CALC:
        if (!shift() && !ctrl())
        {   if (MonitorWindowPtr)
            {   DestroyWindow(MonitorWindowPtr);
                MonitorWindowPtr = NULL;
                updatemenu(MENUITEM_VIEWMONITOR);
            } else
            {   view_monitor();
        }   }
    acase SCAN_A6:
    case SCAN_N6:
        if (ctrl())
        {   if (shift())
            {   if (machine == PIPBUG || machine == CHAOS)
                {   if (highres) highres = FALSE; else highres = TRUE;
                    docommand(MENUITEM_HIGHRES);
            }   }
            else
            {   if (!crippled)
                {   docommand(COMMAND_ARCADIA);
        }   }   }
    acase SCAN_F7:
        if (!ctrl() && !shift())
        {   if
            (   machine == ARCADIA
             || machine == INTERTON
             || machine == ELEKTOR
             || machine == ASTROWARS
             || machine == GALAXIA
             || machine == MALZAK
            )
            {   if (swapped) swapped = FALSE; else swapped = TRUE; // foo = ~foo; doesn't always work!
                docommand(MENUITEM_SWAPPED);
        }   }
    acase SCAN_A7:
    case SCAN_N7:
        if (ctrl())
        {   if (shift())
            {   if
                (   machine == ASTROWARS
                 || machine == GALAXIA
                 || machine == MALZAK
                 || (game && autotext[AUTOLINE_GAMENAME][0])
                )
                {   help_gameinfo();
            }   }
            else
            {   if (!crippled)
                {   docommand(COMMAND_INTERTON);
        }   }   }
    acase SCAN_F8:
    case SCAN_FFWD:
        if (!ctrl() && !shift())
        {   if (turbo) turbo = FALSE; else turbo = TRUE; // foo = ~foo; doesn't always work!
            docommand(MENUITEM_TURBO);
        }
    acase SCAN_A8:
    case SCAN_N8:
        if (ctrl())
        {   if (shift())
            {   if
                (   machine == ARCADIA
                 || machine == INTERTON
                 || machine == ELEKTOR
                 || machine == INSTRUCTOR
                 || machine == ASTROWARS
                 || machine == GALAXIA
                 || machine == MALZAK
                )
                {   sound_off(FALSE);
                    opening = TRUE;
                    DISCARD DialogBox(GetModuleHandle(NULL), MAKEINTRESOURCE(IDD_REDEFINE), MainWindowPtr, RedefineDlgProc);
                    opening = FALSE;
                    sound_on();
            }   }
            else
            {   if (!crippled)
                {   docommand(COMMAND_ELEKTOR);
        }   }   }
    acase SCAN_F9:
        if (!ctrl() && !shift() && !AnimInfo)
        {   if (fullscreen) fullscreen = FALSE; else fullscreen = TRUE; // foo = ~foo; doesn't always work!
            docommand(MENUITEM_FULLSCREEN);
        }
    acase SCAN_A9:
    case SCAN_N9:
        if (ctrl() && !crippled)
        {   if (!shift())
            {   docommand(COMMAND_PIPBUG);
            } else
            {   docommand(MENUITEM_QUICKLOAD);
        }   }
    acase SCAN_A0:
    case SCAN_N0:
        if (ctrl() && !crippled)
        {   if (!shift())
            {   docommand(COMMAND_INSTRUCTOR);
            } else
            {   docommand(MENUITEM_QUICKSAVE);
        }   }
    acase SCAN_EQUALS:
        if (ctrl())
        {   if (shift())
            {   if (!crippled)
                {   docommand(COMMAND_GALAXIA);
            }   }
            else
            {   if (!crippled)
                {   docommand(COMMAND_ASTROWARS);
        }   }   }
    acase SCAN_BACKSLASH:
        if (ctrl())
        {   if (shift())
            {   if (!crippled)
                {   docommand(COMMAND_MALZAK2);
            }   }
            else
            {   if (!crippled)
                {   docommand(COMMAND_MALZAK1);
        }   }   }
    acase SCAN_F11:
        if (!ctrl() && !shift())
        {   if (MonitorWindowPtr)
            {   DestroyWindow(MonitorWindowPtr);
                MonitorWindowPtr = NULL;
                updatemenu(MENUITEM_VIEWMONITOR);
            } else
            {   view_monitor();
        }   }
    acase SCAN_F12:
        if (!shift())
        {   if (ctrl())
            {   // assert(!iconified);
                clearkybd();
                iconify();
            } else
            {   if
                (   machine == ARCADIA
                 || machine == INTERTON
                 || machine == ELEKTOR
                 || machine == INSTRUCTOR
                 || machine == ASTROWARS
                 || machine == GALAXIA
                 || machine == MALZAK
                 || machine == DOLPHIN
                )
                {   if (ControlsWindowPtr)
                    {   DestroyWindow(ControlsWindowPtr);
                        ControlsWindowPtr = NULL;
                        updatemenu(MENUITEM_CONTROLS);
                    } else
                    {   view_controls();
        }   }   }   }
    acase SCAN_HYPHEN:
        if (ctrl())
        {   if (shift())
            {   savescreenshot(KIND_ILBM, TRUE, FALSE);
            } else
            {   if (!crippled)
                {   docommand(COMMAND_CD2650);
        }   }   }
    acase SCAN_OS:
        if (ctrl())
        {   if (shift())
            {   if
                (   machine == ARCADIA
                 || machine == INTERTON
                 || machine == ELEKTOR
                )
                {   if (analog) analog = FALSE; else analog = TRUE; // foo = ~foo; doesn't always work!
                    updatemenu(MENUITEM_ANALOG);
                    updatemenu(MENUITEM_SENSITIVITY);
            }   }
            else
            {   region = REGION_NTSC;
                updatemenu(MENUITEM_REGION);
        }   }
    acase SCAN_CS:
        if (ctrl() && !shift())
        {   region = REGION_PAL;
            updatemenu(MENUITEM_REGION);
        }
    acase SCAN_COMMA:
        if (ctrl() && !shift())
        {   if
            (   machine == ELEKTOR
             || machine == PIPBUG
             || machine == INSTRUCTOR
             || machine == CD2650
            )
            {   docommand(MENUITEM_RESETTOMONITOR);
        }   }
    acase SCAN_SLASH:
        if (ctrl())
        {   if (!shift())
            {   if (cli) cli = FALSE; else cli = TRUE; // foo = ~foo; doesn't always work!
                docommand(MENUITEM_CLI);
        }   }
    acase SCAN_PAUSE:
    case SCAN_PLAY:
        if (!ctrl() && !shift())
        {   if (paused)
            {   emu_unpause();
            } else
            {   emu_pause(TRUE);
        }   }
 /* acase SCAN_SCRLK:
        if (!ctrl() && !shift())
        {   if (frameskip == 0x7FFFFFFF)
            {   frameskip = 1;
            } else
            {   frameskip = 0x7FFFFFFF;
        }   } */
    acase SCAN_LCTRL:
    case SCAN_RCTRL:
    case SCAN_LSHIFT:
    case SCAN_RSHIFT:
        KeyMatrix[code / 8] |= (1 << (code % 8));
    acase SCAN_UP:
    case SCAN_LEFT:
        if
        (   ctrl()
         && showsidebar
         && foundgames
         && !crippled
        )
        {   sidebar_up();
        }
    acase SCAN_PREV:
        if
        (   showsidebar
         && foundgames
         && !crippled
        )
        {   sidebar_up();
        }
    acase SCAN_DOWN:
    case SCAN_RIGHT:
        if
        (   ctrl()
         && showsidebar
         && foundgames
         && !crippled
        )
        {   sidebar_down();
        }
    acase SCAN_NEXT:
        if
        (   showsidebar
         && foundgames
         && !crippled
        )
        {   sidebar_down();
        }
    acase SCAN_TAB:
        if (ctrl() && !shift())
        {   if (ConsoleWindowPtr)
            {   clearkybd();
                SetForegroundWindow(ConsoleWindowPtr);
}   }   }   }

MODULE void sidebar_up(void)
{   int oldcurrentgame;

    oldcurrentgame = currentgame;
    if (currentgame == -1 || shift())
    {   currentgame = 2; // move to top
    } elif (currentgame > 0)
    {   currentgame--; // move up by 1
    }
    if (currentgame != oldcurrentgame)
    {   ListView_SetItemState(hSideBar, oldcurrentgame, 0, 0x000F);
        ListView_SetItemState(hSideBar, currentgame, (LVIS_FOCUSED | LVIS_SELECTED), 0x000F);
        if (currentgame != foundgames - 1)
        {   DISCARD ListView_EnsureVisible(hSideBar, currentgame, TRUE); // doesn't seem to work properly for items in the rightmost column
        }
        macro_stop();
        dosidebar(); // but window might be about to be resized!
}   }

MODULE void sidebar_down(void)
{   int oldcurrentgame;

    oldcurrentgame = currentgame;
    if (currentgame == -1 || shift())
    {   currentgame = foundgames - 1; // move to bottom
    } elif (currentgame < foundgames - 1)
    {   currentgame++; // move down by 1
    }
    if (currentgame != oldcurrentgame)
    {   ListView_SetItemState(hSideBar, oldcurrentgame, 0, 0x000F);
        ListView_SetItemState(hSideBar, currentgame, (LVIS_FOCUSED | LVIS_SELECTED), 0x000F);
        if (currentgame != foundgames - 1)
        {   DISCARD ListView_EnsureVisible(hSideBar, currentgame, TRUE); // doesn't seem to work properly for items in the rightmost column
        }
        macro_stop();
        dosidebar(); // but window might be about to be resized!
}   }

EXPORT void handlealtkybd(UINT code)
{   switch (code)
    {
    case SCAN_W:
        if (turbo) turbo = FALSE; else turbo = TRUE; // foo = ~foo; doesn't always work!
        docommand(MENUITEM_TURBO);
    acase SCAN_J:
        if (swapped) swapped = FALSE; else swapped = TRUE; // foo = ~foo; doesn't always work!
        docommand(MENUITEM_SWAPPED);
    acase SCAN_L:
        if (!crippled)
        {   docommand(MENUITEM_QUICKLOAD);
        }
    acase SCAN_R:
        if (!crippled)
        {   project_reset(FALSE);
        }
    acase SCAN_S:
        if (!crippled)
        {   docommand(MENUITEM_QUICKSAVE);
        }
    acase SCAN_AE:
    case SCAN_NE:
        if (!ctrl() && !shift())
        {   if (fullscreen) fullscreen = FALSE; else fullscreen = TRUE; // foo = ~foo; doesn't always work!
            docommand(MENUITEM_FULLSCREEN);
}   }   }

EXPORT void clearkybd(void)
{   KeyMatrix[SCAN_LCTRL  / 8] &= ~(1 << (SCAN_LCTRL  % 8));
    KeyMatrix[SCAN_RCTRL  / 8] &= ~(1 << (SCAN_RCTRL  % 8));
    KeyMatrix[SCAN_LSHIFT / 8] &= ~(1 << (SCAN_LSHIFT % 8));
    KeyMatrix[SCAN_RSHIFT / 8] &= ~(1 << (SCAN_RSHIFT % 8));
}

EXPORT void reactivate(void)
{   DISCARD SetForegroundWindow(MainWindowPtr);
    // checkinput();
}

EXPORT void updatebiggads(void)
{   if (!MainWindowPtr)
    {   return; // important!
    }

    if (crippled)
    {   if (hToolbar)
        {   DISCARD SendMessage(hToolbar, TB_SETSTATE, ID_FILE_RESET,        0);
            DISCARD SendMessage(hToolbar, TB_SETSTATE, ID_FILE_OPEN,         0);
            DISCARD SendMessage(hToolbar, TB_SETSTATE, ID_FILE_SAVESNP,      0);
            DISCARD SendMessage(hToolbar, TB_SETSTATE, ID_FILE_QUICKLOAD,    0);
            DISCARD SendMessage(hToolbar, TB_SETSTATE, ID_FILE_QUICKSAVE,    0);
        }
        if (hSideBar)
        {   EnableWindow(hSideBar, FALSE);
    }   }
    else
    {   if (hToolbar)
        {   DISCARD SendMessage(hToolbar, TB_SETSTATE, ID_FILE_RESET,        TBSTATE_ENABLED);
            DISCARD SendMessage(hToolbar, TB_SETSTATE, ID_FILE_OPEN,         TBSTATE_ENABLED);
            DISCARD SendMessage(hToolbar, TB_SETSTATE, ID_FILE_SAVESNP,      TBSTATE_ENABLED);
            DISCARD SendMessage(hToolbar, TB_SETSTATE, ID_FILE_QUICKLOAD,    TBSTATE_ENABLED);
            DISCARD SendMessage(hToolbar, TB_SETSTATE, ID_FILE_QUICKSAVE,    TBSTATE_ENABLED);
        }
        if (hSideBar && foundgames)
        {   EnableWindow(hSideBar, TRUE);
    }   }

    if (hToolbar)
    {   DISCARD RedrawWindow(FPSPtr, NULL, NULL, RDW_INVALIDATE | RDW_UPDATENOW);
}   }

EXPORT void ghost(int which, int ghosted)
{   if (menucode[which] != -1)
    {   if (ghosted)
        {   if (MenuPtr)
            {   DISCARD EnableMenuItem(MenuPtr,  (UINT) menucode[which],  MF_BYCOMMAND | MF_GRAYED);
            }
            DISCARD EnableMenuItem(PopUpMenuPtr, (UINT) menucode[which],  MF_BYCOMMAND | MF_GRAYED);
        } else
        {   if (MenuPtr)
            {   DISCARD EnableMenuItem(MenuPtr,  (UINT) menucode[which],  MF_BYCOMMAND | MF_ENABLED);
            }
            DISCARD EnableMenuItem(PopUpMenuPtr, (UINT) menucode[which],  MF_BYCOMMAND | MF_ENABLED);
}   }   }
EXPORT void enable(int which, int enabled)
{   if (menucode2[which] != -1)
    {   if (enabled)
        {   if (MenuPtr)
            {   DISCARD EnableMenuItem(MenuPtr,  (UINT) menucode2[which], MF_BYCOMMAND | MF_ENABLED);
            }
            DISCARD EnableMenuItem(PopUpMenuPtr, (UINT) menucode2[which], MF_BYCOMMAND | MF_ENABLED);
        } else
        {   if (MenuPtr)
            {   DISCARD EnableMenuItem(MenuPtr,  (UINT) menucode2[which], MF_BYCOMMAND | MF_GRAYED);
            }
            DISCARD EnableMenuItem(PopUpMenuPtr, (UINT) menucode2[which], MF_BYCOMMAND | MF_GRAYED);
}   }   }
EXPORT void checkmx(int which, int first, int last)
{   if (menucode2[which] != -1)
    {   // assert(menucode2[first] != -1);
        // assert(menucode2[last ] != -1);
        if (MenuPtr)
        {   DISCARD CheckMenuRadioItem(MenuPtr,  (UINT) menucode2[first], (UINT) menucode2[last], (UINT) menucode2[which], MF_BYCOMMAND);
        }
        DISCARD CheckMenuRadioItem(PopUpMenuPtr, (UINT) menucode2[first], (UINT) menucode2[last], (UINT) menucode2[which], MF_BYCOMMAND);
}   }
EXPORT void uncheckmx(int which) { ; }
EXPORT void tick(int which, int ticked)
{   if (menucode[which] != -1)
    {   if (ticked)
        {   if (MenuPtr)
            {   DISCARD CheckMenuItem( MenuPtr,  (UINT) menucode[which], MF_BYCOMMAND | MF_CHECKED);
            }
            DISCARD CheckMenuItem( PopUpMenuPtr, (UINT) menucode[which], MF_BYCOMMAND | MF_CHECKED);
        } else
        {   if (MenuPtr)
            {   DISCARD CheckMenuItem( MenuPtr,  (UINT) menucode[which], MF_BYCOMMAND | MF_UNCHECKED);
            }
            DISCARD CheckMenuItem( PopUpMenuPtr, (UINT) menucode[which], MF_BYCOMMAND | MF_UNCHECKED);
}   }   }
EXPORT void setbutton(int which, FLAG enabled, FLAG state)
{   if (gadgetcode[which] != -1)
    {   if (state)
        {   DISCARD SendMessage(hToolbar, TB_CHANGEBITMAP, (UINT) gadgetcode[which], gadgetimage[which][0]);
        } else
        {   DISCARD SendMessage(hToolbar, TB_CHANGEBITMAP, (UINT) gadgetcode[which], gadgetimage[which][1]);
        }
        if (!enabled)
        {   if (state)
            {   DISCARD SendMessage(hToolbar, TB_SETSTATE, (UINT) gadgetcode[which], TBSTATE_CHECKED);
            } else
            {   DISCARD SendMessage(hToolbar, TB_SETSTATE, (UINT) gadgetcode[which], 0);
        }   }
        else
        {   if (state)
            {   DISCARD SendMessage(hToolbar, TB_SETSTATE, (UINT) gadgetcode[which], TBSTATE_ENABLED | TBSTATE_CHECKED);
            } else
            {   DISCARD SendMessage(hToolbar, TB_SETSTATE, (UINT) gadgetcode[which], TBSTATE_ENABLED);
}   }   }   }

EXPORT void say(STRPTR text, FLAG handlesound)
{   if (handlesound)
    {   sound_off(FALSE);
    }
    MessageBox(MainWindowPtr, text, "WinArcadia: Warning", MB_OK | MB_ICONEXCLAMATION);
    if (handlesound)
    {   sound_on();
}   }

EXPORT void help_gameinfo(void)
{   if
    (   GameInfoWindowPtr
     || (   machine != ASTROWARS
         && machine != GALAXIA
         && machine != MALZAK
         && (   !game
             || (!pgmtext[0] && !strcmp(autotext[AUTOLINE_GAMENAME], "?"))
    )   )   )
    {   return;
    }

    opening = TRUE;
    GameInfoWindowPtr = CreateDialog
    (   InstancePtr,
        MAKEINTRESOURCE(IDD_GAMEINFO),
        MainWindowPtr,
        GameInfoDlgProc
    );
    opening = FALSE;
    updatemenu(MENUITEM_GAMEINFO);
}
EXPORT void close_gameinfo(void)
{   if (!GameInfoWindowPtr)
    {   return;
    }

    DestroyWindow(GameInfoWindowPtr);
    GameInfoWindowPtr = NULL;
    updatemenu(MENUITEM_GAMEINFO);
}

BOOL CALLBACK ListeningDlgProc(HWND hwnd, UINT Message, WPARAM wParam, LPARAM lParam)
{   switch (Message)
    {
    case WM_INITDIALOG:
        charset = CHARSET_WIN;
        DISCARD SetWindowText(hwnd, LLL, MSG_HAIL_LISTENING, "Listening..."));
        charset = CHARSET_DOS;

        return TRUE;
    case WM_ACTIVATE: // no need for acase
        do_autopause(wParam, lParam);
        return 0;
    case WM_CLOSE: // no need for acase
    case WM_KEYDOWN:
        DestroyWindow(hwnd);
        ListeningWindowPtr = NULL;
        aborting = TRUE;
        return TRUE;
    default: // no need for adefault
        return FALSE;
}   }

BOOL CALLBACK GameInfoDlgProc(HWND hwnd, UINT Message, WPARAM wParam, LPARAM lParam)
{   TRANSIENT PAINTSTRUCT localps;
    TRANSIENT LONG        gid;
    PERSIST   HBRUSH      hBrush[4];
    PERSIST   HICON       hicon;

PERSIST const int key_to_gid[2][16] = {
{ IDC_LT_0,  //  0
  IDC_LT_1,  //  1
  IDC_LT_2,  //  2
  IDC_LT_3,  //  3
  IDC_LT_4,  //  4
  IDC_LT_5,  //  5
  IDC_LT_6,  //  6
  IDC_LT_7,  //  7
  IDC_LT_8,  //  8
  IDC_LT_9,  //  9
  IDC_LT_CL, // 10
  IDC_LT_EN, // 11
  IDC_LT_X1, // 12
  IDC_LT_X2, // 13
  IDC_LT_X3, // 14
  IDC_LT_X4  // 15
},
{ IDC_RT_0,  //  0
  IDC_RT_1,  //  1
  IDC_RT_2,  //  2
  IDC_RT_3,  //  3
  IDC_RT_4,  //  4
  IDC_RT_5,  //  5
  IDC_RT_6,  //  6
  IDC_RT_7,  //  7
  IDC_RT_8,  //  8
  IDC_RT_9,  //  9
  IDC_RT_CL, // 10
  IDC_RT_EN, // 11
  IDC_RT_X1, // 12
  IDC_RT_X2, // 13
  IDC_RT_X3, // 14
  IDC_RT_X4  // 15
} };

    switch (Message)
    {
    case WM_INITDIALOG:
        charset = CHARSET_WIN;

        if (language == LANGUAGE_RUS)
        {   DISCARD SendMessage(GetDlgItem(hwnd, IDC_AUTOSENSE_LEFT ), WM_SETFONT, (WPARAM) hRussianFont, MAKELPARAM(FALSE, 0));
            DISCARD SendMessage(GetDlgItem(hwnd, IDC_AUTOSENSE_RIGHT), WM_SETFONT, (WPARAM) hRussianFont, MAKELPARAM(FALSE, 0));
            DISCARD SendMessage(GetDlgItem(hwnd, IDOK               ), WM_SETFONT, (WPARAM) hRussianFont, MAKELPARAM(FALSE, 0));
        
            DISCARD SendMessage(GetDlgItem(hwnd, IDL_AUTOLABEL1 ), WM_SETFONT, (WPARAM) hRussianFont, MAKELPARAM(FALSE, 0));
            DISCARD SendMessage(GetDlgItem(hwnd, IDL_AUTOLABEL2 ), WM_SETFONT, (WPARAM) hRussianFont, MAKELPARAM(FALSE, 0));
            DISCARD SendMessage(GetDlgItem(hwnd, IDL_AUTOLABEL3 ), WM_SETFONT, (WPARAM) hRussianFont, MAKELPARAM(FALSE, 0));
            DISCARD SendMessage(GetDlgItem(hwnd, IDL_AUTOLABEL4 ), WM_SETFONT, (WPARAM) hRussianFont, MAKELPARAM(FALSE, 0));
            DISCARD SendMessage(GetDlgItem(hwnd, IDL_AUTOLABEL5 ), WM_SETFONT, (WPARAM) hRussianFont, MAKELPARAM(FALSE, 0));
            DISCARD SendMessage(GetDlgItem(hwnd, IDL_AUTOLABEL6 ), WM_SETFONT, (WPARAM) hRussianFont, MAKELPARAM(FALSE, 0));
            DISCARD SendMessage(GetDlgItem(hwnd, IDL_AUTOLABEL7 ), WM_SETFONT, (WPARAM) hRussianFont, MAKELPARAM(FALSE, 0));
            DISCARD SendMessage(GetDlgItem(hwnd, IDL_AUTOLABEL8 ), WM_SETFONT, (WPARAM) hRussianFont, MAKELPARAM(FALSE, 0));
            DISCARD SendMessage(GetDlgItem(hwnd, IDL_AUTOLABEL9 ), WM_SETFONT, (WPARAM) hRussianFont, MAKELPARAM(FALSE, 0));
            DISCARD SendMessage(GetDlgItem(hwnd, IDL_AUTOLABEL10), WM_SETFONT, (WPARAM) hRussianFont, MAKELPARAM(FALSE, 0));

            DISCARD SendMessage(GetDlgItem(hwnd, IDC_AUTOSENSE1 ), WM_SETFONT, (WPARAM) hRussianFont, MAKELPARAM(FALSE, 0));
            DISCARD SendMessage(GetDlgItem(hwnd, IDC_AUTOSENSE2 ), WM_SETFONT, (WPARAM) hRussianFont, MAKELPARAM(FALSE, 0));
            DISCARD SendMessage(GetDlgItem(hwnd, IDC_AUTOSENSE3 ), WM_SETFONT, (WPARAM) hRussianFont, MAKELPARAM(FALSE, 0));
            DISCARD SendMessage(GetDlgItem(hwnd, IDC_AUTOSENSE4 ), WM_SETFONT, (WPARAM) hRussianFont, MAKELPARAM(FALSE, 0));
            DISCARD SendMessage(GetDlgItem(hwnd, IDC_AUTOSENSE5 ), WM_SETFONT, (WPARAM) hRussianFont, MAKELPARAM(FALSE, 0));
            DISCARD SendMessage(GetDlgItem(hwnd, IDC_AUTOSENSE6 ), WM_SETFONT, (WPARAM) hRussianFont, MAKELPARAM(FALSE, 0));
            DISCARD SendMessage(GetDlgItem(hwnd, IDC_AUTOSENSE7 ), WM_SETFONT, (WPARAM) hRussianFont, MAKELPARAM(FALSE, 0));
            DISCARD SendMessage(GetDlgItem(hwnd, IDC_AUTOSENSE8 ), WM_SETFONT, (WPARAM) hRussianFont, MAKELPARAM(FALSE, 0));
            DISCARD SendMessage(GetDlgItem(hwnd, IDC_AUTOSENSE9 ), WM_SETFONT, (WPARAM) hRussianFont, MAKELPARAM(FALSE, 0));

            DISCARD SendMessage(GetDlgItem(hwnd, IDL_1STBUTTON  ), WM_SETFONT, (WPARAM) hRussianFont, MAKELPARAM(FALSE, 0));
            DISCARD SendMessage(GetDlgItem(hwnd, IDL_2NDBUTTON  ), WM_SETFONT, (WPARAM) hRussianFont, MAKELPARAM(FALSE, 0));
            DISCARD SendMessage(GetDlgItem(hwnd, IDL_3RDBUTTON  ), WM_SETFONT, (WPARAM) hRussianFont, MAKELPARAM(FALSE, 0));
            DISCARD SendMessage(GetDlgItem(hwnd, IDL_4THBUTTON  ), WM_SETFONT, (WPARAM) hRussianFont, MAKELPARAM(FALSE, 0));
        }

        DISCARD SetWindowText( hwnd,                      LLL, MSG_HAIL_INFO             , "Game Information"    ));
        DISCARD SetDlgItemText(hwnd, IDC_AUTOSENSE_LEFT,  LLL, MSG_LEFT                  , "Left"                ));
        DISCARD SetDlgItemText(hwnd, IDC_AUTOSENSE_RIGHT, LLL, MSG_RIGHT                 , "Right"               ));
        DISCARD SetDlgItemText(hwnd, IDOK,                LLL, MSG_OK                    , "OK"                  ));

        DISCARD SetDlgItemText(hwnd, IDL_AUTOLABEL1 , LLL, MSG_INFO_NAME                 , "Game name:"          ));
        DISCARD SetDlgItemText(hwnd, IDL_AUTOLABEL2 , LLL, MSG_INFO_CREDITS              , "Credits, Year:"      ));
        DISCARD SetDlgItemText(hwnd, IDL_AUTOLABEL3 , LLL, MSG_INFO_REFERENCE            , "Reference:"          ));
        DISCARD SetDlgItemText(hwnd, IDL_AUTOLABEL4 , LLL, MSG_INFO_MACHINE              , "Machine:"            ));
        DISCARD SetDlgItemText(hwnd, IDL_AUTOLABEL5 , LLL, MSG_INFO_SIZE                 , "Size:"               ));
        DISCARD SetDlgItemText(hwnd, IDL_AUTOLABEL6 , LLL, MSG_INFO_COMPLANG             , "Language:"           ));
        DISCARD SetDlgItemText(hwnd, IDL_AUTOLABEL7 , LLL, MSG_INFO_ADDRESS              , "Start address:"      ));
        DISCARD SetDlgItemText(hwnd, IDL_AUTOLABEL8 , LLL, MSG_INFO_AUTOFIRE             , "Autofire rate:"      ));
        DISCARD SetDlgItemText(hwnd, IDL_AUTOLABEL9 , LLL, MSG_INFO_CONTROLLERS          , "Controllers:"        ));
        DISCARD SetDlgItemText(hwnd, IDL_AUTOLABEL10, LLL, MSG_INFO_DEMULTIPLEX          , "Demultiplex?"        ));
        DISCARD SetDlgItemText(hwnd, IDL_AUTOLABEL11, LLL, MSG_INFO_FLAGLINE             , "Flag line:"          ));

        DISCARD SetDlgItemText(hwnd, IDC_AUTOSENSE1 , autotext[ 0]);
        DISCARD SetDlgItemText(hwnd, IDC_AUTOSENSE2 , autotext[ 1]);
        DISCARD SetDlgItemText(hwnd, IDC_AUTOSENSE3 , autotext[ 2]);
        DISCARD SetDlgItemText(hwnd, IDC_AUTOSENSE4 , autotext[ 3]);
        DISCARD SetDlgItemText(hwnd, IDC_AUTOSENSE5 , autotext[ 4]);
        DISCARD SetDlgItemText(hwnd, IDC_AUTOSENSE6 , autotext[ 5]);
        DISCARD SetDlgItemText(hwnd, IDC_AUTOSENSE7 , autotext[ 6]);
        DISCARD SetDlgItemText(hwnd, IDC_AUTOSENSE8 , autotext[ 7]);
        DISCARD SetDlgItemText(hwnd, IDC_AUTOSENSE9 , autotext[ 8]);
        DISCARD SetDlgItemText(hwnd, IDC_AUTOSENSE10, autotext[ 9]);
        DISCARD SetDlgItemText(hwnd, IDC_AUTOSENSE11, autotext[10]);

        DISCARD SetDlgItemText(hwnd, IDL_1STBUTTON,   LLL, MSG_1STBUTTON                 , "1st button"          ));
        DISCARD SetDlgItemText(hwnd, IDL_2NDBUTTON,   LLL, MSG_2NDBUTTON                 , "2nd button"          ));
        DISCARD SetDlgItemText(hwnd, IDL_3RDBUTTON,   LLL, MSG_3RDBUTTON                 , "3rd button"          ));
        DISCARD SetDlgItemText(hwnd, IDL_4THBUTTON,   LLL, MSG_4THBUTTON                 , "4th button"          ));

        DISCARD SetDlgItemText(hwnd, IDC_PGMINFO,     pgmtext);

        DISCARD SetDlgItemText(hwnd, IDC_LT_2,        overlays[whichoverlay][0]);
        DISCARD SetDlgItemText(hwnd, IDC_LT_X1,       overlays[whichoverlay][2]);
        DISCARD SetDlgItemText(hwnd, IDC_LT_X2,       overlays[whichoverlay][3]);
        DISCARD SetDlgItemText(hwnd, IDC_LT_X3,       overlays[whichoverlay][4]);
        DISCARD SetDlgItemText(hwnd, IDC_LT_1,        overlays[whichoverlay][8]);
        DISCARD SetDlgItemText(hwnd, IDC_LT_X4,       overlays[whichoverlay][9]);
        DISCARD SetDlgItemText(hwnd, IDC_LT_3,        overlays[whichoverlay][10]);
        DISCARD SetDlgItemText(hwnd, IDC_LT_4,        overlays[whichoverlay][14]);
        DISCARD SetDlgItemText(hwnd, IDC_LT_5,        overlays[whichoverlay][15]);
        DISCARD SetDlgItemText(hwnd, IDC_LT_6,        overlays[whichoverlay][16]);
        DISCARD SetDlgItemText(hwnd, IDC_LT_7,        overlays[whichoverlay][20]);
        DISCARD SetDlgItemText(hwnd, IDC_LT_8,        overlays[whichoverlay][21]);
        DISCARD SetDlgItemText(hwnd, IDC_LT_9,        overlays[whichoverlay][22]);
        DISCARD SetDlgItemText(hwnd, IDC_LT_CL,       overlays[whichoverlay][26]);
        DISCARD SetDlgItemText(hwnd, IDC_LT_0,        overlays[whichoverlay][27]);
        DISCARD SetDlgItemText(hwnd, IDC_LT_EN,       overlays[whichoverlay][28]);

        DISCARD SetDlgItemText(hwnd, IDC_RT_2,        overlays[whichoverlay][1]);
        DISCARD SetDlgItemText(hwnd, IDC_RT_X1,       overlays[whichoverlay][5]);
        DISCARD SetDlgItemText(hwnd, IDC_RT_X2,       overlays[whichoverlay][6]);
        DISCARD SetDlgItemText(hwnd, IDC_RT_X3,       overlays[whichoverlay][7]);
        DISCARD SetDlgItemText(hwnd, IDC_RT_1,        overlays[whichoverlay][11]);
        DISCARD SetDlgItemText(hwnd, IDC_RT_X4,       overlays[whichoverlay][12]);
        DISCARD SetDlgItemText(hwnd, IDC_RT_3,        overlays[whichoverlay][13]);
        DISCARD SetDlgItemText(hwnd, IDC_RT_4,        overlays[whichoverlay][17]);
        DISCARD SetDlgItemText(hwnd, IDC_RT_5,        overlays[whichoverlay][18]);
        DISCARD SetDlgItemText(hwnd, IDC_RT_6,        overlays[whichoverlay][19]);
        DISCARD SetDlgItemText(hwnd, IDC_RT_7,        overlays[whichoverlay][23]);
        DISCARD SetDlgItemText(hwnd, IDC_RT_8,        overlays[whichoverlay][24]);
        DISCARD SetDlgItemText(hwnd, IDC_RT_9,        overlays[whichoverlay][25]);
        DISCARD SetDlgItemText(hwnd, IDC_RT_CL,       overlays[whichoverlay][29]);
        DISCARD SetDlgItemText(hwnd, IDC_RT_0,        overlays[whichoverlay][30]);
        DISCARD SetDlgItemText(hwnd, IDC_RT_EN,       overlays[whichoverlay][31]);

        charset = CHARSET_DOS;

        hBrush[0] = CreateSolidBrush(EMUPEN_RED);    // red
        hBrush[1] = CreateSolidBrush(EMUPEN_BLUE);   // blue
        hBrush[2] = CreateSolidBrush(EMUPEN_GREEN);  // green
        hBrush[3] = CreateSolidBrush(EMUPEN_YELLOW); // yellow

        // assert(machine != CHAOS);
        // assert(machine != DOLPHIN);
        // assert(machines[machine].icon);
        if (machine == ARCADIA && xmas)
        {   hicon = LoadIcon(InstancePtr, MAKEINTRESOURCE(IDI_XMAS                  ));
        } else
        {   hicon = LoadIcon(InstancePtr, MAKEINTRESOURCE(hostmachines[machine].icon));
        }
        DISCARD SendMessage(GetDlgItem(hwnd, IDL_GLYPH), STM_SETICON, (WPARAM) hicon, (LPARAM) 0);

        if (machine != ARCADIA)
        {   EnableWindow(GetDlgItem(hwnd, IDC_LT_X1), FALSE);
            EnableWindow(GetDlgItem(hwnd, IDC_LT_X2), FALSE);
            EnableWindow(GetDlgItem(hwnd, IDC_LT_X3), FALSE);
            EnableWindow(GetDlgItem(hwnd, IDC_LT_X4), FALSE);
            EnableWindow(GetDlgItem(hwnd, IDC_RT_X1), FALSE);
            EnableWindow(GetDlgItem(hwnd, IDC_RT_X2), FALSE);
            EnableWindow(GetDlgItem(hwnd, IDC_RT_X3), FALSE);
            EnableWindow(GetDlgItem(hwnd, IDC_RT_X4), FALSE);
        }
        if
        (   machine == PIPBUG
         || machine == CD2650
         || machine == ASTROWARS
         || machine == GALAXIA
         || machine == MALZAK
        )
        {   EnableWindow(GetDlgItem(hwnd, IDC_LT_1),  FALSE);
            EnableWindow(GetDlgItem(hwnd, IDC_LT_3),  FALSE);
            EnableWindow(GetDlgItem(hwnd, IDC_LT_4),  FALSE);
            EnableWindow(GetDlgItem(hwnd, IDC_LT_5),  FALSE);
            EnableWindow(GetDlgItem(hwnd, IDC_LT_6),  FALSE);
            EnableWindow(GetDlgItem(hwnd, IDC_LT_7),  FALSE);
            EnableWindow(GetDlgItem(hwnd, IDC_LT_8),  FALSE);
            EnableWindow(GetDlgItem(hwnd, IDC_LT_9),  FALSE);
            EnableWindow(GetDlgItem(hwnd, IDC_LT_CL), FALSE);
            EnableWindow(GetDlgItem(hwnd, IDC_LT_0),  FALSE);
            EnableWindow(GetDlgItem(hwnd, IDC_LT_EN), FALSE);
            EnableWindow(GetDlgItem(hwnd, IDC_RT_1),  FALSE);
            EnableWindow(GetDlgItem(hwnd, IDC_RT_3),  FALSE);
            EnableWindow(GetDlgItem(hwnd, IDC_RT_4),  FALSE);
            EnableWindow(GetDlgItem(hwnd, IDC_RT_5),  FALSE);
            EnableWindow(GetDlgItem(hwnd, IDC_RT_6),  FALSE);
            EnableWindow(GetDlgItem(hwnd, IDC_RT_7),  FALSE);
            EnableWindow(GetDlgItem(hwnd, IDC_RT_8),  FALSE);
            EnableWindow(GetDlgItem(hwnd, IDC_RT_9),  FALSE);
            EnableWindow(GetDlgItem(hwnd, IDC_RT_CL), FALSE);
            EnableWindow(GetDlgItem(hwnd, IDC_RT_0),  FALSE);
            EnableWindow(GetDlgItem(hwnd, IDC_RT_EN), FALSE);
        }
        if (machine == PIPBUG || machine == CD2650)
        {   EnableWindow(GetDlgItem(hwnd, IDC_LT_2),  FALSE);
        }
        if (machine == PIPBUG || machine == CD2650 || machine == MALZAK)
        {   EnableWindow(GetDlgItem(hwnd, IDC_RT_2),  FALSE);
        }

        // DISCARD SetFocus(GetDlgItem(hwnd, IDOK));
        return FALSE; // must be FALSE so that our SetFocus()sing is respected
    case WM_CTLCOLORSTATIC: // no need for acase
        if
        (   machine == ARCADIA
         || machine == INTERTON
         || machine == ELEKTOR
         || machine == ASTROWARS
         || machine == GALAXIA
         || machine == MALZAK
        )
        {   gid = GetWindowLong((HWND) lParam, GWL_ID);

            if (    gid == IDL_GAMEINFO_1ST || gid == key_to_gid[0][key1] || (machine != MALZAK && gid == key_to_gid[1][key1]))
            {   SetBkColor((HDC) wParam, EMUPEN_RED);
                return (LRESULT) hBrush[0];
            } elif (gid == IDL_GAMEINFO_2ND || gid == key_to_gid[0][key2] || (machine != MALZAK && gid == key_to_gid[1][key2]))
            {   SetBkColor((HDC) wParam, EMUPEN_BLUE);
                return (LRESULT) hBrush[1];
            } elif (gid == IDL_GAMEINFO_3RD || gid == key_to_gid[0][key3] || (machine != MALZAK && gid == key_to_gid[1][key3]))
            {   SetBkColor((HDC) wParam, EMUPEN_GREEN);
                return (LRESULT) hBrush[2];
            } elif (gid == IDL_GAMEINFO_4TH || gid == key_to_gid[0][key4] || (machine != MALZAK && gid == key_to_gid[1][key4]))
            {   SetBkColor((HDC) wParam, EMUPEN_YELLOW);
                return (LRESULT) hBrush[3];
        }   }
        return FALSE;
    case WM_CLOSE: // no need for acase
        clearkybd();
        DestroyWindow(GameInfoWindowPtr);
        GameInfoWindowPtr = NULL;
        updatemenu(MENUITEM_GAMEINFO);

        return TRUE;
    case WM_COMMAND: // no need for acase
        if
        (   LOWORD(wParam) == IDOK
         || LOWORD(wParam) == IDCANCEL
        )
        {   clearkybd();
            DestroyWindow(GameInfoWindowPtr);
            GameInfoWindowPtr = NULL;
            updatemenu(MENUITEM_GAMEINFO);
        }
        return TRUE;
    case WM_DESTROY: // no need for acase
        DeleteObject(hicon);
        DeleteObject(hBrush[0]);
        DeleteObject(hBrush[1]);
        DeleteObject(hBrush[2]);
        DeleteObject(hBrush[3]);
        GameInfoWindowPtr = NULL;
        return FALSE;
    case WM_PAINT: // no need for acase
        DISCARD BeginPaint(hwnd, &localps);
        DISCARD EndPaint(hwnd, &localps);
        return FALSE;
    case WM_KEYDOWN: // no need for acase
        return TRUE;
    default: // no need for adefault
        return FALSE;
        // using return DefWindowProc(hwnd, Message, wParam, lParam); means that we would
        // have to manually reactivate the main window after closing this requester.
    }

    return FALSE;
}

EXPORT int asl
(   STRPTR hail,
    STRPTR pattern,
    FLAG   save,
    STRPTR startdir,
    STRPTR startfile,
    STRPTR passedfn
)
{   OPENFILENAME ofn;

    DISCARD GetCurrentDirectory(MAX_PATH + 1, olddir);
    DISCARD SetCurrentDirectory(ProgDir);

    strcpy(passedfn, startfile);

/* T1;
zprintf("startdir  is %s!\n", startdir);
zprintf("startfile is %s!\n", startfile);
zprintf("passedfn  is %s!\n", passedfn);
T2; */

    ZeroMemory(&ofn, sizeof(ofn));
    ofn.lStructSize     = sizeof(ofn);
    ofn.hwndOwner       = MainWindowPtr;
    ofn.lpstrTitle      = hail;
    ofn.lpstrFilter     = pattern;
    ofn.lpstrInitialDir = startdir;
    ofn.lpstrFile       = passedfn;
    ofn.nMaxFile        = MAX_PATH;
    if (save)
    {   ofn.Flags       = OFN_EXPLORER | OFN_PATHMUSTEXIST | OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT;
    } else
    {   ofn.Flags       = OFN_EXPLORER | OFN_PATHMUSTEXIST | OFN_HIDEREADONLY;
    }

    sound_off(FALSE);
    if (!showpointer)
    {   showingpointer = TRUE;
        ShowCursor(TRUE);
    }
    clearkybd();
    opening = TRUE;
    if
    (   ( save && GetSaveFileName(&ofn))
     || (!save && GetOpenFileName(&ofn))
    )
    {   opening = FALSE;
        if (!showpointer)
        {   showingpointer = FALSE;
            ShowCursor(FALSE);
        }
        sound_on();
        DISCARD SetCurrentDirectory(olddir);
        return EXIT_SUCCESS;
    } else
    {   opening = FALSE;
        if (!showpointer)
        {   showingpointer = FALSE;
            ShowCursor(FALSE);
        }
        sound_on();
        DISCARD SetCurrentDirectory(olddir);
        return EXIT_FAILURE;
}   }

EXPORT void view_monitor(void)
{   TRANSIENT       int   i;
    PERSIST         HDC   MonitorRastPtr; // PERSISTent for speed
    PERSIST   const UWORD ibmgad[MONITORGADS] = {
    ID_P2PADDLE,      //   0
    ID_PITCH,         //   1
    ID_SIZES,         //   2
    ID_SCORECTRL,     //   3
    ID_SCORELT,       //   4
    ID_SCORERT,       //   5
    ID_BGCOLOUR,      //   6
    ID_BGCOLLIDE,     //   7
    ID_SPRITECOLLIDE, //   8
    ID_SPR01COLOURS,  //   9
    ID_SPR23COLOURS,  //  10
    ID_P1PADDLE,      //  11
    ID_P1LEFTKEYS,    //  12
    ID_P1MIDDLEKEYS,  //  13
    ID_P1RIGHTKEYS,   //  14
    ID_CONSOLE,       //  15
    ID_P2LEFTKEYS,    //  16
    ID_P2MIDDLEKEYS,  //  17
    ID_P2RIGHTKEYS,   //  18
    ID_NOISE,         //  19
    ID_AMPLITUDEA1,   //  20
    ID_AMPLITUDEB1,   //  21
    ID_AMPLITUDEC1,   //  22
    ID_PITCHD1,       //  23
    ID_ENABLE1,       //  24
    ID_SHAPE1,        //  25
    ID_PORTA1,        //  26
    ID_PORTB1,        //  27
    ID_AMPLITUDEA2,   //  28
    ID_AMPLITUDEB2,   //  29
    ID_AMPLITUDEC2,   //  30
    ID_PITCHD2,       //  31
    ID_ENABLE2,       //  32
    ID_SHAPE2,        //  33
    ID_PORTA2,        //  34
    ID_PORTB2,        //  35
    ID_1F0E,          //  36
    ID_1F0F,          //  37
    ID_1F1E,          //  38
    ID_1F1F,          //  39
    ID_1F4E,          //  40
    ID_1F4F,          //  41
    ID_1F50,          //  42
    ID_1F51,          //  43
    ID_1F52,          //  44
    ID_1F53,          //  45
    ID_1F54,          //  46
    ID_1F55,          //  47
    ID_1F56,          //  48
    ID_1F57,          //  49
    ID_1F58,          //  50
    ID_1F59,          //  51
    ID_1F5A,          //  52
    ID_1F5B,          //  53
    ID_1F5C,          //  54
    ID_1F5D,          //  55
    ID_1F5E,          //  56
    ID_1F5F,          //  57
    ID_1F60,          //  58
    ID_1F61,          //  59
    ID_1F62,          //  60
    ID_1F63,          //  61
    ID_1F64,          //  62
    ID_1F65,          //  63
    ID_1F66,          //  64
    ID_1F67,          //  65
    ID_1F68,          //  66
    ID_1F69,          //  67
    ID_1F6A,          //  68
    ID_1F6B,          //  69
    ID_1F6C,          //  70
    ID_1F6D,          //  71
    ID_1FAD,          //  72
    ID_CONSOLE,       //  73
    ID_RESOLUTION,    //  74
    ID_BGCOLLIDE,     //  75
    ID_P1PADDLE,      //  76
    ID_P2PADDLE,      //  77
    ID_PITCH,         //  78
    ID_BGCOLOUR,      //  79
    ID_SPRITECOLLIDE, //  80
    ID_P1LEFTKEYS,    //  81
    ID_P2LEFTKEYS,    //  82
    ID_VOLUME,        //  83
    ID_VSCROLL,       //  84
    ID_SPRITES01CTRL, //  85
    ID_P1MIDDLEKEYS,  //  86
    ID_P2MIDDLEKEYS,  //  87
    ID_CHARLINE,      //  88
    ID_SPRITES23CTRL, //  89
    ID_P1RIGHTKEYS,   //  90
    ID_P2RIGHTKEYS,   //  91
    ID_P1PALLADIUM,   //  92
    ID_P2PALLADIUM,   //  93
    ID_18D0,          //  94
    ID_18D1,          //  95
    ID_18D2,          //  96
    ID_18D3,          //  97
    ID_18D4,          //  98
    ID_18D5,          //  99
    ID_18D6,          // 100
    ID_18D7,          // 101
    ID_18D8,          // 102
    ID_18D9,          // 103
    ID_18DA,          // 104
    ID_18DB,          // 105
    ID_18DC,          // 106
    ID_18DD,          // 107
    ID_18DE,          // 108
    ID_18DF,          // 109
    ID_18E0,          // 110
    ID_18E1,          // 111
    ID_18E2,          // 112
    ID_18E3,          // 113
    ID_18E4,          // 114
    ID_18E5,          // 115
    ID_18E6,          // 116
    ID_18E7,          // 117
    ID_18E8,          // 118
    ID_18E9,          // 119
    ID_18EA,          // 120
    ID_18EB,          // 121
    ID_18EC,          // 122
    ID_18ED,          // 123
    ID_18EE,          // 124
    ID_18EF,          // 125
    ID_18F8,          // 126
    ID_18F9,          // 127
    ID_18FA,          // 128
    ID_18FB,          // 129
    ID_1AD0,          // 130
    ID_1AD1,          // 131
    ID_1AD2,          // 132
    ID_1AD3,          // 133
    ID_1AD4,          // 134
    ID_1AD5,          // 135
    ID_1AD6,          // 136
    ID_1AD7,          // 137
    ID_1AD8,          // 138
    ID_1AD9,          // 139
    ID_1ADA,          // 140
    ID_1ADB,          // 141
    ID_1ADC,          // 142
    ID_1ADD,          // 143
    ID_1ADE,          // 144
    ID_1ADF,          // 145
    ID_1AE0,          // 146
    ID_1AE1,          // 147
    ID_1AE2,          // 148
    ID_1AE3,          // 149
    ID_1AE4,          // 150
    ID_1AE5,          // 151
    ID_1AE6,          // 152
    ID_1AE7,          // 153
    ID_1AE8,          // 154
    ID_1AE9,          // 155
    ID_1AEA,          // 156
    ID_1AEB,          // 157
    ID_1AEC,          // 158
    ID_1AED,          // 159
    ID_1AEE,          // 160
    ID_1AEF,          // 161
    ID_1AF0,          // 162
    ID_1AF1,          // 163
    ID_1AF2,          // 164
    ID_1AF3,          // 165
    ID_1AF4,          // 166
    ID_1AF5,          // 167
    ID_1AF6,          // 168
    ID_1AF7,          // 169
    ID_1AF8,          // 170
    ID_1AF9,          // 171
    ID_1AFA,          // 172
    ID_1AFB,          // 173
    ID_1AFC,          // 174
    ID_1AFD,          // 175
    ID_1AFE,          // 176
    ID_1AFF,          // 177
    ID_PITCH2,         // 178
    ID_SIZES2,         // 179
    ID_SCORECTRL2,     // 180
    ID_SCORELT2,       // 181
    ID_SCORERT2,       // 182
    ID_BGCOLOUR2,      // 183
    ID_BGCOLLIDE2,     // 184
    ID_SPRITECOLLIDE2, // 185
    ID_SPR45COLOURS,   // 186
    ID_SPR67COLOURS,   // 187
    ID_P3PADDLE,       // 188
    ID_P4PADDLE,       // 189
    ID_PITCH3,         // 190
    ID_SIZES3,         // 191
    ID_SCORECTRL3,     // 192
    ID_SCORELT3,       // 193
    ID_SCORERT3,       // 194
    ID_BGCOLOUR3,      // 195
    ID_BGCOLLIDE3,     // 196
    ID_SPRITECOLLIDE3, // 197
    ID_SPR89COLOURS,   // 198
    ID_SPR1011COLOURS, // 199
    ID_P5PADDLE,       // 200
    ID_P6PADDLE        // 201
};

    opening = TRUE;
    switch (machine)
    {
    case ARCADIA:
        MonitorWindowPtr = CreateDialog
        (   InstancePtr,                   // handle to application instance
            MAKEINTRESOURCE(IDD_A_MONITOR), // identifies dialog box template name
            MainWindowPtr,
            MonitorDlgProc
        );
    acase INTERTON:
        MonitorWindowPtr = CreateDialog
        (   InstancePtr,                   // handle to application instance
            MAKEINTRESOURCE(IDD_I_MONITOR), // identifies dialog box template name
            MainWindowPtr,
            MonitorDlgProc
        );
    acase ELEKTOR:
        if (memmap == MEMMAP_E)
        {   MonitorWindowPtr = CreateDialog
            (   InstancePtr,                      // handle to application instance
                MAKEINTRESOURCE(IDD_E_E_MONITOR), // identifies dialog box template name
                MainWindowPtr,
                MonitorDlgProc
            );
        } else
        {   // assert(memmap == MEMMAP_F);
            MonitorWindowPtr = CreateDialog
            (   InstancePtr,                      // handle to application instance
                MAKEINTRESOURCE(IDD_E_F_MONITOR), // identifies dialog box template name
                MainWindowPtr,
                MonitorDlgProc
            );
        }
    acase PIPBUG:
        MonitorWindowPtr = CreateDialog
        (   InstancePtr,                   // handle to application instance
            MAKEINTRESOURCE(IDD_P_MONITOR), // identifies dialog box template name
            MainWindowPtr,
            MonitorDlgProc
        );
    acase INSTRUCTOR:
        MonitorWindowPtr = CreateDialog
        (   InstancePtr,                   // handle to application instance
            MAKEINTRESOURCE(IDD_S_MONITOR), // identifies dialog box template name
            MainWindowPtr,
            MonitorDlgProc
        );
    acase CD2650:
        MonitorWindowPtr = CreateDialog
        (   InstancePtr,                    // handle to application instance
            MAKEINTRESOURCE(IDD_C_MONITOR), // identifies dialog box template name
            MainWindowPtr,
            MonitorDlgProc
        );
    acase ASTROWARS:
        MonitorWindowPtr = CreateDialog
        (   InstancePtr,                      // handle to application instance
            MAKEINTRESOURCE(IDD_G_X_MONITOR), // identifies dialog box template name
            MainWindowPtr,
            MonitorDlgProc
        );
    acase GALAXIA:
        MonitorWindowPtr = CreateDialog
        (   InstancePtr,                      // handle to application instance
            MAKEINTRESOURCE(IDD_G_W_MONITOR), // identifies dialog box template name
            MainWindowPtr,
            MonitorDlgProc
        );
    acase MALZAK:
        MonitorWindowPtr = CreateDialog
        (   InstancePtr,                   // handle to application instance
            MAKEINTRESOURCE(IDD_M_MONITOR), // identifies dialog box template name
            MainWindowPtr,
            MonitorDlgProc
        );
    acase CHAOS:
        MonitorWindowPtr = CreateDialog
        (   InstancePtr,                    // handle to application instance
            MAKEINTRESOURCE(IDD_H_MONITOR), // identifies dialog box template name
            MainWindowPtr,
            MonitorDlgProc
        );
    acase DOLPHIN:
        MonitorWindowPtr = CreateDialog
        (   InstancePtr,                    // handle to application instance
            MAKEINTRESOURCE(IDD_D_MONITOR), // identifies dialog box template name
            MainWindowPtr,
            MonitorDlgProc
        );
    acase PHUNSY:
        MonitorWindowPtr = CreateDialog
        (   InstancePtr,                    // handle to application instance
            MAKEINTRESOURCE(IDD_PHUNSY_MONITOR), // identifies dialog box template name
            MainWindowPtr,
            MonitorDlgProc
        );
    }   
    opening = FALSE;

    // assert(MonitorWindowPtr);

    RGad[0]      = GetDlgItem(MonitorWindowPtr, ID_R0);
    RGad[1]      = GetDlgItem(MonitorWindowPtr, ID_R1);
    RGad[2]      = GetDlgItem(MonitorWindowPtr, ID_R2);
    RGad[3]      = GetDlgItem(MonitorWindowPtr, ID_R3);
    RGad[4]      = GetDlgItem(MonitorWindowPtr, ID_R4);
    RGad[5]      = GetDlgItem(MonitorWindowPtr, ID_R5);
    RGad[6]      = GetDlgItem(MonitorWindowPtr, ID_R6);
    CCGad        = GetDlgItem(MonitorWindowPtr, ID_CC);
    AddrBusGad   = GetDlgItem(MonitorWindowPtr, ID_ADDRBUS);
    DataBusGad   = GetDlgItem(MonitorWindowPtr, ID_DATABUS);
    OneGad[0]    = GetDlgItem(MonitorWindowPtr, ID_SENSE);
    OneGad[1]    = GetDlgItem(MonitorWindowPtr, ID_FLAG);
    OneGad[2]    = GetDlgItem(MonitorWindowPtr, ID_INTERRUPT);
    OneGad[3]    = GetDlgItem(MonitorWindowPtr, ID_SP);
    OneGad[4]    = GetDlgItem(MonitorWindowPtr, ID_IDC);
    OneGad[5]    = GetDlgItem(MonitorWindowPtr, ID_RS);
    OneGad[6]    = GetDlgItem(MonitorWindowPtr, ID_WC);
    OneGad[7]    = GetDlgItem(MonitorWindowPtr, ID_OVF);
    OneGad[8]    = GetDlgItem(MonitorWindowPtr, ID_COM);
    OneGad[9]    = GetDlgItem(MonitorWindowPtr, ID_C);
    RASGad[0]    = GetDlgItem(MonitorWindowPtr, ID_RAS0);
    RASGad[1]    = GetDlgItem(MonitorWindowPtr, ID_RAS1);
    RASGad[2]    = GetDlgItem(MonitorWindowPtr, ID_RAS2);
    RASGad[3]    = GetDlgItem(MonitorWindowPtr, ID_RAS3);
    RASGad[4]    = GetDlgItem(MonitorWindowPtr, ID_RAS4);
    RASGad[5]    = GetDlgItem(MonitorWindowPtr, ID_RAS5);
    RASGad[6]    = GetDlgItem(MonitorWindowPtr, ID_RAS6);
    RASGad[7]    = GetDlgItem(MonitorWindowPtr, ID_RAS7);
    IARGad       = GetDlgItem(MonitorWindowPtr, ID_IAR);
    ClockGad     = GetDlgItem(MonitorWindowPtr, ID_CLOCK);
    FrameGad     = GetDlgItem(MonitorWindowPtr, ID_FRAME);
    TimeGad      = GetDlgItem(MonitorWindowPtr, ID_TIME);

    switch (machine)
    {
    case ARCADIA:
    case INTERTON:
    case ELEKTOR:
    case ASTROWARS:
    case GALAXIA:
    case MALZAK:
        RasterGad         = GetDlgItem(MonitorWindowPtr, ID_RASTER);

        SPRITEnAXYGad[0]  = GetDlgItem(MonitorWindowPtr, ID_SPRITE0XY);
        SPRITEnAXYGad[1]  = GetDlgItem(MonitorWindowPtr, ID_SPRITE1XY);
        SPRITEnAXYGad[2]  = GetDlgItem(MonitorWindowPtr, ID_SPRITE2XY);
        SPRITEnAXYGad[3]  = GetDlgItem(MonitorWindowPtr, ID_SPRITE3XY);

        if (machine == ARCADIA)
        {   for (i = 73; i < MONITORGADS; i++)
            {   monitorgad[i] = GetDlgItem(MonitorWindowPtr, ibmgad[i]);
        }   }
        else
        {   SPRITEnBXYGad[0]  = GetDlgItem(MonitorWindowPtr, ID_SPRITE0XY2);
            SPRITEnBXYGad[1]  = GetDlgItem(MonitorWindowPtr, ID_SPRITE1XY2);
            SPRITEnBXYGad[2]  = GetDlgItem(MonitorWindowPtr, ID_SPRITE2XY2);
            SPRITEnBXYGad[3]  = GetDlgItem(MonitorWindowPtr, ID_SPRITE3XY2);
            if (machine == MALZAK || machine == GALAXIA)
            {   SPRITEnAXYGad[4] = GetDlgItem(MonitorWindowPtr, ID_SPRITE4XY);
                SPRITEnAXYGad[5] = GetDlgItem(MonitorWindowPtr, ID_SPRITE5XY);
                SPRITEnAXYGad[6] = GetDlgItem(MonitorWindowPtr, ID_SPRITE6XY);
                SPRITEnAXYGad[7] = GetDlgItem(MonitorWindowPtr, ID_SPRITE7XY);
                SPRITEnBXYGad[4] = GetDlgItem(MonitorWindowPtr, ID_SPRITE4XY2);
                SPRITEnBXYGad[5] = GetDlgItem(MonitorWindowPtr, ID_SPRITE5XY2);
                SPRITEnBXYGad[6] = GetDlgItem(MonitorWindowPtr, ID_SPRITE6XY2);
                SPRITEnBXYGad[7] = GetDlgItem(MonitorWindowPtr, ID_SPRITE7XY2);
                if (machine == GALAXIA)
                {   SPRITEnAXYGad[8]  = GetDlgItem(MonitorWindowPtr, ID_SPRITE8XY);
                    SPRITEnAXYGad[9]  = GetDlgItem(MonitorWindowPtr, ID_SPRITE9XY);
                    SPRITEnAXYGad[10] = GetDlgItem(MonitorWindowPtr, ID_SPRITE10XY);
                    SPRITEnAXYGad[11] = GetDlgItem(MonitorWindowPtr, ID_SPRITE11XY);
                    SPRITEnBXYGad[8]  = GetDlgItem(MonitorWindowPtr, ID_SPRITE8XY2);
                    SPRITEnBXYGad[9]  = GetDlgItem(MonitorWindowPtr, ID_SPRITE9XY2);
                    SPRITEnBXYGad[10] = GetDlgItem(MonitorWindowPtr, ID_SPRITE10XY2);
                    SPRITEnBXYGad[11] = GetDlgItem(MonitorWindowPtr, ID_SPRITE11XY2);
            }   }

            if (machine == INTERTON)
            {   for (i = 0; i <= 19; i++)
                {   monitorgad[i] = GetDlgItem(MonitorWindowPtr, ibmgad[i]);
                }
                for (i = 36; i <= 72; i++)
                {   monitorgad[i] = GetDlgItem(MonitorWindowPtr, ibmgad[i]);
            }   }
            elif (machine == ELEKTOR)
            {   if (memmap == MEMMAP_E)
                {   for (i = 0; i <= 18; i++)
                    {   monitorgad[i] = GetDlgItem(MonitorWindowPtr, ibmgad[i]);
                }   }
                else
                {   // assert(memmap == MEMMAP_F);
                    for (i = 0; i <= 35; i++)
                    {   monitorgad[i] = GetDlgItem(MonitorWindowPtr, ibmgad[i]);
                    }

                    PITCHAGad[0]     = GetDlgItem(MonitorWindowPtr, ID_PITCHA1);
                    PITCHBGad[0]     = GetDlgItem(MonitorWindowPtr, ID_PITCHB1);
                    PITCHCGad[0]     = GetDlgItem(MonitorWindowPtr, ID_PITCHC1);
                    PERIODGad[0]     = GetDlgItem(MonitorWindowPtr, ID_PERIOD1);

                    PITCHAGad[1]     = GetDlgItem(MonitorWindowPtr, ID_PITCHA2);
                    PITCHBGad[1]     = GetDlgItem(MonitorWindowPtr, ID_PITCHB2);
                    PITCHCGad[1]     = GetDlgItem(MonitorWindowPtr, ID_PITCHC2);
                    PERIODGad[1]     = GetDlgItem(MonitorWindowPtr, ID_PERIOD2);
            }   }
            else
            {   // assert(machine == ASTROWARS || machine == GALAXIA || machine == MALZAK);
                for (i = 0; i <= 11; i++)
                {   monitorgad[i] = GetDlgItem(MonitorWindowPtr, ibmgad[i]);
                }
                monitorgad[15] = GetDlgItem(MonitorWindowPtr, ibmgad[15]);
                if (machine == MALZAK || machine == GALAXIA)
                {   for (i = 178; i <= 189; i++)
                    {   monitorgad[i] = GetDlgItem(MonitorWindowPtr, ibmgad[i]);
                    }
                    if (machine == GALAXIA)
                    {   for (i = 190; i <= 201; i++)
                        {   monitorgad[i] = GetDlgItem(MonitorWindowPtr, ibmgad[i]);
    }   }   }   }   }   }

    if (machine == ARCADIA || machine == INTERTON || machine == ELEKTOR)
    {   ignorepaint = FALSE;
        DISCARD GetWindowRect(GetDlgItem(MonitorWindowPtr, IDC_AXES), &axesrect);
        axesrect.right  -= axesrect.left;
        axesrect.bottom -= axesrect.top;
        sparex          =  axesrect.right  - 64;
        sparey          =  axesrect.bottom - 64;
        axesrect.left   =  (sparex / 2) - 1;
        axesrect.top    =  (sparey / 2) - 1;
        axesrect.right  -= (sparex / 2) + 1;
        axesrect.bottom -= (sparey / 2) + 1;
        InvalidateRect(MonitorWindowPtr, NULL, FALSE);
    }

    DISCARD SetActiveWindow(MainWindowPtr);

    updatemenu(MENUITEM_VIEWMONITOR);
    update_monitor(TRUE);
}

EXPORT void view_controls(void)
{   PERSIST const int controlsdlg[MACHINES] = {
IDD_A_CONTROLS,       // ARCADIA
IDD_I_CONTROLS,       // INTERTON
IDD_E_CONTROLS,       // ELEKTOR
0,                    // PIPBUG
IDD_S_CONTROLS,       // INSTRUCTOR
0,                    // CD2650
IDD_G_X_CONTROLS,     // ASTROWARS
IDD_G_W_CONTROLS,     // GALAXIA
IDD_M_CONTROLS,       // MALZAK
0,                    // CHAOS
IDD_DOLPHIN_CONTROLS, // DOLPHIN
0                     // PHUNSY
};

    if (!controlsdlg[machine]) // eg. PIPBUG, CD2650, CHAOS, DOLPHIN
    {   return; // important!
    }

    view_controls_engine();

    opening = TRUE;
    ControlsWindowPtr = CreateDialog
    (   InstancePtr,
        MAKEINTRESOURCE(controlsdlg[machine]),
        MainWindowPtr,
        ControlsDlgProc
    );
    DISCARD SetActiveWindow(MainWindowPtr);
    opening = FALSE;

    updatemenu(MENUITEM_CONTROLS);

    if (machine == INSTRUCTOR)
    {   oldflag =
        oldglow = 0;
        oldrun  = 0x40;

        redrawscreen();
        s_updatecontrols();
}   }

BOOL CALLBACK SensitivityDlgProc(HWND hwnd, UINT Message, WPARAM wParam, LPARAM lParam)
{   switch (Message)
    {
    case WM_INITDIALOG:
        charset = CHARSET_WIN;
        DISCARD SetWindowText( hwnd,                 LLL, MSG_HAIL_SENSITIVITY, "Sensitivity"));

        if (language == LANGUAGE_RUS)
        {   DISCARD SendMessage(GetDlgItem(hwnd, IDOK          ), WM_SETFONT, (WPARAM) hRussianFont, MAKELPARAM(FALSE, 0));
            DISCARD SendMessage(GetDlgItem(hwnd, IDC_LABEL_LOW ), WM_SETFONT, (WPARAM) hRussianFont, MAKELPARAM(FALSE, 0));
            DISCARD SendMessage(GetDlgItem(hwnd, IDC_LABEL_HIGH), WM_SETFONT, (WPARAM) hRussianFont, MAKELPARAM(FALSE, 0));
        }
        DISCARD SetDlgItemText(hwnd, IDOK,           LLL, MSG_OK2             , "&OK"        ));
        DISCARD SetDlgItemText(hwnd, IDC_LABEL_LOW,  LLL, MSG_LOW             , "Low"        ));
        DISCARD SetDlgItemText(hwnd, IDC_LABEL_HIGH, LLL, MSG_HIGH            , "High"       ));
        charset = CHARSET_DOS;

        DISCARD SendMessage
        (   GetDlgItem(hwnd, IDC_SENSITIVITY),
            TBM_SETRANGE,
            FALSE,
            MAKELONG(SENSITIVITY_MIN, SENSITIVITY_MAX)
        );
        DISCARD SendMessage
        (   GetDlgItem(hwnd, IDC_SENSITIVITY),
            TBM_SETPOS,
            TRUE,
            sensitivity
        );
        return TRUE;
    case WM_CLOSE: // no need for acase
        sensitivity = SendMessage
        (   GetDlgItem(hwnd, IDC_SENSITIVITY),
            TBM_GETPOS,
            0,
            0
        );

        clearkybd();
        DISCARD EndDialog(hwnd, 0);

        return TRUE;
    case WM_COMMAND: // no need for acase
        if (LOWORD (wParam) == IDOK)
        {   sensitivity = SendMessage
            (   GetDlgItem(hwnd, IDC_SENSITIVITY),
                TBM_GETPOS,
                0,
                0
            );

            clearkybd();
            DISCARD EndDialog(hwnd, 0);

            return TRUE;
        } // implied else
        if (LOWORD (wParam) == IDCANCEL)
        {   clearkybd();
            DISCARD EndDialog(hwnd, 0);

            return TRUE;
        } // implied else
        return FALSE;
    default: // no need for adefault
        return FALSE;
}   }

BOOL CALLBACK VolumeDlgProc(HWND hwnd, UINT Message, WPARAM wParam, LPARAM lParam)
{   switch (Message)
    {
    case WM_INITDIALOG:
        charset = CHARSET_WIN;
        DISCARD SetWindowText( hwnd,                 LLL, MSG_HAIL_VOLUME, "Volume"));

        if (language == LANGUAGE_RUS)
        {   DISCARD SendMessage(GetDlgItem(hwnd, IDC_LABEL_LOW ), WM_SETFONT, (WPARAM) hRussianFont, MAKELPARAM(FALSE, 0));
            DISCARD SendMessage(GetDlgItem(hwnd, IDC_LABEL_HIGH), WM_SETFONT, (WPARAM) hRussianFont, MAKELPARAM(FALSE, 0));
        }
        DISCARD SetDlgItemText(hwnd, IDC_LABEL_LOW,  LLL, MSG_SILENT     , "Silent"));
        DISCARD SetDlgItemText(hwnd, IDC_LABEL_HIGH, LLL, MSG_LOUD       , "Loud"  ));
        charset = CHARSET_DOS;

        DISCARD SendMessage
        (   GetDlgItem(hwnd, IDC_VOLUME),
            TBM_SETRANGE,
            FALSE,
            MAKELONG(HOSTVOLUME_MIN, HOSTVOLUME_MAX)
        );
        DISCARD SendMessage
        (   GetDlgItem(hwnd, IDC_VOLUME),
            TBM_SETPOS,
            TRUE,
            hostvolume
        );
        return TRUE;
    case WM_CLOSE: // no need for acase
        hostvolume = SendMessage
        (   GetDlgItem(hwnd, IDC_VOLUME),
            TBM_GETPOS,
            0,
            0
        );

        clearkybd();
        DISCARD EndDialog(hwnd, 0);

        return TRUE;
    case WM_COMMAND: // no need for acase
        if (LOWORD (wParam) == IDOK)
        {   hostvolume = SendMessage
            (   GetDlgItem(hwnd, IDC_VOLUME),
                TBM_GETPOS,
                0,
                0
            );

            clearkybd();
            DISCARD EndDialog(hwnd, 0);

            return TRUE;
        } // implied else
        if (LOWORD (wParam) == IDCANCEL)
        {   clearkybd();
            DISCARD EndDialog(hwnd, 0);

            return TRUE;
        } // implied else
        return FALSE;
    default: // no need for adefault
        return FALSE;
}   }

BOOL CALLBACK FrameSkipDlgProc(HWND hwnd, UINT Message, WPARAM wParam, LPARAM lParam)
{   switch (Message)
    {
    case WM_INITDIALOG:
        charset = CHARSET_WIN;
        DISCARD SetWindowText(hwnd, LLL, MSG_HAIL_FRAMESKIP, "Frame Skipping"));
        charset = CHARSET_DOS;

        DISCARD SendMessage
        (   GetDlgItem(hwnd, IDC_FRAMESKIP),
            TBM_SETRANGE,
            FALSE,
            MAKELONG(FRAMESKIP_MIN, FRAMESKIP_MAX)
        );
        DISCARD SendMessage
        (   GetDlgItem(hwnd, IDC_FRAMESKIP),
            TBM_SETPOS,
            TRUE,
            frameskip
        );
        return TRUE;
    case WM_CLOSE: // no need for acase
        frameskip = SendMessage
        (   GetDlgItem(hwnd, IDC_FRAMESKIP),
            TBM_GETPOS,
            0,
            0
        );

        clearkybd();
        DISCARD EndDialog(hwnd, 0);

        return TRUE;
    case WM_COMMAND: // no need for acase
        if (LOWORD (wParam) == IDOK)
        {   frameskip = SendMessage
            (   GetDlgItem(hwnd, IDC_FRAMESKIP),
                TBM_GETPOS,
                0,
                0
            );

            clearkybd();
            DISCARD EndDialog(hwnd, 0);

            return TRUE;
        } // implied else
        if (LOWORD (wParam) == IDCANCEL)
        {   clearkybd();
            DISCARD EndDialog(hwnd, 0);

            return TRUE;
        } // implied else
        return FALSE;
    default: // no need for adefault
        return FALSE;
}   }

EXPORT void changefilepart(STRPTR newfilepart)
{   signed int i,
               thelength,
               where      = -1;

    /* It doesn't actually do anything with filepart, you would need to
       call breakparts() afterwards if you wanted filepart to be
       accurate. */

    strcpy(pathpart, fn_game);
    where = -1;
    thelength = (signed int) strlen(pathpart);
    for (i = 0; i < thelength; i++)
    {   if
        (   pathpart[i] == ':'
         || pathpart[i] == '\\'
        )
        {   where = i;
            // don't break, we want the LAST component, not the FIRST
    }   }
    pathpart[where + 1] = 0;
    strcpy(fn_game, pathpart);
    strcat(fn_game, newfilepart);
}

EXPORT void lockgui(void)
{   ;

/*  if (MenuPtr)
    {   EnableMenuItem(MenuPtr,  0, MF_BYPOSITION | MF_GRAYED);
        EnableMenuItem(MenuPtr,  1, MF_BYPOSITION | MF_GRAYED);
        EnableMenuItem(MenuPtr,  2, MF_BYPOSITION | MF_GRAYED);
        EnableMenuItem(MenuPtr,  3, MF_BYPOSITION | MF_GRAYED);
        EnableMenuItem(MenuPtr,  4, MF_BYPOSITION | MF_GRAYED);
        EnableMenuItem(MenuPtr,  5, MF_BYPOSITION | MF_GRAYED);
        EnableMenuItem(MenuPtr,  6, MF_BYPOSITION | MF_GRAYED);
        EnableMenuItem(MenuPtr,  7, MF_BYPOSITION | MF_GRAYED);
    }

    EnableMenuItem(PopUpMenuPtr, 0, MF_BYPOSITION | MF_GRAYED);
    EnableMenuItem(PopUpMenuPtr, 1, MF_BYPOSITION | MF_GRAYED);
    EnableMenuItem(PopUpMenuPtr, 2, MF_BYPOSITION | MF_GRAYED);
    EnableMenuItem(PopUpMenuPtr, 3, MF_BYPOSITION | MF_GRAYED);
    EnableMenuItem(PopUpMenuPtr, 4, MF_BYPOSITION | MF_GRAYED);
    EnableMenuItem(PopUpMenuPtr, 5, MF_BYPOSITION | MF_GRAYED);
    EnableMenuItem(PopUpMenuPtr, 6, MF_BYPOSITION | MF_GRAYED);
    EnableMenuItem(PopUpMenuPtr, 7, MF_BYPOSITION | MF_GRAYED);

    if (hSideBar)
    {   EnableWindow(hSideBar, FALSE);
    }
    if (hToolbar)
    {   DISCARD SendMessage(hToolbar, TB_SETSTATE, ID_FILE_RESET,            0);
        DISCARD SendMessage(hToolbar, TB_SETSTATE, ID_FILE_OPEN,             0);
        DISCARD SendMessage(hToolbar, TB_SETSTATE, ID_FILE_SAVESNP,          0);
        DISCARD SendMessage(hToolbar, TB_SETSTATE, ID_FILE_SAVEILBM,         0);
        DISCARD SendMessage(hToolbar, TB_SETSTATE, ID_EDIT_COPY,             0);
        DISCARD SendMessage(hToolbar, TB_SETSTATE, ID_CONTROLLERS_ANALOG,    0);
        DISCARD SendMessage(hToolbar, TB_SETSTATE, ID_CONTROLLERS_AUTOFIRE,  0);
        DISCARD SendMessage(hToolbar, TB_SETSTATE, ID_CONTROLLERS_SWAPPED,   0);
        DISCARD SendMessage(hToolbar, TB_SETSTATE, ID_SPEED_PAUSED,          0);
        DISCARD SendMessage(hToolbar, TB_SETSTATE, ID_SPEED_TURBO,           0);
        DISCARD SendMessage(hToolbar, TB_SETSTATE, ID_SPRITES_COLLISIONS,    0);
        DISCARD SendMessage(hToolbar, TB_SETSTATE, ID_SPRITES_DEMULTIPLEX,   0);
        DISCARD SendMessage(hToolbar, TB_SETSTATE, ID_GRAPHICS_FLAGLINE,     0);
        DISCARD SendMessage(hToolbar, TB_SETSTATE, ID_SOUND_ENABLED,         0);
        DISCARD SendMessage(hToolbar, TB_SETSTATE, ID_MACRO_TOGGLEPLAYING,   0);
        DISCARD SendMessage(hToolbar, TB_SETSTATE, ID_MACRO_TOGGLERECORDING, 0);
        EnableWindow(hToolbar, FALSE); // not really needed
    }
*/
}

EXPORT void unlockgui(void)
{   ;

/*  if (MenuPtr)
    {   EnableMenuItem(MenuPtr,  0, MF_BYPOSITION | MF_ENABLED);
        EnableMenuItem(MenuPtr,  1, MF_BYPOSITION | MF_ENABLED);
        EnableMenuItem(MenuPtr,  2, MF_BYPOSITION | MF_ENABLED);
        EnableMenuItem(MenuPtr,  3, MF_BYPOSITION | MF_ENABLED);
        EnableMenuItem(MenuPtr,  4, MF_BYPOSITION | MF_ENABLED);
        EnableMenuItem(MenuPtr,  5, MF_BYPOSITION | MF_ENABLED);
        EnableMenuItem(MenuPtr,  6, MF_BYPOSITION | MF_ENABLED);
        EnableMenuItem(MenuPtr,  7, MF_BYPOSITION | MF_ENABLED);
    }

    EnableMenuItem(PopUpMenuPtr, 0, MF_BYPOSITION | MF_ENABLED);
    EnableMenuItem(PopUpMenuPtr, 1, MF_BYPOSITION | MF_ENABLED);
    EnableMenuItem(PopUpMenuPtr, 2, MF_BYPOSITION | MF_ENABLED);
    EnableMenuItem(PopUpMenuPtr, 3, MF_BYPOSITION | MF_ENABLED);
    EnableMenuItem(PopUpMenuPtr, 4, MF_BYPOSITION | MF_ENABLED);
    EnableMenuItem(PopUpMenuPtr, 5, MF_BYPOSITION | MF_ENABLED);
    EnableMenuItem(PopUpMenuPtr, 6, MF_BYPOSITION | MF_ENABLED);
    EnableMenuItem(PopUpMenuPtr, 7, MF_BYPOSITION | MF_ENABLED);

    updatebiggads();
    updatesmlgads();
    if (hToolbar)
    {   DISCARD SendMessage(hToolbar, TB_SETSTATE, ID_FILE_SAVEILBM, TBSTATE_ENABLED);
        DISCARD SendMessage(hToolbar, TB_SETSTATE, ID_EDIT_COPY,     TBSTATE_ENABLED);
        EnableWindow(hToolbar, TRUE);
    }
*/
}
EXPORT void clearmsgs(void)
{   MSG Msg;

    if (!MainWindowPtr)
    {   return;
    }

    while (PeekMessage(&Msg, MainWindowPtr, 0, 0, PM_REMOVE))
    {   TranslateMessage(&Msg);
        DISCARD DispatchMessage(&Msg);
    }

    if (!ListeningWindowPtr)
    {   return;
    }

    while (PeekMessage(&Msg, ListeningWindowPtr, 0, 0, PM_REMOVE))
    {   TranslateMessage(&Msg);
        DISCARD DispatchMessage(&Msg);
}   }

EXPORT void clearscreen(void)
{   HDC OnScreenRastPort;

    // assert(MainWindowPtr);
    // assert(fullscreen);

    if (showtoolbar)
    {   therect.top = toolbarheight;
    } else
    {   therect.top = 0;
    }
    therect.bottom  = winheight;
    therect.left    = 0;
    therect.right   = clientwidth;
    /* Note that there is slight flickering caused by this; ideally
       we would only fill the borders with grey, not the whole client area of the window. */
    OnScreenRastPort = GetDC(MainWindowPtr);
    FillRect(OnScreenRastPort, &therect, GetStockObject(GRAY_BRUSH));
    DISCARD ReleaseDC(MainWindowPtr, OnScreenRastPort);
}

EXPORT void invert(int i)
{   therect.left   = keyrect[machine][i].left;
    therect.top    = keyrect[machine][i].top;
    therect.right  = keyrect[machine][i].left + keyrect[machine][i].width;
    therect.bottom = keyrect[machine][i].top  + keyrect[machine][i].height;
    DISCARD InvertRect(ControlsRastPtr, &therect);
}

EXPORT void listen_open(void)
{   opening = TRUE;
    ListeningWindowPtr = CreateDialog
    (   InstancePtr,                    // handle to application instance
        MAKEINTRESOURCE(IDD_LISTENING), // identifies dialog box template name
        MainWindowPtr,
        ListeningDlgProc
    );
    opening = FALSE;
}
EXPORT void hostnamewindow(void)
{   opening = TRUE;
    DISCARD DialogBox(GetModuleHandle(NULL), MAKEINTRESOURCE(IDD_HOSTNAME), MainWindowPtr, HostNameDlgProc);
    opening = FALSE;
}

BOOL CALLBACK HostNameDlgProc(HWND hwnd, UINT Message, WPARAM wParam, LPARAM lParam)
{   switch (Message)
    {
    case WM_INITDIALOG:
        charset = CHARSET_WIN;
        DISCARD SetWindowText(hwnd, LLL, MSG_HAIL_HOSTNAME, "Enter Hostname"));
        DISCARD SetDlgItemText(hwnd, IDC_HOSTNAME, hostname);
        charset = CHARSET_DOS;

        return TRUE;
    case WM_CLOSE: // no need for acase
        DISCARD GetWindowText(GetDlgItem(hwnd, IDC_HOSTNAME), hostname, sizeof(hostname));
        clearkybd();
        DISCARD EndDialog(hwnd, 0);

        return TRUE;
    case WM_COMMAND: // no need for acase
        if (LOWORD (wParam) == IDOK)
        {   DISCARD GetWindowText(GetDlgItem(hwnd, IDC_HOSTNAME), hostname, sizeof(hostname));
            clearkybd();
            DISCARD EndDialog(hwnd, 0);

            return TRUE;
        }
        if (LOWORD (wParam) == IDCANCEL)
        {   hostname[0] = 0;
            clearkybd();
            DISCARD EndDialog(hwnd, 0);

            return TRUE;
        }

        return FALSE;
    default: // no need for adefault
        return FALSE;
}   }

EXPORT void close_monitor(void)
{   if (!MonitorWindowPtr)
    {   return;
    }

    DestroyWindow(MonitorWindowPtr);
    MonitorWindowPtr = NULL;
    updatemenu(MENUITEM_VIEWMONITOR);
}
EXPORT void close_controls(void)
{   if (!ControlsWindowPtr)
    {   return;
    }

    DestroyWindow(ControlsWindowPtr);
    ControlsWindowPtr = NULL;
    updatemenu(MENUITEM_CONTROLS);
}
EXPORT void close_dips(void)
{   if (!DIPsWindowPtr)
    {   return;
    }

    DestroyWindow(DIPsWindowPtr);
    DIPsWindowPtr = NULL;
    updatemenu(MENUITEM_DIPSWITCHES);
}
EXPORT void close_memory(void)
{   if (!MemoryWindowPtr)
    {   return;
    }

    DestroyWindow(MemoryWindowPtr);
    MemoryWindowPtr = NULL;
    updatemenu(MENUITEM_VIEWMEMORY);
}
EXPORT void close_palette(void)
{   if (!PaletteWindowPtr)
    {   return;
    }

    DestroyWindow(PaletteWindowPtr);
    PaletteWindowPtr = NULL;
    updatemenu(MENUITEM_PALETTE);
}
EXPORT void close_spriteviewer(void)
{   if (!SpriteWindowPtr)
    {   return;
    }

    DestroyWindow(SpriteWindowPtr);
    SpriteWindowPtr = NULL;
    updatemenu(MENUITEM_SPRITEVIEWER);
}

EXPORT void setmonitor(HWND gadgetptr, STRPTR contents)
{   DISCARD SetWindowText(gadgetptr, contents);
}
EXPORT void setmemory(int whichgad, STRPTR contents)
{   DISCARD SetWindowText(memorygad[whichgad], contents);
}

EXPORT void audit(FLAG user)
{   TRANSIENT WIN32_FIND_DATA FindData;
    TRANSIENT HANDLE          FindHandle;
    TRANSIENT int             thelength,
                              thesize;
    PERSIST   TEXT            activefile[MAX_PATH + 1],
                              resultstring[512 + MAX_PATH + 1];

    if (showsidebar)
    {   DISCARD ListView_DeleteAllItems(hSideBar);
    } elif (!user)
    {   needaudit = TRUE;
        return;
    }
    needaudit = FALSE;

    foundaofs    =
    founddirs    =
    foundgames   =
    foundgood    =
    foundbad     =
    foundsnaps   =
    foundicons   =
    foundunknown = 0;
    audit_coinops();

    DISCARD GetCurrentDirectory(MAX_PATH + 1, olddir);
    DISCARD SetCurrentDirectory(pathpart);

#ifdef VERBOSE
    T1; zprintf("Sidebar directory is %s!\n", pathpart); T2;
#endif

    FindHandle = FindFirstFile("*", &FindData);
    if (FindHandle == INVALID_HANDLE_VALUE)
    {   DISCARD SetCurrentDirectory(olddir);
        return;
    }

    do
    {   if (FindData.dwFileAttributes == FILE_ATTRIBUTE_DIRECTORY)
        {   if
            (   strcmp(FindData.cFileName, "." )
             && strcmp(FindData.cFileName, "..")
            )
            {
#ifdef VERBOSE
                T1; zprintf("Found directory \"%s\".\n", FindData.cFileName); T2;
#endif
                strcpy(auditlist[foundgames].filename, FindData.cFileName);
                strcpy(auditlist[foundgames].gamename, FindData.cFileName);
                auditlist[foundgames].whichgame  = -1;
                auditlist[foundgames].machine   = -1;
                auditlist[foundgames].glyph     = FOLDERGLYPH;
                auditlist[foundgames].memmap    = -1;
                sidebar[foundgames]             = foundgames;
                foundgames++;
                founddirs++;
        }   }
        else
        {   thelength = (int) strlen(FindData.cFileName);
            if
            (   thelength >= 6
             && !stricmp(&FindData.cFileName[thelength - 5], ".info")
            )
            {   foundicons++;
            } else
            {   strcpy(activefile, pathpart);
                thelength = (int) strlen(activefile);
                if
                (   thelength >= 1
                 && activefile[thelength - 1] != '\\'
                 && activefile[thelength - 1] != ':'
                )
                {   strcat(activefile, "\\");
                }
                strcat(activefile, FindData.cFileName);
                DISCARD SetCurrentDirectory(olddir);
                thesize = (int) getsize(activefile);
                auditfile(activefile, thesize, user);
                DISCARD SetCurrentDirectory(pathpart);
    }   }   }
    while (FindNextFile(FindHandle, &FindData));

    DISCARD FindClose(FindHandle);
    DISCARD SetCurrentDirectory(olddir);

    buildlistbrowser();

    if (user)
    {   charset = CHARSET_WIN;
        makeaudittext(resultstring);
        sound_off(FALSE);
        MessageBox
        (   MainWindowPtr,
            resultstring,
            GetCatalogStr(CatalogPtr, MSG_AUDITRESULTS, "WinArcadia: Audit Results"),
            MB_OK | MB_ICONINFORMATION
        );
        charset = CHARSET_DOS;
        clearkybd();
        sound_on();
}   }

EXPORT void buildlistbrowser(void)
{   int    i,
           items = 0;
    LVITEM lvi;

    // This gets called twice at startup, unfortunately
    // (once by audit() and once by openwindow()).

    if (!showsidebar)
    {   return;
    }

    if (showsidebar)
    {   DISCARD ListView_DeleteAllItems(hSideBar);
    }

    sortaudit();
    lvi.iSubItem    = 0;
    lvi.state       = 0;
    lvi.stateMask   = 0;
    lvi.mask        = LVIF_TEXT | LVIF_IMAGE;
    for (i = 0; i < foundgames; i++)
    {   lvi.iItem   = i;
        lvi.iImage  = auditlist[sidebar[i]].glyph;
        lvi.pszText = auditlist[sidebar[i]].gamename;
        DISCARD ListView_InsertItem(hSideBar, &lvi);
    }

    EnableWindow(hSideBar, TRUE);
    currentgame = -1;
    // should we call setselection() here?
}

/* The return value is whether to process keyboard directional input */
EXPORT FLAG system_dopaddle(int source, int dest)
{   PERSIST int x, y; // PERSISTent for speed

    if (hostcontroller[source] == CONTROLLER_TRACKBALL)
    {   getpointerpos(&x, &y);
        x /= 256;              // scale from 0..65535 down to 0..255
        y /= 256;              // scale from 0..65535 down to 0..255
        ax[dest] = x;
        ay[dest] = y;

        return FALSE;
    } elif (hostcontroller[source] == CONTROLLER_1STDJOY)
    {   ax[dest] = jx[0];
        ay[dest] = jy[0];

        if (whichgame == SUPERINVPOS)
        {   if (ax[dest] == 0x80) ax[dest] = 0x7F;
            if (ay[dest] == 0x80) ay[dest] = 0x7F;
        }

        return FALSE;
    } elif (hostcontroller[source] == CONTROLLER_2NDDJOY)
    {   ax[dest] = jx[1];
        ay[dest] = jy[1];

        if (whichgame == SUPERINVPOS)
        {   if (ax[dest] == 0x80) ax[dest] = 0x7F;
            if (ay[dest] == 0x80) ay[dest] = 0x7F;
        }

        return FALSE;
    }

    // assert(hostcontroller[source] == CONTROLLER_NONE);
    return TRUE;
}

EXPORT void updatepointer(FLAG full)
{   int x, y;

    if (!MainWindowPtr)
    {   return;
    }

    ThePoint.x = 0;
    ThePoint.y = 0;
    DISCARD ClientToScreen(MainWindowPtr, &ThePoint);
    if (stretch && fullscreen)
    {   therect.left   = ThePoint.x;
        therect.right  = ThePoint.x +           clientwidth  - 1;
        therect.top    = ThePoint.y + yoffset;
        therect.bottom = ThePoint.y + yoffset + clientheight - 6;
    } else
    {   therect.left   = ThePoint.x + xoffset;
        therect.right  = ThePoint.x + xoffset +   rastwidth     ;
        therect.top    = ThePoint.y + yoffset;
        therect.bottom = ThePoint.y + yoffset +   rastheight    ;
        if (!fullscreen)
        {   therect.bottom--;
    }   }

    if (showpointer)
    {   if
        (   machine != PIPBUG
         && machine != INSTRUCTOR
         && (   hostcontroller[0] == CONTROLLER_TRACKBALL
             || hostcontroller[1] == CONTROLLER_TRACKBALL
        )   )
        {   DISCARD GetCursorPos(&ThePoint);
            DISCARD ScreenToClient(MainWindowPtr, &ThePoint);
            x = ThePoint.x;
            y = ThePoint.y;
            if (fullscreen && stretch)
            {   if
                (   x >= xoffset
                 && y >= yoffset
                 && x <  xoffset + clientwidth
                 && y <  yoffset + clientheight
                )
                {   SetCursor(hCross);
                } else
                {   SetCursor(hArrow);
            }   }
            else
            {   if
                (   x >= xoffset
                 && y >= yoffset
                 && x <  xoffset + rastwidth
                 && y <  yoffset + rastheight
                )
                {   SetCursor(hCross);
                } else
                {   SetCursor(hArrow);
        }   }   }
        else
        {   SetCursor(hArrow);
        }
        if (!showingpointer)
        {   showingpointer = TRUE;
            ShowCursor(TRUE);
    }   }
    else
    {   if (showingpointer)
        {   showingpointer = FALSE;
            ShowCursor(FALSE);
    }   }

    if (!full)
    {   return;
    }

    if
    (   machine != PIPBUG
     && machine != INSTRUCTOR
     && confine
     && (   hostcontroller[0] == CONTROLLER_TRACKBALL
         || hostcontroller[1] == CONTROLLER_TRACKBALL
    )   )
    {   DISCARD ClipCursor(&therect);
    } else
    {   DISCARD ClipCursor(NULL);
}   }

EXPORT void OpenChannels(void)
{   WAVEFORMATEX l_WaveFormatEx;
    int          i;

#ifdef USEDIRECTSOUND
    for (i = 7; i < 14; i++)
#else
    for (i = 0; i < 14; i++)
#endif
    {   l_WaveFormatEx.wFormatTag      = WAVE_FORMAT_PCM;
        l_WaveFormatEx.nChannels       = 1;
        l_WaveFormatEx.nSamplesPerSec  = 11025;
        l_WaveFormatEx.wBitsPerSample  = 8;
        l_WaveFormatEx.nAvgBytesPerSec = 11025;
        l_WaveFormatEx.nBlockAlign     = 1;
     // l_WaveFormatEx.cbSize          = 0; ignored
        memset(&hPSG[i], 0, sizeof(HWAVEOUT));
        DISCARD waveOutOpen
        (   &hPSG[i],
            WAVE_MAPPER,
            &l_WaveFormatEx,
            0,
            0,
            CALLBACK_NULL
        );
        SoundOpened[i] = TRUE;
}   }

EXPORT void TonePlay(int guestchan, float hertz, int volume)
{
#ifndef _lint
    UWORD   counter;
#endif
#ifdef USEDIRECTSOUND
    HRESULT hr;
#endif

    // assert(volume >= 1 && volume <= 15);

#ifdef DEBUGSOUND
    if (guestplaying[guestchan])
    {   T1; textpen(TEXTPEN_VERBOSE); zprintf("Channel %d is already playing a tone!\n", guestchan); T2;
    } else
    {   T1; textpen(TEXTPEN_VERBOSE); zprintf("Channel %d is not yet playing a tone!\n", guestchan); T2;
    }
    T1; textpen(TEXTPEN_VERBOSE); zprintf("Playing %f Hz tone on channel %d!\n", hertz, guestchan); T2;
#endif

    // free old buffer (if required)
    SoundStop(guestchan);

    if (useinternal && guestchan == 6)
    {   // assert(HOSTVOLUME_MIN == 0);
        if (hostvolume == 0)
        {   return;
        }

#ifndef _lint
        counter = (UWORD) (0x1234DD / hertz);

        __asm mov al, 182
        __asm out 43h, al
        __asm mov ax, counter
        __asm out 42h, al
        __asm mov al, ah
        __asm out 42h, al
        __asm in  al, 61h
        __asm or  al, 00000011b
        __asm out 61h, al
#endif

        // how to vary volume? and how to support noise channel?

        guestplaying[guestchan] = TRUE;

        return;
    } // implied else

    // hr = inst[guestchan]->lpVtbl->SetVolume(inst[guestchan], DSBVOLUME_MAX);
    // check hr here

#ifdef USEDIRECTSOUND
    hr = inst[guestchan]->lpVtbl->SetFrequency(inst[guestchan], (unsigned long) (hertz) * 50);
    switch (hr)
    {
    case DS_OK:
        // T1; zprintf("SetFrequency(): OK.\n"); T2;
    acase DSERR_ALLOCATED:
        // T1; zprintf("SetFrequency(): Already allocated!\n"); T2;
        return;
    acase DSERR_INVALIDPARAM:
        // T1; zprintf("SetFrequency(): Invalid parameter!\n"); T2;
        return;
    acase DSERR_UNINITIALIZED:
        // T1; zprintf("SetFrequency(): Uninitialized!\n"); T2;
        return;
    acase DSERR_UNSUPPORTED:
        // T1; zprintf("SetFrequency(): Unsupported function!\n"); T2;
        return;
    adefault:
        // T1; zprintf("SetFrequency(): Unknown error!\n"); T2;
        return;
    }

    hr = inst[guestchan]->lpVtbl->Play(inst[guestchan], 0, 0, DSBPLAY_LOOPING);
    switch (hr)
    {
    case DS_OK:
        T1; zprintf("Play(): OK.\n"); T2;
    acase DSERR_BUFFERLOST:
        T1; zprintf("Play(): Buffer lost!\n"); T2;
        return;
    acase DSERR_INVALIDCALL:
        T1; zprintf("Play(): Invalid call!\n"); T2;
        return;
    acase DSERR_INVALIDPARAM:
        T1; zprintf("Play(): Invalid parameter!\n"); T2;
        return;
    acase DSERR_PRIOLEVELNEEDED:
        T1; zprintf("Play(): Wrong priority!\n"); T2;
        return;
    adefault:
        T1; zprintf("Play(): Unknown error!\n"); T2;
        return;
    }
#else
    generatewave(guestchan, (double) hertz, volume, FALSE);
    PSGHdr[guestchan].lpData           = ToneBuffer[guestchan];
    PSGHdr[guestchan].dwBufferLength   = (DWORD) ToneLength[guestchan];
    PSGHdr[guestchan].dwBytesRecorded  = 0;
    PSGHdr[guestchan].dwUser           = 0;
    PSGHdr[guestchan].dwFlags          = 0;
    PSGHdr[guestchan].dwLoops          = ~0; // loop almost indefinitely
    PSGHdr[guestchan].lpNext           = NULL;
    PSGHdr[guestchan].reserved         = (unsigned long) NULL;
    DISCARD waveOutPrepareHeader(hPSG[guestchan], &PSGHdr[guestchan], sizeof(WAVEHDR));
    PSGHdr[guestchan].dwFlags          |= WHDR_BEGINLOOP | WHDR_ENDLOOP;
    DISCARD waveOutWrite(hPSG[guestchan], &PSGHdr[guestchan], sizeof(WAVEHDR));
#endif

    guestplaying[guestchan] = TRUE;
}

EXPORT void NoisePlay(int guestchan, float hertz, int volume)
{   // assert(volume    >= 1 && volume    <= 15);
    // assert(guestchan >= 7 && guestchan <= 13);

#ifdef DEBUGSOUND
    if (guestplaying[guestchan])
    {   T1; textpen(TEXTPEN_VERBOSE); zprintf("Guest channel %d is already playing a noise!\n", guestchan); T2;
        return;
    } else
    {   T1; textpen(TEXTPEN_VERBOSE); zprintf("Playing noise at hertz %f, volume %d on channel %d!\n", hertz, volume, guestchan); T2;
    }
#endif

    // free old buffer (if required)
    SoundStop(guestchan);

    generatewave(guestchan, (double) hertz, volume, TRUE);

    PSGHdr[guestchan].lpData          = NoiseBuffer[guestchan - 7];
    PSGHdr[guestchan].dwBufferLength  = NOISELENGTH;
    PSGHdr[guestchan].dwBytesRecorded = 0;
    PSGHdr[guestchan].dwUser          = 0;
    PSGHdr[guestchan].dwFlags         = 0;
    PSGHdr[guestchan].dwLoops         = ~0; // loop almost indefinitely
    PSGHdr[guestchan].lpNext          = NULL;
    PSGHdr[guestchan].reserved        = (unsigned long) NULL;
    DISCARD waveOutPrepareHeader(hPSG[guestchan], &PSGHdr[guestchan], sizeof(WAVEHDR));
    PSGHdr[guestchan].dwFlags         |= WHDR_BEGINLOOP | WHDR_ENDLOOP;
    DISCARD waveOutWrite(hPSG[guestchan], &PSGHdr[guestchan], sizeof(WAVEHDR));

    guestplaying[guestchan] = TRUE;
}

EXPORT void SoundStop(int guestchan)
{   if (guestplaying[guestchan])
    {   guestplaying[guestchan] = FALSE;

#ifdef DEBUGSOUND
        T1; zprintf("Stopping tone channel %d!\n", guestchan); T2;
#endif

        if (useinternal && guestchan == 6)
        {   __asm in  al, 61h
            __asm and al, 11111100b
            __asm out 61h, al

            return;
        }

#ifdef USEDIRECTSOUND
        if (guestchan <= 6)
        {   inst[guestchan]->lpVtbl->Stop(inst[guestchan]);
            inst[guestchan]->lpVtbl->SetCurrentPosition(inst[guestchan], 0);
            return;
        }
#endif
        DISCARD waveOutReset(hPSG[guestchan]);
        DISCARD waveOutUnprepareHeader(hPSG[guestchan], &PSGHdr[guestchan], sizeof(WAVEHDR));
}   }

EXPORT void SoundClose(int guestchan)
{   if (SoundOpened[guestchan])
    {   SoundStop(guestchan);
        DISCARD waveOutClose(hPSG[guestchan]);
        SoundOpened[guestchan] = FALSE;
}   }

MODULE void generatewave(int channel, double hertz, int volume, FLAG noisy)
{   TRANSIENT double perc,
                     swap,
                     split;
    TRANSIENT int    done         = 0,
                     i,
                     localvolume,
                     oldoutputval = 0,
                     output_val,
                     realoutput;

    PERSIST   const    UBYTE  apcy_volume[8] =
    {   0, //  0: 128 +/-   0
       18, //  1: 128 +/-  18 ( 18.14286)
       36, //  2: 128 +/-  32 ( 36.28571)
       54, //  3: 128 +/-  54 ( 54.42857)
       73, //  4: 128 +/-  73 ( 72.57143)
       91, //  5: 128 +/-  91 ( 90.71429)
      109, //  6: 128 +/- 109 (108.8571 )
      127  //  7: 128 +/- 127
    },                        iemg_volume[16] =
    {   0, //  0: 128 +/-   0
        8, //  1: 128 +/-   8 (  8.46667)
       17, //  2: 128 +/-  17 ( 16.93333)
       25, //  3: 128 +/-  25 ( 25.4    )
       34, //  4: 128 +/-  34 ( 33.86667)
       42, //  5: 128 +/-  42 ( 42.33333)
       51, //  6: 128 +/-  51 ( 50.8    )
       59, //  7: 128 +/-  59 ( 59.26667)
       68, //  8: 128 +/-  68 ( 67.73333)
       76, //  9: 128 +/-  76 ( 76.2    )
       85, // 10: 128 +/-  85 ( 84.66667)
       93, // 11: 128 +/-  93 ( 93.13333)
      102, // 12: 128 +/- 102 (101.6    )
      110, // 13: 128 +/- 110 (110.06667)
      119, // 14: 128 +/- 119 (118.53333)
      127  // 15: 128 +/- 127
    };

#ifdef DEBUGSOUND
    T1; textpen(TEXTPEN_VERBOSE); zprintf("Tone volume for channel %d is %d!\n", channel, volume); T2;
#endif

    swap = (0.25 / hertz);

    switch (machine)
    {
    case ARCADIA:
    case PIPBUG:
    case CD2650:
    case PHUNSY:
        localvolume = (apcy_volume[volume] * hostvolume) / HOSTVOLUME_MAX;
    acase INTERTON:
    case ELEKTOR:
    case ASTROWARS:
    case GALAXIA:
    case MALZAK:
        localvolume = (iemg_volume[volume] * hostvolume) / HOSTVOLUME_MAX;
    adefault: // eg. INSTRUCTOR, CHAOS
        localvolume = 0;
    }
    realoutput = 128 + localvolume;

    // is this function harmless even if volume is 0?

    for (i = 0; i < NOISELENGTH; i++)
    {   // determine where in sample we are
        perc = (double) (i) / 22025.0;
        // from where in sample we are can now determine what we should be
        split = perc / swap;

        output_val = ((int) (split) % 2) ? (128 + localvolume) : (128 - localvolume);
        if (noisy)
        {   if (output_val != oldoutputval)
            {   oldoutputval = output_val;
                if (rand() % 2)
                {   if (realoutput == 128 + localvolume)
                    {   realoutput = 128 - localvolume;
                    } else
                    {   realoutput = 128 + localvolume;
            }   }   }

            NoiseBuffer[channel - 7][i] = (unsigned char) realoutput;
        } else
        {   if (output_val != oldoutputval)
            {   oldoutputval = output_val;
                if (done == 8 * 2) // ie. generate 8 full cycles of the wave,
                // because only 1 cycle would not be precise enough to give the
                // exact pitch we want.
                {   ToneLength[channel] = i;
                    return;
                } else
                {   done++;
            }   }
            output_val = ((int) (split) % 2) ? (128 + localvolume) : (128 - localvolume);
            ToneBuffer[channel][i] = (unsigned char) output_val;
}   }   }

EXPORT void changecolours(void)
{   make_stars();
    redrawscreen();
}

EXPORT void textpen(int colour)
{   PERSIST       int    textcolour = TEXTPEN_DEFAULT;
    PERSIST const STRPTR ansi[9]    =
    {   "\x1b" "[30m",
        "\x1b" "[31m",
        "\x1b" "[32m",
        "\x1b" "[33m",
        "\x1b" "[34m",
        "\x1b" "[35m",
        "\x1b" "[36m",
        "\x1b" "[37m",
        "\x1b" "[37m"  // 39 doesn't work!
    };
    PERSIST const WORD nt[9] =
    {   0,                                                                          // black on black
        FOREGROUND_INTENSITY | FOREGROUND_RED,                                      // red on black
        FOREGROUND_INTENSITY | FOREGROUND_GREEN,                                    // green on black
        FOREGROUND_INTENSITY | FOREGROUND_RED   | FOREGROUND_GREEN,                 // yellow on black
        FOREGROUND_INTENSITY | FOREGROUND_BLUE,                                     // blue on black
        FOREGROUND_INTENSITY | FOREGROUND_RED   | FOREGROUND_BLUE,                  // purple on black
        FOREGROUND_INTENSITY | FOREGROUND_GREEN | FOREGROUND_BLUE,                  // cyan on black
        FOREGROUND_INTENSITY | FOREGROUND_RED | FOREGROUND_GREEN | FOREGROUND_BLUE, // white on black
        FOREGROUND_INTENSITY | FOREGROUND_RED | FOREGROUND_GREEN | FOREGROUND_BLUE  // white on black
    };

    if (!useansi || textcolour == colour)
    {   return;
    }

    textcolour = colour;
    if (lame)
    {   DISCARD SetConsoleTextAttribute
        (   hConsole, // handle to console screen buffer
            nt[textcolour]
        );
    } else
    {   printf("%s", ansi[textcolour]); // not zprintf()!
}   }

#ifdef FLASHSL
EXPORT void leds(FLAG state)
{   UBYTE mask;

/* Bits are:
   2: Caps Lock
   1: Num Lock
   0: Scroll Lock

   We are supposed to keep the BIOS flags for CL/NL/SL in sync, but we don't bother.

   Also, ideally at startup we would read the state of the LEDs and restore them to that
    state (or read actual CL/NL/SL mode status directly) at shutdown.

   When SL flashing is enabled, sometimes primary firebutton (probably affects other
    keys too) is becoming "stuck"? Maybe it's not hearing the key release from the
    keyboard because it's busy sending data to the keyboard. */

    if (state)
    {   mask = 1; // %001
    } else
    {   mask = 0; // %000
    }

    if (mask == oldmask)
    {   return; // to avoid needlessly accessing it, which causes problems with keyboard reading
                // ("stuck" keys)
    }
    oldmask = mask;

FIRST:
    __asm in  al,  64h
    __asm and al,  02h
    __asm jnz FIRST

    __asm mov al,  237
    __asm out 60h, al

SECOND:
    __asm in  al,  64h
    __asm and al,  02h
    __asm jnz SECOND

    __asm mov al,  mask
    __asm out 60h, al
}

#endif

EXPORT void load_samples(void)
{   TRANSIENT       FILE*        TheLocalHandle; // LocalHandle is a variable of winbase.h
    TRANSIENT       WAVEFORMATEX l_WaveFormatEx;
    TRANSIENT       int          i;
    PERSIST   const STRPTR       SampleName[SAMPLES] =
    { "sounds\\bell.wav"
 // , "sounds\\amigan.wav"
    };

#ifdef USEDIRECTSOUND
    TRANSIENT       HRESULT      hr;

    hr = DirectSoundCreate(NULL, &lpds, NULL);
    switch (hr)
    {
    case DS_OK:
        // T1; zprintf("DirectSoundCreate(): OK.\n"); T2;
    acase DSERR_ALLOCATED:
        // T1; zprintf("DirectSoundCreate(): Already allocated!\n"); T2;
        return;
    acase DSERR_NOAGGREGATION:
        // T1; zprintf("DirectSoundCreate(): Aggregation is unsupported!\n"); T2;
        return;
    acase DSERR_OUTOFMEMORY:
        // T1; zprintf("DirectSoundCreate(): Out of memory!\n"); T2;
        return;
    acase DSERR_INVALIDPARAM:
        // T1; zprintf("DirectSoundCreate(): Invalid parameter!\n"); T2;
        return;
    acase DSERR_NODRIVER:
        // T1; zprintf("DirectSoundCreate(): No driver!\n"); T2;
        return;
    adefault:
        // T1; zprintf("DirectSoundCreate(): Unknown error!\n"); T2;
        return;
    }

    // assert(MainWindowPtr);
    // assert(lpds);
    hr = lpds->lpVtbl->SetCooperativeLevel(lpds, MainWindowPtr, DSSCL_NORMAL); // 22050Hz, 8-bit stereo
    switch (hr)
    {
    case DS_OK:
        // T1; zprintf("SetCooperativeLevel(): OK.\n"); T2;
    acase DSERR_ALLOCATED:
        // T1; zprintf("SetCooperativeLevel(): Already allocated!\n"); T2;
        lpds->lpVtbl->Release(lpds);
        lpds = NULL;
        return;
    acase DSERR_INVALIDPARAM:
        // T1; zprintf("SetCooperativeLevel(): Invalid parameter!\n"); T2;
        lpds->lpVtbl->Release(lpds);
        lpds = NULL;
        return;
    acase DSERR_UNINITIALIZED:
        // T1; zprintf("SetCooperativeLevel(): Uninitialized!\n"); T2;
        lpds->lpVtbl->Release(lpds);
        lpds = NULL;
        return;
    acase DSERR_UNSUPPORTED:
        // T1; zprintf("SetCooperativeLevel(): Unsupported function!\n"); T2;
        lpds->lpVtbl->Release(lpds);
        lpds = NULL;
        return;
    adefault:
        // T1; zprintf("SetCooperativeLevel(): Unknown error!\n"); T2;
        lpds->lpVtbl->Release(lpds);
        lpds = NULL;
        return;
    }

    change_instrument();
#endif

    for (i = 0; i < SAMPLES; i++)
    {   if
        (   ((SampleLength[i] = getsize(SampleName[i])))
         && ((TheLocalHandle = fopen(SampleName[i], "rb")))
        )
        {   SampleBuffer[i] = malloc(SampleLength[i]); // should really check return code
            DISCARD fread(SampleBuffer[i], SampleLength[i], 1, TheLocalHandle); // should really check return code
            DISCARD fclose(TheLocalHandle);
            // TheLocalHandle = NULL;

            l_WaveFormatEx.wFormatTag      = WAVE_FORMAT_PCM;
            l_WaveFormatEx.nChannels       = 1;
            l_WaveFormatEx.nSamplesPerSec  = 11025;
            l_WaveFormatEx.wBitsPerSample  = 8;
            l_WaveFormatEx.nBlockAlign     = 1;
            l_WaveFormatEx.nAvgBytesPerSec = l_WaveFormatEx.nSamplesPerSec * l_WaveFormatEx.nBlockAlign;
            l_WaveFormatEx.cbSize          = 0; // ignored

            memset(&hSample[i], 0, sizeof(HWAVEOUT));
            DISCARD waveOutOpen
            (   &hSample[i],
                WAVE_MAPPER,
                &l_WaveFormatEx,
                0,
                0,
                CALLBACK_NULL
            );

            SampleOpened[i] = TRUE;
}   }   }

#ifdef USEDIRECTSOUND
EXPORT void change_instrument(void)
{   TRANSIENT       FILE*        TheLocalHandle; // LocalHandle is a variable of winbase.h
    TRANSIENT       WAVEFORMATEX l_WaveFormatEx;
    TRANSIENT       int          i;
	TRANSIENT       DSBUFFERDESC dsbd;
	TRANSIENT       UBYTE       *InstBuffer,
                                *ptr1,
                                *ptr2;
	TRANSIENT       ULONG        InstLength,
                                 len1, len2;
    PERSIST   const STRPTR       InstName[INSTRUMENTS] =
    { "sounds\\flute.wav",
      "sounds\\guitar.wav",
      "sounds\\oboe.wav",
      "sounds\\organ.wav",
      "sounds\\piano.wav",
      "sounds\\sax.wav",
      "sounds\\trombone.wav",
      "sounds\\violin.wav"
    };

    if
    (   ((InstLength     = getsize(InstName[currentinst])    ))
     && ((TheLocalHandle = fopen(InstName[currentinst], "rb")))
    )
    {   InstBuffer = malloc(InstLength); // should really check return code
        DISCARD fread(InstBuffer, InstLength, 1, TheLocalHandle); // should really check return code
        DISCARD fclose(TheLocalHandle);
        // TheLocalHandle = NULL;

        for (i = 0; i <= 6; i++) // for each tone channel
        {   l_WaveFormatEx.wFormatTag      = WAVE_FORMAT_PCM;
            l_WaveFormatEx.nChannels       = 1;
            l_WaveFormatEx.nSamplesPerSec  = 22050;
            l_WaveFormatEx.wBitsPerSample  = 8;
            l_WaveFormatEx.nBlockAlign     = 1;
            l_WaveFormatEx.nAvgBytesPerSec = l_WaveFormatEx.nSamplesPerSec * l_WaveFormatEx.nBlockAlign;
            l_WaveFormatEx.cbSize          = 0; // ignored

            ZeroMemory(&dsbd, sizeof(dsbd));
		    dsbd.dwSize        = sizeof(dsbd);
		    dsbd.dwFlags       = DSBCAPS_CTRLVOLUME | DSBCAPS_CTRLFREQUENCY | DSBCAPS_STATIC | DSBCAPS_GLOBALFOCUS;
		    dsbd.dwBufferBytes = InstLength;
		    dsbd.lpwfxFormat   = &l_WaveFormatEx;

            if
            (   FAILED(lpds->lpVtbl->CreateSoundBuffer(lpds, &dsbd, &inst[i], NULL))
			 || FAILED(inst[i]->lpVtbl->Lock(inst[i], 0, InstLength, (void**) &ptr1, &len1, (void**) &ptr2, &len2, DSBLOCK_ENTIREBUFFER))
            )
            {   // any allocated channels will be freed eventually in freeall()
                lpds->lpVtbl->Release(lpds);
                lpds = NULL;
				return;
			}
            {	memcpy(ptr1, &InstBuffer[0x2C], min(InstLength, len1));
				(inst[i])->lpVtbl->Unlock((inst[i]), ptr1, len1, ptr2, len2);
        }   }

        free(InstBuffer);
        // InstBuffer = NULL;
}   }
#endif

EXPORT void play_sample(int sample)
{   // assert(machine == PIPBUG);

    if
    (   !sound
     || !hostvolume
     || !SampleBuffer[sample]
     || !SampleOpened[sample]
    )
    {   return;
    }

    // it's fine if the sample isn't prepared, we are about to
    // unprepare and then reprepare it anyway.

    stop_sample(sample);

    SampleHdr[sample].lpData          = SampleBuffer[sample];
    SampleHdr[sample].dwBufferLength  = SampleLength[sample];
    SampleHdr[sample].dwBytesRecorded = 0;
    SampleHdr[sample].dwUser          = 0;
    SampleHdr[sample].dwFlags         = 0;
    SampleHdr[sample].dwLoops         = 1;
    SampleHdr[sample].lpNext          = NULL;
    SampleHdr[sample].reserved        = (unsigned long) NULL;
    DISCARD waveOutPrepareHeader(hSample[sample], &SampleHdr[sample], sizeof(WAVEHDR));
    SamplePrepared[sample] = TRUE;

    SampleHdr[sample].dwFlags         |= WHDR_BEGINLOOP | WHDR_ENDLOOP;
    DISCARD waveOutWrite(hSample[sample], &SampleHdr[sample], sizeof(WAVEHDR));
}

EXPORT void stop_sample(int sample)
{   if (!SamplePrepared[sample])
    {   return;
    }

    DISCARD waveOutReset(hSample[sample]);
    DISCARD waveOutUnprepareHeader(hSample[sample], &SampleHdr[sample], sizeof(WAVEHDR));
    SamplePrepared[sample] = FALSE;
}

EXPORT void traymenu(void)
{   HMENU TrayMenuPtr,
          TraySubMenuPtr;

    // assert(iconified);

    DISCARD SetForegroundWindow(MainWindowPtr);
    DISCARD GetCursorPos(&ThePoint);

    TrayMenuPtr = LoadMenu(InstancePtr, MAKEINTRESOURCE(langs[language].traymenu));
    TraySubMenuPtr = GetSubMenu(TrayMenuPtr, 0);
    // SetDefaultItem(TraySubMenuPtr, ID_FILE_UNICONIFY);
    TrackPopupMenu
    (   TraySubMenuPtr,
        TPM_RIGHTALIGN | TPM_RIGHTBUTTON,
        ThePoint.x,
        ThePoint.y,
        0,
        MainWindowPtr,
        NULL
    );
    PostMessage(MainWindowPtr, WM_NULL, 0, 0);
}

BOOL CALLBACK RegisterDlgProc(HWND hwnd, UINT Message, WPARAM wParam, LPARAM lParam)
{   switch (Message)
    {
    case WM_INITDIALOG:
        charset = CHARSET_WIN;
        DISCARD SetWindowText( hwnd,           LLL, MSG_HAIL_REGISTERFILETYPES, "Register Filetypes"));

        if (language == LANGUAGE_RUS)
        {   DISCARD SendMessage(GetDlgItem(hwnd, IDOK          ), WM_SETFONT, (WPARAM) hRussianFont, MAKELPARAM(FALSE, 0));
            DISCARD SendMessage(GetDlgItem(hwnd, IDCANCEL      ), WM_SETFONT, (WPARAM) hRussianFont, MAKELPARAM(FALSE, 0));
        }
        DISCARD SetDlgItemText(hwnd, IDOK,            LLL, MSG_OK2,         "&OK"                                        ));
        DISCARD SetDlgItemText(hwnd, IDCANCEL,        LLL, MSG_CANCEL2,     "&Cancel"                                    ));
        DISCARD SetDlgItemText(hwnd, IDC_REASSOCIATE, LLL, MSG_REASSOCIATE, "Reassociate these automatically at startup?"));

        charset = CHARSET_DOS;

        if (assoc[0]   ) DISCARD SendMessage(GetDlgItem(hwnd, IDC_AOF        ), BM_SETCHECK, BST_CHECKED, 0);
        if (assoc[1]   ) DISCARD SendMessage(GetDlgItem(hwnd, IDC_BIN        ), BM_SETCHECK, BST_CHECKED, 0);
        if (assoc[2]   ) DISCARD SendMessage(GetDlgItem(hwnd, IDC_COR        ), BM_SETCHECK, BST_CHECKED, 0);
        if (assoc[3]   ) DISCARD SendMessage(GetDlgItem(hwnd, IDC_COS        ), BM_SETCHECK, BST_CHECKED, 0);
        if (assoc[4]   ) DISCARD SendMessage(GetDlgItem(hwnd, IDC_PGM        ), BM_SETCHECK, BST_CHECKED, 0);
        if (assoc[5]   ) DISCARD SendMessage(GetDlgItem(hwnd, IDC_TVC        ), BM_SETCHECK, BST_CHECKED, 0);
        if (assoc[6]   ) DISCARD SendMessage(GetDlgItem(hwnd, IDC_ZIP        ), BM_SETCHECK, BST_CHECKED, 0);
        if (reassociate) DISCARD SendMessage(GetDlgItem(hwnd, IDC_REASSOCIATE), BM_SETCHECK, BST_CHECKED, 0);
        
        return TRUE;
    case WM_CLOSE: // no need for acase
        goto DONE;
    case WM_COMMAND: // no need for acase
        switch (LOWORD(wParam))
        {
        case IDOK:
            goto DONE;
        case IDCANCEL: // no need for acase
            clearkybd();
            DISCARD EndDialog(hwnd, 0);
            return TRUE;
    }   }

    return FALSE;
DONE:

    if (SendMessage(GetDlgItem(hwnd, IDC_AOF), BM_GETCHECK, 0, 0) == BST_CHECKED)
    {   assoc[0] = TRUE;
        associate(KIND_AOF);
    } else
    {   assoc[0] = FALSE;
    }
    if (SendMessage(GetDlgItem(hwnd, IDC_BIN), BM_GETCHECK, 0, 0) == BST_CHECKED)
    {   assoc[1] = TRUE;
        associate(KIND_BIN);
    } else
    {   assoc[1] = FALSE;
    }
    if (SendMessage(GetDlgItem(hwnd, IDC_COR), BM_GETCHECK, 0, 0) == BST_CHECKED)
    {   assoc[2] = TRUE;
        associate(KIND_COR);
    } else
    {   assoc[2] = FALSE;
    }
    if (SendMessage(GetDlgItem(hwnd, IDC_COS), BM_GETCHECK, 0, 0) == BST_CHECKED)
    {   assoc[3] = TRUE;
        associate(KIND_COS);
    } else
    {   assoc[3] = FALSE;
    }
    if (SendMessage(GetDlgItem(hwnd, IDC_PGM), BM_GETCHECK, 0, 0) == BST_CHECKED)
    {   assoc[4] = TRUE;
        associate(KIND_PGM);
    } else
    {   assoc[4] = FALSE;
    }
    if (SendMessage(GetDlgItem(hwnd, IDC_TVC), BM_GETCHECK, 0, 0) == BST_CHECKED)
    {   assoc[5] = TRUE;
        associate(KIND_TVC);
    } else
    {   assoc[5] = FALSE;
    }
    if (SendMessage(GetDlgItem(hwnd, IDC_ZIP), BM_GETCHECK, 0, 0) == BST_CHECKED)
    {   assoc[6] = TRUE;
        associate(KIND_ZIP);
    } else
    {   assoc[6] = FALSE;
    }

    if (SendMessage(GetDlgItem(hwnd, IDC_REASSOCIATE), BM_GETCHECK, 0, 0) == BST_CHECKED)
    {   reassociate = TRUE;
    } else
    {   reassociate = FALSE;
    }

    clearkybd();
    DISCARD EndDialog(hwnd, 0);

    return TRUE;
}

EXPORT void associate(int kind)
{   TRANSIENT HKEY   hKey;
    TRANSIENT DWORD* lRtn;
    PERSIST   TEXT   tempstring[MAX_PATH + 7 + 1]; // PERSISTent so as not to overflow the stack

    // create the new registry key for the file extension
    if (RegCreateKeyEx
    (   HKEY_CLASSES_ROOT,
        filekind[kind].extension,
        0,
        NULL,
        REG_OPTION_NON_VOLATILE,
        KEY_ALL_ACCESS,
        0,
        (PHKEY) &hKey,
        (LPDWORD) &lRtn
    ) != ERROR_SUCCESS)
    {   return;
    }
    // set "(default)" string value to identifier
    if (RegSetValueEx
    (   hKey,
        NULL,
        0,
        REG_SZ,
        filekind[kind].extname,
        strlen(filekind[kind].extname) + 1
    ) != ERROR_SUCCESS)
    {   DISCARD RegCloseKey(hKey);
        return;
    }
    DISCARD RegCloseKey(hKey);

    // create the new registry key, the file extension identifier
    if (RegCreateKeyEx
    (   HKEY_CLASSES_ROOT,
        filekind[kind].extname,
        0,
        NULL,
        REG_OPTION_NON_VOLATILE,
        KEY_ALL_ACCESS,
        0,
        (PHKEY) &hKey,
        (LPDWORD) &lRtn
    ) != ERROR_SUCCESS)
    {   return;
    }
    // set "(default)" string value to description of the file type
    if (RegSetValueEx
    (   hKey,
        NULL,
        0,
        REG_SZ,
        filekind[kind].desc,
        strlen(filekind[kind].desc) + 1
    ) != ERROR_SUCCESS)
    {   DISCARD RegCloseKey(hKey);
        return;
    }
    DISCARD RegCloseKey(hKey);

    strcpy(tempstring, filekind[kind].extname);
    strcat(tempstring, "\\DefaultIcon");
    // create the new registry key, the default icon key within the identifier key
    if (RegCreateKeyEx
    (   HKEY_CLASSES_ROOT,
        tempstring,
        0,
        NULL,
        REG_OPTION_NON_VOLATILE,
        KEY_ALL_ACCESS,
        0,
        (PHKEY) &hKey,
        (LPDWORD) &lRtn
    ) != ERROR_SUCCESS)
    {   return;
    }
    strcpy(tempstring, ProgName);
    // set "(default)" string value to the full path name of the icon that
    // will be associated with this filetype
    if (RegSetValueEx
    (   hKey,
        NULL,
        0,
        REG_SZ,
        tempstring,
        strlen(tempstring) + 1
    ) != ERROR_SUCCESS)
    {   DISCARD RegCloseKey(hKey);
        return;
    }
    DISCARD RegCloseKey(hKey);

    strcpy(tempstring, filekind[kind].extname);
    strcat(tempstring, "\\shell");
    // create the new registry key, the "shell" key within the identifier key
    if (RegCreateKeyEx
    (   HKEY_CLASSES_ROOT,
        tempstring,
        0,
        NULL,
        REG_OPTION_NON_VOLATILE,
        KEY_ALL_ACCESS,
        0,
        (PHKEY) &hKey,
        (LPDWORD) &lRtn
    ) != ERROR_SUCCESS)
    {   return;
    }
    DISCARD RegCloseKey(hKey);

    strcat(tempstring, "\\open"); // now foo_ext\shell\open
    // create the new registry key, the "open" command key within the
    // shell key
    if (RegCreateKeyEx
    (   HKEY_CLASSES_ROOT,
        tempstring,
        0,
        NULL,
        REG_OPTION_NON_VOLATILE,
        KEY_ALL_ACCESS,
        0,
        (PHKEY) &hKey,
        (LPDWORD) &lRtn
    ) != ERROR_SUCCESS)
    {   return;
    }
    DISCARD RegCloseKey(hKey);

    strcat(tempstring, "\\command"); // now foo_ext\shell\open\command
    // create the new registry key, the "command" key within the "open"
    // command key
    if (RegCreateKeyEx
    (   HKEY_CLASSES_ROOT,
        tempstring,
        0,
        NULL,
        REG_OPTION_NON_VOLATILE,
        KEY_ALL_ACCESS,
        0,
        (PHKEY) &hKey,
        (LPDWORD) &lRtn
    ) != ERROR_SUCCESS)
    {   return;
    }
    strcpy(tempstring, "\"");        // now "
    strcat(tempstring, ProgName);    // now "C:\E\S\WA\WA.EXE
    strcat(tempstring, "\" \"%1\""); // now "C:\E\S\WA\WA.EXE" "%1"
    // set "(default)" string value of the "command" key to the command
    // line to be used to open the file
    if (RegSetValueEx
    (   hKey,
        NULL,
        0,
        REG_SZ,
        tempstring,
        strlen(tempstring) + 1
    ) != ERROR_SUCCESS)
    {   DISCARD RegCloseKey(hKey);
        return;
    }
    DISCARD RegCloseKey(hKey);

#ifdef VERBOSE
    T1; zprintf("Associated %s.\n", filekind[kind].extension); T2;
#endif
}

EXPORT void setselection(void)
{   int i;

    if (currentgame != -1)
    {   ListView_SetItemState(hSideBar, currentgame, 0, 0x000F);
        currentgame = -1;
    }

    switch (machine)
    {
    case ASTROWARS:
    case GALAXIA:
    case MALZAK:
        for (i = 0; i < foundgames; i++)
        {   if (auditlist[sidebar[i]].memmap == memmap)
            {   currentgame = i;
                goto DONE;
        }   }
        // assert(0);
    adefault:
        for (i = 0; i < foundgames; i++)
        {   if (!stricmp(auditlist[sidebar[i]].filename, 
        fn_game))
            {   currentgame = i;
                goto DONE;
    }   }   }

DONE:
    if (showsidebar)
    {   ListView_SetItemState(hSideBar, currentgame, (LVIS_FOCUSED | LVIS_SELECTED), 0x000F);
        DISCARD ListView_EnsureVisible(hSideBar, currentgame, TRUE);
}   }

EXPORT void AddAnim(void)
{	HDC     hdc;
	HDC     hdcMem;
	HBITMAP hbitmap,
            hbitmapOld;

	hdc = GetDC(NULL);
	hdcMem = CreateCompatibleDC(NULL);
	hbitmap = CreateCompatibleBitmap(hdc, destwidth, destheight);

	hbitmapOld = SelectBitmap(hdcMem, hbitmap);
    DISCARD StretchDIBits
    (   hdcMem,
        0,              // dest leftx
        0,              // dest topy
        destwidth,      // dest width
        destheight,     // dest height
        0,              // source leftx
        0,              // source topy
        sourcewidth,    // source width
        sourceheight,   // source height
        display,        // pointer to the bits
        (const struct tagBITMAPINFO *) &TheBitMapInfo, // pointer to BITMAPINFO structure
        DIB_RGB_COLORS, // format of data
        SRCCOPY         // blit mode
    );
    DISCARD SelectBitmap(hdcMem, hbitmapOld);

	// Make this into a DIB and stuff it into the array
	AnimInfo = (LPBITMAPINFOHEADER) GlobalLock(MakeDib(hbitmap, 4)); // 4 bitplanes
	// assert(AnimInfo); (should check return code!)

	if (firstanim)
    {   DISCARD AVIStreamSetFormat
        (   psCompressed,
            0,
			AnimInfo,          // stream format
			(LONG) (AnimInfo->biSize + // format size
			        AnimInfo->biClrUsed * sizeof(RGBQUAD))
        ); // should check return code! (to be zero)
        firstanim = FALSE;
    }

	DISCARD AVIStreamWrite
    (   psCompressed,            // stream pointer
		frameno++,               // time of this frame
		1,                       // number to write
		(LPBYTE) AnimInfo +      // pointer to data
		AnimInfo->biSize +
		AnimInfo->biClrUsed * sizeof(RGBQUAD),
		(LONG) AnimInfo->biSizeImage, // size of this frame
		AVIIF_KEYFRAME,          // flags....
		NULL,
        NULL
    ); // should check return code! (to be zero)

	// Select all the old objects back and delete resources
	DeleteBitmap(hbitmap);
	DeleteObject(hdcMem);
	ReleaseDC(NULL, hdc);
}

MODULE HANDLE MakeDib(HBITMAP hbitmap, UINT bits)
{	HANDLE              hdib;
	HDC                 hdc;
	BITMAP              bitmap;
	UINT                wLineLen;
	DWORD               dwSize;
	DWORD               wColSize;
	LPBITMAPINFOHEADER  lpbi;
	LPBYTE              lpBits;

	DISCARD GetObject(hbitmap, sizeof(BITMAP), &bitmap) ;

	// Longword-align the width of the DIB
	// Figure out the size of the colour table
	// Calculate the size of the DIB
	wLineLen = (((bitmap.bmWidth * bits) + 31) / 32) * 4;
	wColSize = sizeof(RGBQUAD)*((bits <= 8) ? 1<<bits : 0);
	dwSize   = sizeof(BITMAPINFOHEADER)
             + wColSize
             + (DWORD)(UINT)wLineLen
             * (DWORD)(UINT)bitmap.bmHeight;

	// Allocate room for a DIB and set the LPBI fields
	hdib = GlobalAlloc(GHND, dwSize);
	if (!hdib)
    {   return hdib;
    }
	lpbi = (LPBITMAPINFOHEADER) GlobalLock(hdib);
	lpbi->biSize          = sizeof(BITMAPINFOHEADER);
	lpbi->biWidth         = bitmap.bmWidth;
	lpbi->biHeight        = bitmap.bmHeight;
	lpbi->biPlanes        = 1;
	lpbi->biBitCount      = (WORD) bits;
	lpbi->biCompression   = BI_RGB;
	lpbi->biSizeImage     = dwSize - sizeof(BITMAPINFOHEADER) - wColSize;
	lpbi->biXPelsPerMeter = 0;
	lpbi->biYPelsPerMeter = 0;
	lpbi->biClrUsed       = (bits <= 8) ? 1<<bits : 0;
	lpbi->biClrImportant  = 0;

	// Get the bits from the bitmap and stuff them after the LPBI
	lpBits = (LPBYTE) (lpbi + 1) + wColSize;

	hdc = CreateCompatibleDC(NULL);

	DISCARD GetDIBits
    (   hdc,
        hbitmap,
        0,
        (UINT) (bitmap.bmHeight),
        lpBits,
        (LPBITMAPINFO) lpbi,
        DIB_RGB_COLORS
    );

	// Fix this if GetDIBits messed it up...
	lpbi->biClrUsed = (bits <= 8) ? 1<<bits : 0;

	DeleteDC(hdc);
	GlobalUnlock(hdib);

	return hdib;
}

EXPORT void OpenAnim(STRPTR name)
{	HRESULT                  hr;
	AVISTREAMINFO            strhdr;
	AVICOMPRESSOPTIONS       opts;
//	AVICOMPRESSOPTIONS FAR * aopts[1] = {&opts};
    int                      rowsize;

    AVIFileInit();

	// Open the movie file for writing....

	hr = AVIFileOpen(&pfile,		 // returned file pointer
		       name,    	         // file name
		       OF_WRITE | OF_CREATE, // mode to open file with
		       NULL);			     // use handler determined
						             // from file extension....
	if (hr != AVIERR_OK)
		goto error;

	// Fill in the header for the video stream....

	_fmemset(&strhdr, 0, sizeof(strhdr));
	strhdr.fccType                = streamtypeVIDEO;// stream type
	strhdr.fccHandler             = 0;
	strhdr.dwScale                = 1;
	if (region == REGION_NTSC)
    {   strhdr.dwRate             = 60;
    } else
    {   // assert(region == REGION_PAL);
        strhdr.dwRate             = 50;
	}
    rowsize = destwidth / 2;
    if (rowsize % 4)
    {   rowsize += 4 - (rowsize % 4);
    }
    strhdr.dwSuggestedBufferSize  = (DWORD) (rowsize * destheight);
	DISCARD SetRect
    (   &strhdr.rcFrame,
        0, 0,                       // rectangle for stream
	    destwidth,
	    destheight
    );

	// And create the stream
	hr = AVIFileCreateStream(pfile,	// file pointer
			         &ps,		    // returned stream pointer
			         &strhdr);	    // stream header
	if (hr != AVIERR_OK) {
		goto error;
	}

	_fmemset(&opts, 0, sizeof(opts));
    opts.fccType    = streamtypeVIDEO; // stream type
    opts.fccHandler = mmioFOURCC('D', 'I', 'B', ' '); // no others seem to work :-(

	hr = AVIMakeCompressedStream(&psCompressed, ps, &opts, NULL);
	if (hr != AVIERR_OK) {
		goto error;
	}

    firstanim = TRUE;
    frameno = 1;
    return;

error:
    CloseAnim();
}

EXPORT void CloseAnim(void)
{	if (ps)
    {   DISCARD AVIStreamClose(ps);
        ps = NULL;
    }
	if (psCompressed)
	{	DISCARD AVIStreamClose(psCompressed);
        psCompressed = NULL;
    }
	if (pfile)
	{	DISCARD AVIFileClose(pfile);
        pfile = NULL;
    }

	AVIFileExit();

	if (AnimInfo)
    {   DISCARD GlobalFreePtr(AnimInfo);
        AnimInfo = NULL;
}   }

EXPORT void clip_open(FLAG empty)
{   DISCARD OpenClipboard(NULL);
    if (empty)
    {   DISCARD EmptyClipboard();
}   }

EXPORT void clip_write(STRPTR data, int localsize, UINT kind)
{   HGLOBAL hGlobal;
    STRPTR  pGlobal;
    int     i;

    hGlobal = GlobalAlloc(GMEM_MOVEABLE | GMEM_DDESHARE, (DWORD) localsize);
    pGlobal = GlobalLock(hGlobal);
    for (i = 0; i < localsize; i++)
    {   pGlobal[i] = data[i];
    }
    GlobalUnlock(hGlobal);

    DISCARD SetClipboardData(kind, hGlobal);
}

EXPORT void clip_read(void)
{   TRANSIENT HGLOBAL hGlobal;
    TRANSIENT STRPTR  pGlobal;
    TRANSIENT int     i, thesize;
    PERSIST   TEXT    PasteBuffer[QUEUESIZE + 1]; // PERSISTent so as not to overflow the stack

 /* if (!(IsClipboardFormatAvailable(CF_TEXT)))
    {   return;
    } */
    if (!(hGlobal = GetClipboardData(CF_TEXT)))
    {   return;
    }
    thesize = (int) GlobalSize(hGlobal);
    if (thesize > QUEUESIZE / 2)
    {   thesize = QUEUESIZE / 2;
    }
    pGlobal = GlobalLock(hGlobal);
    for (i = 0; i < thesize; i++)
    {   PasteBuffer[i] = pGlobal[i];
    }
    GlobalUnlock(hGlobal);
    PasteBuffer[thesize] = 0;

    if (thesize <= 1) // because it's NULL-terminated
    {   return;
    }

#ifdef VERBOSE
    T1; zprintf("Pasting %s (%d characters).\n", PasteBuffer, thesize);
#endif

    for (i = 0; i < thesize - 1; i++)
    {   if
        (   (machine == CD2650 && queuepos >= QUEUESIZE - 1)
         || queuepos >= QUEUESIZE
         || PasteBuffer[i] == 0
        )
        {   break;
        } // implied else

        switch (machine)
        {
        case PIPBUG:
            if (PasteBuffer[i] == LF)
            {   continue;
            }
        acase CD2650:
            if (PasteBuffer[i] >= 'a' && PasteBuffer[i] <= 'z')
            {   PasteBuffer[i] -= 96;
        }   }

        // not enqueue() for these!
        thequeue[queuepos++] = PasteBuffer[i];
        if (machine == CD2650)
        {   thequeue[queuepos++] = 0xFF;
}   }   }

EXPORT void clip_close(void)
{   CloseClipboard();
}

EXPORT void edit_copytext(void)
{   if (machine == INTERTON)
    {   return;
    }

    edit_copytext_engine();

    clip_open(TRUE);
    clip_write(ProjectBuffer, (int) (strlen(ProjectBuffer) + 1), CF_TEXT);
    clip_close();
}

EXPORT void edit_pastetext(void)
{   if
    (   (   machine != PIPBUG
         && machine != CD2650
         && machine != CHAOS
         && machine != PHUNSY
        )
     || recmode == RECMODE_PLAY
    )
    {   return; // important!
    }

    clip_open(FALSE);
    clip_read();
    clip_close(); // it would be better to close the clipboard earlier
}

BOOL CALLBACK PaletteDlgProc(HWND hwnd, UINT Message, WPARAM wParam, LPARAM lParam)
{   TRANSIENT int   i;
    PERSIST   ULONG oldpens[GUESTCOLOURS];

    switch (Message)
    {
    case WM_INITDIALOG:
        charset = CHARSET_WIN;
        DISCARD SetWindowText( hwnd, LLL, MSG_HAIL_PALETTE, "Palette Editor"));

        if (language == LANGUAGE_RUS)
        {   DISCARD SendMessage(GetDlgItem(hwnd, IDL_R              ), WM_SETFONT, (WPARAM) hRussianFont, MAKELPARAM(FALSE, 0));
            DISCARD SendMessage(GetDlgItem(hwnd, IDL_G              ), WM_SETFONT, (WPARAM) hRussianFont, MAKELPARAM(FALSE, 0));
            DISCARD SendMessage(GetDlgItem(hwnd, IDL_B              ), WM_SETFONT, (WPARAM) hRussianFont, MAKELPARAM(FALSE, 0));
            DISCARD SendMessage(GetDlgItem(hwnd, IDC_PEN0           ), WM_SETFONT, (WPARAM) hRussianFont, MAKELPARAM(FALSE, 0));
            DISCARD SendMessage(GetDlgItem(hwnd, IDC_PEN1           ), WM_SETFONT, (WPARAM) hRussianFont, MAKELPARAM(FALSE, 0));
            DISCARD SendMessage(GetDlgItem(hwnd, IDC_PEN2           ), WM_SETFONT, (WPARAM) hRussianFont, MAKELPARAM(FALSE, 0));
            DISCARD SendMessage(GetDlgItem(hwnd, IDC_PEN3           ), WM_SETFONT, (WPARAM) hRussianFont, MAKELPARAM(FALSE, 0));
            DISCARD SendMessage(GetDlgItem(hwnd, IDC_PEN4           ), WM_SETFONT, (WPARAM) hRussianFont, MAKELPARAM(FALSE, 0));
            DISCARD SendMessage(GetDlgItem(hwnd, IDC_PEN5           ), WM_SETFONT, (WPARAM) hRussianFont, MAKELPARAM(FALSE, 0));
            DISCARD SendMessage(GetDlgItem(hwnd, IDC_PEN6           ), WM_SETFONT, (WPARAM) hRussianFont, MAKELPARAM(FALSE, 0));
            DISCARD SendMessage(GetDlgItem(hwnd, IDC_PEN7           ), WM_SETFONT, (WPARAM) hRussianFont, MAKELPARAM(FALSE, 0));
            DISCARD SendMessage(GetDlgItem(hwnd, IDC_PEN8           ), WM_SETFONT, (WPARAM) hRussianFont, MAKELPARAM(FALSE, 0));
            DISCARD SendMessage(GetDlgItem(hwnd, IDC_PEN9           ), WM_SETFONT, (WPARAM) hRussianFont, MAKELPARAM(FALSE, 0));
            DISCARD SendMessage(GetDlgItem(hwnd, IDC_PEN10          ), WM_SETFONT, (WPARAM) hRussianFont, MAKELPARAM(FALSE, 0));
            DISCARD SendMessage(GetDlgItem(hwnd, IDC_PEN11          ), WM_SETFONT, (WPARAM) hRussianFont, MAKELPARAM(FALSE, 0));
            DISCARD SendMessage(GetDlgItem(hwnd, IDC_PEN12          ), WM_SETFONT, (WPARAM) hRussianFont, MAKELPARAM(FALSE, 0));
            DISCARD SendMessage(GetDlgItem(hwnd, IDC_PEN13          ), WM_SETFONT, (WPARAM) hRussianFont, MAKELPARAM(FALSE, 0));
            DISCARD SendMessage(GetDlgItem(hwnd, IDC_PEN14          ), WM_SETFONT, (WPARAM) hRussianFont, MAKELPARAM(FALSE, 0));
            DISCARD SendMessage(GetDlgItem(hwnd, IDC_PEN15          ), WM_SETFONT, (WPARAM) hRussianFont, MAKELPARAM(FALSE, 0));
            DISCARD SendMessage(GetDlgItem(hwnd, IDC_PEN16          ), WM_SETFONT, (WPARAM) hRussianFont, MAKELPARAM(FALSE, 0));
            DISCARD SendMessage(GetDlgItem(hwnd, IDC_PEN17          ), WM_SETFONT, (WPARAM) hRussianFont, MAKELPARAM(FALSE, 0));
            DISCARD SendMessage(GetDlgItem(hwnd, IDC_PEN18          ), WM_SETFONT, (WPARAM) hRussianFont, MAKELPARAM(FALSE, 0));
            DISCARD SendMessage(GetDlgItem(hwnd, IDC_PEN19          ), WM_SETFONT, (WPARAM) hRussianFont, MAKELPARAM(FALSE, 0));
            DISCARD SendMessage(GetDlgItem(hwnd, IDC_PEN20          ), WM_SETFONT, (WPARAM) hRussianFont, MAKELPARAM(FALSE, 0));
            DISCARD SendMessage(GetDlgItem(hwnd, IDC_PEN21          ), WM_SETFONT, (WPARAM) hRussianFont, MAKELPARAM(FALSE, 0));
            DISCARD SendMessage(GetDlgItem(hwnd, IDC_PEN22          ), WM_SETFONT, (WPARAM) hRussianFont, MAKELPARAM(FALSE, 0));
            DISCARD SendMessage(GetDlgItem(hwnd, IDC_PEN23          ), WM_SETFONT, (WPARAM) hRussianFont, MAKELPARAM(FALSE, 0));
            DISCARD SendMessage(GetDlgItem(hwnd, IDC_RESETTODEFAULTS), WM_SETFONT, (WPARAM) hRussianFont, MAKELPARAM(FALSE, 0));
            DISCARD SendMessage(GetDlgItem(hwnd, IDOK               ), WM_SETFONT, (WPARAM) hRussianFont, MAKELPARAM(FALSE, 0));
            DISCARD SendMessage(GetDlgItem(hwnd, IDCANCEL           ), WM_SETFONT, (WPARAM) hRussianFont, MAKELPARAM(FALSE, 0));
        }
        DISCARD SetDlgItemText(hwnd, IDL_R,               LLL, MSG_LABEL_RED      , "R"            ));
        DISCARD SetDlgItemText(hwnd, IDL_G,               LLL, MSG_LABEL_GREEN    , "G"            ));
        DISCARD SetDlgItemText(hwnd, IDL_B,               LLL, MSG_LABEL_BLUE     , "B"            ));
        DISCARD SetDlgItemText(hwnd, IDC_PEN0,            LLL, MSG_COLOUR2_WHITE  , "White"        ));
        DISCARD SetDlgItemText(hwnd, IDC_PEN1,            LLL, MSG_COLOUR2_YELLOW , "Yellow"       ));
        DISCARD SetDlgItemText(hwnd, IDC_PEN2,            LLL, MSG_COLOUR2_LPURPLE, "Bright Purple"));
        DISCARD SetDlgItemText(hwnd, IDC_PEN3,            LLL, MSG_COLOUR2_LRED   , "Bright Red"   ));
        DISCARD SetDlgItemText(hwnd, IDC_PEN4,            LLL, MSG_COLOUR2_LCYAN  , "Bright Cyan"  ));
        DISCARD SetDlgItemText(hwnd, IDC_PEN5,            LLL, MSG_COLOUR2_LGREEN , "Bright Green" ));
        DISCARD SetDlgItemText(hwnd, IDC_PEN6,            LLL, MSG_COLOUR2_LBLUE  , "Bright Blue"  ));
        DISCARD SetDlgItemText(hwnd, IDC_PEN7,            LLL, MSG_COLOUR2_BLACK1 , "Black #1"     ));
        DISCARD SetDlgItemText(hwnd, IDC_PEN8,            LLL, MSG_COLOUR2_GREY   , "Grey #1"      ));
        DISCARD SetDlgItemText(hwnd, IDC_PEN9,            LLL, MSG_COLOUR2_BROWN  , "Brown"        ));
        DISCARD SetDlgItemText(hwnd, IDC_PEN10,           LLL, MSG_COLOUR2_DPURPLE, "Dark Purple"  ));
        DISCARD SetDlgItemText(hwnd, IDC_PEN11,           LLL, MSG_COLOUR2_DRED   , "Dark Red"     ));
        DISCARD SetDlgItemText(hwnd, IDC_PEN12,           LLL, MSG_COLOUR2_DCYAN  , "Dark Cyan"    ));
        DISCARD SetDlgItemText(hwnd, IDC_PEN13,           LLL, MSG_COLOUR2_DGREEN , "Dark Green"   ));
        DISCARD SetDlgItemText(hwnd, IDC_PEN14,           LLL, MSG_COLOUR2_DBLUE  , "Dark Blue"    ));
        DISCARD SetDlgItemText(hwnd, IDC_PEN15,           LLL, MSG_COLOUR2_BLACK2 , "Black #2"     ));
        DISCARD SetDlgItemText(hwnd, IDC_PEN16,           LLL, MSG_COLOUR2_GREY2  , "Grey #2"      ));
        DISCARD SetDlgItemText(hwnd, IDC_PEN17,           LLL, MSG_COLOUR2_GREY3  , "Grey #3"      ));
        DISCARD SetDlgItemText(hwnd, IDC_PEN18,           LLL, MSG_COLOUR2_GREY4  , "Grey #4"      ));
        DISCARD SetDlgItemText(hwnd, IDC_PEN19,           LLL, MSG_COLOUR2_GREY5  , "Grey #5"      ));
        DISCARD SetDlgItemText(hwnd, IDC_PEN20,           LLL, MSG_COLOUR2_GREY6  , "Grey #6"      ));
        DISCARD SetDlgItemText(hwnd, IDC_PEN21,           LLL, MSG_COLOUR2_GREY7  , "Grey #7"      ));
        DISCARD SetDlgItemText(hwnd, IDC_PEN22,           LLL, MSG_COLOUR2_ORANGE , "Orange"       ));
        DISCARD SetDlgItemText(hwnd, IDC_PEN23,           LLL, MSG_COLOUR2_PINK   , "Pink"         ));

        DISCARD SetDlgItemText(hwnd, IDC_RESETTODEFAULTS, LLL, MSG_RESETTODEFAULTS, "Reset to defaults"));
        DISCARD SetDlgItemText(hwnd, IDOK,                LLL, MSG_OK             , "OK"               ));
        DISCARD SetDlgItemText(hwnd, IDCANCEL,            LLL, MSG_CANCEL         , "Cancel"           ));
        charset = CHARSET_DOS;

        DISCARD CheckRadioButton
        (   hwnd,
            IDC_PEN0,
            IDC_PEN23,
            IDC_PEN0 + whichpen
        );
        checkcolours();
        if (resetdisabled) // all are defaults
        {   EnableWindow(GetDlgItem(hwnd, IDC_RESETTODEFAULTS), FALSE);
        } else // not all are defaults
        {   EnableWindow(GetDlgItem(hwnd, IDC_RESETTODEFAULTS), TRUE );
        }
        DISCARD SendMessage
        (   GetDlgItem(hwnd, IDC_RED),
            TBM_SETRANGE,
            FALSE,
            MAKELONG(0, 255)
        );
        DISCARD SendMessage
        (   GetDlgItem(hwnd, IDC_GREEN),
            TBM_SETRANGE,
            FALSE,
            MAKELONG(0, 255)
        );
        DISCARD SendMessage
        (   GetDlgItem(hwnd, IDC_BLUE),
            TBM_SETRANGE,
            FALSE,
            MAKELONG(0, 255)
        );
        DISCARD SendMessage
        (   GetDlgItem(hwnd, IDC_RED),
            TBM_SETPOS,
            TRUE,
            255 - ((pens[colourset][whichpen] & 0x00FF0000) >> 16)
        );
        DISCARD SendMessage
        (   GetDlgItem(hwnd, IDC_GREEN),
            TBM_SETPOS,
            TRUE,
            255 - ((pens[colourset][whichpen] & 0x0000FF00) >>  8)
        );
        DISCARD SendMessage
        (   GetDlgItem(hwnd, IDC_BLUE),
            TBM_SETPOS,
            TRUE,
            255 -  (pens[colourset][whichpen] & 0x000000FF)
        );
        DISCARD SendMessage
        (   GetDlgItem(hwnd, IDC_RED),
            TBM_SETTICFREQ,
            64,
            0
        );
        DISCARD SendMessage
        (   GetDlgItem(hwnd, IDC_GREEN),
            TBM_SETTICFREQ,
            64,
            0
        );
        DISCARD SendMessage
        (   GetDlgItem(hwnd, IDC_BLUE),
            TBM_SETTICFREQ,
            64,
            0
        );
        for (i = 0; i < GUESTCOLOURS; i++)
        {   oldpens[i] = pens[colourset][i];
        }
        return TRUE;
    case WM_CLOSE: // no need for acase
        DestroyWindow(hwnd);
        PaletteWindowPtr = NULL;
        updatemenu(MENUITEM_PALETTE);
        return TRUE;
    case WM_COMMAND: // no need for acase
        if (LOWORD(wParam) >= IDC_PEN0 && LOWORD(wParam) <= IDC_PEN23)
        {   whichpen = LOWORD(wParam) - IDC_PEN0;
            DISCARD SendMessage
            (   GetDlgItem(hwnd, IDC_RED),
                TBM_SETPOS,
                TRUE,
                255 - ((pens[colourset][whichpen] & 0x00FF0000) >> 16)
            );
            DISCARD SendMessage
            (   GetDlgItem(hwnd, IDC_GREEN),
                TBM_SETPOS,
                TRUE,
                255 - ((pens[colourset][whichpen] & 0x0000FF00) >>  8)
            );
            DISCARD SendMessage
            (   GetDlgItem(hwnd, IDC_BLUE),
                TBM_SETPOS,
                TRUE,
                255 - (pens[colourset][whichpen] & 0x000000FF)
            );
        } else switch (LOWORD(wParam))
        {
        case IDC_RESETTODEFAULTS:
            for (i = 0; i < GUESTCOLOURS; i++)
            {   resetcolour(colourset, i, FALSE);
            }
            redrawscreen();
            DISCARD SendMessage
            (   GetDlgItem(hwnd, IDC_RED),
                TBM_SETPOS,
                TRUE,
                255 - ((pens[colourset][whichpen] & 0x00FF0000) >> 16)
            );
            DISCARD SendMessage
            (   GetDlgItem(hwnd, IDC_GREEN),
                TBM_SETPOS,
                TRUE,
                255 - ((pens[colourset][whichpen] & 0x0000FF00) >>  8)
            );
            DISCARD SendMessage
            (   GetDlgItem(hwnd, IDC_BLUE),
                TBM_SETPOS,
                TRUE,
                255 -  (pens[colourset][whichpen] & 0x000000FF)
            );
            resetdisabled = TRUE;
            EnableWindow(GetDlgItem(hwnd, IDC_RESETTODEFAULTS), FALSE);
        acase IDCANCEL:
            for (i = 0; i < GUESTCOLOURS; i++)
            {   pens[colourset][               i] =  oldpens[i];
                pens[colourset][GUESTCOLOURS + i] = (oldpens[i] & 0x00FEFEFE) >> 1;
            }
            redrawscreen();
//lint -fallthrough
        case IDOK:
            DestroyWindow(hwnd);
            PaletteWindowPtr = NULL;
            updatemenu(MENUITEM_PALETTE);
            return TRUE;
        }
        return FALSE;
    case WM_VSCROLL: // no need for acase
        if (lParam == (long) GetDlgItem(hwnd, IDC_RED))
        {   pens[colourset][whichpen] &= 0x0000FFFF;
            pens[colourset][whichpen] |= ((ULONG) (255 - SendMessage
            (   GetDlgItem(hwnd, IDC_RED),
                TBM_GETPOS,
                0,
                0
            )) << 16);
            // because LOWORD(lParam) is not always correct

            if (colourset == GREYSCALE)
            {   pens[colourset][whichpen] &= 0x00FF0000;
                pens[colourset][whichpen] |= (pens[colourset][whichpen] >>  8)
                                          |  (pens[colourset][whichpen] >> 16);

                DISCARD SendMessage
                (   GetDlgItem(hwnd, IDC_GREEN),
                    TBM_SETPOS,
                    TRUE,
                    255 - ((pens[colourset][whichpen] & 0x0000FF00) >>  8)
                );
                DISCARD SendMessage
                (   GetDlgItem(hwnd, IDC_BLUE),
                    TBM_SETPOS,
                    TRUE,
                    255 -  (pens[colourset][whichpen] & 0x000000FF)
                );
            }
            pens[colourset][16 + whichpen] = (pens[colourset][whichpen] & 0x00FEFEFE) >> 1;
        } elif (lParam == (long) GetDlgItem(hwnd, IDC_GREEN))
        {   pens[colourset][whichpen] &= 0x00FF00FF;
            pens[colourset][whichpen] |= ((ULONG) (255 - SendMessage
            (   GetDlgItem(hwnd, IDC_GREEN),
                TBM_GETPOS,
                0,
                0
            )) << 8);
            // because LOWORD(lParam) is not always correct

            if (colourset == GREYSCALE)
            {   pens[colourset][whichpen] &= 0x0000FF00;
                pens[colourset][whichpen] |= (pens[colourset][whichpen] <<  8)
                                          |  (pens[colourset][whichpen] >>  8);

                DISCARD SendMessage
                (   GetDlgItem(hwnd, IDC_RED),
                    TBM_SETPOS,
                    TRUE,
                    255 - ((pens[colourset][whichpen] & 0x00FF0000) >> 16)
                );
                DISCARD SendMessage
                (   GetDlgItem(hwnd, IDC_BLUE),
                    TBM_SETPOS,
                    TRUE,
                    255 -  (pens[colourset][whichpen] & 0x000000FF)
                );
            }
            pens[colourset][GUESTCOLOURS + whichpen] = (pens[colourset][whichpen] & 0x00FEFEFE) >> 1;
        } elif (lParam == (long) GetDlgItem(hwnd, IDC_BLUE))
        {   pens[colourset][whichpen] &= 0x00FFFF00;
            pens[colourset][whichpen] |= (ULONG) (255 - SendMessage
            (   GetDlgItem(hwnd, IDC_BLUE),
                TBM_GETPOS,
                0,
                0
            )); // because LOWORD(lParam) is not always correct

            if (colourset == GREYSCALE)
            {   pens[colourset][whichpen] &= 0x000000FF;
                pens[colourset][whichpen] |= (pens[colourset][whichpen] << 16)
                                          |  (pens[colourset][whichpen] <<  8);

                DISCARD SendMessage
                (   GetDlgItem(hwnd, IDC_RED),
                    TBM_SETPOS,
                    TRUE,
                    255 - ((pens[colourset][whichpen] & 0x0000FF00) >> 8)
                );
                DISCARD SendMessage
                (   GetDlgItem(hwnd, IDC_GREEN),
                    TBM_SETPOS,
                    TRUE,
                    255 -  (pens[colourset][whichpen] & 0x000000FF)
                );
            }
            pens[colourset][GUESTCOLOURS + whichpen] = (pens[colourset][whichpen] & 0x00FEFEFE) >> 1;
        }

        redrawscreen();
        checkcolours();
        if (resetdisabled) // all are defaults
        {   EnableWindow(GetDlgItem(hwnd, IDC_RESETTODEFAULTS), FALSE);
        } else // not all are defaults
        {   EnableWindow(GetDlgItem(hwnd, IDC_RESETTODEFAULTS), TRUE );
        }

        return FALSE;
    case WM_ACTIVATE: // no need for acase
        do_autopause(wParam, lParam);
        return TRUE;
    adefault: // no need for adefault
        return FALSE;
}   }

MODULE void checkcolours(void)
{   int i;

    resetdisabled = TRUE;
    for (i = 0; i < GUESTCOLOURS; i++)
    {   if
        (   (pens[colourset][i] & 0x00FFFFFF)
         != defpencolours[colourset][wsc][i]
        )
        {   resetdisabled = FALSE;
            return; // for speed
}   }   }

EXPORT void makedisplay(void)
{
#ifdef OLDWAY
    memset(&TheBitMapInfo, 0, sizeof(TheBitMapInfo));

    TheBitMapInfo.Header.biWidth           = sourcewidth;
    TheBitMapInfo.Header.biHeight          = -sourceheight;
    TheBitMapInfo.Header.biSize            = sizeof(BITMAPINFOHEADER);
    TheBitMapInfo.Header.biBitCount        = 32;
    TheBitMapInfo.Header.biPlanes          = 1;
    TheBitMapInfo.Header.biCompression     = BI_RGB;
    TheBitMapInfo.Header.biSizeImage       = (   (   (   TheBitMapInfo.Header.biWidth
                                                       * TheBitMapInfo.Header.biBitCount
                                                       / 8
                                                     )
                                                   + 3
                                                 ) & 0xFFFFFFFC
                                             )
                                           * TheBitMapInfo.Header.biHeight;
    TheBitMapInfo.Header.biXPelsPerMeter   = 10000;
    TheBitMapInfo.Header.biYPelsPerMeter   = 10000;
    TheBitMapInfo.Colours[0]               = 0x00FF0000;
    TheBitMapInfo.Colours[1]               = 0x0000FF00;
    TheBitMapInfo.Colours[2]               = 0x000000FF;
#endif
#ifdef NEWWAY
    TheBitMapInfo.bmiHeader.biSizeImage     = 0;
    TheBitMapInfo.bmiHeader.biXPelsPerMeter = 0;
    TheBitMapInfo.bmiHeader.biYPelsPerMeter = 0;
    TheBitMapInfo.bmiHeader.biClrUsed       = 0;
    TheBitMapInfo.bmiHeader.biClrImportant  = 0;
    TheBitMapInfo.bmiHeader.biWidth         = sourcewidth;
    TheBitMapInfo.bmiHeader.biHeight        = -sourceheight;
    TheBitMapInfo.bmiHeader.biSize          = sizeof(BITMAPINFO);
    TheBitMapInfo.bmiHeader.biBitCount      = 32;
    TheBitMapInfo.bmiHeader.biPlanes        = 1;
    TheBitMapInfo.bmiHeader.biCompression   = BI_RGB;
    TheBitMapInfo.bmiColors[0].rgbRed       =
    TheBitMapInfo.bmiColors[0].rgbGreen     =
    TheBitMapInfo.bmiColors[0].rgbBlue      =
    TheBitMapInfo.bmiColors[0].rgbReserved  = 0;
#endif

#ifdef OLDWAY
    if (!(OurhDC = CreateCompatibleDC(0)))
    {   MessageBox
        (   NULL,
            "CreateCompatibleDC() failed!",
            "WinArcadia: Error",
            MB_ICONEXCLAMATION | MB_OK
        );
        cleanexit(EXIT_FAILURE);
    }
#endif
#ifdef NEWWAY
    if (!(OurhDC = GetDC(MainWindowPtr)))
    {   MessageBox
        (   NULL,
            "GetDC() failed!",
            "WinArcadia: Error",
            MB_ICONEXCLAMATION | MB_OK
        );
        cleanexit(EXIT_FAILURE);
    }
#endif

    if (!(OurhBitMap = CreateDIBSection
    (   OurhDC,
        (BITMAPINFO *) &TheBitMapInfo,
        DIB_RGB_COLORS,
        &display,
        0,
        0
    )))
    {   MessageBox
        (   NULL,
            "CreateDIBSection() failed!",
            "WinArcadia: Error",
            MB_ICONEXCLAMATION | MB_OK
        );
        cleanexit(EXIT_FAILURE);
    }

#ifdef OLDWAY
    if (!(SelectObject(OurhDC, OurhBitMap)))
    {   MessageBox
        (   NULL,
            "SelectObject() failed!",
            "WinArcadia: Error",
            MB_ICONEXCLAMATION | MB_OK
        );
        cleanexit(EXIT_FAILURE);
    }
#endif
#ifdef NEWWAY
    DISCARD ReleaseDC(MainWindowPtr, OurhDC);
#endif

    make_stars();
}

EXPORT void make_stars(void)
{   int   stardensity,
#ifdef SKYIMAGERY
          destx, desty,
#endif
          i, j, x, y;
    ULONG value;

#define STARDENSITY 256
// lower numbers mean denser stars (1 star per STARDENSITY pixels)

    if (sourcewidth == 0 || sourceheight == 0)
    {   return; // important!
    }

    if (fullscreen && stretch)
    {   stardensity = STARDENSITY * 4;
    } else
    {   stardensity = STARDENSITY;
    }

    // these 5 parts (sky, stars, nebula, comet, moon) are order-dependent!

    if ((machine == INTERTON || machine == ELEKTOR) && flagline)
    {   for (x = 0; x < rastwidth; x++)
        {   for (y = 0; y < rastheight; y++)
            {   stars[x + (y * rastwidth)] = pens[colourset][8 + starfield];
    }   }   }
    else
    {   for (x = 0; x < rastwidth; x++)
        {   for (y = 0; y < rastheight; y++)
            {   stars[x + (y * rastwidth)] = pens[colourset][starfield];
    }   }   }

    j = (rastwidth * rastheight) / stardensity;
    for (i = 0; i < j; i++)
    {   x = rand() % sourcewidth;
        y = rand() % sourceheight;
        if (colourset == COLOURFUL)
        {   stars[x + (y * rastwidth)] = (((ULONG) (64 + (rand() % 192))) << 16)
                                       + (((ULONG) (64 + (rand() % 192))) <<  8)
                                       +  ((ULONG) (64 + (rand() % 192)));
        } else
        {   // assert(colourset == GREYSCALE);
            value = (ULONG) (int) (64 + (rand() % 192));
            stars[x + (y * rastwidth)] = (value << 16)
                                       + (value <<  8)
                                       +  value;
    }   }

#ifdef SKYIMAGERY
if ((!fullscreen || !stretch) && starfield == BLACK)
{   if (rand() % NEBULAFREQ == 0)
    {   destx = rand() % sourcewidth;
        desty = rand() % (sourceheight / 2); // top 1/2 of the screen
        if (realsize >= 2)
        {   if (destx >= sourcewidth  - BIGNEBULAWIDTH ) destx -= BIGNEBULAWIDTH;
            if (desty >= sourceheight - BIGNEBULAHEIGHT) desty -= BIGNEBULAHEIGHT;
            for (x = 0; x < BIGNEBULAWIDTH; x++)
            {   for (y = 0; y < BIGNEBULAHEIGHT; y++)
                {   if (colourset == COLOURFUL)
                    {   stars[destx + x + ((desty + y) * rastwidth)] = bignebulaimagery[(y * BIGNEBULAWIDTH) + x];
                    } else
                    {   // assert(colourset == GREYSCALE);
                        value = (((bignebulaimagery[(y * BIGNEBULAWIDTH) + x] & 0xFF0000) >> 16)
                              +  ((bignebulaimagery[(y * BIGNEBULAWIDTH) + x] & 0x00FF00) >>  8)
                              +   (bignebulaimagery[(y * BIGNEBULAWIDTH) + x] & 0x0000FF)) / 3;
                        value |= (value << 16) | (value << 8);
                        stars[destx + x + ((desty + y) * rastwidth)] = value;
        }   }   }   }
        else
        {   if (destx >= sourcewidth  - SMLNEBULAWIDTH ) destx -= SMLNEBULAWIDTH;
            if (desty >= sourceheight - SMLNEBULAHEIGHT) desty -= SMLNEBULAHEIGHT;
            for (x = 0; x < SMLNEBULAWIDTH; x++)
            {   for (y = 0; y < SMLNEBULAHEIGHT; y++)
                {   if (colourset == COLOURFUL)
                    {   stars[destx + x + ((desty + y) * rastwidth)] = smlnebulaimagery[(y * SMLNEBULAWIDTH) + x];
                    } else
                    {   // assert(colourset == GREYSCALE);
                        value = (((smlnebulaimagery[(y * SMLNEBULAWIDTH) + x] & 0xFF0000) >> 16)
                              +  ((smlnebulaimagery[(y * SMLNEBULAWIDTH) + x] & 0x00FF00) >>  8)
                              +   (smlnebulaimagery[(y * SMLNEBULAWIDTH) + x] & 0x0000FF)) / 3;
                        value |= (value << 16) | (value << 8);
                        stars[destx + x + ((desty + y) * rastwidth)] = value;
    }   }   }   }   }

    if (rand() % COMETFREQ == 0)
    {   destx = rand() % sourcewidth;
        desty = rand() % ((sourceheight / 8) * 3); // top 3/8ths of the screen
        if (realsize >= 2)
        {   if (destx >= sourcewidth  - BIGCOMETWIDTH ) destx -= BIGCOMETWIDTH;
            if (desty >= sourceheight - BIGCOMETHEIGHT) desty -= BIGCOMETHEIGHT;
            for (x = 0; x < BIGCOMETWIDTH; x++)
            {   for (y = 0; y < BIGCOMETHEIGHT; y++)
                {   if (bigcometimagery[(y * BIGCOMETWIDTH) + x] != 0x000000)
                    {   if (colourset == COLOURFUL)
                        {   stars[destx + x + ((desty + y) * rastwidth)] = bigcometimagery[(y * BIGCOMETWIDTH) + x];
                        } else
                        {   // assert(colourset == GREYSCALE);
                            value = (((bigcometimagery[(y * BIGCOMETWIDTH) + x] & 0xFF0000) >> 16)
                                  +  ((bigcometimagery[(y * BIGCOMETWIDTH) + x] & 0x00FF00) >>  8)
                                  +   (bigcometimagery[(y * BIGCOMETWIDTH) + x] & 0x0000FF)) / 3;
                            value |= (value << 16) | (value << 8);
                            stars[destx + x + ((desty + y) * rastwidth)] = value;
        }   }   }   }   }
        else
        {   if (destx >= sourcewidth  - SMLCOMETWIDTH ) destx -= SMLCOMETWIDTH;
            if (desty >= sourceheight - SMLCOMETHEIGHT) desty -= SMLCOMETHEIGHT;
            for (x = 0; x < SMLCOMETWIDTH; x++)
            {   for (y = 0; y < SMLCOMETHEIGHT; y++)
                {   if (smlcometimagery[(y * SMLCOMETWIDTH) + x] != 0x000000)
                    {   if (colourset == COLOURFUL)
                        {   stars[destx + x + ((desty + y) * rastwidth)] = smlcometimagery[(y * SMLCOMETWIDTH) + x];
                        } else
                        {   // assert(colourset == GREYSCALE);
                            value = (((smlcometimagery[(y * SMLCOMETWIDTH) + x] & 0xFF0000) >> 16)
                                  +  ((smlcometimagery[(y * SMLCOMETWIDTH) + x] & 0x00FF00) >>  8)
                                  +   (smlcometimagery[(y * SMLCOMETWIDTH) + x] & 0x0000FF)) / 3;
                            value |= (value << 16) | (value << 8);
                            stars[destx + x + ((desty + y) * rastwidth)] = value;
    }   }   }   }   }   }

    if (rand() % MOONFREQ == 0)
    {   destx = rand() % sourcewidth;
        desty = rand() % ((sourceheight / 8) * 3); // top 3/8ths of the screen
        if (realsize >= 2)
        {   if (destx >= sourcewidth  - BIGMOONWIDTH ) destx -= BIGMOONWIDTH;
            if (desty >= sourceheight - BIGMOONHEIGHT) desty -= BIGMOONHEIGHT;
            for (x = 0; x < BIGMOONWIDTH; x++)
            {   for (y = 0; y < BIGMOONHEIGHT; y++)
                {   if (bigmoonimagery[(y * BIGMOONWIDTH) + x] != 0x000000)
                    {   if (colourset == COLOURFUL)
                        {   stars[destx + x + ((desty + y) * rastwidth)] = bigmoonimagery[(y * BIGMOONWIDTH) + x];
                        } else
                        {   // assert(colourset == GREYSCALE);
                            value = (((bigmoonimagery[(y * BIGMOONWIDTH) + x] & 0xFF0000) >> 16)
                                  +  ((bigmoonimagery[(y * BIGMOONWIDTH) + x] & 0x00FF00) >>  8)
                                  +   (bigmoonimagery[(y * BIGMOONWIDTH) + x] & 0x0000FF)) / 3;
                            value |= (value << 16) | (value << 8);
                            stars[destx + x + ((desty + y) * rastwidth)] = value;
        }   }   }   }   }
        else
        {   if (destx >= sourcewidth  - SMLMOONWIDTH ) destx -= SMLMOONWIDTH;
            if (desty >= sourceheight - SMLMOONHEIGHT) desty -= SMLMOONHEIGHT;
            for (x = 0; x < SMLMOONWIDTH; x++)
            {   for (y = 0; y < SMLMOONHEIGHT; y++)
                {   if (smlmoonimagery[(y * SMLMOONWIDTH) + x] != 0x000000)
                    {   if (colourset == COLOURFUL)
                        {   stars[destx + x + ((desty + y) * rastwidth)] = smlmoonimagery[(y * SMLMOONWIDTH) + x];
                        } else
                        {   // assert(colourset == GREYSCALE);
                            value = (((smlmoonimagery[(y * SMLMOONWIDTH) + x] & 0xFF0000) >> 16)
                                  +  ((smlmoonimagery[(y * SMLMOONWIDTH) + x] & 0x00FF00) >>  8)
                                  +   (smlmoonimagery[(y * SMLMOONWIDTH) + x] & 0x0000FF)) / 3;
                            value |= (value << 16) | (value << 8);
                            stars[destx + x + ((desty + y) * rastwidth)] = value;
}   }   }   }   }   }   }
#endif
}

EXPORT ULONG thetime(void)
{   return timeGetTime();
}

/* MODULE HDC GetPrinterDC(void)
{   DWORD            dwNeeded,
                     dwReturned;
    HDC              hdc;
    PRINTER_INFO_4 * pinfo4;
    PRINTER_INFO_5 * pinfo5;

    if (GetVersion() & 0x80000000) // Windows 98
    {   EnumPrinters(PRINTER_ENUM_DEFAULT, NULL, 5, NULL, 0, &dwNeeded, &dwReturned);
        pinfo5 = malloc(dwNeeded);
        EnumPrinters (PRINTER_ENUM_DEFAULT, NULL, 5, (PBYTE) pinfo5, dwNeeded, &dwNeeded, &dwReturned);
        hdc = CreateDC(NULL, pinfo5->pPrinterName, NULL, NULL);
        free(pinfo5);
    } else // Windows NT
    {   EnumPrinters(PRINTER_ENUM_LOCAL, NULL, 4, NULL, 0, &dwNeeded, &dwReturned);
        pinfo4 = malloc(dwNeeded);
        EnumPrinters(PRINTER_ENUM_LOCAL, NULL, 4, (PBYTE) pinfo4, dwNeeded, &dwNeeded, &dwReturned);
        hdc = CreateDC(NULL, pinfo4->pPrinterName, NULL, NULL);
        free(pinfo4);
    }

    return hdc;
}

MODULE void file_print(void)
{   PERSIST   DOCINFO di = { sizeof(DOCINFO), TEXT("WinArcadia") } ;
    TRANSIENT HDC     hdcPrint;
    TRANSIENT int     xMargin,
                      yMargin,
                      xPage,
                      yPage;

    if ((hdcPrint = GetPrinterDC()))                        // for Lexmark X1170...
    {   SetMapMode(hdcPrint, MM_TEXT);
     // xPage   = GetDeviceCaps(hdcPrint, PHYSICALWIDTH);   // 5100 width       of entire page in device units
     // yPage   = GetDeviceCaps(hdcPrint, PHYSICALHEIGHT);  // 6600 height      of entire page in device units
        xPage   = GetDeviceCaps(hdcPrint, HORZRES);         // 4800 width       in pixels
        yPage   = GetDeviceCaps(hdcPrint, VERTRES);         // 6260 height      in pixels
        xMargin = GetDeviceCaps(hdcPrint, PHYSICALOFFSETX); //  150 top  margin in device units
        yMargin = GetDeviceCaps(hdcPrint, PHYSICALOFFSETY); //   40 left margin in device units

        if (StartDoc(hdcPrint, &di) > 0)
        {   if (StartPage(hdcPrint) > 0 && EndPage(hdcPrint) > 0)
            {   // assert (!stretch || !fullscreen);
                DISCARD StretchDIBits
                (   hdcPrint,
                    xMargin,        // dest leftx
                    yMargin,        // dest topy
                    xPage,          // dest width
                    yPage,          // dest height
                    0,              // source leftx
                    0,              // source topy
                    rastwidth,      // source width
                    rastheight,     // source height
                    display,        // pointer to the bits
                    (const struct tagBITMAPINFO *) &TheBitMapInfo, // pointer to BITMAPINFO structure
                    DIB_RGB_COLORS, // format of data
                    SRCCOPY         // blit mode
                );
                EndDoc(hdcPrint);
                T1; zprintf("Printing succeeded.\n"); T2;
        }   }
        DeleteDC(hdcPrint);
    } else
    {   T1; zprintf("Printing failed.\n"); T2;
}   } */

EXPORT void s_updatedips(FLAG full)
{   int i;

    DISCARD CheckRadioButton
    (   DIPsWindowPtr,
        IDC_INTERRUPTS_DIRECT,
        IDC_INTERRUPTS_INDIRECT,
        IDC_INTERRUPTS_DIRECT + s_intdir
    );
    DISCARD CheckRadioButton
    (   DIPsWindowPtr,
        IDC_INTSELECTOR_ACLINE,
        IDC_INTSELECTOR_KYBD,
        IDC_INTSELECTOR_ACLINE + s_intselector
    );
    DISCARD CheckRadioButton
    (   DIPsWindowPtr,
        IDC_PARALLEL_MEMMAPPED,
        IDC_PARALLEL_NONEXTENDED,
        IDC_PARALLEL_MEMMAPPED + s_io
    );

    if (!full) return;

    for (i = 0; i < 8; i++)
    {   if (s_toggles & (128 >> i))
        {   DISCARD SendMessage(GetDlgItem(DIPsWindowPtr, IDC_PARALLEL_BIT7 + i), BM_SETCHECK, BST_CHECKED,   0);
        } else
        {   DISCARD SendMessage(GetDlgItem(DIPsWindowPtr, IDC_PARALLEL_BIT7 + i), BM_SETCHECK, BST_UNCHECKED, 0);
}   }   }

BOOL CALLBACK s_DIPsDlgProc(HWND hwnd, UINT Message, WPARAM wParam, LPARAM lParam)
{   int i;

    switch (Message)
    {
    case WM_ACTIVATE:
        do_autopause(wParam, lParam);
    acase WM_CLOSE:
        DestroyWindow(hwnd);
        DIPsWindowPtr = NULL;
        updatemenu(MENUITEM_DIPSWITCHES);
    acase WM_INITDIALOG:
        charset = CHARSET_WIN;
        DISCARD SetWindowText(hwnd, LLL, MSG_HAIL_S_DIPS, "Signetics Instructor 50 DIP Switches"));
        charset = CHARSET_DOS;

        DIPsWindowPtr = hwnd;
        s_updatedips(TRUE);
        if (recmode == RECMODE_PLAY)
        {   ghost_dips(FALSE);
        }
        return TRUE;
    case WM_COMMAND: // no need for acase
        switch (LOWORD(wParam))
        {
        case IDOK:
            DestroyWindow(hwnd);
            DIPsWindowPtr = NULL;
            updatemenu(MENUITEM_DIPSWITCHES);
        acase IDC_INTERRUPTS_DIRECT:
            s_intdir = INTDIR_DIRECT;
        acase IDC_INTERRUPTS_INDIRECT:
            s_intdir = INTDIR_INDIRECT;
        acase IDC_INTSELECTOR_ACLINE:
            s_intselector = INTSEL_ACLINE;
        acase IDC_INTSELECTOR_KYBD:
            s_intselector = INTSEL_KYBD;
        acase IDC_PARALLEL_MEMMAPPED:
            s_io = PARALLEL_MEMMAPPED;
        acase IDC_PARALLEL_EXTENDED:
            s_io = PARALLEL_EXTENDED;
        acase IDC_PARALLEL_NONEXTENDED:
            s_io = PARALLEL_NONEXTENDED;
        adefault:
            if
            (   LOWORD(wParam) >= IDC_PARALLEL_BIT7
             && LOWORD(wParam) <= IDC_PARALLEL_BIT0
            )
            {   i = LOWORD(wParam) - IDC_PARALLEL_BIT7;

                if (SendMessage(GetDlgItem(hwnd, IDC_PARALLEL_BIT7 + i), BM_GETCHECK, 0, 0) == BST_CHECKED)
                {   s_toggles |= 128 >> i;
                } else
                {   s_toggles &= ~(128 >> i);
        }   }   }

        s_updatedips(FALSE);
        return FALSE;
    default: // no need for adefault
        return FALSE;
    }

    return TRUE;
}

EXPORT void g_updatedips(FLAG full)
{   DISCARD CheckRadioButton
    (   DIPsWindowPtr,
        IDC_LIVES_3,
        IDC_LIVES_5,
        IDC_LIVES_3 + ((g_dips & 8) / 8)
    );
    DISCARD CheckRadioButton
    (   DIPsWindowPtr,
        IDC_COINA_1C,
        IDC_COINA_5C,
        IDC_COINA_1C + (g_dips % 4)
    );
    DISCARD CheckRadioButton
    (   DIPsWindowPtr,
        IDC_COINB_HALFC,
        IDC_COINB_1C,
        IDC_COINB_HALFC + ((g_dips & 4) >> 2)
    );

    if (!full) return;

    if (!(g_dips & 0x80))
    {   DISCARD SendMessage(GetDlgItem(DIPsWindowPtr, IDC_FREEZE), BM_SETCHECK, BST_CHECKED, 0);
}   }

BOOL CALLBACK g_DIPsDlgProc(HWND hwnd, UINT Message, WPARAM wParam, LPARAM lParam)
{   PERSIST TEXT  tempstring[80 + 1]; // PERSISTent for speed
    PERSIST HICON hicon;

    switch (Message)
    {
    case WM_ACTIVATE:
        do_autopause(wParam, lParam);
    acase WM_INITDIALOG:
        charset = CHARSET_WIN;
        DISCARD SetWindowText( hwnd,                      LLL, MSG_HAIL_G_DIPS           , "Astro Wars/Galaxia DIP Switches"));

        if (language == LANGUAGE_RUS)
        {   DISCARD SendMessage(GetDlgItem(hwnd, IDL_LIVES          ), WM_SETFONT, (WPARAM) hRussianFont, MAKELPARAM(FALSE, 0));
            DISCARD SendMessage(GetDlgItem(hwnd, IDL_COINA          ), WM_SETFONT, (WPARAM) hRussianFont, MAKELPARAM(FALSE, 0));
            DISCARD SendMessage(GetDlgItem(hwnd, IDL_COINB          ), WM_SETFONT, (WPARAM) hRussianFont, MAKELPARAM(FALSE, 0));
            DISCARD SendMessage(GetDlgItem(hwnd, IDC_FREEZE         ), WM_SETFONT, (WPARAM) hRussianFont, MAKELPARAM(FALSE, 0));
            DISCARD SendMessage(GetDlgItem(hwnd, IDC_COINA_1C       ), WM_SETFONT, (WPARAM) hRussianFont, MAKELPARAM(FALSE, 0));
            DISCARD SendMessage(GetDlgItem(hwnd, IDC_COINA_2C       ), WM_SETFONT, (WPARAM) hRussianFont, MAKELPARAM(FALSE, 0));
            DISCARD SendMessage(GetDlgItem(hwnd, IDC_COINA_3C       ), WM_SETFONT, (WPARAM) hRussianFont, MAKELPARAM(FALSE, 0));
            DISCARD SendMessage(GetDlgItem(hwnd, IDC_COINA_5C       ), WM_SETFONT, (WPARAM) hRussianFont, MAKELPARAM(FALSE, 0));
            DISCARD SendMessage(GetDlgItem(hwnd, IDC_COINB_HALFC    ), WM_SETFONT, (WPARAM) hRussianFont, MAKELPARAM(FALSE, 0));
            DISCARD SendMessage(GetDlgItem(hwnd, IDC_COINB_1C       ), WM_SETFONT, (WPARAM) hRussianFont, MAKELPARAM(FALSE, 0));
        }
        DISCARD SetDlgItemText(hwnd, IDL_LIVES,           LLL, MSG_LIVES                 , "Lives"                          ));
        DISCARD SetDlgItemText(hwnd, IDL_COINA,           LLL, MSG_COIN_A                , "Coin A"                         ));
        DISCARD SetDlgItemText(hwnd, IDL_COINB,           LLL, MSG_COIN_B                , "Coin B"                         ));
        DISCARD SetDlgItemText(hwnd, IDC_FREEZE,          LLL, MSG_FREEZE2               , "Freeze?"                        ));
        strcpy(tempstring, "1 ");
        strcat(tempstring, LLL, MSG_CREDIT,  "credit"));
        DISCARD SetDlgItemText(hwnd, IDC_COINA_1C, tempstring);
        strcpy(tempstring, "2 ");
        strcat(tempstring, LLL, MSG_CREDITS, "credits"));
        DISCARD SetDlgItemText(hwnd, IDC_COINA_2C, tempstring);
        strcpy(tempstring, "3 ");
        strcat(tempstring, LLL, MSG_CREDITS, "credits"));
        DISCARD SetDlgItemText(hwnd, IDC_COINA_3C, tempstring);
        strcpy(tempstring, "5 ");
        strcat(tempstring, LLL, MSG_CREDITS, "credits"));
        DISCARD SetDlgItemText(hwnd, IDC_COINA_5C, tempstring);
        strcpy(tempstring, " ");
        strcat(tempstring, LLL, MSG_CREDIT,  "credit"));
        DISCARD SetDlgItemText(hwnd, IDC_COINB_HALFC, tempstring);
        strcpy(tempstring, "1 ");
        strcat(tempstring, LLL, MSG_CREDIT,  "credit"));
        DISCARD SetDlgItemText(hwnd, IDC_COINB_1C, tempstring);
        charset = CHARSET_DOS;

        // assert(machines[machine].icon);
        hicon = LoadIcon(InstancePtr, MAKEINTRESOURCE(hostmachines[machine].icon));
        DISCARD SendMessage(GetDlgItem(hwnd, IDL_DIPSGLYPH), STM_SETICON, (WPARAM) hicon, (LPARAM) 0);

        DIPsWindowPtr = hwnd;
        g_updatedips(TRUE);
        return TRUE;
    case WM_CLOSE: // no need for acase
        DestroyWindow(hwnd);
        DIPsWindowPtr = NULL;
        updatemenu(MENUITEM_DIPSWITCHES);
    acase WM_COMMAND:
        switch (LOWORD(wParam))
        {
        case IDOK:
            DestroyWindow(hwnd);
            DIPsWindowPtr = NULL;
            updatemenu(MENUITEM_DIPSWITCHES);
        acase IDC_LIVES_3:
            g_dips    &= 0xF7; // %0,x,xx
        acase IDC_LIVES_5:
            g_dips    |= 0x08; // %1,x,xx
        acase IDC_COINA_1C:
            g_dips    &= 0xFC; // %x,x,00
        acase IDC_COINA_2C:
            g_dips    &= 0xFC; // %x,x,00
            g_dips    |=    1; // %x,x,01
        acase IDC_COINA_3C:
            g_dips    &= 0xFC; // %x,x,00
            g_dips    |=    2; // %x,x,10
        acase IDC_COINA_5C:
            g_dips    |=    3; // %x,x,11
        acase IDC_COINB_HALFC:
            g_dips    &= 0xFB; // %x,0,xx
        acase IDC_COINB_1C:
            g_dips    |= 0x04; // %x,1,xx
        acase IDC_FREEZE:
            if (SendMessage(GetDlgItem(hwnd, IDC_FREEZE), BM_GETCHECK, 0, 0) == BST_CHECKED)
            {   g_dips &= 0x7F;
            } else g_dips |= 0x80;
        }

        g_updatedips(FALSE);
        return FALSE;
    default: // no need for adefault
        return FALSE;
    }

    return TRUE;
}

EXPORT void m_updatedips(FLAG full)
{   switch (memory[0x1400 + PVI_P1PADDLE])
    {
    case 0xF0: // state "1"
        DISCARD CheckRadioButton
        (   DIPsWindowPtr,
            IDC_SWITCH_1,
            IDC_SWITCH_4,
            IDC_SWITCH_1
        );
    acase 0x90: // state "2"
        DISCARD CheckRadioButton
        (   DIPsWindowPtr,
            IDC_SWITCH_1,
            IDC_SWITCH_4,
            IDC_SWITCH_2
        );
    acase 0x70: // state "3"
        DISCARD CheckRadioButton
        (   DIPsWindowPtr,
            IDC_SWITCH_1,
            IDC_SWITCH_4,
            IDC_SWITCH_3
        );
    acase 0x00: // state "4"
        DISCARD CheckRadioButton
        (   DIPsWindowPtr,
            IDC_SWITCH_1,
            IDC_SWITCH_4,
            IDC_SWITCH_4
        );
/*  adefault:
        otherwise don't tick anything */
}   }

BOOL CALLBACK m_DIPsDlgProc(HWND hwnd, UINT Message, WPARAM wParam, LPARAM lParam)
{   switch (Message)
    {
    case WM_ACTIVATE:
        do_autopause(wParam, lParam);
    acase WM_CLOSE:
        DestroyWindow(hwnd);
        DIPsWindowPtr = NULL;
        updatemenu(MENUITEM_DIPSWITCHES);
    acase WM_INITDIALOG:
        charset = CHARSET_WIN;
        DISCARD SetWindowText( hwnd,                      LLL, MSG_HAIL_M_DIPS           , "Malzak 2 DIP Switches"));

        if (language == LANGUAGE_RUS)
        {   DISCARD SendMessage(GetDlgItem(hwnd, IDL_TESTSWITCH     ), WM_SETFONT, (WPARAM) hRussianFont, MAKELPARAM(FALSE, 0));
            DISCARD SendMessage(GetDlgItem(hwnd, IDC_SWITCH_1       ), WM_SETFONT, (WPARAM) hRussianFont, MAKELPARAM(FALSE, 0));
            // the next 2 are purely for aesthetic purposes
            DISCARD SendMessage(GetDlgItem(hwnd, IDC_SWITCH_2       ), WM_SETFONT, (WPARAM) hRussianFont, MAKELPARAM(FALSE, 0));
            DISCARD SendMessage(GetDlgItem(hwnd, IDC_SWITCH_3       ), WM_SETFONT, (WPARAM) hRussianFont, MAKELPARAM(FALSE, 0));
            DISCARD SendMessage(GetDlgItem(hwnd, IDC_SWITCH_4       ), WM_SETFONT, (WPARAM) hRussianFont, MAKELPARAM(FALSE, 0));
        }
        DISCARD SetDlgItemText(hwnd, IDL_TESTSWITCH,      LLL, MSG_SWITCH                , "Test Switch"          ));
        DISCARD SetDlgItemText(hwnd, IDC_SWITCH_1,        LLL, MSG_SWITCH1               , "1 (normal play)"      ));
        DISCARD SetDlgItemText(hwnd, IDC_SWITCH_4,        LLL, MSG_SWITCH4               , "4 (change settings)"  ));
        charset = CHARSET_DOS;

        DIPsWindowPtr = hwnd;
        m_updatedips(TRUE);
        return TRUE;
    case WM_COMMAND: // no need for acase
        switch (LOWORD(wParam))
        {
        case IDOK:
            DestroyWindow(hwnd);
            DIPsWindowPtr = NULL;
            updatemenu(MENUITEM_DIPSWITCHES);
        acase IDC_SWITCH_1:
            memory[0x1400 + PVI_P1PADDLE] = 0xF0;
        acase IDC_SWITCH_2:
            memory[0x1400 + PVI_P1PADDLE] = 0x90;
        acase IDC_SWITCH_3:
            memory[0x1400 + PVI_P1PADDLE] = 0x70;
        acase IDC_SWITCH_4:
            memory[0x1400 + PVI_P1PADDLE] = 0x00;
        }

        return TRUE;
    default: // no need for adefault
        return FALSE;
    }

    return TRUE;
}

EXPORT void drawpixel(int x, int y, int colour)
{   PERSIST int temp; // PERSISTent for speed

    // assert(x >= 0);
    // assert(x < BOXWIDTH);
    // assert(y >= 0);
    // assert(y < BOXHEIGHT);
    // assert(colour >= 0);
    // assert(colour <= 23);

    if ((machine == ASTROWARS || machine == GALAXIA) && rotate)
    {   temp = x;
        x = machines[machine].width - 1 - y; // this is no mistake
        // assert(x < machines[machine].width);
        y = temp;
        /* if (x < 0 || y < 0 || y >= machines[machine].height)
        {   return;
        } */
    }

    if
    (   enhancestars
     && machine != PHUNSY
     && (   (   flagline
             && colour - 8 == starfield
            )
         || (   !flagline
             && colour     == starfield
            )
         || // needed for SUPERINV
            (   colour    == BLACK
             && starfield == BLACK
    )   )   )
    {   drawsky(x, y);
        return;
    }

    switch (fastsize)
    {
    case 0: // 1*1
        display[ x      +     (y * machines[machine].width     )                                 ] = pens[colourset][colour]; // 0,0
    acase 1: // 2*1
        display[(x * 2) + 0 + (y * machines[machine].width *  2)                                 ] =                          // 0,0
        display[(x * 2) + 1 + (y * machines[machine].width *  2)                                 ] = pens[colourset][colour]; // 1,0
    acase 2: // 2*2
        display[(x * 2) + 0 + (y * machines[machine].width *  4)                                 ] =                          // 0,0
        display[(x * 2) + 1 + (y * machines[machine].width *  4)                                 ] =                          // 1,0
        display[(x * 2) + 0 + (y * machines[machine].width *  4) + (machines[machine].width *  2)] =                          // 0,1
        display[(x * 2) + 1 + (y * machines[machine].width *  4) + (machines[machine].width *  2)] = pens[colourset][colour]; // 1,1
    acase 3: // 4*2
        display[(x * 4) +     (y * machines[machine].width *  8)                                 ] =                          // 0,0
        display[(x * 4) + 1 + (y * machines[machine].width *  8)                                 ] =                          // 1,0
        display[(x * 4) + 2 + (y * machines[machine].width *  8)                                 ] =                          // 2,0
        display[(x * 4) + 3 + (y * machines[machine].width *  8)                                 ] =                          // 3,0
        display[(x * 4) +     (y * machines[machine].width *  8) + (machines[machine].width *  4)] =                          // 0,1
        display[(x * 4) + 1 + (y * machines[machine].width *  8) + (machines[machine].width *  4)] =                          // 1,1
        display[(x * 4) + 2 + (y * machines[machine].width *  8) + (machines[machine].width *  4)] =                          // 2,1
        display[(x * 4) + 3 + (y * machines[machine].width *  8) + (machines[machine].width *  4)] = pens[colourset][colour]; // 3,1
    acase 4: // 3*3
        display[(x * 3) + 0 + (y * machines[machine].width *  9)                                 ] =                          // 0,0
        display[(x * 3) + 1 + (y * machines[machine].width *  9)                                 ] =                          // 1,0
        display[(x * 3) + 2 + (y * machines[machine].width *  9)                                 ] =                          // 2,0
        display[(x * 3) + 0 + (y * machines[machine].width *  9) + (machines[machine].width *  3)] =                          // 0,1
        display[(x * 3) + 1 + (y * machines[machine].width *  9) + (machines[machine].width *  3)] =                          // 1,1
        display[(x * 3) + 2 + (y * machines[machine].width *  9) + (machines[machine].width *  3)] =                          // 2,1
        display[(x * 3) + 0 + (y * machines[machine].width *  9) + (machines[machine].width *  6)] =                          // 0,2
        display[(x * 3) + 1 + (y * machines[machine].width *  9) + (machines[machine].width *  6)] =                          // 1,2
        display[(x * 3) + 2 + (y * machines[machine].width *  9) + (machines[machine].width *  6)] = pens[colourset][colour]; // 2,2
    acase 5: // 6*3
        display[(x * 6) + 0 + (y * machines[machine].width * 18)                                 ] =                          // 0,0
        display[(x * 6) + 1 + (y * machines[machine].width * 18)                                 ] =                          // 1,0
        display[(x * 6) + 2 + (y * machines[machine].width * 18)                                 ] =                          // 2,0
        display[(x * 6) + 3 + (y * machines[machine].width * 18)                                 ] =                          // 3,0
        display[(x * 6) + 4 + (y * machines[machine].width * 18)                                 ] =                          // 4,0
        display[(x * 6) + 5 + (y * machines[machine].width * 18)                                 ] =                          // 5,0
        display[(x * 6) + 0 + (y * machines[machine].width * 18) + (machines[machine].width *  6)] =                          // 0,1
        display[(x * 6) + 1 + (y * machines[machine].width * 18) + (machines[machine].width *  6)] =                          // 1,1
        display[(x * 6) + 2 + (y * machines[machine].width * 18) + (machines[machine].width *  6)] =                          // 2,1
        display[(x * 6) + 3 + (y * machines[machine].width * 18) + (machines[machine].width *  6)] =                          // 3,1
        display[(x * 6) + 4 + (y * machines[machine].width * 18) + (machines[machine].width *  6)] =                          // 4,1
        display[(x * 6) + 5 + (y * machines[machine].width * 18) + (machines[machine].width *  6)] =                          // 5,1
        display[(x * 6) + 0 + (y * machines[machine].width * 18) + (machines[machine].width * 12)] =                          // 0,2
        display[(x * 6) + 1 + (y * machines[machine].width * 18) + (machines[machine].width * 12)] =                          // 1,2
        display[(x * 6) + 2 + (y * machines[machine].width * 18) + (machines[machine].width * 12)] =                          // 2,2
        display[(x * 6) + 3 + (y * machines[machine].width * 18) + (machines[machine].width * 12)] =                          // 3,2
        display[(x * 6) + 4 + (y * machines[machine].width * 18) + (machines[machine].width * 12)] =                          // 4,2
        display[(x * 6) + 5 + (y * machines[machine].width * 18) + (machines[machine].width * 12)] = pens[colourset][colour]; // 5,2
    acase 6: // 4*4
        display[(x * 4) + 0 + (y * machines[machine].width * 16)                                 ] =                          // 0,0
        display[(x * 4) + 1 + (y * machines[machine].width * 16)                                 ] =                          // 1,0
        display[(x * 4) + 2 + (y * machines[machine].width * 16)                                 ] =                          // 2,0
        display[(x * 4) + 3 + (y * machines[machine].width * 16)                                 ] =                          // 3,0
        display[(x * 4) + 0 + (y * machines[machine].width * 16) + (machines[machine].width *  4)] =                          // 0,1
        display[(x * 4) + 1 + (y * machines[machine].width * 16) + (machines[machine].width *  4)] =                          // 1,1
        display[(x * 4) + 2 + (y * machines[machine].width * 16) + (machines[machine].width *  4)] =                          // 2,1
        display[(x * 4) + 3 + (y * machines[machine].width * 16) + (machines[machine].width *  4)] =                          // 3,1
        display[(x * 4) + 0 + (y * machines[machine].width * 16) + (machines[machine].width *  8)] =                          // 0,2
        display[(x * 4) + 1 + (y * machines[machine].width * 16) + (machines[machine].width *  8)] =                          // 1,2
        display[(x * 4) + 2 + (y * machines[machine].width * 16) + (machines[machine].width *  8)] =                          // 2,2
        display[(x * 4) + 3 + (y * machines[machine].width * 16) + (machines[machine].width *  8)] =                          // 3,2
        display[(x * 4) + 0 + (y * machines[machine].width * 16) + (machines[machine].width * 12)] =                          // 0,3
        display[(x * 4) + 1 + (y * machines[machine].width * 16) + (machines[machine].width * 12)] =                          // 1,3
        display[(x * 4) + 2 + (y * machines[machine].width * 16) + (machines[machine].width * 12)] =                          // 2,3
        display[(x * 4) + 3 + (y * machines[machine].width * 16) + (machines[machine].width * 12)] = pens[colourset][colour]; // 3,3
    acase 7: // 8*4
        display[(x * 8) + 0 + (y * machines[machine].width * 32)                                 ] =                          // 0,0
        display[(x * 8) + 1 + (y * machines[machine].width * 32)                                 ] =                          // 1,0
        display[(x * 8) + 2 + (y * machines[machine].width * 32)                                 ] =                          // 2,0
        display[(x * 8) + 3 + (y * machines[machine].width * 32)                                 ] =                          // 3,0
        display[(x * 8) + 4 + (y * machines[machine].width * 32)                                 ] =                          // 4,0
        display[(x * 8) + 5 + (y * machines[machine].width * 32)                                 ] =                          // 5,0
        display[(x * 8) + 6 + (y * machines[machine].width * 32)                                 ] =                          // 6,0
        display[(x * 8) + 7 + (y * machines[machine].width * 32)                                 ] =                          // 7,0
        display[(x * 8) + 0 + (y * machines[machine].width * 32) + (machines[machine].width *  8)] =                          // 0,1
        display[(x * 8) + 1 + (y * machines[machine].width * 32) + (machines[machine].width *  8)] =                          // 1,1
        display[(x * 8) + 2 + (y * machines[machine].width * 32) + (machines[machine].width *  8)] =                          // 2,1
        display[(x * 8) + 3 + (y * machines[machine].width * 32) + (machines[machine].width *  8)] =                          // 3,1
        display[(x * 8) + 4 + (y * machines[machine].width * 32) + (machines[machine].width *  8)] =                          // 4,1
        display[(x * 8) + 5 + (y * machines[machine].width * 32) + (machines[machine].width *  8)] =                          // 5,1
        display[(x * 8) + 6 + (y * machines[machine].width * 32) + (machines[machine].width *  8)] =                          // 6,1
        display[(x * 8) + 7 + (y * machines[machine].width * 32) + (machines[machine].width *  8)] =                          // 7,1
        display[(x * 8) + 0 + (y * machines[machine].width * 32) + (machines[machine].width * 16)] =                          // 0,2
        display[(x * 8) + 1 + (y * machines[machine].width * 32) + (machines[machine].width * 16)] =                          // 1,2
        display[(x * 8) + 2 + (y * machines[machine].width * 32) + (machines[machine].width * 16)] =                          // 2,2
        display[(x * 8) + 3 + (y * machines[machine].width * 32) + (machines[machine].width * 16)] =                          // 3,2
        display[(x * 8) + 4 + (y * machines[machine].width * 32) + (machines[machine].width * 16)] =                          // 4,2
        display[(x * 8) + 5 + (y * machines[machine].width * 32) + (machines[machine].width * 16)] =                          // 5,2
        display[(x * 8) + 6 + (y * machines[machine].width * 32) + (machines[machine].width * 16)] =                          // 6,2
        display[(x * 8) + 7 + (y * machines[machine].width * 32) + (machines[machine].width * 16)] =                          // 7,2
        display[(x * 8) + 0 + (y * machines[machine].width * 32) + (machines[machine].width * 24)] =                          // 0,3
        display[(x * 8) + 1 + (y * machines[machine].width * 32) + (machines[machine].width * 24)] =                          // 1,3
        display[(x * 8) + 2 + (y * machines[machine].width * 32) + (machines[machine].width * 24)] =                          // 2,3
        display[(x * 8) + 3 + (y * machines[machine].width * 32) + (machines[machine].width * 24)] =                          // 3,3
        display[(x * 8) + 4 + (y * machines[machine].width * 32) + (machines[machine].width * 24)] =                          // 4,3
        display[(x * 8) + 5 + (y * machines[machine].width * 32) + (machines[machine].width * 24)] =                          // 5,3
        display[(x * 8) + 6 + (y * machines[machine].width * 32) + (machines[machine].width * 24)] =                          // 6,3
        display[(x * 8) + 7 + (y * machines[machine].width * 32) + (machines[machine].width * 24)] = pens[colourset][colour]; // 7,3
}   }

EXPORT void apply_scale2x(void)
{   PERSIST int   b, d, f, h,
                  e, e0, e1, e2, e3,
                  olde0, olde1,
                  xx, yy;
    PERSIST ULONG x, y,
                  px, py,
                  sky; // all PERSISTent for speed

    if (rastlines)
    {   for (x = 0; x < (ULONG) machines[machine].width; x++)
        {   drawpixel((int) x, 0, screen[x][0]);
            drawpixel((int) x, machines[machine].height - 1, screen[x][machines[machine].height - 1]);
        }
        for (y = 1; y < (ULONG) (machines[machine].height - 1); y++)
        {   drawpixel(0, (int) y, screen[0][y]);
            drawpixel(machines[machine].width - 1, (int) y, screen[machines[machine].width - 1][y]);
    }   }

    sky = pens[colourset][starfield];

    for (xx = 1; xx < machines[machine].width - 1; xx++)
    {   for (yy = 1; yy < machines[machine].height - 1; yy++)
        {   b = screen[xx][yy - 1];
            d = screen[xx - 1][yy];
            e = screen[xx][yy];
            f = screen[xx + 1][yy];
            h = screen[xx][yy + 1];

            if (b != h && d != f)
            {   e0 = d == b ? d : e;
                e1 = b == f ? f : e;
                e2 = d == h ? d : e;
                e3 = h == f ? f : e;
            } else
            {   e0 = e1 = e2 = e3 = e;
            }

            if ((machine == ASTROWARS || machine == GALAXIA) && rotate)
            {   x     = (ULONG) (machines[machine].width - 1 - yy); // this is no mistake
                y     = (ULONG) xx;
                olde0 = e0;
                e0    = e2;
                olde1 = e1;
                e1    = olde0;
                e2    = e3;
                e3    = olde1;
            } else
            {   x = (ULONG) xx;
                y = (ULONG) yy;
            }

            if (wide == 1)
            {   px = x << 1;
                py = (y * machines[machine].width) << 2;
                if
                (   !enhancestars
                 || (screen[xx][yy] & 7) != starfield
                )
                {   display[  px +     py                                ] =  pens[colourset][e0]; // 0,0
                    display[  px + 1 + py                                ] =  pens[colourset][e1]; // 1,0
                    display[  px +     py + (machines[machine].width * 2)] =  pens[colourset][e2]; // 0,1
                    display[  px + 1 + py + (machines[machine].width * 2)] =  pens[colourset][e3]; // 1,1
                } else
                {   if (stars[px +     py                                ] == sky) // starfield lacks a star here
                      display[px +     py                                ] =  pens[colourset][e0]; // 0,0
                    if (stars[px + 1 + py                                ] == sky)
                      display[px + 1 + py                                ] =  pens[colourset][e1]; // 1,0
                    if (stars[px +     py + (machines[machine].width * 2)] == sky)
                      display[px +     py + (machines[machine].width * 2)] =  pens[colourset][e2]; // 0,1
                    if (stars[px + 1 + py + (machines[machine].width * 2)] == sky)
                      display[px + 1 + py + (machines[machine].width * 2)] =  pens[colourset][e3]; // 1,1
            }   }
            else
            {   px = (int) (x << 2);
                py = (int) ((y * machines[machine].width) << 3);
                if
                (   !enhancestars
                 || (screen[xx][yy] & 7) != starfield
                )
                {   display[px +     py                                ] =                       // 0,0
                    display[px + 1 + py                                ] =  pens[colourset][e0]; // 1,0
                    display[px + 2 + py                                ] =                       // 2,0
                    display[px + 3 + py                                ] =  pens[colourset][e1]; // 3,0
                    display[px +     py + (machines[machine].width * 4)] =                       // 0,1
                    display[px + 1 + py + (machines[machine].width * 4)] =  pens[colourset][e2]; // 1,1
                    display[px + 2 + py + (machines[machine].width * 4)] =                       // 0,1
                    display[px + 3 + py + (machines[machine].width * 4)] =  pens[colourset][e3]; // 1,1
                } else
                {   if (stars[px +     py                                ] == sky)
                      display[px +     py                                ] =  pens[colourset][e0]; // 0,0
                    if (stars[px + 1 + py                                ] == sky)
                      display[px + 1 + py                                ] =  pens[colourset][e0]; // 1,0
                    if (stars[px + 2 + py                                ] == sky)
                      display[px + 2 + py                                ] =  pens[colourset][e1]; // 2,0
                    if (stars[px + 3 + py                                ] == sky)
                      display[px + 3 + py                                ] =  pens[colourset][e1]; // 3,0
                    if (stars[px +     py + (machines[machine].width * 4)] == sky)
                      display[px +     py + (machines[machine].width * 4)] =  pens[colourset][e2]; // 0,1
                    if (stars[px + 1 + py + (machines[machine].width * 4)] == sky)
                      display[px + 1 + py + (machines[machine].width * 4)] =  pens[colourset][e2]; // 1,1
                    if (stars[px + 2 + py + (machines[machine].width * 4)] == sky)
                      display[px + 2 + py + (machines[machine].width * 4)] =  pens[colourset][e3]; // 2,1
                    if (stars[px + 3 + py + (machines[machine].width * 4)] == sky)
                      display[px + 3 + py + (machines[machine].width * 4)] =  pens[colourset][e3]; // 3,1
}   }   }   }   }

EXPORT void apply_scale3x(void)
{   PERSIST int   a, b, c, d, e, f, g, h, i,
                  e0, e1, e2, e3, e4, e5, e6, e7, e8,
                  olde0, olde1, olde2, olde5,
                  x, xx, px,
                  y, yy, py; // all PERSISTent for speed
    PERSIST ULONG sky;

    if (rastlines)
    {   for (x = 0; x < machines[machine].width; x++)
        {   drawpixel(x, 0, screen[x][0]);
            drawpixel(x, machines[machine].height - 1, screen[x][machines[machine].height - 1]);
        }
        for (y = 1; y < machines[machine].height - 1; y++)
        {   drawpixel(0, y, screen[0][y]);
            drawpixel(machines[machine].width - 1, y, screen[machines[machine].width - 1][y]);
    }   }

    sky = pens[colourset][starfield];

    for (xx = 1; xx < machines[machine].width - 1; xx++)
    {   for (yy = 1; yy < machines[machine].height - 1; yy++)
        {   a = screen[xx - 1][yy - 1];
            b = screen[xx    ][yy - 1];
            c = screen[xx + 1][yy - 1];
            d = screen[xx - 1][yy    ];
            e = screen[xx    ][yy    ];
            f = screen[xx + 1][yy    ];
            g = screen[xx - 1][yy + 1];
            h = screen[xx    ][yy + 1];
            i = screen[xx + 1][yy + 1];

            if (b != h && d != f)
            {   e0 = d == b ? d : e;
                e1 = (d == b && e != c) || (b == f && e != a) ? b : e;
                e2 = b == f ? f : e;
                e3 = (d == b && e != g) || (d == h && e != a) ? d : e;
                e4 = e;
                e5 = (b == f && e != i) || (h == f && e != c) ? f : e;
                e6 = d == h ? d : e;
                e7 = (d == h && e != i) || (h == f && e != g) ? h : e;
                e8 = h == f ? f : e;
            } else
            {   e0 = e1 = e2 = e3 = e4 = e5 = e6 = e7 = e8 = e;
            }

            if ((machine == ASTROWARS || machine == GALAXIA) && rotate)
            {   x = machines[machine].width - 1 - yy; // this is no mistake
                y = xx;
                /* e0 <- e6
                   e1 <- e3
                   e2 <- e0
                   e3 <- e7
                   e4 <- e4
                   e5 <- e1
                   e6 <- e8
                   e7 <- e5
                   e8 <- e2 */
                olde0 = e0;
                e0 = e6;
                olde1 = e1;
                e1 = e3;
                olde2 = e2;
                e2 = olde0;
                e3 = e7;
                olde5 = e5;
                e5 = olde1;
                e6 = e8;
                e7 = olde5;
                e8 = olde2;
            } else
            {   x = xx;
                y = yy;
            }

            if (wide == 1)
            {   px = x * 3;
                py = y * machines[machine].width * 9;
                if
                (   !enhancestars
                 || (screen[xx][yy] & 7) != starfield
                )
                {   display[  px +     py                                ] =  pens[colourset][e0]; // 0,0
                    display[  px + 1 + py                                ] =  pens[colourset][e1]; // 1,0
                    display[  px + 2 + py                                ] =  pens[colourset][e2]; // 2,0
                    display[  px +     py + (machines[machine].width * 3)] =  pens[colourset][e3]; // 0,1
                    display[  px + 1 + py + (machines[machine].width * 3)] =  pens[colourset][e4]; // 1,1
                    display[  px + 2 + py + (machines[machine].width * 3)] =  pens[colourset][e5]; // 2,1
                    display[  px +     py + (machines[machine].width * 6)] =  pens[colourset][e6]; // 0,2
                    display[  px + 1 + py + (machines[machine].width * 6)] =  pens[colourset][e7]; // 1,2
                    display[  px + 2 + py + (machines[machine].width * 6)] =  pens[colourset][e8]; // 2,2
                } else
                {   if (stars[px +     py                                ] == sky)
                    display[  px +     py                                ] =  pens[colourset][e0]; // 0,0
                    if (stars[px + 1 + py                                ] == sky)
                    display[  px + 1 + py                                ] =  pens[colourset][e1]; // 1,0
                    if (stars[px + 2 + py                                ] == sky)
                    display[  px + 2 + py                                ] =  pens[colourset][e2]; // 2,0
                    if (stars[px +     py + (machines[machine].width * 3)] == sky)
                    display[  px +     py + (machines[machine].width * 3)] =  pens[colourset][e3]; // 0,1
                    if (stars[px + 1 + py + (machines[machine].width * 3)] == sky)
                    display[  px + 1 + py + (machines[machine].width * 3)] =  pens[colourset][e4]; // 1,1
                    if (stars[px + 2 + py + (machines[machine].width * 3)] == sky)
                    display[  px + 2 + py + (machines[machine].width * 3)] =  pens[colourset][e5]; // 2,1
                    if (stars[px +     py + (machines[machine].width * 6)] == sky)
                    display[  px +     py + (machines[machine].width * 6)] =  pens[colourset][e6]; // 0,2
                    if (stars[px + 1 + py + (machines[machine].width * 6)] == sky)
                    display[  px + 1 + py + (machines[machine].width * 6)] =  pens[colourset][e7]; // 1,2
                    if (stars[px + 2 + py + (machines[machine].width * 6)] == sky)
                    display[  px + 2 + py + (machines[machine].width * 6)] =  pens[colourset][e8]; // 2,2
            }   }
            else
            {   px = x * 6;
                py = y * machines[machine].width * 18;
                if
                (   !enhancestars
                 || (screen[xx][yy] & 7) != starfield
                )
                {   display[  px +     py                                 ] =                       // 0,0
                    display[  px + 1 + py                                 ] =  pens[colourset][e0]; // 1,0
                    display[  px + 2 + py                                 ] =                       // 2,0
                    display[  px + 3 + py                                 ] =  pens[colourset][e1]; // 3,0
                    display[  px + 4 + py                                 ] =                       // 4,0
                    display[  px + 5 + py                                 ] =  pens[colourset][e2]; // 5,0
                    display[  px +     py + (machines[machine].width *  6)] =                       // 0,1
                    display[  px + 1 + py + (machines[machine].width *  6)] =  pens[colourset][e3]; // 1,1
                    display[  px + 2 + py + (machines[machine].width *  6)] =                       // 2,1
                    display[  px + 3 + py + (machines[machine].width *  6)] =  pens[colourset][e4]; // 3,1
                    display[  px + 4 + py + (machines[machine].width *  6)] =                       // 4,1
                    display[  px + 5 + py + (machines[machine].width *  6)] =  pens[colourset][e5]; // 5,1
                    display[  px +     py + (machines[machine].width * 12)] =                       // 0,3
                    display[  px + 1 + py + (machines[machine].width * 12)] =  pens[colourset][e6]; // 1,3
                    display[  px + 2 + py + (machines[machine].width * 12)] =                       // 2,3
                    display[  px + 3 + py + (machines[machine].width * 12)] =  pens[colourset][e7]; // 3,3
                    display[  px + 4 + py + (machines[machine].width * 12)] =                       // 4,3
                    display[  px + 5 + py + (machines[machine].width * 12)] =  pens[colourset][e8]; // 5,3
                } else
                {   if (stars[px +     py                                 ] == sky)
                    display[  px +     py                                 ] =  pens[colourset][e0]; // 0,0
                    if (stars[px + 1 + py                                 ] == sky)
                    display[  px + 1 + py                                 ] =  pens[colourset][e0]; // 1,0
                    if (stars[px + 2 + py                                 ] == sky)
                    display[  px + 2 + py                                 ] =  pens[colourset][e1]; // 2,0
                    if (stars[px + 3 + py                                 ] == sky)
                    display[  px + 3 + py                                 ] =  pens[colourset][e1]; // 3,0
                    if (stars[px + 4 + py                                 ] == sky)
                    display[  px + 4 + py                                 ] =  pens[colourset][e2]; // 4,0
                    if (stars[px + 5 + py                                 ] == sky)
                    display[  px + 5 + py                                 ] =  pens[colourset][e2]; // 5,0
                    if (stars[px +     py + (machines[machine].width *  6)] == sky)
                    display[  px +     py + (machines[machine].width *  6)] =  pens[colourset][e3]; // 0,1
                    if (stars[px + 1 + py + (machines[machine].width *  6)] == sky)
                    display[  px + 1 + py + (machines[machine].width *  6)] =  pens[colourset][e3]; // 1,1
                    if (stars[px + 2 + py + (machines[machine].width *  6)] == sky)
                    display[  px + 2 + py + (machines[machine].width *  6)] =  pens[colourset][e4]; // 2,1
                    if (stars[px + 3 + py + (machines[machine].width *  6)] == sky)
                    display[  px + 3 + py + (machines[machine].width *  6)] =  pens[colourset][e4]; // 3,1
                    if (stars[px + 4 + py + (machines[machine].width *  6)] == sky)
                    display[  px + 4 + py + (machines[machine].width *  6)] =  pens[colourset][e5]; // 4,1
                    if (stars[px + 5 + py + (machines[machine].width *  6)] == sky)
                    display[  px + 5 + py + (machines[machine].width *  6)] =  pens[colourset][e5]; // 5,1
                    if (stars[px +     py + (machines[machine].width * 12)] == sky)
                    display[  px +     py + (machines[machine].width * 12)] =  pens[colourset][e6]; // 0,2
                    if (stars[px + 1 + py + (machines[machine].width * 12)] == sky)
                    display[  px + 1 + py + (machines[machine].width * 12)] =  pens[colourset][e6]; // 1,2
                    if (stars[px + 2 + py + (machines[machine].width * 12)] == sky)
                    display[  px + 2 + py + (machines[machine].width * 12)] =  pens[colourset][e7]; // 2,2
                    if (stars[px + 3 + py + (machines[machine].width * 12)] == sky)
                    display[  px + 3 + py + (machines[machine].width * 12)] =  pens[colourset][e7]; // 3,2
                    if (stars[px + 4 + py + (machines[machine].width * 12)] == sky)
                    display[  px + 4 + py + (machines[machine].width * 12)] =  pens[colourset][e8]; // 4,2
                    if (stars[px + 5 + py + (machines[machine].width * 12)] == sky)
                    display[  px + 5 + py + (machines[machine].width * 12)] =  pens[colourset][e8]; // 5,2
}   }   }   }   }

EXPORT void apply_scale4x(void)
{   PERSIST UBYTE b, d, f, h,
                  e, e0, e1, e2, e3,
                  tempscreen[BOXWIDTH * 2][BOXHEIGHT * 2],
                  sky;
    PERSIST int   px, py,
                  x, y; // all PERSISTent for speed

    sky = (UBYTE) pens[colourset][starfield];

    for (y = 1; y < machines[machine].height - 1; y++)
    {   for (x = 1; x < machines[machine].width - 1; x++)
        {   b = screen[x    ][y - 1];
            d = screen[x - 1][y    ];
            e = screen[x    ][y    ];
            f = screen[x + 1][y    ];
            h = screen[x    ][y + 1];

            if (b != h && d != f)
            {   e0 = d == b ? d : e;
                e1 = b == f ? f : e;
                e2 = d == h ? d : e;
                e3 = h == f ? f : e;
            } else
            {   e0 = e1 = e2 = e3 = e;
            }

            if ((machine == ASTROWARS || machine == GALAXIA) && rotate)
            {   tempscreen[ (machines[machine].width - 1 - y) * 2     ][ x * 2     ] = e2; // 0,1
                tempscreen[((machines[machine].width - 1 - y) * 2) + 1][ x * 2     ] = e0; // 0,0
                tempscreen[ (machines[machine].width - 1 - y) * 2     ][(x * 2) + 1] = e3; // 1,1
                tempscreen[((machines[machine].width - 1 - y) * 2) + 1][(x * 2) + 1] = e1; // 1,0
            } else
            {   tempscreen[                                x  * 2     ][ y * 2     ] = e0; // 0,0
                tempscreen[                               (x  * 2) + 1][ y * 2     ] = e1; // 1,0
                tempscreen[                                x  * 2     ][(y * 2) + 1] = e2; // 0,1
                tempscreen[                               (x  * 2) + 1][(y * 2) + 1] = e3; // 1,1
    }   }   }

    if (wide == 1) // 4*4
    {   for (y = 3; y < (machines[machine].height * 2) - 3; y++)
        {   for (x = 3; x < (machines[machine].width * 2) - 3; x++)
            {   b = tempscreen[x    ][y - 1];
                d = tempscreen[x - 1][y    ];
                e = tempscreen[x    ][y    ];
                f = tempscreen[x + 1][y    ];
                h = tempscreen[x    ][y + 1];

                if (b != h && d != f)
                {   e0 = d == b ? d : e;
                    e1 = b == f ? f : e;
                    e2 = d == h ? d : e;
                    e3 = h == f ? f : e;
                } else
                {   e0 = e1 = e2 = e3 = e;
                }

                px = x * 2; // this is no mistake
                py = y * machines[machine].width * 8; // and neither is this
                if
                (   !enhancestars
                 || (screen[x / 2][y / 2] & 7) != starfield
                )
                {   display[  px +     py                                 ] = pens[colourset][e0]; // 0,0
                    display[  px + 1 + py                                 ] = pens[colourset][e1]; // 1,0
                    display[  px +     py + (machines[machine].width *  4)] = pens[colourset][e2]; // 0,1
                    display[  px + 1 + py + (machines[machine].width *  4)] = pens[colourset][e3]; // 1,1
                } else
                {   if (stars[px +     py                                 ] == sky)
                    display[  px +     py                                 ] = pens[colourset][e0]; // 0,0
                    if (stars[px + 1 + py                                 ] == sky)
                    display[  px + 1 + py                                 ] = pens[colourset][e1]; // 1,0
                    if (stars[px +     py + (machines[machine].width *  4)] == sky)
                    display[  px +     py + (machines[machine].width *  4)] = pens[colourset][e2]; // 0,1
                    if (stars[px + 1 + py + (machines[machine].width *  4)] == sky)
                    display[  px + 1 + py + (machines[machine].width *  4)] = pens[colourset][e3]; // 1,1
    }   }   }   }
    else // 8*4
    {   for (y = 3; y < (machines[machine].height * 2) - 3; y++)
        {   for (x = 3; x < (machines[machine].width * 2) - 3; x++)
            {   b = tempscreen[x    ][y - 1];
                d = tempscreen[x - 1][y    ];
                e = tempscreen[x    ][y    ];
                f = tempscreen[x + 1][y    ];
                h = tempscreen[x    ][y + 1];

                if (b != h && d != f)
                {   e0 = d == b ? d : e;
                    e1 = b == f ? f : e;
                    e2 = d == h ? d : e;
                    e3 = h == f ? f : e;
                } else
                {   e0 = e1 = e2 = e3 = e;
                }

                px = x * 4; // this is no mistake
                py = y * machines[machine].width * 16; // and neither is this
                if
                (   !enhancestars
                 || (screen[x / 2][y / 2] & 7) != starfield
                )
                {   display[px +     py                                ] =     // 0,0
                    display[px + 1 + py                                ] = pens[colourset][e0]; // 1,0
                    display[px + 2 + py                                ] =     // 2,0
                    display[px + 3 + py                                ] = pens[colourset][e1]; // 3,0
                    display[px +     py + (machines[machine].width * 8)] =     // 0,1
                    display[px + 1 + py + (machines[machine].width * 8)] = pens[colourset][e2]; // 1,1
                    display[px + 2 + py + (machines[machine].width * 8)] =     // 2,1
                    display[px + 3 + py + (machines[machine].width * 8)] = pens[colourset][e3]; // 3,1
                } else
                {   if (stars[px +     py                                 ] == sky)
                    display[  px +     py                                 ] = pens[colourset][e0]; // 0,0
                    if (stars[px + 1 + py                                 ] == sky)
                    display[  px + 1 + py                                 ] = pens[colourset][e0]; // 1,0
                    if (stars[px + 2 + py                                 ] == sky)
                    display[  px + 2 + py                                 ] = pens[colourset][e1]; // 2,0
                    if (stars[px + 3 + py                                 ] == sky)
                    display[  px + 3 + py                                 ] = pens[colourset][e1]; // 3,0
                    if (stars[px +     py + (machines[machine].width *  8)] == sky)
                    display[  px +     py + (machines[machine].width *  8)] = pens[colourset][e2]; // 0,1
                    if (stars[px + 1 + py + (machines[machine].width *  8)] == sky)
                    display[  px + 1 + py + (machines[machine].width *  8)] = pens[colourset][e2]; // 1,1
                    if (stars[px + 2 + py + (machines[machine].width *  8)] == sky)
                    display[  px + 2 + py + (machines[machine].width *  8)] = pens[colourset][e3]; // 2,1
                    if (stars[px + 3 + py + (machines[machine].width *  8)] == sky)
                    display[  px + 3 + py + (machines[machine].width *  8)] = pens[colourset][e3]; // 3,1
}   }   }   }   }

EXPORT void apply_rastlines(void)
{   PERSIST int rowwidth,
                x, xx, y, yy, yyy; // all PERSISTent for speed

    if (!rastlines || realsize == 1)
    {   return;
    }

    rowwidth = machines[machine].width * fastwide;

    if ((machine == ASTROWARS || machine == GALAXIA) && rotate)
    {   for (y = 0; y < machines[machine].height; y++)
        {   for (x = 0; x < machines[machine].width; x++)
            {   yy = machines[machine].width - 1 - x;
                for (yyy = 0; yyy < realsize; yyy++)
                {   display[(y * rowwidth * realsize)
                          + (yyy * rowwidth)
                          + ((x + 1) * fastwide) - 1] = pens[colourset][screen[y][yy] + GUESTCOLOURS];
    }   }   }   }
    else
    {   for (y = 0; y < machines[machine].height; y++)
        {   for (x = 0; x < machines[machine].width; x++)
            {   for (xx = 0; xx < fastwide; xx++)
                {   display[((((y + 1) * realsize) - 1) * rowwidth)
                          + (x * fastwide)
                          + xx] = pens[colourset][screen[x][y] + GUESTCOLOURS];
}   }   }   }   }

EXPORT void iconify(void)
{   NOTIFYICONDATA tnid;
    BOOL           pvParam;

    if (iconified)
    {   return;
    }

    if (autopause)
    {   emu_pause(TRUE);
    }

    tnid.cbSize           = sizeof(NOTIFYICONDATA);
    tnid.hWnd             = MainWindowPtr;
    tnid.uID              = 1;
    tnid.uFlags           = NIF_MESSAGE | NIF_ICON | NIF_TIP;
    tnid.uCallbackMessage = USR_NOTIFYICON;
    tnid.hIcon            = (HICON) LoadImage(InstancePtr, MAKEINTRESOURCE(IDI_ICON), IMAGE_ICON, 16, 16, LR_DEFAULTCOLOR);
    strcpy(tnid.szTip, titlebartext);

    DISCARD Shell_NotifyIcon(NIM_ADD, &tnid);

    if (ControlsWindowPtr) ShowWindow(ControlsWindowPtr, SW_HIDE);
    if ( MonitorWindowPtr) ShowWindow( MonitorWindowPtr, SW_HIDE);
    if ( ConsoleWindowPtr) ShowWindow( ConsoleWindowPtr, SW_HIDE);
    if (    DIPsWindowPtr) ShowWindow(    DIPsWindowPtr, SW_HIDE);
    if (GameInfoWindowPtr) ShowWindow(GameInfoWindowPtr, SW_HIDE);
    if (  MemoryWindowPtr) ShowWindow(  MemoryWindowPtr, SW_HIDE);
    if ( PaletteWindowPtr) ShowWindow( PaletteWindowPtr, SW_HIDE);
    if (  SpriteWindowPtr) ShowWindow(  SpriteWindowPtr, SW_HIDE);
    ShowWindow(MainWindowPtr, SW_HIDE);

    if (lame)
    {   SystemParametersInfo(SPI_GETSCREENSAVEACTIVE, 0, &pvParam, 0);
        if (pvParam == FALSE)
        {   SystemParametersInfo(SPI_SETSCREENSAVEACTIVE, TRUE, 0, SPIF_SENDWININICHANGE);
    }   }

    iconified = TRUE;
}

EXPORT void uniconify(FLAG exiting)
{   NOTIFYICONDATA tnid;
    BOOL           pvParam;

    if (!exiting)
    {   ShowWindow(MainWindowPtr, SW_SHOW);
        if (ControlsWindowPtr) ShowWindow(ControlsWindowPtr, SW_SHOW);
        if ( MonitorWindowPtr) ShowWindow( MonitorWindowPtr, SW_SHOW);
        if ( ConsoleWindowPtr) ShowWindow( ConsoleWindowPtr, SW_SHOW);
        if (    DIPsWindowPtr) ShowWindow(    DIPsWindowPtr, SW_SHOW);
        if (GameInfoWindowPtr) ShowWindow(GameInfoWindowPtr, SW_SHOW);
        if (  MemoryWindowPtr) ShowWindow(  MemoryWindowPtr, SW_SHOW);
        if ( PaletteWindowPtr) ShowWindow( PaletteWindowPtr, SW_SHOW);
        if (  SpriteWindowPtr) ShowWindow(  SpriteWindowPtr, SW_SHOW);
    }

    tnid.cbSize = sizeof(NOTIFYICONDATA);
    tnid.hWnd   = MainWindowPtr;
    tnid.uID    = 1;
    DISCARD Shell_NotifyIcon(NIM_DELETE, &tnid);

    if (lame)
    {   SystemParametersInfo(SPI_GETSCREENSAVEACTIVE, 0, &pvParam, 0);
        if (pvParam == TRUE)
        {   SystemParametersInfo(SPI_SETSCREENSAVEACTIVE, FALSE, 0, SPIF_SENDWININICHANGE);
    }   }

    iconified = FALSE;
    // should we call setselection() here?
}

EXPORT void rectfill(int leftx, int topy)
{   // This is only intended for use by s_updatecontrols()!
    // Note that there are also global variables with the same names as these parameters.

    // assert(ControlsWindowPtr);

    therect.left   = leftx;
    therect.top    = topy;
    therect.right  = leftx + 4;
    therect.bottom = topy  + 4;
    ControlsRastPtr = GetDC(ControlsWindowPtr);
    DISCARD InvertRect
    (   ControlsRastPtr,
        &therect
    );
    ReleaseDC(ControlsWindowPtr, ControlsRastPtr);
}

EXPORT void edit_dips(void)
{   opening = TRUE;

    switch (machine)
    {
    case INSTRUCTOR:
        DIPsWindowPtr = CreateDialog
        (   InstancePtr,                 // handle to application instance
            MAKEINTRESOURCE(IDD_S_DIPS), // identifies dialog box template name
            MainWindowPtr,
            s_DIPsDlgProc
        );
    acase ASTROWARS:
    case GALAXIA:
        DIPsWindowPtr = CreateDialog
        (   InstancePtr,                 // handle to application instance
            MAKEINTRESOURCE(IDD_G_DIPS), // identifies dialog box template name
            MainWindowPtr,
            g_DIPsDlgProc
        );
    acase MALZAK:
        if (memmap == MEMMAP_MALZAK2)
        {   DIPsWindowPtr = CreateDialog
            (   InstancePtr,                 // handle to application instance
                MAKEINTRESOURCE(IDD_M_DIPS), // identifies dialog box template name
                MainWindowPtr,
                m_DIPsDlgProc
            );
    }   }

    opening = FALSE;
    updatemenu(MENUITEM_DIPSWITCHES);
}

EXPORT void edit_palette(void)
{   opening = TRUE;

    PaletteWindowPtr = CreateDialog
    (   InstancePtr,
        MAKEINTRESOURCE(IDD_PALETTE),
        MainWindowPtr,
        PaletteDlgProc
    );

    opening = FALSE;
    updatemenu(MENUITEM_PALETTE);
}

EXPORT void open_spriteviewer(void)
{   int  i;
    TEXT tempstring[10 + 1];

    if
    (   SpriteWindowPtr
     || machines[machine].maxsprites == 0 // eg. PIPBUG, INSTRUCTOR, CD2650, CHAOS, DOLPHIN, PHUNSY
    )
    {   return;
    }

    opening = TRUE;
    if (machine == ARCADIA)
    {   SpriteWindowPtr = CreateDialog
        (   InstancePtr,
            MAKEINTRESOURCE(IDD_SPRITEVIEWER8),
            MainWindowPtr,
            SpriteDlgProc
        );
        for (i = 0; i < 64; i++)
        {   spritegad[i] = GetDlgItem(SpriteWindowPtr, IDC_SPR_11 + i);
    }   }
    else
    {   // assert(machine == INTERTON || machine == ELEKTOR || machine == ASTROWARS || machine == GALAXIA || machine == MALZAK);
        SpriteWindowPtr = CreateDialog
        (   InstancePtr,
            MAKEINTRESOURCE(IDD_SPRITEVIEWER10),
            MainWindowPtr,
            SpriteDlgProc
        );
        for (i = 0; i < 80; i++)
        {   spritegad[i] = GetDlgItem(SpriteWindowPtr, IDC_SPR_11 + i);
    }   }
    opening = FALSE;

    if (viewingsprite >= machines[machine].maxsprites)
    {   viewingsprite = 0;
    }

    // assert(SpriteWindowPtr);

    DISCARD SendMessage(GetDlgItem(SpriteWindowPtr, IDC_WHICHSPRITE), WM_SETREDRAW, FALSE, 0);

    if (machine == ARCADIA)
    {   for (i = 0; i < 4; i++)
        {   sprintf(tempstring, "Sprite #%d", i);
            DISCARD SendMessage(GetDlgItem(SpriteWindowPtr, IDC_WHICHSPRITE), LB_ADDSTRING, 0, (LPARAM) tempstring);
        }
        for (i = 0; i < 4; i++)
        {   sprintf(tempstring, "UDC #%d", i);
            DISCARD SendMessage(GetDlgItem(SpriteWindowPtr, IDC_WHICHSPRITE), LB_ADDSTRING, 0, (LPARAM) tempstring);
    }   }
    else
    {   for (i = 0; i < machines[machine].maxsprites; i++)
        {   sprintf(tempstring, "#%d", i);
            DISCARD SendMessage(GetDlgItem(SpriteWindowPtr, IDC_WHICHSPRITE), LB_ADDSTRING, 0, (LPARAM) tempstring);
    }   }
    DISCARD SendMessage(GetDlgItem(SpriteWindowPtr, IDC_WHICHSPRITE), LB_SETTOPINDEX, (WPARAM) viewingsprite, 0);
    DISCARD SendMessage(GetDlgItem(SpriteWindowPtr, IDC_WHICHSPRITE), WM_SETREDRAW, TRUE, 0);

    DISCARD SetActiveWindow(MainWindowPtr);

    updatemenu(MENUITEM_SPRITEVIEWER);
    update_spriteviewer(TRUE);
}

EXPORT void ghost_dips(FLAG state)
{   if (DIPsWindowPtr)
    {   // assert(machine == INSTRUCTOR);

        EnableWindow(GetDlgItem(DIPsWindowPtr, IDC_INTERRUPTS_DIRECT   ), (BOOL) state);
        EnableWindow(GetDlgItem(DIPsWindowPtr, IDC_INTERRUPTS_INDIRECT ), (BOOL) state);
        EnableWindow(GetDlgItem(DIPsWindowPtr, IDC_INTSELECTOR_ACLINE  ), (BOOL) state);
        EnableWindow(GetDlgItem(DIPsWindowPtr, IDC_INTSELECTOR_KYBD    ), (BOOL) state);
        EnableWindow(GetDlgItem(DIPsWindowPtr, IDC_PARALLEL_MEMMAPPED  ), (BOOL) state);
        EnableWindow(GetDlgItem(DIPsWindowPtr, IDC_PARALLEL_EXTENDED   ), (BOOL) state);
        EnableWindow(GetDlgItem(DIPsWindowPtr, IDC_PARALLEL_NONEXTENDED), (BOOL) state);
        EnableWindow(GetDlgItem(DIPsWindowPtr, IDC_PARALLEL_BIT7       ), (BOOL) state);
        EnableWindow(GetDlgItem(DIPsWindowPtr, IDC_PARALLEL_BIT6       ), (BOOL) state);
        EnableWindow(GetDlgItem(DIPsWindowPtr, IDC_PARALLEL_BIT5       ), (BOOL) state);
        EnableWindow(GetDlgItem(DIPsWindowPtr, IDC_PARALLEL_BIT4       ), (BOOL) state);
        EnableWindow(GetDlgItem(DIPsWindowPtr, IDC_PARALLEL_BIT3       ), (BOOL) state);
        EnableWindow(GetDlgItem(DIPsWindowPtr, IDC_PARALLEL_BIT2       ), (BOOL) state);
        EnableWindow(GetDlgItem(DIPsWindowPtr, IDC_PARALLEL_BIT1       ), (BOOL) state);
        EnableWindow(GetDlgItem(DIPsWindowPtr, IDC_PARALLEL_BIT0       ), (BOOL) state);
}   }

EXPORT void drawsky(int x, int y)
{   switch (fastsize)
    {
    case 0: // 1*1
        display[ x      +     (y * machines[machine].width     )                                 ] = stars[ x          + (y * rastwidth)                   ]; // 0,0
    acase 1: // 2*1
        display[(x * 2) + 0 + (y * machines[machine].width *  2)                                 ] = stars[(x * 2) + 0 + (y * machines[machine].width *  2)]; // 0,0
        display[(x * 2) + 1 + (y * machines[machine].width *  2)                                 ] = stars[(x * 2) + 1 + (y * machines[machine].width *  2)]; // 1,0
    acase 2: // 2*2
        display[(x * 2) + 0 + (y * machines[machine].width *  4)                                 ] = stars[(x * 2) + 0 + (y * machines[machine].width *  4)                                 ]; // 0,0
        display[(x * 2) + 1 + (y * machines[machine].width *  4)                                 ] = stars[(x * 2) + 1 + (y * machines[machine].width *  4)                                 ]; // 1,0
        display[(x * 2) + 0 + (y * machines[machine].width *  4) + (machines[machine].width *  2)] = stars[(x * 2) + 0 + (y * machines[machine].width *  4) + (machines[machine].width *  2)]; // 0,1
        display[(x * 2) + 1 + (y * machines[machine].width *  4) + (machines[machine].width *  2)] = stars[(x * 2) + 1 + (y * machines[machine].width *  4) + (machines[machine].width *  2)]; // 1,1
    acase 3: // 4*2
        display[(x * 4) + 0 + (y * machines[machine].width *  8)                                 ] = stars[(x * 4) + 0 + (y * machines[machine].width *  8)                                 ]; // 0,0
        display[(x * 4) + 1 + (y * machines[machine].width *  8)                                 ] = stars[(x * 4) + 1 + (y * machines[machine].width *  8)                                 ]; // 1,0
        display[(x * 4) + 2 + (y * machines[machine].width *  8)                                 ] = stars[(x * 4) + 2 + (y * machines[machine].width *  8)                                 ]; // 2,0
        display[(x * 4) + 3 + (y * machines[machine].width *  8)                                 ] = stars[(x * 4) + 3 + (y * machines[machine].width *  8)                                 ]; // 3,0
        display[(x * 4) + 0 + (y * machines[machine].width *  8) + (machines[machine].width *  4)] = stars[(x * 4) + 0 + (y * machines[machine].width *  8) + (machines[machine].width *  4)]; // 0,1
        display[(x * 4) + 1 + (y * machines[machine].width *  8) + (machines[machine].width *  4)] = stars[(x * 4) + 1 + (y * machines[machine].width *  8) + (machines[machine].width *  4)]; // 1,1
        display[(x * 4) + 2 + (y * machines[machine].width *  8) + (machines[machine].width *  4)] = stars[(x * 4) + 2 + (y * machines[machine].width *  8) + (machines[machine].width *  4)]; // 2,1
        display[(x * 4) + 3 + (y * machines[machine].width *  8) + (machines[machine].width *  4)] = stars[(x * 4) + 3 + (y * machines[machine].width *  8) + (machines[machine].width *  4)]; // 3,1
    acase 4: // 3*3
        display[(x * 3) + 0 + (y * machines[machine].width *  9)                                 ] = stars[(x * 3) + 0 + (y * machines[machine].width *  9)                                 ]; // 0,0
        display[(x * 3) + 1 + (y * machines[machine].width *  9)                                 ] = stars[(x * 3) + 1 + (y * machines[machine].width *  9)                                 ]; // 1,0
        display[(x * 3) + 2 + (y * machines[machine].width *  9)                                 ] = stars[(x * 3) + 2 + (y * machines[machine].width *  9)                                 ]; // 2,0
        display[(x * 3) + 0 + (y * machines[machine].width *  9) + (machines[machine].width *  3)] = stars[(x * 3) + 0 + (y * machines[machine].width *  9) + (machines[machine].width *  3)]; // 0,1
        display[(x * 3) + 1 + (y * machines[machine].width *  9) + (machines[machine].width *  3)] = stars[(x * 3) + 1 + (y * machines[machine].width *  9) + (machines[machine].width *  3)]; // 1,1
        display[(x * 3) + 2 + (y * machines[machine].width *  9) + (machines[machine].width *  3)] = stars[(x * 3) + 2 + (y * machines[machine].width *  9) + (machines[machine].width *  3)]; // 2,1
        display[(x * 3) + 0 + (y * machines[machine].width *  9) + (machines[machine].width *  6)] = stars[(x * 3) + 0 + (y * machines[machine].width *  9) + (machines[machine].width *  6)]; // 0,2
        display[(x * 3) + 1 + (y * machines[machine].width *  9) + (machines[machine].width *  6)] = stars[(x * 3) + 1 + (y * machines[machine].width *  9) + (machines[machine].width *  6)]; // 1,2
        display[(x * 3) + 2 + (y * machines[machine].width *  9) + (machines[machine].width *  6)] = stars[(x * 3) + 2 + (y * machines[machine].width *  9) + (machines[machine].width *  6)]; // 2,2
    acase 5: // 6*3
        display[(x * 6) + 0 + (y * machines[machine].width * 18)                                 ] = stars[(x * 6) + 0 + (y * machines[machine].width * 18)                                 ]; // 0,0
        display[(x * 6) + 1 + (y * machines[machine].width * 18)                                 ] = stars[(x * 6) + 1 + (y * machines[machine].width * 18)                                 ]; // 1,0
        display[(x * 6) + 2 + (y * machines[machine].width * 18)                                 ] = stars[(x * 6) + 2 + (y * machines[machine].width * 18)                                 ]; // 2,0
        display[(x * 6) + 3 + (y * machines[machine].width * 18)                                 ] = stars[(x * 6) + 3 + (y * machines[machine].width * 18)                                 ]; // 3,0
        display[(x * 6) + 4 + (y * machines[machine].width * 18)                                 ] = stars[(x * 6) + 4 + (y * machines[machine].width * 18)                                 ]; // 4,0
        display[(x * 6) + 5 + (y * machines[machine].width * 18)                                 ] = stars[(x * 6) + 5 + (y * machines[machine].width * 18)                                 ]; // 5,0
        display[(x * 6) + 0 + (y * machines[machine].width * 18) + (machines[machine].width *  6)] = stars[(x * 6) + 0 + (y * machines[machine].width * 18) + (machines[machine].width *  6)]; // 0,1
        display[(x * 6) + 1 + (y * machines[machine].width * 18) + (machines[machine].width *  6)] = stars[(x * 6) + 1 + (y * machines[machine].width * 18) + (machines[machine].width *  6)]; // 1,1
        display[(x * 6) + 2 + (y * machines[machine].width * 18) + (machines[machine].width *  6)] = stars[(x * 6) + 2 + (y * machines[machine].width * 18) + (machines[machine].width *  6)]; // 2,1
        display[(x * 6) + 3 + (y * machines[machine].width * 18) + (machines[machine].width *  6)] = stars[(x * 6) + 3 + (y * machines[machine].width * 18) + (machines[machine].width *  6)]; // 3,1
        display[(x * 6) + 4 + (y * machines[machine].width * 18) + (machines[machine].width *  6)] = stars[(x * 6) + 4 + (y * machines[machine].width * 18) + (machines[machine].width *  6)]; // 4,1
        display[(x * 6) + 5 + (y * machines[machine].width * 18) + (machines[machine].width *  6)] = stars[(x * 6) + 5 + (y * machines[machine].width * 18) + (machines[machine].width *  6)]; // 5,1
        display[(x * 6) + 0 + (y * machines[machine].width * 18) + (machines[machine].width * 12)] = stars[(x * 6) + 0 + (y * machines[machine].width * 18) + (machines[machine].width * 12)]; // 0,2
        display[(x * 6) + 1 + (y * machines[machine].width * 18) + (machines[machine].width * 12)] = stars[(x * 6) + 1 + (y * machines[machine].width * 18) + (machines[machine].width * 12)]; // 1,2
        display[(x * 6) + 2 + (y * machines[machine].width * 18) + (machines[machine].width * 12)] = stars[(x * 6) + 2 + (y * machines[machine].width * 18) + (machines[machine].width * 12)]; // 2,2
        display[(x * 6) + 3 + (y * machines[machine].width * 18) + (machines[machine].width * 12)] = stars[(x * 6) + 3 + (y * machines[machine].width * 18) + (machines[machine].width * 12)]; // 3,2
        display[(x * 6) + 4 + (y * machines[machine].width * 18) + (machines[machine].width * 12)] = stars[(x * 6) + 4 + (y * machines[machine].width * 18) + (machines[machine].width * 12)]; // 4,2
        display[(x * 6) + 5 + (y * machines[machine].width * 18) + (machines[machine].width * 12)] = stars[(x * 6) + 5 + (y * machines[machine].width * 18) + (machines[machine].width * 12)]; // 5,2
    acase 6: // 4*4
        display[(x * 4) + 0 + (y * machines[machine].width * 16)                                 ] = stars[(x * 4) + 0 + (y * machines[machine].width * 16)                                 ]; // 0,0
        display[(x * 4) + 1 + (y * machines[machine].width * 16)                                 ] = stars[(x * 4) + 1 + (y * machines[machine].width * 16)                                 ]; // 1,0
        display[(x * 4) + 2 + (y * machines[machine].width * 16)                                 ] = stars[(x * 4) + 2 + (y * machines[machine].width * 16)                                 ]; // 2,0
        display[(x * 4) + 3 + (y * machines[machine].width * 16)                                 ] = stars[(x * 4) + 3 + (y * machines[machine].width * 16)                                 ]; // 3,0
        display[(x * 4) + 0 + (y * machines[machine].width * 16) + (machines[machine].width *  4)] = stars[(x * 4) + 0 + (y * machines[machine].width * 16) + (machines[machine].width *  4)]; // 0,1
        display[(x * 4) + 1 + (y * machines[machine].width * 16) + (machines[machine].width *  4)] = stars[(x * 4) + 1 + (y * machines[machine].width * 16) + (machines[machine].width *  4)]; // 1,1
        display[(x * 4) + 2 + (y * machines[machine].width * 16) + (machines[machine].width *  4)] = stars[(x * 4) + 2 + (y * machines[machine].width * 16) + (machines[machine].width *  4)]; // 2,1
        display[(x * 4) + 3 + (y * machines[machine].width * 16) + (machines[machine].width *  4)] = stars[(x * 4) + 3 + (y * machines[machine].width * 16) + (machines[machine].width *  4)]; // 3,1
        display[(x * 4) + 0 + (y * machines[machine].width * 16) + (machines[machine].width *  8)] = stars[(x * 4) + 0 + (y * machines[machine].width * 16) + (machines[machine].width *  8)]; // 0,2
        display[(x * 4) + 1 + (y * machines[machine].width * 16) + (machines[machine].width *  8)] = stars[(x * 4) + 1 + (y * machines[machine].width * 16) + (machines[machine].width *  8)]; // 1,2
        display[(x * 4) + 2 + (y * machines[machine].width * 16) + (machines[machine].width *  8)] = stars[(x * 4) + 2 + (y * machines[machine].width * 16) + (machines[machine].width *  8)]; // 2,2
        display[(x * 4) + 3 + (y * machines[machine].width * 16) + (machines[machine].width *  8)] = stars[(x * 4) + 3 + (y * machines[machine].width * 16) + (machines[machine].width *  8)]; // 3,2
        display[(x * 4) + 0 + (y * machines[machine].width * 16) + (machines[machine].width * 12)] = stars[(x * 4) + 0 + (y * machines[machine].width * 16) + (machines[machine].width * 12)]; // 0,3
        display[(x * 4) + 1 + (y * machines[machine].width * 16) + (machines[machine].width * 12)] = stars[(x * 4) + 1 + (y * machines[machine].width * 16) + (machines[machine].width * 12)]; // 1,3
        display[(x * 4) + 2 + (y * machines[machine].width * 16) + (machines[machine].width * 12)] = stars[(x * 4) + 2 + (y * machines[machine].width * 16) + (machines[machine].width * 12)]; // 2,3
        display[(x * 4) + 3 + (y * machines[machine].width * 16) + (machines[machine].width * 12)] = stars[(x * 4) + 3 + (y * machines[machine].width * 16) + (machines[machine].width * 12)]; // 3,3
    acase 7: // 8*4
        display[(x * 8) + 0 + (y * machines[machine].width * 32)                                 ] = stars[(x * 8) + 0 + (y * machines[machine].width * 32)                                 ]; // 0,0
        display[(x * 8) + 1 + (y * machines[machine].width * 32)                                 ] = stars[(x * 8) + 1 + (y * machines[machine].width * 32)                                 ]; // 1,0
        display[(x * 8) + 2 + (y * machines[machine].width * 32)                                 ] = stars[(x * 8) + 2 + (y * machines[machine].width * 32)                                 ]; // 2,0
        display[(x * 8) + 3 + (y * machines[machine].width * 32)                                 ] = stars[(x * 8) + 3 + (y * machines[machine].width * 32)                                 ]; // 3,0
        display[(x * 8) + 4 + (y * machines[machine].width * 32)                                 ] = stars[(x * 8) + 4 + (y * machines[machine].width * 32)                                 ]; // 4,0
        display[(x * 8) + 5 + (y * machines[machine].width * 32)                                 ] = stars[(x * 8) + 5 + (y * machines[machine].width * 32)                                 ]; // 5,0
        display[(x * 8) + 6 + (y * machines[machine].width * 32)                                 ] = stars[(x * 8) + 6 + (y * machines[machine].width * 32)                                 ]; // 6,0
        display[(x * 8) + 7 + (y * machines[machine].width * 32)                                 ] = stars[(x * 8) + 7 + (y * machines[machine].width * 32)                                 ]; // 7,0
        display[(x * 8) + 0 + (y * machines[machine].width * 32) + (machines[machine].width *  8)] = stars[(x * 8) + 0 + (y * machines[machine].width * 32) + (machines[machine].width *  8)]; // 0,1
        display[(x * 8) + 1 + (y * machines[machine].width * 32) + (machines[machine].width *  8)] = stars[(x * 8) + 1 + (y * machines[machine].width * 32) + (machines[machine].width *  8)]; // 1,1
        display[(x * 8) + 2 + (y * machines[machine].width * 32) + (machines[machine].width *  8)] = stars[(x * 8) + 2 + (y * machines[machine].width * 32) + (machines[machine].width *  8)]; // 2,1
        display[(x * 8) + 3 + (y * machines[machine].width * 32) + (machines[machine].width *  8)] = stars[(x * 8) + 3 + (y * machines[machine].width * 32) + (machines[machine].width *  8)]; // 3,1
        display[(x * 8) + 4 + (y * machines[machine].width * 32) + (machines[machine].width *  8)] = stars[(x * 8) + 4 + (y * machines[machine].width * 32) + (machines[machine].width *  8)]; // 4,1
        display[(x * 8) + 5 + (y * machines[machine].width * 32) + (machines[machine].width *  8)] = stars[(x * 8) + 5 + (y * machines[machine].width * 32) + (machines[machine].width *  8)]; // 5,1
        display[(x * 8) + 6 + (y * machines[machine].width * 32) + (machines[machine].width *  8)] = stars[(x * 8) + 6 + (y * machines[machine].width * 32) + (machines[machine].width *  8)]; // 6,1
        display[(x * 8) + 7 + (y * machines[machine].width * 32) + (machines[machine].width *  8)] = stars[(x * 8) + 7 + (y * machines[machine].width * 32) + (machines[machine].width *  8)]; // 7,1
        display[(x * 8) + 0 + (y * machines[machine].width * 32) + (machines[machine].width * 16)] = stars[(x * 8) + 0 + (y * machines[machine].width * 32) + (machines[machine].width * 16)]; // 0,2
        display[(x * 8) + 1 + (y * machines[machine].width * 32) + (machines[machine].width * 16)] = stars[(x * 8) + 1 + (y * machines[machine].width * 32) + (machines[machine].width * 16)]; // 1,2
        display[(x * 8) + 2 + (y * machines[machine].width * 32) + (machines[machine].width * 16)] = stars[(x * 8) + 2 + (y * machines[machine].width * 32) + (machines[machine].width * 16)]; // 2,2
        display[(x * 8) + 3 + (y * machines[machine].width * 32) + (machines[machine].width * 16)] = stars[(x * 8) + 3 + (y * machines[machine].width * 32) + (machines[machine].width * 16)]; // 3,2
        display[(x * 8) + 4 + (y * machines[machine].width * 32) + (machines[machine].width * 16)] = stars[(x * 8) + 4 + (y * machines[machine].width * 32) + (machines[machine].width * 16)]; // 4,2
        display[(x * 8) + 5 + (y * machines[machine].width * 32) + (machines[machine].width * 16)] = stars[(x * 8) + 5 + (y * machines[machine].width * 32) + (machines[machine].width * 16)]; // 5,2
        display[(x * 8) + 6 + (y * machines[machine].width * 32) + (machines[machine].width * 16)] = stars[(x * 8) + 6 + (y * machines[machine].width * 32) + (machines[machine].width * 16)]; // 6,2
        display[(x * 8) + 7 + (y * machines[machine].width * 32) + (machines[machine].width * 16)] = stars[(x * 8) + 7 + (y * machines[machine].width * 32) + (machines[machine].width * 16)]; // 7,2
        display[(x * 8) + 0 + (y * machines[machine].width * 32) + (machines[machine].width * 24)] = stars[(x * 8) + 0 + (y * machines[machine].width * 32) + (machines[machine].width * 24)]; // 0,3
        display[(x * 8) + 1 + (y * machines[machine].width * 32) + (machines[machine].width * 24)] = stars[(x * 8) + 1 + (y * machines[machine].width * 32) + (machines[machine].width * 24)]; // 1,3
        display[(x * 8) + 2 + (y * machines[machine].width * 32) + (machines[machine].width * 24)] = stars[(x * 8) + 2 + (y * machines[machine].width * 32) + (machines[machine].width * 24)]; // 2,3
        display[(x * 8) + 3 + (y * machines[machine].width * 32) + (machines[machine].width * 24)] = stars[(x * 8) + 3 + (y * machines[machine].width * 32) + (machines[machine].width * 24)]; // 3,3
        display[(x * 8) + 4 + (y * machines[machine].width * 32) + (machines[machine].width * 24)] = stars[(x * 8) + 4 + (y * machines[machine].width * 32) + (machines[machine].width * 24)]; // 4,3
        display[(x * 8) + 5 + (y * machines[machine].width * 32) + (machines[machine].width * 24)] = stars[(x * 8) + 5 + (y * machines[machine].width * 32) + (machines[machine].width * 24)]; // 5,3
        display[(x * 8) + 6 + (y * machines[machine].width * 32) + (machines[machine].width * 24)] = stars[(x * 8) + 6 + (y * machines[machine].width * 32) + (machines[machine].width * 24)]; // 6,3
        display[(x * 8) + 7 + (y * machines[machine].width * 32) + (machines[machine].width * 24)] = stars[(x * 8) + 7 + (y * machines[machine].width * 32) + (machines[machine].width * 24)]; // 7,3
}   }

EXPORT void view_hiscores(void)
{   sound_off(FALSE);
    opening = TRUE;

    switch (machine)
    {
    case ARCADIA:
        DISCARD DialogBox(GetModuleHandle(NULL), MAKEINTRESOURCE(IDD_HISCORES), MainWindowPtr, HiScoresDlgProc);
    acase ASTROWARS:
    case GALAXIA:
    case MALZAK:
        DISCARD DialogBox(GetModuleHandle(NULL), MAKEINTRESOURCE(IDD_COINOPHISCORES), MainWindowPtr, HiScoresDlgProc);
    }

    opening = FALSE;
    sound_on();
}

BOOL CALLBACK HiScoresDlgProc(HWND hwnd, UINT Message, WPARAM wParam, LPARAM lParam)
{   int         i;
    TEXT        tempstring[6 + 1];
    PAINTSTRUCT localps;

    switch (Message)
    {
    case WM_INITDIALOG:
        charset = CHARSET_WIN;

        switch (machine)
        {
        case ARCADIA:
            DISCARD SetWindowText( hwnd,       LLL, MSG_HAIL_HISCORES, "Emerson Arcadia 2001 High Scores"));
        acase ASTROWARS:
        case GALAXIA:
        case MALZAK:
            DISCARD SetWindowText( hwnd,       LLL, MSG_HAIL_COINOPHISCORES, "Coin-Op High Scores"));
        }

        if (language == LANGUAGE_RUS)
        {   DISCARD SendMessage(GetDlgItem(hwnd, IDOK), WM_SETFONT, (WPARAM) hRussianFont, MAKELPARAM(FALSE, 0));
        }
        DISCARD SetDlgItemText(    hwnd, IDOK, LLL, MSG_OK2, "&OK"));

        charset = CHARSET_DOS;

        switch (machine)
        {
        case ARCADIA:
            for (i = 0; i < A_HISCORES; i++)
            {   sprintf(tempstring, "%d", hiscore[i].score);
                DISCARD SetDlgItemText(hwnd, IDC_SCORE1 + i, tempstring);
                DISCARD SetDlgItemText(hwnd, IDC_TIME1  + i, hiscore[i].thetime);
                DISCARD SetDlgItemText(hwnd, IDC_DATE1  + i, hiscore[i].thedate);
            }
        acase ASTROWARS:
        case GALAXIA:
        case MALZAK:
            for (i = 0; i < 4; i++)
            {   sprintf(tempstring, "%d", hiscore[A_HISCORES + i].score);
                DISCARD SetDlgItemText(hwnd, IDC_SCORE1 + i, tempstring);
                DISCARD SetDlgItemText(hwnd, IDC_TIME1  + i, hiscore[A_HISCORES + i].thetime);
                DISCARD SetDlgItemText(hwnd, IDC_DATE1  + i, hiscore[A_HISCORES + i].thedate);
        }   }

        return TRUE;
    case WM_CLOSE: // no need for acase
        clearkybd();
        DISCARD EndDialog(hwnd, 0);

        return TRUE;
    case WM_COMMAND: // no need for acase
        if
        (   LOWORD (wParam) == IDOK
         || LOWORD (wParam) == IDCANCEL
        )
        {   clearkybd();
            DISCARD EndDialog(hwnd, 0);

            return TRUE;
        }

        return FALSE;
    case WM_PAINT: // no need for acase
        DISCARD BeginPaint(hwnd, &localps);
        DISCARD EndPaint(hwnd, &localps);
    adefault:
        return FALSE;
    }

    return FALSE;
}

EXPORT void view_memory(void)
{   int  i;
    TEXT tempstring[10 + 1];

    if (MemoryWindowPtr)
    {   return; // important!
    }

    opening = TRUE;
    MemoryWindowPtr = CreateDialog
    (   InstancePtr,
        showlegend ? MAKEINTRESOURCE(IDD_MEMORYLEGEND) : MAKEINTRESOURCE(IDD_MEMORY),
        MainWindowPtr,
        MemoryDlgProc
    );
    opening = FALSE;

    for (i = 0; i < MEMGADGETS; i++)
    {   memorygad[i] = GetDlgItem(MemoryWindowPtr, ID_MEM_0 + i);
    }
    hRegionListBox = GetDlgItem(MemoryWindowPtr, IDC_LISTBOX);

    DISCARD SendMessage(hRegionListBox, WM_SETREDRAW, FALSE, 0);
    for (i = 0; i < 128; i++)
    {   sprintf(tempstring, "%02X00..%02X7F", i, i);
        DISCARD SendMessage(hRegionListBox, LB_ADDSTRING, 0, (LPARAM) tempstring);
        sprintf(tempstring, "%02X80..%02XFF", i, i);
        DISCARD SendMessage(hRegionListBox, LB_ADDSTRING, 0, (LPARAM) tempstring);
    }
    DISCARD SendMessage(hRegionListBox, LB_SETTOPINDEX, (WPARAM) (regionstart / MEMGADGETS), 0);
    DISCARD SendMessage(hRegionListBox, WM_SETREDRAW, TRUE, 0);

    DISCARD SetActiveWindow(MainWindowPtr);

    updatemenu(MENUITEM_VIEWMEMORY);
    update_memory(TRUE);
}

EXPORT void getpointerpos(int* x, int* y)
{   DISCARD GetCursorPos(&ThePoint);
    DISCARD ScreenToClient(MainWindowPtr, &ThePoint);
    *x = ThePoint.x;
    *y = ThePoint.y;
    if (*y < yoffset) *y = yoffset;
    if (stretch && fullscreen)
    {   if (*x < 0) *x = 0;
        if (*x > xoffset + clientwidth ) *x = xoffset + clientwidth;
        if (*y > yoffset + clientheight) *y = yoffset + clientheight;
        // *x -= 0; :-)
        *y -= yoffset;
        // assert(*x >= 0     );
        // assert(*y >= 0     );
        // assert(*x <  clientwidth );
        // assert(*y <  clientheight);
        *x *= (65535 / clientwidth ); // scale from 0..width  up to 0..65535
        *y *= (65535 / clientheight); // scale from 0..height up to 0..65535
    } else
    {   if (*x < xoffset) *x = xoffset;
        if (*y < yoffset) *y = yoffset;
        if (*x > xoffset + rastwidth ) *x = xoffset + rastwidth;
        if (*y > yoffset + rastheight) *y = yoffset + rastheight;
        *x -= xoffset;
        *y -= yoffset;
        // assert(*x >= 0     );
        // assert(*y >= 0     );
        // assert(*x <  rastwidth );
        // assert(*y <  rastheight);
        *x *= (65535 / rastwidth);  // scale from 0..width  up to 0..65535
        *y *= (65535 / rastheight); // scale from 0..height up to 0..65535
}   }

EXPORT void enqueue(UINT hostcode, TEXT guestcode)
{   if ((keyframes[hostcode] - 1) % REPEATRATE == 0)
    {   thequeue[queuepos++] = guestcode;
}   }

BOOL CALLBACK SpriteDlgProc(HWND hwnd, UINT Message, WPARAM wParam, LPARAM lParam)
{   TRANSIENT LONG   gid;
    PERSIST   HBRUSH hBrush[9];
    PERSIST   int    i,              // PERSISTent for speed
                     mousex, mousey, // PERSISTent for speed
                     x, y;           // PERSISTent for speed
    PERSIST   ULONG  reversed;       // PERSISTent for speed

    switch (Message)
    {
    case WM_INITDIALOG:
        charset = CHARSET_WIN;
        DISCARD SetWindowText( hwnd,                    LLL, MSG_HAIL_SPRITEVIEWER, "Sprite Editor" ));

        if (language == LANGUAGE_RUS)
        {   DISCARD SendMessage(GetDlgItem(hwnd, IDL_WHICHSPRITE   ), WM_SETFONT, (WPARAM) hRussianFont, MAKELPARAM(FALSE, 0));
            DISCARD SendMessage(GetDlgItem(hwnd, IDL_SPRITEIMAGERY ), WM_SETFONT, (WPARAM) hRussianFont, MAKELPARAM(FALSE, 0));
        }
        DISCARD SetDlgItemText(hwnd, IDL_WHICHSPRITE,   LLL, MSG_SPRITE,            "Sprite:"       ));
        DISCARD SetDlgItemText(hwnd, IDL_SPRITEIMAGERY, LLL, MSG_SPRITEIMAGERY,     "Sprite Imagery"));

        charset = CHARSET_DOS;

        for (i = 0; i < 9; i++)
        {   // 0RGB -> 0BGR
            reversed = ((pens[colourset][i] & 0x00FF0000) >> 16)  // red
                     |  (pens[colourset][i] & 0x0000FF00)         // green
                     | ((pens[colourset][i] & 0x000000FF) << 16); // blue
            hBrush[i] = CreateSolidBrush(reversed);
        }

        return FALSE;
    case WM_CTLCOLORSTATIC: // no need for acase
        gid = GetWindowLong((HWND) lParam, GWL_ID);
        x = (gid - IDC_SPR_11) % 8;
        y = (gid - IDC_SPR_11) / 8;

        switch (machine)
        {
        case ARCADIA:
            if (gid >= IDC_SPR_11 && gid <= IDC_SPR_88)
            {   if
                (   memory[0x1980 + (viewingsprite * 8) + y]
                 &  (128 >> x)
                )
                {   reversed = ((pens[colourset][sprviewcolour] & 0x00FF0000) >> 16)  // red
                             |  (pens[colourset][sprviewcolour] & 0x0000FF00)         // green
                             | ((pens[colourset][sprviewcolour] & 0x000000FF) << 16); // blue
                    SetBkColor((HDC) wParam, reversed);
                    return (LRESULT) hBrush[sprviewcolour];
                } else
                {   SetBkColor((HDC) wParam, EMUPEN_GREY); // grey
                    return (LRESULT) hBrush[GREY1];
            }   }
            // implied else
            return FALSE;
        case INTERTON: //-lint fallthrough
        case ELEKTOR:
        case ASTROWARS:
        case GALAXIA:
        case MALZAK:
            if (gid >= IDC_SPR_11 && gid <= IDC_SPR_108)
            {   if
                (   memory[pvibase + pvi_spritedata[viewingsprite % 4] + y]
                 &  (128 >> x)
                )
                {   reversed = ((pens[colourset][sprviewcolour] & 0x00FF0000) >> 16)  // red
                             |  (pens[colourset][sprviewcolour] & 0x0000FF00)         // green
                             | ((pens[colourset][sprviewcolour] & 0x000000FF) << 16); // blue
                    SetBkColor((HDC) wParam, reversed);
                    return (LRESULT) hBrush[sprviewcolour];
                } else
                {   SetBkColor((HDC) wParam, EMUPEN_GREY); // grey
                    return (LRESULT) hBrush[GREY1];
        }   }   }
    acase WM_ACTIVATE:
        do_autopause(wParam, lParam);
    acase WM_COMMAND:
        return TRUE;
    case WM_LBUTTONDBLCLK: // no need for acase
    case WM_LBUTTONDOWN:
        mousex = (int) (LOWORD(lParam));
        mousey = (int) (HIWORD(lParam));
        x      =       (mousex - 30) / 15;
        y      =       (mousey - 72) / 15;
        spritebutton(x, y);
        return TRUE;
    case WM_CLOSE: // no need for acase
        DestroyWindow(hwnd);
        SpriteWindowPtr = NULL;
        updatemenu(MENUITEM_SPRITEVIEWER);
    acase WM_DESTROY:
        for (i = 0; i < 9; i++)
        {   DeleteObject(hBrush[i]);
        }
    adefault:
        return FALSE;
    }
    return TRUE;
}

EXPORT void update_spriteviewer(FLAG force)
{   PERSIST int oldsprviewcolour,
                oldviewingsprite,
                x, y; // all PERSISTent for speed

    if (!SpriteWindowPtr)
    {   return;
    }

    if (viewingsprite >= 4)
    {   pvibase += 0x100;
    }
    if (viewingsprite >= 8)
    {   pvibase += 0x100;
    }

    oldviewingsprite = viewingsprite;
    viewingsprite = SendMessage(GetDlgItem(SpriteWindowPtr, IDC_WHICHSPRITE), LB_GETTOPINDEX, 0, 0);
    if (viewingsprite == LB_ERR)
    {   viewingsprite = 0;
    }
    if (viewingsprite != oldviewingsprite)
    {   force = TRUE;
    }
    oldsprviewcolour = sprviewcolour;
    calcspritecolour(); // sets sprviewcolour
    if (sprviewcolour != oldsprviewcolour)
    {   force = TRUE;
    }

    switch (machine)
    {
    case ARCADIA:
        for (y = 0; y < 8; y++)
        {   for (x = 0; x < 8; x++)
            {   if
                (   ((memory[0x1980 + (viewingsprite * 8) + y] & (128 >> x)) != (spritecontents[y] & (128 >> x)))
                 || force
                )
                {   DISCARD SetWindowText(spritegad[(y * 8) + x], "");
            }   }
            spritecontents[y] = memory[0x1980 + (viewingsprite * 8) + y];
        }
    acase INTERTON:
    case ELEKTOR:
    case ASTROWARS:
    case GALAXIA:
    case MALZAK:
        for (y = 0; y < 10; y++)
        {   for (x = 0; x < 8; x++)
            {   if
                (   ((memory[pvibase + pvi_spritedata[viewingsprite % 4] + y] & (128 >> x)) != (spritecontents[y] & (128 >> x)))
                 || force
                )
                {   DISCARD SetWindowText(GetDlgItem(SpriteWindowPtr, IDC_SPR_11 + (y * 8) + x), "");
            }   }
            spritecontents[y] = memory[pvibase + pvi_spritedata[viewingsprite % 4] + y];
    }   }

    if (viewingsprite >= 4)
    {   pvibase -= 0x100;
    }
    if (viewingsprite >= 8)
    {   pvibase -= 0x100;
}   }

EXPORT void doaxes(void)
{   PERSIST int nx[2], ny[2],
                ox[2], oy[2];

    /* assert
    (   machine == ARCADIA
     || machine == INTERTON
     || machine == ELEKTOR
    ); */

    nx[0] = ax[0] / 4; // 0..255 -> 0..63
    ny[0] = ay[0] / 4; // 0..255 -> 0..63
    nx[1] = ax[1] / 4; // 0..255 -> 0..63
    ny[1] = ay[1] / 4; // 0..255 -> 0..63
    AxesRastPtr = GetDC(GetDlgItem(MonitorWindowPtr, IDC_AXES));

    if (nx[0] == nx[1] && ny[0] == ny[1])
    {   drawpoint(nx[0], ny[0], 0x00FF00FF); // $00BBGGRR format
    } else
    {   drawpoint(nx[0], ny[0], 0x000000FF); // $00BBGGRR format
        drawpoint(nx[1], ny[1], 0x00FF0000); // $00BBGGRR format
    }
    if
    (   (ox[0] != nx[0] || oy[0] != ny[0]) // red dot is elsewhere
     && (ox[0] != nx[1] || oy[0] != ny[1]) // and blue dot is elsewhere
    )
    {   drawpoint(ox[0], oy[0], 0x00FFFFFF); // $00BBGGRR format
    }
    if
    (   (ox[1] != nx[0] || oy[1] != ny[0]) // red dot is elsewhere
     && (ox[1] != nx[1] || oy[1] != ny[1]) // and blue dot is elsewhere
    )
    {   drawpoint(ox[1], oy[1], 0x00FFFFFF); // $00BBGGRR format
    }
    ox[0] = nx[0];
    oy[0] = ny[0];
    ox[1] = nx[1];
    oy[1] = ny[1];

    ReleaseDC(GetDlgItem(MonitorWindowPtr, IDC_AXES), AxesRastPtr);
}

EXPORT void drawpoint(int x, int y, COLORREF colour)
{   SetPixel(AxesRastPtr, (sparex / 2) + x    , (sparey / 2) + y    , colour);
    SetPixel(AxesRastPtr, (sparex / 2) + x - 1, (sparey / 2) + y    , colour);
    SetPixel(AxesRastPtr, (sparex / 2) + x + 1, (sparey / 2) + y    , colour);
    SetPixel(AxesRastPtr, (sparex / 2) + x    , (sparey / 2) + y - 1, colour);
    SetPixel(AxesRastPtr, (sparex / 2) + x    , (sparey / 2) + y + 1, colour);
}
